	This codes implements the multi-point propagator expansion of the matter power spectrum
	up to two loops.

	[1] Installation ::

	MPTbreeze uses the CUBA Library for multidimensional integration to perform two loops
	integrals. The CUBA library can be downloaded from :

        -- http://www.feynarts.de/cuba (and should be simple to install) --

	Note that our integrations have been optimized to version 1.4 of this library (we have no 
	tested it with newer versions).

        We provide a simple compilation script for our code (using ifort) : compile.sh 

	To use it you will have to change the location of libcuba.a to the one in your system, 
	and possibly some flags that might be obsolete in your OS.

	MPTbreeze can also be compiled with other Fortran compilers such as gfortran, but the 
	performance might get worse.

	[2] Input ::

	- Running ./mptbreeze details the running instructions and command line flags

        General inputs are the matter transfer function, relevant cosmological parameters (matter 
	density, spectral tilt, equation of state of DE and amplitude of fluctuations at 8Mpc/h) and 
	the desired redshift output. 

	There are two ways to pass this information to the code : 

	- One is with individual command line inputs. In this case the transfer function must be a 
	two column file (k-Tf)

	- Another is to directly pass the params.ini file used to generate the transfer function 
	in CAMB, which contains much of the relevant information. Additional *needed* information is 
	given as trailing command line options (-sigma8 for sig8, -redshift for output redshift and 
	-filePk for output Pk filename)

	We provide two example scripts, one for each case : run_test.sh and run_test_camb.sh

	Notice that all parameters have default values (declared at the beginning of the code). 
	Make sure you are passing your own.

	[3] Output :: 

	The code evaluates the nonlinear power spectrum from dk = 0.005 h/Mpc up to k_nl = sigv^{-1}
	in steps of size dk (linearly spaced). This election is completely arbitrary and can be
	changed in line 260. 

	Notice however that beyond k ~ k_nl the predictions shows a exponential suppression that
	limits its validity.

	- The output format is given as 

        k P0 P1 P2L 

	corresponding to 0,1 and 2 loops integrals. 

	- The full model prediction would be P0 + P1 + P2 
        
	again one can change this output format trivially

	[4] General Comments and Performance ::

        The speed of the code is mostly controlled by the relative error for the two-loop
        integration, this is set in header-vegas.f (variable -> epsrel). 

	- We recommend epsrel = 0.01 - 0.005 (default value is 0.01) 

	If no (power spectrum) output filename is given the default name is : 
	
	- MPTbreeze_"filename of transfer function"



	** If you find any trouble or you like/dislike something email martincrocce@gmail.com **

Readme file for CLASSgal - the Cosmic Linear Anisotropy Solving System for galaxy number count

By Enea Di Dio, Julien Lesgourgues and Francesco Montanari

Based on the CLASS code by Julien Lesgourgues, with several major
inputs from other people including Benjamin Audren, Thomas Tram, Simon
Prunet, etc.

For download and information on the main CLASS code, see http://class-code.net
For information specific to CLASSgal, see the July 2013 paper by Enea Di Dio, Francesco Montanari, Julien Lesgourgues, Ruth Durrer 

------------------------------------------------------------------

COMPILING CLASS AND GETTING STARTED

(the information below can also be found on the webpage, just below
the download button)

After downloading the code, unpack the archive (tar -zxvf
class_v*.tar.gz), go to the class directory (cd class/) and compile
(make class). If the first compilation attempt fails, you may need to
open the Makefile and adapt the name of the compiler (default: gcc),
of the optization flag (default: -O4) and of the OpenMP flag (default:
-fopenmp; this flag is facultative, you are free to compile without
OpenMP if you don't want parallel execution; note that you need the
version 4.2 or higher of gcc to be able to compile with -fopenmp; some
users of Mac OS 10.7 even reported that they needed gcc-4.5 or
gcc-mp-4.3 in order to compile the CLASS libraries, but this is anyway
an advancesd step that you probably don't need).

Adapt your input parameters in the file explanatory.ini and run with:

./class explanatory.ini

Or, even better, make a copy of explanatory.ini into another file, for
instance test.ini, and remove everything in test.ini that you judge
useless for your own purpose: in that way you can keep explanatory.ini
as a reference file, and play with a more concise and friendly input
file. You can then run with

./class test.ini.

If you want to play with the precision/speed of the code, you can use
one of the provided precision files (e.g. cl_permille.pre) or modify
one of them, and run with two input files, for instance:

./class test.ini cl_permille.pre

The following precision files are less accurate/faster than the default
settings:

chi2pl10.pre (fastest setting)
chi2pl1.pre

The following ones are more accurate/slower than the default settings
(ordered below from lowest to highest accuracy):

chi2pl0.1.pre
cl_3permille.pre
cl_2permille.pre
cl_permille.pre
cl_ref.pre 
pk_ref.pre

A simplified documentation can be found in the paper ``CLASS I:
Overview'', arXiv:1104.2932 [astro-ph.IM]. On top of that, if you wish
to modify the code, you will find lots of comments directly into the
files (and the amount of such comments will increase with the version
number). A more complete documentation may become available some day
if enough users ask for it...

---------------------------------------------------------------------

PLOTTING UTILITY

Since version 1.2, the package includes a convenient plotting script
called CPU (Class Plotting Utility), written by Benjamin Audren. It
can plot the Cl's or P(k) for one or two models, as well as their
ratio or percentage difference. A convenient feature is that
percentage differences can be shown even when two spectra are not
sampled in the same points, as it is often the case when comparing
matter power spectra P(k) for various models - in that case the script
uses some interpolation scheme. The type of spectrum (C_l or P(k)) is
detected automatically (provided that the file name endings are set by
CLASS in the standard way), and axes are labelled accordingly.

CPU is written in python, but you don't need to know anything
about python for using it, for you it will just be a simple command to
use on your terminal. However it will only work on systems with a
recent enough version of python including the 'scipy' package
(scientific python), and a recent enough version of gnuplot. You may
need to install some of them by yourself. These are standard free
facilities easy to download from the web. You don't need to compile
anything, if scipy and gnuplot are installed on your computer, the
CPU command will work immediately.

You can plot a spectrum produced by CLASS (or by another code) and
stored e.g. in the file output/xxx.dat with:

> python CPU output/xxx.dat

or two different spectra with:

> python CPU output/xxx.dat output/yyy.dat 

You can get a list of all available options by typing

> python CPU --help

These options allow you to choose between linear and log scale, to
plot ratios or relative differences between two files, to send the
output in a postscript file instead of the screen, etc.

If you put the path to class plot in the list of default paths, or if
you creat an alias, you may be able to type directly the command
'CPU' instead of 'python CPU'.

---------------------------------------------------------------------

CORRELATION FUNCTION

CLASSgal also contains a python script 'correlation.py', which allows to compute
from the output angular power spectra Cl's of CLASS other observable:
 - Cl(z'-z) at a fixed multipole around z_mean
 - xi(z'-z) at a fixed theta around z_mean
 - xi(theta) at a given redshift, and its variance
 - Reduced covariance Matrix for xi(theta) computed above
To run it, modify the input section and type from terminal:
> python correlation.py 

## DESCRIPTION

FFTLog-f90 is the Fortran 90 version of [FFTLog], a Fortran 77 code by Andrew Hamilton to compute the Fourier-Bessel, or Hankel, transform of a series of logarithmically spaced points.

The main reference for the algorithm is [Andrew Hamilton's webpage]. He first introduced FFTLog in a [paper] on the nonlinearities in the cosmological structures.

The Fourier-Bessel, or Hankel, transform F(r) of a function f(k) is defined as in eq. 159 of Hamilton's paper:

            /
    F(r) =  | dk * k * J_mu(k*r) * f(k)
            /

where `J_mu(k*r)` is the Bessel function of order mu. 

IMPORTANT: Currently, FFTLog-f90 only supports the sine transform (mu=0.5) and returns the following integral:

               1       /             sin(k*r)
    F(r) = ----------  | dk * k^2 * --------- * f(k) .
            (2*pi)^2   /               k*r

If f(k) = P(k) is the power spectrum of a homogeneous 3D random field, then the integral will yield the two-point correlation function xi(r), as in eq. 3.104 of my [PhD Thesis].


## QUICK START

Do the following to produce your first result with FFTLog-f90:

1. Customise the Makefile to use your preferred Fortran compiler.

2. Run `make fftlog-f90`.

3. Execute `./fftlog-f90 pk.dat xi.dat`. This will compute the Fourier transform of the function tabulated in `pk.dat` and store the result in `xi.dat`.

You can then compare with the expected result in `xi_ref.dat` by plotting them in [Gnuplot], with `set log; plot [0.01:1e4] "xi.dat" u 1:(abs($2)) w li, "xi_ref.dat" u 1:(abs($2)) w li`. 

The `pk.dat` file contains the power spectrum P(k) of the matter distribution in our Universe. It is estimated using the [CLASS code] for a standard LCDM cosmological model. Its Fourier transform in `xi.dat` is the correlation function xi(r), computed using eq. 3.104 of my [PhD thesis]. The range of r in `xi.dat` is [1/k_max, 1/k_min]. The results at the edges should not be trusted; see the documentation of [FFTLog] for further details. The feature at r~120 Mpc is called the baryon acoustic peak; you can zoom in it with `unset log; plot [80:180] "xi.dat" u 1:2 w li`.

FFTLog-f90 supports spline integration of the input and output files using the syntax

    ./fftlog-f90 in.dat out.dat N_POINTS

where `N_POINTS` is the number of points you want in the output file. For example, with

    ./fftlog-f90 pk.dat xi_splined.dat 2000

the peak is much smoother:

    unset log; plot [80:180] "xi_splined.dat" u 1:2 w li

Please refer to the documentation in `fftlog_driver.f90` for the full description of the features and arguments of FFTLog-f90.


## CONTRIBUTE

Please feel free to improve FFTLog-f90. You can do so via the Github project page: <https://github.com/coccoinomane/fftlog-f90>. Fork the repository, make your modifications and send a pull request.


[FFTLog]: http://casa.colorado.edu/~ajsh/FFTLog
[Andrew Hamilton's webpage]: http://casa.colorado.edu/~ajsh
[paper]: http://xxx.lanl.gov/abs/astro-ph/9905191
[Gnuplot]: http://www.gnuplot.info/
[CLASS code]: http://class-code.net/
[PhD Thesis]: http://arxiv.org/abs/1405.2280

Read INSTALL for instructions on compilation.

Documentation on mangle is at

http://space.mit.edu/home/tegmark/mangle/

To get started, try creating the mask for an example slice of the SDSS survey:
cd <mangle_directory>/masks/sdss
and follow the README, 
or follow the QuickStart section on the website.

Typing a command with no arguments will give you a brief summary of its usage. 

Typing a command with the -d switch will tell you what the defaults are.

The mathematical algorithms are described by
Hamilton A J S & Tegmark M (2004)
"A scheme to deal accurately and efficiently with complex angular masks
in galaxy surveys", MNRAS, 349, 115-128
and 
Swanson M E C, Tegmark M, Hamilton A J S, and Hill J C (2008)
"Methods for rapidly processing angular masks of next-generation galaxy 
surveys", MNRAS, 387, 1391-1402.

The intention is that the probability of the mangle software failing,
once successfully compiled, should be comparable to the probability
of a piece of spacejunk falling on your head (let's hope it ain't true).
If it fails, please check out Troubleshooting at
http://space.mit.edu/home/tegmark/mangle/manual/troubleshooting.html
If you still have a problem, please contact the mangle development team via
Andrew.Hamilton@colorado.edu or tegmark@mit.edu

Updated by mecs 24 July 2008

The C++ wrapper ClassEngine.cc for Class (written by S. Plaszczynski) is distributed together with a test code, testKlass.cc, in which you can write a list of input parameters. This test code can be compiled with (assuming you are already in the directory cpp/):

> c++ -O2 -fopenmp -I../include -c ClassEngine.cc -o ClassEngine.o
> c++ -O2 -fopenmp -I../include -c testKlass.cc -o testKlass.o
> cd ..
> c++ -O2 -fopenmp build/growTable.o build/dei_rkck.o build/sparse.o build/evolver_rkck.o build/evolver_ndf15.o build/arrays.o build/parser.o build/quadrature.o build/input.o build/background.o build/thermodynamics.o build/perturbations.o build/bessel.o build/transfer.o build/primordial.o build/spectra.o build/trg.o build/nonlinear.o build/lensing.o build/hyrectools.o build/helium.o build/hydrogen.o build/history.o build/output.o cpp/ClassEngine.o cpp/testKlass.o -o testKlass

then run ./testKlass.cc

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine azell(rag,decg,l2p,raz,elp,azp,azg,elg,l2z)
      real*10 rag,decg,l2p,raz,elp,azp,azg,elg,l2z
c
c        parameters
      real*10 CIRCLE,PI,RADIAN
      parameter (CIRCLE = 360._10,
     *           PI = 3.1415926535897932384626_10,
     *           RADIAN = 180._10/PI)
c        local (automatic) variables
      integer iz
      real*10 cazm,cdecg,celg,celp,cl2m,cra
      real*10 sazm,sdecg,selg,selp,sl2m,sra
c *
c * Given transformations g <-> p between and z <-> p between spherical
c * frames, determine transformation g <-> z
c * (I've imagined g = galactic coordinates, p = celestial coordinates,
c * z = dome coordinates, but of course the transformation is quite
c * general).
c *
c  Input: rag = RA of NGP in deg [192.25]
c         decg = Dec of NGP in deg = latitude of NCP [27.4]
c         l2p = longitude of NCP in deg [123]
c         raz = RA of zenith in deg
c         elp = elevation of NCP in deg = Dec of zenith
c         azp = azimuth of NCP in deg
c Output: azg = azimuth of NGP in deg (0.le.az.lt.360)
c         elg = elevation NGP in deg (-90.le.el.le.90)
c         l2z = longitude of zenith in deg
c
c        sines and cosines of input angles
      sdecg=sin(decg/RADIAN)
      cdecg=cos(decg/RADIAN)
      selp=sin(elp/RADIAN)
      celp=cos(elp/RADIAN)
      sra=sin((rag-raz)/RADIAN)
      cra=cos((rag-raz)/RADIAN)
c        sine and cosine of elevation of NGP
      selg=cdecg*celp*cra+sdecg*selp
      if (selg.gt.1._10) then
        selg=1._10
      elseif (selg.lt.-1._10) then
        selg=-1._10
      endif
      celg=sqrt(1._10-selg*selg)
c        elevation of NGP in deg
      elg=asin(selg)*RADIAN
c        at NGP el +- 90 deg, set NGP az & zenith long consistently
      if (celg.eq.0._10) then
        azg=azp
        l2z=l2p+CIRCLE/2._10
      elseif (celg.ne.0._10) then
c        sine and cosine of azimuth of NGP relative to NCP azimuth
        sazm=-cdecg*sra/celg
        cazm=(sdecg*celp-cdecg*selp*cra)/celg
c        azimuth in deg
        azg=atan2(sazm,cazm)*RADIAN+azp
c        sine and cosine of longitude of zenith relative to NCP longitude
        sl2m=celp*sra/celg
        cl2m=(selp*cdecg-celp*sdecg*cra)/celg
c        longitude of zenith in deg
        l2z=atan2(sl2m,cl2m)*RADIAN+l2p
      endif
c        ensure azimuthal angles are in interval [0,360)
      iz=azg/CIRCLE
      if (azg.lt.0._10) iz=iz-1
      azg=azg-iz*CIRCLE
      iz=l2z/CIRCLE
      if (l2z.lt.0._10) iz=iz-1
      l2z=l2z-iz*CIRCLE
      return
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine fframe(framei,azi,eli,framef,azf,elf)
      integer framei,framef
      real*10 azi,eli,azf,elf
c
c        parameters
      real*10 BEPOCH,JEPOCH
      parameter (BEPOCH=1950._10,JEPOCH=2000._10)
      include 'frames.par'
      include 'radian.par'
c        externals
      real*10 felp,SLA_epj2d
c        data variables
      logical init
c        saved local variables
      real*10 azg,elg,elp,l2z
      save azg,elg,elp,l2z
c        local (automatic) variables
      integer iaz
      real*10 date,dd,dec2k,dr,ra2k
c *
c * Transform azimuth (phi) and elevation (90-theta) in degrees
c * from one frame to another frame.
c *
c * Subroutines beginning SLA_ are from the STARLINK SLA library.
c * Please respect their copyright.
c *
c * WARNING:
c * The 2000 transformations are done consistently with the SLA
c * library, while the 1950 transformations are done consistently
c * using the transformations actually used by the catalogue makers
c * (notably, IRAS mask is in 1950 ecliptic coordinates).
c * The 1950 and 2000 transformations do not commute exactly,
c * but the residuals are < 1 arcsec.
c *
c * WARNING:
c * The SDSS eta, lambda system is unconventional
c * (latitude <-> longitude, and longitude goes backwards).
c * This subroutine returns conventional quantities
c *    azimuth = -eta
c *    elevation = lambda.
c *
c  Input: framei = initial frame, as defined in frames.par .
c         azi = azimuth (longitude) in degrees wrt framei .
c         eli = elevation (latitude) in degrees wrt framei .
c Output: framef = final frame, as defined in frames.par .
c         azf = azimuth (longitude) in degrees wrt framef
c               in interval [0,360).
c         elf = elevation (latitude) in degrees wrt framef
c               in interval [-90,90].
c
      data init /.true./
c
c--------initialize
      if (init) then
c        ecliptic latitude of North Celestial Pole (1950 FK4)
        elp=felp(BEPOCH)
c        angles to transform between ecliptic and galactic coordinates
        call azell(RAG,DECG,L2P,RAEZ,elp,EAZP,azg,elg,l2z)
        init=.false.
      endif

c--------initial and final frames identical
      if (framei.eq.framef) then
        azf=azi
        elf=eli

c--------1950 frames ->
      elseif (framei.eq.EQUATORIAL.or.framei.eq.ECLIPTIC) then
c........RA & Dec B1950.0 FK4 ->
        if (framei.eq.EQUATORIAL) then
          if (framef.eq.ECLIPTIC) then
            call azel(azi,eli,RAEZ,elp,EAZP,azf,elf)
          elseif (framef.eq.GALACTIC) then
            call azel(azi,eli,RAG,DECG,L2P,azf,elf)
          else
            call SLA_fk45z(azi/RADIAN,eli/RADIAN,BEPOCH,ra2k,dec2k)
            ra2k=ra2k*RADIAN
            dec2k=dec2k*RADIAN
          endif
c........Ecliptic 1950 ->
        elseif (framei.eq.ECLIPTIC) then
          if (framef.eq.EQUATORIAL) then
            call azel(azi,eli,EAZP,elp,RAEZ,azf,elf)
          elseif (framef.eq.GALACTIC) then
            call azel(azi,eli,azg,elg,l2z,azf,elf)
          else
            date=SLA_epj2d(BEPOCH)
            call SLA_ecleq(azi/RADIAN,eli/RADIAN,date,ra2k,dec2k)
            ra2k=ra2k*RADIAN
            dec2k=dec2k*RADIAN
          endif
        endif
c........-> 2000 frames
        if (framef.eq.EQUATORIAL2K) then
          azf=ra2k
          elf=dec2k
        elseif (framef.eq.ECLIPTIC2K) then
          date=SLA_epj2d(JEPOCH)
          call SLA_eqecl(ra2k/RADIAN,dec2k/RADIAN,date,azf,elf)
          azf=azf*RADIAN
          elf=elf*RADIAN
        elseif (framef.eq.SDSS) then
          call azel(ra2k,dec2k,RASDNP,DECSDNP,-ETANCP,azf,elf)
        endif

c--------2000 frames ->
      elseif (framei.eq.EQUATORIAL2K.or.framei.eq.ECLIPTIC2K
     *  .or.framei.eq.SDSS) then
c........initial frame -> RA & Dec 2000 FK5
        if (framei.eq.EQUATORIAL2K) then
          ra2k=azi
          dec2k=eli
        elseif (framei.eq.ECLIPTIC2K) then
          date=SLA_epj2d(JEPOCH)
          call SLA_ecleq(azi/RADIAN,eli/RADIAN,date,ra2k,dec2k)
          ra2k=ra2k*RADIAN
          dec2k=dec2k*RADIAN
        elseif (framei.eq.SDSS) then
          call azel(azi,eli,-ETANCP,DECSDNP,RASDNP,ra2k,dec2k)
        endif
c........RA & Dec 2000 FK5 -> final frame
        if (framef.eq.EQUATORIAL) then
          call SLA_fk54z(ra2k/RADIAN,dec2k/RADIAN,BEPOCH,azf,elf,dr,dd)
          azf=azf*RADIAN
          elf=elf*RADIAN
        elseif (framef.eq.ECLIPTIC) then
          date=SLA_epj2d(BEPOCH)
          call SLA_eqecl(ra2k/RADIAN,dec2k/RADIAN,date,azf,elf)
          azf=azf*RADIAN
          elf=elf*RADIAN
        elseif (framef.eq.GALACTIC) then
          call SLA_eqgal(ra2k/RADIAN,dec2k/RADIAN,azf,elf)
          azf=azf*RADIAN
          elf=elf*RADIAN
        elseif (framef.eq.EQUATORIAL2K) then
          azf=ra2k
          elf=dec2k
        elseif (framef.eq.ECLIPTIC2K) then
          date=SLA_epj2d(JEPOCH)
          call SLA_eqecl(ra2k/RADIAN,dec2k/RADIAN,date,azf,elf)
          azf=azf*RADIAN
          elf=elf*RADIAN
        elseif (framef.eq.SDSS) then
          call azel(ra2k,dec2k,RASDNP,DECSDNP,-ETANCP,azf,elf)
        endif

c--------Galactic frame ->
      elseif (framei.eq.GALACTIC) then
        if (framef.eq.EQUATORIAL) then
c         call SLA_ge50(azi/RADIAN,eli/RADIAN,azf,elf)
c         azf=azf*RADIAN
c         elf=elf*RADIAN
          call azel(azi,eli,L2P,DECG,RAG,azf,elf)
        elseif (framef.eq.ECLIPTIC) then
          call azel(azi,eli,l2z,elg,azg,azf,elf)
        else
          call SLA_galeq(azi/RADIAN,eli/RADIAN,ra2k,dec2k)
          if (framef.eq.EQUATORIAL2K) then
            azf=ra2k*RADIAN
            elf=dec2k*RADIAN
          elseif (framef.eq.ECLIPTIC2K) then
            date=SLA_epj2d(JEPOCH)
            call SLA_eqecl(ra2k,dec2k,date,azf,elf)
            azf=azf*RADIAN
            elf=elf*RADIAN
          elseif (framef.eq.SDSS) then
            ra2k=ra2k*RADIAN
            dec2k=dec2k*RADIAN
            call azel(ra2k,dec2k,RASDNP,DECSDNP,-ETANCP,azf,elf)
          endif
        endif

      endif
c--------put azf in interval [0,360)

      iaz=azf/360._10
      if (azf.lt.0._10) iaz=iaz-1
      azf=azf-iaz*360._10

      return
      end
c

!     This this is the main CAMB program module.
!
!     Code for Anisotropies in the Microwave Backgroundeqma
!     by Antony lewis (http://cosmologist.info) and Anthony Challinor
!     See readme.html for documentation. 

!     Note that though the code is internally parallelised, it is not thread-safe
!     so you cannot generate more than one model at the same time in different threads.
!
!     Based on CMBFAST  by  Uros Seljak and Matias Zaldarriaga, itself based
!     on Boltzmann code written by Edmund Bertschinger, Chung-Pei Ma and Paul Bode.
!     Original CMBFAST copyright and disclaimer:
!
!     Copyright 1996 by Harvard-Smithsonian Center for Astrophysics and
!     the Massachusetts Institute of Technology.  All rights reserved.
!
!     THIS SOFTWARE IS PROVIDED "AS IS", AND M.I.T. OR C.f.A. MAKE NO
!     REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPlIED.
!     By way of example, but not limitation,
!     M.I.T. AND C.f.A MAKE NO REPRESENTATIONS OR WARRANTIES OF
!     MERCHANTABIlITY OR FITNESS FOR ANY PARTICUlAR PURPOSE OR THAT
!     THE USE OF THE lICENSED SOFTWARE OR DOCUMENTATION WIll NOT INFRINGE
!     ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.
!
!     portions of this software are based on the COSMICS package of
!     E. Bertschinger.  See the lICENSE file of the COSMICS distribution
!     for restrictions on the modification and distribution of this software.

  module CAMBmain

!     This code evolves the linearized perturbation equations of general relativity,
!     the Boltzmann equations and the fluid equations for perturbations
!     of a Friedmann-Robertson-Walker universe with a supplied system of gauge-dependent equation
!     in a modules called GaugeInterface.  The sources for the line of sight integral are
!     computed at sampled times during the evolution for various of wavenumbers. The sources
!     are then interpolated to a denser wavenumber sampling for computing the line of
!     sight integrals of the form Integral d(conformal time) source_k * bessel_k_l. 
!     For CP%flat models the bessel functions are interpolated from a pre-computed table, for
!     non-CP%flat models the hyperspherical Bessel functions are computed by integrating their
!     differential equation. Both phases ('Evolution' and 'Integration') can do separate 
!     wavenumbers in parallel.

!     The time variable is conformal  time dtau=dt/a(t) and the spatial dependence is Fourier transformed 
!     with q=sqrt(k**2 + (|m|+1)K), comoving distances are x=CP%r/a(t), with a(t)=1 today.  
!     The units of both length and time are Mpc.

!    Many elements are part of derived types (to make thread safe or to allow non-sequential code use
!    CP = CAMB parameters
!    EV = Time evolution variables
!    IV = Source integration variables
!    CT = Cl transfer data
!    MT = matter transfer data

! Modules are defined in modules.f90, except GaugeInterface which gives the background and gauge-dependent 
! perturbation equations, and InitialPower which provides the initial power spectrum.

      use precision
      use ModelParams
      use ModelData
      use GaugeInterface
      use Transfer
      use SpherBessels
      use lvalues
      use MassiveNu
      use InitialPower
      use Errors

      implicit none

      private

      logical ExactClosedSum  !do all nu values in sum for Cls for Omega_k>0.1
  

      !Variables for integrating the sources with the bessel functions for each wavenumber
       type IntegrationVars
          integer q_ix
          real(dl) q, dq    !q value we are doing and delta q
  !        real(dl), dimension(:,:), pointer :: Delta_l_q
            !Contribution to C_l integral from this k 
          real(dl), dimension(:,:), pointer :: Source_q, ddSource_q
            !Interpolated sources for this k
    
          integer SourceSteps !number of steps up to where source is zero

      end type IntegrationVars
      
      integer SourceNum
      !SourceNum is total number sources (2 or 3 for scalars, 3 for tensors).

      real(dl) tautf(0:max_transfer_redshifts)  !Time of Trasfer%redshifts
        

      real(dl), dimension(:,:,:), allocatable :: Src, ddSrc !Sources and second derivs
        ! indices  Src( k_index, source_index, time_step_index )    
  
      real(dl), dimension(:,:,:), allocatable :: iCl_scalar, iCl_vector,iCl_tensor
       ! Cls at the l values we actually compute,  iCl_xxx(l_index, Cl_type, initial_power_index)
      
      Type(Regions) :: Evolve_q

      real(dl),parameter :: qmin0=0.1_dl

      real(dl) :: dtaurec_q
    
!     qmax - CP%Max_eta_k/CP%tau0, qmin = qmin0/CP%tau0 for flat case

      real(dl) qmin, qmax 

      real(dl) max_etak_tensor , max_etak_vector, max_etak_scalar
 !     Will only be calculated if k*tau < max_etak_xx

      integer maximum_l !Max value of l to compute
      real(dl) :: maximum_qeta = 3000._dl

      real(dl) :: fixq = 0._dl !Debug output of one q
      
      real(dl) :: ALens = 1._dl
      
      Type(ClTransferData), pointer :: ThisCT
                    
      public cmbmain, ALens, ClTransferToCl, InitVars !InitVars for BAO hack

contains  

     
      subroutine cmbmain
      integer q_ix 
      type(EvolutionVars) EV
  
!     Timing variables for testing purposes. Used if DebugMsgs=.true. in ModelParams
      real(sp) actual,timeprev,starttime

      if (CP%WantCls) then
        
         if (CP%WantTensors .and. CP%WantScalars) stop 'CMBMAIN cannot generate tensors and scalars'
         !Use CAMB_GetResults instead

         if (CP%WantTensors) then
            maximum_l = CP%Max_l_tensor 
            maximum_qeta = CP%Max_eta_k_tensor
         else
            maximum_l = CP%Max_l
            maximum_qeta = CP%Max_eta_k
         end if

   
         call initlval(lSamp, maximum_l)
         
         if (CP%flat)  call InitSpherBessels
         !This is only slow if not called before with same (or higher) Max_l, Max_eta_k
         !Preferably stick to Max_l being a multiple of 50
      end if 


      if (DebugMsgs .and. Feedbacklevel > 0) then
         actual=GetTestTime()
         starttime=actual !times don't include reading the Bessel file
       end if
    
      call InitVars !Most of single thread time spent here (in InitRECFAST)
      if (global_error_flag/=0) return

      if (DebugMsgs .and. Feedbacklevel > 0) then
         timeprev=actual
         actual=GetTestTime()
         write(*,*) actual-timeprev,' Timing for InitVars'
         write (*,*) 'r = ',real(CP%r),' scale = ',real(scale), 'age = ', real(CP%tau0)  
      end if 

       if (.not. CP%OnlyTransfers .or. CP%NonLinear==NonLinear_Lens)  call InitializePowers(CP%InitPower,CP%curv)
       if (global_error_flag/=0) return

!     Calculation of the CMB sources.


      if (CP%WantCls) call SetkValuesForSources 

      if (CP%WantTransfer) call InitTransfer
 
!      ***note that !$ is the prefix for conditional multi-processor compilation***
      !$ if (ThreadNum /=0) call OMP_SET_NUM_THREADS(ThreadNum)
        
   
      if (CP%WantCls) then

         if (DebugMsgs .and. Feedbacklevel > 0) write(*,*) 'Set ',Evolve_q%npoints,' source k values'
         
         call GetSourceMem

         if (CP%WantScalars) then
             ThisCT => CTransScal
         else if (CP%WantVectors) then
             ThisCT => CTransVec
         else
             ThisCT => CTransTens
         end if

         ThisCT%NumSources = SourceNum
         ThisCT%ls = lSamp

         !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDUlE(DYNAMIC) &
         !$OMP & PRIVATE(EV, q_ix)
         do q_ix= 1,Evolve_q%npoints
             if (global_error_flag==0) call DoSourcek(EV,q_ix)
         end do
         !$OMP END PARAllEl DO
        
         if (DebugMsgs .and. Feedbacklevel > 0) then
            timeprev=actual
            actual=GetTestTime()
            write(*,*) actual-timeprev,' Timing for source calculation'
         end if

      endif !WantCls

   
!     If transfer functions are requested, set remaining k values and output
      if (CP%WantTransfer .and. global_error_flag==0) then
        call TransferOut
         if (DebugMsgs .and. Feedbacklevel > 0) then
         timeprev=actual
         actual=GetTestTime()
         write(*,*) actual-timeprev,' Timing for transfer k values'
         end if  
      end if

       if (CP%WantTransfer .and. CP%WantCls .and. CP%DoLensing &
            .and. CP%NonLinear==NonLinear_Lens .and. global_error_flag==0) then
          
          call NonLinearLensing
          if (DebugMsgs .and. Feedbacklevel > 0) then
             timeprev=actual
             actual=GetTestTime()
             write(*,*) actual-timeprev,' Timing for NonLinear'
          end if

       end if

       if (CP%WantTransfer .and. .not. CP%OnlyTransfers .and. global_error_flag==0) &
          call Transfer_Get_sigma8(MT,8._dl) 
           !Can call with other arguments if need different size
 
!     if CMB calculations are requested, calculate the Cl by
!     integrating the sources over time and over k.


      if (CP%WantCls) then
         
         if (global_error_flag==0) then
          
         call InitSourceInterpolation   
       
         ExactClosedSum = CP%curv > 5e-9_dl .or. scale < 0.93_dl
     
         call SetkValuesForInt

         if (DebugMsgs .and. Feedbacklevel > 0) write(*,*) 'Set ',ThisCT%q%npoints,' integration k values'
   
      !Begin k-loop and integrate Sources*Bessels over time

      
      !$OMP PARAllEl DO DEFAUlT(SHARED),SHARED(TimeSteps), SCHEDUlE(STATIC,4) 
          do q_ix=1,ThisCT%q%npoints
            call SourceToTransfers(q_ix)
         end do !q loop
       !$OMP END PARAllEl DO 
  
        if (DebugMsgs .and. Feedbacklevel > 0) then
         timeprev=actual
         actual=GetTestTime()
         write(*,*)actual-timeprev,' Timing For Integration'
        end if
 
        end if
        
        call FreeSourceMem

        !Final calculations for CMB output unless want the Cl transfer functions only.

        if (.not. CP%OnlyTransfers .and. global_error_flag==0) &
          call ClTransferToCl(CTransScal,CTransTens, CTransVec)

      end if

 
      if (DebugMsgs .and. Feedbacklevel > 0) then
         timeprev=actual
         actual = GetTestTime()
         write(*,*) actual - timeprev,' Timing for final output'
         write(*,*) actual -starttime,' Timing for whole of cmbmain'
      end if

      end subroutine cmbmain

     subroutine ClTransferToCl(CTransS,CTransT, CTransV)
        Type(ClTransferData) :: CTransS,CTransT, CTransV

       if (CP%WantScalars .and. global_error_flag==0) then
           lSamp = CTransS%ls
           allocate(iCl_Scalar(CTransS%ls%l0,C_Temp:C_last,CP%InitPower%nn))
           iCl_scalar = 0
           
           call CalcScalCls(CTransS)
           if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'CalcScalCls'
       end if    

       if (CP%WantVectors .and. global_error_flag==0) then
           allocate(iCl_vector(CTransV%ls%l0,C_Temp:CT_Cross,CP%InitPower%nn))
           iCl_vector = 0
           call CalcVecCls(CTransV,GetInitPowerArrayVec)
           if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'CalcVecCls'
       end if    


       if (CP%WantTensors .and. global_error_flag==0) then
           allocate(iCl_Tensor(CTransT%ls%l0,CT_Temp:CT_Cross,CP%InitPower%nn))
           iCl_tensor = 0
           call CalcTensCls(CTransT,GetInitPowerArrayTens)
           if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'CalcTensCls'
       end if

       if (global_error_flag==0) then
        call Init_Cls
 
  !     Calculating Cls for every l.
        call InterpolateCls(CTransS,CTransT, CTransV)
   
        if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'InterplolateCls'

       end if

       if (CP%WantScalars .and. allocated(iCl_Scalar)) deallocate(iCl_scalar)
       if (CP%WantVectors .and. allocated(iCl_Vector)) deallocate(iCl_vector)
       if (CP%WantTensors .and. allocated(iCl_Tensor)) deallocate(iCl_tensor)
       
       if (global_error_flag/=0) return
 
       if (CP%OutputNormalization >=2) call NormalizeClsAtl(CP%OutputNormalization)
       !Normalize to C_l=1 at l=OutputNormalization 
     
     end subroutine ClTransferToCl
    

     subroutine SourceToTransfers(q_ix)
      integer q_ix
      type(IntegrationVars) :: IV
    
          allocate(IV%Source_q(TimeSteps%npoints,SourceNum))
          if (.not.CP%flat) allocate(IV%ddSource_q(TimeSteps%npoints,SourceNum))

            call IntegrationVars_init(IV)

            IV%q_ix = q_ix
            IV%q =ThisCT%q%points(q_ix)
            IV%dq= ThisCT%q%dpoints(q_ix)

            call InterpolateSources(IV)
           
            call DoSourceIntegration(IV)

          if (.not.CP%flat) deallocate(IV%ddSource_q) 
          deallocate(IV%Source_q)
         
     end subroutine SourceToTransfers
    

      subroutine InitTransfer
        integer nu,lastnu, ntodo, nq, q_ix, first_i
        real(dl) dlog_lowk1,dlog_lowk, d_osc,dlog_osc, dlog_highk, boost
        real(dl) amin,q_switch_lowk,q_switch_lowk1,q_switch_osc,q_switch_highk
        real(dl), dimension(:), allocatable :: q_transfer

       if (CP%Transfer%k_per_logint==0) then
        !Optimized spacing
        !Large log spacing on superhorizon scales
        !Linear spacing for horizon scales and first few baryon osciallations
        !Log spacing for last few oscillations
        !large log spacing for small scales

           boost = AccuracyBoost 
           if (CP%Transfer%high_precision) boost = boost*1.5

           q_switch_lowk1 = 0.7/taurst
           dlog_lowk1=2*boost

           q_switch_lowk = 8/taurst
           dlog_lowk=8*boost
           if (HighAccuracyDefault) dlog_lowk = dlog_lowk*2.5

           q_switch_osc = min(CP%Transfer%kmax,30/taurst)
           d_osc= 200*boost
           if (HighAccuracyDefault) d_osc = d_osc*1.8
    
           q_switch_highk = min(CP%Transfer%kmax,60/taurst)
           dlog_osc = 17*boost 
           if (HighAccuracyDefault) q_switch_highk = min(CP%Transfer%kmax,90/taurst)

           !Then up to kmax
           dlog_highk = 3*boost
            
           amin = 5e-5_dl

           nq=int((log(CP%Transfer%kmax/amin))*d_osc)+1 
           allocate(q_transfer(nq))
     
           nq=int((log(q_switch_lowk1/amin))*dlog_lowk1)+1 
           do q_ix=1, nq
            q_transfer(q_ix) = amin*exp((q_ix-1)/dlog_lowk1)
           end do
           MT%num_q_trans = nq

           nq=int(log( q_switch_lowk/q_transfer(MT%num_q_trans))*dlog_lowk) +1
           do q_ix=1, nq
            q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)*exp(q_ix/dlog_lowk)
           end do
           MT%num_q_trans = MT%num_q_trans + nq

           nq=int((q_switch_osc-q_transfer(MT%num_q_trans))*d_osc)+1 
           do q_ix=1, nq
            q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)+ q_ix/d_osc
           end do
           MT%num_q_trans = MT%num_q_trans + nq

           if (CP%Transfer%kmax > q_transfer(MT%num_q_trans)) then
            nq=int(log( q_switch_highk/q_transfer(MT%num_q_trans))*dlog_osc) +1
            do q_ix=1, nq
             q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)*exp(q_ix/dlog_osc)
            end do
            MT%num_q_trans = MT%num_q_trans + nq
           end if

           if (CP%Transfer%kmax > q_transfer(MT%num_q_trans)) then
            nq=int(log(CP%Transfer%kmax/q_transfer(MT%num_q_trans))*dlog_highk)+1 
            do q_ix=1, nq
             q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)*exp(q_ix/dlog_highk)
            end do
            MT%num_q_trans = MT%num_q_trans + nq
           end if
   
        else
         !Fixed spacing
          MT%num_q_trans=int((log(CP%Transfer%kmax)-log(qmin))*CP%Transfer%k_per_logint)+1
          allocate(q_transfer(MT%num_q_trans))
          do q_ix=1, MT%num_q_trans
            q_transfer(q_ix) = qmin*exp(real(q_ix)/CP%Transfer%k_per_logint)
          end do
        end if

         if (CP%closed) then
              lastnu=0
              ntodo = 0
               do q_ix=1,MT%num_q_trans
                nu =nint(CP%r*q_transfer(q_ix))
                if (.not. ((nu<3).or.(nu<=lastnu))) then
                   ntodo=ntodo+1
                   q_transfer(ntodo)= nu/CP%r
                   lastnu=nu
                end if
               end do
              MT%num_q_trans = ntodo
         end if

         if (CP%WantCls) then
               ntodo = MT%num_q_trans
               first_i = ntodo+1
               do q_ix = 1,ntodo
                if (q_transfer(q_ix) > Evolve_q%highest+1d-4) then
                !Feb13 fix for case with closed universe where qmax is not neccessarily right quantized value
                 !   if (q_transfer(q_ix) > qmax) then
                      first_i=q_ix 
                      exit
                end if
               end do            
           
               if (first_i > ntodo) then
               MT%num_q_trans = Evolve_q%npoints 
              else
               MT%num_q_trans = Evolve_q%npoints + (ntodo - first_i+1) 
              end if
              call Transfer_Allocate(MT)

              MT%q_trans(1:Evolve_q%npoints) = Evolve_q%points(1:Evolve_q%npoints)
              if (MT%num_q_trans > Evolve_q%npoints) then
               MT%q_trans(Evolve_q%npoints+1:MT%num_q_trans) = q_transfer(first_i:ntodo)
          end if

         else
             Evolve_q%npoints = 0
             call Transfer_Allocate(MT)
             MT%q_trans = q_transfer(1:MT%num_q_trans)
         end if
          
         deallocate(q_transfer)
  
      end  subroutine InitTransfer

      function GetTauStart(q)
        real(dl), intent(IN) :: q
        real(dl) taustart, GetTauStart

!     Begin when wave is far outside horizon.
!     Conformal time (in Mpc) in the radiation era, for photons plus 3 species
!     of relativistic neutrinos.
            if (CP%flat) then
              taustart=0.001_dl/q
            else
              taustart=0.001_dl/sqrt(q**2-CP%curv)
            end if

            if (fixq/=0._dl) then
              taustart = 0.001_dl/fixq  
            end if
            
!     Make sure to start early in the radiation era.
           taustart=min(taustart,0.1_dl)

!     Start when massive neutrinos are strongly relativistic.
            if (CP%Num_nu_massive>0) then
               taustart=min(taustart,1.d-3/maxval(nu_masses(1:CP%Nu_mass_eigenstates))/adotrad)
            end if

            GetTauStart=taustart
      end function GetTauStart


      subroutine DoSourcek(EV,q_ix)
        integer q_ix
        real(dl) taustart
        type(EvolutionVars) EV

            EV%q=Evolve_q%points(q_ix) 
 
            if (fixq/=0._dl) then
                EV%q=fixq !for testing
            end if
            EV%q2=EV%q**2

            EV%q_ix = q_ix
            EV%TransferOnly=.false.
      
            taustart = GetTauStart(EV%q)
   
            call GetNumEqns(EV)

            if (CP%WantScalars .and. global_error_flag==0) call CalcScalarSources(EV,taustart)
            if (CP%WantVectors .and. global_error_flag==0) call CalcVectorSources(EV,taustart)
            if (CP%WantTensors .and. global_error_flag==0) call CalcTensorSources(EV,taustart)

      end subroutine DoSourcek

       subroutine GetSourceMem
     
        if (CP%WantScalars) then
           if (CP%Dolensing) then
            SourceNum=3
            C_last = C_PhiE
         else
            SourceNum=2
            C_last = C_Cross
           end if
        else
           SourceNum=3 
        end if
       
        allocate(Src(Evolve_q%npoints,SourceNum,TimeSteps%npoints))
        Src=0
        allocate(ddSrc(Evolve_q%npoints,SourceNum,TimeSteps%npoints))
    
       end subroutine GetSourceMem


       subroutine FreeSourceMem
         
        if (allocated(Src))deallocate(Src, ddSrc)
        call Ranges_Free(Evolve_q)

       end subroutine FreeSourceMem


!  initial variables, number of steps, etc.
      subroutine InitVars
      use ThermoData
      use precision
      use ModelParams
      
      implicit none
      real(dl) taumin, maxq, initAccuracyBoost
      integer itf
      
      initAccuracyBoost = AccuracyBoost 

 ! Maximum and minimum k-values.      
      if (CP%flat) then
      qmax=maximum_qeta/CP%tau0
      qmin=qmin0/CP%tau0/initAccuracyBoost 
      else              
        qmax=maximum_qeta/CP%r/CP%chi0
        qmin=qmin0/CP%r/CP%chi0/initAccuracyBoost
      end if
!     Timesteps during recombination (tentative, the actual
!     timestep is the minimum between this value and taurst/40,
!     where taurst is the time when recombination starts - see inithermo

      dtaurec_q=4/qmax/initAccuracyBoost 
      if (.not. CP%flat) dtaurec_q=dtaurec_q/6
      !AL:Changed Dec 2003, dtaurec feeds back into the non-flat integration via the step size
      dtaurec = dtaurec_q
      !dtau rec may be changed by inithermo

      max_etak_tensor = initAccuracyBoost*maximum_qeta /10  
      max_etak_scalar = initAccuracyBoost*max(1700._dl,maximum_qeta) /20 
      if (maximum_qeta <3500 .and. AccuracyBoost < 2) max_etak_scalar = max_etak_scalar * 1.5
        !tweak to get large scales right
      max_etak_vector = max_etak_scalar
      
      if (CP%WantCls) then     
         maxq = qmax
         if (CP%WantTransfer) maxq=max(qmax,CP%Transfer%kmax)
      else
         maxq=CP%Transfer%kmax
      end if


      taumin=GetTauStart(maxq)
   
!     Initialize baryon temperature and ionization fractions vs. time.
!     This subroutine also fixes the timesteps where the sources are
!     saved in order to do the integration. So TimeSteps is set here.
      !These routines in ThermoData (modules.f90)
      call inithermo(taumin,CP%tau0)
      if (global_error_flag/=0) return
   
      if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'inithermo'

!Do any array initialization for propagation equations
      call GaugeInterface_Init
 
      if (Feedbacklevel > 0)  &
           write(*,'("tau_recomb/Mpc       = ",f7.2,"  tau_now/Mpc = ",f8.1)') tau_maxvis,CP%tau0

!     Calculating the times for the outputs of the transfer functions.
!
      if (CP%WantTransfer) then
         do itf=1,CP%Transfer%num_redshifts
            tautf(itf)=min(TimeOfz(CP%Transfer%redshifts(itf)),CP%tau0)
            if (itf>1) then
             if (tautf(itf) <= tautf(itf-1)) then
               stop 'Transfer redshifts not set or out of order'
             end if
            end if
         end do
      endif
 
      end subroutine InitVars

      subroutine SetkValuesForSources
      implicit none
      real(dl) dlnk0, dkn1, dkn2, q_switch
      real(dl) qmax_log
      real(dl) SourceAccuracyBoost
!     set k values for which the sources for the anisotropy and
!     polarization will be calculated. For low values of k we
!     use a logarithmic spacing. closed case dealt with by SetClosedkValues

         SourceAccuracyBoost = AccuracyBoost  
         if (CP%WantScalars .and. CP%Reion%Reionization .and. CP%AccuratePolarization) then
            dlnk0=2._dl/10/SourceAccuracyBoost 
            !Need this to get accurate low l polarization
         else
            dlnk0=5._dl/10/SourceAccuracyBoost
            if (CP%closed) dlnk0=dlnk0/2
         end if

         if (CP%AccurateReionization) dlnk0 = dlnk0/2

         dkn1=0.6_dl/taurst/SourceAccuracyBoost   
         dkn2=0.9_dl/taurst/SourceAccuracyBoost 
         if (HighAccuracyDefault) dkn2=dkn2/1.2
         if (CP%WantTensors .or. CP%WantVectors) then
              dkn1=dkn1  *0.8_dl
              dlnk0=dlnk0/2 !*0.3_dl
              dkn2=dkn2*0.85_dl
          end if

         qmax_log = dkn1/dlnk0
         q_switch = 2*6.3/taurst 
           !Want linear spacing for wavenumbers which come inside horizon
           !Could use sound horizon, but for tensors that is not relevant

         call Ranges_Init(Evolve_q)
         call Ranges_Add_delta(Evolve_q, qmin, qmax_log, dlnk0, IsLog = .true.)
         call Ranges_Add_delta(Evolve_q, qmax_log, min(qmax,q_switch), dkn1)
         if (qmax > q_switch) then
           call Ranges_Add_delta(Evolve_q, q_switch, qmax, dkn2)
         end if

         call Ranges_GetArray(Evolve_q, .false.)

         if (CP%closed) &
           call SetClosedkValuesFromArr(Evolve_q, .false.) 
 
      end subroutine SetkValuesForSources


      subroutine SetClosedkValuesFromArr(R, forInt)
      Type(Regions) :: R
      integer i,nu,lastnu,nmax
       !nu = 3,4,5... in CP%closed case, so set nearest integers from arr array
      logical, intent(in) :: forInt
      integer ix
      real(dl) dnu
      integer, allocatable :: nu_array(:)
             
       if (forInt .and. nint(R%points(1)*CP%r)<=3) then
        
         !quantization is important       
       call Ranges_Getdpoints(R,half_ends = .false.)
       R%dpoints = max(1,int(R%dpoints*CP%r+0.02))
       lastnu=2
       ix=1
       dnu =R%dpoints(ix)
       nmax=0
       lastnu=2   
       allocate(nu_array(R%npoints*2))    
       do
        
       do while (R%dpoints(ix)==dnu .and. ix <R%npoints) 
        ix=ix+1
       end do
       do nu=lastnu+1,nint(R%points(ix)*CP%r), nint(dnu)
          nmax=nmax+1 
          nu_array(nmax)= nu
       end do
       lastnu=nu_array(nmax) + nint(dnu)-1
       if (ix==R%npoints) exit
       dnu = R%dpoints(ix)
       end do
       if (nint(R%points(R%npoints)*CP%r) > nu_array(nmax)) then
          nmax=nmax+1
          nu_array(nmax) = nint(R%points(R%npoints)*CP%r)
       end if 
       deallocate(R%points)
       allocate(R%points(nmax))
       R%points = nu_array(1:nmax)/CP%r
       deallocate(nu_array)
       
      else
                
       lastnu=3
       nmax=1
      
       do i=2,R%npoints
         nu=nint(R%points(i)*CP%r)
         if (nu > lastnu) then
          nmax=nmax+1 
          lastnu=nu         
          R%points(nmax)=nu/CP%r 
         end if
       
       end do  
       R%points(1)=3/CP%r
       
       end if
       
       R%Lowest = R%points(1) 
       R%Highest = R%points(nmax)
       R%npoints=nmax

      end subroutine SetClosedkValuesFromArr



      subroutine CalcScalarSources(EV,taustart)
      use Transfer
      implicit none
      type(EvolutionVars) EV
      real(dl) tau,tol1,tauend, taustart
      integer j,ind,itf
      real(dl) c(24),w(EV%nvar,9), y(EV%nvar), sources(SourceNum)
      
      real(dl) yprime(EV%nvar), ddelta, delta, adotoa,dtauda, growth
      external dtauda

        if (fixq/=0._dl) then
            !evolution output
            EV%q=fixq
            EV%q2=EV%q**2
        endif

         w=0
         y=0
         call initial(EV,y, taustart)
         if (global_error_flag/=0) return
       
         tau=taustart
         ind=1

!!Example code for plotting out variable evolution
       if (fixq/=0._dl) then
        tol1=tol/exp(AccuracyBoost-1)
        call CreateTxtFile('evolve_q005.txt',1)
         do j=1,1000       
          tauend = taustart+(j-1)*(CP%tau0-taustart)/1000 
          call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
          yprime = 0
          call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)      
          adotoa = 1/(y(1)*dtauda(y(1)))
          ddelta= (yprime(3)*grhoc+yprime(4)*grhob)/(grhob+grhoc)
          delta=(grhoc*y(3)+grhob*y(4))/(grhob+grhoc)
          growth= ddelta/delta/adotoa
          write (1,'(7E15.5)') tau, delta, growth, y(3), y(4), y(EV%g_ix), y(1)
         end do
         close(1)
         stop
      end if

!     Begin timestep loop.

           itf=1
           tol1=tol/exp(AccuracyBoost-1) 
           if (CP%WantTransfer .and. CP%Transfer%high_precision) tol1=tol1/100

           do j=2,TimeSteps%npoints               
             tauend=TimeSteps%points(j)  

             if (.not. DebugEvolution .and. (EV%q*tauend > max_etak_scalar .and. tauend > taurend) &
                  .and. .not. CP%Dolensing .and. &
                  (.not.CP%WantTransfer.or.tau > tautf(CP%Transfer%num_redshifts))) then
      
              Src(EV%q_ix,1:SourceNum,j)=0
 
             else
             
             !Integrate over time, calulate end point derivs and calc output
             call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
             if (global_error_flag/=0) return
 
             call output(EV,y,j,tau,sources)
             Src(EV%q_ix,1:SourceNum,j)=sources
            
!     Calculation of transfer functions.
101          if (CP%WantTransfer.and.itf <= CP%Transfer%num_redshifts) then
                if (j < TimeSteps%npoints) then
                  if (tauend < tautf(itf) .and.TimeSteps%points(j+1)  > tautf(itf)) then
                          
                     call GaugeInterface_EvolveScal(EV,tau,y,tautf(itf),tol1,ind,c,w)
                     if (global_error_flag/=0) return

                  endif
                end if  
!     output transfer functions for this k-value.
                      
                  if (abs(tau-tautf(itf)) < 1.e-5_dl) then
                           call outtransf(EV,y, MT%TransferData(:,EV%q_ix,itf))
                         
                           itf=itf+1
                           if (j < TimeSteps%npoints) then
                            if (itf <= CP%Transfer%num_redshifts.and. &
                                TimeSteps%points(j+1) > tautf(itf)) goto 101
                           end if    
                  endif

                  end if
             end if

            end do !time step loop

      end subroutine


      subroutine CalcTensorSources(EV,taustart)

      implicit none
      type(EvolutionVars) EV
      real(dl) tau,tol1,tauend, taustart
      integer j,ind
      real(dl) c(24),wt(EV%nvart,9), yt(EV%nvart)


           call initialt(EV,yt, taustart)
     
           tau=taustart
           ind=1 
           tol1=tol/exp(AccuracyBoost-1)

!     Begin timestep loop.    
           do j=2,TimeSteps%npoints
                  tauend=TimeSteps%points(j)        
                  if (EV%q*tauend > max_etak_tensor) then
                     Src(EV%q_ix,1:SourceNum,j) = 0
                   else
      
                      call GaugeInterface_EvolveTens(EV,tau,yt,tauend,tol1,ind,c,wt)
             
                      call outputt(EV,yt,EV%nvart,j,tau,Src(EV%q_ix,CT_Temp,j),&
                                  Src(EV%q_ix,CT_E,j),Src(EV%q_ix,CT_B,j))
           
                   end if
              end do
    
      end subroutine CalcTensorSources


      subroutine CalcVectorSources(EV,taustart)

      implicit none
      type(EvolutionVars) EV
      real(dl) tau,tol1,tauend, taustart
      integer j,ind
      real(dl) c(24),wt(EV%nvarv,9), yv(EV%nvarv)!,yvprime(EV%nvarv)
        
           
!EV%q=0.2
!EV%q2=EV%q**2

           call initialv(EV,yv, taustart)
     
           tau=taustart
           ind=1 
           tol1=tol*0.01/exp(AccuracyBoost-1)

!!Example code for plotting out variable evolution
!if (.false.) then
!        do j=1,6000      
!          tauend = taustart * exp(j/6000._dl*log(CP%tau0/taustart))
!         call dverk(EV,EV%nvarv,fderivsv,tau,yv,tauend,tol1,ind,c,EV%nvarv,wt) !tauend
!          call fderivsv(EV,EV%nvarv,tau,yv,yvprime)
!
!          write (*,'(7E15.5)') yv(1), yv(2), yv(3),yv(4), &
!                   yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1), &
!                yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+2),yv(5)                            
!         end do
!       stop
!nd if

!     Begin timestep loop.            
               do j=2,TimeSteps%npoints
                  tauend=TimeSteps%points(j)

                  if ( EV%q*tauend > max_etak_vector) then
                     Src(EV%q_ix,1:SourceNum,j) = 0
                   else
      
                      call dverk(EV,EV%nvarv,derivsv,tau,yv,tauend,tol1,ind,c,EV%nvarv,wt) !tauend
                 
                      call outputv(EV,yv,EV%nvarv,j,tau,Src(EV%q_ix,CT_Temp,j),&
                                  Src(EV%q_ix,CT_E,j),Src(EV%q_ix,CT_B,j))
           
                   end if
              end do

      end subroutine CalcVectorSources


     subroutine TransferOut
    !Output transfer functions for k larger than used for C_l computation
      implicit none
      integer q_ix
      real(dl) tau
      type(EvolutionVars) EV
    

       if (DebugMsgs .and. Feedbacklevel > 0) & 
         write(*,*) MT%num_q_trans-Evolve_q%npoints, 'transfer k values'

      !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDUlE(DYNAMIC) &
      !$OMP & PRIVATE(EV, tau, q_ix) 

!     loop over wavenumbers.
         do q_ix=Evolve_q%npoints+1,MT%num_q_trans
      
            EV%TransferOnly=.true. !in case we want to do something to speed it up
          
            EV%q= MT%q_trans(q_ix)

            EV%q2=EV%q**2
            EV%q_ix = q_ix
          
            tau = GetTauStart(EV%q)

            call GetNumEqns(EV)

            call GetTransfer(EV, tau)

         end do
     !$OMP END PARAllEl DO 

     end subroutine TransferOut
      
     subroutine GetTransfer(EV,tau)
       type(EvolutionVars) EV
       real(dl) tau
       integer ind, i
       real(dl) c(24),w(EV%nvar,9), y(EV%nvar)
       real(dl) atol
       
       atol=tol/exp(AccuracyBoost-1)
       if (CP%Transfer%high_precision) atol=atol/10000

       ind=1
       call initial(EV,y, tau) 
       if (global_error_flag/=0) return 
         
       do i=1,CP%Transfer%num_redshifts
          call GaugeInterface_EvolveScal(EV,tau,y,tautf(i),atol,ind,c,w)
          if (global_error_flag/=0) return
          call outtransf(EV,y,MT%TransferData(:,EV%q_ix,i))
       end do
 
     end subroutine GetTransfer


     subroutine NonLinearLensing
        !Scale lensing source terms by non-linear scaling at each redshift and wavenumber
        use NonLinear
        integer i,ik,first_step
        real (dl) tau
        real(dl) scaling(CP%Transfer%num_redshifts), ddScaling(CP%Transfer%num_redshifts)
        real(dl) ho,a0,b0, ascale
        integer tf_lo, tf_hi
        type(MatterPowerData) :: CAMB_Pk

        call Transfer_GetMatterPowerData(MT, CAMB_PK, 1)

        call NonLinear_GetNonLinRatios(CAMB_PK)
 
         if (CP%InitPower%nn > 1) stop 'Non-linear lensing only does one initial power'

        first_step=1
        do while(TimeSteps%points(first_step) < tautf(1))
           first_step = first_step + 1 
        end do
 
        do ik=1, Evolve_q%npoints
          if (Evolve_q%points(ik)/(CP%H0/100) >  Min_kh_nonlinear) then

            !Interpolate non-linear scaling in conformal time
            do i = 1, CP%Transfer%num_redshifts
                scaling(i) = CAMB_Pk%nonlin_ratio(ik,i)
            end do
            if (all(abs(scaling-1) < 5e-4)) cycle
            call spline(tautf(1),scaling(1),CP%Transfer%num_redshifts,&
                                 spl_large,spl_large,ddScaling(1))
       
            tf_lo=1
            tf_hi=tf_lo+1

            do i=first_step,TimeSteps%npoints-1
  
              tau = TimeSteps%points(i)
            
              do while (tau > tautf(tf_hi))
                  tf_lo = tf_lo + 1
                  tf_hi = tf_hi + 1
              end do

              ho=tautf(tf_hi)-tautf(tf_lo) 
              a0=(tautf(tf_hi)-tau)/ho
              b0=1-a0
              
              ascale = a0*scaling(tf_lo)+ b0*scaling(tf_hi)+&
                  ((a0**3-a0)* ddscaling(tf_lo) &
                       +(b0**3-b0)*ddscaling(tf_hi))*ho**2/6
                        
              Src(ik,3,i) = Src(ik,3,i) * ascale
            end  do

          end if
       end do
       
       call MatterPowerdata_Free(CAMB_pk)
 
      end subroutine NonLinearLensing


      subroutine InitSourceInterpolation
      integer i,j
!     get the interpolation matrix for the sources to interpolate them
!     for other k-values
      !$OMP PARAllEl DO DEFAUlT(SHARED), SCHEDUlE(STATIC), PRIVATE(i,j) , SHARED(Evolve_q)
        do  i=1,TimeSteps%npoints
           do j=1, SourceNum
               call spline(Evolve_q%points,Src(1,j,i),Evolve_q%npoints,spl_large,spl_large,ddSrc(1,j,i))
          end do
        end do
       !$OMP END PARAllEl DO 
       end subroutine InitSourceInterpolation


     subroutine SetkValuesForInt
      implicit none
       
      integer no
      real(dl) dk,dk0,dlnk1, dk2, max_k_dk, k_max_log, k_max_0
      integer lognum
      real(dl)  qmax_int,IntSampleBoost
      

       qmax_int = min(qmax,max_bessels_etak/CP%tau0)

       IntSampleBoost=AccuracyBoost 
       if (do_bispectrum) then
        IntSampleBoost = IntSampleBoost * 2  
        if (hard_bispectrum) IntSampleBoost = IntSampleBoost * 2  
       end if
       
!     Fixing the # of k for the integration. 
      
       call Ranges_Init(ThisCT%q)

      if (CP%closed.and.ExactClosedSum) then
       
        call Ranges_Add(ThisCT%q,3/CP%r, nint(qmax_int*CP%r)/CP%r, nint(qmax_int*CP%r)-3) !fix jun08
        call Init_ClTransfer(ThisCT)
        call Ranges_Getdpoints(ThisCT%q,half_ends = .false.) !Jun08
      else

      !Split up into logarithmically spaced intervals from qmin up to k=lognum*dk0
      !then no-lognum*dk0 linearly spaced at dk0 up to no*dk0
      !then at dk up to max_k_dk, then dk2 up to qmax_int
         lognum=nint(10*IntSampleBoost)
         dlnk1=1._dl/lognum  
         no=nint(600*IntSampleBoost)
         dk0=1.8_dl/CP%r/CP%chi0/IntSampleBoost   
         dk=3._dl/CP%r/CP%chi0/IntSampleBoost 
         
         if (HighAccuracyDefault) dk=dk/1.6 

         k_max_log = lognum*dk0
         k_max_0  = no*dk0
         
         if (do_bispectrum) k_max_0 = max(10.d0,k_max_0) 

         dk2 = 0.04/IntSampleBoost  !very small scales  

         call Ranges_Add_delta(ThisCT%q, qmin, k_max_log, dlnk1, IsLog = .true.)
         call Ranges_Add_delta(ThisCT%q, k_max_log, min(qmax_int,k_max_0), dk0)     
       
         if (qmax_int > k_max_0) then

         max_k_dk = max(3000, 2*maximum_l)/CP%tau0
       
          call Ranges_Add_delta(ThisCT%q, k_max_0, min(qmax_int, max_k_dk), dk)
          if (qmax_int > max_k_dk) then
           !This allows inclusion of high k modes for computing BB lensed spectrum accurately
           !without taking ages to compute.
            call Ranges_Add_delta(ThisCT%q, max_k_dk, qmax_int, dk2)
          end if    

         end if           

         call Init_ClTransfer(ThisCT)

       if (CP%closed) then
        call SetClosedkValuesFromArr(ThisCT%q,.true.)
        call Ranges_Getdpoints(ThisCT%q,half_ends = .false.)
        ThisCT%q%dpoints(1) = 1/CP%r
        !!!  
        deallocate(ThisCT%Delta_p_l_k) !Re-do this from Init_ClTransfer because number of points changed
        allocate(ThisCT%Delta_p_l_k(ThisCT%NumSources,min(max_bessels_l_index,ThisCT%ls%l0), ThisCT%q%npoints))
        ThisCT%Delta_p_l_k = 0     
       end if

       end if !ExactClosedSum

         
      end subroutine setkValuesForInt

      subroutine InterpolateSources(IV)
      implicit none
      integer i,khi,klo, step
      real(dl) xf,b0,ho,a0,ho2o6,a03,b03
      type(IntegrationVars) IV


!     finding position of k in table Evolve_q to do the interpolation.

!Can't use the following in closed case because regions are not set up (only points)  
!           klo = min(Evolve_q%npoints-1,Ranges_IndexOf(Evolve_q, IV%q))
           !This is a bit inefficient, but thread safe
            klo=1
            do while ((IV%q > Evolve_q%points(klo+1)).and.(klo < (Evolve_q%npoints-1))) 
               klo=klo+1
            end do

            khi=klo+1


            ho=Evolve_q%points(khi)-Evolve_q%points(klo)
            a0=(Evolve_q%points(khi)-IV%q)/ho
            b0=(IV%q-Evolve_q%points(klo))/ho           
            ho2o6 = ho**2/6
            a03=(a0**3-a0)
            b03=(b0**3-b0)
            IV%SourceSteps = 0

!     Interpolating the source as a function of time for the present
!     wavelength.
             step=2
               do i=2, TimeSteps%npoints
                  xf=IV%q*(CP%tau0-TimeSteps%points(i))
                  if (CP%WantTensors) then
                   if (IV%q*TimeSteps%points(i) < max_etak_tensor.and. xf > 1.e-8_dl) then
                    step=i
                     IV%Source_q(i,1:SourceNum) =a0*Src(klo,1:SourceNum,i)+&
                          b0*Src(khi,1:SourceNum,i)+(a03 *ddSrc(klo,1:SourceNum,i)+ &
                          b03*ddSrc(khi,1:SourceNum,i)) *ho2o6
                    else
                     IV%Source_q(i,1:SourceNum) = 0
                   end if
                  end if
                  if (CP%WantVectors) then
                   if (IV%q*TimeSteps%points(i) < max_etak_vector.and. xf > 1.e-8_dl) then
                     step=i
                     IV%Source_q(i,1:SourceNum) =a0*Src(klo,1:SourceNum,i)+&
                          b0*Src(khi,1:SourceNum,i)+(a03 *ddSrc(klo,1:SourceNum,i)+ &
                          b03*ddSrc(khi,1:SourceNum,i)) *ho2o6
                    else
                     IV%Source_q(i,1:SourceNum) = 0
                   end if
                  end if

                  if (CP%WantScalars) then
                     if ((DebugEvolution .or. CP%Dolensing .or. IV%q*TimeSteps%points(i) < max_etak_scalar) &
                          .and. xf > 1.e-8_dl) then
                        step=i
                        IV%Source_q(i,1:SourceNum)=a0*Src(klo,1:SourceNum,i)+ &
                         b0*Src(khi,1:SourceNum,i) + (a03*ddSrc(klo,1:SourceNum,i) &
                         +b03*ddSrc(khi,1:SourceNum,i))*ho2o6
  
                     else
                       IV%Source_q(i,1:SourceNum) = 0 
                     end if
                  end if
               end do
               IV%SourceSteps = step


          if (.not.CP%flat) then
             do i=1, SourceNum
                call spline(TimeSteps%points,IV%Source_q(1,i),TimeSteps%npoints,&
                     spl_large,spl_large,IV%ddSource_q(1,i))
             end do
          end if
           
           IV%SourceSteps = IV%SourceSteps*1
           !This is a fix for a compiler bug on Seaborg 

      end subroutine

      
      subroutine IntegrationVars_Init(IV)
      type(IntegrationVars), intent(INOUT) :: IV
        
        IV%Source_q(1,1:SourceNum)=0
        IV%Source_q(TimeSteps%npoints,1:SourceNum) = 0
        IV%Source_q(TimeSteps%npoints-1,1:SourceNum) = 0
 
      end  subroutine IntegrationVars_Init


!cccccccccccccccccccccccccccccccccccc


      subroutine DoSourceIntegration(IV) !for particular wave number q
      integer j,ll,llmax
      real(dl) nu
      type(IntegrationVars) IV
       
         
         nu=IV%q*CP%r
        
         if (CP%closed) then
          
          if (nu<20 .or. CP%tau0/CP%r+6*pi/nu > pi/2) then
           llmax=nint(nu)-1
          else
           llmax=nint(nu*rofChi(CP%tau0/CP%r + 6*pi/nu))
           llmax=min(llmax,nint(nu)-1)  !nu >= l+1
          end if       

         else
          llmax=nint(nu*CP%chi0)
          
          if (llmax<15) then
           llmax=17 !AL Sept2010 changed from 15 to get l=16 smooth
          else
           llmax=nint(nu*rofChi(CP%tau0/CP%r + 6*pi/nu))
          end if
          
      
         end if 

         if (CP%flat) then
            call DoFlatIntegration(IV,llmax)
         else
           do j=1,lSamp%l0
            ll=lSamp%l(j)
            if (ll>llmax) exit  
         
            call IntegrateSourcesBessels(IV,j,ll,nu)      
           end do !j loop
         end if

       

      end subroutine DoSourceIntegration     

      function UseLimber(l,k)
       !Calculate lensing potential power using Limber rather than j_l integration
       !even when sources calculated as part of temperature calculation
       !(Limber better on small scales unless step sizes made much smaller)
       !This affects speed, esp. of non-flat case
        logical :: UseLimber
        integer l
        real(dl) :: k
 
        !note increasing non-limber to l>700 is not neccessarily more accurate unless AccruacyBoost much higher
        !use **0.2 to at least give some sensitivity to Limber effects
        if (CP%AccurateBB .or. CP%flat) then
         UseLimber = l > 700*AccuracyBoost**0.2 .and. k > 0.05
        else
         !This is accurate at percent level only (good enough here)
         UseLimber = l > 300*min(AccuracyBoost,2.4_dl) .or. k>0.05
        end if

      end function UseLimber

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!flat source integration
        subroutine DoFlatIntegration(IV, llmax)
        implicit none
        type(IntegrationVars) IV
        integer llmax
        integer j
        logical DoInt
        real(dl) xlim,xlmax1 
        real(dl) tmin, tmax
        real(dl) a2, J_l, aa(IV%SourceSteps), fac(IV%SourceSteps)
        real(dl) xf, sums(SourceNum)
        real(dl) qmax_int
        integer bes_ix,n, bes_index(IV%SourceSteps)
     
!     Find the position in the xx table for the x correponding to each
!     timestep

         do j=1,IV%SourceSteps !Precompute arrays for this k
            xf=abs(IV%q*(CP%tau0-TimeSteps%points(j)))
            bes_index(j)=Ranges_indexOf(BessRanges,xf)
          !Precomputed values for the interpolation
            bes_ix= bes_index(j)
            fac(j)=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
            aa(j)=(BessRanges%points(bes_ix+1)-xf)/fac(j)
            fac(j)=fac(j)**2*aa(j)/6
         end do

         do j=1,lSamp%l0 
             if (lSamp%l(j) > llmax) return
             xlim=xlimfrac*lSamp%l(j)
             xlim=max(xlim,xlimmin)
             xlim=lSamp%l(j)-xlim
             if (full_bessel_integration .or. do_bispectrum) then
                 tmin = TimeSteps%points(2)
             else
                 xlmax1=80*lSamp%l(j)*AccuracyBoost 
                 tmin=CP%tau0-xlmax1/IV%q
                 tmin=max(TimeSteps%points(2),tmin)                 
             end if 
             tmax=CP%tau0-xlim/IV%q
             tmax=min(CP%tau0,tmax)
        
             if (tmax < TimeSteps%points(2)) exit
             sums(1:SourceNum) = 0
 
            !As long as we sample the source well enough, it is sufficient to
            !interpolate the Bessel functions only

             if (SourceNum==2) then
              !This is the innermost loop, so we separate the no lensing scalar case to optimize it
                 do n= Ranges_IndexOf(TimeSteps,tmin),min(IV%SourceSteps,Ranges_IndexOf(TimeSteps,tmax))

                 a2=aa(n)
                 bes_ix=bes_index(n) 

                 J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                        *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac(n)) !cubic spline
 
                 J_l = J_l*TimeSteps%dpoints(n)
                 sums(1) = sums(1) + IV%Source_q(n,1)*J_l
                 sums(2) = sums(2) + IV%Source_q(n,2)*J_l

                end do
              else 
                 qmax_int= max(850,lSamp%l(j))*3*AccuracyBoost/CP%tau0
                 if (HighAccuracyDefault) qmax_int=qmax_int*1.2
                 DoInt = .not. CP%WantScalars .or. IV%q < qmax_int 
                 if (DoInt) then
                  do n= Ranges_IndexOf(TimeSteps,tmin),min(IV%SourceSteps,Ranges_IndexOf(TimeSteps,tmax))
                  !Full Bessel integration
                     a2=aa(n)
                     bes_ix=bes_index(n) 

                     J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                            *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac(n)) !cubic spline
                     J_l = J_l*TimeSteps%dpoints(n)
              
                    !The unwrapped form is faster
     
                     sums(1) = sums(1) + IV%Source_q(n,1)*J_l
                     sums(2) = sums(2) + IV%Source_q(n,2)*J_l
                     sums(3) = sums(3) + IV%Source_q(n,3)*J_l
                     
                  end do
                 end if
                 if (.not. DoInt .or. UseLimber(lsamp%l(j),IV%q) .and. CP%WantScalars) then
                  !Limber approximation for small scale lensing (better than poor version of above integral)
                  xf = CP%tau0-lSamp%l(j)/IV%q
                  if (xf < TimeSteps%Highest .and. xf > TimeSteps%Lowest) then
                   n=Ranges_IndexOf(TimeSteps,xf)
                   xf= (xf-TimeSteps%points(n))/(TimeSteps%points(n+1)-TimeSteps%points(n))                  
                   sums(3) = (IV%Source_q(n,3)*(1-xf) + xf*IV%Source_q(n+1,3))*sqrt(pi/2/lSamp%l(j))/IV%q 
                  else
                   sums(3)=0
                  end if
                 end if

              end if
  
              ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix) = ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix) + sums(1:SourceNum)
 !             IV%Delta_l_q(1:SourceNum,j) = IV%Delta_l_q(1:SourceNum,j) + sums(1:SourceNum)
         
          end do

      
        end subroutine DoFlatIntegration
   

    
!non-flat source integration

      subroutine IntegrateSourcesBessels(IV,j,l,nu)  
      use SpherBessels
      type(IntegrationVars) IV
      logical DoInt   
      integer l,j, nstart,nDissipative,ntop,nbot,nrange,nnow
      real(dl) nu,ChiDissipative,ChiStart,tDissipative,y1,y2,y1dis,y2dis     
      real(dl) xf,x,chi, miny1
      real(dl) sums(SourceNum),out_arr(SourceNum), qmax_int   
    
      !Calculate chi where for smaller chi it is dissipative
      x=sqrt(real(l*(l+1),dl))/nu
    
      ChiDissipative=invsinfunc(x) 
    
      ChiStart=ChiDissipative
      !Move down a bit to get smaller value (better accuracy integrating up from small values)
      if (nu<300) ChiStart = max(ChiDissipative-1._dl/nu,1d-6)   !max(ChiDissipative-1._dl/nu,1d-6)
 
        !Then get nearest source point with lower Chi...
      tDissipative=CP%tau0 - CP%r*ChiStart
      if (tDissipative<TimeSteps%points(1)) then
         nDissipative=2
       else 
         nDissipative = Ranges_IndexOf(TimeSteps,tDissipative)+1
      endif 
      nDissipative=min(nDissipative,TimeSteps%npoints-1)

      tDissipative = TimeSteps%points(nDissipative)

      ChiStart =  max(1d-8,(CP%tau0-tDissipative)/CP%r)
       
      !Get values at ChiStart
   
      call USpherBesselWithDeriv(CP%closed,ChiStart,l,nu,y1dis,y2dis)  

     nstart=nDissipative         
     chi=ChiStart

     if ((CP%WantScalars)) then !Do Scalars

      !Integrate chi down in dissipative region
      ! cuts off when ujl gets small
         miny1= 0.5d-4/l/AccuracyBoost
         sums=0
         qmax_int= max(850,lSamp%l(j))*3*AccuracyBoost/(CP%chi0*CP%r)
         if (HighAccuracyDefault) qmax_int=qmax_int*1.2 
         DoInt =  SourceNum/=3 .or. IV%q < qmax_int
         if (DoInt) then
         if ((nstart < min(TimeSteps%npoints-1,IV%SourceSteps)).and.(y1dis > miny1)) then
     
            y1=y1dis
            y2=y2dis
            nnow=nstart
            do nrange = 1,TimeSteps%Count
               if (nrange == TimeSteps%count) then
                ntop = TimeSteps%npoints -1
               else
                ntop = TimeSteps%R(nrange+1)%start_index
               end if
               if (nnow < ntop) then
                  call DoRangeInt(IV,chi,ChiDissipative,nnow,ntop,TimeSteps%R(nrange)%delta, &
                              nu,l,y1,y2,out_arr)        
                 sums  = sums + out_arr
                 nnow = ntop
                 if (chi==0) exit !small enough to cut off
               end if
             end do
           
           end if !integrate down chi
             
         !Integrate chi up in oscillatory region
          if (nstart > 2) then
           y1=y1dis
           y2=y2dis
           chi=ChiStart
            nnow=nstart
            do nrange = TimeSteps%Count,1,-1 
               nbot = TimeSteps%R(nrange)%start_index          
               if (nnow >  nbot) then
                  call DoRangeInt(IV,chi,ChiDissipative,nnow,nbot,TimeSteps%R(nrange)%delta, &
                              nu,l,y1,y2,out_arr)
                 sums=sums+out_arr
         
                 if (chi==0) exit !small for remaining region
                 nnow = nbot
               end if
               
            end do

           end if

           end if !DoInt
         if (SourceNum==3 .and. (.not. DoInt .or. UseLimber(l,IV%q))) then
            !Limber approximation for small scale lensing (better than poor version of above integral)
             xf = CP%tau0-invsinfunc(l/nu)*CP%r

!Feb09 fix screw up introduced Feb 2008 version
!       if (xf > TimeSteps%Lowest .and. xf > TimeSteps%Highest) then
             if (xf < TimeSteps%Highest .and. xf > TimeSteps%Lowest) then
             nbot=Ranges_IndexOf(TimeSteps,xf)
             xf= (xf-TimeSteps%points(nbot))/(TimeSteps%points(nbot+1)-TimeSteps%points(nbot))                  
             sums(3) = (IV%Source_q(nbot,3)*(1-xf) + xf*IV%Source_q(nbot+1,3))*&
                           sqrt(pi/2/l/sqrt(1-CP%Ksign*real(l**2)/nu**2))/IV%q
             else
              sums(3) = 0
             end if                
         end if

         ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix)=ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix)+sums
           
      end if !Do Scalars
           
     if ((CP%WantTensors)) then !Do Tensors
         chi=ChiStart
        
      !Integrate chi down in dissipative region
      !DoRangeInt cuts off when ujl gets small
         miny1= 1.d-6/l/AccuracyBoost
         if ((nstart < TimeSteps%npoints-1).and.(y1dis>miny1)) then
            y1=y1dis
            y2=y2dis
            nnow=nstart
            do nrange = 1,TimeSteps%Count
               if (nrange == TimeSteps%count) then
                ntop = TimeSteps%npoints -1
               else
                ntop = TimeSteps%R(nrange+1)%start_index
               end if
               if (nnow < ntop) then
                 call DoRangeIntTensor(IV,chi,ChiDissipative,nnow,ntop,TimeSteps%R(nrange)%delta, &
                              nu,l,y1,y2,out_arr)

                 ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix) = ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix) + out_arr
               
                 nnow = ntop
                 if (chi==0) exit
               end if
            end do
                   
         end if 
        
                 
!Integrate chi up in oscillatory region
          if (nstart > 2) then
           y1=y1dis
           y2=y2dis
           chi=ChiStart
         
           nnow=nstart
            do nrange = TimeSteps%Count,1,-1 
               nbot = TimeSteps%R(nrange)%start_index          
               if (nnow >  nbot) then
                 call DoRangeIntTensor(IV,chi,ChiDissipative,nnow,nbot,TimeSteps%R(nrange)%delta, &
                              nu,l,y1,y2,out_arr)
                 ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix) = ThisCT%Delta_p_l_k(1:SourceNum,j,IV%q_ix) + out_arr
                
                 nnow = nbot
                 if (chi==0) exit !small for remaining region
               end if               
            end do

          end if
       
        end if !Do Tensors
     
      end subroutine IntegrateSourcesBessels

   

 subroutine DoRangeInt(IV,chi,chiDisp,nstart,nend,dtau,nu,l,y1,y2,out)
 !Non-flat version

!returns chi at end of integral (where integral stops, not neccessarily end)
! This subroutine integrates the source*ujl for steps nstart to nend
! It calculates ujl by integrating a second order
! differential equation from initial values.
! dtau is the spacing of the timesteps (they must be equally spaced)

      use precision
      use ModelParams
      type(IntegrationVars) IV
      integer l,nIntSteps,nstart,nend,nlowest,isgn,i,is,Startn
      real(dl) nu,dtau,num1,num2,Deltachi,aux1,aux2
      real(dl) a,b,tmpa,tmpb,hh,h6,xh,delchi,taui
      real(dl) nu2,chi,chiDisp,dydchi1,dydchi2,yt1,yt2,dyt1,dyt2,dym1,dym2
  
      real(dl) tmp,dtau2o6,y1,y2,ap1,sh,ujl,chiDispTop
      real(dl) dchimax,dchisource,sgn,sgndelchi,minujl
      real(dl), parameter:: MINUJl1 = 0.5d-4  !cut-off point for small ujl l=1
      logical Interpolate
      real(dl) scalel
      real(dl) IntAccuracyBoost
      real(dl) sources(SourceNum), out(SourceNum)
   
      IntAccuracyBoost=AccuracyBoost 

! atau0 is the array with the time where the sources are stored.
      if (nend==nstart) then  
            out = 0
            return
         end if
      
      dchisource=dtau/CP%r
     
      num1=1._dl/nu     

      scalel=l/scale
      if (scalel>=2400) then
         num2=num1*2.5
      else if (scalel< 50) then
         num2=num1*0.8_dl
      else 
        num2=num1*1.5_dl 
      end if    
      !Dec 2003, since decrease dtaurec, can make this smaller
      if (dtau==dtaurec_q) then
       num2=num2/4
      end if

      if (HighAccuracyDefault .and. scalel<1500 .and. scalel > 150) &
          IntAccuracyBoost=IntAccuracyBoost*(1+(2000-scalel)*0.6/2000 ) 

      if (num2*IntAccuracyBoost < dchisource .and. (.not. CP%DoLensing .or. UseLimber(l,IV%q)) & 
!       if ((num2*IntAccuracyBoost < dchisource ) & !Oscillating fast 
        .or. (nstart>IV%SourceSteps.and.nend>IV%SourceSteps)) then  
         out = 0
         y1=0._dl !So we know to calculate starting y1,y2 if there is next range
         y2=0._dl
         chi=(CP%tau0-TimeSteps%points(nend))/CP%r
         return
        end if
     
      Startn=nstart
      if (nstart>IV%SourceSteps .and. nend < IV%SourceSteps) then
         chi=(CP%tau0-TimeSteps%points(IV%SourceSteps))/CP%r
         Startn=IV%SourceSteps
         call USpherBesselWithDeriv(CP%closed,chi,l,nu,y1,y2)
      else if ((y2==0._dl).and.(y1==0._dl)) then 
         call USpherBesselWithDeriv(CP%closed,chi,l,nu,y1,y2)
      end if
    
      if (CP%closed) then
        !Need to cut off when ujl gets exponentially small as it approaches Pi
         chiDispTop = pi - chiDisp
      else
         chiDispTop = 1d20
      end if

      minujl=MINUJl1/l/IntAccuracyBoost 
      isgn=sign(1,Startn-nend)!direction of chi integration 
        !higher n, later time, smaller chi
    
      sgn= isgn

      nlowest=min(Startn,nend)
      aux1=1._dl*CP%r/dtau  !used to calculate nearest timestep quickly
      aux2=(CP%tau0-TimeSteps%points(nlowest))/dtau + nlowest
          
      nu2=nu*nu
      ap1=l*(l+1)
      sh=rofChi(chi)
           
      if (scalel < 1100) then
         dchimax= 0.3*num1 
      else if (scalel < 1400) then
         dchimax=0.25_dl*num1 *1.5
      else
         dchimax=0.35_dl*num1 *1.5
      end if

      dchimax=dchimax/IntAccuracyBoost 
    
      ujl=y1/sh
      sources = IV%Source_q(Startn,1:SourceNum)

      out = 0.5_dl*ujl*sources

      Interpolate = dchisource > dchimax
      if (Interpolate) then !split up smaller than source step size
         delchi=dchimax
         Deltachi=sgn*(TimeSteps%points(Startn)-TimeSteps%points(nend))/CP%r
         nIntSteps=int(Deltachi/delchi+0.99_dl)        
         delchi=Deltachi/nIntSteps 
         dtau2o6=(CP%r*delchi)**2/6._dl
       else !step size is that of source
         delchi=dchisource
         nIntSteps=isgn*(Startn-nend)      
       end if
        
         sgndelchi=delchi*sgn
         tmp=(ap1/sh**2 - nu2) 
         hh=0.5_dl*sgndelchi  
         h6=sgndelchi/6._dl

      
          do i=1,nIntSteps          
! One step in the ujl integration
! fourth-order Runge-Kutta method to integrate equation for ujl

            dydchi1=y2         !deriv y1
            dydchi2=tmp*y1     !deriv y2     
            xh=chi+hh          !midpoint of step
            yt1=y1+hh*dydchi1  !y1 at midpoint
            yt2=y2+hh*dydchi2  !y2 at midpoint
            dyt1=yt2           !deriv y1 at mid
            tmp=(ap1/rofChi(xh)**2 - nu2) 
            
            
            dyt2=tmp*yt1       !deriv y2 at mid
       
            yt1=y1+hh*dyt1     !y1 at mid
            yt2=y2+hh*dyt2     !y2 at mid
           
            dym1=yt2           !deriv y1 at mid
            dym2=tmp*yt1       !deriv y2 at mid
            yt1=y1+sgndelchi*dym1 !y1 at end
            dym1=dyt1+dym1     
            yt2=y2+sgndelchi*dym2 !y2 at end
            dym2=dyt2+dym2
            
            chi=chi+sgndelchi     !end point
            sh=rofChi(chi)    
            dyt1=yt2           !deriv y1 at end
            tmp=(ap1/sh**2 - nu2)
            dyt2=tmp*yt1       !deriv y2 at end
            y1=y1+h6*(dydchi1+dyt1+2*dym1) !add up
            y2=y2+h6*(dydchi2+dyt2+2*dym2)       

            ujl=y1/sh
            if ((isgn<0).and.(y1*y2<0._dl).or.((chi>chiDispTop).and.((chi>3.14).or.(y1*y2>0)))) then
                chi=0._dl 
                exit   !If this happens we are small, so stop integration
            end if

     
            if (Interpolate) then
! Interpolate the source
            taui=aux2-aux1*chi
            is=int(taui)
             b=taui-is
    
            if (b > 0.998) then 
               !may save time, and prevents numerical error leading to access violation of IV%Source_q(0)
             sources = IV%Source_q(is+1,1:SourceNum)
             else

             a=1._dl-b          
             tmpa=(a**3-a)
             tmpb=(b**3-b)
             sources=a*IV%Source_q(is,1:SourceNum)+b*IV%Source_q(is+1,1:SourceNum)+ &
                  (tmpa*IV%ddSource_q(is,1:SourceNum)+ &
                   tmpb*IV%ddSource_q(is+1,1:SourceNum))*dtau2o6
             end if

            else
             sources = IV%Source_q(Startn - i*isgn,1:SourceNum)
      
            end if

            out = out + ujl*sources
                
            if (((isgn<0).or.(chi>chiDispTop)).and.(abs(ujl) < minujl)) then
           
             chi=0
            exit !break when getting  exponentially small in dissipative region

            end if
            
         end do

         out = (out - sources*ujl/2)*delchi*CP%r
         
         end subroutine DoRangeInt

 


      subroutine DoRangeIntTensor(IV,chi,chiDisp,nstart,nend,dtau,nu,l,y1,y2,out)
! It calculates ujl by integrating a second order
! differential equation from initial values for calculating ujl.
! nstart and nend are the starting and finishing values of the
! integration.
! dtau is the spacing of the timesteps (they must be equally spaced)

      use precision
      use ModelParams
      type(IntegrationVars), target :: IV
      integer l,nIntSteps,nstart,nend,nlowest,isgn,i,is
      real(dl) nu,dtau,num1,num2,Deltachi,aux1,aux2
      real(dl) a,b,tmpa,tmpb,hh,h6,xh,delchi,taui,scalel
      real(dl) nu2,chi,chiDisp,chiDispTop
      real(dl) dydchi1,dydchi2,yt1,yt2,dyt1,dyt2,dym1,dym2
  
      real(dl) tmp,dtau2o6,y1,y2,ap1,sh,ujl
      real(dl) dchimax,dchisource,sgn,sgndelchi,minujl
      real(dl), parameter:: MINUJl1 = 1.D-6  !cut-off point for smal ujl l=1
      logical Interpolate
      real(dl) out(SourceNum), source(SourceNum)
      real(dl), dimension(:,:), pointer :: sourcep, ddsourcep

      sourcep => IV%Source_q(:,1:)
      ddsourcep => IV%ddSource_q(:,1:)
      
     
      if (nend==nstart) then  
            out=0
            return
         end if    
      minujl=MINUJL1*AccuracyBoost/l
      isgn=sign(1,nstart-nend)!direction of chi integration 
        !higher n, later time, smaller chi

      if (CP%closed) then
        !Need to cut off when ujl gets exponentially small as it approaches Pi
         chiDispTop = pi - chiDisp
      else
         chiDispTop = 1d20
      end if
      
     
      num1=1._dl/nu
      dchisource=dtau/CP%r

      scalel=l/scale
      if (scalel>=2000) then
         num2=num1*4
      else if (scalel>=1000) then
         num2=num1*2.5 
      else if (scalel< 75) then
         num2=num1*0.1_dl
      else if (scalel<180) then
         num2=num1*0.3_dl
      else if (scalel < 600) then
         num2=num1*0.8_dl
      else
         num2=num1
      end if
  
      if ((isgn==1).and.(num2*AccuracyBoost < dchisource)) then  !Oscillating fast
         out = 0
         y1=0._dl !!So we know to calculate starting y1,y2 if there is next range
         y2=0._dl
         chi=(CP%tau0-TimeSteps%points(nend))/CP%r
         return
        end if
      if ((y2==0._dl).and.(y1==0._dl)) call USpherBesselWithDeriv(CP%closed,chi,l,nu,y1,y2)
   
      sgn=isgn

      nlowest=min(nstart,nend)
      aux1=1._dl*CP%r/dtau  !used to calculate nearest timestep quickly
      aux2=(CP%tau0-TimeSteps%points(nlowest))/dtau + nlowest
          
     
      nu2=nu*nu
      ap1=l*(l+1)

      sh=rofChi(chi)
      
      if (scalel < 120) then
         dchimax=0.6_dl*num1
      else if (scalel < 1400) then
         dchimax=0.25_dl*num1
      else
         dchimax=0.35_dl*num1 
      end if

      dchimax=dchimax/AccuracyBoost
     
      ujl=y1/sh
      out = ujl * sourcep(nstart,1:SourceNum)/2
   
      Interpolate = dchisource > dchimax
      if (Interpolate) then !split up smaller than source step size
         delchi=dchimax
         Deltachi=sgn*(TimeSteps%points(nstart)-TimeSteps%points(nend))/CP%r
         nIntSteps=int(Deltachi/delchi+0.99_dl)
         delchi=Deltachi/nIntSteps 
         dtau2o6=(CP%r*delchi)**2/6._dl
       else !step size is that of source
         delchi=dchisource
         nIntSteps=isgn*(nstart-nend)      
       end if
    
       
         sgndelchi=delchi*sgn
         tmp=(ap1/sh**2 - nu2) 
         hh=0.5_dl*sgndelchi  
         h6=sgndelchi/6._dl
    
                
         do i=1,nIntSteps
            

! One step in the ujl integration
! fourth-order Runge-Kutta method to integrate equation for ujl

            dydchi1=y2         !deriv y1
            dydchi2=tmp*y1     !deriv y2     
            xh=chi+hh          !midpoint of step
            yt1=y1+hh*dydchi1  !y1 at midpoint
            yt2=y2+hh*dydchi2  !y2 at midpoint
            dyt1=yt2           !deriv y1 at mid
            tmp=(ap1/rofChi(xh)**2 - nu2) 
          
            
            dyt2=tmp*yt1       !deriv y2 at mid        
            yt1=y1+hh*dyt1     !y1 at mid
            yt2=y2+hh*dyt2     !y2 at mid
           
            dym1=yt2           !deriv y1 at mid
            dym2=tmp*yt1       !deriv y2 at mid
            yt1=y1+sgndelchi*dym1 !y1 at end
            dym1=dyt1+dym1     
            yt2=y2+sgndelchi*dym2 !y2 at end
            dym2=dyt2+dym2
         
            chi=chi+sgndelchi     !end point
            sh=rofChi(chi)    
            dyt1=yt2           !deriv y1 at end
            tmp=(ap1/sh**2 - nu2)
            dyt2=tmp*yt1       !deriv y2 at end
            y1=y1+h6*(dydchi1+dyt1+2._dl*dym1) !add up
            y2=y2+h6*(dydchi2+dyt2+2._dl*dym2)

            ujl=y1/sh 
            if ((isgn<0).and.(y1*y2<0._dl).or.((chi>chiDispTop).and.((chi>3.14).or.(y1*y2>0)))) then
                chi=0._dl
                exit   !exit because ujl now small
                end if
            
            if (Interpolate) then
! Interpolate the source
            taui=aux2-aux1*chi
            is=int(taui)
            b=taui-is
            if (b > 0.995) then 
               !may save time, and prevents numerical error leading to access violation of zero index
             is=is+1
             source = sourcep(is,1:SourceNum)
            
             else
             a=1._dl-b            
             tmpa=(a**3-a)
             tmpb=(b**3-b)
             source = a*sourcep(is,1:SourceNum)+b*sourcep(is+1,1:SourceNum)+ &
                   (tmpa*ddsourcep(is,1:SourceNum) +  tmpb*ddsourcep(is+1,1:SourceNum))*dtau2o6

             end if           

            else
             source = sourcep(nstart - i*isgn,1:SourceNum)
          
            end if
            out = out + source * ujl
                  
            if (((isgn<0).or.(chi>chiDispTop)).and.(abs(ujl) < minujl)) then
            chi=0
            exit  !break when getting  exponentially small in dissipative region
            end if
         end do

         out = (out - source * ujl /2)*delchi*CP%r
       
         end subroutine DoRangeIntTensor

        subroutine GetInitPowerArrayVec(pows,ks, numks,pix)
         integer, intent(in) :: numks, pix
         real(dl) pows(numks), ks(numks)
         integer i
      
         do i = 1, numks
         !!change to vec...
            pows(i) =  ScalarPower(ks(i) ,pix)
            if (global_error_flag/=0) exit
         end do

        end subroutine GetInitPowerArrayVec


        subroutine GetInitPowerArrayTens(pows,ks, numks,pix)
         integer, intent(in) :: numks, pix
         real(dl) pows(numks), ks(numks)
         integer i
      
         do i = 1, numks
            pows(i) =  TensorPower(ks(i) ,pix)
            if (global_error_flag/=0) exit
         end do

        end subroutine GetInitPowerArrayTens


        subroutine CalcScalCls(CTrans)
        use Bispectrum
        implicit none
        Type(ClTransferData) :: CTrans
        integer pix,j
        real(dl) apowers, pows(CTrans%q%npoints)
        integer q_ix
        real(dl)  ks(CTrans%q%npoints),dlnks(CTrans%q%npoints),dlnk
        real(dl) ctnorm,dbletmp


         do pix=1,CP%InitPower%nn

          do q_ix = 1, CTrans%q%npoints 

             if (CP%flat) then
                     ks(q_ix) = CTrans%q%points(q_ix)
                     dlnks(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
             else
                     ks(q_ix) = sqrt(CTrans%q%points(q_ix)**2 - CP%curv)
                     dlnks(q_ix) = CTrans%q%dpoints(q_ix)*CTrans%q%points(q_ix)/ks(q_ix)**2
             end if

             pows(q_ix) =  ScalarPower(ks(q_ix) ,pix)
             if (global_error_flag/=0) return
      
          end do


        !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDUlE(STATIC,4) &
        !$OMP & PRIVATE(j,q_ix,dlnk,apowers,ctnorm,dbletmp)

         do j=1,CTrans%ls%l0

        !Integrate dk/k Delta_l_q**2 * Power(k)
          do q_ix = 1, CTrans%q%npoints 

             if (.not.(CP%closed.and.nint(CTrans%q%points(q_ix)*CP%r)<=CTrans%ls%l(j))) then 
               !cut off at nu = l + 1
             dlnk = dlnks(q_ix)
             apowers = pows(q_ix)

             iCl_scalar(j,C_Temp:C_E,pix) = iCl_scalar(j,C_Temp:C_E,pix) +  &
                          apowers*CTrans%Delta_p_l_k(1:2,j,q_ix)**2*dlnk
             iCl_scalar(j,C_Cross,pix) = iCl_scalar(j,C_Cross,pix) + &
                          apowers*CTrans%Delta_p_l_k(1,j,q_ix)*CTrans%Delta_p_l_k(2,j,q_ix)*dlnk
             if (CTrans%NumSources>2) then
                        iCl_scalar(j,C_Phi,pix) = iCl_scalar(j,C_Phi,pix) +  &
                                                       apowers*CTrans%Delta_p_l_k(3,j,q_ix)**2*dlnk
                        iCl_scalar(j,C_PhiTemp,pix) = iCl_scalar(j,C_PhiTemp,pix) +  &
                                          apowers*CTrans%Delta_p_l_k(3,j,q_ix)*CTrans%Delta_p_l_k(1,j,q_ix)*dlnk
                        iCl_scalar(j,C_PhiE,pix) = iCl_scalar(j,C_PhiE,pix) +  &
                                          apowers*CTrans%Delta_p_l_k(3,j,q_ix)*CTrans%Delta_p_l_k(2,j,q_ix)*dlnk
             end if

             end if
             
           end do

!Output l(l+1)C_l/OutputDenominator

           !ctnorm = (CTrans%ls%l+2)!/(CTrans%ls%l-2)! - beware of int overflow
            ctnorm=(CTrans%ls%l(j)*CTrans%ls%l(j)-1)*real((CTrans%ls%l(j)+2)*CTrans%ls%l(j),dl)
            dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*fourpi  
                 
            iCl_scalar(j,C_Temp,pix)  =  iCl_scalar(j,C_Temp,pix)*dbletmp
            iCl_scalar(j,C_E,pix)     =  iCl_scalar(j,C_E,pix)*dbletmp*ctnorm
            iCl_scalar(j,C_Cross,pix) =  iCl_scalar(j,C_Cross,pix)*dbletmp*sqrt(ctnorm)
            if (CTrans%NumSources>2) then
                     iCl_scalar(j,C_Phi,pix)   =  &
                          ALens*iCl_scalar(j,C_Phi,pix)*fourpi*real(CTrans%ls%l(j)**2,dl)**2    
                     !The lensing power spectrum computed is l^4 C_l^{\phi\phi}
                     !We put pix extra factors of l here to improve interpolation in CTrans%ls%l
                     iCl_scalar(j,C_PhiTemp,pix)   =  &
                          sqrt(ALens)*  iCl_scalar(j,C_PhiTemp,pix)*fourpi*real(CTrans%ls%l(j)**2,dl)*CTrans%ls%l(j)
                      !Cross-correlation is CTrans%ls%l^3 C_l^{\phi T}
                     iCl_scalar(j,C_PhiE,pix)   =  &
                          sqrt(ALens)*  iCl_scalar(j,C_PhiE,pix)*fourpi*real(CTrans%ls%l(j)**2,dl)*CTrans%ls%l(j)*sqrt(ctnorm)
                      !Cross-correlation is CTrans%ls%l^3 C_l^{\phi E}
             end if

           end do
         !$OMP END PARAllEl DO

          end do

        end subroutine CalcScalCls

        subroutine CalcScalCls2(CTrans)
        !Calculate C_ll' for non-isotropic models
        !Run with l_sample_boost=50 to get every l
        !not used in normal CAMB
        implicit none
        Type(ClTransferData) :: CTrans
        integer j,j2,in
        real(dl) apowers, pows(CTrans%q%npoints)
        integer q_ix
        real(dl)  ks(CTrans%q%npoints),dlnks(CTrans%q%npoints),dlnk
        real(dl) ctnorm,dbletmp
        real(dl), allocatable :: iCl_Scalar2(:,:,:,:) 

         allocate(iCl_Scalar2(CTranS%ls%l0,CTrans%ls%l0,C_Temp:C_last,CP%InitPower%nn))
         iCl_scalar2 = 0
    
         do in=1,CP%InitPower%nn
          do q_ix = 1, CTrans%q%npoints 

             if (CP%flat) then
                     ks(q_ix) = CTrans%q%points(q_ix)
                     dlnks(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
             else
                     ks(q_ix) = sqrt(CTrans%q%points(q_ix)**2 - CP%curv)
                     dlnks(q_ix) = CTrans%q%dpoints(q_ix)*CTrans%q%points(q_ix)/ks(q_ix)**2
             end if

             pows(q_ix) =  ScalarPower(ks(q_ix) ,in)
             if (global_error_flag/=0) return

          end do

         do j=1,CTrans%ls%l0
          do j2=1,CTrans%ls%l0

        !Integrate dk/k Delta_l_q**2 * Power(k)

          do q_ix = 1, CTrans%q%npoints 

             if (.not.(CP%closed.and.nint(CTrans%q%points(q_ix)*CP%r)<= CTrans%ls%l(j))) then 
               !cut off at nu = l + 1
             dlnk = dlnks(q_ix)
             apowers = pows(q_ix)

             iCl_scalar2(j,j2,C_Temp:C_E,in) = iCl_scalar2(j,j2,C_Temp:C_E,in) +  &
                          apowers*CTrans%Delta_p_l_k(1:2,j,q_ix)*CTrans%Delta_p_l_k(1:2,j2,q_ix)*dlnk
             iCl_scalar2(j,j2,C_Cross,in) = iCl_scalar2(j,j2,C_Cross,in) + &
                          apowers*CTrans%Delta_p_l_k(1,j,q_ix)*CTrans%Delta_p_l_k(2,j2,q_ix)*dlnk
    
             end if

           end do

!Output l(l+1)C_l/OutputDenominator

           !ctnorm = (CTrans%ls%l+2)!/(CTrans%ls%l-2)! - beware of int overflow
            ctnorm=(CTrans%ls%l(j)*CTrans%ls%l(j)-1)*real((CTrans%ls%l(j)+2)*CTrans%ls%l(j),dl)
            ctnorm=sqrt(ctnorm*(CTrans%ls%l(j2)*CTrans%ls%l(j2)-1)*real((CTrans%ls%l(j2)+2)*CTrans%ls%l(j2),dl))
            
            dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*fourpi  
            dbletmp=sqrt(dbletmp*(CTrans%ls%l(j2)*(CTrans%ls%l(j2)+1))/OutputDenominator*fourpi  )
                 
            iCl_scalar2(j,j2,C_Temp,in)  =  iCl_scalar2(j,j2,C_Temp,in)*dbletmp
            iCl_scalar2(j,j2,C_E,in)     =  iCl_scalar2(j,j2,C_E,in)*dbletmp*ctnorm
            iCl_scalar2(j,j2,C_Cross,in) =  iCl_scalar2(j,j2,C_Cross,in)*dbletmp*sqrt(ctnorm)
    
           end do

          end do

        end do
        
        call CreateTxtFile('z:\cl2.dat',1)
        do j=1,CTrans%ls%l0
        do j2=1,CTrans%ls%l0
         write (1,*) CTrans%ls%l(j),CTrans%ls%l(j2),iCl_scalar2(j,j2,1,1)*7.4311e12
        end do
        end do  
        close(1)
        call CreateTxtFile('cl1l2.dat',1)
        do j=1,999
         write (1,'(999E15.5)') iCl_scalar2(j,1:999,1,1)*7.4311e12
        end do          
        stop

        end subroutine CalcScalCls2

     
        subroutine CalcTensCls(CTrans, GetInitPowers)
        implicit none
        Type(ClTransferData) :: CTrans
        external GetInitPowers       
        integer in,j, q_ix
        real(dl) nu
        real(dl) apowert,  measure
        real(dl) ctnorm,dbletmp
        real(dl) pows(CTrans%q%npoints)
        real(dl)  ks(CTrans%q%npoints),measures(CTrans%q%npoints)

        !For tensors we want Integral dnu/nu (nu^2-3)/(nu^2-1) Delta_l_k^2 P(k) for CP%closed

        do in=1,CP%InitPower%nn
        
         do q_ix = 1, CTrans%q%npoints 

             if (CP%flat) then
                     ks(q_ix) = CTrans%q%points(q_ix)
                     measures(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
             else
                     nu = CTrans%q%points(q_ix)*CP%r
                     ks(q_ix) = sqrt(CTrans%q%points(q_ix)**2 - 3*CP%curv)
                     measures(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)*(nu**2-3*CP%Ksign)/(nu**2-CP%Ksign)
             end if

          end do

         call GetInitPowers(pows,ks,CTrans%q%npoints,in)

        !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDUlE(STATIC,4) &
        !$OMP & PRIVATE(j,q_ix,measure,apowert,ctnorm,dbletmp)
         do j=1,CTrans%ls%l0

          do q_ix = 1, CTrans%q%npoints 

                 if (.not.(CP%closed.and. nint(CTrans%q%points(q_ix)*CP%r)<=CTrans%ls%l(j))) then
                     !cut off at nu = l+1

                 apowert = pows(q_ix)
                 measure = measures(q_ix)
               
                 iCl_tensor(j,CT_Temp:CT_B,in) = iCl_tensor(j,CT_Temp:CT_B,in) + &
                      apowert*CTrans%Delta_p_l_k(CT_Temp:CT_B,j,q_ix)**2*measure
                 
                 iCl_tensor(j,CT_cross, in ) = iCl_tensor(j,CT_cross, in ) &
                      +apowert*CTrans%Delta_p_l_k(CT_Temp,j,q_ix)*CTrans%Delta_p_l_k(CT_E,j,q_ix)*measure
                 end if 
           end do

            ctnorm=(CTrans%ls%l(j)*CTrans%ls%l(j)-1)*real((CTrans%ls%l(j)+2)*CTrans%ls%l(j),dl)
            dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*pi/4
            iCl_tensor(j, CT_Temp, in)   = iCl_tensor(j, CT_Temp, in)*dbletmp*ctnorm
            if (CTrans%ls%l(j)==1) dbletmp=0
            iCl_tensor(j, CT_E:CT_B, in) = iCl_tensor(j, CT_E:CT_B, in)*dbletmp
            iCl_tensor(j, CT_Cross, in)  = iCl_tensor(j, CT_Cross, in)*dbletmp*sqrt(ctnorm)

         end do

         end do
    
        end subroutine CalcTensCls


        subroutine CalcVecCls(CTrans, GetInitPowers)
        implicit none
        Type(ClTransferData) :: CTrans
        external GetInitPowers       
        integer in,j, q_ix
        real(dl) power,  measure
        real(dl) ctnorm,lfac,dbletmp
        real(dl) pows(CTrans%q%npoints)
        real(dl)  ks(CTrans%q%npoints),measures(CTrans%q%npoints)

        do in=1,CP%InitPower%nn
        
         do q_ix = 1, CTrans%q%npoints 

               ks(q_ix) = CTrans%q%points(q_ix)
               measures(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)

          end do

         call GetInitPowers(pows,ks,CTrans%q%npoints,in)

        !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDUlE(STATIC,4) &
        !$OMP & PRIVATE(j,q_ix,measure,power,ctnorm,dbletmp,lfac)
         do j=1,CTrans%ls%l0

          do q_ix = 1, CTrans%q%npoints 

             if (.not.(CP%closed.and. nint(CTrans%q%points(q_ix)*CP%r)<=CTrans%ls%l(j))) then
                     !cut off at nu = l+1

                 power = pows(q_ix)
                 measure = measures(q_ix)
               
                 iCl_vector(j,CT_Temp:CT_B,in) = iCl_vector(j,CT_Temp:CT_B,in) + &
                      power*CTrans%Delta_p_l_k(CT_Temp:CT_B,j,q_ix)**2*measure
                 
                 iCl_vector(j,CT_cross, in ) = iCl_vector(j,CT_cross, in ) &
                      +power*CTrans%Delta_p_l_k(CT_Temp,j,q_ix)*CTrans%Delta_p_l_k(CT_E,j,q_ix)*measure
             end if 
          end do

            ctnorm=CTrans%ls%l(j)*(CTrans%ls%l(j)+1)
            dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*pi/8
            iCl_vector(j, CT_Temp, in)   = iCl_vector(j, CT_Temp, in)*dbletmp*ctnorm
            lfac = (CTrans%ls%l(j) + 2)*(CTrans%ls%l(j) - 1)
            iCl_vector(j, CT_E:CT_B, in) = iCl_vector(j, CT_E:CT_B, in)*dbletmp*lfac
            iCl_vector(j, CT_Cross, in)  = iCl_vector(j, CT_Cross, in)*dbletmp*sqrt(lfac*ctnorm)

         end do

         end do
    
        end subroutine CalcVecCls


    subroutine InterpolateCls(CTransS,CTransT,CTransV)
      implicit none
       Type(ClTransferData) :: CTransS, CTransT, CTransV
      integer in,i
  
!Note using log interpolation is worse]

      !$OMP PARALLEL DO DEFAULT(SHARED), PRIVATE(i,in), SHARED(CTransS,CTransT),IF(CP%InitPower%nn > 1)
      do in=1,CP%InitPower%nn
         if (CP%WantScalars) then
           do i = C_Temp, C_last
              call InterpolateClArrTemplated(CTransS%ls,iCl_scalar(1,i,in),Cl_scalar(lmin, in, i), &
                 CTransS%ls%l0,i)
           end do
         end if
      
         if (CP%WantVectors) then
           do i = C_Temp, CT_cross
            call InterpolateClArr(CTransV%ls,iCl_vector(1,i,in),Cl_vector(lmin, in, i),CTransV%ls%l0)
           end do
         end if
         
         if (CP%WantTensors) then
           do i = CT_Temp, CT_Cross
             call InterpolateClArr(CTransT%ls,iCl_tensor(1,i,in),Cl_tensor(lmin, in, i), &
               CTransT%ls%l0)
           end do
         end if
      end do
      !$OMP END PARALLEL DO
    end subroutine InterpolateCls


end module CAMBmain

    
     

    

 !Interface module for CAMB. Call CAMB_GetResults to do the work.

     module CAMB
         use Precision
         use ModelParams
         use ModelData
         use Transfer
         use GaugeInterface
         use InitialPower
         use Reionization
         use Recombination
         use lensing
         implicit none
         
         Type CAMBdata
            Type (ClTransferData) :: ClTransScal,ClTransTens,ClTransVec
            Type (MatterTransferData) :: MTrans
            Type (CAMBparams) :: Params
         end Type CAMBdata

!         public CAMB_GetTransfers, CAMB_GetResults, CAMB_GetCls, CAMB_SetDefParams, & 
!                CAMB_ValidateParams, CAMB_GetAge,CAMB_InitCAMBdata, 
     contains

       subroutine CAMB_GetTransfers(Params, OutData, error)
        use CAMBmain
        use lensing
        type(CAMBparams) :: Params
        type (CAMBdata)  :: OutData
        integer :: error !Zero if OK
  
      !Set internal types from OutData so it always 'owns' the memory, prevent leaks
      
        MT =  OutData%MTrans

        CTransScal = OutData%ClTransScal  
        CTransVec  = OutData%ClTransVec  
        CTransTens = OutData%ClTransTens
  

        call CAMB_GetResults(Params, error)
        OutData%Params = Params
        OutData%MTrans = MT
        OutData%ClTransScal = CTransScal
        OutData%ClTransVec  = CTransVec
        OutData%ClTransTens = CTransTens
  
       end subroutine CAMB_GetTransfers

       subroutine CAMB_InitCAMBdata(Dat)
        type (CAMBdata) :: Dat
 
!Comment these out to try to avoid intel bugs with status deallocating uninitialized pointers   
        call Ranges_Nullify(Dat%ClTransScal%q)
        call Ranges_Nullify(Dat%ClTransVec%q)
        call Ranges_Nullify(Dat%ClTransTens%q)

        nullify(Dat%ClTransScal%Delta_p_l_k)
        nullify(Dat%ClTransVec%Delta_p_l_k)
        nullify(Dat%ClTransTens%Delta_p_l_k)
        nullify(Dat%MTrans%sigma_8,Dat%MTrans%TransferData,Dat%MTrans%q_trans)
             
       end subroutine CAMB_InitCAMBdata


       subroutine CAMB_FreeCAMBdata(Dat)
            type (CAMBdata) :: Dat

            call Free_ClTransfer(Dat%ClTransScal)
            call Free_ClTransfer(Dat%ClTransVec)
            call Free_ClTransfer(Dat%ClTransTens)
            call Transfer_Free(Dat%MTrans)

       end subroutine CAMB_FreeCAMBdata


       subroutine CAMB_TransfersToPowers(CData)
        use CAMBmain
        use lensing
        type (CAMBdata) :: CData

        CP = CData%Params
        call InitializePowers(CP%InitPower,CP%curv)
        if (global_error_flag/=0) return
        if (CData%Params%WantCls) then
          call ClTransferToCl(CData%ClTransScal,CData%ClTransTens, CData%ClTransvec)  
          if (CP%DoLensing .and. global_error_flag==0) call lens_Cls
          if (global_error_flag/=0) return
          if (CP%OutputNormalization == outCOBE) call COBEnormalize
        end if
        if (CData%Params%WantTransfer) call Transfer_Get_sigma8(Cdata%MTrans,8._dl)
     
       end subroutine CAMB_TransfersToPowers
  


       !Call this routine with a set of parameters to generate the results you want.
       subroutine CAMB_GetResults(Params, error)
        use CAMBmain
        use lensing
        use Bispectrum
        use Errors
        type(CAMBparams) :: Params
        integer, optional :: error !Zero if OK
        type(CAMBparams) P
        logical :: separate = .true. !whether to do P_k in separate call or not
        logical :: InReionization
        
        if (Params%DoLensing .and. Params%NonLinear==NonLinear_Lens) separate = .false.
        InReionization = Params%Reion%Reionization
        global_error_flag = 0
        call_again = .false.
        
         if (Params%WantCls .and. Params%WantScalars) then
          P = Params
          if (separate) then
          P%WantTransfer = .false.
          P%Transfer%high_precision = .false.
          end if
          P%WantTensors = .false.
          P%WantVectors = .false.
          call CAMBParams_Set(P)  
          if (global_error_flag==0) call cmbmain
          if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return 
          end if
          call_again = .true.
          !Need to store CP%flat etc, but must keep original P_k settings
          CP%Transfer%high_precision = Params%Transfer%high_precision
          CP%WantTransfer = Params%WantTransfer
          CP%WantTensors = Params%WantTensors
          CP%WantVectors = Params%WantVectors
          CP%Transfer%num_redshifts = Params%Transfer%num_redshifts
          Params = CP            
         end if
 
         if (Params%WantCls .and. Params%WantTensors) then
          P=Params
          P%WantTransfer = .false.
          P%Transfer%high_precision = .false.
          P%WantScalars = .false.
          P%WantVectors = .false.
          call CAMBParams_Set(P)  
          if (global_error_flag==0) call cmbmain
          if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return 
          end if
           call_again = .true.
           CP%Transfer%high_precision = Params%Transfer%high_precision
           CP%WantTransfer = Params%WantTransfer
           CP%WantScalars = Params%WantScalars
           CP%WantVectors = Params%WantVectors
           CP%Transfer%num_redshifts = Params%Transfer%num_redshifts
           Params = CP            
   
         end if
 
         if (Params%WantCls .and. Params%WantVectors) then
          P=Params
          P%WantTransfer = .false.
          P%Transfer%high_precision = .false.
          P%WantScalars = .false.
          P%WantTensors = .false.
          call CAMBParams_Set(P)  
          if (global_error_flag==0) call cmbmain
          if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return 
          end if
          call_again = .true.
          CP%Transfer%high_precision = Params%Transfer%high_precision
          CP%WantTransfer = Params%WantTransfer
          CP%WantTensors = Params%WantTensors
          CP%WantScalars = Params%WantScalars
          CP%Transfer%num_redshifts = Params%Transfer%num_redshifts
          Params = CP            
   
         end if

         if (Params%WantTransfer .and. &
          .not. (Params%WantCls .and. Params%WantScalars .and. .not. separate)) then
          P=Params
          P%WantCls = .false.
          P%WantScalars = .false.
          P%WantTensors = .false.
          P%WantVectors = .false.
          call CAMBParams_Set(P)  
          if (global_error_flag==0) call cmbmain
          if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return 
          end if
          !Need to store num redshifts etc
          CP%WantScalars = Params%WantScalars
          CP%WantCls =  Params%WantCls
          CP%WantTensors = Params%WantTensors
          CP%WantVectors = Params%WantVectors
          CP%Reion%Reionization = InReionization
          Params = CP            

         end if

        call_again = .false.
   

        if (.not. CP%OnlyTransfers) then

         if (CP%WantCls .and. CP%OutputNormalization == outCOBE) call COBEnormalize

         if (CP%DoLensing .and. global_error_flag==0) then
           call lens_Cls 
         end if
         
         if (do_bispectrum .and. global_error_flag==0) call GetBispectrum(CTransScal) 

        end if

        end subroutine CAMB_GetResults


        !Return real (NOT double precision) arrays of the computed CMB  Cls
        !Output is l(l+1)C_l/2pi
        !If GC_Conventions = .false. use E-B conventions (as the rest of CAMB does)
        subroutine CAMB_GetCls(Cls, lmax, in, GC_conventions)
          integer, intent(IN) :: lmax, in
          logical, intent(IN) :: GC_conventions
          real, intent(OUT) :: Cls(2:lmax,1:4)
          integer l
      
          Cls = 0
          do l=2, lmax
             if (CP%WantScalars .and. l<= CP%Max_l) then
             Cls(l,1:2) = Cl_scalar(l, in,  C_Temp:C_E)
             Cls(l,4) = Cl_scalar(l, in,  C_Cross)
             end if
             if (CP%WantTensors .and. l <= CP%Max_l_tensor) then
                Cls(l,1:4) = Cls(l,1:4) + Cl_tensor(l, in,  CT_Temp:CT_Cross)
             end if
          end do
          if (GC_conventions) then
             Cls(:,2:3) = Cls(:,2:3)/2
             Cls(:,4)   = Cls(:,4)/sqrt(2.0)             
          end if
 
        end subroutine CAMB_GetCls

        function CAMB_GetAge(P)
           !Return age in gigayears, returns -1 on error
           use constants
           type(CAMBparams), intent(in) :: P
           real(dl) CAMB_GetAge
           integer error

           call  CAMBParams_Set(P, error, .false.)

           if (error/=0) then
            CAMB_GetAge = -1
           else
            CAMB_GetAge = DeltaPhysicalTimeGyr(0.0_dl,1.0_dl)
           end if
    
         end function CAMB_GetAge


        function CAMB_GetZreFromTau(P, tau)
           type(CAMBparams) :: P
           real(dl) tau
           real(dl) CAMB_GetZreFromTau
           integer error

            P%Reion%use_optical_depth = .true.
            P%Reion%optical_depth = tau
            call CAMBParams_Set(P,error)
            
            CAMB_GetZreFromTau = CP%Reion%redshift

        end function CAMB_GetZreFromTau

      
        subroutine CAMB_SetDefParams(P)
            use Bispectrum
            use constants
            type(CAMBparams), intent(out) :: P

            P%WantTransfer= .false.
            P%WantCls = .true.

            P%omegab  = .045
            P%omegac  = 0.255
            P%omegav  = 0.7
            P%omegan  = 0
            P%H0      = 65

            P%TCMB    = COBE_CMBTemp
            P%YHe     = 0.24
            P%Num_Nu_massless =default_nnu
            P%Num_Nu_massive  =0
            P%Nu_mass_splittings = .false.
            P%same_neutrino_Neff = .false.
            P%Nu_mass_eigenstates = 0
           
            P%Scalar_initial_condition =initial_adiabatic
            P%NonLinear = NonLinear_none
            
            call SetDefPowerParams(P%InitPower)

            call Recombination_SetDefParams(P%Recomb)
          
            call Reionization_SetDefParams(P%Reion)
            
            P%Transfer%high_precision=.false.
    
            P%OutputNormalization = outNone

            P%WantScalars = .true.
            P%WantVectors = .false.
            P%WantTensors = .false.
            P%want_zstar = .false.  !!JH 
            P%want_zdrag = .false.  !!JH  

            P%Max_l=1500
            P%Max_eta_k=3000
            P%Max_l_tensor=400
            P%Max_eta_k_tensor=800
            !Set up transfer just enough to get sigma_8 OK
            P%Transfer%kmax=0.9  
            P%Transfer%k_per_logint=0
            P%Transfer%num_redshifts=1
            P%Transfer%redshifts=0

            P%AccuratePolarization = .true.
            P%AccurateReionization = .false.
            P%AccurateBB = .false.

            P%DoLensing = .false.

            P%MassiveNuMethod = Nu_best
            P%OnlyTransfers = .false.

            P%DerivedParameters = .true.

        end subroutine CAMB_SetDefParams


         !Stop with error is not good
         function CAMB_ValidateParams(P) result(OK)
            type(CAMBparams), intent(in) :: P
            logical OK

             OK = .true.
             if (.not. P%WantTransfer .and. .not. P%WantCls) then
                OK = .false.
                write(*,*) 'There is nothing to do! Do transfer functions or Cls.'
             end if

             if (P%h0 < 20._dl.or.P%h0 > 100._dl) then
               OK = .false.
               write(*,*) '  Warning: H0 has units of km/s/Mpc. You have:', P%h0
            end if
             if (P%tcmb < 2.7d0.or.P%tcmb > 2.8d0) then
                write(*,*) '  Warning: Tcmb has units of K.  Your have:', P%tcmb
             end if

             if (P%yhe < 0.2d0.or.P%yhe > 0.8d0) then
                OK = .false.
                write(*,*) &
                     '  Warning: YHe is the Helium fraction of baryons.', &
                     '  Your have:', P%yhe
             end if
             if (P%Num_Nu_massive < 0.or.P%Num_Nu_massive > 3.1) then
                OK = .false.
                write(*,*) &
                     'Warning: Num_Nu_massive is strange:',P%Num_Nu_massive 
              end if
             if (P%Num_Nu_massless < 0.or.P%Num_Nu_massless > 3.1) then
                OK = .false.
                write(*,*) &
                     'Warning: Num_nu_massless is strange:', P%Num_Nu_massless
              end if
             if (P%Num_Nu_massive < 1 .and. P%omegan > 0.0) then
                OK = .false.
                write(*,*) &
                     'Warning: You have omega_neutrino > 0, but no massive species'
              end if


             if (P%omegab<0.001 .or. P%omegac<0 .or. P%omegab>1 .or. P%omegac>3) then
                OK = .false.
                write(*,*) 'Your matter densities are strange'
             end if

             if (P%WantScalars .and. P%Max_eta_k < P%Max_l .or.  &
                  P%WantTensors .and. P%Max_eta_k_tensor < P%Max_l_tensor) then
                OK = .false.
                write(*,*) 'You need Max_eta_k larger than Max_l to get good results'
             end if
             
             call Reionization_Validate(P%Reion, OK)
             call Recombination_Validate(P%Recomb, OK)

             if (P%WantTransfer) then
              if (P%transfer%num_redshifts > max_transfer_redshifts .or. P%transfer%num_redshifts<1) then
                OK = .false.
                write(*,*) 'Maximum ',  max_transfer_redshifts, &
                     'redshifts. You have: ', P%transfer%num_redshifts 
              end if
              if (P%transfer%kmax < 0.01 .or. P%transfer%kmax > 50000 .or. &
                     P%transfer%k_per_logint>0 .and.  P%transfer%k_per_logint <1) then
                 OK = .false.
                 write(*,*) 'Strange transfer function settings.'
              end if
              if (P%transfer%num_redshifts > max_transfer_redshifts .or. P%transfer%num_redshifts<1) then
                OK = .false.
                write(*,*) 'Maximum ',  max_transfer_redshifts, &
                     'redshifts. You have: ', P%transfer%num_redshifts 
              end if


             end if

         end function CAMB_ValidateParams

         subroutine CAMB_cleanup
          use ThermoData
          use SpherBessels
          use ModelData
          use Transfer

            !Free memory
           call ThermoData_Free
           call Bessels_Free
           call ModelData_Free  
           call Transfer_Free(MT)

         end subroutine CAMB_cleanup


  end module CAMB

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gvert(ve,angle,ipv,gp,ev,nvmax,nv,per,nve,nev,nev0,
     *  rp,cm,np,vcirc,tol,phi,iord,wk,iwk,ldegen)
      integer nvmax,ipv(nvmax),np,gp(np),ev(nvmax),nv,per,nve,nev,nev0,
     *  vcirc
      logical ldegen
      real*10 ve(3,nve,nvmax),angle(nvmax),rp(3,np),cm(np),tol
c        work arrays (could be automatic if compiler supports it)
      integer iord(2*np),iwk(nvmax,4)
      real*10 phi(2,np),wk(nvmax)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        externals
      integer gsegij,gzeroar
c        data variables
      real*10 big
c     real*10 dphmin
c        local (automatic) variables
      integer i,ii,ik,iseg,iv,ive,j,jm,jml,jmu,jp,jpl,jpu,km,kp,
     *  mve,ni,scmi
C     logical warn
      real*10 amve,cmi,dph,ikchk,ph,phm,php
      real*10 si,tolin,xi(3),xv,yi(3),yv,zv
c *
c * Vertices, plus points on edges, of the polygon defined by
c *    1 - r.rp(i) < cm(i)  (if cm(i).ge.0)
c *    1 - r.rp(i) > -cm(i)  (if cm(i).lt.0)
c * for i=1,np where rp(i) are unit directions.
c *
c * Since each pair of circles can intersect at at most 2 points,
c * an upper limit on the number of possible vertices is np*(np-1),
c * twice the number of distinct pairs of np objects.
c * I can find configurations which exhaust this bound for np <= 4.
c * For np >= 4, I can find configurations with 6*(np-2) vertices,
c * namely, form two triangles from the intersection of 3 caps
c * (producing 6 vertices),
c * then for each additional cap, inscribe it as an excluding cap
c * inside one of the triangles, so as to transform that one
c * triangle (with 3 vertices) into 3 triangles (with 9 vertices).
c *
c * gp(i) is the group of circles to which circle i belongs.
c * Two circles are friends, belonging to the same group,
c * if they intersect, and friends of friends are friends.
c * Theorem: A polygon is not simply-connected
c * if and only if its boundaries belong to distinct groups.
c * The group number is the smallest circle number of circles
c * within the group.
c *
c * Connected sequences of vertices are ordered by group,
c * with the lowest group numbers coming first, except that
c * intersecting boundaries come 1st, then non-intersecting boundaries.
c * Each connected sequence of vertices is ordered right-handedly
c * about the polygon, with the vertices belonging to the lowest
c * circle numbers coming first.
c * The array ev records the end index of each connected
c * sequences of vertices.
c * If the polygon is connected and simply-connected, the usual case,
c * then ev(1) = nv on output, and ev(i) = 0 for i >= 2.
c * If the polygon is not connected and simply-connected,
c * then the number of non-zero elements of ev will equal the
c * number of distinct connected boundaries of the polygon.
c *
c  Input: nvmax = guess at maximum nv;
c                 must be >= np;
c                 recommend:
c               = np        if 0 <= np <= 2
c               = np*(np-1) if 2 <= np <= 4
c               = 6*(np-2)  if np >= 4
c         rp(3,i),i=1,np
c         cm(i),i=1,np
c         np
c         per = controls meaning of nve
c             = 0 for nve points per edge
c             = 1 for nve points per 2 pi on each edge,
c                 rounded up, so there is at least 1 point per edge;
c                 excess points are set to zero.
c         nve = desired number of points per edge
c             = 1 for vertices only
c             = 2 for vertices + midpoints of edges
c             >= 2 for vertices + (nve-1) non-vertex points per edge.
c         vcirc = 1 to return vertices and edge points also for bounding
c                 circles which do not intersect any other circle;
c               = 0 otherwise.
c Output: ve(3,ive,iv),ive=1,nve,iv=1,nv are points uniformly spaced
c                   along the edges of the polygon,
c                   starting with vertices in ve(3,1,iv).
c         angle(iv),i=1,nv are azimuthal lengths of edges of polygon.
c         ipv(iv),iv=1,nv is the circle number of the iv'th edge,
c                  that is,points ve(*,ive,iv) lie on circle number ipv.
c         gp(i),i=1,np = which group circle i belongs to:
c                circle i and circle j are friends if they intersect,
c                and friends of friends are friends.
c         ev(i),i=1,nev = end index of each connected sequence of edges;
c                 the number of non-zero elements of ev is the number
c                 nev of connected boundaries of the polygon,
c                 and the last nev0 of these are non-intersecting.
c         nv = number of points;
c              if this exceeds nvmax, then you should call gvert again
c              with a larger nvmax.
c         nev = number of connected sequences of vertices,
c               including those in non-intersecting circles.
c         nev0 = number of non-intersecting boundary circles if vcirc=1;
c              = 0 if vcirc=0;
c                non-intersecting boundaries come last in ve,
c                and the last nev0 entries of ev(i) refer
c                to non-intersecting boundaries.
c         ldegen = .true. means there's a problem with multiply
c                  intersecting boundary.
c Input/Output: tol
c Work arrays: phi and iord should be dimensioned at least 2*np.
c              iwk should be dimensioned at least 4*nvmax.
c              wk should be dimensioned at least nvmax.
c
c     data dphmin /1.e-8_10/
      data big /1.e6_10/
c
c        input tolerance to multiple intersections
      tolin=tol
C     print *,'--------------------'
c        come here with modified tolerance
  100 continue
c        initialise error flag to no error
      ldegen=.false.
C     warn=.false.
c        zero number of vertices
      nv=0
      nev=0
      nev0=0
c        initialise ev to zero
      do iv=1,nvmax
        ev(iv)=0
      enddo
c        initially each circle is its own group
      do i=1,np
        gp(i)=i
      enddo
c        check for zero area because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        error check on evaluation of vertex terms
      ikchk=0._10
c        initialise iwk to inadmissible values
      do iv=1,nvmax
        iwk(iv,2)=-1
      enddo
      do iv=1,nvmax
        iwk(iv,3)=-1
      enddo
c--------identify boundary segments around each circle i in turn
      do 280 i=1,np
c        cm(i).ge.2 means include whole sphere, which is no constraint
        if (cm(i).ge.2._10) goto 280
c        scmi * cmi = 1-cos th(i)
        if (cm(i).ge.0._10) then
          scmi=1
        else
          scmi=-1
        endif
        cmi=abs(cm(i))
c        si = sin th(i)
        si=sqrt(cmi*(2._10-cmi))
c........construct cartesian axes with z-axis along rp(i)
        call gaxisi(rp(1,i),xi,yi)
c........angles phi about z-axis rp(i) of intersection of i & j circles
        call gphij(rp,cm,np,i,rp(1,i),scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside polygon
        if (ni.eq.-1) goto 280
c        area of polygon is zero
        if (ni.eq.-2) then
          nv=0
          nev=0
          nev0=0
          goto 410
        endif
c........i circle has no intersections
        if (ni.eq.0) then
c        want vertices and midpoints for circles without intersections
          if (vcirc.eq.1) then
c        introduce pretend circle 0
            do j=1,2
              if (j.eq.1) then
                ii=0
                km=i
                kp=i
                phm=0._10
                php=PI
              elseif (j.eq.2) then
                ii=i
                km=0
                kp=0
                phm=PI
                php=TWOPI
              endif
              dph=php-phm
              nv=nv+1
              if (nv.le.nvmax) then
c        edge index of this vertex
                ipv(nv)=i
c        azimuthal length of edge
                angle(nv)=dph
c        edge points
                zv=1._10-cmi
                if (per.eq.0) then
                  mve=nve
                else
                  amve=nve*(dph/TWOPI)
                  mve=amve
                  if (dble(mve).lt.amve) mve=mve+1
                endif
                do ive=1,mve
                  if (cm(i).ge.0._10) then
                    ph=(phm*(mve-ive+1)+php*(ive-1))/dble(mve)
                  else
                    ph=(php*(mve-ive+1)+phm*(ive-1))/dble(mve)
                  endif
                  xv=si*cos(ph)
                  yv=si*sin(ph)
                  ve(1,ive,nv)=zv*rp(1,i)+xv*xi(1)+yv*yi(1)
                  ve(2,ive,nv)=zv*rp(2,i)+xv*xi(2)+yv*yi(2)
                  ve(3,ive,nv)=zv*rp(3,i)+xv*xi(3)+yv*yi(3)
                enddo
                do ive=mve+1,nve
                  ve(1,ive,nv)=0._10
                  ve(2,ive,nv)=0._10
                  ve(3,ive,nv)=0._10
                enddo
              endif
c        record endpoints of edge
              call gvtrail(scmi,np,ii,km,kp,iwk,iwk(1,2),nvmax,nv,
     *          ik,ikchk)
            enddo
            nev0=nev0+1
          endif
C         print *,'at',i,': full circle'
c........i circle has intersections
        elseif (ni.gt.0) then
c........friends of i circle
          call ggpij(np,gp,i,big,phi)
c........find ordering of intersection angles around i circle
          call findbot(phi,2*np,iord,ni)
c........vertices around i circle
          jpl=0
c        come here to do another segment
  220     continue
c........is segment edge of polygon?
            iseg=gsegij(rp,cm,np,0,0,i,rp(1,i),scmi,cmi,tol,ni,
     *        phi,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
c        error
            if (iseg.eq.-1) goto 420
c        not an edge
            if (iseg.eq.0) goto 220
c        gone full circle
            if (iseg.eq.2) goto 280
c........segment is edge
c        warn about near multiple intersection
c           if (dph.lt.dphmin) then
c             print *,'*** warning from gvert: near multiple intersectio
c    *n at',i,': edge',km,kp,' dph=',real(dph)
c             warn=.true.
c           endif
C           print *,'at',i,': edge',km,kp,
C    *        ' (',jm,' in',jml,jmu,',',jp,' in',jpl,jpu,' of',ni,')',
C    *        ' ph=',real(ph),' dph=',real(dph)
            nv=nv+1
            if (nv.le.nvmax) then
c        edge index of this vertex
              ipv(nv)=i
c        azimuthal length of edge
              angle(nv)=dph
c        edge points
              zv=1._10-cmi
              if (per.eq.0) then
                mve=nve
              else
                amve=nve*(dph/TWOPI)
                mve=amve
                if (dble(mve).lt.amve) mve=mve+1
              endif
              do ive=1,mve
                if (cm(i).ge.0._10) then
                  ph=(phm*(mve-ive+1)+php*(ive-1))/dble(mve)
                else
                  ph=(php*(mve-ive+1)+phm*(ive-1))/dble(mve)
                endif
                xv=si*cos(ph)
                yv=si*sin(ph)
                ve(1,ive,nv)=zv*rp(1,i)+xv*xi(1)+yv*yi(1)
                ve(2,ive,nv)=zv*rp(2,i)+xv*xi(2)+yv*yi(2)
                ve(3,ive,nv)=zv*rp(3,i)+xv*xi(3)+yv*yi(3)
              enddo
              do ive=mve+1,nve
                ve(1,ive,nv)=0._10
                ve(2,ive,nv)=0._10
                ve(3,ive,nv)=0._10
              enddo
            endif
c        record endpoints of edge
            call gvtrail(scmi,np,i,km,kp,iwk,iwk(1,2),nvmax,nv,ik,ikchk)
c        do another segment
          goto 220
        endif
  280 continue
c--------check on whether ik endpoints matched ki endpoints
      if (ikchk.ne.0._10) then
C       warn=.true.
C       print *,'*** from gvert: at tol =',tol,
C    *    ', ikchk=',ikchk,' should be 0'
c        retry with modified tolerance
        call gtol(tol,tolin)
        goto 100
      elseif (tol.gt.0._10) then
C       print *,'... from gvert: success at tol =',tol
      endif
c--------order vertices right-handedly about polygon
      if (nv.gt.0.and.nv.le.nvmax) then
c........which group of friends each circle belongs to
        call ggp(np,gp)
c........find order of vertices around polygon
        call gvord(np,nv,ipv,gp,ev,nev,iwk,iwk(1,2),iwk(1,3),iwk(1,4))
c........reorder vertices
        call vpermi(ipv,nv,iwk(1,2),iwk(1,3))
        call vpermdd(ve,3*nve,nv,iwk(1,2),wk)
        call vpermd(angle,nv,iwk(1,2),wk)
      endif
c--------done
  410 continue
C     if (warn) then
C       write (*,'(a3,a20,4a24)')
C    *    ' ','x','y','z','r','1-c'
C       write (*,'(i3,5g24.16)')
C    *    (j,(rp(i,j),i=1,3),sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
C    *    cm(j),j=1,np)
C     endif
c     if (nv.gt.nvmax) then
c       print *,'*** from gvert: number of vertices =',nv,
c    *    ' exceeds maximum',nvmax
c     endif
      return
c
  420 print *,'*** from gvert: total failure at tol = ',tol
      write (*,'(a3,a20,4a24)')
     *  ' ','x','y','z',
c    *  'r',
     *  '1-c'
      do j=1,np
        write (*,'(i3,5g24.16)')
     *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *    cm(j)
      enddo
      ldegen=.true.
      return
c
      end
c

program main

!*****************************************************************************80
!
!! MAIN is the main program for SPLINE_PRB.
!
!  Discussion:
!
!    SPLINE_PRB calls the SPLINE tests.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  call timestamp ( )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'SPLINE_PRB'
  write ( *, '(a)' ) '  FORTRAN90 version:'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Test the routines in the SPLINE library.'
 
  call test001
  call test002
  call test003
  call test004
  call test005
  call test006

  call test01
  call test02
  call test03
  call test04
  call test05
  call test06
  call test07
  call test08
  call test09
  call test10

  call test11
  call test115
  call test116
  call test12
  call test125
  call test126
  call test127
  call test13
  call test14
  call test143
  call test144
  call test145
  call test15
  call test16
  call test17
  call test18
  call test19
  call test20
  call test205

  call test21
  call test215
  call test22
  call test225
  call test23
  call test235
  call test24

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'SPLINE_PRB'
  write ( *, '(a)' ) '  Normal end of execution.'

  write ( *, '(a)' ) ' '
  call timestamp ( )

  stop
end
subroutine test001

!***********************************************************************
!
!! TEST001 tests PARABOLA_VAL2.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: dim_num = 1
  integer ( kind = 4 ), parameter :: ndata = 5

  integer ( kind = 4 ) i
  integer ( kind = 4 ) left
  real    ( kind = 8 ) xdata(ndata)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) ydata(dim_num,ndata)
  real    ( kind = 8 ) yval(dim_num)
  real    ( kind = 8 ) zdata(ndata)
  real    ( kind = 8 ) zval(dim_num)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST001'
  write ( *, '(a)' ) '  PARABOLA_VAL2 evaluates parabolas through'
  write ( *, '(a)' ) '    3 points in a table'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Our data tables will actually be parabolas:'
  write ( *, '(a)' ) '    Y: 2*x**2 + 3 * x + 1.'
  write ( *, '(a)' ) '    Z: 4*x**2 - 2 * x + 5.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '         I        X         Y           Z'
  write ( *, '(a)' ) ' '

  do i = 1, ndata

    xval = 2.0D+00 * real ( i, kind = 8 )
    xdata(i) = xval
    ydata(1,i) = 2.0D+00 * xval * xval + 3.0 * xval + 1.0D+00
    zdata(i) = 4.0D+00 * xval * xval - 2.0D+00 * xval + 5.0D+00
    write ( *, '(2x,i8,2x,f10.4,2x,f10.4,2x,f10.4)' ) &
      i, xdata(i), ydata(1,i), zdata(i)

  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Interpolated data:'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '      LEFT        X         Y           Z'
  write ( *, '(a)' ) ' '

  do i = 1, 5

    xval = real ( 2 * i - 1, kind = 8 )
    left = i

    if ( ndata - 2 < left ) then
      left = ndata - 2
    end if

    if ( left < 1 ) then
      left = 1
    end if

    call parabola_val2 ( dim_num, ndata, xdata, ydata, left, xval, yval )

    call parabola_val2 ( dim_num, ndata, xdata, zdata, left, xval, zval )

    write ( *, '(2x,i8,2x,f10.4,2x,f10.4,2x,f10.4)' ) &
      left, xval, yval(1), zval(1)

  end do

  return
end
subroutine test002

!*****************************************************************************80
!
!! TEST002 tests R8VEC_BRACKET.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 10
  integer ( kind = 4 ), parameter :: test_num = 6

  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  integer ( kind = 4 ) test
  real    ( kind = 8 ) x(n)
  real    (  kind = 8 ), dimension ( test_num ) :: xtest = (/ &
   -10.0D+00, 1.0D+00, 4.5D+00, 5.0D+00, 10.0D+00, 12.0D+00 /)
  real    ( kind = 8 ) xval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST002'
  write ( *, '(a)' ) '  R8VEC_BRACKET finds a pair of entries in a'
  write ( *, '(a)' ) '    sorted real array which bracket a value.'

  call r8vec_indicator ( n, x )
  x(6) = x(5)

  call r8vec_print ( n, x, '  Sorted array:' )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    LEFT             RIGHT'
  write ( *, '(a)' ) '  X(LEFT)   XVAL   X(RIGHT)'
  write ( *, '(a)' ) ' '

  do test = 1, test_num

    xval = xtest(test)

    call r8vec_bracket ( n, x, xval, left, right )

    write ( *, '(2x,i14,14x,i14)' ) left, right

    if ( 1 <= left .and. 1 <= right ) then
      write ( *, '(2x,3g14.6)' ) x(left), xval, x(right)
    else if ( left < 1 .and. 1 <= right ) then
      write ( *, '(2x,14x,2g14.6)' )          xval, x(right)
    else if ( 1 <= left .and. right < 1 ) then
      write ( *, '(2x,2g14.6)' ) x(left), xval
    else if ( left < 1 .and. right < 1 ) then
      write ( *, '(2x,14x,g14.6)' )          xval
    end if

  end do

  return
end
subroutine test003

!*****************************************************************************80
!
!! TEST003 tests R8VEC_BRACKET3.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 10
  integer ( kind = 4 ), parameter :: test_num = 6

  integer ( kind = 4 ) left
  integer ( kind = 4 ) test
  real    ( kind = 8 ) x(n)
  real    (  kind = 8 ), dimension ( test_num ) :: xtest = (/ &
    -10.0D+00, 1.0D+00, 4.5D+00, 5.0D+00, 10.0D+00, 12.0D+00 /)
  real    ( kind = 8 ) xval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST003'
  write ( *, '(a)' ) '  R8VEC_BRACKET3 finds a pair of entries in a'
  write ( *, '(a)' ) '    sorted real array which bracket a value.'

  call r8vec_indicator ( n, x )
  x(6) = x(5)

  call r8vec_print ( n, x, '  Sorted array:' )

  left = ( n + 1 ) / 2

  do test = 1, test_num

    xval = xtest(test)

    write ( *, '(a)' ) ' '
    write ( *, '(a,g14.6)' ) '  Search for XVAL = ', xval

    write ( *, '(a,i8)' ) '  Starting guess for interval is = ', left

    call r8vec_bracket3 ( n, x, xval, left )

    write ( *, '(a)' ) '  Nearest interval:'
    write ( *, '(2x,a,i8,a,g14.6)' ) '    X[', left,' ]= ', x(left)
    write ( *, '(2x,a,i8,a,g14.6)' ) '    X[', left+1, ' ]= ', x(left+1)

  end do

  return
end
subroutine test004

!*****************************************************************************80
!
!! TEST004 tests R8VEC_ORDER_TYPE.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: test_num = 6

  integer ( kind = 4 ) j
  integer ( kind = 4 ) order
  integer ( kind = 4 ) test
  real    ( kind = 8 ), dimension(n,test_num) :: x

  x(1,1) = 1.0D+00
  x(2,1) = 3.0D+00
  x(3,1) = 2.0D+00
  x(4,1) = 4.0D+00

  x(1,2) = 2.0D+00
  x(2,2) = 2.0D+00
  x(3,2) = 2.0D+00
  x(4,2) = 2.0D+00

  x(1,3) = 1.0D+00
  x(2,3) = 2.0D+00
  x(3,3) = 2.0D+00
  x(4,3) = 4.0D+00

  x(1,4) = 1.0D+00
  x(2,4) = 2.0D+00
  x(3,4) = 3.0D+00
  x(4,4) = 4.0D+00

  x(1,5) = 4.0D+00
  x(2,5) = 4.0D+00
  x(3,5) = 3.0D+00
  x(4,5) = 1.0D+00

  x(1,6) = 9.0D+00
  x(2,6) = 7.0D+00
  x(3,6) = 3.0D+00
  x(4,6) = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST004'
  write ( *, '(a)' ) '  R8VEC_ORDER_TYPE classifies a real vector as'
  write ( *, '(a)' ) '  -1: no order'
  write ( *, '(a)' ) '   0: all equal;'
  write ( *, '(a)' ) '   1: ascending;'
  write ( *, '(a)' ) '   2: strictly ascending;'
  write ( *, '(a)' ) '   3: descending;'
  write ( *, '(a)' ) '   4: strictly descending.'
  write ( *, '(a)' ) ' '

  do test = 1, test_num

    call r8vec_order_type ( n, x(1,test), order )

    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  The following vector has order type ', order
    write ( *, '(a)' ) ' '
    do j = 1, n
      write ( *, '(2x,i8,g14.6)' ) j, x(j,test)
    end do

  end do

  return
end
subroutine test005

!*****************************************************************************80
!
!! TEST005 tests R83_NP_FS.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 10

  real    ( kind = 8 ) a(3,n)
  real    ( kind = 8 ) b(n)
  integer ( kind = 4 ) :: seed = 123456789
  real    ( kind = 8 ) x(n)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST005'
  write ( *, '(a)' ) '  R83_NP_FS factors and solves a tridiagonal'
  write ( *, '(a)' ) '    linear system.'
  write ( *, '(a)' ) ' '
  write ( *, '(a,i8)' ) '  Matrix order N = ', n
!
!  Set the matrix elements.
!
  call r83_uniform ( n, seed, a )
!
!  Set the desired solution.
!
  call r8vec_indicator ( n, x )
!
!  Compute b = A * x.
!
  call r83_mxv ( n, a, x, b )
!
!  Wipe out the solution.
!
  x(1:n) = 0.0D+00
!
!  Solve the system.
!
  call r83_np_fs ( n, a, b, x )

  call r8vec_print ( n, x, '  Solution:' )

  return
end
subroutine test006

!*****************************************************************************80
!
!! TEST006 tests DATA_TO_DIF and DIF_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: maxtab = 8

  real    ( kind = 8 ) diftab(maxtab)
  real    ( kind = 8 ) err
  real    ( kind = 8 ) exact
  integer ( kind = 4 ) j
  integer ( kind = 4 ) ntab
  real    ( kind = 8 ) xtab(maxtab)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) ytab(maxtab)
  real    ( kind = 8 ) yval

  xval = 2.5D+00
  exact = exp ( xval )
 
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST006'
  write ( *, '(a,i8)' ) '  Approximate Y = EXP(X) using orders 1 to ', maxtab
  write ( *, '(a,g14.6)' ) '  Evaluate at X = ', xval
  write ( *, '(a,g14.6)' ) '  where EXP(X)=   ', exact

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    Order  Approximate Y     Error'
  write ( *, '(a)' ) ' '
 
  do ntab = 1, maxtab
 
    do j = 1, ntab
      xtab(j) = real ( j - 1, kind = 8 )
      ytab(j) = exp ( xtab(j) )
    end do
 
    call data_to_dif ( ntab, xtab, ytab, diftab )

    call dif_val ( ntab, xtab, diftab, xval, yval )
 
    err = yval - exact
    write ( *, ' ( 2x, i8, 2g14.6 )' ) ntab, yval, err
 
  end do
 
  return
end
subroutine test01

!*****************************************************************************80
!
!! TEST01 tests BASIS_FUNCTION_B_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 5

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), dimension ( ndata ) :: tdata = (/ &
    0.0D+00, 1.0D+00, 4.0D+00, 6.0D+00, 10.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST01'
  write ( *, '(a)' ) '  BASIS_FUNCTION_B_VAL evaluates the '
  write ( *, '(a)' ) '    B spline basis function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T            B(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_function_b_val ( tdata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test02

!*****************************************************************************80
!
!! TEST02 tests BASIS_FUNCTION_BETA_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 5

  real    ( kind = 8 ) beta1
  real    ( kind = 8 ) beta2
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), dimension ( ndata ) :: tdata = (/ &
    0.0D+00, 1.0D+00, 4.0D+00, 6.0D+00, 10.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST02'
  write ( *, '(a)' ) '  BASIS_FUNCTION_BETA_VAL evaluates the '
  write ( *, '(a)' ) '    Beta spline basis function.'

  beta1 = 1.0D+00
  beta2 = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       T            B(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_function_beta_val ( beta1, beta2, tdata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  beta1 = 1.0D+00
  beta2 = 100.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       T            B(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_function_beta_val ( beta1, beta2, tdata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  beta1 = 100.0D+00
  beta2 = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       T            B(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_function_beta_val ( beta1, beta2, tdata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test03

!*****************************************************************************80
!
!! TEST03 tests BASIS_MATRIX_B_UNI and BASIS_MATRIX_TMP.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), dimension (ndata) ::  tdata = (/ &
    -1.0D+00, 0.0D+00, 1.0D+00, 2.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    (  kind = 8 ), dimension (ndata) ::  ydata = (/ &
    4.0D+00, 7.0D+00, 12.0D+00, 19.0D+00 /)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST03'
  write ( *, '(a)' ) '  BASIS_MATRIX_B_UNI sets up the basis matrix'
  write ( *, '(a)' ) '    for the uniform B spline.'

  call basis_matrix_b_uni ( mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       TDATA         YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '        T            Spline(T)'
  write ( *, '(a)' ) ' '

  left = 2

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test04

!*****************************************************************************80
!
!! TEST04 tests BASIS_MATRIX_BETA_UNI and BASIS_MATRIX_TMP.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  real    ( kind = 8 ) beta1
  real    ( kind = 8 ) beta2
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    ( kind = 8 ), dimension ( ndata ) :: tdata = (/ &
    -1.0D+00, 0.0D+00, 1.0D+00, 2.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ), dimension ( ndata ) :: ydata = (/ &
    4.0D+00, 7.0D+00, 12.0D+00, 19.0D+00 /)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST04'
  write ( *, '(a)' ) '  BASIS_MATRIX_BETA_UNI sets up the basis matrix'
  write ( *, '(a)' ) '    for the uniform beta spline.'
!
!  First test
!
  beta1 = 1.0D+00
  beta2 = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2

  call basis_matrix_beta_uni ( beta1, beta2, mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    TDATA, YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do
!
!  Second test
!
  beta1 = 1.0D+00
  beta2 = 100.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2

  call basis_matrix_beta_uni ( beta1, beta2, mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    TDATA, YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do
!
!  Third test
!
  beta1 = 100.0D+00
  beta2 = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2

  call basis_matrix_beta_uni ( beta1, beta2, mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     TDATA        YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '        T           Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8  ) * thi ) &
             / real ( nsample,     kind = 8  )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test05

!*****************************************************************************80
!
!! TEST05 tests BASIS_MATRIX_BEZIER and BASIS_MATRIX_TMP.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    ( kind = 8 ), dimension ( ndata ) :: tdata = (/ &
    0.0D+00, 0.0D+00, 1.0D+00, 1.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ), dimension ( ndata ) :: ydata = (/ &
    7.0D+00,  8.3333333D+00,   10.0D+00, 12.0D+00 /)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST05'
  write ( *, '(a)' ) '  BASIS_MATRIX_BEZIER sets up the basis'
  write ( *, '(a)' ) '    matrix for the uniform Bezier spline.'

  call basis_matrix_bezier ( mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       TDATA          YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '        T            Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test06

!*****************************************************************************80
!
!! TEST06 tests BASIS_MATRIX_HERMITE and BASIS_MATRIX_TMP.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    ( kind = 8 ), dimension ( ndata ) :: tdata = (/ &
    0.0D+00, 0.0D+00, 1.0D+00, 1.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ), dimension ( ndata ) :: ydata = (/ &
    7.0D+00, 12.0D+00, 4.0D+00, 6.0D+00 /)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST06'
  write ( *, '(a)' ) '  BASIS_MATRIX_HERMITE sets up the basis matrix'
  write ( *, '(a)' ) '    for the Hermite spline.'

  call basis_matrix_hermite ( mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       TDATA        YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '        T           Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test07

!*****************************************************************************80
!
!! TEST07 tests BASIS_MATRIX_OVERHAUSER_UNI and BASIS_MATRIX_TMP.
!
!  Discussion:
!
!   YDATA(1:NDATA) = ( TDATA(1:NDATA) + 2 )**2 + 3
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    ( kind = 8 ), dimension ( ndata ) :: tdata = (/ &
    -1.0D+00, 0.0D+00, 1.0D+00, 2.0D+00 /)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ), dimension ( ndata ) :: ydata = (/ &
    4.0D+00, 7.0D+00, 12.0D+00, 19.0D+00 /)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST07'
  write ( *, '(a)' ) '  BASIS_MATRIX_OVERHAUSER_UNI sets up the basis'
  write ( *, '(a)' ) '    matrix for the uniform Overhauser spline.'

  call basis_matrix_overhauser_uni ( mbasis )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       TDATA         YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '        T            Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test08

!*****************************************************************************80
!
!! TEST08 tests BASIS_MATRIX_OVERHAUSER_NONUNI and BASIS_MATRIX_TMP.
!
!  Discussion:
!
!    YDATA(1:NDATA) = ( TDATA(1:NDATA) - 2 )**2 + 3
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  real    ( kind = 8 ) alpha
  real    ( kind = 8 ) beta
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    ( kind = 8 ), dimension ( ndata ) :: tdata
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    (  kind = 8 ), dimension ( ndata ) :: ydata
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST08'
  write ( *, '(a)' ) '  BASIS_MATRIX_OVERHAUSER_NONUNI sets up the'
  write ( *, '(a)' ) '    basis matrix for the nonuniform Overhauser'
  write ( *, '(a)' ) '    spline.'

  tdata = (/ 0.0D+00, 1.0D+00, 2.0D+00, 3.0D+00 /)

  alpha = ( tdata(3) - tdata(2) ) / ( tdata(3) - tdata(1) )
  beta = ( tdata(3) - tdata(2) ) / ( tdata(4) - tdata(2) )

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  ALPHA = ', alpha
  write ( *, '(a,g14.6)' ) '  BETA = ', beta

  call basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

  do i = 1, ndata
    ydata(i) = ( tdata(i) - 2.0D+00 )**2 + 3.0D+00
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       TDATA         YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       T           Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  tdata(1:4) = (/ 0.0D+00, 1.0D+00, 2.0D+00, 5.0D+00 /)

  alpha = ( tdata(3) - tdata(2) ) / ( tdata(3) - tdata(1) )
  beta = ( tdata(3) - tdata(2) ) / ( tdata(4) - tdata(2) )

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  ALPHA = ', alpha
  write ( *, '(a,g14.6)' ) '  BETA = ', beta

  call basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

  do i = 1, ndata
    ydata(i) = ( tdata(i) - 2.0D+00 )**2 + 3.0D+00
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    TDATA, YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  tdata(1:4) = (/ 0.0D+00, 3.0D+00, 4.0D+00, 5.0D+00 /)

  alpha = ( tdata(3) - tdata(2) ) / ( tdata(3) - tdata(1) )
  beta = ( tdata(3) - tdata(2) ) / ( tdata(4) - tdata(2) )

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  ALPHA = ', alpha
  write ( *, '(a,g14.6)' ) '  BETA = ', beta

  call basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

  do i = 1, ndata
    ydata(i) = ( tdata(i) - 2.0D+00 )**2 + 3.0D+00
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    TDATA, YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test09

!*****************************************************************************80
!
!! TEST09 tests BASIS_MATRIX_OVERHAUSER_NONUNI and BASIS_MATRIX_TMP.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4
  integer ( kind = 4 ), parameter :: ndata = 4

  real    ( kind = 8 ) alpha
  real    ( kind = 8 ) beta
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) left
  character mark
  real    ( kind = 8 ) mbasis(n,n)
  integer ( kind = 4 ), parameter :: nsample = 4
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST09'
  write ( *, '(a)' ) '  BASIS_MATRIX_OVERHAUSER_NONUNI sets up the'
  write ( *, '(a)' ) '    basis matrix for the nonuniform Overhauser '
  write ( *, '(a)' ) '    spline.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  First test that the nonuniform code can match'
  write ( *, '(a)' ) '  the uniform code.  Compare these results with'
  write ( *, '(a)' ) '  the uniform output.'
  write ( *, '(a)' ) ' '

  tdata(1:4) = (/ -1.0D+00, 0.0D+00, 1.0D+00, 2.0D+00 /)

  alpha = ( tdata(3) - tdata(2) ) / ( tdata(3) - tdata(1) )
  beta =  ( tdata(3) - tdata(2) ) / ( tdata(4) - tdata(2) )

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  ALPHA = ', alpha
  write ( *, '(a,g14.6)' ) '  BETA = ', beta

  call basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

  do i = 1, ndata
    ydata(i) = ( tdata(i) + 2.0D+00 )**2 + 3.0D+00
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    TDATA, YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Now test that the nonuniform code on a'
  write ( *, '(a)' ) '  nonuniform grid.'
  write ( *, '(a)' ) ' '

  tdata(1:4) = (/ -4.0D+00, -3.0D+00, -1.0D+00, 2.0D+00 /)

  alpha = ( tdata(3) - tdata(2) ) / ( tdata(3) - tdata(1) )
  beta =  ( tdata(3) - tdata(2) ) / ( tdata(4) - tdata(2) )

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  ALPHA = ', alpha
  write ( *, '(a,g14.6)' ) '  BETA =  ', beta

  call basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

  ydata(1:ndata) = ( tdata(1:ndata) + 2.0D+00 )**2 + 3.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       TDATA         YDATA'
  write ( *, '(a)' ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  left = 2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '        T            Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test10

!*****************************************************************************80
!
!! TEST10 tests BC_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 2

  integer ( kind = 4 ) i
  integer ( kind = 4 ), parameter :: nsample = 101
  real    ( kind = 8 ) t
  real    (  kind = 8 ), dimension (0:n) :: xcon = (/ 0.0D+00, 0.75D+00, 1.0D+00 /)
  real    ( kind = 8 ) xval
  real    (  kind = 8 ), dimension (0:n) :: ycon = (/ 1.0D+00, 0.0D+00,  1.0D+00 /)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST10'
  write ( *, '(a)' ) '  BC_VAL evaluates a general Bezier function.'
!
!  One point on the curve should be about (0.75, 0.536).
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       T            X(T)          Y(T)'
  write ( *, '(a)' ) ' '

  do i = 1, nsample
    t = real (       i - 1, kind = 8 ) &
      / real ( nsample - 1, kind = 8 )
    call bc_val ( n, t, xcon, ycon, xval, yval )
    write ( *, '(2x,3g14.6)' ) t, xval, yval
  end do
 
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  The point ( 0.75, 0.536 ) should be on the curve.'
 
  return
end
subroutine test11

!*****************************************************************************80
!
!! TEST11 tests BEZ_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 2

  real    ( kind = 8 ) :: a = 0.0D+00
  real    ( kind = 8 ) :: b = 1.0D+00
  real    ( kind = 8 ) bez_val
  integer ( kind = 4 ) i
  integer ( kind = 4 ) :: nsample = 21
  real    ( kind = 8 ) x
  real    (  kind = 8 ), dimension ( 0 : n ) :: y = (/ 1.0D+00, 0.0D+00, 1.0D+00 /)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST11'
  write ( *, '(a)' ) '  BEZ_VAL evaluates a Bezier function.'
!
!  One point on the curve should be (0.75, 20/32).
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '         T    X(T)          Y(T)'
  write ( *, '(a)' ) ' '

  do i = 1, nsample

    x = ( real ( nsample - i,     kind = 8 ) * a   &
        + real (           i - 1, kind = 8 ) * b ) &
        / real ( nsample     - 1, kind = 8 )

    write ( *, '(2x,i8,2g14.6)' ) i, x, bez_val ( n, x, a, b, y )

  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  When X = ', 0.75D+00
  write ( *, '(a,g14.6)' ) '  BEZ_VAL(X) should be ', 0.625D+00
 
  return
end
subroutine test115

!*****************************************************************************80
!
!! TEST115 tests BP01.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n_max = 3

  real    ( kind = 8 ) :: a = 0.0D+00
  real    ( kind = 8 ) :: b = 1.0D+00
  real    ( kind = 8 ) bern(0:n_max)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) n
  integer ( kind = 4 ) :: nsample = 11
  real    ( kind = 8 ) x

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST115'
  write ( *, '(a)' ) '  BP01 evaluates the Bernstein basis polynomials'
  write ( *, '(a)' ) '  for the interval [0,1].'

  do n = 0, n_max

    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  Degree N = ', n
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) &
      '   X         BERN(N,0,X)  BERN(N,1,X)  BERN(N,2,X)  BERN(N,3,X)'
    write ( *, '(a)' ) ' ' 

    do i = 1, nsample

      x = ( real ( nsample - i,     kind = 8 ) * a   &
          + real (           i - 1, kind = 8 ) * b ) &
          / real ( nsample     - 1, kind = 8 )

      call bp01 ( n, x, bern )

      write ( *, '(2x,f8.4,4x,5g14.6)' ) x, bern(0:n)

    end do

  end do

  return
end
subroutine test116

!*****************************************************************************80
!
!! TEST116 tests BPAB.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n_max = 3

  real    (  kind = 8 ), parameter :: a = 1.0D+00
  real    (  kind = 8 ), parameter :: b = 3.0D+00
  real    ( kind = 8 ) bern(0:n_max)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) n
  real    ( kind = 8 ) x
  integer ( kind = 4 ), parameter :: nsample = 11

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST116'
  write ( *, '(a)' ) '  BPAB evaluates the Bernstein basis polynomials'
  write ( *, '(a)' ) '  for the interval [A,B].'
  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  A = ', a
  write ( *, '(a,g14.6)' ) '  B = ', b

  do n = 0, n_max

    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  Degree N = ', n
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) &
      '   X         BERN(N,0,X)  BERN(N,1,X)  BERN(N,2,X)  BERN(N,3,X)'
    write ( *, '(a)' ) ' ' 

    do i = 1, nsample

      x = ( real ( nsample - i,     kind = 8 ) * a   &
          + real (           i - 1, kind = 8 ) * b ) &
          / real ( nsample     - 1, kind = 8 )

      call bpab ( n, a, b, x, bern )

      write ( *, '(2x,f8.4,4x,5g14.6)' ) x, bern(0:n)

    end do

  end do

  return
end
subroutine test12

!*****************************************************************************80
!
!! TEST12 tests BP_APPROX.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: maxdata = 10

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ndata
  integer ( kind = 4 ) nsample
  real    ( kind = 8 ) xdata(0:maxdata)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) ydata(0:maxdata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST12'
  write ( *, '(a)' ) '  BP_APPROX evaluates the Bernstein polynomial'
  write ( *, '(a)' ) '    approximant to a function F(X).'

  a = 1.0D+00
  b = 3.0D+00

  do ndata = 0, 9, 3

    do i = 0, ndata

      if ( ndata == 0 ) then
        xdata(i) = 0.5D+00 * ( a + b )
      else
        xdata(i) = ( real ( ndata - i, kind = 8 ) * a   &
                   + real (         i, kind = 8 ) * b ) &
                   / real ( ndata,     kind = 8 )
      end if

      ydata(i) = sin ( xdata(i) )

    end do

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '       XDATA        YDATA'
    write ( *, '(a)' ) ' '
    do i = 0, ndata
      write ( *, '(2x,2g14.6)' ) xdata(i), ydata(i)
    end do

    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  Bernstein approximant of degree N = ', ndata
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '       X            F(X)          BERN(X)        ERROR'
    write ( *, '(a)' ) ' '

    nsample = 2 * ndata + 1

    do i = 1, nsample

      if ( nsample == 1 ) then
        xval = 0.5D+00 * ( a + b )
      else
        xval = ( real ( nsample - i,     kind = 8 ) * a   &
               + real (           i - 1, kind = 8 ) * b ) &
               / real ( nsample     - 1, kind = 8 )
      end if

      call bp_approx ( ndata, a, b, ydata, xval, yval )

      write ( *, '(2x,4g14.6)' ) xval, sin(xval), yval, yval - sin(xval)

    end do

  end do

  return
end
subroutine test125

!*****************************************************************************80
!
!! TEST125 tests LEAST_SET_OLD and LEAST_VAL_OLD.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: maxdeg = 6
  integer ( kind = 4 ), parameter :: ntab = 21

  real    ( kind = 8 ) b(1:maxdeg)
  real    ( kind = 8 ) c(0:maxdeg)
  real    ( kind = 8 ) d(2:maxdeg)
  real    ( kind = 8 ) eps
  real    ( kind = 8 ) error
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ierror
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) ndeg
  real    ( kind = 8 ) ptab(ntab)
  real    ( kind = 8 ) xtab(ntab)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) ytab(ntab)
  real    ( kind = 8 ) ytrue
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST125'
  write ( *, '(a)' ) '  LEAST_SET_OLD sets a least squares polynomial,'
  write ( *, '(a)' ) '  LEAST_VAL_OLD evaluates it.'

  do i = 1, ntab
    xtab(i) = ( real ( ntab - i,     kind = 8 ) * ( -1.0D+00 )   &
              + real (        i - 1, kind = 8 ) * ( +1.0D+00 ) ) &
              / real ( ntab     - 1, kind = 8 )
    ytab(i) = real ( int ( exp ( xtab(i) ) * 100.0D+00 + 0.5D+00 ) ) / 100.0D+00
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ntab
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       X             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, ntab
    write ( *, '(2x,2g14.6)' ) xtab(i), ytab(i)
  end do

  do ndeg = 1, maxdeg

    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  Using a polynomial of degree: ', ndeg
    write ( *, '(a)' ) ' '

    call least_set_old ( ntab, xtab, ytab, ndeg, ptab, b, c, d, eps, ierror )

    write ( *, '(a)' ) ' '
    write ( *, '(a,g14.6)' ) '  Total approximation error = ', eps
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '      X            F(X)          P(X)         Error'
    write ( *, '(a)' ) ' '

    do i = 1, ntab

      if ( i < ntab ) then
        jhi = 2
      else
        jhi = 0
      end if

      do j = 0, jhi

        if ( i < ntab ) then

          xval = ( real ( 3 - j, kind = 8 ) * xtab(i)     &
                 + real (     j, kind = 8 ) * xtab(i+1) ) &
                 / real ( 3,     kind = 8 )

        else

          xval = xtab(i)

        end if

        call least_val_old ( xval, ndeg, b, c, d, yval )

        ytrue = real ( int ( exp ( xval ) * 100.0D+00 + 0.5D+00 ), kind = 8 ) &
          / 100.0D+00

        error = yval - ytrue
        write ( *, '(2x,5g14.6)' ) xval, yval, ytrue, error
      end do

    end do

  end do

  return
end
subroutine test126

!*****************************************************************************80
!
!! TEST126 tests LEAST_SET and LEAST_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    09 December 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: point_num = 21
  integer ( kind = 4 ), parameter :: nterms = 4

  real    ( kind = 8 ) b(nterms)
  real    ( kind = 8 ) c(nterms)
  real    ( kind = 8 ) d(nterms)
  real    ( kind = 8 ) f(point_num)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) nterms2
  real    ( kind = 8 ) px
  real    ( kind = 8 ) w(point_num)
  real    ( kind = 8 ) x(point_num)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST126'
  write ( *, '(a)' ) '  LEAST_SET sets a least squares polynomial,'
  write ( *, '(a)' ) '  LEAST_VAL evaluates it.'

  w(1:point_num) = 1.0D+00

  do i = 1, point_num
    x(i) = - 1.0D+00 + real ( i - 1, kind = 8 ) / 10.0D+00
    f(i) = real ( int ( exp ( x(i) ) * 100.0D+00 + 0.5D+00 ), kind = 8 ) &
      / 100.0D+00
  end do

  call least_set ( point_num, x, f, w, nterms, b, c, d )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  X, F(X), P(X), Error'
  write ( *, '(a)' ) ' '

  do nterms2 = 1, nterms
    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  Using polynomial order = ', nterms2
    write ( *, '(a)' ) ' '
    do i = 1, point_num
      call least_val ( nterms2, b, c, d, x(i), px )
      write ( *, '(5g14.6)' ) x(i), f(i), px, px - f(i)
    end do
  end do

  return
end
subroutine test127

!*****************************************************************************80
!
!! TEST127 tests LEAST_SET and LEAST_VAL2.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    09 December 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: point_num = 21
  integer ( kind = 4 ), parameter :: nterms = 4

  real    ( kind = 8 ) b(nterms)
  real    ( kind = 8 ) c(nterms)
  real    ( kind = 8 ) d(nterms)
  real    ( kind = 8 ) f(point_num)
  real    ( kind = 8 ) fp(point_num)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) nterms2
  real    ( kind = 8 ) px
  real    ( kind = 8 ) pxp
  real    ( kind = 8 ) w(point_num)
  real    ( kind = 8 ) x(point_num)

  w(1:point_num) = 1.0D+00

  do i = 1, point_num
    x(i) = -1.0D+00 + real ( i - 1, kind = 8 ) / 10.0D+00
    f(i) = x(i)**2 - x(i) - 6.0D+00
    fp(i) = 2.0D+00 * x(i) - 1.0D+00
  end do

  call least_set ( point_num, x, f, w, nterms, b, c, d )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST127'
  write ( *, '(a)' ) '  LEAST_SET sets a least squares polynomial,'
  write ( *, '(a)' ) '  LEAST_VAL2 evaluates it.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  X, F(X), P(X), FP(X), PP(X)'
  write ( *, '(a)' ) ' '

  do nterms2 = 1, nterms
    write ( *, '(a)' ) ' '
    write ( *, '(a,i8)' ) '  Using polynomial order = ', nterms2
    write ( *, '(a)' ) ' '
    do i = 1, point_num
      call least_val2 ( nterms2, b, c, d, x(i), px, pxp )
      write ( *, '(5g14.6)' ) x(i), f(i), px, fp(i), pxp
    end do
  end do

  return
end
subroutine test13

!*****************************************************************************80
!
!! TEST13 tests SPLINE_B_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 11

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), parameter :: pi = 3.141592653589793D+00
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST13'
  write ( *, '(a)' ) '  SPLINE_B_VAL evaluates the B spline.'

  do i = 1, ndata
    tdata(i) = real ( i - 1, kind = 8 )
    ydata(i) = sin ( 2.0D+00 * pi * tdata(i) / real ( ndata - 1, kind = 8 ) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       T           Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call spline_b_val ( ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test14

!*****************************************************************************80
!
!! TEST14 tests SPLINE_BETA_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 11

  real    ( kind = 8 ) beta1
  real    ( kind = 8 ) beta2
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), parameter :: pi = 3.141592653589793D+00
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST14'
  write ( *, '(a)' ) '  SPLINE_BETA_VAL evaluates the BETA spline.'

  do i = 1, ndata
    tdata(i) = real ( i - 1, kind = 8 )
    ydata(i) = sin ( 2.0D+00 * pi * tdata(i) / real ( ndata - 1, kind = 8 ) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  beta1 = 1.0D+00
  beta2 = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call spline_beta_val ( beta1, beta2, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  beta1 = 1.0D+00
  beta2 = 100.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call spline_beta_val ( beta1, beta2, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  beta1 = 100.0D+00
  beta2 = 0.0D+00

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  BETA1 = ', beta1
  write ( *, '(a,g14.6)' ) '  BETA2 = ', beta2
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call spline_beta_val ( beta1, beta2, ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test143

!*****************************************************************************80
!
!! TEST143 tests SPLINE_BEZIER_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: dim_num = 1
  integer ( kind = 4 ), parameter :: interval_num = 3

  real    ( kind = 8 ) data_val(dim_num,3*interval_num+1)
  real    ( kind = 8 ) dxdt
  integer ( kind = 4 ) interval
  integer ( kind = 4 ) j
  character mark
  integer ( kind = 4 ) point
  integer ( kind = 4 ) point_num
  real    ( kind = 8 ), allocatable, dimension ( : ) :: point_t
  real    ( kind = 8 ), allocatable, dimension ( :, : ) :: point_val
  real    ( kind = 8 ) t
  real    ( kind = 8 ) t_max
  real    ( kind = 8 ) t_min
  real    ( kind = 8 ) x
  real    ( kind = 8 ), parameter :: x_max = 2.0D+00 * 3.141592653589793D+00
  real    ( kind = 8 ), parameter :: x_min = 0.0D+00
  real    ( kind = 8 ) xdata(0:interval_num)
  real    ( kind = 8 ) ydata(0:interval_num)
  real    ( kind = 8 ) ypdata(0:interval_num)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST143'
  write ( *, '(a)' ) '  SPLINE_BEZIER_VAL evaluates a cubic Bezier spline.'
!
!  Construct the data.
!
  do interval = 0, interval_num

    x = ( real ( interval_num - interval, kind = 8 ) * x_min   &
        + real (                interval, kind = 8 ) * x_max ) &
        / real ( interval_num,            kind = 8 )
    
    xdata(interval) = x
    ydata(interval) =  sin ( x )
    ypdata(interval) = cos ( x )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of intervals = ', interval_num
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       X             Y            dYdX'
  write ( *, '(a)'    ) ' '

  do interval = 0, interval_num
    write ( *, '(2x,3g14.6)' ) &
      xdata(interval), ydata(interval), ypdata(interval)
  end do
!
!  Construct the Bezier control data.
!
  dxdt = ( x_max - x_min ) / real ( interval_num, kind = 8 )
  j = 0

  do interval = 1, interval_num

    if ( interval == 1 ) then
      j = j + 1
      data_val(1,j) = ydata(interval-1)
    end if

    j = j + 1
    data_val(1,j) = ydata(interval-1) + ypdata(interval-1) * dxdt / 3.0D+00

    j = j + 1
    data_val(1,j) = ydata(interval)   - ypdata(interval) * dxdt  / 3.0D+00

    j = j + 1
    data_val(1,j) = ydata(interval)

  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  The control points'
  write ( *, '(a)' ) '  Interpolation points are marked with a "*".'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '                     T            P(T)'
  write ( *, '(a)' ) ' '

  do j = 1, 3 * interval_num + 1

    t = real ( j - 1, kind = 8 ) / 3.0

    if ( abs ( nint ( t ) - t ) < 0.00001D+00 ) then
      mark = '*'
    else
      mark = ' '
    end if

    write ( *, '(2x,a,2x,i8,2g14.6)' ) mark, j, t, data_val(1,j)
  end do

  point_num = 6 * interval_num + 1
  allocate ( point_t(1:point_num) )
  allocate ( point_val(1:dim_num,1:point_num) )

  t_min = 0.0D+00
  t_max = real ( interval_num, kind = 8 )

  do point = 1, point_num

    t = ( real ( point_num - point,     kind = 8 ) * t_min   &
        + real (             point - 1, kind = 8 ) * t_max ) &
        / real ( point_num         - 1, kind = 8 )
    
    point_t(point) = t

  end do

  call spline_bezier_val ( dim_num, interval_num, data_val, point_num, &
    point_t, point_val )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  The Bezier spline, sampled at various points.'
  write ( *, '(a)' ) '  Interpolation points are marked with a "*".'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '                   T        Spline(T)      F(X(T))'
  write ( *, '(a)' ) ' '

  do point = 1, point_num

    if ( abs ( nint ( point_t(point) ) - point_t(point) ) < 0.00001D+00 ) then
      mark = '*'
    else
      mark = ' '
    end if

    x = ( real ( point_num - point,     kind = 8 ) * x_min   &
        + real (             point - 1, kind = 8 ) * x_max ) &
        / real ( point_num         - 1, kind = 8 )

    write ( *, '(2x,a,2x,i8,2x,f10.6,2g14.6)' ) &
      mark, point, point_t(point), point_val(1,point), sin ( x )

  end do

  deallocate ( point_t )
  deallocate ( point_val )

  return
end
subroutine test144

!*****************************************************************************80
!
!! TEST144 tests SPLINE_BEZIER_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    18 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: dim_num = 1
  integer ( kind = 4 ), parameter :: interval_num = 3

  real    ( kind = 8 ) data_val(dim_num,3*interval_num+1)
  integer ( kind = 4 ) interval
  integer ( kind = 4 ) j
  character mark
  integer ( kind = 4 ) point
  integer ( kind = 4 ) point_num
  real    ( kind = 8 ), allocatable, dimension ( : ) :: point_t
  real    ( kind = 8 ), allocatable, dimension ( :, : ) :: point_val
  real    ( kind = 8 ) t
  real    ( kind = 8 ) t_max
  real    ( kind = 8 ) t_min
  real    ( kind = 8 ) x
  real    ( kind = 8 ), parameter :: x_max = 2.0D+00 * 3.141592653589793D+00
  real    ( kind = 8 ), parameter :: x_min = 0.0D+00
  real    ( kind = 8 ) xdata(0:3*interval_num)
  real    ( kind = 8 ) ydata(0:3*interval_num)
  real    ( kind = 8 ) y0
  real    ( kind = 8 ) y1
  real    ( kind = 8 ) y2
  real    ( kind = 8 ) y3
  real    ( kind = 8 ) ypdata(0:interval_num)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST144'
  write ( *, '(a)' ) '  SPLINE_BEZIER_VAL evaluates a cubic Bezier spline.'
  write ( *, '(a)' ) '  Normally, the "interior" points of a Bezier spline'
  write ( *, '(a)' ) '  are not interpolating points.  Instead, the'
  write ( *, '(a)' ) '  derivatives at the interval endpoints are used.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  This example shows, however, that it is possible'
  write ( *, '(a)' ) '  to start with only data values, and to "massage"'
  write ( *, '(a)' ) '  the data so that we can define a cubic Bezier spline'
  write ( *, '(a)' ) '  which interpolates ALL the data.'
!
!  Construct the data.
!
  do interval = 0, 3 * interval_num

    x = ( real ( 3 * interval_num - interval, kind = 8 ) * x_min   &
        + real (                    interval, kind = 8 ) * x_max ) &
        / real ( 3 * interval_num,            kind = 8 )
    
    xdata(interval) = x
    ydata(interval) = sin ( x )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of intervals = ', interval_num
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       X             Y'
  write ( *, '(a)'    ) ' '

  do interval = 0, 3 * interval_num
    write ( *, '(2x,3g14.6)' ) xdata(interval), ydata(interval)
  end do
!
!  Construct the Bezier control data.
!  The middle points must be "massaged".
!
  j = 0

  do interval = 1, interval_num

    y0 = ydata(3*(interval-1))
    y1 = ydata(3*(interval-1)+1)
    y2 = ydata(3*(interval-1)+2)
    y3 = ydata(3*(interval-1)+3)

    if ( interval == 1 ) then
      j = j + 1
      data_val(1,j) = y0
    end if

    j = j + 1
    data_val(1,j) = &
      ( -5.0D+00 * y0 + 18.0D+00 * y1 - 9.0D+00 * y2 + 2.0D+00 * y3 ) / 6.0D+00 

    j = j + 1
    data_val(1,j) = &
      ( 2.0D+00 * y0 - 9.0D+00 * y1 + 18.0D+00 * y2 - 5.0D+00 * y3 ) / 6.0D+00

    j = j + 1
    data_val(1,j) = y3

  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  The control points'
  write ( *, '(a)' ) '  ALL control points will be interpolation points!'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '                     T            P(T)'
  write ( *, '(a)' ) ' '

  do j = 1, 3 * interval_num + 1

    t = real ( j - 1, kind = 8 ) / 3.0

    mark = '*'

    write ( *, '(2x,a,2x,i8,2g14.6)' ) mark, j, t, data_val(1,j)
  end do

  point_num = 6 * interval_num + 1
  allocate ( point_t(1:point_num) )
  allocate ( point_val(1:dim_num,1:point_num) )

  t_min = 0.0D+00
  t_max = real ( interval_num, kind = 8 )

  do point = 1, point_num

    t = ( real ( point_num - point,     kind = 8 ) * t_min   &
        + real (             point - 1, kind = 8 ) * t_max ) &
        / real ( point_num         - 1, kind = 8 )
    
    point_t(point) = t

  end do

  call spline_bezier_val ( dim_num, interval_num, data_val, point_num, &
    point_t, point_val )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  The Bezier spline, sampled at various points.'
  write ( *, '(a)' ) '  Interpolation points are marked with a "*".'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '                   T        Spline(T)      F(X(T))'
  write ( *, '(a)' ) ' '

  do point = 1, point_num

    if ( abs ( nint ( 3 * point_t(point) ) - 3 * point_t(point) ) &
      < 0.00001D+00 ) then
      mark = '*'
    else
      mark = ' '
    end if

    x = ( real ( point_num - point,     kind = 8 ) * x_min   &
        + real (             point - 1, kind = 8 ) * x_max ) &
        / real ( point_num         - 1, kind = 8 )

    write ( *, '(2x,a,2x,i8,2x,f10.6,2g14.6)' ) &
      mark, point, point_t(point), point_val(1,point), sin ( x )

  end do

  deallocate ( point_t )
  deallocate ( point_val )

  return
end
subroutine test145

!*****************************************************************************80
!
!! TEST145 tests SPLINE_CONSTANT_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 12
  integer ( kind = 4 ), parameter :: n_test = 20

  real    ( kind = 8 ) ahi
  real    ( kind = 8 ) alo
  real    ( kind = 8 ) frunge
  real    ( kind = 8 ) fval
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) :: seed = 123456789
  real    ( kind = 8 ) tdata(ndata-1)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) t_test(n_test)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST145'
  write ( *, '(a)' ) '  SPLINE_CONSTANT_VAL evaluates a piecewise '
  write ( *, '(a)' ) '  constant spline.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Runge''s function, evenly spaced knots.'
!
!  Set the data.
!
  tlo = -1.0D+00
  thi = +1.0D+00
  call r8vec_even ( ndata-1, tlo, thi, tdata )

  do i = 1, ndata

    if ( i == 1 ) then
      tval = tdata(1)
    else if ( i < ndata ) then
      tval = 0.5D+00 * ( tdata(i-1) + tdata(i) )
    else if ( i == ndata ) then
      tval = tdata(i-1)
    end if

    ydata(i) = frunge ( tval )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, ndata
    write ( *, '(2x,a1,14x,g14.6)' ) '*', ydata(i)
    if ( i < ndata ) then
      write ( *, '(2x,a1, g14.6)' ) '*', tdata(i)
    end if
  end do
!
!  Sample the spline.
!
  write ( *, * ) 'DEBUG: TLO = ', tlo
  write ( *, * ) 'DEBUG: THI = ', thi

  alo = tlo - 1.0D+00
  ahi = thi + 1.0D+00

  call r8vec_uniform_01 ( n_test, seed, t_test )

  t_test(1:n_test) = ( 1.0D+00 - t_test(1:n_test) ) * alo &
                   +             t_test(1:n_test)   * ahi

  call r8vec_sort_bubble_a ( n_test, t_test )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     T     Y(interp)    Y(exact)'
  write ( *, '(a)' ) ' '

  j = 0
  write ( *, '(2x,a1,14x,g14.6)' ) '*', ydata(j+1)
  j = j + 1

  do i = 1, n_test

    tval = t_test(i)

    call spline_constant_val ( ndata, tdata, ydata, tval, yval )

    if ( j <= ndata - 1 ) then
      do while ( tdata(j) <= tval )
        fval = frunge ( tdata(j) )
        write ( *, '(2x,a1,g14.6,14x,g14.6)' ) '*', tdata(j), fval
        write ( *, '(2x,a1,14x,g14.6)' ) '*', ydata(j+1)
        j = j + 1
        if ( ndata <= j ) then
          exit
        end if
      end do
    end if

    fval = frunge ( tval )

    write ( *, '(2x,a1,3g14.6)' ) ' ', tval, yval, fval

  end do

  return
end
subroutine test15

!*****************************************************************************80
!
!! TEST15 tests SPLINE_CUBIC_SET and SPLINE_CUBIC_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 11

  real    ( kind = 8 ) frunge
  real    ( kind = 8 ) fprunge
  real    ( kind = 8 ) fpprunge
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) k
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ybcbeg
  real    ( kind = 8 ) ybcend
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST15'
  write ( *, '(a)' ) '  SPLINE_CUBIC_SET sets up a cubic spline;'
  write ( *, '(a)' ) '  SPLINE_CUBIC_VAL evaluates it.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Runge''s function, evenly spaced knots.'

  do i = 1, n

    t(i) = ( real ( n - i,     kind = 8 ) * (-1.0D+00)   &
           + real (     i - 1, kind = 8 ) * (+1.0D+00) ) &
           / real ( n     - 1, kind = 8 )

    y(i) =  frunge ( t(i) )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, n
    write ( *, '(2x,g14.6,2x,g14.6)' ) t(i), y(i)
  end do
!
!  Try boundary condition types 0, 1 and 2.
!
  do k = 0, 3

    if ( k == 0 ) then

      ibcbeg = 0
      ybcbeg = 0.0D+00

      ibcend = 0
      ybcend = 0.0D+00

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 0 at both ends:'
      write ( *, '(a)' ) '  Spline is quadratic in boundary intervals.'

    else if ( k == 1 ) then

      ibcbeg = 1
      ybcbeg = fprunge ( t(1) )

      ibcend = 1
      ybcend = fprunge ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 1 at both ends:'
      write ( *, '(a,g14.6)' ) '  Y''(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  Y''(right) = ', ybcend

    else if ( k == 2 ) then

      ibcbeg = 2
      ybcbeg = fpprunge ( t(1) )

      ibcend = 2
      ybcend = fpprunge ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 2 at both ends:'
      write ( *, '(a,g14.6)' ) '  YP"(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  YP"(right) = ', ybcend

    else if ( k == 3 ) then

      ibcbeg = 2
      ybcbeg = 0.0D+00

      ibcend = 2
      ybcend = 0.0D+00

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  "Natural" spline:'
      write ( *, '(a)' ) '  Boundary condition 2 at both ends:'
      write ( *, '(a,g14.6)' ) '  YP"(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  YP"(right) = ', ybcend

    end if

    call spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

    if ( k == 3 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '       I      Y(I)          YPP(I)'
      write ( *, '(a)' ) ' '
      do i = 1, n
        write ( *, '(2x,i8,2g14.6)' ) i, y(i), ypp(i)
      end do
    end if

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '    SPLINE"(T)      F"(T):'
    write ( *, '(a)' ) ' '
    do i = 1, n
      write ( *, '(2x,2g14.6)' ) ypp(i), fpprunge(t(i))
    end do

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '      T            SPLINE(T)      F(T)'
    write ( *, '(a)' ) ' '

    do i = 0, n

      if ( i == 0 ) then
        jhi = 1
      else if ( i < n ) then
        jhi = 2
      else
        jhi = 2
      end if

      do j = 1, jhi

        if ( i == 0 ) then
          tval = t(1) - 1.0D+00
        else if ( i < n ) then
          tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
                 + real (       j - 1, kind = 8 ) * t(i+1) ) &
                 / real ( jhi,         kind = 8 )
        else
          if ( j == 1 ) then
            tval = t(n)
          else
            tval = t(n) + 1.0D+00
          end if
        end if

        call spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )

        write ( *, '(2x,3g14.6)' ) tval, yval, frunge ( tval )

      end do
    end do

  end do

  return
end
subroutine test16

!*****************************************************************************80
!
!! TEST16 tests SPLINE_CUBIC_SET and SPLINE_CUBIC_VAL2.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 11

  real    ( kind = 8 ) frunge
  real    ( kind = 8 ) fprunge
  real    ( kind = 8 ) fpprunge
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) k
  integer ( kind = 4 ) left
  integer ( kind = 4 ) left_in
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ybcbeg
  real    ( kind = 8 ) ybcend
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST16'
  write ( *, '(a)' ) '  SPLINE_CUBIC_SET sets up a cubic spline;'
  write ( *, '(a)' ) '  SPLINE_CUBIC_VAL2 evaluates it.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Runge''s function, evenly spaced knots.'
  do i = 1, n

    t(i) = ( real ( n - i,     kind = 8 ) * (-1.0D+00)   &
           + real (     i - 1, kind = 8 ) * (+1.0D+00) ) &
           / real ( n     - 1, kind = 8 )

    y(i) =  frunge ( t(i) )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, n
    write ( *, '(2x,2g14.6)' ) t(i), y(i)
  end do
!
!  Try boundary condition types 0, 1 and 2.
!
  do k = 0, 2

    if ( k == 0 ) then

      ibcbeg = 0
      ybcbeg = 0.0D+00

      ibcend = 0
      ybcend = 0.0D+00

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 0 at both ends:'
      write ( *, '(a)' ) '  Spline is quadratic in boundary intervals.'

    else if ( k == 1 ) then

      ibcbeg = 1
      ybcbeg = fprunge ( t(1) )

      ibcend = 1
      ybcend = fprunge ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 1 at both ends:'
      write ( *, '(a,g14.6)' ) '  Y''(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  Y''(right) = ', ybcend

    else if ( k == 2 ) then

      ibcbeg = 2
      ybcbeg = fpprunge ( t(1) )

      ibcend = 2
      ybcend = fpprunge ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 2 at both ends:'
      write ( *, '(a,g14.6)' ) '  YP"(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  YP"(right) = ', ybcend

    end if

    call spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '  SPLINE"(T)      F"(T)'
    write ( *, '(a)' ) ' '
    do i = 1, n
      write ( *, '(2x,2g14.6)' ) ypp(i), fpprunge(t(i))
    end do

    left = 0

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) &
      '      T             SPLINE(T)       F(T)       LEFT_IN  LEFT_OUT'
    write ( *, '(a)' ) ' '

    do i = 0, n

      if ( i == 0 ) then
        jhi = 1
      else if ( i < n ) then
        jhi = 2
      else
        jhi = 2
      end if

      do j = 1, jhi

        if ( i == 0 ) then
          tval = t(1) - 1.0D+00
        else if ( i < n ) then
          tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
                 + real (       j - 1, kind = 8 ) * t(i+1) ) &
                 / real ( jhi,         kind = 8 )
        else
          if ( j == 1 ) then
            tval = t(n)
          else
            tval = t(n) + 1.0D+00
          end if
        end if

        left_in = left

        call spline_cubic_val2 ( n, t, y, ypp, left, tval, yval, ypval, yppval )

        write ( *, '(2x,3g14.6,2i8)' ) tval, yval, frunge ( tval ), &
          left_in, left

      end do
    end do

  end do

  return
end
subroutine test17

!*****************************************************************************80
!
!! TEST17 tests SPLINE_CUBIC_SET and SPLINE_CUBIC_VAL.
!
!  Discussion:
!
!    For boundary condition 0, the spline should come very close within
!    the interpolation interval.
!
!    For conditions 1 and 2, the spline should be essentially exactly equal
!    to the data, inside and outside the interpolation interval.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 11

  real    ( kind = 8 ) fcube
  real    ( kind = 8 ) fpcube
  real    ( kind = 8 ) fppcube
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) k
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ybcbeg
  real    ( kind = 8 ) ybcend
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST17'
  write ( *, '(a)' ) '  SPLINE_CUBIC_SET sets up a cubic spline;'
  write ( *, '(a)' ) '  SPLINE_CUBIC_VAL evaluates it.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Cubic data, unevenly spaced knots.'

  do i = 1, n
    t(i) = ( real ( i - 1, kind = 8 ) &
           / real ( n - 1, kind = 8 ) )**2
  end do

  do i = 1, n
    y(i) = fcube ( t(i) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, n
    write ( *, '(2x,g14.6,2x,g14.6)' ) t(i), y(i)
  end do
!
!  Try boundary condition types 0, 1 and 2.
!
  do k = 0, 2

    if ( k == 0 ) then

      ibcbeg = 0
      ybcbeg = 0.0D+00

      ibcend = 0
      ybcend = 0.0D+00

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 0 at both ends:'
      write ( *, '(a)' ) '  Spline is quadratic in boundary intervals.'

    else if ( k == 1 ) then

      ibcbeg = 1
      ybcbeg = fpcube ( t(1) )

      ibcend = 1
      ybcend = fpcube ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 1 at both ends:'
      write ( *, '(a,g14.6)' ) '  Y''(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  Y''(right) = ', ybcend

    else if ( k == 2 ) then

      ibcbeg = 2
      ybcbeg = fppcube ( t(1) )

      ibcend = 2
      ybcend = fppcube ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 2 at both ends:'
      write ( *, '(a,g14.6)' ) '  YP"(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  YP"(right) = ', ybcend

    end if

    call spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '       SPLINE"(T)    F"(T):'
    write ( *, '(a)' ) ' '
    do i = 1, n
      write ( *, '(2x,2g14.6)' ) ypp(i), fppcube(t(i))
    end do

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '       T           SPLINE(T)      F(T)'
    write ( *, '(a)' ) ' '

    do i = 0, n

      if ( i == 0 ) then
        jhi = 1
      else if ( i < n ) then
        jhi = 2
      else
        jhi = 2
      end if

      do j = 1, jhi

        if ( i == 0 ) then
          tval = t(1) - 1.0D+00
        else if ( i < n ) then
          tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
                 + real (       j - 1, kind = 8 ) * t(i+1) ) &
                 / real ( jhi,         kind = 8 )
        else
          if ( j == 1 ) then
            tval = t(n)
          else
            tval = t(n) + 1.0D+00
          end if
        end if

        call spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )

        write ( *, '(2x,3g14.6)' ) tval, yval, fcube ( tval )

      end do
    end do

  end do

  return
end
subroutine test18

!*****************************************************************************80
!
!! TEST18 tests SPLINE_CUBIC_SET and SPLINE_CUBIC_VAL.
!
!  Discussion:
!
!    For boundary condition 0, the spline should come very close within
!    the interpolation interval.
!
!    For conditions 1 and 2, the spline should be essentially exactly equal
!    to the data, inside and outside the interpolation interval.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 11

  real    ( kind = 8 ) fcube
  real    ( kind = 8 ) fpcube
  real    ( kind = 8 ) fppcube
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) k
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ybcbeg
  real    ( kind = 8 ) ybcend
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST18'
  write ( *, '(a)' ) '  SPLINE_CUBIC_SET sets up a cubic spline;'
  write ( *, '(a)' ) '  SPLINE_CUBIC_VAL evaluates it.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Cubic data, evenly spaced knots.'
  do i = 1, n
    t(i) = real ( i - 1, kind = 8 ) / real ( n - 1, kind = 8 )
    y(i) =  fcube ( t(i) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, n
    write ( *, '(2x,g14.6,2x,g14.6)' ) t(i), y(i)
  end do
!
!  Try boundary condition types 0, 1 and 2.
!
  do k = 0, 2

    if ( k == 0 ) then

      ibcbeg = 0
      ybcbeg = 0.0D+00

      ibcend = 0
      ybcend = 0.0D+00

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 0 at both ends:'
      write ( *, '(a)' ) '  Spline is quadratic in boundary intervals.'

    else if ( k == 1 ) then

      ibcbeg = 1
      ybcbeg = fpcube ( t(1) )

      ibcend = 1
      ybcend = fpcube ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 1 at both ends:'
      write ( *, '(a,g14.6)' ) '  Y''(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  Y''(right) = ', ybcend

    else if ( k == 2 ) then

      ibcbeg = 2
      ybcbeg = fppcube ( t(1) )

      ibcend = 2
      ybcend = fppcube ( t(n) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 2 at both ends:'
      write ( *, '(a,g14.6)' ) '  YP"(left) =  ', ybcbeg
      write ( *, '(a,g14.6)' ) '  YP"(right) = ', ybcend

    end if

    call spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '   SPLINE"(T)      F"(T):'
    write ( *, '(a)' ) ' '
    do i = 1, n
      write ( *, '(2x,2g14.6)' ) ypp(i), fppcube(t(i))
    end do

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '        T      SPLINE(T)    F(T)'
    write ( *, '(a)' ) ' '

    do i = 0, n

      if ( i == 0 ) then
        jhi = 1
      else if ( i < n ) then
        jhi = 2
      else
        jhi = 2
      end if

      do j = 1, jhi

        if ( i == 0 ) then
          tval = t(1) - 1.0D+00
        else if ( i < n ) then
          tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
                 + real (       j - 1, kind = 8 ) * t(i+1) ) &
                 / real ( jhi,         kind = 8 )
        else
          if ( j == 1 ) then
            tval = t(n)
          else
            tval = t(n) + 1.0D+00
          end if
        end if

        call spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )

        write ( *, '(2x,f10.4)' ) tval
        write ( *, '(2x,10x,2f10.4)' )   yval, fcube ( tval )
        write ( *, '(2x,10x,2f10.4)' )   ypval, fpcube ( tval )
        write ( *, '(2x,10x,2f10.4)' )   yppval, fppcube ( tval )

      end do
    end do

  end do

  return
end
subroutine test19

!*****************************************************************************80
!
!! TEST19 tests SPLINE_CUBIC_SET and SPLINE_CUBIC_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 2

  real    ( kind = 8 ) fcube
  real    ( kind = 8 ) fpcube
  real    ( kind = 8 ) fppcube
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) k1
  integer ( kind = 4 ) k2
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ybcbeg
  real    ( kind = 8 ) ybcend
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST19'
  write ( *, '(a)' ) '  SPLINE_CUBIC_SET sets up a cubic spline;'
  write ( *, '(a)' ) '  SPLINE_CUBIC_VAL evaluates it.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Cubic data, evenly spaced knots.'
  write ( *, '(a)' ) '  ONLY TWO KNOTS!'

  do i = 1, n
    t(i) = real ( i - 1, kind = 8 ) / real ( n - 1, kind = 8 )
    y(i) = fcube ( t(i) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, n
    write ( *, '(2x,g14.6,2x,g14.6)' ) t(i), y(i)
  end do
!
!  Try all 9 pairs of boundary condition types 0, 1 and 2.
!
  do k1 = 0, 2

    if ( k1 == 0 ) then

      ibcbeg = 0
      ybcbeg = 0.0D+00

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 0 at left end.'

    else if ( k1 == 1 ) then

      ibcbeg = 1
      ybcbeg = fpcube ( t(1) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 1 at left end.'
      write ( *, '(a,g14.6)' ) '  Y''(left) =  ', ybcbeg

    else if ( k1 == 2 ) then

      ibcbeg = 2
      ybcbeg = fppcube ( t(1) )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  Boundary condition 2 at left ends:'
      write ( *, '(a,g14.6)' ) '  YP"(left) =  ', ybcbeg

    end if

    do k2 = 0, 2

      if ( k2 == 0 ) then

        ibcend = 0
        ybcend = 0.0D+00

        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) '  Boundary condition 0 at right end.'

      else if ( k2 == 1 ) then

        ibcend = 1
        ybcend = fpcube ( t(n) )

        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) '  Boundary condition 1 at right end.'
        write ( *, '(a,g14.6)' ) '  Y''(right) = ', ybcend

      else if ( k2 == 2 ) then

        ibcend = 2
        ybcend = fppcube ( t(n) )

        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) '  Boundary condition 2 at right end.'
        write ( *, '(a,g14.6)' ) '  YP"(right) = ', ybcend

      end if

      call spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  SPLINE"(T), F"(T):'
      write ( *, '(a)' ) ' '
      do i = 1, n
        write ( *, '(2x,2g14.6)' ) ypp(i), fppcube(t(i))
      end do

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  T, SPLINE(T), F(T)'
      write ( *, '(a)' ) ' '

      do i = 0, n

        if ( i == 0 ) then
          jhi = 1
        else if ( i < n ) then
          jhi = 2
        else
          jhi = 2
        end if

        do j = 1, jhi

          if ( i == 0 ) then
            tval = t(1) - 1.0D+00
          else if ( i < n ) then
            tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
                   + real (       j - 1, kind = 8 ) * t(i+1) ) &
                   / real ( jhi,         kind = 8 )
          else
            if ( j == 1 ) then
              tval = t(n)
            else
              tval = t(n) + 1.0D+00
            end if
          end if

          call spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )

          write ( *, '(2x,f10.4)' ) tval
          write ( *, '(2x,10x,2f10.4)' )   yval, fcube ( tval )
          write ( *, '(2x,10x,2f10.4)' )   ypval, fpcube ( tval )
          write ( *, '(2x,10x,2f10.4)' )   yppval, fppcube ( tval )

        end do
      end do

    end do

  end do

  return
end
subroutine test20

!*****************************************************************************80
!
!! TEST20 tests SPLINE_HERMITE_SET and SPLINE_HERMITE_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 4

  real    ( kind = 8 ) c(4,ndata)
  real    ( kind = 8 ) fpval
  real    ( kind = 8 ) fval
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  real    (  kind = 8 ), parameter :: pi = 3.141592653589793D+00
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) ypdata(ndata)
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST20'
  write ( *, '(a)' ) '  SPLINE_HERMITE_SET sets up a Hermite spline;'
  write ( *, '(a)' ) '  SPLINE_HERMITE_VAL evaluates it.'
!
!  Set the data.
!
  do i = 1, ndata
    tdata(i) = ( real ( ndata - i,     kind = 8 ) *   0.0D+00          &
               + real (         i - 1, kind = 8 ) * ( 0.5D+00 * pi ) ) &
               / real ( ndata     - 1, kind = 8 )
    ydata(i) = sin ( tdata(i) )
    ypdata(i) = cos ( tdata(i) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y             Y'''
  write ( *, '(a)'    ) ' '
  do i = 1, ndata
    write ( *, '(2x,3g14.6)' ) tdata(i), ydata(i), ypdata(i)
  end do
!
!  Set up the spline.
!
  call spline_hermite_set ( ndata, tdata, ydata, ypdata, c )
!
!  Now evaluate the spline all over the place.
!
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T        Y(hermite)     ' // &
    'Y(exact)      Y''(hermite)   Y''(exact)'
  write ( *, '(a)'    ) ' '

  do i = 1, ndata

    if ( i == ndata ) then
      jhi = 0
    else
      jhi = 2
    end if

    do j = 0, jhi

      tval = real ( 3 * ( i - 1 ) + j, kind = 8 ) * ( 0.5D+00 * pi ) &
           / real ( 3 * ( ndata - 1 ), kind = 8 )

      fval = sin ( tval )
      fpval = cos ( tval )
 
      call spline_hermite_val ( ndata, tdata, c, tval, yval, ypval )

      if (j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,5g14.6)' ) mark, tval, yval, fval, ypval, fpval

    end do

  end do

  return
end
subroutine test205

!*****************************************************************************80
!
!! TEST205 tests SPLINE_LINEAR_INT and SPLINE_LINEAR_INTSET.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 4

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) data_x(n)
  real    ( kind = 8 ) data_y(n)
  integer ( kind = 4 ) i
  real    ( kind = 8 ) int_x(n+1)
  real    ( kind = 8 ) int_v(n)
  real    ( kind = 8 ) value

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST205'
  write ( *, '(a)' ) '  SPLINE_LINEAR_INTSET is given some interval endpoints,'
  write ( *, '(a)' ) '  and a value associated with each interval.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  It determines a linear spline, with breakpoints'
  write ( *, '(a)' ) '  at the centers of each interval, whose integral'
  write ( *, '(a)' ) '  over each interval is equal to the given value.'

  int_x(1:n+1) = (/ 0.0D+00, 1.0D+00, 4.0D+00, 5.0D+00, 10.0D+00 /)
  int_v(1:n) = (/ 10.0D+00, 2.0D+00, 8.0D+00, 27.5D+00 /)

  call r8vec_print ( n+1, int_x, '  The interval end points:' )

  call r8vec_print ( n, int_v, '  The desired interval integral values:' )

  call spline_linear_intset ( n, int_x, int_v, data_x, data_y )

  call r8vec_print ( n, data_x, '  The spline break points:' )
  call r8vec_print ( n, data_y, '  The spline data values: ' )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  As a check, call SPLINE_LINEAR_INT to compute'
  write ( *, '(a)' ) '  the integral of the spline over each interval,'
  write ( *, '(a)' ) '  and compare to the desired value.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     A       B    Desired      Computed'
  write ( *, '(a)' ) ' '

  do i = 1, n
    a = int_x(i)
    b = int_x(i+1)
    call spline_linear_int ( n, data_x, data_y, a, b, value )
    write ( *, '(2x,2f8.2,2g14.6)' ) a, b, int_v(i), value
  end do

  return
end
subroutine test21

!*****************************************************************************80
!
!! TEST21 tests SPLINE_LINEAR_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 11

  real    ( kind = 8 ) frunge
  real    ( kind = 8 ) fval
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST21'
  write ( *, '(a)' ) '  SPLINE_LINEAR_VAL evaluates a linear spline.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Runge''s function, evenly spaced knots.'

  do i = 1, n

    t(i) = ( real ( n - i,     kind = 8 ) * (-1.0D+00)   &
           + real (     i - 1, kind = 8 ) * (+1.0D+00) ) &
           / real ( n     - 1, kind = 8 )

    y(i) =  frunge ( t(i) )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '
  do i = 1, n
    write ( *, '(2x,2g14.6)' ) t(i), y(i)
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  Interpolation:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y            Yexact'
  write ( *, '(a)'    ) ' '

  do i = 0, n

    if ( i == 0 ) then
      jhi = 1
    else if ( i < n ) then
      jhi = 2
    else
      jhi = 2
    end if

    do j = 1, jhi

      if ( i == 0 ) then
        tval = t(1) - 1.0D+00
      else if ( i < n ) then
        tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
               + real (       j - 1, kind = 8 ) * t(i+1) ) &
               / real ( jhi,         kind = 8 )
      else
        if ( j == 1 ) then
          tval = t(n)
        else
          tval = t(n) + 1.0D+00
        end if
      end if

      call spline_linear_val ( n, t, y, tval, yval, ypval )

      fval = frunge ( tval )

      write ( *, '(2x,3g14.6)' ) tval, yval, fval

    end do

  end do

  return
end
subroutine test215

!*****************************************************************************80
!
!! TEST215 tests SPLINE_LINEAR_INT.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 3

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  integer ( kind = 4 ) i
  real    ( kind = 8 ) int_val
  real    (  kind = 8 ), dimension ( n ) :: t = (/ 2.0D+00, 4.5D+00, 7.5D+00 /)
  real    (  kind = 8 ), dimension ( n ) :: y = (/ 3.0D+00, 3.75D+00, 5.5D+00 /)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST215'
  write ( *, '(a)' ) '  SPLINE_LINEAR_INT computes the integral '
  write ( *, '(a)' ) '  of a linear spline.'
  write ( *, '(a)' ) ' '

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '
  do i = 1, n
    write ( *, '(2x,2g14.6)' ) t(i), y(i)
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    A             B           Integral'
  write ( *, '(a)' ) ' '

  do i = 1, 5

    if ( i == 1 ) then
      a = 0.0D+00
      b = 4.0D+00
    else if ( i == 2 ) then
      a = 4.0D+00
      b = 5.0D+00
    else if ( i == 3 ) then
      a = 5.0D+00
      b = 10.0D+00
    else if ( i == 4 ) then
      a = 0.0D+00
      b = 10.0D+00
    else
      a = 10.0D+00
      b = 0.0D+00
    end if

    call spline_linear_int ( n, t, y, a, b, int_val )

    write ( *, '(2x,3g14.6)' ) a, b, int_val

  end do

  return
end
subroutine test22

!*****************************************************************************80
!
!! TEST22 tests SPLINE_OVERHAUSER_UNI_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 11

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), parameter :: pi = 3.141592653589793D+00
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST22'
  write ( *, '(a)' ) '  SPLINE_OVERHAUSER_UNI_VAL evaluates the'
  write ( *, '(a)' ) '    uniform Overhauser spline.'

  do i = 1, ndata
    tdata(i) = real ( i - 1, kind = 8 )
    ydata(i) = sin ( 2.0D+00 * pi * tdata(i) / real ( ndata - 1, kind = 8 ) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '         T             Y'
  write ( *, '(a)'    ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '      T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call spline_overhauser_uni_val ( ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test225

!*****************************************************************************80
!
!! TEST225 tests SPLINE_OVERHAUSER_NONUNI_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 11

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  character mark
  integer ( kind = 4 ), parameter :: nsample = 4
  real    (  kind = 8 ), parameter :: pi = 3.141592653589793D+00
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) thi
  real    ( kind = 8 ) tlo
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST225'
  write ( *, '(a)' ) '  SPLINE_OVERHAUSER_NONUNI_VAL evaluates the'
  write ( *, '(a)' ) '    nonuniform Overhauser spline.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  In this initial draft of a test, we simply'
  write ( *, '(a)' ) '  use uniform nodes.'

  do i = 1, ndata
    tdata(i) = real ( i - 1, kind = 8 )
    ydata(i) = sin ( 2.0D+00 * pi * tdata(i) / real ( ndata - 1, kind = 8 ) )
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '         T             Y'
  write ( *, '(a)'    ) ' '
  do i = 1, ndata
    write ( *, '(2x,2g14.6)' ) tdata(i), ydata(i)
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '      T, Spline(T)'
  write ( *, '(a)' ) ' '

  do i = 0, ndata

    if ( i == 0 ) then
      tlo = tdata(1) - 0.5D+00 * ( tdata(2) - tdata(1) )
      thi = tdata(1)
    else if ( i < ndata ) then
      tlo = tdata(i)
      thi = tdata(i+1)
    else if ( ndata <= i ) then
      tlo = tdata(ndata)
      thi = tdata(ndata) + 0.5D+00 * ( tdata(ndata) - tdata(ndata-1) )
    end if

    if ( i < ndata ) then
      jhi = nsample - 1
    else
      jhi = nsample
    end if

    do j = 0, jhi

      tval = ( real ( nsample - j, kind = 8 ) * tlo   &
             + real (           j, kind = 8 ) * thi ) &
             / real ( nsample,     kind = 8 )

      call spline_overhauser_nonuni_val ( ndata, tdata, ydata, tval, yval )

      if ( 0 < i .and. j == 0 ) then
        mark = '*'
      else
        mark = ' '
      end if

      write ( *, '(2x,a1,2g14.6)' ) mark, tval, yval

    end do

  end do

  return
end
subroutine test23

!*****************************************************************************80
!
!! TEST23 tests SPLINE_OVERHAUSER_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 4
  integer ( kind = 4 ), parameter :: dim_num = 2

  integer ( kind = 4 ) i
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(dim_num,ndata)
  real    ( kind = 8 ) yval(dim_num)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST23'
  write ( *, '(a)' ) '  SPLINE_OVERHAUSER_VAL evaluates the'
  write ( *, '(a)' ) '    Overhauser spline.'
!
!  Set the data.
!
  tdata(1) = 1.0D+00
  ydata(1,1) =   0.0D+00
  ydata(2,1) =   0.0D+00

  tdata(2) = 2.0D+00
  ydata(1,2) =   1.0D+00
  ydata(2,2) =   1.0D+00

  tdata(3) = 3.0D+00
  ydata(1,3) =   2.0D+00
  ydata(2,3) = - 1.0D+00

  tdata(4) = 4.0D+00
  ydata(1,4) =   3.0D+00
  ydata(2,4) =   0.0D+00

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', ndata
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y'
  write ( *, '(a)'    ) ' '

  do i = 1, ndata
    write ( *, '(2x,3g14.6)' ) tdata(i), ydata(1:dim_num,i)
  end do
!
!  Now evaluate the spline all over the place.
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  T, Spline value'
  write ( *, '(a)' ) ' '

  do i = 0, 6 * ndata + 3

    tval = real ( i, kind = 8 ) / 6.0D+00
    call spline_overhauser_val ( dim_num, ndata, tdata, ydata, tval, yval )
    write ( *, '(2x,3g14.6)' ) tval, yval(1:dim_num)

  end do

  return
end
subroutine test235

!*****************************************************************************80
!
!! TEST235 tests SPLINE_PCHIP_SET and SPLINE_PCHIP_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    14 August 2005
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 21
  integer ( kind = 4 ), parameter :: ne = 101

  real    ( kind = 8 ) d(n)
  real    ( kind = 8 ) diff
  real    ( kind = 8 ) f(n)
  real    ( kind = 8 ) fd(ne)
  real    ( kind = 8 ) fe(ne)
  integer ( kind = 4 ) i
  real    ( kind = 8 ), external :: frunge
  real    ( kind = 8 ) x(n)
  real    ( kind = 8 ) xe(ne)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST235'
  write ( *, '(a)' ) '  SPLINE_PCHIP_SET carries out piecewise cubic '
  write ( *, '(a)' ) '    Hermite interpolation.'
  write ( *, '(a)' ) '  SPLINE_PCHIP_VAL evaluates the interpolant.'
  write ( *, '(a)' ) ' '
!
!  Compute Runge's function at N points in [-1,1].
!
  do i = 1, n
    x(i) = -1.0D+00 + real ( i - 1, kind = 8 ) / 10.0D+00
    f(i) = frunge ( x(i) )
  end do
!
!  SPLINE_PCHIP_SET takes the data in X and F, and constructs a table in D
!  that defines the interpolant.
!
  call spline_pchip_set ( n, x, f, d )
!
!  Evaluate the interpolant and derivative at NE points from -1 to 0.
!
  do i = 1, ne
    xe(i) = -1.0D+00 + real ( i - 1, kind = 8 ) / real ( ne - 1, kind = 8 )
  end do

  call spline_pchip_val ( n, x, f, d, ne, xe, fe )
!
!  Print the table of X, F(exact) and F(interpolated)
!
  do i = 1, ne
    diff = fe(i) - frunge ( xe(i) )
    write ( *, '(2x,f8.4,2x,f10.6,2x,f10.6,2x,g14.6)' ) &
      xe(i), frunge ( xe(i) ), fe(i), diff
  end do

  return
end
subroutine test24

!*****************************************************************************80
!
!! TEST24 tests SPLINE_QUADRATIC_VAL.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
  implicit none

  integer ( kind = 4 ), parameter :: n = 11

  real    ( kind = 8 ) frunge
  real    ( kind = 8 ) fval
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST24'
  write ( *, '(a)' ) '  SPLINE_QUADRATIC_VAL evaluates a '
  write ( *, '(a)' ) '    quadratic spline.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Runge''s function, evenly spaced knots.'

  do i = 1, n

    t(i) = ( real ( n - i,     kind = 8 ) * (-1.0D+00)   &
           + real (     i - 1, kind = 8 ) * (+1.0D+00) ) &
           / real ( n     - 1, kind = 8 )

    y(i) =  frunge ( t(i) )

  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  The data to be interpolated:'
  write ( *, '(a)'    ) ' '
  write ( *, '(a,i8)' ) '  Number of data values = ', n
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '         T             Y'
  write ( *, '(a)'    ) ' '
  do i = 1, n
    write ( *, '(2x,2g14.6)' ) t(i), y(i)
  end do

  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '  Interpolated values'
  write ( *, '(a)'    ) ' '
  write ( *, '(a)'    ) '       T             Y           Y(exact)'
  write ( *, '(a)'    ) ' '

  do i = 0, n

    if ( i == 0 ) then
      jhi = 1
    else if ( i < n ) then
      jhi = 2
    else
      jhi = 2
    end if

    do j = 1, jhi

      if ( i == 0 ) then
        tval = t(1) - 1.0D+00
      else if ( i < n ) then
        tval = ( real ( jhi - j + 1, kind = 8 ) * t(i)     &
               + real (       j - 1, kind = 8 ) * t(i+1) ) &
               / real ( jhi,         kind = 8 )
      else
        if ( j == 1 ) then
          tval = t(n)
        else
          tval = t(n) + 1.0D+00
        end if
      end if

      call spline_quadratic_val ( n, t, y, tval, yval, ypval )

      fval = frunge ( tval )

      write ( *, '(2x,3g14.6)' ) tval, yval, fval

    end do

  end do

  return
end
function fcube ( x )

!*****************************************************************************80
!
!! FCUBE evaluates a cubic function.
!
!  Discussion:
!
!    Y(X) = ( ( X + 2 ) * X + 3 ) * X + 4
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    10 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real X, the argument.
!
!    Output, real FCUBE, the value of the function.
!
  implicit none

  real    ( kind = 8 ) fcube
  real    ( kind = 8 ) x

  fcube = ( ( (       1.0D+00 ) &
                * x + 2.0D+00 ) &
                * x + 3.0D+00 ) &
                * x + 4.0D+00

  return
end
function fpcube ( x )

!*****************************************************************************80
!
!! FPCUBE evaluates the derivative of a cubic function.
!
!  Discussion:
!
!    Y(X) = ( ( X + 2 ) * X + 3 ) * X + 4
!
!  Modified:
!
!    10 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real X, the argument.
!
!    Output, real FPCUBE, the value of the derivative of the cubic function.
!
  implicit none

  real    ( kind = 8 ) fpcube
  real    ( kind = 8 ) x

  fpcube = ( 3.0D+00 * x + 4.0D+00 ) * x + 3.0D+00

  return
end
function fppcube ( x )

!*****************************************************************************80
!
!! FPPCUBE evaluates the second derivative of a cubic function.
!
!  Discussion:
!
!    Y(X) = ( ( X + 2 ) * X + 3 ) * X + 4
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    10 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real X, the argument.
!
!    Output, real FPPCUBE, the second derivative of the cubic function.
!
  implicit none

  real    ( kind = 8 ) fppcube
  real    ( kind = 8 ) x

  fppcube = 6.0D+00 * x + 4.0D+00

  return
end
function frunge ( x )

!*****************************************************************************80
!
!! FRUNGE evaluates the Runge function.
!
!  Discussion:
!
!    Interpolation of the Runge function at evenly spaced points in [-1,1]
!    is a common test.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 January 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real X, the argument.
!
!    Output, real FRUNGE, the value of the function.
!
  implicit none

  real    ( kind = 8 ) frunge
  real    ( kind = 8 ) x

  frunge = 1.0D+00 / ( 1.0D+00 + 25.0D+00 * x * x )

  return
end
function fprunge ( x )

!*****************************************************************************80
!
!! FPRUNGE evaluates the derivative of the Runge function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 January 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real X, the argument.
!
!    Output, real FPRUNGE, the value of the derivative of the Runge function.
!
  implicit none

  real    ( kind = 8 ) fprunge
  real    ( kind = 8 ) x

  fprunge = - 50.0D+00 * x / ( 1.0D+00 + 25.0D+00 * x * x )**2

  return
end
function fpprunge ( x )

!*****************************************************************************80
!
!! FPPRUNGE evaluates the second derivative of the Runge function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 January 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real X, the argument.
!
!    Output, real FPPRUNGE, the value of the second derivative of
!    the Runge function.
!
  implicit none

  real    ( kind = 8 ) fpprunge
  real    ( kind = 8 ) x

  fpprunge = ( - 50.0D+00 + 3750.0D+00 * x * x ) &
    / ( 1.0D+00 + 25.0D+00 * x * x )**3

  return
end

      subroutine dqawfe(f,a,omega,integr,epsabs,limlst,limit,maxp1,
     *   result,abserr,neval,ier,rslst,erlst,ierlst,lst,alist,blist,
     *   rlist,elist,iord,nnlog,chebmo)
c***begin prologue  dqawfe
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a3a1
c***keywords  automatic integrator, special-purpose,
c             fourier integrals,
c             integration between zeros with dqawoe,
c             convergence acceleration with dqelg
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           dedoncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  the routine calculates an approximation result to a
c            given fourier integal
c            i = integral of f(x)*w(x) over (a,infinity)
c            where w(x)=cos(omega*x) or w(x)=sin(omega*x),
c            hopefully satisfying following claim for accuracy
c            abs(i-result).le.epsabs.
c***description
c
c        computation of fourier integrals
c        standard fortran subroutine
c        double precision version
c
c        parameters
c         on entry
c            f      - double precision
c                     function subprogram defining the integrand
c                     function f(x). the actual name for f needs to
c                     be declared e x t e r n a l in the driver program.
c
c            a      - double precision
c                     lower limit of integration
c
c            omega  - double precision
c                     parameter in the weight function
c
c            integr - integer
c                     indicates which weight function is used
c                     integr = 1      w(x) = cos(omega*x)
c                     integr = 2      w(x) = sin(omega*x)
c                     if integr.ne.1.and.integr.ne.2, the routine will
c                     end with ier = 6.
c
c            epsabs - double precision
c                     absolute accuracy requested, epsabs.gt.0
c                     if epsabs.le.0, the routine will end with ier = 6.
c
c            limlst - integer
c                     limlst gives an upper bound on the number of
c                     cycles, limlst.ge.1.
c                     if limlst.lt.3, the routine will end with ier = 6.
c
c            limit  - integer
c                     gives an upper bound on the number of subintervals
c                     allowed in the partition of each cycle, limit.ge.1
c                     each cycle, limit.ge.1.
c
c            maxp1  - integer
c                     gives an upper bound on the number of
c                     chebyshev moments which can be stored, i.e.
c                     for the intervals of lengths abs(b-a)*2**(-l),
c                     l=0,1, ..., maxp1-2, maxp1.ge.1
c
c         on return
c            result - double precision
c                     approximation to the integral x
c
c            abserr - double precision
c                     estimate of the modulus of the absolute error,
c                     which should equal or exceed abs(i-result)
c
c            neval  - integer
c                     number of integrand evaluations
c
c            ier    - ier = 0 normal and reliable termination of
c                             the routine. it is assumed that the
c                             requested accuracy has been achieved.
c                     ier.gt.0 abnormal termination of the routine. the
c                             estimates for integral and error are less
c                             reliable. it is assumed that the requested
c                             accuracy has not been achieved.
c            error messages
c                    if omega.ne.0
c                     ier = 1 maximum number of  cycles  allowed
c                             has been achieved., i.e. of subintervals
c                             (a+(k-1)c,a+kc) where
c                             c = (2*int(abs(omega))+1)*pi/abs(omega),
c                             for k = 1, 2, ..., lst.
c                             one can allow more cycles by increasing
c                             the value of limlst (and taking the
c                             according dimension adjustments into
c                             account).
c                             examine the array iwork which contains
c                             the error flags on the cycles, in order to
c                             look for eventual local integration
c                             difficulties. if the position of a local
c                             difficulty can be determined (e.g.
c                             singularity, discontinuity within the
c                             interval) one will probably gain from
c                             splitting up the interval at this point
c                             and calling appropriate integrators on
c                             the subranges.
c                         = 4 the extrapolation table constructed for
c                             convergence acceleration of the series
c                             formed by the integral contributions over
c                             the cycles, does not converge to within
c                             the requested accuracy. as in the case of
c                             ier = 1, it is advised to examine the
c                             array iwork which contains the error
c                             flags on the cycles.
c                         = 6 the input is invalid because
c                             (integr.ne.1 and integr.ne.2) or
c                              epsabs.le.0 or limlst.lt.3.
c                              result, abserr, neval, lst are set
c                              to zero.
c                         = 7 bad integrand behaviour occurs within one
c                             or more of the cycles. location and type
c                             of the difficulty involved can be
c                             determined from the vector ierlst. here
c                             lst is the number of cycles actually
c                             needed (see below).
c                             ierlst(k) = 1 the maximum number of
c                                           subdivisions (= limit) has
c                                           been achieved on the k th
c                                           cycle.
c                                       = 2 occurrence of roundoff error
c                                           is detected and prevents the
c                                           tolerance imposed on the
c                                           k th cycle, from being
c                                           achieved.
c                                       = 3 extremely bad integrand
c                                           behaviour occurs at some
c                                           points of the k th cycle.
c                                       = 4 the integration procedure
c                                           over the k th cycle does
c                                           not converge (to within the
c                                           required accuracy) due to
c                                           roundoff in the
c                                           extrapolation procedure
c                                           invoked on this cycle. it
c                                           is assumed that the result
c                                           on this interval is the
c                                           best which can be obtained.
c                                       = 5 the integral over the k th
c                                           cycle is probably divergent
c                                           or slowly convergent. it
c                                           must be noted that
c                                           divergence can occur with
c                                           any other value of
c                                           ierlst(k).
c                    if omega = 0 and integr = 1,
c                    the integral is calculated by means of dqagie
c                    and ier = ierlst(1) (with meaning as described
c                    for ierlst(k), k = 1).
c
c            rslst  - double precision
c                     vector of dimension at least limlst
c                     rslst(k) contains the integral contribution
c                     over the interval (a+(k-1)c,a+kc) where
c                     c = (2*int(abs(omega))+1)*pi/abs(omega),
c                     k = 1, 2, ..., lst.
c                     note that, if omega = 0, rslst(1) contains
c                     the value of the integral over (a,infinity).
c
c            erlst  - double precision
c                     vector of dimension at least limlst
c                     erlst(k) contains the error estimate corresponding
c                     with rslst(k).
c
c            ierlst - integer
c                     vector of dimension at least limlst
c                     ierlst(k) contains the error flag corresponding
c                     with rslst(k). for the meaning of the local error
c                     flags see description of output parameter ier.
c
c            lst    - integer
c                     number of subintervals needed for the integration
c                     if omega = 0 then lst is set to 1.
c
c            alist, blist, rlist, elist - double precision
c                     vector of dimension at least limit,
c
c            iord, nnlog - integer
c                     vector of dimension at least limit, providing
c                     space for the quantities needed in the subdivision
c                     process of each cycle
c
c            chebmo - double precision
c                     array of dimension at least (maxp1,25), providing
c                     space for the chebyshev moments needed within the
c                     cycles
c
c***references  (none)
c***routines called  d1mach,dqagie,dqawoe,dqelg
c***end prologue  dqawfe
c
      double precision a,abseps,abserr,alist,blist,chebmo,correc,cycle,
     *  c1,c2,dabs,dl,dla,dmax1,drl,d1mach,elist,erlst,ep,eps,epsa,
     *  epsabs,errsum,f,fact,omega,p,pi,p1,psum,reseps,result,res3la,
     *  rlist,rslst,uflow
      integer ier,ierlst,integr,iord,ktmin,l,last,lst,limit,limlst,ll,
     *    maxp1,momcom,nev,neval,nnlog,nres,numrl2
c
      dimension alist(limit),blist(limit),chebmo(maxp1,25),elist(limit),
     *  erlst(limlst),ierlst(limlst),iord(limit),nnlog(limit),psum(52),
     *  res3la(3),rlist(limit),rslst(limlst)
c
      external f
c
c
c            the dimension of  psum  is determined by the value of
c            limexp in subroutine dqelg (psum must be of dimension
c            (limexp+2) at least).
c
c           list of major variables
c           -----------------------
c
c           c1, c2    - end points of subinterval (of length cycle)
c           cycle     - (2*int(abs(omega))+1)*pi/abs(omega)
c           psum      - vector of dimension at least (limexp+2)
c                       (see routine dqelg)
c                       psum contains the part of the epsilon table
c                       which is still needed for further computations.
c                       each element of psum is a partial sum of the
c                       series which should sum to the value of the
c                       integral.
c           errsum    - sum of error estimates over the subintervals,
c                       calculated cumulatively
c           epsa      - absolute tolerance requested over current
c                       subinterval
c           chebmo    - array containing the modified chebyshev
c                       moments (see also routine dqc25f)
c
      data p/0.9d+00/
      data pi / 3.1415926535 8979323846 2643383279 50 d0 /
c
c           test on validity of parameters
c           ------------------------------
c
c***first executable statement  dqawfe
      result = 0.0d+00
      abserr = 0.0d+00
      neval = 0
      lst = 0
      ier = 0
      if((integr.ne.1.and.integr.ne.2).or.epsabs.le.0.0d+00.or.
     *  limlst.lt.3) ier = 6
      if(ier.eq.6) go to 999
      if(omega.ne.0.0d+00) go to 10
c
c           integration by dqagie if omega is zero
c           --------------------------------------
c
      if(integr.eq.1) call dqagie(f,0.0d+00,1,epsabs,0.0d+00,limit,
     *  result,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
      rslst(1) = result
      erlst(1) = abserr
      ierlst(1) = ier
      lst = 1
      go to 999
c
c           initializations
c           ---------------
c
   10 l = dabs(omega)
      dl = 2*l+1
      cycle = dl*pi/dabs(omega)
      ier = 0
      ktmin = 0
      neval = 0
      numrl2 = 0
      nres = 0
      c1 = a
      c2 = cycle+a
      p1 = 0.1d+01-p
      uflow = d1mach(1)
      eps = epsabs
      if(epsabs.gt.uflow/p1) eps = epsabs*p1
      ep = eps
      fact = 0.1d+01
      correc = 0.0d+00
      abserr = 0.0d+00
      errsum = 0.0d+00
c
c           main do-loop
c           ------------
c
      do 50 lst = 1,limlst
c
c           integrate over current subinterval.
c
        dla = lst
        epsa = eps*fact
        call dqawoe(f,c1,c2,omega,integr,epsa,0.0d+00,limit,lst,maxp1,
     *  rslst(lst),erlst(lst),nev,ierlst(lst),last,alist,blist,rlist,
     *  elist,iord,nnlog,momcom,chebmo)
        neval = neval+nev
        fact = fact*p
        errsum = errsum+erlst(lst)
        drl = 0.5d+02*dabs(rslst(lst))
c
c           test on accuracy with partial sum
c
        if((errsum+drl).le.epsabs.and.lst.ge.6) go to 80
        correc = dmax1(correc,erlst(lst))
        if(ierlst(lst).ne.0) eps = dmax1(ep,correc*p1)
        if(ierlst(lst).ne.0) ier = 7
        if(ier.eq.7.and.(errsum+drl).le.correc*0.1d+02.and.
     *  lst.gt.5) go to 80
        numrl2 = numrl2+1
        if(lst.gt.1) go to 20
        psum(1) = rslst(1)
        go to 40
   20   psum(numrl2) = psum(ll)+rslst(lst)
        if(lst.eq.2) go to 40
c
c           test on maximum number of subintervals
c
        if(lst.eq.limlst) ier = 1
c
c           perform new extrapolation
c
        call dqelg(numrl2,psum,reseps,abseps,res3la,nres)
c
c           test whether extrapolated result is influenced by roundoff
c
        ktmin = ktmin+1
        if(ktmin.ge.15.and.abserr.le.0.1d-02*(errsum+drl)) ier = 4
        if(abseps.gt.abserr.and.lst.ne.3) go to 30
        abserr = abseps
        result = reseps
        ktmin = 0
c
c           if ier is not 0, check whether direct result (partial sum)
c           or extrapolated result yields the best integral
c           approximation
c
        if((abserr+0.1d+02*correc).le.epsabs.or.
     *  (abserr.le.epsabs.and.0.1d+02*correc.ge.epsabs)) go to 60
   30   if(ier.ne.0.and.ier.ne.7) go to 60
   40   ll = numrl2
        c1 = c2
        c2 = c2+cycle
   50 continue
c
c         set final result and error estimate
c         -----------------------------------
c
   60 abserr = abserr+0.1d+02*correc
      if(ier.eq.0) go to 999
      if(result.ne.0.0d+00.and.psum(numrl2).ne.0.0d+00) go to 70
      if(abserr.gt.errsum) go to 80
      if(psum(numrl2).eq.0.0d+00) go to 999
   70 if(abserr/dabs(result).gt.(errsum+drl)/dabs(psum(numrl2)))
     *  go to 80
      if(ier.ge.1.and.ier.ne.7) abserr = abserr+drl
      go to 999
   80 result = psum(numrl2)
      abserr = errsum+drl
  999 return
      end
      subroutine dqagie(f,bound,inf,epsabs,epsrel,limit,result,abserr,
     *   neval,ier,alist,blist,rlist,elist,iord,last)
c***begin prologue  dqagie
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a3a1,h2a4a1
c***keywords  automatic integrator, infinite intervals,
c             general-purpose, transformation, extrapolation,
c             globally adaptive
c***author  piessens,robert,appl. math & progr. div - k.u.leuven
c           de doncker,elise,appl. math & progr. div - k.u.leuven
c***purpose  the routine calculates an approximation result to a given
c            integral   i = integral of f over (bound,+infinity)
c            or i = integral of f over (-infinity,bound)
c            or i = integral of f over (-infinity,+infinity),
c            hopefully satisfying following claim for accuracy
c            abs(i-result).le.max(epsabs,epsrel*abs(i))
c***description
c
c integration over infinite intervals
c standard fortran subroutine
c
c            f      - double precision
c                     function subprogram defining the integrand
c                     function f(x). the actual name for f needs to be
c                     declared e x t e r n a l in the driver program.
c
c            bound  - double precision
c                     finite bound of integration range
c                     (has no meaning if interval is doubly-infinite)
c
c            inf    - double precision
c                     indicating the kind of integration range involved
c                     inf = 1 corresponds to  (bound,+infinity),
c                     inf = -1            to  (-infinity,bound),
c                     inf = 2             to (-infinity,+infinity).
c
c            epsabs - double precision
c                     absolute accuracy requested
c            epsrel - double precision
c                     relative accuracy requested
c                     if  epsabs.le.0
c                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                     the routine will end with ier = 6.
c
c            limit  - integer
c                     gives an upper bound on the number of subintervals
c                     in the partition of (a,b), limit.ge.1
c
c         on return
c            result - double precision
c                     approximation to the integral
c
c            abserr - double precision
c                     estimate of the modulus of the absolute error,
c                     which should equal or exceed abs(i-result)
c
c            neval  - integer
c                     number of integrand evaluations
c
c            ier    - integer
c                     ier = 0 normal and reliable termination of the
c                             routine. it is assumed that the requested
c                             accuracy has been achieved.
c                   - ier.gt.0 abnormal termination of the routine. the
c                             estimates for result and error are less
c                             reliable. it is assumed that the requested
c                             accuracy has not been achieved.
c            error messages
c                     ier = 1 maximum number of subdivisions allowed
c                             has been achieved. one can allow more
c                             subdivisions by increasing the value of
c                             limit (and taking the according dimension
c                             adjustments into account). however,if
c                             this yields no improvement it is advised
c                             to analyze the integrand in order to
c                             determine the integration difficulties.
c                             if the position of a local difficulty can
c                             be determined (e.g. singularity,
c                             discontinuity within the interval) one
c                             will probably gain from splitting up the
c                             interval at this point and calling the
c                             integrator on the subranges. if possible,
c                             an appropriate special-purpose integrator
c                             should be used, which is designed for
c                             handling the type of difficulty involved.
c                         = 2 the occurrence of roundoff error is
c                             detected, which prevents the requested
c                             tolerance from being achieved.
c                             the error may be under-estimated.
c                         = 3 extremely bad integrand behaviour occurs
c                             at some points of the integration
c                             interval.
c                         = 4 the algorithm does not converge.
c                             roundoff error is detected in the
c                             extrapolation table.
c                             it is assumed that the requested tolerance
c                             cannot be achieved, and that the returned
c                             result is the best which can be obtained.
c                         = 5 the integral is probably divergent, or
c                             slowly convergent. it must be noted that
c                             divergence can occur with any other value
c                             of ier.
c                         = 6 the input is invalid, because
c                             (epsabs.le.0 and
c                              epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                             result, abserr, neval, last, rlist(1),
c                             elist(1) and iord(1) are set to zero.
c                             alist(1) and blist(1) are set to 0
c                             and 1 respectively.
c
c            alist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the left
c                     end points of the subintervals in the partition
c                     of the transformed integration range (0,1).
c
c            blist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the right
c                     end points of the subintervals in the partition
c                     of the transformed integration range (0,1).
c
c            rlist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the integral
c                     approximations on the subintervals
c
c            elist  - double precision
c                     vector of dimension at least limit,  the first
c                     last elements of which are the moduli of the
c                     absolute error estimates on the subintervals
c
c            iord   - integer
c                     vector of dimension limit, the first k
c                     elements of which are pointers to the
c                     error estimates over the subintervals,
c                     such that elist(iord(1)), ..., elist(iord(k))
c                     form a decreasing sequence, with k = last
c                     if last.le.(limit/2+2), and k = limit+1-last
c                     otherwise
c
c            last   - integer
c                     number of subintervals actually produced
c                     in the subdivision process
c
c***references  (none)
c***routines called  d1mach,dqelg,dqk15i,dqpsrt
c***end prologue  dqagie
      double precision abseps,abserr,alist,area,area1,area12,area2,a1,
     *  a2,blist,boun,bound,b1,b2,correc,dabs,defabs,defab1,defab2,
     *  dmax1,dres,d1mach,elist,epmach,epsabs,epsrel,erlarg,erlast,
     *  errbnd,errmax,error1,error2,erro12,errsum,ertest,f,oflow,resabs,
     *  reseps,result,res3la,rlist,rlist2,small,uflow
      integer id,ier,ierro,inf,iord,iroff1,iroff2,iroff3,jupbnd,k,ksgn,
     *  ktmin,last,limit,maxerr,neval,nres,nrmax,numrl2
      logical extrap,noext
c
      dimension alist(limit),blist(limit),elist(limit),iord(limit),
     *  res3la(3),rlist(limit),rlist2(52)
c
      external f
c
c            the dimension of rlist2 is determined by the value of
c            limexp in subroutine dqelg.
c
c
c            list of major variables
c            -----------------------
c
c           alist     - list of left end points of all subintervals
c                       considered up to now
c           blist     - list of right end points of all subintervals
c                       considered up to now
c           rlist(i)  - approximation to the integral over
c                       (alist(i),blist(i))
c           rlist2    - array of dimension at least (limexp+2),
c                       containing the part of the epsilon table
c                       wich is still needed for further computations
c           elist(i)  - error estimate applying to rlist(i)
c           maxerr    - pointer to the interval with largest error
c                       estimate
c           errmax    - elist(maxerr)
c           erlast    - error on the interval currently subdivided
c                       (before that subdivision has taken place)
c           area      - sum of the integrals over the subintervals
c           errsum    - sum of the errors over the subintervals
c           errbnd    - requested accuracy max(epsabs,epsrel*
c                       abs(result))
c           *****1    - variable for the left subinterval
c           *****2    - variable for the right subinterval
c           last      - index for subdivision
c           nres      - number of calls to the extrapolation routine
c           numrl2    - number of elements currently in rlist2. if an
c                       appropriate approximation to the compounded
c                       integral has been obtained, it is put in
c                       rlist2(numrl2) after numrl2 has been increased
c                       by one.
c           small     - length of the smallest interval considered up
c                       to now, multiplied by 1.5
c           erlarg    - sum of the errors over the intervals larger
c                       than the smallest interval considered up to now
c           extrap    - logical variable denoting that the routine
c                       is attempting to perform extrapolation. i.e.
c                       before subdividing the smallest interval we
c                       try to decrease the value of erlarg.
c           noext     - logical variable denoting that extrapolation
c                       is no longer allowed (true-value)
c
c            machine dependent constants
c            ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c           oflow is the largest positive magnitude.
c
c***first executable statement  dqagie
       epmach = d1mach(4)
c
c           test on validity of parameters
c           -----------------------------
c
      ier = 0
      neval = 0
      last = 0
      result = 0.0d+00
      abserr = 0.0d+00
      alist(1) = 0.0d+00
      blist(1) = 0.1d+01
      rlist(1) = 0.0d+00
      elist(1) = 0.0d+00
      iord(1) = 0
      if(epsabs.le.0.0d+00.and.epsrel.lt.dmax1(0.5d+02*epmach,0.5d-28))
     *  ier = 6
       if(ier.eq.6) go to 999
c
c
c           first approximation to the integral
c           -----------------------------------
c
c           determine the interval to be mapped onto (0,1).
c           if inf = 2 the integral is computed as i = i1+i2, where
c           i1 = integral of f over (-infinity,0),
c           i2 = integral of f over (0,+infinity).
c
      boun = bound
      if(inf.eq.2) boun = 0.0d+00
      call dqk15i(f,boun,inf,0.0d+00,0.1d+01,result,abserr,
     *  defabs,resabs)
c
c           test on accuracy
c
      last = 1
      rlist(1) = result
      elist(1) = abserr
      iord(1) = 1
      dres = dabs(result)
      errbnd = dmax1(epsabs,epsrel*dres)
      if(abserr.le.1.0d+02*epmach*defabs.and.abserr.gt.errbnd) ier = 2
      if(limit.eq.1) ier = 1
      if(ier.ne.0.or.(abserr.le.errbnd.and.abserr.ne.resabs).or.
     *  abserr.eq.0.0d+00) go to 130
c
c           initialization
c           --------------
c
      uflow = d1mach(1)
      oflow = d1mach(2)
      rlist2(1) = result
      errmax = abserr
      maxerr = 1
      area = result
      errsum = abserr
      abserr = oflow
      nrmax = 1
      nres = 0
      ktmin = 0
      numrl2 = 2
      extrap = .false.
      noext = .false.
      ierro = 0
      iroff1 = 0
      iroff2 = 0
      iroff3 = 0
      ksgn = -1
      if(dres.ge.(0.1d+01-0.5d+02*epmach)*defabs) ksgn = 1
c
c           main do-loop
c           ------------
c
      do 90 last = 2,limit
c
c           bisect the subinterval with nrmax-th largest error estimate.
c
        a1 = alist(maxerr)
        b1 = 0.5d+00*(alist(maxerr)+blist(maxerr))
        a2 = b1
        b2 = blist(maxerr)
        erlast = errmax
        call dqk15i(f,boun,inf,a1,b1,area1,error1,resabs,defab1)
        call dqk15i(f,boun,inf,a2,b2,area2,error2,resabs,defab2)
c
c           improve previous approximations to integral
c           and error and test for accuracy.
c
        area12 = area1+area2
        erro12 = error1+error2
        errsum = errsum+erro12-errmax
        area = area+area12-rlist(maxerr)
        if(defab1.eq.error1.or.defab2.eq.error2)go to 15
        if(dabs(rlist(maxerr)-area12).gt.0.1d-04*dabs(area12)
     *  .or.erro12.lt.0.99d+00*errmax) go to 10
        if(extrap) iroff2 = iroff2+1
        if(.not.extrap) iroff1 = iroff1+1
   10   if(last.gt.10.and.erro12.gt.errmax) iroff3 = iroff3+1
   15   rlist(maxerr) = area1
        rlist(last) = area2
        errbnd = dmax1(epsabs,epsrel*dabs(area))
c
c           test for roundoff error and eventually set error flag.
c
        if(iroff1+iroff2.ge.10.or.iroff3.ge.20) ier = 2
        if(iroff2.ge.5) ierro = 3
c
c           set error flag in the case that the number of
c           subintervals equals limit.
c
        if(last.eq.limit) ier = 1
c
c           set error flag in the case of bad integrand behaviour
c           at some points of the integration range.
c
        if(dmax1(dabs(a1),dabs(b2)).le.(0.1d+01+0.1d+03*epmach)*
     *  (dabs(a2)+0.1d+04*uflow)) ier = 4
c
c           append the newly-created intervals to the list.
c
        if(error2.gt.error1) go to 20
        alist(last) = a2
        blist(maxerr) = b1
        blist(last) = b2
        elist(maxerr) = error1
        elist(last) = error2
        go to 30
   20   alist(maxerr) = a2
        alist(last) = a1
        blist(last) = b1
        rlist(maxerr) = area2
        rlist(last) = area1
        elist(maxerr) = error2
        elist(last) = error1
c
c           call subroutine dqpsrt to maintain the descending ordering
c           in the list of error estimates and select the subinterval
c           with nrmax-th largest error estimate (to be bisected next).
c
   30   call dqpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
        if(errsum.le.errbnd) go to 115
        if(ier.ne.0) go to 100
        if(last.eq.2) go to 80
        if(noext) go to 90
        erlarg = erlarg-erlast
        if(dabs(b1-a1).gt.small) erlarg = erlarg+erro12
        if(extrap) go to 40
c
c           test whether the interval to be bisected next is the
c           smallest interval.
c
        if(dabs(blist(maxerr)-alist(maxerr)).gt.small) go to 90
        extrap = .true.
        nrmax = 2
   40   if(ierro.eq.3.or.erlarg.le.ertest) go to 60
c
c           the smallest interval has the largest error.
c           before bisecting decrease the sum of the errors over the
c           larger intervals (erlarg) and perform extrapolation.
c
        id = nrmax
        jupbnd = last
        if(last.gt.(2+limit/2)) jupbnd = limit+3-last
        do 50 k = id,jupbnd
          maxerr = iord(nrmax)
          errmax = elist(maxerr)
          if(dabs(blist(maxerr)-alist(maxerr)).gt.small) go to 90
          nrmax = nrmax+1
   50   continue
c
c           perform extrapolation.
c
   60   numrl2 = numrl2+1
        rlist2(numrl2) = area
        call dqelg(numrl2,rlist2,reseps,abseps,res3la,nres)
        ktmin = ktmin+1
        if(ktmin.gt.5.and.abserr.lt.0.1d-02*errsum) ier = 5
        if(abseps.ge.abserr) go to 70
        ktmin = 0
        abserr = abseps
        result = reseps
        correc = erlarg
        ertest = dmax1(epsabs,epsrel*dabs(reseps))
        if(abserr.le.ertest) go to 100
c
c            prepare bisection of the smallest interval.
c
   70   if(numrl2.eq.1) noext = .true.
        if(ier.eq.5) go to 100
        maxerr = iord(1)
        errmax = elist(maxerr)
        nrmax = 1
        extrap = .false.
        small = small*0.5d+00
        erlarg = errsum
        go to 90
   80   small = 0.375d+00
        erlarg = errsum
        ertest = errbnd
        rlist2(2) = area
   90 continue
c
c           set final result and error estimate.
c           ------------------------------------
c
  100 if(abserr.eq.oflow) go to 115
      if((ier+ierro).eq.0) go to 110
      if(ierro.eq.3) abserr = abserr+correc
      if(ier.eq.0) ier = 3
      if(result.ne.0.0d+00.and.area.ne.0.0d+00)go to 105
      if(abserr.gt.errsum)go to 115
      if(area.eq.0.0d+00) go to 130
      go to 110
  105 if(abserr/dabs(result).gt.errsum/dabs(area))go to 115
c
c           test on divergence
c
  110 if(ksgn.eq.(-1).and.dmax1(dabs(result),dabs(area)).le.
     * defabs*0.1d-01) go to 130
      if(0.1d-01.gt.(result/area).or.(result/area).gt.0.1d+03.
     *or.errsum.gt.dabs(area)) ier = 6
      go to 130
c
c           compute global integral sum.
c
  115 result = 0.0d+00
      do 120 k = 1,last
        result = result+rlist(k)
  120 continue
      abserr = errsum
  130 neval = 30*last-15
      if(inf.eq.2) neval = 2*neval
      if(ier.gt.2) ier=ier-1
  999 return
      end
      subroutine dqawoe (f,a,b,omega,integr,epsabs,epsrel,limit,icall,
     *  maxp1,result,abserr,neval,ier,last,alist,blist,rlist,elist,iord,
     *   nnlog,momcom,chebmo)
c***begin prologue  dqawoe
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a2a1
c***keywords  automatic integrator, special-purpose,
c             integrand with oscillatory cos or sin factor,
c             clenshaw-curtis method, (end point) singularities,
c             extrapolation, globally adaptive
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  the routine calculates an approximation result to a given
c            definite integral
c            i = integral of f(x)*w(x) over (a,b)
c            where w(x) = cos(omega*x) or w(x)=sin(omega*x),
c            hopefully satisfying following claim for accuracy
c            abs(i-result).le.max(epsabs,epsrel*abs(i)).
c***description
c
c        computation of oscillatory integrals
c        standard fortran subroutine
c        double precision version
c
c        parameters
c         on entry
c            f      - double precision
c                     function subprogram defining the integrand
c                     function f(x). the actual name for f needs to be
c                     declared e x t e r n a l in the driver program.
c
c            a      - double precision
c                     lower limit of integration
c
c            b      - double precision
c                     upper limit of integration
c
c            omega  - double precision
c                     parameter in the integrand weight function
c
c            integr - integer
c                     indicates which of the weight functions is to be
c                     used
c                     integr = 1      w(x) = cos(omega*x)
c                     integr = 2      w(x) = sin(omega*x)
c                     if integr.ne.1 and integr.ne.2, the routine
c                     will end with ier = 6.
c
c            epsabs - double precision
c                     absolute accuracy requested
c            epsrel - double precision
c                     relative accuracy requested
c                     if  epsabs.le.0
c                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                     the routine will end with ier = 6.
c
c            limit  - integer
c                     gives an upper bound on the number of subdivisions
c                     in the partition of (a,b), limit.ge.1.
c
c            icall  - integer
c                     if dqawoe is to be used only once, icall must
c                     be set to 1.  assume that during this call, the
c                     chebyshev moments (for clenshaw-curtis integration
c                     of degree 24) have been computed for intervals of
c                     lenghts (abs(b-a))*2**(-l), l=0,1,2,...momcom-1.
c                     if icall.gt.1 this means that dqawoe has been
c                     called twice or more on intervals of the same
c                     length abs(b-a). the chebyshev moments already
c                     computed are then re-used in subsequent calls.
c                     if icall.lt.1, the routine will end with ier = 6.
c
c            maxp1  - integer
c                     gives an upper bound on the number of chebyshev
c                     moments which can be stored, i.e. for the
c                     intervals of lenghts abs(b-a)*2**(-l),
c                     l=0,1, ..., maxp1-2, maxp1.ge.1.
c                     if maxp1.lt.1, the routine will end with ier = 6.
c
c         on return
c            result - double precision
c                     approximation to the integral
c
c            abserr - double precision
c                     estimate of the modulus of the absolute error,
c                     which should equal or exceed abs(i-result)
c
c            neval  - integer
c                     number of integrand evaluations
c
c            ier    - integer
c                     ier = 0 normal and reliable termination of the
c                             routine. it is assumed that the
c                             requested accuracy has been achieved.
c                   - ier.gt.0 abnormal termination of the routine.
c                             the estimates for integral and error are
c                             less reliable. it is assumed that the
c                             requested accuracy has not been achieved.
c            error messages
c                     ier = 1 maximum number of subdivisions allowed
c                             has been achieved. one can allow more
c                             subdivisions by increasing the value of
c                             limit (and taking according dimension
c                             adjustments into account). however, if
c                             this yields no improvement it is advised
c                             to analyze the integrand, in order to
c                             determine the integration difficulties.
c                             if the position of a local difficulty can
c                             be determined (e.g. singularity,
c                             discontinuity within the interval) one
c                             will probably gain from splitting up the
c                             interval at this point and calling the
c                             integrator on the subranges. if possible,
c                             an appropriate special-purpose integrator
c                             should be used which is designed for
c                             handling the type of difficulty involved.
c                         = 2 the occurrence of roundoff error is
c                             detected, which prevents the requested
c                             tolerance from being achieved.
c                             the error may be under-estimated.
c                         = 3 extremely bad integrand behaviour occurs
c                             at some points of the integration
c                             interval.
c                         = 4 the algorithm does not converge.
c                             roundoff error is detected in the
c                             extrapolation table.
c                             it is presumed that the requested
c                             tolerance cannot be achieved due to
c                             roundoff in the extrapolation table,
c                             and that the returned result is the
c                             best which can be obtained.
c                         = 5 the integral is probably divergent, or
c                             slowly convergent. it must be noted that
c                             divergence can occur with any other value
c                             of ier.gt.0.
c                         = 6 the input is invalid, because
c                             (epsabs.le.0 and
c                              epsrel.lt.max(50*rel.mach.acc.,0.5d-28))
c                             or (integr.ne.1 and integr.ne.2) or
c                             icall.lt.1 or maxp1.lt.1.
c                             result, abserr, neval, last, rlist(1),
c                             elist(1), iord(1) and nnlog(1) are set
c                             to zero. alist(1) and blist(1) are set
c                             to a and b respectively.
c
c            last  -  integer
c                     on return, last equals the number of
c                     subintervals produces in the subdivision
c                     process, which determines the number of
c                     significant elements actually in the
c                     work arrays.
c            alist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the left
c                     end points of the subintervals in the partition
c                     of the given integration range (a,b)
c
c            blist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the right
c                     end points of the subintervals in the partition
c                     of the given integration range (a,b)
c
c            rlist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the integral
c                     approximations on the subintervals
c
c            elist  - double precision
c                     vector of dimension at least limit, the first
c                      last  elements of which are the moduli of the
c                     absolute error estimates on the subintervals
c
c            iord   - integer
c                     vector of dimension at least limit, the first k
c                     elements of which are pointers to the error
c                     estimates over the subintervals,
c                     such that elist(iord(1)), ...,
c                     elist(iord(k)) form a decreasing sequence, with
c                     k = last if last.le.(limit/2+2), and
c                     k = limit+1-last otherwise.
c
c            nnlog  - integer
c                     vector of dimension at least limit, containing the
c                     subdivision levels of the subintervals, i.e.
c                     iwork(i) = l means that the subinterval
c                     numbered i is of length abs(b-a)*2**(1-l)
c
c         on entry and return
c            momcom - integer
c                     indicating that the chebyshev moments
c                     have been computed for intervals of lengths
c                     (abs(b-a))*2**(-l), l=0,1,2, ..., momcom-1,
c                     momcom.lt.maxp1
c
c            chebmo - double precision
c                     array of dimension (maxp1,25) containing the
c                     chebyshev moments
c
c***references  (none)
c***routines called  d1mach,dqc25f,dqelg,dqpsrt
c***end prologue  dqawoe
c
      double precision a,abseps,abserr,alist,area,area1,area12,area2,a1,
     *  a2,b,blist,b1,b2,chebmo,correc,dabs,defab1,defab2,defabs,dmax1,
     *  domega,d1mach,dres,elist,epmach,epsabs,epsrel,erlarg,erlast,
     *  errbnd,errmax,error1,erro12,error2,errsum,ertest,f,oflow,
     *  omega,resabs,reseps,result,res3la,rlist,rlist2,small,uflow,width
      integer icall,id,ier,ierro,integr,iord,iroff1,iroff2,iroff3,
     *  jupbnd,k,ksgn,ktmin,last,limit,maxerr,maxp1,momcom,nev,neval,
     *  nnlog,nres,nrmax,nrmom,numrl2
      logical extrap,noext,extall
c
      dimension alist(limit),blist(limit),rlist(limit),elist(limit),
     *  iord(limit),rlist2(52),res3la(3),chebmo(maxp1,25),nnlog(limit)
c
      external f
c
c            the dimension of rlist2 is determined by  the value of
c            limexp in subroutine dqelg (rlist2 should be of
c            dimension (limexp+2) at least).
c
c            list of major variables
c            -----------------------
c
c           alist     - list of left end points of all subintervals
c                       considered up to now
c           blist     - list of right end points of all subintervals
c                       considered up to now
c           rlist(i)  - approximation to the integral over
c                       (alist(i),blist(i))
c           rlist2    - array of dimension at least limexp+2
c                       containing the part of the epsilon table
c                       which is still needed for further computations
c           elist(i)  - error estimate applying to rlist(i)
c           maxerr    - pointer to the interval with largest
c                       error estimate
c           errmax    - elist(maxerr)
c           erlast    - error on the interval currently subdivided
c           area      - sum of the integrals over the subintervals
c           errsum    - sum of the errors over the subintervals
c           errbnd    - requested accuracy max(epsabs,epsrel*
c                       abs(result))
c           *****1    - variable for the left subinterval
c           *****2    - variable for the right subinterval
c           last      - index for subdivision
c           nres      - number of calls to the extrapolation routine
c           numrl2    - number of elements in rlist2. if an appropriate
c                       approximation to the compounded integral has
c                       been obtained it is put in rlist2(numrl2) after
c                       numrl2 has been increased by one
c           small     - length of the smallest interval considered
c                       up to now, multiplied by 1.5
c           erlarg    - sum of the errors over the intervals larger
c                       than the smallest interval considered up to now
c           extrap    - logical variable denoting that the routine is
c                       attempting to perform extrapolation, i.e. before
c                       subdividing the smallest interval we try to
c                       decrease the value of erlarg
c           noext     - logical variable denoting that extrapolation
c                       is no longer allowed (true  value)
c
c            machine dependent constants
c            ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c           oflow is the largest positive magnitude.
c
c***first executable statement  dqawoe
      epmach = d1mach(4)
c
c         test on validity of parameters
c         ------------------------------
c
      ier = 0
      neval = 0
      last = 0
      result = 0.0d+00
      abserr = 0.0d+00
      alist(1) = a
      blist(1) = b
      rlist(1) = 0.0d+00
      elist(1) = 0.0d+00
      iord(1) = 0
      nnlog(1) = 0
      if((integr.ne.1.and.integr.ne.2).or.(epsabs.le.0.0d+00.and.
     *  epsrel.lt.dmax1(0.5d+02*epmach,0.5d-28)).or.icall.lt.1.or.
     *  maxp1.lt.1) ier = 6
      if(ier.eq.6) go to 999
c
c           first approximation to the integral
c           -----------------------------------
c
      domega = dabs(omega)
      nrmom = 0
      if (icall.gt.1) go to 5
      momcom = 0
    5 call dqc25f(f,a,b,domega,integr,nrmom,maxp1,0,result,abserr,
     *  neval,defabs,resabs,momcom,chebmo)
c
c           test on accuracy.
c
      dres = dabs(result)
      errbnd = dmax1(epsabs,epsrel*dres)
      rlist(1) = result
      elist(1) = abserr
      iord(1) = 1
      if(abserr.le.0.1d+03*epmach*defabs.and.abserr.gt.errbnd) ier = 2
      if(limit.eq.1) ier = 1
      if(ier.ne.0.or.abserr.le.errbnd) go to 200
c
c           initializations
c           ---------------
c
      uflow = d1mach(1)
      oflow = d1mach(2)
      errmax = abserr
      maxerr = 1
      area = result
      errsum = abserr
      abserr = oflow
      nrmax = 1
      extrap = .false.
      noext = .false.
      ierro = 0
      iroff1 = 0
      iroff2 = 0
      iroff3 = 0
      ktmin = 0
      small = dabs(b-a)*0.75d+00
      nres = 0
      numrl2 = 0
      extall = .false.
      if(0.5d+00*dabs(b-a)*domega.gt.0.2d+01) go to 10
      numrl2 = 1
      extall = .true.
      rlist2(1) = result
   10 if(0.25d+00*dabs(b-a)*domega.le.0.2d+01) extall = .true.
      ksgn = -1
      if(dres.ge.(0.1d+01-0.5d+02*epmach)*defabs) ksgn = 1
c
c           main do-loop
c           ------------
c
      do 140 last = 2,limit
c
c           bisect the subinterval with the nrmax-th largest
c           error estimate.
c
        nrmom = nnlog(maxerr)+1
        a1 = alist(maxerr)
        b1 = 0.5d+00*(alist(maxerr)+blist(maxerr))
        a2 = b1
        b2 = blist(maxerr)
        erlast = errmax
        call dqc25f(f,a1,b1,domega,integr,nrmom,maxp1,0,
     *  area1,error1,nev,resabs,defab1,momcom,chebmo)
        neval = neval+nev
        call dqc25f(f,a2,b2,domega,integr,nrmom,maxp1,1,
     *  area2,error2,nev,resabs,defab2,momcom,chebmo)
        neval = neval+nev
c
c           improve previous approximations to integral
c           and error and test for accuracy.
c
        area12 = area1+area2
        erro12 = error1+error2
        errsum = errsum+erro12-errmax
        area = area+area12-rlist(maxerr)
        if(defab1.eq.error1.or.defab2.eq.error2) go to 25
        if(dabs(rlist(maxerr)-area12).gt.0.1d-04*dabs(area12)
     *  .or.erro12.lt.0.99d+00*errmax) go to 20
        if(extrap) iroff2 = iroff2+1
        if(.not.extrap) iroff1 = iroff1+1
   20   if(last.gt.10.and.erro12.gt.errmax) iroff3 = iroff3+1
   25   rlist(maxerr) = area1
        rlist(last) = area2
        nnlog(maxerr) = nrmom
        nnlog(last) = nrmom
        errbnd = dmax1(epsabs,epsrel*dabs(area))
c
c           test for roundoff error and eventually set error flag.
c
        if(iroff1+iroff2.ge.10.or.iroff3.ge.20) ier = 2
        if(iroff2.ge.5) ierro = 3
c
c           set error flag in the case that the number of
c           subintervals equals limit.
c
        if(last.eq.limit) ier = 1
c
c           set error flag in the case of bad integrand behaviour
c           at a point of the integration range.
c
        if(dmax1(dabs(a1),dabs(b2)).le.(0.1d+01+0.1d+03*epmach)
     *  *(dabs(a2)+0.1d+04*uflow)) ier = 4
c
c           append the newly-created intervals to the list.
c
        if(error2.gt.error1) go to 30
        alist(last) = a2
        blist(maxerr) = b1
        blist(last) = b2
        elist(maxerr) = error1
        elist(last) = error2
        go to 40
   30   alist(maxerr) = a2
        alist(last) = a1
        blist(last) = b1
        rlist(maxerr) = area2
        rlist(last) = area1
        elist(maxerr) = error2
        elist(last) = error1
c
c           call subroutine dqpsrt to maintain the descending ordering
c           in the list of error estimates and select the subinterval
c           with nrmax-th largest error estimate (to bisected next).
c
   40   call dqpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
c ***jump out of do-loop
      if(errsum.le.errbnd) go to 170
      if(ier.ne.0) go to 150
        if(last.eq.2.and.extall) go to 120
        if(noext) go to 140
        if(.not.extall) go to 50
        erlarg = erlarg-erlast
        if(dabs(b1-a1).gt.small) erlarg = erlarg+erro12
        if(extrap) go to 70
c
c           test whether the interval to be bisected next is the
c           smallest interval.
c
   50   width = dabs(blist(maxerr)-alist(maxerr))
        if(width.gt.small) go to 140
        if(extall) go to 60
c
c           test whether we can start with the extrapolation procedure
c           (we do this if we integrate over the next interval with
c           use of a gauss-kronrod rule - see subroutine dqc25f).
c
        small = small*0.5d+00
        if(0.25d+00*width*domega.gt.0.2d+01) go to 140
        extall = .true.
        go to 130
   60   extrap = .true.
        nrmax = 2
   70   if(ierro.eq.3.or.erlarg.le.ertest) go to 90
c
c           the smallest interval has the largest error.
c           before bisecting decrease the sum of the errors over
c           the larger intervals (erlarg) and perform extrapolation.
c
        jupbnd = last
        if (last.gt.(limit/2+2)) jupbnd = limit+3-last
        id = nrmax
        do 80 k = id,jupbnd
          maxerr = iord(nrmax)
          errmax = elist(maxerr)
          if(dabs(blist(maxerr)-alist(maxerr)).gt.small) go to 140
          nrmax = nrmax+1
   80   continue
c
c           perform extrapolation.
c
   90   numrl2 = numrl2+1
        rlist2(numrl2) = area
        if(numrl2.lt.3) go to 110
        call dqelg(numrl2,rlist2,reseps,abseps,res3la,nres)
        ktmin = ktmin+1
        if(ktmin.gt.5.and.abserr.lt.0.1d-02*errsum) ier = 5
        if(abseps.ge.abserr) go to 100
        ktmin = 0
        abserr = abseps
        result = reseps
        correc = erlarg
        ertest = dmax1(epsabs,epsrel*dabs(reseps))
c ***jump out of do-loop
        if(abserr.le.ertest) go to 150
c
c           prepare bisection of the smallest interval.
c
  100   if(numrl2.eq.1) noext = .true.
        if(ier.eq.5) go to 150
  110   maxerr = iord(1)
        errmax = elist(maxerr)
        nrmax = 1
        extrap = .false.
        small = small*0.5d+00
        erlarg = errsum
        go to 140
  120   small = small*0.5d+00
        numrl2 = numrl2+1
        rlist2(numrl2) = area
  130   ertest = errbnd
        erlarg = errsum
  140 continue
c
c           set the final result.
c           ---------------------
c
  150 if(abserr.eq.oflow.or.nres.eq.0) go to 170
      if(ier+ierro.eq.0) go to 165
      if(ierro.eq.3) abserr = abserr+correc
      if(ier.eq.0) ier = 3
      if(result.ne.0.0d+00.and.area.ne.0.0d+00) go to 160
      if(abserr.gt.errsum) go to 170
      if(area.eq.0.0d+00) go to 190
      go to 165
  160 if(abserr/dabs(result).gt.errsum/dabs(area)) go to 170
c
c           test on divergence.
c
  165 if(ksgn.eq.(-1).and.dmax1(dabs(result),dabs(area)).le.
     * defabs*0.1d-01) go to 190
      if(0.1d-01.gt.(result/area).or.(result/area).gt.0.1d+03
     * .or.errsum.ge.dabs(area)) ier = 6
      go to 190
c
c           compute global integral sum.
c
  170 result = 0.0d+00
      do 180 k=1,last
        result = result+rlist(k)
  180 continue
      abserr = errsum
  190 if (ier.gt.2) ier=ier-1
  200 if (integr.eq.2.and.omega.lt.0.0d+00) result=-result
  999 return
      end
      subroutine dqc25f(f,a,b,omega,integr,nrmom,maxp1,ksave,result,
     *   abserr,neval,resabs,resasc,momcom,chebmo)
c***begin prologue  dqc25f
c***date written   810101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a2a2
c***keywords  integration rules for functions with cos or sin
c             factor, clenshaw-curtis, gauss-kronrod
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute the integral i=integral of f(x) over (a,b)
c            where w(x) = cos(omega*x) or w(x)=sin(omega*x) and to
c            compute j = integral of abs(f) over (a,b). for small value
c            of omega or small intervals (a,b) the 15-point gauss-kronro
c            rule is used. otherwise a generalized clenshaw-curtis
c            method is used.
c***description
c
c        integration rules for functions with cos or sin factor
c        standard fortran subroutine
c        double precision version
c
c        parameters
c         on entry
c           f      - double precision
c                    function subprogram defining the integrand
c                    function f(x). the actual name for f needs to
c                    be declared e x t e r n a l in the calling program.
c
c           a      - double precision
c                    lower limit of integration
c
c           b      - double precision
c                    upper limit of integration
c
c           omega  - double precision
c                    parameter in the weight function
c
c           integr - integer
c                    indicates which weight function is to be used
c                       integr = 1   w(x) = cos(omega*x)
c                       integr = 2   w(x) = sin(omega*x)
c
c           nrmom  - integer
c                    the length of interval (a,b) is equal to the length
c                    of the original integration interval divided by
c                    2**nrmom (we suppose that the routine is used in an
c                    adaptive integration process, otherwise set
c                    nrmom = 0). nrmom must be zero at the first call.
c
c           maxp1  - integer
c                    gives an upper bound on the number of chebyshev
c                    moments which can be stored, i.e. for the
c                    intervals of lengths abs(bb-aa)*2**(-l),
c                    l = 0,1,2, ..., maxp1-2.
c
c           ksave  - integer
c                    key which is one when the moments for the
c                    current interval have been computed
c
c         on return
c           result - double precision
c                    approximation to the integral i
c
c           abserr - double precision
c                    estimate of the modulus of the absolute
c                    error, which should equal or exceed abs(i-result)
c
c           neval  - integer
c                    number of integrand evaluations
c
c           resabs - double precision
c                    approximation to the integral j
c
c           resasc - double precision
c                    approximation to the integral of abs(f-i/(b-a))
c
c         on entry and return
c           momcom - integer
c                    for each interval length we need to compute the
c                    chebyshev moments. momcom counts the number of
c                    intervals for which these moments have already been
c                    computed. if nrmom.lt.momcom or ksave = 1, the
c                    chebyshev moments for the interval (a,b) have
c                    already been computed and stored, otherwise we
c                    compute them and we increase momcom.
c
c           chebmo - double precision
c                    array of dimension at least (maxp1,25) containing
c                    the modified chebyshev moments for the first momcom
c                    momcom interval lengths
c
c ......................................................................
c***references  (none)
c***routines called  d1mach,dgtsl,dqcheb,dqk15w,dqwgtf
c***end prologue  dqc25f
c
      double precision a,abserr,ac,an,an2,as,asap,ass,b,centr,chebmo,
     *  cheb12,cheb24,conc,cons,cospar,d,dabs,dcos,dsin,dqwgtf,d1,
     *  d1mach,d2,estc,ests,f,fval,hlgth,oflow,omega,parint,par2,par22,
     *  p2,p3,p4,resabs,resasc,resc12,resc24,ress12,ress24,result,
     *  sinpar,v,x
      integer i,iers,integr,isym,j,k,ksave,m,momcom,neval,maxp1,
     *  noequ,noeq1,nrmom
c
      dimension chebmo(maxp1,25),cheb12(13),cheb24(25),d(25),d1(25),
     *  d2(25),fval(25),v(28),x(11)
c
      external f,dqwgtf
c
c           the vector x contains the values cos(k*pi/24)
c           k = 1, ...,11, to be used for the chebyshev expansion of f
c
      data x(1) / 0.9914448613 7381041114 4557526928 563d0 /
      data x(2) / 0.9659258262 8906828674 9743199728 897d0 /
      data x(3) / 0.9238795325 1128675612 8183189396 788d0 /
      data x(4) / 0.8660254037 8443864676 3723170752 936d0 /
      data x(5) / 0.7933533402 9123516457 9776961501 299d0 /
      data x(6) / 0.7071067811 8654752440 0844362104 849d0 /
      data x(7) / 0.6087614290 0872063941 6097542898 164d0 /
      data x(8) / 0.5000000000 0000000000 0000000000 000d0 /
      data x(9) / 0.3826834323 6508977172 8459984030 399d0 /
      data x(10) / 0.2588190451 0252076234 8898837624 048d0 /
      data x(11) / 0.1305261922 2005159154 8406227895 489d0 /
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the integration interval
c           hlgth  - half-length of the integration interval
c           fval   - value of the function f at the points
c                    (b-a)*0.5*cos(k*pi/12) + (b+a)*0.5, k = 0, ..., 24
c           cheb12 - coefficients of the chebyshev series expansion
c                    of degree 12, for the function f, in the
c                    interval (a,b)
c           cheb24 - coefficients of the chebyshev series expansion
c                    of degree 24, for the function f, in the
c                    interval (a,b)
c           resc12 - approximation to the integral of
c                    cos(0.5*(b-a)*omega*x)*f(0.5*(b-a)*x+0.5*(b+a))
c                    over (-1,+1), using the chebyshev series
c                    expansion of degree 12
c           resc24 - approximation to the same integral, using the
c                    chebyshev series expansion of degree 24
c           ress12 - the analogue of resc12 for the sine
c           ress24 - the analogue of resc24 for the sine
c
c
c           machine dependent constant
c           --------------------------
c
c           oflow is the largest positive magnitude.
c
c***first executable statement  dqc25f
      oflow = d1mach(2)
c
      centr = 0.5d+00*(b+a)
      hlgth = 0.5d+00*(b-a)
      parint = omega*hlgth
c
c           compute the integral using the 15-point gauss-kronrod
c           formula if the value of the parameter in the integrand
c           is small.
c
      if(dabs(parint).gt.0.2d+01) go to 10
      call dqk15w(f,dqwgtf,omega,p2,p3,p4,integr,a,b,result,
     *  abserr,resabs,resasc)
      neval = 15
      go to 170
c
c           compute the integral using the generalized clenshaw-
c           curtis method.
c
   10 conc = hlgth*dcos(centr*omega)
      cons = hlgth*dsin(centr*omega)
      resasc = oflow
      neval = 25
c
c           check whether the chebyshev moments for this interval
c           have already been computed.
c
      if(nrmom.lt.momcom.or.ksave.eq.1) go to 120
c
c           compute a new set of chebyshev moments.
c
      m = momcom+1
      par2 = parint*parint
      par22 = par2+0.2d+01
      sinpar = dsin(parint)
      cospar = dcos(parint)
c
c           compute the chebyshev moments with respect to cosine.
c
      v(1) = 0.2d+01*sinpar/parint
      v(2) = (0.8d+01*cospar+(par2+par2-0.8d+01)*sinpar/parint)/par2
      v(3) = (0.32d+02*(par2-0.12d+02)*cospar+(0.2d+01*
     *  ((par2-0.80d+02)*par2+0.192d+03)*sinpar)/parint)/(par2*par2)
      ac = 0.8d+01*cospar
      as = 0.24d+02*parint*sinpar
      if(dabs(parint).gt.0.24d+02) go to 30
c
c           compute the chebyshev moments as the solutions of a
c           boundary value problem with 1 initial value (v(3)) and 1
c           end value (computed using an asymptotic formula).
c
      noequ = 25
      noeq1 = noequ-1
      an = 0.6d+01
      do 20 k = 1,noeq1
        an2 = an*an
        d(k) = -0.2d+01*(an2-0.4d+01)*(par22-an2-an2)
        d2(k) = (an-0.1d+01)*(an-0.2d+01)*par2
        d1(k+1) = (an+0.3d+01)*(an+0.4d+01)*par2
        v(k+3) = as-(an2-0.4d+01)*ac
        an = an+0.2d+01
   20 continue
      an2 = an*an
      d(noequ) = -0.2d+01*(an2-0.4d+01)*(par22-an2-an2)
      v(noequ+3) = as-(an2-0.4d+01)*ac
      v(4) = v(4)-0.56d+02*par2*v(3)
      ass = parint*sinpar
      asap = (((((0.210d+03*par2-0.1d+01)*cospar-(0.105d+03*par2
     *  -0.63d+02)*ass)/an2-(0.1d+01-0.15d+02*par2)*cospar
     *  +0.15d+02*ass)/an2-cospar+0.3d+01*ass)/an2-cospar)/an2
      v(noequ+3) = v(noequ+3)-0.2d+01*asap*par2*(an-0.1d+01)*
     *   (an-0.2d+01)
c
c           solve the tridiagonal system by means of gaussian
c           elimination with partial pivoting.
c
c***        call to dgtsl must be replaced by call to
c***        double precision version of linpack routine sgtsl
c
      call dgtsl(noequ,d1,d,d2,v(4),iers)
      go to 50
c
c           compute the chebyshev moments by means of forward
c           recursion.
c
   30 an = 0.4d+01
      do 40 i = 4,13
        an2 = an*an
        v(i) = ((an2-0.4d+01)*(0.2d+01*(par22-an2-an2)*v(i-1)-ac)
     *  +as-par2*(an+0.1d+01)*(an+0.2d+01)*v(i-2))/
     *  (par2*(an-0.1d+01)*(an-0.2d+01))
        an = an+0.2d+01
   40 continue
   50 do 60 j = 1,13
        chebmo(m,2*j-1) = v(j)
   60 continue
c
c           compute the chebyshev moments with respect to sine.
c
      v(1) = 0.2d+01*(sinpar-parint*cospar)/par2
      v(2) = (0.18d+02-0.48d+02/par2)*sinpar/par2
     *  +(-0.2d+01+0.48d+02/par2)*cospar/parint
      ac = -0.24d+02*parint*cospar
      as = -0.8d+01*sinpar
      if(dabs(parint).gt.0.24d+02) go to 80
c
c           compute the chebyshev moments as the solutions of a boundary
c           value problem with 1 initial value (v(2)) and 1 end value
c           (computed using an asymptotic formula).
c
      an = 0.5d+01
      do 70 k = 1,noeq1
        an2 = an*an
        d(k) = -0.2d+01*(an2-0.4d+01)*(par22-an2-an2)
        d2(k) = (an-0.1d+01)*(an-0.2d+01)*par2
        d1(k+1) = (an+0.3d+01)*(an+0.4d+01)*par2
        v(k+2) = ac+(an2-0.4d+01)*as
        an = an+0.2d+01
   70 continue
      an2 = an*an
      d(noequ) = -0.2d+01*(an2-0.4d+01)*(par22-an2-an2)
      v(noequ+2) = ac+(an2-0.4d+01)*as
      v(3) = v(3)-0.42d+02*par2*v(2)
      ass = parint*cospar
      asap = (((((0.105d+03*par2-0.63d+02)*ass+(0.210d+03*par2
     *  -0.1d+01)*sinpar)/an2+(0.15d+02*par2-0.1d+01)*sinpar-
     *  0.15d+02*ass)/an2-0.3d+01*ass-sinpar)/an2-sinpar)/an2
      v(noequ+2) = v(noequ+2)-0.2d+01*asap*par2*(an-0.1d+01)
     *  *(an-0.2d+01)
c
c           solve the tridiagonal system by means of gaussian
c           elimination with partial pivoting.
c
c***        call to dgtsl must be replaced by call to
c***        double precision version of linpack routine sgtsl
c
      call dgtsl(noequ,d1,d,d2,v(3),iers)
      go to 100
c
c           compute the chebyshev moments by means of forward recursion.
c
   80 an = 0.3d+01
      do 90 i = 3,12
        an2 = an*an
        v(i) = ((an2-0.4d+01)*(0.2d+01*(par22-an2-an2)*v(i-1)+as)
     *  +ac-par2*(an+0.1d+01)*(an+0.2d+01)*v(i-2))
     *  /(par2*(an-0.1d+01)*(an-0.2d+01))
        an = an+0.2d+01
   90 continue
  100 do 110 j = 1,12
        chebmo(m,2*j) = v(j)
  110 continue
  120 if (nrmom.lt.momcom) m = nrmom+1
       if (momcom.lt.(maxp1-1).and.nrmom.ge.momcom) momcom = momcom+1
c
c           compute the coefficients of the chebyshev expansions
c           of degrees 12 and 24 of the function f.
c
      fval(1) = 0.5d+00*f(centr+hlgth)
      fval(13) = f(centr)
      fval(25) = 0.5d+00*f(centr-hlgth)
      do 130 i = 2,12
        isym = 26-i
        fval(i) = f(hlgth*x(i-1)+centr)
        fval(isym) = f(centr-hlgth*x(i-1))
  130 continue
      call dqcheb(x,fval,cheb12,cheb24)
c
c           compute the integral and error estimates.
c
      resc12 = cheb12(13)*chebmo(m,13)
      ress12 = 0.0d+00
      k = 11
      do 140 j = 1,6
        resc12 = resc12+cheb12(k)*chebmo(m,k)
        ress12 = ress12+cheb12(k+1)*chebmo(m,k+1)
        k = k-2
  140 continue
      resc24 = cheb24(25)*chebmo(m,25)
      ress24 = 0.0d+00
      resabs = dabs(cheb24(25))
      k = 23
      do 150 j = 1,12
        resc24 = resc24+cheb24(k)*chebmo(m,k)
        ress24 = ress24+cheb24(k+1)*chebmo(m,k+1)
        resabs = dabs(cheb24(k))+dabs(cheb24(k+1))
        k = k-2
  150 continue
      estc = dabs(resc24-resc12)
      ests = dabs(ress24-ress12)
      resabs = resabs*dabs(hlgth)
      if(integr.eq.2) go to 160
      result = conc*resc24-cons*ress24
      abserr = dabs(conc*estc)+dabs(cons*ests)
      go to 170
  160 result = conc*ress24+cons*resc24
      abserr = dabs(conc*ests)+dabs(cons*estc)
  170 return
      end
      subroutine dqcheb(x,fval,cheb12,cheb24)
c***begin prologue  dqcheb
c***refer to  dqc25c,dqc25f,dqc25s
c***routines called  (none)
c***revision date  830518   (yymmdd)
c***keywords  chebyshev series expansion, fast fourier transform
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  this routine computes the chebyshev series expansion
c            of degrees 12 and 24 of a function using a
c            fast fourier transform method
c            f(x) = sum(k=1,..,13) (cheb12(k)*t(k-1,x)),
c            f(x) = sum(k=1,..,25) (cheb24(k)*t(k-1,x)),
c            where t(k,x) is the chebyshev polynomial of degree k.
c***description
c
c        chebyshev series expansion
c        standard fortran subroutine
c        double precision version
c
c        parameters
c          on entry
c           x      - double precision
c                    vector of dimension 11 containing the
c                    values cos(k*pi/24), k = 1, ..., 11
c
c           fval   - double precision
c                    vector of dimension 25 containing the
c                    function values at the points
c                    (b+a+(b-a)*cos(k*pi/24))/2, k = 0, ...,24,
c                    where (a,b) is the approximation interval.
c                    fval(1) and fval(25) are divided by two
c                    (these values are destroyed at output).
c
c          on return
c           cheb12 - double precision
c                    vector of dimension 13 containing the
c                    chebyshev coefficients for degree 12
c
c           cheb24 - double precision
c                    vector of dimension 25 containing the
c                    chebyshev coefficients for degree 24
c
c***end prologue  dqcheb
c
      double precision alam,alam1,alam2,cheb12,cheb24,fval,part1,part2,
     *  part3,v,x
      integer i,j
c
      dimension cheb12(13),cheb24(25),fval(25),v(12),x(11)
c
c***first executable statement  dqcheb
      do 10 i=1,12
        j = 26-i
        v(i) = fval(i)-fval(j)
        fval(i) = fval(i)+fval(j)
   10 continue
      alam1 = v(1)-v(9)
      alam2 = x(6)*(v(3)-v(7)-v(11))
      cheb12(4) = alam1+alam2
      cheb12(10) = alam1-alam2
      alam1 = v(2)-v(8)-v(10)
      alam2 = v(4)-v(6)-v(12)
      alam = x(3)*alam1+x(9)*alam2
      cheb24(4) = cheb12(4)+alam
      cheb24(22) = cheb12(4)-alam
      alam = x(9)*alam1-x(3)*alam2
      cheb24(10) = cheb12(10)+alam
      cheb24(16) = cheb12(10)-alam
      part1 = x(4)*v(5)
      part2 = x(8)*v(9)
      part3 = x(6)*v(7)
      alam1 = v(1)+part1+part2
      alam2 = x(2)*v(3)+part3+x(10)*v(11)
      cheb12(2) = alam1+alam2
      cheb12(12) = alam1-alam2
      alam = x(1)*v(2)+x(3)*v(4)+x(5)*v(6)+x(7)*v(8)
     *  +x(9)*v(10)+x(11)*v(12)
      cheb24(2) = cheb12(2)+alam
      cheb24(24) = cheb12(2)-alam
      alam = x(11)*v(2)-x(9)*v(4)+x(7)*v(6)-x(5)*v(8)
     *  +x(3)*v(10)-x(1)*v(12)
      cheb24(12) = cheb12(12)+alam
      cheb24(14) = cheb12(12)-alam
      alam1 = v(1)-part1+part2
      alam2 = x(10)*v(3)-part3+x(2)*v(11)
      cheb12(6) = alam1+alam2
      cheb12(8) = alam1-alam2
      alam = x(5)*v(2)-x(9)*v(4)-x(1)*v(6)
     *  -x(11)*v(8)+x(3)*v(10)+x(7)*v(12)
      cheb24(6) = cheb12(6)+alam
      cheb24(20) = cheb12(6)-alam
      alam = x(7)*v(2)-x(3)*v(4)-x(11)*v(6)+x(1)*v(8)
     *  -x(9)*v(10)-x(5)*v(12)
      cheb24(8) = cheb12(8)+alam
      cheb24(18) = cheb12(8)-alam
      do 20 i=1,6
        j = 14-i
        v(i) = fval(i)-fval(j)
        fval(i) = fval(i)+fval(j)
   20 continue
      alam1 = v(1)+x(8)*v(5)
      alam2 = x(4)*v(3)
      cheb12(3) = alam1+alam2
      cheb12(11) = alam1-alam2
      cheb12(7) = v(1)-v(5)
      alam = x(2)*v(2)+x(6)*v(4)+x(10)*v(6)
      cheb24(3) = cheb12(3)+alam
      cheb24(23) = cheb12(3)-alam
      alam = x(6)*(v(2)-v(4)-v(6))
      cheb24(7) = cheb12(7)+alam
      cheb24(19) = cheb12(7)-alam
      alam = x(10)*v(2)-x(6)*v(4)+x(2)*v(6)
      cheb24(11) = cheb12(11)+alam
      cheb24(15) = cheb12(11)-alam
      do 30 i=1,3
        j = 8-i
        v(i) = fval(i)-fval(j)
        fval(i) = fval(i)+fval(j)
   30 continue
      cheb12(5) = v(1)+x(8)*v(3)
      cheb12(9) = fval(1)-x(8)*fval(3)
      alam = x(4)*v(2)
      cheb24(5) = cheb12(5)+alam
      cheb24(21) = cheb12(5)-alam
      alam = x(8)*fval(2)-fval(4)
      cheb24(9) = cheb12(9)+alam
      cheb24(17) = cheb12(9)-alam
      cheb12(1) = fval(1)+fval(3)
      alam = fval(2)+fval(4)
      cheb24(1) = cheb12(1)+alam
      cheb24(25) = cheb12(1)-alam
      cheb12(13) = v(1)-v(3)
      cheb24(13) = cheb12(13)
      alam = 0.1d+01/0.6d+01
      do 40 i=2,12
        cheb12(i) = cheb12(i)*alam
   40 continue
      alam = 0.5d+00*alam
      cheb12(1) = cheb12(1)*alam
      cheb12(13) = cheb12(13)*alam
      do 50 i=2,24
        cheb24(i) = cheb24(i)*alam
   50 continue
      cheb24(1) = 0.5d+00*alam*cheb24(1)
      cheb24(25) = 0.5d+00*alam*cheb24(25)
      return
      end
      subroutine dqelg(n,epstab,result,abserr,res3la,nres)
c***begin prologue  dqelg
c***refer to  dqagie,dqagoe,dqagpe,dqagse
c***routines called  d1mach
c***revision date  830518   (yymmdd)
c***keywords  epsilon algorithm, convergence acceleration,
c             extrapolation
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math & progr. div. - k.u.leuven
c***purpose  the routine determines the limit of a given sequence of
c            approximations, by means of the epsilon algorithm of
c            p.wynn. an estimate of the absolute error is also given.
c            the condensed epsilon table is computed. only those
c            elements needed for the computation of the next diagonal
c            are preserved.
c***description
c
c           epsilon algorithm
c           standard fortran subroutine
c           double precision version
c
c           parameters
c              n      - integer
c                       epstab(n) contains the new element in the
c                       first column of the epsilon table.
c
c              epstab - double precision
c                       vector of dimension 52 containing the elements
c                       of the two lower diagonals of the triangular
c                       epsilon table. the elements are numbered
c                       starting at the right-hand corner of the
c                       triangle.
c
c              result - double precision
c                       resulting approximation to the integral
c
c              abserr - double precision
c                       estimate of the absolute error computed from
c                       result and the 3 previous results
c
c              res3la - double precision
c                       vector of dimension 3 containing the last 3
c                       results
c
c              nres   - integer
c                       number of calls to the routine
c                       (should be zero at first call)
c
c***end prologue  dqelg
c
      double precision abserr,dabs,delta1,delta2,delta3,dmax1,d1mach,
     *  epmach,epsinf,epstab,error,err1,err2,err3,e0,e1,e1abs,e2,e3,
     *  oflow,res,result,res3la,ss,tol1,tol2,tol3
      integer i,ib,ib2,ie,indx,k1,k2,k3,limexp,n,newelm,nres,num
      dimension epstab(52),res3la(3)
c
c           list of major variables
c           -----------------------
c
c           e0     - the 4 elements on which the computation of a new
c           e1       element in the epsilon table is based
c           e2
c           e3                 e0
c                        e3    e1    new
c                              e2
c           newelm - number of elements to be computed in the new
c                    diagonal
c           error  - error = abs(e1-e0)+abs(e2-e1)+abs(new-e2)
c           result - the element in the new diagonal with least value
c                    of error
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           oflow is the largest positive magnitude.
c           limexp is the maximum number of elements the epsilon
c           table can contain. if this number is reached, the upper
c           diagonal of the epsilon table is deleted.
c
c***first executable statement  dqelg
      epmach = d1mach(4)
      oflow = d1mach(2)
      nres = nres+1
      abserr = oflow
      result = epstab(n)
      if(n.lt.3) go to 100
      limexp = 50
      epstab(n+2) = epstab(n)
      newelm = (n-1)/2
      epstab(n) = oflow
      num = n
      k1 = n
      do 40 i = 1,newelm
        k2 = k1-1
        k3 = k1-2
        res = epstab(k1+2)
        e0 = epstab(k3)
        e1 = epstab(k2)
        e2 = res
        e1abs = dabs(e1)
        delta2 = e2-e1
        err2 = dabs(delta2)
        tol2 = dmax1(dabs(e2),e1abs)*epmach
        delta3 = e1-e0
        err3 = dabs(delta3)
        tol3 = dmax1(e1abs,dabs(e0))*epmach
        if(err2.gt.tol2.or.err3.gt.tol3) go to 10
c
c           if e0, e1 and e2 are equal to within machine
c           accuracy, convergence is assumed.
c           result = e2
c           abserr = abs(e1-e0)+abs(e2-e1)
c
        result = res
        abserr = err2+err3
c ***jump out of do-loop
        go to 100
   10   e3 = epstab(k1)
        epstab(k1) = e1
        delta1 = e1-e3
        err1 = dabs(delta1)
        tol1 = dmax1(e1abs,dabs(e3))*epmach
c
c           if two elements are very close to each other, omit
c           a part of the table by adjusting the value of n
c
        if(err1.le.tol1.or.err2.le.tol2.or.err3.le.tol3) go to 20
        ss = 0.1d+01/delta1+0.1d+01/delta2-0.1d+01/delta3
        epsinf = dabs(ss*e1)
c
c           test to detect irregular behaviour in the table, and
c           eventually omit a part of the table adjusting the value
c           of n.
c
        if(epsinf.gt.0.1d-03) go to 30
   20   n = i+i-1
c ***jump out of do-loop
        go to 50
c
c           compute a new element and eventually adjust
c           the value of result.
c
   30   res = e1+0.1d+01/ss
        epstab(k1) = res
        k1 = k1-2
        error = err2+dabs(res-e2)+err3
        if(error.gt.abserr) go to 40
        abserr = error
        result = res
   40 continue
c
c           shift the table.
c
   50 if(n.eq.limexp) n = 2*(limexp/2)-1
      ib = 1
      if((num/2)*2.eq.num) ib = 2
      ie = newelm+1
      do 60 i=1,ie
        ib2 = ib+2
        epstab(ib) = epstab(ib2)
        ib = ib2
   60 continue
      if(num.eq.n) go to 80
      indx = num-n+1
      do 70 i = 1,n
        epstab(i)= epstab(indx)
        indx = indx+1
   70 continue
   80 if(nres.ge.4) go to 90
      res3la(nres) = result
      abserr = oflow
      go to 100
c
c           compute error estimate
c
   90 abserr = dabs(result-res3la(3))+dabs(result-res3la(2))
     *  +dabs(result-res3la(1))
      res3la(1) = res3la(2)
      res3la(2) = res3la(3)
      res3la(3) = result
  100 abserr = dmax1(abserr,0.5d+01*epmach*dabs(result))
      return
      end
      subroutine dqk15i(f,boun,inf,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk15i
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a3a2,h2a4a2
c***keywords  15-point transformed gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  the original (infinite integration range is mapped
c            onto the interval (0,1) and (a,b) is a part of (0,1).
c            it is the purpose to compute
c            i = integral of transformed integrand over (a,b),
c            j = integral of abs(transformed integrand) over (a,b).
c***description
c
c           integration rule
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       fuction subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the calling program.
c
c              boun   - double precision
c                       finite bound of original integration
c                       range (set to zero if inf = +2)
c
c              inf    - integer
c                       if inf = -1, the original interval is
c                                   (-infinity,bound),
c                       if inf = +1, the original interval is
c                                   (bound,+infinity),
c                       if inf = +2, the original interval is
c                                   (-infinity,+infinity) and
c                       the integral is computed as the sum of two
c                       integrals, one over (-infinity,0) and one over
c                       (0,+infinity).
c
c              a      - double precision
c                       lower limit for integration over subrange
c                       of (0,1)
c
c              b      - double precision
c                       upper limit for integration over subrange
c                       of (0,1)
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 15-point
c                       kronrod rule(resk) obtained by optimal addition
c                       of abscissae to the 7-point gauss rule(resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should equal or exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integral of
c                       abs((transformed integrand)-i/(b-a)) over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk15i
c
      double precision a,absc,absc1,absc2,abserr,b,boun,centr,dabs,dinf,
     *  dmax1,dmin1,d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,
     *  resabs,resasc,resg,resk,reskh,result,tabsc1,tabsc2,uflow,wg,wgk,
     *  xgk
      integer inf,j
      external f
c
      dimension fv1(7),fv2(7),xgk(8),wgk(8),wg(8)
c
c           the abscissae and weights are supplied for the interval
c           (-1,1).  because of symmetry only the positive abscissae and
c           their corresponding weights are given.
c
c           xgk    - abscissae of the 15-point kronrod rule
c                    xgk(2), xgk(4), ... abscissae of the 7-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 7-point gauss rule
c
c           wgk    - weights of the 15-point kronrod rule
c
c           wg     - weights of the 7-point gauss rule, corresponding
c                    to the abscissae xgk(2), xgk(4), ...
c                    wg(1), wg(3), ... are set to zero.
c
      data wg(1) / 0.0d0 /
      data wg(2) / 0.1294849661 6886969327 0611432679 082d0 /
      data wg(3) / 0.0d0 /
      data wg(4) / 0.2797053914 8927666790 1467771423 780d0 /
      data wg(5) / 0.0d0 /
      data wg(6) / 0.3818300505 0511894495 0369775488 975d0 /
      data wg(7) / 0.0d0 /
      data wg(8) / 0.4179591836 7346938775 5102040816 327d0 /
c
      data xgk(1) / 0.9914553711 2081263920 6854697526 329d0 /
      data xgk(2) / 0.9491079123 4275852452 6189684047 851d0 /
      data xgk(3) / 0.8648644233 5976907278 9712788640 926d0 /
      data xgk(4) / 0.7415311855 9939443986 3864773280 788d0 /
      data xgk(5) / 0.5860872354 6769113029 4144838258 730d0 /
      data xgk(6) / 0.4058451513 7739716690 6606412076 961d0 /
      data xgk(7) / 0.2077849550 0789846760 0689403773 245d0 /
      data xgk(8) / 0.0000000000 0000000000 0000000000 000d0 /
c
      data wgk(1) / 0.0229353220 1052922496 3732008058 970d0 /
      data wgk(2) / 0.0630920926 2997855329 0700663189 204d0 /
      data wgk(3) / 0.1047900103 2225018383 9876322541 518d0 /
      data wgk(4) / 0.1406532597 1552591874 5189590510 238d0 /
      data wgk(5) / 0.1690047266 3926790282 6583426598 550d0 /
      data wgk(6) / 0.1903505780 6478540991 3256402421 014d0 /
      data wgk(7) / 0.2044329400 7529889241 4161999234 649d0 /
      data wgk(8) / 0.2094821410 8472782801 2999174891 714d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc*  - abscissa
c           tabsc* - transformed abscissa
c           fval*  - function value
c           resg   - result of the 7-point gauss formula
c           resk   - result of the 15-point kronrod formula
c           reskh  - approximation to the mean value of the transformed
c                    integrand over (a,b), i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk15i
      epmach = d1mach(4)
      uflow = d1mach(1)
      dinf = min0(1,inf)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      tabsc1 = boun+dinf*(0.1d+01-centr)/centr
      fval1 = f(tabsc1)
      if(inf.eq.2) fval1 = fval1+f(-tabsc1)
      fc = (fval1/centr)/centr
c
c           compute the 15-point kronrod approximation to
c           the integral, and estimate the error.
c
      resg = wg(8)*fc
      resk = wgk(8)*fc
      resabs = dabs(resk)
      do 10 j=1,7
        absc = hlgth*xgk(j)
        absc1 = centr-absc
        absc2 = centr+absc
        tabsc1 = boun+dinf*(0.1d+01-absc1)/absc1
        tabsc2 = boun+dinf*(0.1d+01-absc2)/absc2
        fval1 = f(tabsc1)
        fval2 = f(tabsc2)
        if(inf.eq.2) fval1 = fval1+f(-tabsc1)
        if(inf.eq.2) fval2 = fval2+f(-tabsc2)
        fval1 = (fval1/absc1)/absc1
        fval2 = (fval2/absc2)/absc2
        fv1(j) = fval1
        fv2(j) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(j)*fsum
        resabs = resabs+wgk(j)*(dabs(fval1)+dabs(fval2))
   10 continue
      reskh = resk*0.5d+00
      resasc = wgk(8)*dabs(fc-reskh)
      do 20 j=1,7
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resasc = resasc*hlgth
      resabs = resabs*hlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.d0) abserr = resasc*
     * dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     * ((epmach*0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqk15w(f,w,p1,p2,p3,p4,kp,a,b,result,abserr,
     *   resabs,resasc)
c***begin prologue  dqk15w
c***date written   810101   (yymmdd)
c***revision date  830518   (mmddyy)
c***category no.  h2a2a2
c***keywords  15-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f*w over (a,b), with error
c                           estimate
c                       j = integral of abs(f*w) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c             on entry
c              f      - double precision
c                       function subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the driver program.
c
c              w      - double precision
c                       function subprogram defining the integrand
c                       weight function w(x). the actual name for w
c                       needs to be declared e x t e r n a l in the
c                       calling program.
c
c              p1, p2, p3, p4 - double precision
c                       parameters in the weight function
c
c              kp     - integer
c                       key for indicating the type of weight function
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 15-point
c                       kronrod rule (resk) obtained by optimal addition
c                       of abscissae to the 7-point gauss rule (resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should equal or exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral of abs(f)
c
c              resasc - double precision
c                       approximation to the integral of abs(f-i/(b-a))
c
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk15w
c
      double precision a,absc,absc1,absc2,abserr,b,centr,dabs,dhlgth,
     *  dmax1,dmin1,d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,
     *  p1,p2,p3,p4,resabs,resasc,resg,resk,reskh,result,uflow,w,wg,wgk,
     *  xgk
      integer j,jtw,jtwm1,kp
      external f,w
c
      dimension fv1(7),fv2(7),xgk(8),wgk(8),wg(4)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 15-point gauss-kronrod rule
c                    xgk(2), xgk(4), ... abscissae of the 7-point
c                    gauss rule
c                    xgk(1), xgk(3), ... abscissae which are optimally
c                    added to the 7-point gauss rule
c
c           wgk    - weights of the 15-point gauss-kronrod rule
c
c           wg     - weights of the 7-point gauss rule
c
      data xgk(1),xgk(2),xgk(3),xgk(4),xgk(5),xgk(6),xgk(7),xgk(8)/
     *     0.9914553711208126d+00,     0.9491079123427585d+00,
     *     0.8648644233597691d+00,     0.7415311855993944d+00,
     *     0.5860872354676911d+00,     0.4058451513773972d+00,
     *     0.2077849550078985d+00,     0.0000000000000000d+00/
c
      data wgk(1),wgk(2),wgk(3),wgk(4),wgk(5),wgk(6),wgk(7),wgk(8)/
     *     0.2293532201052922d-01,     0.6309209262997855d-01,
     *     0.1047900103222502d+00,     0.1406532597155259d+00,
     *     0.1690047266392679d+00,     0.1903505780647854d+00,
     *     0.2044329400752989d+00,     0.2094821410847278d+00/
c
      data wg(1),wg(2),wg(3),wg(4)/
     *     0.1294849661688697d+00,    0.2797053914892767d+00,
     *     0.3818300505051889d+00,    0.4179591836734694d+00/
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc*  - abscissa
c           fval*  - function value
c           resg   - result of the 7-point gauss formula
c           resk   - result of the 15-point kronrod formula
c           reskh  - approximation to the mean value of f*w over (a,b),
c                    i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk15w
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 15-point kronrod approximation to the
c           integral, and estimate the error.
c
      fc = f(centr)*w(centr,p1,p2,p3,p4,kp)
      resg = wg(4)*fc
      resk = wgk(8)*fc
      resabs = dabs(resk)
      do 10 j=1,3
        jtw = j*2
        absc = hlgth*xgk(jtw)
        absc1 = centr-absc
        absc2 = centr+absc
        fval1 = f(absc1)*w(absc1,p1,p2,p3,p4,kp)
        fval2 = f(absc2)*w(absc2,p1,p2,p3,p4,kp)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j=1,4
        jtwm1 = j*2-1
        absc = hlgth*xgk(jtwm1)
        absc1 = centr-absc
        absc2 = centr+absc
        fval1 = f(absc1)*w(absc1,p1,p2,p3,p4,kp)
        fval2 = f(absc2)*w(absc2,p1,p2,p3,p4,kp)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(8)*dabs(fc-reskh)
      do 20 j=1,7
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1((epmach*
     *  0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqpsrt(limit,last,maxerr,ermax,elist,iord,nrmax)
c***begin prologue  dqpsrt
c***refer to  dqage,dqagie,dqagpe,dqawse
c***routines called  (none)
c***revision date  810101   (yymmdd)
c***keywords  sequential sorting
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  this routine maintains the descending ordering in the
c            list of the local error estimated resulting from the
c            interval subdivision process. at each call two error
c            estimates are inserted using the sequential search
c            method, top-down for the largest error estimate and
c            bottom-up for the smallest error estimate.
c***description
c
c           ordering routine
c           standard fortran subroutine
c           double precision version
c
c           parameters (meaning at output)
c              limit  - integer
c                       maximum number of error estimates the list
c                       can contain
c
c              last   - integer
c                       number of error estimates currently in the list
c
c              maxerr - integer
c                       maxerr points to the nrmax-th largest error
c                       estimate currently in the list
c
c              ermax  - double precision
c                       nrmax-th largest error estimate
c                       ermax = elist(maxerr)
c
c              elist  - double precision
c                       vector of dimension last containing
c                       the error estimates
c
c              iord   - integer
c                       vector of dimension last, the first k elements
c                       of which contain pointers to the error
c                       estimates, such that
c                       elist(iord(1)),...,  elist(iord(k))
c                       form a decreasing sequence, with
c                       k = last if last.le.(limit/2+2), and
c                       k = limit+1-last otherwise
c
c              nrmax  - integer
c                       maxerr = iord(nrmax)
c
c***end prologue  dqpsrt
c
      double precision elist,ermax,errmax,errmin
      integer i,ibeg,ido,iord,isucc,j,jbnd,jupbn,k,last,limit,maxerr,
     *  nrmax
      dimension elist(last),iord(last)
c
c           check whether the list contains more than
c           two error estimates.
c
c***first executable statement  dqpsrt
      if(last.gt.2) go to 10
      iord(1) = 1
      iord(2) = 2
      go to 90
c
c           this part of the routine is only executed if, due to a
c           difficult integrand, subdivision increased the error
c           estimate. in the normal case the insert procedure should
c           start after the nrmax-th largest error estimate.
c
   10 errmax = elist(maxerr)
      if(nrmax.eq.1) go to 30
      ido = nrmax-1
      do 20 i = 1,ido
        isucc = iord(nrmax-1)
c ***jump out of do-loop
        if(errmax.le.elist(isucc)) go to 30
        iord(nrmax) = isucc
        nrmax = nrmax-1
   20    continue
c
c           compute the number of elements in the list to be maintained
c           in descending order. this number depends on the number of
c           subdivisions still allowed.
c
   30 jupbn = last
      if(last.gt.(limit/2+2)) jupbn = limit+3-last
      errmin = elist(last)
c
c           insert errmax by traversing the list top-down,
c           starting comparison from the element elist(iord(nrmax+1)).
c
      jbnd = jupbn-1
      ibeg = nrmax+1
      if(ibeg.gt.jbnd) go to 50
      do 40 i=ibeg,jbnd
        isucc = iord(i)
c ***jump out of do-loop
        if(errmax.ge.elist(isucc)) go to 60
        iord(i-1) = isucc
   40 continue
   50 iord(jbnd) = maxerr
      iord(jupbn) = last
      go to 90
c
c           insert errmin by traversing the list bottom-up.
c
   60 iord(i-1) = maxerr
      k = jbnd
      do 70 j=i,jbnd
        isucc = iord(k)
c ***jump out of do-loop
        if(errmin.lt.elist(isucc)) go to 80
        iord(k+1) = isucc
        k = k-1
   70 continue
      iord(i) = last
      go to 90
   80 iord(k+1) = last
c
c           set maxerr and ermax.
c
   90 maxerr = iord(nrmax)
      ermax = elist(maxerr)
      return
      end
      double precision function dqwgtf(x,omega,p2,p3,p4,integr)
c***begin prologue  dqwgtf
c***refer to   dqk15w
c***routines called  (none)
c***revision date 810101   (yymmdd)
c***keywords  cos or sin in weight function
c***author  piessens,robert, appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. * progr. div. - k.u.leuven
c***end prologue  dqwgtf
c
      double precision dcos,dsin,omega,omx,p2,p3,p4,x
      integer integr
c***first executable statement  dqwgtf
      omx = omega*x
      go to(10,20),integr
   10 dqwgtf = dcos(omx)
      go to 30
   20 dqwgtf = dsin(omx)
   30 return
      end
      subroutine dgtsl(n,c,d,e,b,info)
      integer n,info
      double precision c(1),d(1),e(1),b(1)
c
c     dgtsl given a general tridiagonal matrix and a right hand
c     side will find the solution.
c
c     on entry
c
c        n       integer
c                is the order of the tridiagonal matrix.
c
c        c       double precision(n)
c                is the subdiagonal of the tridiagonal matrix.
c                c(2) through c(n) should contain the subdiagonal.
c                on output c is destroyed.
c
c        d       double precision(n)
c                is the diagonal of the tridiagonal matrix.
c                on output d is destroyed.
c
c        e       double precision(n)
c                is the superdiagonal of the tridiagonal matrix.
c                e(1) through e(n-1) should contain the superdiagonal.
c                on output e is destroyed.
c
c        b       double precision(n)
c                is the right hand side vector.
c
c     on return
c
c        b       is the solution vector.
c
c        info    integer
c                = 0 normal value.
c                = k if the k-th element of the diagonal becomes
c                    exactly zero.  the subroutine returns when
c                    this is detected.
c
c     linpack. this version dated 08/14/78 .
c     jack dongarra, argonne national laboratory.
c
c     no externals
c     fortran dabs
c
c     internal variables
c
      integer k,kb,kp1,nm1,nm2
      double precision t
c     begin block permitting ...exits to 100
c
         info = 0
         c(1) = d(1)
         nm1 = n - 1
         if (nm1 .lt. 1) go to 40
            d(1) = e(1)
            e(1) = 0.0d0
            e(n) = 0.0d0
c
            do 30 k = 1, nm1
               kp1 = k + 1
c
c              find the largest of the two rows
c
               if (dabs(c(kp1)) .lt. dabs(c(k))) go to 10
c
c                 interchange row
c
                  t = c(kp1)
                  c(kp1) = c(k)
                  c(k) = t
                  t = d(kp1)
                  d(kp1) = d(k)
                  d(k) = t
                  t = e(kp1)
                  e(kp1) = e(k)
                  e(k) = t
                  t = b(kp1)
                  b(kp1) = b(k)
                  b(k) = t
   10          continue
c
c              zero elements
c
               if (c(k) .ne. 0.0d0) go to 20
                  info = k
c     ............exit
                  go to 100
   20          continue
               t = -c(kp1)/c(k)
               c(kp1) = d(kp1) + t*d(k)
               d(kp1) = e(kp1) + t*e(k)
               e(kp1) = 0.0d0
               b(kp1) = b(kp1) + t*b(k)
   30       continue
   40    continue
         if (c(n) .ne. 0.0d0) go to 50
            info = n
         go to 90
   50    continue
c
c           back solve
c
            nm2 = n - 2
            b(n) = b(n)/c(n)
            if (n .eq. 1) go to 80
               b(nm1) = (b(nm1) - d(nm1)*b(n))/c(nm1)
               if (nm2 .lt. 1) go to 70
               do 60 kb = 1, nm2
                  k = nm2 - kb + 1
                  b(k) = (b(k) - d(k)*b(k+1) - e(k)*b(k+2))/c(k)
   60          continue
   70          continue
   80       continue
   90    continue
  100 continue
c
      return
      end

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
c * This routine needs upgrading to the same level of robustness
c * as the rest of the mangle software:
c * 1. Should check consistency of multiple intersections,
c *    and increase tol and repeat if an inconsistency is detected.
c * 2. As a corollary of 1., need to go around all edges,
c *    not just the particular edge i.
c * 3. If 2. is done, then the routine should be able to deal
c *    with point abuts in addition to abutments of finite extent.
c *
c * Currently, the routine deals correctly with multiple intersections,
c * albeit without checking for consistency.
c * However, it deals only with abutments of finite extent,
c * NOT with point abutments, where polygons abut at a single point
c * or at a set of isolated points.
c * This is enough to get bound right,
c * but vert is missing contributions from point abuts.
c-----------------------------------------------------------------------
      subroutine gphbv(bound,vert,rp,cm,np,npb,npc,i,tol,phi,iord)
      integer np,npb,npc,i,iord(2*np)
      real*10 bound(2),vert(2),rp(3,np),cm(np),tol,phi(2,np)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        externals
      integer gsegij,gzeroar
c        data variables
      real*10 big,bndtol,psitol
      real*10 dphmin
c        local (automatic) variables
      integer iphbv,iseg,j,jm(2),jml,jmu,jp(2),jpl,jpu,k,km(2),kp(2),
     *  l,ni,nmult
      logical warn
      real*10 bik,cmi,cmik,cmk,cti(3),ctk(3),ctpsi(3),
     *  d,dbound(2),dph,dvert(2),p,ph,phm,php,psi(3),
     *  scmi,si,sk,t(3),xi(3),yi(3)
c *
c * Correction to boundary and vertex terms per subroutine gspher
c * arising from disjoint regions W12 and W13 which abut along circle i
c * defined by 1 - r.rp(i) = cm(i).
c * W12 (W13) is the intersection of W2 (W3) with global region W1.
c * Regions are bounded by
c *    1 - r.rp(j) < cm(j)  (if cm(j).ge.0)
c *    1 - r.rp(j) > -cm(j)  (if cm(j).lt.0)
c * for j=1,np where rp(j) are unit directions.
c * The boundary of W2 is in j =     1 to npb
c *                 W3           npb+1 to npc
c *                 W1           npc+1 to np.
c * If circle i belongs to W2 (i.e. i=1 to npb) then
c * W2 (W3) is north (south) of circle i if cm(i).ge.0,
c *            south (north) of circle i if cm(i).lt.0.
c * Conversely, if circle i belongs to W3 (i.e. i=npb+1 to npc) then
c * W3 (W2) is north (south) of circle i if cm(i).ge.0,
c *            south (north) of circle i if cm(i).lt.0.
c * The abutting boundary i' of W3 (W2) which coincides with
c * boundary i of W2 (W3) should be suppressed by setting cm(i')=2.
c * Boundaries j that are duplicates of boundary i
c * or j' of the abutting boundary i'
c * should be suppressed by setting cm(j)=2 and cm(j')=2.
c *
c * Boundary and vertex terms are evaluated for -<W12 W13>.
c *
c * To get bound & vert for correlation <(W1-W12-W13)^2>
c * of region W1 less its intersection with disjoint regions W2 and W3,
c * follow instructions in gspher, i.e. basically
c *    call gspher(area,bound,vert,parameters of W1,ibv=0,...)
c *    call gspher(darea,dbound,dvert,parameters of W2 & W1,ibv=2,...)
c *    area=area-darea, etc.
c *    call gspher(darea,dbound,dvert,parameters of W3 & W1,ibv=2,...)
c *    area=area-darea, etc.
c * and then, if W2 and W3 abut,
c *    call gphbv(dbound,dvert,parameters of W2 W3 & W1,...)
c *    bound=bound-2*dbound
c *    vert=vert-2*dvert
c *
c * To get bound & vert for cross-correlation <W12(W1-W13)>
c * between W12
c * and region W1 less its intersection with W3 outside W2,
c * follow instructions in gspher, i.e.
c *    call gspher(area,bound,vert,parameters of W2 & W1,ibv=1,...)
c * and then, if W2 and W3 abut,
c *    call gphbv(dbound,dvert,parameters of W2 W3 & W1,...)
c *    bound=bound+dbound
c *    vert=vert+dvert
c *
c * To get bound & vert for cross-correlation <(W12-W13)(W1-W13)>
c * between W12 less its intersection with W3 inside W2,
c * and region W1 less its intersection with W3,
c * follow instructions in gspher, i.e.
c *    call gspher(area,bound,vert,parameters of W2 & W1,ibv=1,...)
c *    call gspher(darea,dbound,dvert,parameters of W3 & W12,ibv=2,...)
c *    area=area-darea, etc.
c * and then, if W2' and W3 abut, where W2' denotes complement of W2,
c *    call gphbv(dbound,dvert,parameters of W2' W3 & W1,...)
c *    bound=bound-dbound
c *    vert=vert-dvert
c * Note that usually all W2' constraints should be null.
c * If however W2' abuts W3 along two distinct boundaries, then W2'
c * should be split into two regions W2'a and W2'b which each have a
c * single abutment with W3, and two calls to gphbv should be made
c *    call gphbv(dbound,dvert,parameters of W2'a W3 & W1,...)
c *    bound=bound-dbound
c *    vert=vert-dvert
c *    call gphbv(dbound,dvert,parameters of W2'b W3 & W1,...)
c *    bound=bound-dbound, etc.
c *
c * In general, to get bound & vert for cross-correlation
c * <(W12-W13-...)(W1-W13-W14-...)>
c * between region W12 less its intersection W13 with a
c * bunch of disjoint W3 lying inside W2,
c * and W1 less its intersections W13 and W14 with that bunch of W3 and
c * another bunch of disjoint W4 lying outside W2,
c *    call gspher(area,bound,vert,parameters of W2 & W1,ibv=1,...)
c * then chop out all the W13s by calls
c *    call gspher(darea,dbound,dvert,parameters of W3 & W12,ibv=2,...)
c *    area=area-darea, etc.
c * then for each W3 (inside W2) abutting the edge of W2
c *    call gphbv(dbound,dvert,parameters of W2' W3 & W1,...)
c *    bound=bound-dbound, etc.
c * for each W4 (outside W2) abutting W2
c *    call gphbv(dbound,dvert,parameters of W2 W4 & W1,...)
c *    bound=bound+dbound, etc.
c * for each pair W3a & W3b (inside W2) which abut each other
c *    call gphbv(dbound,dvert,parameters of W3a W3b & W1,...)
c *    bound=bound-2*dbound, etc.
c * for each pair W3 (inside W2) & W4 (outside W2) abutting each other
c *    call gphbv(dbound,dvert,parameters of W3 W4 & W1,...)
c *    bound=bound-dbound, etc.
c *
c  Input: rp(3,j),j=1,np
c         cm(j),j=1,np
c         np, npb, npc: W2     1 to npb
c                       W3 npb+1 to npc
c                       W1 npc+1 to np.
c         i = abutting boundary of W2 (or W3);
c             the abutting boundary i' of W3 (or W2) which coincides
c             with boundary i of W2 (or W3) should be suppressed
c             by setting cm(i')=2.
c Output: bound(2)
c         vert(2)
c Work arrays: phi and iord should be dimensioned at least 2*np
c
c        set azimuthal angle of non-intersection to big
      data big /1.e6_10/
c        set vertex term to zero if |psi| < psitol
      data psitol /1.e-10_10/
c        ok if bound(1) tests not too far outside [0,max]
      data bndtol /1.e-10_10/
c        warn about multiple intersection when dph < dphmin
      data dphmin /1.e-8_10/
c
C     print *,'--------------------'
c        abutting boundary must belong to W2 or W3
      if (i.gt.npc) then
        print *,'*** from gphbv: i =',i,' should be .le.',npc
        goto 410
      endif
c        zero stuff
      bound(1)=0._10
      bound(2)=0._10
      vert(1)=0._10
      vert(2)=0._10
      warn=.false.
c        check for zero angle because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        cm(i).ge.2 means include whole sphere, which is no constraint
      if (cm(i).ge.2._10) goto 410
c--------identify boundary segments around circle i
      if (cm(i).ge.0._10) then
        scmi=1
      else
        scmi=-1
      endif
      cmi=abs(cm(i))
      si=sqrt(cmi*(2._10-cmi))
c........construct cartesian axes with z-axis along rp(i)
      call gaxisi(rp(1,i),xi,yi)
c........angles phi about z-axis rp(i) of intersection of i & j circles
      call gphij(rp,cm,np,i,rp(1,i),scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside polygon
      if (ni.eq.-1) goto 410
c        area of polygon is zero
      if (ni.eq.-2) goto 410
c........i circle has no intersections
      if (ni.eq.0) then
        dph=TWOPI
        dbound(1)=si*dph
        dbound(2)=(1._10/si-2._10*si)*dph
        bound(1)=bound(1)+dbound(1)
        bound(2)=bound(2)+dbound(2)
C       print *,'full circle'
C       print *,'dbound =',dbound(1),dbound(2),
C    *    ' bound =',bound(1),bound(2)
c........i circle has intersections
      elseif (ni.gt.0) then
c        find ordering of intersection angles around i circle
        call findbot(phi,2*np,iord,ni)
c........contribution from each segment of i circle
        jpl=0
c        come here to do another segment
  220   continue
c........is segment edge of polygon?
          iseg=gsegij(rp,cm,np,npb,npc,i,rp(1,i),scmi,cmi,tol,ni,
     *      phi,iord,jml,jmu,jpl,jpu,2,jm,jp,km,kp,phm,php,ph,dph)
c        error
          if (iseg.eq.-1) goto 420
c        not an edge
          if (iseg.eq.0) goto 220
c        gone full circle
          if (iseg.eq.2) goto 280
c        near multiple intersection
          if (dph.lt.dphmin) then
c        increment count of near multiple intersections
            nmult=nmult+1
c           warn=.true.
c           print *,
c    *        '*** warning from gspher: near multiple intersection at'
c    *        ,i,': segment',km(1),kp(1),' &',km(2),kp(2),' dph=',dph
          endif
c........segment satisfies conditions
c. . . . boundary terms
          dbound(1)=si*dph
          dbound(2)=(1._10/si-2._10*si)*dph
          bound(1)=bound(1)+dbound(1)
          bound(2)=bound(2)+dbound(2)
C         print *,'at',i,': edge',km(1),kp(1),' &',km(2),kp(2),
C    *     ' (',jm(1),' &',jm(2),' in',jml,jmu,',',
C    *     jp(1),' &',jp(2),' in',jpl,jpu,' of',ni,')'
C         print *,'dph/(2*pi)=',dph/TWOPI
C         print *,'dbound =',dbound(1),dbound(2),
C    *      ' bound =',bound(1),bound(2)
c. . . . vertex terms
          do l=1,2
            do iphbv=1,2
c        end point is intersection of i circle with k circle
              if (l.eq.1) then
                k=km(iphbv)
              elseif (l.eq.2) then
                k=kp(iphbv)
              endif
              if (k.eq.0) then
                psi(iphbv)=0._10
                ctpsi(iphbv)=1._10/psi(iphbv)
                t(iphbv)=0._10
c        cti = cot th(i)
                cti(iphbv)=(1._10-cmi)/si
                if (scmi.lt.0) cti(iphbv)=-cti(iphbv)
                if (iphbv.eq.2) cti(iphbv)=-cti(iphbv)
c        ctk = cot th(k)
                ctk(iphbv)=cti(iphbv)
              else
                cmk=abs(cm(k))
                sk=sqrt(cmk*(2._10-cmk))
c        cmik = 1-cos th(ik)
                cmik=((rp(1,i)-rp(1,k))**2+(rp(2,i)-rp(2,k))**2
     *            +(rp(3,i)-rp(3,k))**2)/2._10
c        bik = cik-ci*ck
c        d = 1-ci^2-ck^2-cik^2+2*ci*ck*cik
c        cos psi = bik/(si*sk)
c        sin psi = sqrt(d)/(si*sk)
c        psi = atan(sqrt(d)/bik) is exterior angle at intersection
                bik=(cmi+cmk)-cmi*cmk-cmik
                if ((scmi.ge.0.and.cm(k).lt.0._10)
     *            .or.(scmi.le.0.and.cm(k).ge.0._10)) bik=-bik
                if (iphbv.eq.2) bik=-bik
c        i and k circles kiss
                if (phi(1,k).eq.phi(2,k)) then
                  d=0._10
                else
                  d=-(cmi-cmk)**2+cmik*(2._10*((cmi+cmk)-cmi*cmk)-cmik)
c        assert that circles at least touch
                  if (d.lt.0._10) d=0._10
                  d=sqrt(d)
                endif
                ctpsi(iphbv)=bik/d
                psi(iphbv)=atan2(d,bik)
c        t=tan psi/2
                if (bik.gt.0._10) then
                  t(iphbv)=d/(bik+sqrt(bik**2+d**2))
                elseif (bik.lt.0._10) then
                  t(iphbv)=(-bik+sqrt(bik**2+d**2))/d
                elseif (bik.eq.0._10) then
                  t(iphbv)=1._10
                endif
c        cti = cot th(i)
                cti(iphbv)=(1._10-cmi)/si
                if (scmi.lt.0) cti(iphbv)=-cti(iphbv)
                if (iphbv.eq.2) cti(iphbv)=-cti(iphbv)
c        ctk = cot th(k)
                ctk(iphbv)=(1._10-cmk)/sk
                if (cm(k).lt.0._10) ctk(iphbv)=-ctk(iphbv)
              endif
            enddo
c        psi(3) = psi(1) + psi(2) - pi
            psi(3)=psi(1)+psi(2)-PI
c        cot psi(3)
            if (abs(ctpsi(1)).le.1._10) then
              if (abs(ctpsi(2)).le.1._10) then
                ctpsi(3)=(ctpsi(1)*ctpsi(2)-1._10)
     *            /(ctpsi(1)+ctpsi(2))
              else
                ctpsi(3)=(ctpsi(1)-1._10/ctpsi(2))
     *            /(ctpsi(1)/ctpsi(2)+1._10)
              endif
            else
              if (abs(ctpsi(2)).le.1._10) then
                ctpsi(3)=(ctpsi(2)-1._10/ctpsi(1))
     *            /(1._10+ctpsi(2)/ctpsi(1))
              else
                ctpsi(3)=(1._10-1._10/ctpsi(1)/ctpsi(2))
     *            /(1._10/ctpsi(2)+1._10/ctpsi(1))
              endif
            endif
c        tan psi(3)/2
            if (abs(t(1)).le.1._10) then
              if (abs(t(2)).le.1._10) then
                t(3)=(t(1)*t(2)-1._10)/(t(1)+t(2))
              else
                t(3)=(t(1)-1._10/t(2))/(t(1)/t(2)+1._10)
              endif
            else
              if (abs(t(2)).le.1._10) then
                t(3)=(t(2)-1._10/t(1))/(1._10+t(2)/t(1))
              else
                t(3)=(1._10-1._10/t(1)/t(2))/(1._10/t(2)+1._10/t(1))
              endif
            endif
            cti(3)=ctk(1)
            ctk(3)=ctk(2)
            do iphbv=1,3
              if (abs(psi(iphbv)).le.psitol) then
                dvert(1)=0._10
                dvert(2)=0._10
              else
                dvert(1)=1._10-psi(iphbv)*ctpsi(iphbv)
                dvert(2)=t(iphbv)*(3._10+t(iphbv)**2)
     *            *(cti(iphbv)+ctk(iphbv))/2._10
                dvert(1)=dvert(1)/2._10
                dvert(2)=dvert(2)/2._10
              endif
              if (iphbv.le.2) then
                vert(1)=vert(1)+dvert(1)
                vert(2)=vert(2)+dvert(2)
              else
                vert(1)=vert(1)-dvert(1)
                vert(2)=vert(2)-dvert(2)
              endif
C             print *,'vertex',i,k,' part ',iphbv,
C    *          ' psi =',psi(iphbv)
C             print *,'     dvert =',dvert(1),dvert(2),
C    *          ' vert =',vert(1),vert(2)
C             print *,' cot(',psi(iphbv),') =',1._10/tan(psi(iphbv)),
C    *          ' should =',ctpsi(iphbv)
C             print *,' tan(',psi(iphbv),'/2) =',tan(psi(iphbv)/2._10),
C    *          ' should =',t(iphbv)
C             print *,' cot(th_i) =',cti(iphbv),
C    *          ' cot(th_k) =',ctk(iphbv)
            enddo
          enddo
c        do another segment
        goto 220
      endif
  280 continue
c--------finish off
c        check angle is between 0 and 2*pi
      p=bound(1)/si/TWOPI
c     print *,rp(1,i),rp(2,i),rp(3,i),'angle/(2*pi)=',p
      if (p.lt.0._10) then
        print *,'*** from gphbv: angle/(2*pi)=',p,
     *    '  should be .ge. 0'
        warn=.true.
      elseif (p.gt.1._10) then
        if (bound(1)/si.le.TWOPI+bndtol) then
          continue
        else
          print *,'*** from gphbv: angle/(2*pi)=',p,
     *      '  should be .le. 1'
          warn=.true.
        endif
      endif
      if (warn) then
        print *,'boundary',i
        write (*,'(a3,a20,4a24)')
     *    ' ','x','y','z',
c    *    'r',
     *    '1-c'
        do j=1,np
          write (*,'(i3,5g24.16)')
     *      j,(rp(i,j),i=1,3),
c    *      sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *      cm(j)
        enddo
      endif
  410 continue
C     print *,'final bound =',bound(1),bound(2),
C    *  ' vert =',vert(1),vert(2)
C     print *,'....................'
      return
c
  420 continue
      print *,'*** from gphbv: total failure at tol =',tol
      write (*,'(a3,a20,4a24)')
     *  ' ','x','y','z',
c    *  'r',
     *  '1-c'
      do j=1,np
        write (*,'(i3,5g24.16)')
     *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *    cm(j)
      enddo
C     print *,'....................'
      return
c
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      real*10 function twodf100k(ra,dec)
      real*10 ra,dec
c
c        parameters
      include 'pi.par'
      real*10 RADIAN
      parameter (RADIAN=180._10/PI)
c        data variables
C     logical init
C     real magcut
c        local (automatic) variables
      real rar,decr,compl,maglim
c *
c * Completeness of 30 June 2001 2dF 100k galaxy survey.
c * This is an interface to
c * the 2dFGRS mask software by Peder Norberg and Shaun Cole.
c *
c * WARNING:
c * There is a hard-wired magnitude cut.
c * Comment it out if you don't want it.
c *
c  Input: ra, dec = RA & Dec (B1950) in degrees.
c Output: twodf100k: 0 = empty to 1 = complete.
c
C     data init /.true./
c This magnitude cut gives the maximum number of survivors
C     data magcut /19.27/

c convert from real*10 degrees to real*4 radians
      rar=ra
      decr=dec
      if (rar.lt.0.) rar=rar+360.
      if (rar.lt.0.) rar=rar+360.
      rar=rar/RADIAN
      decr=decr/RADIAN
c
c the 2dFGRS mask software by Peder Norberg and Shaun Cole
      call in_2df_mask(rar,decr,compl,maglim)

c compl = -1. means the position is outside the main 2dF boundary
      if (compl.eq.-1.) then
        twodf100k=0._10

c compl = -2. means the position is inside a drill hole
      elseif (compl.eq.-2.) then
        twodf100k=0._10

c discard fields with limiting magnitude brighter than magcut
C COMMENT THIS OUT IF YOU DON'T WANT IT
C     elseif (maglim.lt.magcut) then
C       if (init) then
C         write (*,'(" WARNING from twodf100k: USING HARD-WIRED MAGNITUDE CU
C    *T OF ",f5.2)') magcut
C         init=.false.
C       endif
C       twodf100k=0._10

c standard
      else

c completeness
        twodf100k=compl

c magnitude limit
c       twodf100k=maglim

      endif

c completeness: round to 8 decimal places
      twodf100k=dble(nint(twodf100k*1.e8_10))/1.e8_10

c     print *,ra,dec,compl,maglim,twodf100k
c
      return
      end
c
c=======================================================================
c
c The remaining code below is (with minor modifications)
c the mask_compl.f subroutine provided by the 2dFGRS team
c in the 30 June 2001 public release of data at
c http://www.mso.anu.edu.au/2dFGRS/Public/Release/index.html
c
c The minor modifications are options to read/write
c formatted as well as fortran unformatted data.
c
c The documentation at
c http://www.mso.anu.edu.au/2dFGRS/Public/Release/Masks/index.html
c states the following:
c
c 2. Copyright and use of the mask codes
c    As a user of the mask codes, we request that you observe the following guidelines:
c    The code provided here has been written by several members of the 2dFGRS team.
c    Peder Norberg and Shaun Cole (University of Durham, UK) wrote the
c    software used to create the survey masks.
c    If you use any part of this 2dFGRS software, please acknowledge
c    "the 2dFGRS mask software by Peder Norberg and Shaun Cole".
c    This code is supplied as-is (i.e. we do not support any modifications
c    to the file mask_compl.f containing the subroutines) and without guarantees
c    - use it with caution and report any bugs.
c    Read all of this documentation before trying to use the code!
c
c-----------------------------------------------------------------------------
c     For a given position in ra & dec, this subroutine tells if this
c     position is inside the 2df_mask or not, by returning the actual
c     completeness. It returns in the same time the corresponding
c     magnitude limit.

      subroutine in_2df_mask(ra,dec,compl,maglim)
*************************************variables********************************
      implicit none

      real ra,dec,compl,maglim

      integer np_x,np_y
      parameter (np_x=1800,np_y=600)
      integer np_xx,np_yy,ifirst,ix,iy,np,sgn
      real rpix(np_x,np_y),magpix(np_x,np_y),x,y,z,rx,ry
      character name_mask*20,last_reg*3,reg*3
      save ifirst,np_xx,np_yy,np,rpix,magpix,last_reg
      data ifirst/1/
******************************************************************************

c     Everytime check which region one points to: either ngp, sgp or ran
      call which_reg(ra,dec,reg)

      if (reg.eq.'ran') then
         call in_2df_ran(ra,dec,compl,maglim)
         return
      endif

c     On the first call, the program reads the mask
      if ((ifirst.eq.1).or.(last_reg.ne.reg)) then
         ifirst=0
         last_reg=reg
         name_mask='mask.'//reg//'.dat'
         call read_mask(rpix,np_xx,np_yy,name_mask,np_x,np_y,np)
         name_mask='maglim.'//reg//'.dat'
         call read_mask(magpix,np_xx,np_yy,name_mask,np_x,np_y,np)
c         write(0,*) 'Read masks for ',reg,' region!'
      endif

      call radec_xyz(ra,dec,x,y,z)
      call eq_2dfrx(np,x,y,z,rx,ry,sgn)
      call rx_ix_map(rx,ry,ix,iy)

      if ((ix.ge.1).and.(ix.le.np_xx).and.
     :    (iy.ge.1).and.(iy.le.np_yy)) then
         compl=rpix(ix,iy)
         maglim=magpix(ix,iy)
      else
         compl= -1.0  !default value (i.e. outside 2dF boundary)
         maglim=-2.0  !default value (i.e. outside 2dF boundary)
      endif

      return
      end

c-----------------------------------------------------------------------------
c     For a given position in ra & dec, this subroutine tells if this
c     position is inside one of the used random fields or not, by returning
c     the actual completeness of the field.

      subroutine in_2df_ran(ra,dec,compl,maglim)
*************************************variables********************************
      implicit none

      real ra,dec,compl,maglim

      integer nmax,NP,NPX,NPY
      real theta_min
      parameter (nmax=98,NP=2400,NPX=50,NPY=50,theta_min=1.014)
      logical in
      integer i,ifirst,nb_field,io
      real costheta,costheta_r,costheta_min,xc(nmax),yc(nmax),zc(nmax)
     &,    comp(nmax),r,x,y,z,magpix(nmax,NPX,NPY)
      character name_mask*20
      data ifirst/1/
      save ifirst,nb_field,xc,yc,zc,comp,costheta_min,magpix
******************************************************************************

c     On the first call, reads the file containing the random fields
      if (ifirst.eq.1) then
         ifirst=0
         name_mask='mask.ran.dat'
         call ran2df_cen_used(nb_field,xc,yc,zc,comp,name_mask)
         name_mask='maglim.ran.dat'
         call readranmask(name_mask,NPX,NPY,nmax,magpix)
         costheta_min=cos(theta_min*atan(1.)/45.)
c         write(0,*) 'Read mask for ran region!'
      endif

      i=0
      in=.false.
      call radec_xyz(ra,dec,x,y,z)
      r=sqrt(x**2+y**2+z**2)
      costheta_r=costheta_min*r
      do while ((.not.in).and.(i.lt.nb_field))
         i=i+1
         costheta=(x*xc(i)+y*yc(i)+z*zc(i))
         if (costheta.gt.costheta_r) then   ! We use here the fact the random
            in=.true.                       ! fields doesn't overlapp with
         endif                              ! each other...
      enddo

      if (in) then
         call holes_2df_xyz(x,y,z,io)
c         compl=comp(i)*real(io)       ! io = 0 if in a hole; 1 otherwise
         if (io.eq.0) then
            compl=-2.           ! default value in holes
            maglim=-2.          ! default value when not specified
         else
            compl=comp(i)
            call get_maglimran(NP,NPX,NPY,x,y,z,xc(i),yc(i),zc(i),maglim
     &,                        nmax,magpix,i)
         endif


      else
         compl=-1.              ! default value (ie. outside 2dF boundary)
         maglim=-2.             ! default value (when not specified)
      endif

      return
      end

c----------------------------------------------------------------------------
c     Given x,y,z position and centre of the corresponding random field,
c     returns the magnitude limit at that position
      subroutine get_maglimran(NP,NPX,NPY,x,y,z,xc,yc,zc,maglim
     &,                        nmax,magpix,ifield)

      implicit none

      integer NP,NPX,NPY,nmax,ifield
      real x,y,z,xc,yc,zc,maglim,magpix(nmax,NPX,NPY)

      intrinsic max,min

      integer sgn,ixc_min,iyc_min,ix,iy
      real rx,ry

c      integer ifirst,max_ix,max_iy,min_ix,min_iy,inum
c      data ifirst/-1/
c      save ifirst,max_ix,max_iy,min_ix,min_iy,inum

c      if (ifirst.eq.-1) then
c         ifirst=0
c         inum=0
c         max_ix=0
c         min_ix=NPX
c         max_iy=0
c         min_iy=NPY
c      endif

c      ifirst=ifirst+1
      call eq_2dfrx(NP,xc,yc,zc,rx,ry,sgn)
      call bound_map_ran(NPX,NPY,rx,ry,ixc_min,iyc_min)

      call eq_2dfrx(NP,x,y,z,rx,ry,sgn)
      call rx_ix_map(rx,ry,ix,iy)

      ix=min(max(1,ix-ixc_min),NPX)
      iy=min(max(1,iy-iyc_min),NPY)
c      ix = ix-ixc_min
c      iy = iy-iyc_min
c      if ((ix.ge.1).and.(ix.le.NPX).and.(iy.ge.1).and.(iy.le.NPY)) then
         maglim=magpix(ifield,ix,iy)
c      else
c         write(*,*) 'ix=',ix,'iy=',iy,ifield
c         max_ix=max(ix,max_ix)
c         min_ix=min(ix,min_ix)
c         max_iy=max(iy,max_iy)
c         min_iy=min(iy,min_iy)
c         maglim=1.0
c         inum=inum+1
c      endif
c
c      if (ifirst.ge.57012) then
c         write(*,*) ifirst,inum,max_ix,max_iy,min_ix,min_iy
c      endif

      return
      end

c----------------------------------------------------------------------------
c     Given ra & dec determines which region to look at
      subroutine which_reg(ra,dec,reg)
*************************************variables********************************
      implicit none

      real ra,dec
      character reg*(*)

      real EPS
      parameter (EPS=1.e-5)
      integer i,ifirst,nb_strip,nb_stripsgp,nb_stripngp
      real ra_min(4),ra_max(4),dec_min(4),dec_max(4)
      data ifirst/1/
      save ra_min,ra_max,dec_min,dec_max,nb_strip,nb_stripsgp
     &,    nb_stripngp,ifirst
******************************************************************************

      if (ifirst.eq.1) then
         ifirst=0
         nb_stripsgp=3
         nb_stripngp=4
         nb_strip=5
c        SGP strips
         ra_min(1)= 5.711590    ! 21h49m
         ra_max(1)= 0.911935    !  3h29m
         dec_min(1)= -0.479966  ! -27.5 deg
         dec_max(1)= -0.392699  ! -22.5 deg
         ra_min(2)= 5.670138    ! 21h39.5m
         ra_max(2)= 0.975203    !  3h43.5m
         dec_min(2)= -0.567232  ! -32.5 deg
         dec_max(2)= -0.479966  ! -27.5 deg
         ra_min(3)= 5.707227    ! 21h48m
         ra_max(3)= 0.890118    !  3h24m
         dec_min(3)= -0.654498  ! -37.5 deg
         dec_max(3)= -0.567232  ! -32.5 deg
c        NGP strips
         ra_min(4)= 2.574361    !  9h50m
         ra_max(4)= 3.883358    ! 14h50m
         dec_min(4)= -0.130900  !  -7.5 deg
         dec_max(4)= +0.043633  !  +2.5 deg
c        Make boundaries more secure
         do i=1,4
            ra_min(i)=ra_min(i)-EPS
            ra_max(i)=ra_max(i)+EPS
            dec_min(i)=dec_min(i)-EPS
            dec_max(i)=dec_max(i)+EPS
         enddo
      endif

      i=0
      do while (i.lt.nb_stripsgp)
         i=i+1
         if (((ra_min(i).le.ra).or.(ra_max(i).ge.ra)).and.
     &        (dec_min(i).le.dec).and.(dec_max(i).ge.dec)) then
            i=nb_strip
            reg='sgp'
         endif
      enddo

      do while (i.lt.nb_stripngp)
         i=i+1
         if ((ra_min(i).le.ra).and.(ra_max(i).ge.ra).and.
     &        (dec_min(i).le.dec).and.(dec_max(i).ge.dec)) then
            i=nb_strip
            reg='ngp'
         endif
      enddo

      if (i.ne.nb_strip) reg='ran'

      return
      end

c----------------------------------------------------------------------------
c  Subroutine to read the 2dF mask
c
      subroutine  read_mask(mask,np_xx,np_yy,name_mask,np_x,np_y,np)
*************************************variables********************************
      implicit none

      integer np_x,np_y,np_xx,np_yy,np
      real mask(np_x,np_y)
      character name_mask*(*)

      integer ix,iy

      integer access,lnblnk
      character*1 go
      character*128 dat
      logical NP_set,ok
      logical ex
      character*3 re
******************************************************************************

      dat=name_mask(1:lnblnk(name_mask))//'.fmt'

      ok=.false.

c try unformatted
      inquire(FILE=name_mask, EXIST=ex, READ=re)
      if (ex.and.(re.eq.'YES')) then
c      if (access(name_mask,' r').eq.0) then
        open(11,file=name_mask,status='old',form='unformatted')
        rewind(11)
        read(11,end=200,err=200) np_xx,np_yy
        ok=NP_set(np_xx,np_yy,np,0)
        if (.not.ok) then
          print *,'try formatted version of file instead ...'
          close(11)
          goto 200
        endif
        ok=.false.
        if ((np_xx.gt.np_x).or.(np_yy.gt.np_y)) then
           write(0,*) 'Dimension of the mask too big!'
           write(0,*) ' Mask: NPX= ',np_xx,' NPY= ',np_yy
           print *,'try formatted version of file instead ...'
           close(11)
           goto 200
        endif
        do ix=1,np_xx
          read(11,end=200,err=200) (mask(ix,iy),iy=1,np_yy)
        enddo
        print *,np_xx,' x',np_yy,' values read from ',
     *    name_mask(1:lnblnk(name_mask))
        close(11)
        ok=.true.

c COMMENT THIS OUT IF YOU DON'T WANT IT
C        inquire(FILE=dat, EXIST=ex)
C        if (.not.ex) then
Cc       if (access(dat,' ').ne.0) then
C         print *,'write FORMATTED values? [CR,n=no, y=yes]'
C         read (*,'(a1)',end=150,err=150) go
C         if (go.eq.'y'.or.go.eq.'Y') then
C           open(11,file=dat)
C           write(11,'(2i8)') np_xx,np_yy
C           do ix=1,np_xx
C             write (11,'(5g16.8)') (mask(ix,iy),iy=1,np_yy)
C           enddo
C           print *,np_xx,' x',np_yy,' values written to ',
C    *        dat(1:lnblnk(dat))
C           close(11)
C         endif
C 150     continue
C       endif

      endif

c try formatted
  200 if (.not.ok) then
         inquire(FILE=dat, EXIST=ex)
         if (.not.ex) goto 300
c        if (access(dat,' ').ne.0) goto 300
        open(11,file=dat)
        rewind(11)
        read(11,'(2i8)') np_xx,np_yy
        ok=NP_set(np_xx,np_yy,np,0)
        if (.not.ok) goto 300
        ok=.false.
        if ((np_xx.gt.np_x).or.(np_yy.gt.np_y)) then
          write(0,*) 'Dimension of the mask too big!'
          write(0,*) ' Mask: NPX= ',np_xx,' NPY= ',np_yy
          close(11)
          goto 300
        endif
        do ix=1,np_xx
          read (11,'(5g16.8)') (mask(ix,iy),iy=1,np_yy)
        enddo
        print *,np_xx,' x',np_yy,' values read from ',
     *    dat(1:lnblnk(dat))
        close(11)
        ok=.true.

c COMMENT THIS OUT IF YOU DON'T WANT IT
        inquire(FILE=name_mask, EXIST=ex)
        if (.not.ex) then
c       if (access(name_mask,' ').ne.0) then
         print *,'write UNFORMATTED values? [CR,n=no, y=yes]'
         read (*,'(a1)',end=250,err=250) go
         if (go.eq.'y'.or.go.eq.'Y') then
           open(11,file=name_mask,form='unformatted')
           write(11) np_xx,np_yy
           do ix=1,np_xx
             write(11) (mask(ix,iy),iy=1,np_yy)
           enddo
           print *,np_xx,' x',np_yy,' values written to from ',
     *          name_mask(1:lnblnk(name_mask))
           close(11)
         endif
 250     continue
       endif

      endif
c
      return
c
c error
  300 print *,'failed to read unformatted data from ',
     *  name_mask(1:lnblnk(name_mask))
      print *,'or formatted data from ',
     *  dat(1:lnblnk(dat))
      inquire(FILE=name_mask, EXIST=ex, READ=re)
      if (ex.and.(re.eq.'YES')) then
c      if (access(name_mask,' r').eq.0) then
        print *,'you may have a problem with endianness;'
        print *,'please read HELP.unformatted in the mangle directory'
      endif
      stop
c
      end

c----------------------------------------------------------------------------
      subroutine readranmask(namemask,NPX,NPY,nbf,rpix)

c     This subroutine reads the mask stored in the file name_mask.
c     N.B.: This subroutine contains the same stuff as mask_2df, but has the
c     advantage of giving back also sgn!

      implicit none

      integer nbf,NPX,NPY
      real rpix(nbf,NPX,NPY)
      character namemask*(*)

      integer i,j,k,npxx,npyy,nbff

      integer access,lnblnk
      character*1 go
      character*128 dat
      logical ok
      logical ex
      character*3 re

      ok=.false.

      dat=namemask(1:lnblnk(namemask))//'.fmt'

c try unformatted
      inquire(FILE=namemask, EXIST=ex, READ=re)
      if (ex.and.(re.eq.'YES')) then
c     if (access(namemask,' r').eq.0) then
         open(unit=14,file=namemask,status='old',form='unformatted')
         rewind(14)
         read(14,end=200,err=200) nbff,npxx,npyy
         if ((npxx.ne.NPX).or.(npyy.ne.NPY).or.(nbff.ne.nbf)) then
            write(*,*) 'Wrong dimensions for ran mask. Should have:'
     &           ,             npxx,npyy,nbff
            print *,'try formatted version of file instead ...'
            close(14)
            goto 200
         endif
         do k=1,nbff
            do i=1,npxx
               read(14,end=200,err=200) (rpix(k,i,j),j=1,npyy)
            enddo
         enddo
         print *,nbff,' x',npxx,' x',npyy,
     *        ' values read from ',namemask(1:lnblnk(namemask))
         ok=.true.
         close(14)

c     COMMENT THIS OUT IF YOU DON'T WANT IT
C     inquire(FILE=dat, EXIST=ex)
C     if (.not.ex) then
Cc       if (access(dat,' ').ne.0) then
C         print *,'write FORMATTED values? [CR,n=no, y=yes]'
C         read (*,'(a1)',end=150,err=150) go
C         if (go.eq.'y'.or.go.eq.'Y') then
C           open(14,file=dat)
C           write(14,'(3i8)') nbff,npxx,npyy
C           do k=1,nbff
C             do i=1,npxx
C               write (14,'(5g16.8)') (rpix(k,i,j),j=1,npyy)
C             enddo
C           enddo
C           print *,nbff,' x',npxx,' x',npyy,
C    *        ' values written to ',dat(1:lnblnk(dat))
C           close(14)
C         endif
C 150     continue
C       endif

      endif

c try formatted
 200  if (.not.ok) then
         inquire(FILE=dat, EXIST=ex)
         if (.not.ex) goto 300
c        if (access(dat,' ').ne.0) goto 300
        open(unit=14,file=dat)
        rewind(14)
        read(14,'(3i8)') nbff,npxx,npyy
        if ((npxx.ne.NPX).or.(npyy.ne.NPY).or.(nbff.ne.nbf)) then
          write(*,*) 'Wrong dimensions for ran mask. Should have:'
     &  ,             npxx,npyy,nbff
          goto 300
        endif
        do k=1,nbff
          do i=1,npxx
            read (14,'(5g16.8)') (rpix(k,i,j),j=1,npyy)
          enddo
        enddo
        print *,nbff,' x',npxx,' x',npyy,
     *    ' values read from ',dat(1:lnblnk(dat))
        close(14)
        ok=.true.

c COMMENT THIS OUT IF YOU DON'T WANT IT
         inquire(FILE=namemask, EXIST=ex)
         if (.not.ex) then
c       if (access(namemask,' ').ne.0) then
         print *,'write UNFORMATTED values? [CR,n=no, y=yes]'
         read (*,'(a1)',end=250,err=250) go
         if (go.eq.'y'.or.go.eq.'Y') then
           open(14,file=namemask,form='unformatted')
           write(14) nbff,npxx,npyy
           do k=1,nbff
             do i=1,npxx
               write (14) (rpix(k,i,j),j=1,npyy)
             enddo
           enddo
           print *,nbff,' x',npxx,' x',npyy,
     *          ' values written to ',namemask(1:lnblnk(namemask))
           close(14)
         endif
 250     continue
       endif

      endif
c
      return
c
c error
  300 print *,'failed to read unformatted data from ',
     *  namemask(1:lnblnk(namemask))
      print *,'or formatted data from ',
     *  dat(1:lnblnk(dat))
      inquire(FILE=namemask, EXIST=ex, READ=re)
      if (ex.and.(re.eq.'YES')) then
c      if (access(namemask,' r').eq.0) then
        print *,'you may have a problem with endianness;'
        print *,'please read HELP.unformatted in the mangle directory'
      endif
      stop
c
      end

c-----------------------------------------------------------------------------
c     This subroutine reads the used 2dF random field centres from the file
c     name, which contains also the overall completeness of the field (with
c     respect to the underlying density field). Read the information written
c     by write_ran2df_cen.
      subroutine ran2df_cen_used(nb_field,xc,yc,zc,comp,name)
*************************************variables********************************
      implicit none

      integer nb_field
      real xc(*),yc(*),zc(*),comp(*)
      character name*(*)

      integer i

      integer access,lnblnk
      character*1 go
      character*128 dat
      logical ok
      logical ex
      character*3 re

******************************************************************************

      dat=name(1:lnblnk(name))//'.fmt'

      ok=.false.

c try unformatted
      inquire(FILE=name, EXIST=ex, READ=re)
      if (ex.and.(re.eq.'YES')) then
c      if (access(name,' r').eq.0) then
        open(unit=11,file=name,status='old',form='unformatted')
        rewind(11)
        read(11,end=200,err=200) nb_field
        read(11,end=200,err=200) (xc(i),i=1,nb_field)
        read(11,end=200,err=200) (yc(i),i=1,nb_field)
        read(11,end=200,err=200) (zc(i),i=1,nb_field)
        read(11,end=200,err=200) (comp(i),i=1,nb_field)
        print *,nb_field,' x y z w values read from ',
     *    name(1:lnblnk(name))
        close(11)
        ok=.true.

c COMMENT THIS OUT IF YOU DON'T WANT IT
C         inquire(FILE=dat, EXIST=ex)
C         if (.not.ex) then
Cc       if (access(dat,' ').ne.0) then
C         print *,'write FORMATTED values? [CR,n=no, y=yes]'
C         read (*,'(a1)',end=150,err=150) go
C         if (go.eq.'y'.or.go.eq.'Y') then
C           open(11,file=dat)
C           write(11,'(i8," fields")') nb_field
C           do i=1,nb_field
C             write (11,'(4g16.8)') xc(i),yc(i),zc(i),comp(i)
C           enddo
C           print *,nb_field,' lines written to ',dat(1:lnblnk(dat))
C           close(11)
C         endif
C 150     continue
C       endif

      endif

c try formatted
  200 if (.not.ok) then
         inquire(FILE=dat, EXIST=ex)
         if (.not.ex) goto 300
c        if (access(dat,' ').ne.0) goto 300
        open(11,file=dat)
        rewind(11)
        read(11,'(i8)') nb_field
        do i=1,nb_field
          read (11,'(4g16.8)') xc(i),yc(i),zc(i),comp(i)
        enddo
        print *,nb_field,' lines read from ',dat(1:lnblnk(dat))
        close(11)
        ok=.true.

c COMMENT THIS OUT IF YOU DON'T WANT IT
         inquire(FILE=name, EXIST=ex)
         if (.not.ex) then
c       if (access(name,' ').ne.0) then
         print *,'write UNFORMATTED values? [CR,n=no, y=yes]'
         read (*,'(a1)',end=250,err=250) go
         if (go.eq.'y'.or.go.eq.'Y') then
           open(unit=11,file=name,form='unformatted')
           write(11) nb_field
           write(11) (xc(i),i=1,nb_field)
           write(11) (yc(i),i=1,nb_field)
           write(11) (zc(i),i=1,nb_field)
           write(11) (comp(i),i=1,nb_field)
           close(11)
           print *,nb_field,' x y z w values written to ',
     *          name(1:lnblnk(name))
        endif
 250    continue
      endif

      endif

      return
c
c error
  300 print *,'failed to read unformatted data from ',
     *  name(1:lnblnk(name))
      print *,'or formatted data from ',
     *  dat(1:lnblnk(dat))
      inquire(FILE=name, EXIST=ex, READ=re)
      if (ex.and.(re.eq.'YES')) then
c      if (access(name,' r').eq.0) then
        print *,'you may have a problem with endianness;'
        print *,'please read HELP.unformatted in the mangle directory'
      endif
      stop
c
      end

c-----------------------------------------------------------------------------
c     Convert an equatorial cartesian coordinate to the rx,ry pixel
c     coordinate used for the 2df mask. This subroutine is valid for both
c     sgp and ngp elements.
c
c
      subroutine  eq_2dfrx(NP,x,y,z,rx,ry,sgn)
*************************************variables********************************
      implicit none
      intrinsic abs
      real x,y,z,r,PI,EPS
      parameter (EPS=3.e-13)
      integer ifirst,sgn,NP,ix_min,iy_min
      real racen,sc,deccen,rx,ry
      double precision costheta
      real xc,yc,zc,phi,dec_gc,ra_gc,xgc,ygc,zgc,sintheta_2
     & ,xgp,ygp,zgp,xx,yy,zz,phi0
      save ifirst,sc,xc,yc,zc,xgc,ygc,zgc,xgp,ygp,zgp,phi0,PI !ix_min,iy_min
      data ifirst/1/
******************************************************************************

c     On the first call define the values which define the
c     centre, orientation and scale of the transformation
      if (ifirst.eq.1) then
         ifirst=0
         PI= atan(1.)*4.
c        This is the direction of the Galactic Centre as adopted
c        by Steve Maddox
         racen  = 12.3*PI/180.0
         deccen = -27.5*PI/180.0
         sc = 120.0*PI/180.0
         xc=cos(deccen)*cos(racen)
         yc=cos(deccen)*sin(racen)
         zc=sin(deccen)
c        This is a direction perpendicular to above but otherwise
c        arbitrary provided that the phi0 has then been correctly
c        set to be the offset between this arbitrary direction and
c        that used for the projection of the APM SGP region
         ra_gc   = -94.40593*PI/180.0
         dec_gc  = -28.90771*PI/180.0
         phi0=236.97694*PI/180.0
         xgc=cos(dec_gc)*cos(ra_gc)
         ygc=cos(dec_gc)*sin(ra_gc)
         zgc=sin(dec_gc)
c        Generate the mutually perpendicular unit vector via
c        the cross product
         xgp = yc*zgc-zc*ygc
         ygp = zc*xgc-xc*zgc
         zgp = xc*ygc-yc*xgc
      endif

c     Section utilized on each call
c     Find components in the new 3D Cartesian system
      r=sqrt(x**2+y**2+z**2)
      zz=(x*xc+y*yc+z*zc)
      xx=(x*xgc+y*ygc+z*zgc)
      yy=(x*xgp+y*ygp+z*zgp)

c     Compute corresponding spherical polar angles
      costheta= abs(dble(zz)/dble(r))
      sgn=int(sign(1.,zz/r)) ! tells if x,y,z is in the ngp or sgp region
      phi=phi0-atan2(yy,xx)
      if (phi.gt.2.0*PI) phi=phi-2.0*PI

c     Apply the Zenithal Equal Area Projection
      if (sngl(dble(1.0)-costheta).ge.EPS) then
         sintheta_2=sngl(dsqrt(dble(0.5)*(dble(1.0)-costheta)))
      else
         sintheta_2=0.
      endif
      r=2.*sintheta_2 !If sc changes, change this like:r=sintheta_2/sin(sc/4.)

c     convert to x,y coordinate
      xx=-r*sin(phi)*real(NP)*0.5
      yy= r*cos(phi)*real(NP)*0.5

      call bound_map_2df(NP,sgn,ix_min,iy_min)

      rx=xx+0.5*real(NP)-1.*real(ix_min)
      ry=-yy+0.5*real(NP)-1.*real(iy_min)

      return
      end

c-----------------------------------------------------------------------------
c     Convert the pixel postion rx,ry to ra and dec.
c     This subroutine is the inverse of eq_2dfrx. Works for both ngp and sgp,
c     as long as the sgn is given (respectively by -1 and 1).

      subroutine inv_eq_2dfrx(NP,rx,ry,sgn,x,y,z)
************************************variables*********************************
      implicit none
      intrinsic abs
      real x,y,z,r,PI,EPS,EPS2,a(3,3),PI_hf,PI_3hf
      parameter (EPS=3.e-13)
      integer ifirst,sgn,NP,iy_min,ix_min
      real racen,sc,deccen,costheta,rx,ry,delta_phi
     & ,xc,yc,zc,phi,dec_gc,ra_gc,xgc,ygc,zgc,sintheta_2
     & ,xgp,ygp,zgp,xx,yy,zz,phi0
      save ifirst,sc,phi0,PI,EPS2,a,PI_hf,PI_3hf,xc,yc,zc   !ix_min,iy_min
      data ifirst/1/
******************************************************************************

c     On the first call define the values which define the
c     centre, orientation and scale of the transformation
      if (ifirst.eq.1) then
         ifirst=0
         EPS2=sqrt(0.5*EPS)
         PI= atan(1.)*4.
         PI_hf=PI/2.
         PI_3hf=3.*PI/2.
c        This is the direction of the Galactic Centre as adopted
c        by Steve Maddox
         racen  = 12.3*PI/180.0
         deccen = -27.5*PI/180.0
         sc = 120.0*PI/180.0
         xc=cos(deccen)*cos(racen)
         yc=cos(deccen)*sin(racen)
         zc=sin(deccen)
c        This is a direction perpendicular to above but otherwise
c        arbitrary provided that the phi0 has then been correctly
c        set to be the offset between this arbitrary direction and
c        that used for the projection of the APM SGP region
         ra_gc   = -94.40593*PI/180.0
         dec_gc  = -28.90771*PI/180.0
         phi0=236.97694*PI/180.0
         xgc=cos(dec_gc)*cos(ra_gc)
         ygc=cos(dec_gc)*sin(ra_gc)
         zgc=sin(dec_gc)
c        Generate the mutually perpendicular unit vector via
c        the cross product
         xgp = yc*zgc-zc*ygc
         ygp = zc*xgc-xc*zgc
         zgp = xc*ygc-yc*xgc
c        Define Matrix a which is the inverse (transpose) of the base matrix
         a(1,1)=xc
         a(1,2)=xgc
         a(1,3)=xgp
         a(2,1)=yc
         a(2,2)=ygc
         a(2,3)=ygp
         a(3,1)=zc
         a(3,2)=zgc
         a(3,3)=zgp
      endif

c     Section utilized on each call
      call bound_map_2df(NP,sgn,ix_min,iy_min)

      xx=rx+1.*real(ix_min)-0.5*real(NP)
      yy=-ry-1.*real(iy_min)+0.5*real(NP)

      if ((xx.eq.0.).and.(yy.eq.0.)) then
         x=xc*real(sgn)
         y=yc*real(sgn)
         z=zc*real(sgn)
         return
      endif

      phi=atan2(-xx,yy)+2.*PI
      if (xx.eq.0.) then
         r=yy/(cos(phi)*real(NP)*0.5)
      else if (yy.eq.0.) then
         r=-xx/(sin(phi)*real(NP)*0.5)
      else if (    ((sgn.eq. 1).and.(abs(xx).gt.50.))
     &         .or.((sgn.eq.-1).and.(abs(yy).lt.50.))) then
         r=-xx/(sin(phi)*real(NP)*0.5)
      else
        r=yy/(cos(phi)*real(NP)*0.5)
      endif

      sintheta_2=r*0.5!If sc changes, change like this:sintheta_2=r*sin(sc/4.)
      if (sintheta_2.gt.EPS2) then
         costheta=sngl((dble(1.)-dble(2.*sintheta_2**2)))*real(sgn)
      else
         costheta=1.*real(sgn)
      endif

      zz=costheta
      if (zz.gt.1.)  zz= 1. ! rounding error corrections
      if (zz.lt.-1.) zz=-1.

      delta_phi=phi0-phi
      if (delta_phi.lt.0.) delta_phi=delta_phi+2.*PI
      if ((delta_phi.le.PI_hf).or.(delta_phi.ge.PI_3hf)) then ! xx is positive
         xx=sqrt((1.-zz**2)/(1.+tan(delta_phi)**2))
         yy=xx*tan(delta_phi)
      else                                                    ! xx is negative
         xx=-sqrt((1.-zz**2)/(1.+tan(delta_phi)**2))
         yy=xx*tan(delta_phi)
      endif

      x=a(1,1)*zz+a(1,2)*xx+a(1,3)*yy
      y=a(2,1)*zz+a(2,2)*xx+a(2,3)*yy
      z=a(3,1)*zz+a(3,2)*xx+a(3,3)*yy

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine contains the boundaries of the sgp and ngp pixel map.
c     It returns the ix_min and iy_min which are the offsets of the two maps.

      subroutine bound_map_2df(NP,sgn,ix_min,iy_min)
******************************************************************************
      implicit none

      integer NP,sgn,ix_min,iy_min
******************************************************************************

      if (sgn.eq.1) then        ! use the sgp map
         ix_min=NP*15/100
         iy_min=NP*44/100
      else if (sgn.eq.-1) then  ! use the ngp map
         ix_min=NP*7/100
         iy_min=NP*60/100
      endif

      return
      end

c----------------------------------------------------------------------------
c This subroutine gives the right boundaries for each random field mask, ie.
c calculates the offset needed such that the pixel center of each random
c field, given by (rxc,ryc), is located at (NPX_ran/2, NPY_ran/2) .
c
      subroutine bound_map_ran(NPX_ran,NPY_ran,rxc,ryc,ixc_min,iyc_min)

      implicit none

      integer NPX_ran,NPY_ran,ixc_min,iyc_min
      real rxc,ryc

      integer ixc,iyc


      call rx_ix_map(rxc,ryc,ixc,iyc)
      ixc_min=ixc-int(NPX_ran/2)
      iyc_min=iyc-int(NPY_ran/2)

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine converts real pixel coordinates rx,ry to integer
c     ix,iy pixel coordinates.

      subroutine rx_ix_map(rx,ry,ix,iy)
******************************************************************************
      implicit none

      integer ix,iy
      real rx,ry
******************************************************************************

      ix=int(rx+0.5)
      iy=int(ry+0.5)

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine converts integer pixel coordinates ix,iy to real
c     rx,ry pixel coordinates which corresponds to the center of the pixel.

      subroutine ix_rx_map(ix,iy,rx,ry)
******************************************************************************
      implicit none

      integer ix,iy
      real rx,ry
******************************************************************************

      rx=real(ix)
      ry=real(iy)

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine transforms x,y & z cartesian coordinates to ra & dec.

      subroutine xyz_radec(x,y,z,ra,dec)
******************************************************************************
      implicit none

      real x,y,z,ra,dec

      real PI2
      parameter (PI2=6.2831853072)
      real zz
******************************************************************************

      zz=sqrt(x**2+y**2+z**2)
      dec= asin(z/zz)
      if (y.lt.0) then
         ra= atan2(y,x)+PI2
      else
         ra= atan2(y,x)
      endif

      return
      end

c-----------------------------------------------------------------------------
c This subroutine transforms ra & dec into x,y & z cartesian coordinates.

      subroutine radec_xyz(ra,dec,x,y,z)
******************************************************************************
      implicit none

      real x,y,z,ra,dec
******************************************************************************

      x=cos(dec)*cos(ra)
      y=cos(dec)*sin(ra)
      z=sin(dec)

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine sets and checks that NP and NPX_NPY are correct and that
c     they correspond to the value used for NPX and NPY, the dimensions of the
c     pixel grid.
c     N.B.: NPX_NPY is also accepted if equal to 0 (default value if not
c     used!)

      logical function NP_set(NPX,NPY,NP,NPX_NPY)
******************************************************************************
      implicit none

      integer NPX,NPY,NP,NPX_NPY

      integer num
******************************************************************************

      NP_set=.true.

      NP=NPX*4/3
      if (NP.ne.NPY*4) then
         write(0,*) 'Distortion of the pixel grid: NPX= ',NPX,' NPY='
     &,              NPY,' do not obey NPX=3*NPY!'
         NP_set=.false.
      endif

c     We check also that NPX_NPY is NPX*NPY or NPX_NPY = 0
      num=NPX*NPY
      if ((num.ne.NPX_NPY).and.(NPX_NPY.ne.0)) then
         write(0,*) 'Wrong dimension on NPX_NPY; should be ',num
         NP_set=.false.
      endif

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine holes_2df_xyz tells if (x,y,z) is in a hole or not,
c     depending on the value of io (io=1 not in a hole; io=0 in a hole). The
c     value of sgn tells if it is a position in the ngp or sgp/ran.

      subroutine holes_2df_xyz(x,y,z,io)
*************************************variables********************************
      implicit none

      integer io
      real x,y,z

      intrinsic abs

      integer jf,ifirst,in,sgn
      real ra,dec,racen,deccen,xc,yc,zc,PI,r,zz
      save ifirst,xc,yc,zc

      real pival,degs_rads,ramins_rads,radfac,tpi
      parameter (pival=3.1415926535897)
      parameter (degs_rads=pival/180.,ramins_rads=pival/720.
     &,          radfac=pival/10800.,tpi=2.*pival)
      data ifirst/1/
******************************************************************************

      if (ifirst.eq.1) then
         ifirst=0
         PI= atan(1.)*4.
c        This is the direction of the Galactic Centre as adopted
c        by Steve Maddox
         racen  = 12.3*PI/180.0
         deccen = -27.5*PI/180.0
         xc=cos(deccen)*cos(racen)
         yc=cos(deccen)*sin(racen)
         zc=sin(deccen)
      endif

      in=0
      r=sqrt(x**2+y**2+z**2)
      zz=(x*xc+y*yc+z*zc)
      sgn=int(sign(1.,zz/r))

      call initialisation(sgn)
      call xyz_radec(x,y,z,ra,dec)

      if ((ra.gt.pival).and.(sgn.eq.1))then
         ra=ra-tpi
      endif

      call fnumber(ra,dec,jf)

      if (sgn.eq.1) then
         call test_sgp_holes(ra,dec,jf,in)
      else
         call test_ngp_holes(ra,dec,jf,in)
      endif

      io=abs(in-1) ! N.B.: in = 1 if in a hole and 0 otherwise(opposite to io)

      return
      end

c----------------------------------------------------------------------------
      subroutine initialisation(sgn)
******************************************************************************
      implicit none

      integer sgn

      integer sgn_ifirst
      save sgn_ifirst
      data sgn_ifirst/0/
******************************************************************************

      if (sgn.ne.sgn_ifirst) then
         sgn_ifirst=sgn
         if (sgn.eq.1) then
            call sgp_mask_init
         else
            call ngp_mask_init
         endif
      endif

      return
      end

c-----------------------------------------------------------------------------
c     Given ra,dec in radians returns corresponding field no.

      subroutine fnumber(rar,decr,ifield)
******************************************************************************
      implicit none

      intrinsic abs

      integer ifield
      real decr,rar

      integer iygrid,ixgrid,i
      real ra,dec,raminus,yspace,ygrid,xspace,xgrid,xoff,yoff

      integer*4 field0h(22)
      real*4 ragaps(22), decbands(22)

      real pival,degs_rads,ramins_rads,radfac,tpi
      parameter (pival=3.1415926535897)
      parameter (degs_rads=pival/180.,ramins_rads=pival/720.
     &,          radfac=pival/10800.,tpi=2.*pival)

      data (ragaps(i),i=1,22)/ 0.,144.,90.,66.,52.,44.,38.,33.,30.,28.,
     +                 26.,24.,23.,22.,21.,20.,20.,20.,20.,20.,20.,20./
      data (decbands(i),i=1,22)/-90.,-85.,-80.,-75.,-70.,-65.,-60.,-55.,
     +   -50.,-45.,-40.,-35.,-30.,-25.,-20.,-15.,-10.,-5.,0.,5.,10.,15./
      data (field0h(i),i=1,22)/1,2,12,28,50,78,111,149,193,241,293,349,
     +   409,472,538,607,679,751,823,895,967,1039 /
******************************************************************************

c     find the nearest grid centre
      ra = rar*180./pival
      dec = decr*180./pival

      if (dec.gt.15.) then
         ifield = 0
         return
      end if

      if (ra.lt.0.) ra = ra + 360.
      if (ra.gt.180.) then
         raminus = ra - 360.
      else
         raminus = ra
      end if

      yspace = 5.0
      iygrid = nint(dec/5.)+19
      ygrid = decbands(iygrid)

      xspace = ragaps(iygrid)
      if (abs(raminus).lt.xspace/4.0/2.0) then ! 4 for degs, 2 for half field
c     it's a 0hr field
         xgrid = 0.
         ixgrid = 0
      else
         xspace = ragaps(iygrid) / 4.0 ! in degs
         ixgrid = int(ra/xspace + 0.5)
         xgrid = ixgrid * xspace
      end if

      ifield = field0h(iygrid) + ixgrid
      xoff = ra - xgrid
      if (xoff.gt.180.) xoff = xoff - 360.
      yoff = dec - ygrid

      return
      end

c-----------------------------------------------------------------------------
c     Initialisation of the sgp_holes positions

      subroutine sgp_mask_init
******************************************************************************
      implicit none

      integer i,j,jhole(2000),nshols,ilast,jfld
      real sxhole(3,2000),syhole(3,2000)

      real pival,degs_rads,ramins_rads,radfac,tpi
      parameter (pival=3.1415926535897)
      parameter (degs_rads=pival/180.,ramins_rads=pival/720.
     &,          radfac=pival/10800.,tpi=2.*pival)
      common/sgphole/sxhole,syhole,jhole,nshols
      common/last_field/ilast,jfld
******************************************************************************

      ilast = 0
      open (unit=30,file='sgpholes.lis',status='old',form='formatted')
      do i=1,2000
         read(30,*,end=999) (sxhole(j,i),syhole(j,i),j=1,3),jhole(i)
      enddo
 999  nshols = i-1
      close(30)

      return
      end

c-----------------------------------------------------------------------------
c     Initialisation of the ngp_holes positions

      subroutine ngp_mask_init
******************************************************************************
      implicit none

      integer i,j,jhole(300),nnhols,ilast,jfld
      real xnhole(3,300),ynhole(3,300)

      real pival,degs_rads,ramins_rads,radfac,tpi
      parameter (pival=3.1415926535897)
      parameter (degs_rads=pival/180.,ramins_rads=pival/720.
     &,          radfac=pival/10800.,tpi=2.*pival)
      common/ngphole/xnhole,ynhole,jhole,nnhols
      common/last_field/ilast,jfld
******************************************************************************

      open (unit=30,file='ngpholes.lis',status='old',form='formatted')
      do i=1,300
         read(30,*,end=999) (xnhole(j,i),ynhole(j,i),j=1,3),jhole(i)
      enddo
 999  nnhols = i-1
      close(30)

      return
      end

c----------------------------------------------------------------------------
c     Returns inhol = 1 if point (xx,yy) lies in a drilled region

      subroutine test_sgp_holes(xx,yy,jf,inhol)
******************************************************************************
      implicit none

      integer jf,inhol
      real xx,yy

      intrinsic abs,max,min

      integer j,jhole(2000),nholes
      real xhole(3,2000),yhole(3,2000),dx,dy,dx1,dy1,dx2,dy2,x0,y0,a1,a2

      real pival,degs_rads,ramins_rads,radfac,tpi
      parameter (pival=3.1415926535897)
      parameter (degs_rads=pival/180.,ramins_rads=pival/720.
     &,          radfac=pival/10800.,tpi=2.*pival)
      common/sgphole/xhole,yhole,jhole,nholes
******************************************************************************

      inhol = 0
      do j = 1,nholes
         if (jhole(j).ne.jf) goto 124
         x0 = xhole(1,j)
         y0 = yhole(1,j)

         if(y0.eq.yhole(3,j)) then ! It's a square hole
            if(xx.le.min(x0,xhole(3,j)).or.xx.ge.max(x0,xhole(3,j)))
     &         goto 124 ! speed-up
         end if
         dx = xx-x0
         dy = yy-y0
         dx1 = xhole(2,j)-x0
         dy1 = yhole(2,j)-y0
         dx2 = xhole(3,j)-x0
         dy2 = yhole(3,j)-y0

         if (abs(dx2).gt.0) then
            a1 = (dx*dy2 - dy*dx2)/(dx1*dy2 - dy1*dx2)
            a2 = (dx - a1*dx1)/dx2
            if (0.le.a1.and.a1.le.1.and.0.le.a2.and.a2.le.1) then
               inhol = 1
               return
            end if
         end if
 124     continue
      end do                    ! loop over holes

      return
      end

c-----------------------------------------------------------------------------
c     Returns inhol = 1 if point (xx,yy) lies in a drilled region

      subroutine test_ngp_holes(xx,yy,jf,inhol)
******************************************************************************
      implicit none

      integer jf,inhol
      real xx,yy

      intrinsic abs,max,min

      integer j,jhole(300),nholes
      real xhole(3,300),yhole(3,300),dx,dy,dx1,dy1,dx2,dy2,x0,y0,a1,a2

      real pival,degs_rads,ramins_rads,radfac,tpi
      parameter (pival=3.1415926535897)
      parameter (degs_rads=pival/180.,ramins_rads=pival/720.
     &,          radfac=pival/10800.,tpi=2.*pival)
      common/ngphole/xhole,yhole,jhole,nholes
******************************************************************************

      inhol = 0
      do j = 1,nholes
         if (jhole(j).ne.jf) goto 123
         x0 = xhole(1,j)
         y0 = yhole(1,j)
         if(y0.eq.yhole(3,j)) then ! It's a square hole
            if(xx.le.min(x0,xhole(3,j)).or.xx.ge.max(x0,xhole(3,j)))
     &         goto 123 ! speed-up
         end if
         dx = xx-x0
         dy = yy-y0
         dx1 = xhole(2,j)-x0
         dy1 = yhole(2,j)-y0
         dx2 = xhole(3,j)-x0
         dy2 = yhole(3,j)-y0

         if (abs(dx2).gt.0) then
            a1 = (dx*dy2 - dy*dx2)/(dx1*dy2 - dy1*dx2)
            a2 = (dx - a1*dx1)/dx2
            if (0.le.a1.and.a1.le.1.and.0.le.a2.and.a2.le.1) then
               inhol = 1
               return
            end if
         end if
 123     continue
      end do  ! loop over holes

      return
      end

c-----------------------------------------------------------------------------

!Module to read in name/value pairs from a file, with each line of the form line 'name = value'
!Should correctly interpret FITS headers
!Antony Lewis (http://cosmologist.info/). Released to the public domain.
!Apr 11, added support for INCLUDE(file); check for duplicate keys
!Jun 12, added support for DEFAULT(file), provides default values for keys not defined in the read file

module IniFile
 implicit none
 public

  integer, parameter :: Ini_max_name_len = 128

  integer, parameter :: Ini_max_string_len = 1024
  logical :: Ini_fail_on_not_found = .false.

  logical :: Ini_Echo_Read = .false.

  logical :: Ini_AllowDuplicateKeys = .false.

  type TNameValue
   !no known way to make character string pointers..
    character(Ini_max_name_len)  :: Name
    character(Ini_max_string_len):: Value
  end type TNameValue

  type TNameValue_pointer
     Type(TNameValue), pointer :: P
  end type TNameValue_pointer

  Type TNameValueList
    integer Count
    integer Delta
    integer Capacity
    logical ignoreDuplicates
    type(TNameValue_pointer), dimension(:), pointer :: Items
  end Type TNameValueList

  Type TIniFile
   logical SlashComments
   Type (TNameValueList) :: L, ReadValues
  end Type TIniFile
 
  Type(TIniFile) :: DefIni

contains

   subroutine TNameValueList_Init(L, ignoreDuplicates)
    Type (TNameValueList) :: L
    logical, intent(in), optional :: ignoreDuplicates
    
     L%Count = 0
     L%Capacity = 0
     L%Delta = 128
     L%ignoreDuplicates = .false.
     if (present(ignoreDuplicates)) L%ignoreDuplicates=ignoreDuplicates
     nullify(L%Items)

   end subroutine TNameValueList_Init

   subroutine TNameValueList_Clear(L)
    Type (TNameValueList) :: L
    integer i, status
     
    do i=L%count,1,-1
     deallocate (L%Items(i)%P, stat = status)
    end do
    deallocate (L%Items, stat = status)
    call TNameValueList_Init(L)

   end subroutine TNameValueList_Clear

   subroutine TNameValueList_ValueOf(L, AName, AValue)
     Type (TNameValueList), intent(in) :: L
     character(LEN=*), intent(in) :: AName
     CHARACTER(LEN=*), intent(out) :: AValue
     integer i

     do i=1, L%Count
       if (L%Items(i)%P%Name == AName) then
          AValue = L%Items(i)%P%Value 
          return
       end if
     end do
     AValue = ''

   end subroutine TNameValueList_ValueOf

   
    function TNameValueList_IndexOf(L, AName) result (AValue)
     Type (TNameValueList), intent(in) :: L
     character(LEN=*), intent(in) :: AName
     integer :: AValue
     integer i

     do i=1, L%Count
       if (L%Items(i)%P%Name == AName) then
          AValue = i
          return
       end if
     end do
     AValue = -1
     
   end function TNameValueList_IndexOf

   function TNameValueList_HasKey(L, AName) result (AValue)
     Type (TNameValueList), intent(in) :: L
     character(LEN=*), intent(in) :: AName
     logical :: AValue
    
     AValue = TNameValueList_IndexOf(L,AName) /= -1
     
   end function TNameValueList_HasKey
    
   subroutine TNameValueList_Add(L, AName, AValue, only_if_undefined)
    Type (TNameValueList) :: L
    character(LEN=*), intent(in) :: AName, AValue
    logical, optional, intent(in) :: only_if_undefined
    logical isDefault
    
    if (present(only_if_undefined)) then
     isDefault = only_if_undefined
    else
     isDefault = .true.
    end if
    if ((.not. Ini_AllowDuplicateKeys .or. isDefault) .and. TNameValueList_HasKey(L,AName)) then
      if (L%ignoreDuplicates .or. isDefault) return
      write (*,*) 'IniFile,TNameValueList_Add: duplicate key name in file: '//trim(AName)
      stop 
     end if 
    if (L%Count == L%Capacity) call TNameValueList_SetCapacity(L, L%Capacity + L%Delta)
    L%Count = L%Count + 1
    allocate(L%Items(L%Count)%P)
    L%Items(L%Count)%P%Name = AName
    L%Items(L%Count)%P%Value = AValue

   end subroutine TNameValueList_Add

   subroutine TNameValueList_SetCapacity(L, C)
    Type (TNameValueList) :: L
    integer C
    type(TNameValue_pointer), dimension(:), pointer :: TmpItems
    
    if (L%Count > 0) then
      if (C < L%Count) stop 'TNameValueList_SetCapacity: smaller than Count'
      allocate(TmpItems(L%Count))
      TmpItems = L%Items(1:L%Count)
      deallocate(L%Items)
      allocate(L%Items(C))
      L%Items(1:L%Count) = TmpItems
      deallocate(TmpItems)
    else
     allocate(L%Items(C))
    end if  
    L%Capacity = C
  
   end subroutine TNameValueList_SetCapacity

   subroutine TNameValueList_Delete(L, i)
    Type (TNameValueList) :: L
    integer, intent(in) :: i
     
     deallocate(L%Items(i)%P)
     if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
     L%Count = L%Count -1
     
   end subroutine TNameValueList_Delete

  subroutine Ini_NameValue_Add(Ini,AInLine,only_if_undefined)
    Type(TIniFile) :: Ini
    character (LEN=*), intent(IN) :: AInLine
    integer EqPos, slashpos, lastpos
    logical, optional, intent(in) :: only_if_undefined
    logical isDefault
    character (LEN=len(AInLine)) :: AName, S, InLine

     if (present(only_if_undefined)) then
      isDefault = only_if_undefined  
     else
      isDefault = .false.  
     end if
      InLine=trim(adjustl(AInLine))
      EqPos = scan(InLine,'=')
      if (EqPos/=0 .and. InLine(1:1)/='#' .and. InLine(1:7) /= 'COMMENT' ) then
   
         AName = trim(InLine(1:EqPos-1))
         
         S = adjustl(InLine(EqPos+1:)) 
           if (Ini%SlashComments) then
           slashpos=scan(S,'/')
           if (slashpos /= 0) then
              S  = S(1:slashpos-1)
           end if
         end if
         lastpos=len_trim(S)
         if (lastpos>1) then
          if (S(1:1)=='''' .and. S(lastpos:lastpos)=='''') then
           S = S(2:lastpos-1)
          end if
         end if
         call TNameValueList_Add(Ini%L, AName, S,only_if_undefined = isDefault )

      end if

  end subroutine Ini_NameValue_Add

  subroutine Ini_Open(filename, unit_id,  error, slash_comments)
     character (LEN=*), intent(IN) :: filename
     integer, intent(IN) :: unit_id
     logical, optional, intent(OUT) :: error
     logical, optional, intent(IN) :: slash_comments
     logical aerror

     call TNameValueList_Init(DefIni%L)
     call TNameValueList_Init(DefIni%ReadValues, .true.)
          
     if (present(slash_comments)) then
      call Ini_Open_File(DefIni,filename,unit_id,aerror,slash_comments)
     else
      call Ini_Open_File(DefIni,filename,unit_id,aerror)
     end if

     if (present(error)) then
       error = aerror
     else
      if (aerror) then
        write (*,*) 'Ini_Open: Error opening file ' // trim(filename)
        stop
      end if
     end if

  end subroutine Ini_Open

  function Ini_ExtractFilePath(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=Ini_max_string_len) Ini_ExtractFilePath
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
       if (aname(i:i)=='/') then
          Ini_ExtractFilePath = aname(1:i)
          return
       end if
    end do
    Ini_ExtractFilePath = ''

  end function Ini_ExtractFilePath

  recursive subroutine Ini_Open_File(Ini, filename, unit_id,  &
                                    error, slash_comments, append,only_if_undefined)
     Type(TIniFile) :: Ini

     character (LEN=*), intent(IN) :: filename
     integer, intent(IN) :: unit_id
     logical, intent(OUT) :: error
     logical, optional, intent(IN) :: slash_comments
     logical, optional, intent(in) :: append, only_if_undefined
     character (LEN=Ini_max_string_len) :: InLine, IncludeFile
     integer lastpos, i
     Type (TNameValueList) IncudeFiles, DefaultValueFiles
     logical doappend, FileExists, isDefault
     
     if (present(append)) then
      doappend=append
     else
      doappend=.false.
     end if  
     
     if (present(only_if_undefined)) then
        isDefault = only_if_undefined
     else
        isDefault = .false.
     end if
     
     if (.not. doappend) then
       call TNameValueList_Init(Ini%L)
       call TNameValueList_Init(Ini%ReadValues, .true.)
     end if
 
    call TNameValueList_Init(IncudeFiles) 
    call TNameValueList_Init(DefaultValueFiles) 
     
    if (present(slash_comments)) then
     Ini%SlashComments = slash_comments
    else
     Ini%SlashComments = .false.
    end if
         
    open(unit=unit_id,file=filename,form='formatted',status='old', err=500)
   
    do 
      read (unit_id,'(a)',end=400) InLine
      if (InLine == 'END') exit;
      if (InLine(1:8) == 'INCLUDE(') then
           lastpos = scan(InLine,')')
           if (lastpos/=0) then
            call TNameValueList_Add(IncudeFiles, trim(adjustl(InLine(9:lastpos-1))),'')            
           else
            stop 'Ini_Open_File: error in INCLUDE line'
           end if 
      elseif (InLine(1:8) == 'DEFAULT(') then
          !Settings to read in as defaults, overridden by subsequent re-definitions
          lastpos = scan(InLine,')')
           if (lastpos/=0) then
            call TNameValueList_Add(DefaultValueFiles, trim(adjustl(InLine(9:lastpos-1))),'')            
           else
            stop 'Ini_Open_File: error in DEFAULT line'
           end if 
      elseif (InLine /= '') then
       call Ini_NameValue_Add(Ini,InLine, only_if_undefined=isDefault) 
      end if
    end do

400 close(unit_id)
    error=.false.

    do i=1, IncudeFiles%Count
       if (error) exit
       IncludeFile=IncudeFiles%Items(i)%P%Name
       inquire(file=IncludeFile, exist = FileExists)
       if (.not. FileExists) then
         IncludeFile=trim(Ini_ExtractFilePath(filename))//trim(IncludeFile)
         inquire(file=IncludeFile, exist = FileExists)
         if (.not. FileExists) then
             write(*,*) 'Ini_Open_File: INCLUDE file not found: '//trim(IncudeFiles%Items(i)%P%Name)
             stop 
         end if
       end if
       call Ini_Open_File(Ini, IncludeFile, unit_id,  &
                          error, slash_comments, append=.true.,only_if_undefined=isDefault)      
    end do
    do i=1, DefaultValueFiles%Count
       if (error) exit
       IncludeFile=DefaultValueFiles%Items(i)%P%Name
       inquire(file=IncludeFile, exist = FileExists)
       if (.not. FileExists) then
         IncludeFile=trim(Ini_ExtractFilePath(filename))//trim(IncludeFile)
         inquire(file=IncludeFile, exist = FileExists)
         if (.not. FileExists) then
             write(*,*) 'Ini_Open_File: DEFAULT file not found:' //trim(DefaultValueFiles%Items(i)%P%Name)
             stop
         end if
       end if
       call Ini_Open_File(Ini, IncludeFile, unit_id,  &
                          error, slash_comments, append=.true., only_if_undefined=.true.)      
    end do

    call TNameValueList_Clear(IncudeFiles)
    call TNameValueList_Clear(DefaultValueFiles)
    
    return

500 error=.true.
    call TNameValueList_Clear(IncudeFiles)
    call TNameValueList_Clear(DefaultValueFiles)

  end subroutine Ini_Open_File

  subroutine Ini_Open_Fromlines(Ini, Lines, NumLines, slash_comments)
    Type(TIniFile) :: Ini

    integer, intent(IN) :: NumLines
    character (LEN=*), dimension(NumLines), intent(IN) :: Lines
    logical, intent(IN) :: slash_comments
    integer i

    call TNameValueList_Init(Ini%L)
    call TNameValueList_Init(Ini%ReadValues, .true.)

    Ini%SlashComments = slash_comments

    do i=1,NumLines
       call Ini_NameValue_Add(Ini,Lines(i))
    end do

  end  subroutine Ini_Open_Fromlines

  subroutine Ini_Close

    call Ini_close_File(DefIni)

  end subroutine Ini_Close


  subroutine Ini_Close_File(Ini)
    Type(TIniFile) :: Ini
   
    call TNameValueList_Clear(Ini%L)
    call TNameValueList_Clear(Ini%ReadValues)

  end  subroutine Ini_Close_File
  


  function Ini_Read_String(Key, NotFoundFail) result(AValue)
   character (LEN=*), intent(IN) :: Key
   logical, optional, intent(IN) :: NotFoundFail
   character(LEN=Ini_max_string_len) :: AValue

     if (present(NotFoundFail)) then
      AValue = Ini_Read_String_File(DefIni, Key, NotFoundFail)
     else
      AValue = Ini_Read_String_File(DefIni, Key)
     end if

  end function Ini_Read_String

  function Ini_Read_String_Default(Key, Default,AllowBlank) result(AValue)
   character (LEN=*), intent(IN) :: Key, Default
   character(LEN=Ini_max_string_len) :: AValue
   logical, intent(in), optional :: AllowBlank

   if (present(AllowBlank)) then
      AValue = Ini_Read_String_Default_File(DefIni, Key, Default, AllowBlank)
   else    
      AValue = Ini_Read_String_Default_File(DefIni, Key, Default)
   end if
   
  end function Ini_Read_String_Default


  function Ini_Read_String_File(Ini, Key, NotFoundFail) result(AValue)
   Type(TIniFile) :: Ini
   character (LEN=*), intent(IN) :: Key
   logical, optional, intent(IN) :: NotFoundFail
   character(LEN=Ini_max_string_len) :: AValue

   call TNameValueList_ValueOf(Ini%L, Key, AValue)

   if (AValue/='') then

    call  TNameValueList_Add(Ini%ReadValues, Key, AValue)
    if (Ini_Echo_Read) write (*,*) trim(Key)//' = ',trim(AValue)
    return

   end if
   if (present(NotFoundFail)) then
      if (NotFoundFail) then
         write(*,*) 'key not found : '//trim(Key)
         stop
      end if
   else if (Ini_fail_on_not_found) then
      write(*,*) 'key not found : '//trim(Key)
      stop
   end if

  end function Ini_Read_String_File

  function Ini_Read_String_Default_File(Ini, Key, Default, AllowBlank) result(AValue)
   Type(TIniFile) :: Ini
   character (LEN=*), intent(IN) :: Key, Default
   character(LEN=Ini_max_string_len) :: AValue
   logical, intent(in), optional :: AllowBlank

   if (Ini_HasKey_File(Ini,Key)) then
    AValue = Ini_Read_String_file(Ini, Key, .false.)
    if (present(AllowBlank)) then
      if (AllowBlank) return
    end if
    if (AValue=='') AValue = Default
   else
    AValue = Default
   end if
  
  end function Ini_Read_String_Default_File
  
  function Ini_HasKey(Key) result(AValue)
   character (LEN=*), intent(IN) :: Key
   logical AValue

   AValue = Ini_HasKey_File(DefIni, Key)

  end function Ini_HasKey

  function Ini_HasKey_File(Ini, Key) result(AValue)
   type(TIniFile), intent(in) :: Ini
   character (LEN=*), intent(IN) :: Key
   logical AValue

      Avalue = TNameValueList_HasKey(Ini%L, Key)
      
  end function Ini_HasKey_File

 function Ini_Key_To_Arraykey(Key, index)  result(AValue)
    character (LEN=*), intent(IN) :: Key
    integer, intent(in) :: index
    character(LEN=Ini_max_string_len) :: AValue
    
    character(LEN=32) :: numstr
    write (numstr,*) index 
    numstr=adjustl(numstr)
    AValue = trim(Key) // '(' // trim(numStr) // ')' 
 
 end function Ini_Key_To_Arraykey

  function Ini_Read_String_Array(Key, index, NotFoundFail) result(AValue)
   character (LEN=*), intent(IN) :: Key
   integer, intent(in) :: index
   logical, optional, intent(IN) :: NotFoundFail
   character(LEN=Ini_max_string_len) :: AValue

     if (present(NotFoundFail)) then
      AValue = Ini_Read_String_Array_File(DefIni, Key, index, NotFoundFail)
     else
      AValue = Ini_Read_String_Array_File(DefIni, Key, index)
     end if

  end function Ini_Read_String_Array

  function Ini_Read_String_Array_File(Ini, Key, index, NotFoundFail) result(AValue)
   Type(TIniFile) :: Ini
   integer, intent(in) :: index
   character (LEN=*), intent(IN) :: Key
   logical, optional, intent(IN) :: NotFoundFail
   character(LEN=Ini_max_string_len) :: AValue
   character(LEN=Ini_max_string_len) :: ArrayKey
   
     ArrayKey = Ini_Key_To_Arraykey(Key,index)
     if (present(NotFoundFail)) then
      AValue = Ini_Read_String_File(Ini, ArrayKey, NotFoundFail)
     else
      AValue = Ini_Read_String_File(Ini, ArrayKey)
     end if
   
  end function Ini_Read_String_Array_File

  function Ini_Read_Int_Array(Key, index, Default)
     integer, optional, intent(IN) :: Default
     integer, intent(in) :: index
     character (LEN=*), intent(IN) :: Key
     integer Ini_Read_Int_Array

     if (present(Default)) then
      Ini_Read_Int_Array = Ini_Read_Int_Array_File(DefIni, Key, index, Default)
     else
      Ini_Read_Int_Array = Ini_Read_Int_Array_File(DefIni, Key, index)
     end if
     
   end function Ini_Read_Int_Array

  function Ini_Read_Int_Array_File(Ini,Key, index, Default)
  !Reads Key(1), Key(2), etc.
   Type(TIniFile) :: Ini
   integer Ini_Read_Int_Array_File 
   integer, optional, intent(IN) :: Default
   integer, intent(in) :: index
   character (LEN=*), intent(IN) :: Key
   character(LEN=Ini_max_string_len) :: ArrrayKey
     ArrrayKey = Ini_Key_To_Arraykey(Key,index)
     if (present(Default)) then
      Ini_Read_Int_Array_File = Ini_Read_Int_File(Ini, ArrrayKey, Default)
     else
      Ini_Read_Int_Array_File = Ini_Read_Int_File(Ini, ArrrayKey)
     end if
  end function Ini_Read_Int_Array_File


  function Ini_Read_Int(Key, Default)
     integer, optional, intent(IN) :: Default
     character (LEN=*), intent(IN) :: Key
     integer Ini_Read_Int

     if (present(Default)) then
      Ini_Read_Int = Ini_Read_Int_File(DefIni, Key, Default)
     else
      Ini_Read_Int = Ini_Read_Int_File(DefIni, Key)
     end if
  end function Ini_Read_Int

  function Ini_Read_Int_File(Ini, Key, Default)
   Type(TIniFile) :: Ini
   integer Ini_Read_Int_File
   integer, optional, intent(IN) :: Default
   character  (LEN=*), intent(IN) :: Key
   character(LEN=Ini_max_string_len) :: S
   
   S = Ini_Read_String_File(Ini, Key,.not. present(Default))
   if (S == '') then
      if (.not. present(Default)) then
        write(*,*) 'no value for key: '//Key
        stop
      end if
      Ini_Read_Int_File = Default
      write (S,*) Default
      call  TNameValueList_Add(Ini%ReadValues, Key, S)
   else
    if (verify(trim(S),'-+0123456789') /= 0) goto 10
    read (S,*, err = 10) Ini_Read_Int_File
   end if
  return
10 write (*,*) 'error reading integer for key: '//Key
   stop
  
  end function Ini_Read_Int_File

  function Ini_Read_Double(Key, Default)
     double precision, optional, intent(IN) :: Default
     character (LEN=*), intent(IN) :: Key
     double precision Ini_Read_Double

     if (present(Default)) then
      Ini_Read_Double = Ini_Read_Double_File(DefIni, Key, Default)
     else
      Ini_Read_Double = Ini_Read_Double_File(DefIni, Key)
     end if
  
  end function Ini_Read_Double

  function Ini_Read_Double_File(Ini,Key, Default)
   Type(TIniFile) :: Ini
   double precision Ini_Read_Double_File 
   double precision, optional, intent(IN) :: Default
   character (LEN=*), intent(IN) :: Key
   character(LEN=Ini_max_string_len) :: S
   
   S = Ini_Read_String_File(Ini,Key,.not. present(Default))
   if (S == '') then
      if (.not. present(Default)) then
        write(*,*) 'no value for key: '//Key
        stop
      end if
      Ini_Read_Double_File = Default
      write (S,*) Default

      call  TNameValueList_Add(Ini%ReadValues, Key, S)

   else
    read (S,*, err=10) Ini_Read_Double_File
   end if

  return

10 write (*,*) 'error reading double for key: '//Key
   stop

  end function Ini_Read_Double_File



    function Ini_Read_Double_Array(Key, index, Default)
     double precision, optional, intent(IN) :: Default
     integer, intent(in) :: index
     character (LEN=*), intent(IN) :: Key
     double precision Ini_Read_Double_Array

     if (present(Default)) then
      Ini_Read_Double_Array = Ini_Read_Double_Array_File(DefIni, Key, index, Default)
     else
      Ini_Read_Double_Array = Ini_Read_Double_Array_File(DefIni, Key, index)
     end if
     
    end function Ini_Read_Double_Array


  function Ini_Read_Double_Array_File(Ini,Key, index, Default)

  !Reads Key(1), Key(2), etc.

   Type(TIniFile) :: Ini

   double precision Ini_Read_Double_Array_File 
   double precision, optional, intent(IN) :: Default
   integer, intent(in) :: index
   character (LEN=*), intent(IN) :: Key
   character(LEN=Ini_max_string_len) ::  ArrrayKey

     ArrrayKey = Ini_Key_To_Arraykey(Key,index)
     if (present(Default)) then

      Ini_Read_Double_Array_File = Ini_Read_Double_File(Ini, ArrrayKey, Default)
     else
      Ini_Read_Double_Array_File = Ini_Read_Double_File(Ini, ArrrayKey)
     end if
  end function Ini_Read_Double_Array_File

    function Ini_Read_Real(Key, Default)
     real, optional, intent(IN) :: Default
     character (LEN=*), intent(IN) :: Key
     real Ini_Read_Real

     if (present(Default)) then
      Ini_Read_Real = Ini_Read_Real_File(DefIni, Key, Default)
     else
      Ini_Read_Real = Ini_Read_Real_File(DefIni, Key)
     end if

    end function Ini_Read_Real

    function Ini_Read_Real_File(Ini,Key, Default)
    Type(TIniFile) :: Ini
    real Ini_Read_Real_File 
    real, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) :: S
   
    S = Ini_Read_String_File(Ini,Key,.not. present(Default))
    if (S == '') then
      if (.not. present(Default)) then
        write(*,*) 'no value for key: '//Key
        stop
      end if
      Ini_Read_Real_File = Default
      write (S,*) Default
      call  TNameValueList_Add(Ini%ReadValues, Key, S)

   else
    read (S,*, err=10) Ini_Read_Real_File
   end if

  return

10 write (*,*) 'error reading double for key: '//Key
   stop

  end function Ini_Read_Real_File



   function Ini_Read_Real_Array(Key, index, Default)
     real, optional, intent(IN) :: Default
     integer, intent(in) :: index
     character (LEN=*), intent(IN) :: Key
     real Ini_Read_Real_Array

     if (present(Default)) then
      Ini_Read_Real_Array = Ini_Read_Real_Array_File(DefIni, Key, index, Default)
     else
      Ini_Read_Real_Array = Ini_Read_Real_Array_File(DefIni, Key, index)
     end if
   end function Ini_Read_Real_Array

  function Ini_Read_Real_Array_File(Ini,Key, index, Default)
  !Reads Key(1), Key(2), etc.
   Type(TIniFile) :: Ini
   real Ini_Read_Real_Array_File 
   real, optional, intent(IN) :: Default
   integer, intent(in) :: index
   character (LEN=*), intent(IN) :: Key
   character(LEN=Ini_max_string_len) :: ArrrayKey
   
     ArrrayKey = Ini_Key_To_Arraykey(Key,index)
     if (present(Default)) then
      Ini_Read_Real_Array_File = Ini_Read_Real_File(Ini, ArrrayKey, Default)
     else
      Ini_Read_Real_Array_File = Ini_Read_Real_File(Ini, ArrrayKey)
     end if
  end function Ini_Read_Real_Array_File

  function Ini_Read_Logical(Key, Default)
     Logical, optional, intent(IN) :: Default
     character (LEN=*), intent(IN) :: Key
    logical Ini_Read_Logical

     if (present(Default)) then
      Ini_Read_Logical = Ini_Read_Logical_File(DefIni, Key, Default)
     else
      Ini_Read_Logical = Ini_Read_Logical_File(DefIni, Key)
     end if
  end function Ini_Read_Logical

  function Ini_Read_Logical_File(Ini, Key, Default)
   Type(TIniFile) :: Ini

   logical Ini_Read_Logical_File
   logical, optional, intent(IN) :: Default
   character  (LEN=*), intent(IN) :: Key
  
   character(LEN=Ini_max_string_len) :: S
   
   S = Ini_Read_String_File(Ini,Key,.not. present(Default))
   if (S == '') then
      if (.not. present(Default)) then
        write(*,*) 'no value for key: '//Key
        stop
      end if
      Ini_Read_Logical_File = Default
      write (S,*) Default

      call  TNameValueList_Add(Ini%ReadValues, Key, S)

   else

    if (verify(trim(S),'10TF') /= 0) goto 10  
    read (S,*, err = 10) Ini_Read_Logical_File
   end if

  return

10 write (*,*) 'error reading logical for key: '//Key
   stop
  end function Ini_Read_Logical_File



  subroutine Ini_SaveReadValues(afile,unit_id)
   character(LEN=*)  :: afile
   integer, intent(in) :: unit_id

   call Ini_SaveReadValues_File(DefIni, afile, unit_id)

  end subroutine Ini_SaveReadValues



  subroutine Ini_SaveReadValues_File(Ini, afile, unit_id)
   Type(TIniFile) :: Ini
   character(LEN=*), intent(in) :: afile
   integer, intent(in) :: unit_id
   integer i

   open(unit=unit_id,file=afile,form='formatted',status='replace', err=500)

   do i=1, Ini%ReadValues%Count

    write (unit_id,'(a)') trim(Ini%ReadValues%Items(i)%P%Name) // ' = ' &
                        //trim(Ini%ReadValues%Items(i)%P%Value)

   end do

   close(unit_id)
   return

500 write(*,*) 'Ini_SaveReadValues_File: Error creating '//trim(afile)

  end subroutine Ini_SaveReadValues_File

end module IniFile

* demo-fortran.F
* test program for the Cuba library
* last modified 13 Mar 15 th

#define cubareal real*REALSIZE


	program CubaTest
	implicit none

	integer ndim, ncomp, nvec, last, seed, mineval, maxeval
	cubareal epsrel, epsabs, userdata
	parameter (ndim = 3)
	parameter (ncomp = 1)
	parameter (userdata = 0)
	parameter (nvec = 1)
	parameter (epsrel = 1D-3)
	parameter (epsabs = 1D-12)
	parameter (last = 4)
	parameter (seed = 0)
	parameter (mineval = 0)
	parameter (maxeval = 50000)

	integer nstart, nincrease, nbatch, gridno
	integer*8 spin
	character*(*) statefile	
	parameter (nstart = 1000)
	parameter (nincrease = 500)
	parameter (nbatch = 1000)
	parameter (gridno = 0)
	parameter (statefile = "")
	parameter (spin = -1)

	integer nnew, nmin
	cubareal flatness
	parameter (nnew = 1000)
	parameter (nmin = 2)
	parameter (flatness = 25D0)

	integer key1, key2, key3, maxpass
	cubareal border, maxchisq, mindeviation
	integer ngiven, ldxgiven, nextra
	parameter (key1 = 47)
	parameter (key2 = 1)
	parameter (key3 = 1)
	parameter (maxpass = 5)
	parameter (border = 0D0)
	parameter (maxchisq = 10D0)
	parameter (mindeviation = .25D0)
	parameter (ngiven = 0)
	parameter (ldxgiven = ndim)
	parameter (nextra = 0)

	integer key
	parameter (key = 0)

	external integrand

	cubareal integral(ncomp), error(ncomp), prob(ncomp)
	integer verbose, nregions, neval, fail
	character*16 env

	integer c

	call getenv("CUBAVERBOSE", env)
	verbose = 2
	read(env, *, iostat=fail, end=999, err=999) verbose
999	continue

	print *, "-------------------- Vegas test --------------------"

	call vegas(ndim, ncomp, integrand, userdata, nvec,
     &    epsrel, epsabs, verbose, seed,
     &    mineval, maxeval, nstart, nincrease, nbatch,
     &    gridno, statefile, spin,
     &    neval, fail, integral, error, prob)

	print *, "neval    =", neval
	print *, "fail     =", fail
	print '(F20.12," +- ",F20.12,"   p = ",F8.3)',
     &    (integral(c), error(c), prob(c), c = 1, ncomp)

	print *, " "
	print *, "-------------------- Suave test --------------------"

	call suave(ndim, ncomp, integrand, userdata, nvec,
     &    epsrel, epsabs, verbose + last, seed,
     &    mineval, maxeval, nnew, nmin, flatness,
     &    statefile, spin,
     &    nregions, neval, fail, integral, error, prob)

	print *, "nregions =", nregions
	print *, "neval    =", neval
	print *, "fail     =", fail
	print '(F20.12," +- ",F20.12,"   p = ",F8.3)',
     &    (integral(c), error(c), prob(c), c = 1, ncomp)

	print *, " "
	print *, "------------------- Divonne test -------------------"

	call divonne(ndim, ncomp, integrand, userdata, nvec,
     &    epsrel, epsabs, verbose, seed,
     &    mineval, maxeval, key1, key2, key3, maxpass,
     &    border, maxchisq, mindeviation,
     &    ngiven, ldxgiven, 0, nextra, 0,
     &    statefile, spin,
     &    nregions, neval, fail, integral, error, prob)

	print *, "nregions =", nregions
	print *, "neval    =", neval
	print *, "fail     =", fail
	print '(F20.12," +- ",F20.12,"   p = ",F8.3)',
     &    (integral(c), error(c), prob(c), c = 1, ncomp)

	print *, " "
	print *, "-------------------- Cuhre test --------------------"

	call cuhre(ndim, ncomp, integrand, userdata, nvec,
     &    epsrel, epsabs, verbose + last,
     &    mineval, maxeval, key,
     &    statefile, spin,
     &    nregions, neval, fail, integral, error, prob)

	print *, "nregions =", nregions
	print *, "neval    =", neval
	print *, "fail     =", fail
	print '(F20.12," +- ",F20.12,"   p = ",F8.3)',
     &    (integral(c), error(c), prob(c), c = 1, ncomp)
	end


************************************************************************

	integer function integrand(ndim, xx, ncomp, ff)
	implicit none
	integer ndim, ncomp
	cubareal xx(*), ff(*)

#define x xx(1)
#define y xx(2)
#define z xx(3)
#define f ff(1)

#ifndef FUN
#define FUN 1
#endif

	cubareal pi, rsq
	parameter (pi = 3.14159265358979323846D0)

	rsq = x**2 + y**2 + z**2

#if FUN == 1
	f = sin(x)*cos(y)*exp(z)
#elif FUN == 2
	f = 1/((x + y)**2 + .003D0)*cos(y)*exp(z)
#elif FUN == 3
	f = 1/(3.75D0 - cos(pi*x) - cos(pi*y) - cos(pi*z))
#elif FUN == 4
	f = abs(rsq - .125D0)
#elif FUN == 5
	f = exp(-rsq)
#elif FUN == 6
	f = 1/(1 - x*y*z + 1D-10)
#elif FUN == 7
	f = sqrt(abs(x - y - z))
#elif FUN == 8
	f = exp(-x*y*z)
#elif FUN == 9
	f = x**2/(cos(x + y + z + 1) + 5)
#elif FUN == 10
	if( x .gt. .5D0 ) then
	  f = 1/sqrt(x*y*z + 1D-5)
	else
	  f = sqrt(x*y*z)
	endif
#else
	if( rsq .lt. 1 ) then
	  f = 1
	else
	  f = 0
	endif
#endif

	integrand = 0
	end

!Simple program to get the scalar and tensor Cls, and print them out (and the sum)

      program tester
       use CAMB
        implicit none
        integer l
        real(dl) ratio

        type(CAMBparams)  P !defined in ModelParams in modules.f90

        
        call CAMB_SetDefParams(P)

        P%omegab  = .045
        P%omegac  = 0.355
        P%omegav  = 0.6
        P%omegan  = 0.0
        P%H0      = 65
   
        P%InitPower%nn     = 1 !number of initial power spectra
        P%InitPower%an(1)  = 1 !scalar spectral index
        P%InitPower%ant(1) = 0 !tensor spectra index
        P%InitPower%rat(1) = 1 !ratio of initial amplitudes
         !actually we don't use this here since we generate the Cls separately
         !so set to 1, and then put in the ratio after calculating the Cls

 
        P%OutputNormalization = outNone
      
        !Generate scalars first so that start with maximum Max_l that is used
        P%WantScalars = .true.
        P%WantTensors = .true.
      
        P%Max_l=1500
        P%Max_eta_k=3000
        P%Max_l_tensor=200
        P%Max_eta_k_tensor=500

        P%AccuratePolarization = .false. !We are only interested in the temperature here

        call CAMB_GetResults(P) 

        ratio =0.1

        do l=2,P%Max_l
           !print out scalar and tensor temperature, then sum
           if (l <= P%Max_l_tensor) then
              !The indices of the Cl_xxx arrays are l, initial power spectrum index, Cl type
             write(*,'(1I5,3E15.5)') l, Cl_scalar(l,1, C_Temp), ratio*Cl_tensor(l,1,CT_Temp), &
                   ratio*Cl_tensor(l,1,C_Temp)+Cl_scalar(l,1,C_Temp) 
           else
             write(*,'(1I5,3E15.5)') l,  Cl_scalar(l,1, C_Temp),0._dl,Cl_scalar(l,1,C_Temp) 
           end if
        end do   


        end program Tester

c-----------------------------------------------------------------------
c This code was modified from a subroutine from the gamerf package at
c http://momonga.t.u-tokyo.ac.jp/~ooura/gamerf.html .
c The original copyright statement states:
c   Copyright(C) 1996 Takuya OOURA (email: ooura@mmm.t.u-tokyo.ac.jp).
c   You may use, copy, modify this code for any purpose and 
c   without fee. You may distribute this ORIGINAL package.
c
c Permission to distribute this modified gamma function code
c with the FFTLog package has been granted
c (email from Takuya Ooura to Andrew Hamilton dated 16 March 1999).
c
c Original gamerf2a.doc documentation states:
c
c   Gamma(z)=sqrt(2*pi)*(z+r)^(z-1/2)*exp(-z-r)
c            *(a_0
c            +a_1*(z-1)/z
c            +a_2*(z-1)*(z-2)/z/(z+1)
c            +a_3*(z-1)*(z-2)*(z-3)/z/(z+1)/(z+2)
c            +...)
c        a_n= f_n*(2*n)*(2*n-1)*(2*n-2)*...*(n+1)/1/2/3/.../n
c            -a_0*(2*n)*(2*n-1)*(2*n-2)*...*(n+1)/1/2/3/.../n
c            -a_1*(2*n)*(2*n-1)*(2*n-2)*...*(n+2)/1/2/3/.../(n-1)
c            -...
c            -a_(n-1)*(2*n)/1
c        f_n=1/sqrt(2*pi)*(1*2*3*...*n)*(n+1+r)^(-n-1/2)*exp(n+1+r)

c   C.Lanczos,A Precision Approximation of the Gamma Function,
c   J.SIAM Numer.Anal.Ser.B,Vol.1,1964
c
c Modified 28 Oct 98 by Andrew J S Hamilton
c http://casa.colorado.edu/~ajsh/
c (1) to return ln[Gamma(x)] with the correct phase,
c     as well as Gamma(x), and
c (2) to remain accurate for large absolute values of input x,
c     and for x near 0 or negative integers.
c-----------------------------------------------------------------------
      complex*16 function cdgamma(x,l)
      integer l
      complex*16 x
c *
c * Complex Gamma function in double precision.
c *
c * l = 0: Gamma(x)
c *     1: ln[Gamma(x)]
c *
      real*8 pi,pv,pu,pr,p1,p2,p3,p4,p5,p6,q1,q2,q3,q4,q5,q6
      parameter (
     &    pi = 3.14159265358979324d+00, 
     &    pv = 7.31790632447016203d+00, 
     &    pu = 3.48064577727581257d+00, 
     &    pr = 3.27673720261526849d-02, 
     &    p1 = 1.05400280458730808d+01, 
     &    p2 = 4.73821439163096063d+01, 
     &    p3 = 9.11395751189899762d+01, 
     &    p4 = 6.62756400966213521d+01, 
     &    p5 = 1.32280130755055088d+01, 
     &    p6 = 2.93729529320536228d-01)
      parameter (
     &    q1 = 9.99999999999975753d-01, 
     &    q2 = 2.00000000000603851d+00, 
     &    q3 = 2.99999999944915534d+00, 
     &    q4 = 4.00000003016801681d+00, 
     &    q5 = 4.99999857982434025d+00, 
     &    q6 = 6.00009857740312429d+00)
      real*8 big
      parameter (big=1.d20)
      real*8 t,ui,ur,vi,vr,wr,wi,xi,xr,yi,yr,zero
      data zero /0.d0/
c
      xr = dble(x)
      xi = dimag(x)
c---x = 0, -1, -2
      if (xr .eq. aint(xr) .and. xr .le. 0.d0 .and. xi .eq. 0.d0) then
c...Gamma
        if (l .eq. 0) then
          wr = xr / 2.d0
c   +Infinity at even negative integers
          if (wr .eq. aint(wr)) then
            yr = 1.d0 / zero
c   -Infinity at odd negative integers
          else
            yr = -1.d0 / zero
          endif
          yi = 0.d0
c...lnGamma
        elseif (l .eq. 1) then
c   real part is +Infinity
          yr = 1.d0 / zero
          yi = pi * aint(xr)
        endif
        goto 200
      endif
c---Re(x) < 1/2 : use reflection formula
      if (xr .lt. .5d0) then
          wr = 1.d0 - xr
          wi = -xi
      else
          wr = xr
          wi = xi
      end if
c---large |x|: keep only leading term of rational function
      t = wr * wr + wi * wi
      if (t .gt. big * big) then
c   Rational function v
        vr = wr / t + pr
        vi = - wi / t
c   ln(overall factor)
c   u = ln(x + pv) - 1
        yr = wr + pv
        ur = yr
        if (ur .lt. 0.d0) ur = - ur
        ui = wi
        if (ui .lt. 0.d0) ui = - ui
        if (ur.ge.ui) then
          t = wi / yr
          ur = log(ur) + log(1.d0 + t * t) / 2.d0 - 1.d0
        else
          t = yr / wi
          ur = log(ui) + log(1.d0 + t * t) / 2.d0 - 1.d0
        endif
        ui = atan2(wi, yr)
c---not large |x|
      else
c   u = u(x) = x + q6 = O(x)
        ur = wr + q6
c   v = v(x,u) = (x + q5) u = (x + q5)(x + q6) = O(x^2)
        vr = ur * (wr + q5) - wi * wi
        vi = wi * (wr + q5) + ur * wi
c   y = y(x,u,v) = p6 + p5 u + p4 v = p4 x^2 + ... = O(x^2)
        yr = p6 + (p5 * ur + p4 * vr)
        yi = p5 * wi + p4 * vi
c   u = u(x,v) = (x + q4) v = (x + q4)(x + q5)(x + q6) = O(x^3)
        ur = vr * (wr + q4) - vi * wi
        ui = vi * (wr + q4) + vr * wi
c   v = v(x,u) = (x + q3) u = (x + q3)(x + q4)...(x + q6) = O(x^4)
        vr = ur * (wr + q3) - ui * wi
        vi = ui * (wr + q3) + ur * wi
c   y = y(y,u,v) = y + p3 u + p2 v = p2 x^4 + ... = O(x^4)
        yr = yr + (p3 * ur + p2 * vr)
        yi = yi + (p3 * ui + p2 * vi)
c   u = u(x,v) = (x + q2) v = (x + q2)(x + q3)...(x + q6) = O(x^5)
        ur = vr * (wr + q2) - vi * wi
        ui = vi * (wr + q2) + vr * wi
c   v = v(x,u) = (x + q1) u = (x + q1)(x + q2)...(x + q6) = O(x^6)
        vr = ur * (wr + q1) - ui * wi
        vi = ui * (wr + q1) + ur * wi
c   Numerator
c   y = y(y,u,v) = y + p1 u + v = x^6 + ... = O(x^6)
c     = (x+q1)...(x+q6) + p1 (x+q2)...(x+q6) + ... + p5 (x+q6) + p6
        yr = yr + (p1 * ur + vr)
        yi = yi + (p1 * ui + vi)
c   Denominator
c   u = x v = x(x + q1)(x + q2)...(x + q6) = O(x^7)
        ur = vr * wr - vi * wi
        ui = vi * wr + vr * wi
c   t = |u|^2
        t = ur * ur + ui * ui
c   Rational function v = y u*/|u|^2 + pr = y/u + pr = pr + 1/x + ...
c     = pr + 1/x ( 1 + 1/(x+q1) ( p1 + 1/(x+q2) ( p2 + ...
        vr = (yr * ur + yi * ui) / t + pr
        vi = (yi * ur - yr * ui) / t
c   Overall factor
c   u = ln(x + pv) - 1
        yr = wr + pv
        ur = log(yr * yr + wi * wi) / 2.d0 - 1.d0
        ui = atan2(wi, yr)
      endif
c---lnGamma
c   y = u(x - .5) - pu
c     = (x - .5) [ln(x + pv) - 1] - pu
      yr = ur * (wr - 0.5d0) - ui * wi - pu
      yi = ui * (wr - 0.5d0) + ur * wi
c   y = y + ln(v)
c     = (x - .5) [ln(x + pv) - 1] - pu + ln(Rational)
c     = lnGamma(x)
      yr = yr + log(vr * vr + vi * vi) / 2.d0
      yi = yi + atan2(vi, vr)
c---Reflection formula Gamma(x) Gamma(1-x) = pi/sin(pi x)
c   sign of Gamma
      t = 1.d0
      if (xr .lt. .5d0) then
        wi = anint(xr)
        wr = xr - wi
        if (wi .gt. xr) wi = wi - 1.d0
c   case of real x
        if (xi .eq. 0.d0) then
c   w = ln[sin(pi x)]
          wr = log(sin(pi * abs(wr)))
          if (l .eq. 0) then
            if (wi .ne. 2.d0 * aint(wi / 2)) t = -1.d0
            wi = 0.d0
          elseif (l .eq. 1) then
            wi = - pi * wi
          endif
c   case where imaginary part of x is < 1 in absolute value
        elseif (abs(xi) .lt. 1.d0) then
          if (l .eq. 0) then
            if (wi .ne. 2.d0 * aint(wi / 2.d0)) t = -1.d0
            ui = 0.d0
          elseif (l .eq. 1) then
            ui = -pi * wi
            if (xi .lt. 0.d0) ui = -ui
          endif
          wr = pi * wr
          wi = pi * xi
          vr = sin(wr) * cosh(wi)
          vi = cos(wr) * sinh(wi)
          if (wr .lt. 0.d0) then
            vr = -vr
            vi = -vi
          endif
c   w = ln[sin(pi x)]
          wr = log(vr * vr + vi * vi) / 2.d0
          wi = ui + atan2(vi, vr)
c   case where imaginary part of x is >= 1 in absolute value
        else
          if (l .eq. 0) then
            if (wi .ne. 2.d0 * aint(wi / 2)) t = -1.d0
            if (wr .ge. 0.d0) then
              ui = pi * (.5d0 - wr)
            else
              ui = pi * (- .5d0 - wr)
            endif
          elseif (l .eq. 1) then
            ui = pi * (.5d0 - xr)
          endif
          wi = exp(- 2.d0 * pi * abs(xi))
          wr = 2.d0 * pi * wr
          vr = (1.d0 - cos(wr) * wi) / 2.d0
          vi = - sin(wr) * wi / 2.d0
          ur = pi * xi
c   w = ln[sin(pi x)]
          if (xi .gt. 0.d0) then
            wr = ur + log(vr * vr + vi * vi) / 2.d0
            wi = ui + atan2(vi, vr)
          elseif (xi .lt. 0.d0) then
            wr = - ur + log(vr * vr + vi * vi) / 2.d0
            wi = - ui - atan2(vi, vr)
          endif
        endif
c   y = ln[Gamma(x)]
        yr = log(pi) - yr - wr
        yi = - yi - wi
      endif
c---Gamma
      if (l .eq. 0) then
        ur = exp(yr)
        if (xi .eq. 0.d0) then
          yr = t * ur
          yi = 0.d0
        else
          yr = t * ur * cos(yi)
          yi = ur * sin(yi)
        endif
      endif
c---finish
  200 cdgamma = dcmplx(yr, yi)
      end
c

!subroutine to export Cls in FITS format for HEALPix 1.2
!Antony Lewis July 2003


 subroutine WriteFitsCls(Clsfile, lmx)
  use CAMB
  use head_fits, ONLY : add_card 
  use fitstools, only : write_asctab
  implicit none
  character(LEN=*), INTENT(IN) ::  Clsfile
  integer, INTENT(IN) :: lmx
  CHARACTER(LEN=80), DIMENSION(1:120) :: header
  INTEGER nlheader,i, j
  real, allocatable, dimension (:,:) :: clout,allcl
  real(dl) :: fac,  PowerVals(20)
  character(Len=40) :: unitstr
  character(Len=8) :: PowerKeys(20)
  logical COBEnorm


  if (CP%InitPower%nn>1) write(*,*) &
       'Warning: FITS file contains result for first power spectrum only'

  allocate(clout(2:lmx,1:4))
   
  call CAMB_GetCls(clout, lmx, 1, .false.)
  !HealPix 1.2 uses E-B conventions

  if (CP%OutputNormalization == outCOBE) then
     fac=2*pi*CP%tcmb**2
  else
     if (CP%OutputNormalization >=2) then
      fac=1
     else
      fac=OutputDenominator*CP%tcmb**2
     end if
  end if

!FITS file has Cls without l(l+1)/twopi factors
  do i=2,lmx
     clout(i,:)=clout(i,:)/i/dble(i+1)*fac
  end do

  allocate(allcl(0:lmx,1:4))
  allcl(2:lmx,1:4) = clout
  allcl(0:1,1:4) = 0
  deallocate(clout)

  header = ''

  if (CP%OutputNormalization == outCOBE) then
     unitstr='Kelvin-squared'
  else
     unitstr='unknown'
  end if

  call add_card(header,'COMMENT','-----------------------------------------------')
  call add_card(header,'COMMENT','     CMB power spectrum C(l) keywords          ')
  call add_card(header,'COMMENT','-----------------------------------------------')
  call add_card(header,'EXTNAME','''COMPUTED POWER SPECTRUM''')
  call add_card(header,'COMMENT',' POWER SPECTRUM : C(l) ')
  call add_card(header)
  call add_card(header,'CREATOR','CAMB',        'Software creating the FITS file')
  call add_card(header,'VERSION',version,     'Version of the simulation software')
  call add_card(header,'POLAR',.true.,'Polarisation included (True/False)')
  call add_card(header,'POLNORM','CMBFAST','Uses E-B conventions')
  call add_card(header)
  call add_card(header)
  call add_card(header,'TTYPE1', 'TEMPERATURE','Temperature C(l)')
  call add_card(header,'TUNIT1', unitstr,'unit')
  call add_card(header)

     call add_card(header,'TTYPE2', 'E-mode C_l','ELECTRIC polarisation C(l)')
     call add_card(header,'TUNIT2', unitstr,'unit')
     call add_card(header)

     call add_card(header,'TTYPE3', 'B-mode C_l','MAGNETIC polarisation C(l)')
     call add_card(header,'TUNIT3', unitstr,'unit')
     call add_card(header)

     call add_card(header,'TTYPE4', 'E-T cross corr.','Gradient-Temperature cross terms')
     call add_card(header,'TUNIT4', unitstr,'unit')
     call add_card(header)

 call add_card(header,'COMMENT','-----------------------------------------------')
 call add_card(header,'COMMENT','     Cosmological parameters')
 call add_card(header,'COMMENT','-----------------------------------------------')
 call add_card(header,'OMEGAB',CP%omegab, 'Omega in baryons')
 call add_card(header,'OMEGAC',CP%omegac, 'Omega in CDM')
 call add_card(header,'OMEGAV',CP%omegav, 'Omega in cosmological constant')
 call add_card(header,'OMEGAN',CP%omegan, 'Omega in neutrinos')
 call add_card(header,'HUBBLE', CP%h0, 'Hublle constant in km/s/Mpc')
 call add_card(header,'NNUNR',CP%Num_Nu_massive, 'number of massive neutrinos')
 call add_card(header,'NNUR',CP%Num_Nu_massless, 'number of massless neutrinos')
 call add_card(header,'TCMB',CP%tcmb, 'CMB temperature in Kelvin')
 call add_card(header,'HELFRACT',CP%yhe, 'Helium fraction')
 call add_card(header,'OPTDLSS',CP%Reion%optical_depth, 'reionisation optical depth')
 call add_card(header,'IONFRACT',CP%Reion%fraction, 'ionisation fraction')
 call add_card(header,'ZREION',CP%reion%redshift, 'reionisation redshift')
 call add_card(header,'COMMENT','-----------------------------------------------')
 call add_card(header,'COMMENT','     Other parameters')
 call add_card(header,'COMMENT','-----------------------------------------------')
 call add_card(header,'SCALARS',CP%WantScalars, 'includes scalar modes')
 call add_card(header,'TENSORS',CP%WantTensors, 'includes tensor modes')
 call add_card(header,'INITFLAG',CP%Scalar_initial_condition, 'initial condition flag') 
 COBEnorm = CP%outputNormalization==outCOBE
 call add_card(header,'COBENORM',COBEnorm, 'COBE normalized') 
 call add_card(header,'KETA_MAX',CP%Max_eta_k, 'Max wavenumber') 
 call add_card(header,'PRECIS',AccuracyBoost, 'Relative computation accuracy') 
 call add_card(header,'EQS_FILE',Eqns_name, 'Gauge-dependent and background equations') 
 call add_card(header,'POW_FILE',Power_Name, 'Initial power spectrum file') 
 i = Power_Descript(1,CP%WantScalars,CP%WantTensors,PowerKeys,PowerVals)
 do j=1,i
 call add_card(header,PowerKeys(j),PowerVals(j), 'Initial power spectrum details') 
 end do
  
  nlheader = SIZE(header)
  call write_asctab (allcl, lmx, 4, header, nlheader, Clsfile)
  deallocate(allcl)

end subroutine WriteFitsCls

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      real*10 function felp(epoch)
      real*10 epoch
c
c        parameters
      include 'frames.par'
c        local (automatic) variables
      real*10 t
c *
c * Ecliptic latitude of NCP = Dec of ecliptic NP
c * as a function of epoch (e.g. 1950, 2000).
c *
c        RA & Dec epoch in centuries since 1900
      t=(epoch-1900._10)/100._10
c        ecliptic latitude of NCP = Dec of ecliptic NP
      felp=90._10-(E1+t*(E2+t*(E3+t*E4)))
      return
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gphi(angle,rp,cm,np,rpi,cmi,tol,phi,iord)
      integer np
      real*10 angle,rp(3,np),cm(np),rpi(3),cmi,tol
c        work arrays (could be automatic if compiler supports it)
      integer iord(2*np)
      real*10 phi(2,np)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        externals
      integer gsegij,gzeroar
c        data variables
      real*10 angtol,big
c        local variables
      integer i,iseg,j,jm,jml,jmu,jp,jpl,jpu,km,kp,ni,scmi
      real*10 dph,p,ph,phm,php,xi(3),yi(3)
c *
c * Angle along circle about unit direction rpi satisfying
c *    1 - r.rpi = cmi
c * and bounded by
c *    1 - r.rp(j) <= cm(j)  (if cm(j).ge.0)
c *    1 - r.rp(j) > -cm(j)  (if cm(j).lt.0)
c * for j=1,np where rp(j) are unit directions.
c * If the circle lies along a border of the polygon,
c * then the returned angle is zero.
c *
c  Input: rp(3,j),j=1,np
c         cm(j),j=1,np
c         np
c         rpi(3)
c         cmi
c         tol
c Output: angle
c Work arrays: phi and iord should be dimensioned at least 2*np
c
c        set azimuthal angle of non-intersection to big
      data big /1.e6_10/
c        ok if angle tests not too far outside [0,max]
      data angtol /1.e-10_10/
c
c        initialise angle to zero
      angle=0._10
c        check for null circle
      if (cmi.lt.0._10) goto 410
      if (cmi.gt.2._10) goto 410
c        check for zero angle because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
      scmi=1
c........construct cartesian axes with z-axis along rpi
      call gaxisi(rpi,xi,yi)
c........angles phi about z-axis rp(i) of intersection of i & j circles
c        passing i=0 means circle at edge is considered outside polygon
      call gphij(rp,cm,np,0,rpi,scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside (or at edge of) polygon
      if (ni.le.-1) goto 410
c........order angles around circle
c        circle has no intersections
      if (ni.eq.0) then
        angle=TWOPI
c        circle has intersections
      elseif (ni.gt.0) then
c        find ordering of intersection angles around circle
        call findbot(phi,2*np,iord,ni)
c........vertices around i circle
        jpl=0
c        come here to do another segment
  220   continue
c........is segment edge of polygon?
          iseg=gsegij(rp,cm,np,0,0,i,rpi,scmi,cmi,tol,ni,
     *      phi,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
c        error
          if (iseg.eq.-1) goto 420
c        not an edge
          if (iseg.eq.0) goto 220
c        gone full circle
          if (iseg.eq.2) goto 280
c........segment satisfies conditions
c         print *,'segment',km,kp,' dph/(2*pi)=',dph/TWOPI
          angle=angle+dph
c        do another segment
        goto 220
      endif
  280 continue
c........check angle is between 0 and 2*pi
      p=angle/TWOPI
c     print *,rpi(1),rpi(2),rpi(3),'angle/(2*pi) =',p
      if (p.lt.0._10) then
        write (*,'(" *** from gphi: angle/(2*pi) = ",g24.16,
     *    " should be >= 0")') p
        goto 420
      elseif (p.gt.1._10) then
c        check if discrepancy is from numerical roundoff
        if (angle.le.TWOPI+angtol) then
          angle=TWOPI
        else
          write (*,'(" *** from gphi: angle/(2*pi) = ",g24.16,
     *      " should be <= 1")') p
          goto 420
        endif
      endif
c........done
      return
c
c        zero angle
  410 continue
      return
c
  420 print *,'*** from gphi: total failure at tol =',tol
      write (*,'(a3,a20,4a24)')
     *  ' ','x','y','z',
c    *  'r',
     *  '1-c'
      do j=1,np
        write (*,'(i3,5g24.16)')
     *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *    cm(j)
      enddo
      write (*,'(i3,5g24.16)')
     *  0,(rpi(i),i=1,3),
c    *  sqrt(rpi(1)**2+rpi(2)**2+rpi(3)**2),
     *  cmi
      return
c
      end
c

!This module provides the initial power spectra, parameterized as an expansion in ln k
!
! ln P = ln A_s + (n_s -1)*ln(k/k_0) + n_{run}/2 * ln(k/k_0)^2 
!
! so if n_run = 0
!
! P = A_s (k/k_0_scalar)^(n_s-1)
!
!for the scalar spectrum, when an(in) is the in'th spectral index. k_0_scalar
!is a pivot scale, fixed here to 0.05/Mpc (change it below as desired).
!
!This module uses the same inputs an(in), ant(in) and rat(in) as CMBFAST, however here
!rat(in) is used to set the ratio of the initial power spectra, so here
!
!** rat(in) is not the Cl quadrupole ratio ***
!
!in general models the quadrupole ratio depends in a complicated way on the ratio of the initial
!power spectra

!The absolute normalization of the Cls is unimportant here, but the relative ratio
!of the tensor and scalar Cls generated with this module will be correct for general models


!The OutputNormalization parameter controls the final output
!Absolute Cls can be obtained by setting OuputNormalization=outNone, otherwise the overall normalization
!of the power spectra doesn't matter

!This version December 2003 - changed default tensor pivot to 0.05 (consistent with CMBFAST 4.5)

     module InitialPower   
     use Precision
     implicit none   

     private
    
      character(LEN=*), parameter :: Power_Name = 'power_tilt'

      integer, parameter :: nnmax= 5 
       !Maximum possible number of different power spectra to use

      Type InitialPowerParams

       integer nn  !Must have this variable
      !The actual number of power spectra to use
  
      !For the default implementation return power spectra based on spectral indices
       real(dl) an(nnmax) !scalar spectral indices
       real(dl) n_run(nnmax) !running of spectral index 
       real(dl) ant(nnmax) !tensor spectral indices
       real(dl) rat(nnmax) !ratio of scalar to tensor initial power spectrum amplitudes
       real(dl) k_0_scalar, k_0_tensor
       real(dl) ScalarPowerAmp(nnmax)
 
      end Type InitialPowerParams

      real(dl) curv  !Curvature contant, set in InitializePowers     
      
      Type(InitialPowerParams) :: P
  
!Make things visible as neccessary...
 
      public InitialPowerParams, InitialPower_ReadParams, InitializePowers, ScalarPower, TensorPower
      public nnmax,Power_Descript, Power_Name, SetDefPowerParams
!      public 
    contains
       
  
       subroutine SetDefPowerParams(AP)
        Type (InitialPowerParams) :: AP

         AP%nn     = 1 !number of initial power spectra
         AP%an     = 1 !scalar spectral index
         AP%n_run   = 0 !running of scalar spectral index
         AP%ant    = 0 !tensor spectra index
         AP%rat    = 1
         AP%k_0_scalar = 0.05
         AP%k_0_tensor = 0.05
         AP%ScalarPowerAmp = 1

       end subroutine SetDefPowerParams

       subroutine InitializePowers(AParamSet,acurv)
         Type (InitialPowerParams) :: AParamSet
         !Called before computing final Cls in cmbmain.f90
         !Could read spectra from disk here, do other processing, etc.

        real(dl) acurv

        if (AParamSet%nn > nnmax) then
           write (*,*) 'To use ',AParamSet%nn,'power spectra you need to increase'
           write (*,*) 'nnmax in power_tilt.f90, currently ',nnmax
        end if
        P = AParamSet

        curv=acurv         

!Write implementation specific code here...

       end subroutine InitializePowers
       

      function ScalarPower(k,in)

       !"in" gives the index of the power to return for this k
       !ScalarPower = const for scale invariant spectrum
       !The normalization is defined so that for adiabatic perturbations the gradient of the 3-Ricci 
       !scalar on co-moving hypersurfaces receives power
       ! < |D_a R^{(3)}|^2 > = int dk/k 16 k^6/S^6 (1-3K/k^2)^2 ScalarPower(k) 
       !In other words ScalarPower is the power spectrum of the conserved curvature perturbation given by
       !-chi = \Phi + 2/3*\Omega^{-1} \frac{H^{-1}\Phi' - \Psi}{1+w}
       !(w=p/\rho), so < |\chi(x)|^2 > = \int dk/k ScalarPower(k).
       !Near the end of inflation chi is equal to 3/2 Psi.
       !Here nu^2 = (k^2 + curv)/|curv| 

       !This power spectrum is also used for isocurvature modes where 
       !< |\Delta(x)|^2 > = \int dk/k ScalarPower(k)
       !For the isocurvture velocity mode ScalarPower is the power in the neutrino heat flux.

        real(dl) ScalarPower,k, lnrat
        integer in

          lnrat = log(k/P%k_0_scalar)
          ScalarPower=P%ScalarPowerAmp(in)*exp((P%an(in)-1)*lnrat + P%n_run(in)/2*lnrat**2)   
     
!         ScalarPower = ScalarPower * (1 + 0.1*cos( lnrat*30 ) )
 
      end function ScalarPower

      
      function TensorPower(k,in)
      
       !TensorPower= const for scale invariant spectrum
       !The normalization is defined so that
       ! < h_{ij}(x) h^{ij}(x) > = \sum_nu nu /(nu^2-1) (nu^2-4)/nu^2 TensorPower(k)
       !for a closed model
       ! < h_{ij}(x) h^{ij}(x) > = int d nu /(nu^2+1) (nu^2+4)/nu^2 TensorPower(k)
       !for an open model
       !"in" gives the index of the power spectrum to return 
       !Here nu^2 = (k^2 + 3*curv)/|curv| 


        real(dl) TensorPower,k   
        real(dl), parameter :: PiByTwo=3.14159265d0/2._dl
   
        integer in

        TensorPower=P%rat(in)*P%ScalarPowerAmp(in)*exp(P%ant(in)*log(k/P%k_0_tensor))
        if (curv < 0) TensorPower=TensorPower*tanh(PiByTwo*sqrt(-k**2/curv-3)) 

       
      end function TensorPower

      !Get parameters describing parameterisation (for FITS file)
     function Power_Descript(in, Scal, Tens, Keys, Vals)
         character(LEN=8), intent(out) :: Keys(*)
         real(dl), intent(out) :: Vals(*)
         integer, intent(IN) :: in
         logical, intent(IN) :: Scal, Tens
         integer num, Power_Descript
         num=0
         if (Scal) then
         num=num+1
         Keys(num) = 'n_s'
         Vals(num) = P%an(in)
         num=num+1
         Keys(num) = 'n_run'
         Vals(num) = P%n_run(in)
         num=num+1
         Keys(num) = 's_pivot'
         Vals(num) = P%k_0_scalar
         end if
         if (Tens) then
         num=num+1
         Keys(num) = 'n_t'
         Vals(num) = P%ant(in)
         num=num+1
         Keys(num) = 't_pivot'
         Vals(num) = P%k_0_tensor
         if (Scal) then
           num=num+1
           Keys(num) = 'p_ratio'
           Vals(num) = P%rat(in)
         end if
         end if
         Power_Descript = num

       end  function Power_Descript
        
       subroutine InitialPower_ReadParams(InitPower, Ini, WantTensors)
          use IniFile
          Type(InitialPowerParams) :: InitPower
          Type(TIniFile) :: Ini
          logical, intent(in) :: WantTensors
          integer i
          
           InitPower%k_0_scalar = Ini_Read_Double_File(Ini,'pivot_scalar',InitPower%k_0_scalar)
           InitPower%k_0_tensor = Ini_Read_Double_File(Ini,'pivot_tensor',InitPower%k_0_tensor) 
           InitPower%nn = Ini_Read_Int('initial_power_num')
           if (InitPower%nn>nnmax) stop 'Too many initial power spectra - increase nnmax in InitialPower'
           InitPower%rat(:) = 1
           do i=1, InitPower%nn

              InitPower%an(i) = Ini_Read_Double_Array_File(Ini,'scalar_spectral_index', i)
              InitPower%n_run(i) = Ini_Read_Double_Array_File(Ini,'scalar_nrun',i,0._dl) 
              
              if (WantTensors) then
                 InitPower%ant(i) = Ini_Read_Double_Array_File(Ini,'tensor_spectral_index',i)
                 InitPower%rat(i) = Ini_Read_Double_Array_File(Ini,'initial_ratio',i)
              end if              

              InitPower%ScalarPowerAmp(i) = Ini_Read_Double_Array_File(Ini,'scalar_amp',i,1._dl) 
              !Always need this as may want to set tensor amplitude even if scalars not computed
           end do
          
       end  subroutine InitialPower_ReadParams 


     end module InitialPower

! Driver for FFTLog-f90.
!
! FFTLog-f90 is the Fortran 90 version of FFTLog, a Fortran 77 code by
! Andrew Hamilton to compute the Fourier-Bessel, or Hankel, transform of
! of a series of logarithmically spaced points.
!
! The main reference for the algorithm is Andrew Hamilton's webpage,
! http://casa.colorado.edu/~ajsh/FFTLog. He first introduced FFTLog in a
! paper on the nonlinearities in the cosmological structures
! (http://xxx.lanl.gov/abs/astro-ph/9905191).
!
! The Fourier-Bessel, or Hankel, transform F(r) of a function f(k) is defined
! as in eq. 159 of Hamilton's paper:
!
!           /
!  F(r) =  | dk * k * J_mu(k*r) * f(k)
!          /
!
! where J_mu(k*r) is the Bessel function of order mu and argument k*r. 
!
! IMPORTANT: Currently, FFTLog-f90 only supports the sine transform (mu=0.5)
! and returns the following integral:
!
!              1       /            sin(k*r)
!  F(r) = ----------  | dk * k^2 * ---------- * f(k)
!          (2*pi)^2   /                k*r
!
! If f(k)=P(k) is the power spectrum of a homogeneous 3D random field, then the
! integral will yield the two-point correlation function xi(r), as in eq. 3.104
! of http://arxiv.org/abs/1405.2280.
!
! To generalise FFTLog-f90 to arbitrary Bessel order, one needs to use
! the FHTQ subroutine rather than the FFTL one.
!
! ARGUMENTS
!
! This is the list of command-line arguments taken by FFTLog-f90:
!
! 1. The path of the input file, containing the k and f(k) columns.
!
! 2. The path of the output file, containing the r and F(r) columns. The file
!    will have as many rows as the input file, unless a third argument is given.
!    By default, the range in r will go from 1/k_max to 1/k_min and will contain
!    as many points as the rows in the input file.
!
! 3. [OPTIONAL] N_OUTFILE, the number of r values to include in the output file.
!    Set to zero to use the same number of points in the input file (default behaviour).
!    If positive, then f(k) will be interpolated in N_OUTFILE points and fed to FFTLog.
!
! 4. [OPTIONAL] The order mu of the Bessel function J_mu. By default we take mu=0.5,
!    which corresponds to a regular Fourier transform.
!
! 5. [OPTIONAL] The bias q of the Hankel transformation, as defined in eq. 156.
!    By default we take it to vanish (b=0).
!
! 6. [OPTIONAL] Inferior limit in k for the integration. By default it is set 
!    to the first value in the k column.
!
! 7. [OPTIONAL] Superior limit in k for the integration. By default it is set 
!    to the first value in the k column.
!
! Created by Guido Walter Pettinari on 26/07/2010
! Last modified on 09/09/2015 by GWP


PROGRAM fftlog_f90

	IMPLICIT NONE

	REAL ( KIND = 8 ), PARAMETER :: PI=3.141592653589793238462643383279502884197d0, CONSTANT= 1/(2*PI*PI)*sqrt(PI/2)
	REAL ( KIND = 8 ) :: xx_inf_limit = -1d300, xx_sup_limit = 1d300, dln_xx, dlog_xx, log_xmedian,&
                       &log_xxmedian, log_xxmax, log_xxmin, rk, kr, mu, CENTRAL_INDEX, q, x, temp1, temp2
	INTEGER :: N_ARGUMENTS, DIRECTION, KR_OPTION, UNIT, error, N_INFILE=0, N_USED=0, FIRST_USED_INDEX = 0,&
             &LAST_USED_INDEX=0, N_OUTFILE=0, i=0
	LOGICAL :: INTERPOLATION = .FALSE., FFT_OK
	CHARACTER(512) :: input_filename, output_filename
	CHARACTER(128) :: buffer
  !	The arrays xx and yy will contain the x and y values from the input file, respectively.
  ! They will be overwritten by the FFTL subroutine with the Hankel transform.
	REAL ( KIND = 8 ), DIMENSION(:), ALLOCATABLE :: xx, yy
  ! Parameters for the spline interpolation
	REAL ( KIND = 8 ), DIMENSION(:), ALLOCATABLE :: yy_second_derivative, yy_interp, wsave
  !	Complain if the input file has more than N_MAX lines, because it would require
  ! about 2 GB or RAM. Increase N_MAX if you have more memory than that.
	INTEGER, PARAMETER :: N_MAX=67108864
	
  
  
  ! =======================================================================================
  ! =                                   Parse arguments                                   =
  ! =======================================================================================
  
	N_ARGUMENTS = COMMAND_ARGUMENT_COUNT()
	
	IF ( N_ARGUMENTS.GT.7 .OR. N_ARGUMENTS.LT.2 ) STOP &
   & "FFTLog-f95 can have between 2 and 7 arguments. For more details, please refer to the&
   & documentation in fftlog_driver.f90 (https://github.com/coccoinomane/fftlog-f90)."


	CALL GET_COMMAND_ARGUMENT( 1, input_filename )
	CALL GET_COMMAND_ARGUMENT( 2, output_filename )

	IF ( N_ARGUMENTS .GE. 3 ) THEN
		CALL GET_COMMAND_ARGUMENT( 3, buffer )
		READ ( buffer, * ) N_OUTFILE
	END IF

	! order of Bessel function ( mu = 0.5 for sine transform )
  mu = 0.5d0
	IF ( N_ARGUMENTS .GE. 4 ) THEN
		CALL GET_COMMAND_ARGUMENT( 4, buffer )
		READ ( buffer, * ) mu
	END IF
  IF (mu .NE. 0.5d0) STOP &
   & "FFTLog-f90 so far only supports sine (mu=0.5) and cosine (mu=0.5) transforms. Make&
   & sure that the fourth argument is either 0.5 or -0.5, respectively."

	! bias exponent: q = 0 is unbiased ( good for power spectrum <-> correlation function )
  q = 0.d0
	IF ( N_ARGUMENTS .GE. 5 ) THEN
		CALL GET_COMMAND_ARGUMENT( 5, buffer )
		READ ( buffer, * ) q
	END IF

	IF ( N_ARGUMENTS == 6 ) THEN
		CALL GET_COMMAND_ARGUMENT( 6, buffer )
		READ ( buffer, * ) xx_sup_limit
	END IF
		
	IF ( N_ARGUMENTS == 7 ) THEN
		CALL GET_COMMAND_ARGUMENT( 6, buffer )
		READ ( buffer, * ) xx_inf_limit
		CALL GET_COMMAND_ARGUMENT( 7, buffer )
		READ ( buffer, * ) xx_sup_limit
	END IF
	
  
  
  ! =======================================================================================
  ! =                                   Read input file                                   =
  ! =======================================================================================  
  
  ! Select the entries of input_filename to process
	OPEN ( UNIT=50, FILE=input_filename, STATUS='OLD', IOSTAT=error )
	IF ( error /= 0 ) STOP "Input file could not be opened, exiting..."
	DO
		READ (UNIT=50, FMT=*, IOSTAT=error) temp1
		IF ( error < 0 ) EXIT
		N_INFILE = N_INFILE + 1		
		IF ( temp1 < xx_inf_limit .OR. temp1 > xx_sup_limit ) CYCLE
		N_USED = N_USED + 1
		LAST_USED_INDEX = N_INFILE
	END DO
	CLOSE(UNIT = 50)
	FIRST_USED_INDEX = LAST_USED_INDEX - N_USED + 1
	
  !	Control block	
	IF ( N_USED == 0 ) STOP "Either the input file is empty or incompatible with the specified integration limits."	
	IF ( N_OUTFILE .LE. 0 ) THEN	
		N_OUTFILE = N_USED
		INTERPOLATION = .FALSE.
!		PRINT *, "No interpolation of input data will be performed."
	ELSE
		INTERPOLATION = .TRUE.
	END IF		
    IF ( (N_USED > N_MAX) .OR. (N_OUTFILE > N_MAX) ) &
    &STOP "The number you specified or the number of elements of the input file are greater that N_MAX"

  ! It is now safe to allocate memory to the arrays
	ALLOCATE( xx(N_USED), yy(N_USED), yy_second_derivative(N_USED) )
  ALLOCATE( yy_interp(N_OUTFILE), wsave ( 2*N_OUTFILE + 3*(N_OUTFILE/2) + 19 ) )

  ! Read the first two columns of the input file
	OPEN ( UNIT=50, FILE=input_filename, STATUS='OLD', IOSTAT=error )
	IF ( error /= 0 ) STOP "Input file could not be opened, exiting..."
  !	Dump the rows of the file that are smaller than xx_inf_limit
	DO i = 1, FIRST_USED_INDEX - 1
		READ ( 50, FMT=*, IOSTAT=error )
	END DO
	DO i = 1, N_USED
		READ ( 50, FMT=*, IOSTAT=error ) temp1, temp2
		IF ( error < 0 ) EXIT
		xx(i) = temp1
		yy(i) = temp2
	END DO
	CLOSE( UNIT = 50 )
	
	!PRINT *, "Inferior integration limit = ", xx(1)
	!PRINT *, "corresponding in input file to row = ", FIRST_USED_INDEX
	!PRINT *, "Superior integration limit = ", xx(N_USED)
	!PRINT *, "corresponding in input file to row = ", LAST_USED_INDEX	
	!PRINT *, "Order of Bessel function mu = ", mu
	!PRINT *, "Number of elements in input file = ", N_INFILE
  !PRINT *, "Number of elements used = ", N_USED
	!PRINT *, "Number of elements in output file = ", N_OUTFILE



  ! =======================================================================================
  ! =                                Prepare integrand f(k)                               =
  ! =======================================================================================  

  ! Take the logarithm of the x limits
	log_xxmin = LOG10( xx(1) )
	log_xxmax = LOG10( xx(N_USED) )
  
  ! Logarithmic step in x
	dlog_xx = (log_xxmax-log_xxmin) / (N_OUTFILE-1)

	! central index (1/2 integral if N_OUTFILE is even)
	CENTRAL_INDEX = dble( N_OUTFILE+1 ) / 2.d0
	
	! logarithmical spacing between points (needed by fhti). Was dlnr
	dln_xx = dlog_xx * LOG(10.d0)

	! central point of periodic interval at log10 (xxmedian). Was logrc
	log_xxmedian = ( log_xxmin + log_xxmax) / 2.d0

	! sensible approximate choice of k_c r_c
	kr = 1.d0

	! tell fhti to change kr to low-ringing value
	KR_OPTION = 1

	! forward transform
	DIRECTION = 1

	! central point in k-space. Was logkc
	log_xmedian = LOG10 (kr) - log_xxmedian

	! rk = r_c/k_c
  rk = 10.d0 ** ( log_xxmedian - log_xmedian )

  ! Interpolate the input 
	IF( INTERPOLATION ) THEN
		! Compute the second derivative of the input array yy. The prototype is
    ! spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )
		CALL SPLINE_CUBIC_SET ( N_USED, xx, yy, 0, 0.0d0, 0, 0.0d0, yy_second_derivative )
		DO i = 1, N_OUTFILE ! the x's are the input domain
			x = 10.d0 ** ( log_xxmedian + ( i - CENTRAL_INDEX )*dlog_xx )
      ! Interpolate the input array yy in x. The prototype is
			! spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )
			CALL SPLINE_CUBIC_VAL ( N_USED, xx, yy, yy_second_derivative, x, yy_interp(i), temp1, temp2 )
			yy_interp(i) = yy_interp(i)*x
		END DO
		DEALLOCATE ( yy_second_derivative )
	ELSE
		DO i = 1, N_USED
			yy(i) = xx(i) * yy(i)
		END DO
	END IF
  
  
  
  ! =======================================================================================
  ! =                                    Call FFTLog                                      =
  ! =======================================================================================

  ! Initialize FFTLog transform. Note that fhti resets kr
	CALL FHTI ( N_OUTFILE, mu, q, dln_xx, kr, KR_OPTION, wsave, FFT_OK )
	IF( .NOT. FFT_OK ) STOP "FHTI not ok!"

  ! Call FFTLog
	IF( INTERPOLATION ) THEN 
		CALL FFTL ( N_OUTFILE, yy_interp, rk, DIRECTION, wsave )
	ELSE
		CALL FFTL ( N_OUTFILE, yy, rk, DIRECTION, wsave )
	END IF
	


  ! =======================================================================================
  ! =                                Write result to file                                 =
  ! =======================================================================================

	OPEN( UNIT=40, FILE = output_filename, STATUS = "REPLACE", IOSTAT = error )
	IF ( error /= 0 ) STOP "Output file could not be opened, exiting..."
	IF ( INTERPOLATION ) THEN 
		DO i = 1, N_OUTFILE ! now the x's are the output domain
			x = 10.d0 ** ( log_xmedian + ( i - CENTRAL_INDEX ) * dlog_xx )
			WRITE ( 40, '(3g24.16)' ) x, CONSTANT * yy_interp(i)/x
		END DO
		DEALLOCATE ( yy_interp )
	ELSE
		DO i = 1, N_OUTFILE ! now the x's are the output domain
			x = 10.d0 ** ( log_xmedian + ( i - CENTRAL_INDEX )*dlog_xx )
			WRITE( 40, '(3g24.16)' ) x, CONSTANT * yy(i)/x
		END DO
	END IF
	DEALLOCATE(xx,yy,wsave)
	
END PROGRAM fftlog_f90

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gsphera(area,bound,vert,w,lmax1,im,nw,ibv,
     *  azmin,azmax,elmin,elmax,v,dw)
      integer lmax1,im,nw,ibv
      real*10 area,bound(2),vert(2),w(im,nw),
     *  azmin,azmax,elmin,elmax,dw(nw)
c        work array (could be automatic if compiler supports it)
      real*10 v(lmax1)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI,PIBYTWO
      parameter (TWOPI=2._10*PI,PIBYTWO=PI/2._10)
c        data variables
      real*10 elmino,elmaxo
c        saved variables
      real*10 cl,cu,dth,sl,su
      save cl,cu,dth,sl,su
c        local (automatic) variables
      integer i,l,m,lm,lmax,mmax
      real*10 azmx,cmph,d,dph,ph,smph,thmin,thmax
c *
c * Accelerated computation of spherical transform
c * of rectangle bounded by lines of constant latitude & longitude.
c *
c  Input: lmax1 = lmax+1 where lmax is maximum desired l of transform.
c         im = 1 means compute only real part of harmonics;
c              2 means compute both real and imaginary parts.
c              Note harmonics are real if region possesses reflection
c              symmetry through plane defined by x- and z-axes.
c         nw = [(lmax+1)*(lmax+2)]/2
c         ibv = 0 to 3 controls evaluation of bound & vert,
c               and determines the sign of the returned harmonics,
c               same as in gspher;
c               see comments in gspher for more details.
c         azmin, azmax = minimum, maximum azimuth of rectangle in radians;
c                if azmin > azmax, it is assumed that the rectangle
c                runs from azmin to azmax + 2*pi .
c                To cover an entire strip of latitude, use
c                azmin, azmax = 0, 2*pi .
c         elmin, elmax = minimum, maximum elevation of rectangle in radians;
c                South pole is at elevation -pi/2, North at +pi/2.
c Output: area = area of rectangle in steradians.
c         bound = length of boundary of rectangle in radians if ibv=0,
c                 or as explained in gspher ibv>0.
c         vert = sum over vertices of 1-psi/tan(psi) if ibv=0,
c                where psi is exterior angle (=pi-interior angle)
c                at vertex, or as explained in gspher if ibv>0.
c         dw = integral_thmin^thmax Y_lm(th,0) sin th d th,
c              which should be saved between calls.
c Input/Output: w(i,lm) = spherical transform, dimensioned w(im,nw)
c            w(i,lm), i=1,im, lm=l*(l+1)/2+m+1, l=0,lmax, m=0,l;
c            w(1,lm) is real part, w(2,lm) is imaginary part (if im=2).
c            Note w(l,-m)=(-)**m*[Complex conjugate of w(l,m)], just as
c                 Y(l,-m)=(-)**m*[Complex conjugate of Y(l,m)].
c Work arrays: v should be dimensioned at least lmax1.
c
      data elmino,elmaxo /2*0._10/
c
c        zero stuff
      area=0._10
      bound(1)=0._10
      bound(2)=0._10
      vert(1)=0._10
      vert(2)=0._10
      do lm=1,nw
        do i=1,im
          w(i,lm)=0._10
        enddo
      enddo
c        check input parameters OK
      if (lmax1.le.0) goto 200
      if (elmin.ge.PIBYTWO.or.elmax.le.-PIBYTWO) goto 200
      if (elmin.ge.elmax) goto 200
      azmx=azmax
c        assume azmax.lt.azmin means need to add 2*pi to azmax
      if (azmx.lt.azmin) azmx=azmx+TWOPI
c--------compute integrals of harmonics if elmin and elmax changed
      if (elmino.ne.elmin.or.elmaxo.ne.elmax) then
        if (elmax.ge.PIBYTWO) then
          thmin=0._10
          cu=1._10
          su=0._10
        else
          thmin=PIBYTWO-elmax
          cu=cos(thmin)
          su=sin(thmin)
        endif
        if (elmin.le.-PIBYTWO) then
          thmax=PI
          cl=-1._10
          sl=0._10
        else
          thmax=PIBYTWO-elmin
          cl=cos(thmax)
          sl=sin(thmax)
        endif
        dth=thmax-thmin
c        integrals of harmonics: this takes most time
        call iylm(thmin,thmax,dw,lmax1,nw,v)
        elmaxo=elmax
        elmino=elmin
      endif
c--------fast computation of harmonics
      dph=azmx-azmin
      area=(cu-cl)*dph
      if (ibv.eq.0.or.ibv.eq.2.or.ibv.eq.3) then
        bound(1)=(sl+su)*dph+2._10*dth
        bound(2)=(1._10/sl-2._10*sl+1._10/su-2._10*su)*dph-2._10*dth
        vert(1)=4._10
        vert(2)=4._10*(cl/sl-cu/su)
        if (ibv.eq.2) then
          bound(1)=-bound(1)
          bound(2)=-bound(2)
          vert(1)=-vert(1)
          vert(2)=-vert(2)
        endif
      endif
      ph=(azmx+azmin)/2._10
      if (ibv.ge.2) dph=-dph
      lmax=lmax1-1
      mmax=lmax
      if (dph-nint(dph/TWOPI)*TWOPI.eq.0._10) mmax=0
      do m=0,mmax
        if (m.eq.0) then
          d=dph
        elseif (m.gt.0) then
          d=sin(m*dph/2._10)*2._10/dble(m)
        endif
        cmph=cos(m*ph)
        smph=sin(m*ph)
        lm=(m*(m+1))/2+1
        do l=m,lmax
          lm=lm+l
          w(1,lm)=w(1,lm)+cmph*d*dw(lm)
          if (im.eq.2) w(2,lm)=w(2,lm)-smph*d*dw(lm)
        enddo
      enddo
  200 continue
      return
      end
c

!! Implements the multi-point propagator expansion for the nonlinear       !!
!! matter power spectrum, following Crocce, Scoccimarro and Bernardeau     !! 
!! 2012 (arXiv ). Version 1.0                                              !!
     
      program MPTbreeze
      
      implicit  none

      real*8    tol,pi,ak1,ak2,adk
      integer   iwr,Nbins
      parameter (pi=3.1415927d0)

      real*8    Om0,sig80,sig8,ns,w,var8
      real*8    az,Dp,HF,HF0,sigv,eps,akfun,kc
      real*8    ak,G
      common    / argk    / ak
      common    / klimits / eps,kc
      common    / sigv    / sigv

      integer   i,nlin,nlinmx
      parameter (nlinmx=2000)
      real*8    klin(nlinmx),plin(nlinmx),plind(nlinmx),k,tf,akmin,akmax
      common    / pklin    / klin,plin,plind,nlin
      common    / pklimits / akmin,akmax
      character fileTF*200

      real*8    variance,powlin,af,fk,p1loop,p2loop
      external  variance,powlin,gabqx,af,p1loop,p2loop

      character filePk*200
      real*8    P0,P1L,P2L

      integer   iverbose,nargs,iarg,nc,ic
      real*8    omegab,hv,omch2,ombh2,omc,omb,Hubblev,atf(10)
      character path*60,cambF*200,argc*200
      character args(3)*200,argstr*20


!}{ Some default parameters

      nc       = 2
      iverbose = 1
      path     = "./"
      fileTF   = ""
      filePk   = ""

      sig80    = 1.d4
      az       = 1.d4

!}{ Default cosmological parameters

      Hubblev = 70.
      hv      = 0.7
      sig80   = 0.817
      Om0     = 0.279
      az      = 0.0
      ns      = 0.96
      w       = -1.0

!}{ Reading of the command line options

      nargs   = iargc()

      do iarg=1,nargs
         call getarg(iarg,argc)
         if (argc.eq."-noverbose") then
            iverbose=0
         endif
         if (argc.eq."-verbose") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) iverbose
         endif
         if (argc.eq."-path") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,path)
         endif
         if (argc.eq."-fileTF") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,fileTF)
         endif
         if (argc.eq."-filePk") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,filePk)
         endif
         if (argc.eq."-camb") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,cambF)
            cambF=path(1:len_trim(path))//cambF(1:len_trim(cambF))
            ombh2=0.
            omch2=0.
            open(9, file=cambF, status='old',err=104)
            do while(.true.)
              read(9,*,END=14) args(1),args(2),args(3)
              if (args(1).eq.'hubble') read(args(3),*) Hubblev
              if (args(1).eq.'ombh2') read(args(3),*) ombh2
              if (args(1).eq.'omch2') read(args(3),*) omch2
              if (args(1).eq.'omega_baryon') read(args(3),*) omb
              if (args(1).eq.'omega_cdm') read(args(3),*) omc
              if (args(1).eq.'w') read(args(3),*) w
              if (args(1)(1:21).eq.'scalar_spectral_index') 
     &             read(args(3),*) ns
              if (args(1)(1:17).eq.'transfer_filename') then
                 fileTF=args(3)
              endif
              nc=7
            enddo
 14         continue
            close(9)
            hv=Hubblev/100.
            omegab=max(ombh2/hv/hv,omb)
            Om0=omegab+max(omch2/hv/hv,omc)
         endif
         if (argc.eq."-sigma8") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) sig80
         endif
         if (argc.eq."-omegam") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) Om0
         endif
         if (argc.eq."-h") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) hv
         endif
         if (argc.eq."-ns") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) ns
         endif
         if (argc.eq."-redshift") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) az
         endif
         if (argc.eq."-w") then
            if (iarg.eq.nargs) goto 106
            call getarg(iarg+1,argstr)
            read(argstr,*,err=106) w
         endif
      enddo

      if(filePk.eq."") filePk="MPTbreeze_"//fileTF(1:len_trim(fileTF))
      fileTF = path(1:len_trim(path))//fileTF(1:len_trim(fileTF))
      filePk = path(1:len_trim(path))//filePk(1:len_trim(filePk))

!}{ Inline instructions when verbose <> 0      

      if (iverbose.ge.1) then
      write(6,*)'-----------------------------------------------------
     &--------------------------'
      write(6,*)':  MPTbreeze  = density power spectrum from Multipoin
     &t Propagators            :'
      write(6,*)':               in Perturbation Theory               
     &                         :'
      write(6,*)'-----------------------------------------------------
     &--------------------------'
      write(6,*)': Description of the online options:                 
     &                         :' 
      write(6,*)':  "-noverbose", to suppress verbose                 
     &                         :'
      write(6,*)':                                                    
     &                         :'
      write(6,*)':  "-path" aaa, access path to input and ouput files 
     & (default =./)           :'
      write(6,*)':  "-camb" aaa, to use CAMB ".ini" file for cosmologi
     &cal parameters           :'
      write(6,*)':           and transfer function file.              
     &                         :'
      write(6,*)':                                                    
     &                         :'
      write(6,*)':  "-fileTF" aaa, name of the input Transfer Function
     &file.                    :'
      write(6,*)':  "-sigma8" xxx, to specify the value of sigma8 (def
     &ault.=0.817)             :'
      write(6,*)':  "-omegam" xxx, to specify the value of Omega_m (de
     &fault=.279)              :'
      write(6,*)':  "-ns" xxx, to specify the value of ns (default=.96
     &)                        :'
      write(6,*)':  "-w" xxx, to specify the value of w (default=-1)  
     &                         :'
      write(6,*)':  "-redshift" z, value of the redshift of the comput
     &ed spectra (default=0)   :'
      write(6,*)':  "-filePk" aaa, name of the ouput power spectra.   
     &                         :'
      write(6,*)':____________________________________________________
     &_________________________:'
      write(6,*)
      write(6,*) '    Execution log :'
      write(6,*)
      endif
      if (iverbose.ge.1) then
         write(6,'(A,A)')     '> Initial Transfer file = ',fileTF(1:len_
     &   trim(fileTF))
         write(6,'(A,f10.4)') '> sigma8 = ',sig80
         write(6,'(A,f10.4)') '> omegam = ',Om0
         write(6,'(A,f10.4)') '> spectral index = ',ns
         write(6,'(A,f10.4)') '> eq. of state of DE = ',w
         write(6,'(A,f10.4)') '> output redshift = ',az
      endif         

!}{ Set up linear power spectrum

      open(unit=11,file=fileTF,status='old',err=105) ! Read Transfer Function
      nlin = 0
      do while (.true.)
         read(11,*,end=13) k,(atf(ic),ic=1,nc-1)
         tf         = atf(nc-1)
         nlin       = nlin+1
         klin(nlin) = k
         plin(nlin) = k**ns*tf**2.d0         
      enddo
 13   continue
      close(11)
      If (iverbose.ge.1) then
         write(6,*)
         write(6,"(A,I5,A20)") '> read ',nlin,' lines from input TF'
      endif

      call spline(klin,plin,nlin,3d30,3d30,plind)
      akmin = klin(1)
      akmax = klin(nlin)
      If (iverbose.ge.1) then
       write(6,"(10x,A,F10.7,A,F8.2)") 'kmin=',akmin,' and kmax=',akmax
      endif


      call GFw(w,0.d0,Om0,HF0)
      call GFw(w,az,Om0,HF)
      Dp = HF/HF0/(1+az)
      sig8 = sig80*Dp
      var8 = variance(8.d0)
      do i=1,nlin
      plin(i) = sig8**2*plin(i)/var8
      plind(i)= sig8**2*plind(i)/var8
      enddo

!}{ Compute BAO damping and nonlinear density power spectrum 

      tol  = 1.d-4                                                    
      iwr  = 0          
      call gabqx(powlin,eps,akmax,sigv,tol,iwr)
      sigv = dsqrt(4.d0*pi*sigv/3.d0)

      adk = 0.005d0
!!    ak1 = 0.01d0
      ak2 = 1.d0/sigv      
      eps = akmin

      If (iverbose.ge.1) then
         write(6,'(10x,A,f7.3,A,f10.4)') 'sigv=',sigv,' and knl=',ak2
      endif

      open(unit=8,file=filePk,status='unknown')      

      i = 1
      do while(ak.le.ak2)         !! Edit here for different maximum wavemode and binning !!
         ak   = adk*real(i)
         kc   = max(20.d0*ak,pi)
         call gabqx(af,eps,kc,fk,tol,iwr)
         G    = dexp(fk)
         write(8,100) ak,powlin(ak)*G**2.d0,p1loop(ak)*G**2.d0,
     &   p2loop(ak)*G**2.d0
         i = i+1
      enddo
      close(8)     
 
      If (iverbose.ge.1) then
      write(6,*)
      write(6,'(A)') '> done '
      write(6,'(A,A)') '> Output PS file = ',filePk(1:len_trim(filePk))
      endif
      
 100  format(2x,8e16.6)
      stop

      goto 107
 104  write(6,*) ' ! Error, file not found: ',cambF(1:len_trim(cambF))
      stop
 105  write(6,*) ' ! Error, file not found: ',fileTF(1:len_trim(fileTF))
      stop
 106  write(6,*) ' ! Error in command line for ',argc(1:len_trim(argc))
      stop
 107  continue

      end program MPTbreeze


![1]

      real*8    function powlin(QQ)   !linear power

      implicit  none
      integer   nlinmx,nlin
      parameter (nlinmx=2000)
      real*8    klin(nlinmx),plin(nlinmx),plind(nlinmx)
      real*8    akmin,akmax,QQ
      common    / pklin / klin,plin,plind,nlin
      common    / pklimits / akmin,akmax
      external  splint
      
      if (QQ.ge.akmin .and. QQ.le.akmax) then 
      call splint(klin,plin,plind,nlin,QQ,powlin)
      else
      powlin=0.d0
      endif

      return
      end

![2]

      real*8    function variance(qq)   !linear variance

      implicit  none
      integer   limit
      parameter (limit=1000)
      integer   neval,ier,iord(limit),last
      real*8    alist(limit),blist(limit),elist(limit),rlist(limit)
      real*8    ans,epsabs,epsrel,abserr
      real*8    akmin,akmax,varint,ar,qq
      common    / varscale / ar
      common    / pklimits / akmin,akmax
      external  varint

      ar = qq
      epsabs = 0.d0
      epsrel = 1.d-4                                                            
      call dqage(varint,akmin,akmax,epsabs,epsrel,30,limit,ans,abserr,
     $neval,ier,alist,blist,rlist,elist,iord,last)
      variance = ans
      return
      end

      real*8    function varint(ak)   !linear variance integrand

      implicit  none
      real*8    ak,ax,wth,pid,ar,powlin
      common    / varscale / ar
      external  powlin
      pid = 3.141592654d0
      ax = ak*ar
      wth = 3.d0/ax**3 *(dsin(ax)-ax*dcos(ax))
      varint = powlin(ak) * 4.d0*pid *ak**2 *wth**2
      return
      end

![3]

      real*8    function af(q)  !f integrand

      implicit  none
      real*8    k,q,pi,powlin
      parameter (pi=3.1415926d0)
      external  powlin
      common    / argk /k
       
      af=(4.96031746031746d-4*(4.d0*(6.d0*k**7*q-7.9d1*k**5*q**
     &3+5.d1*k**3*q**5-2.1d1*k*q**7)+3.d0*(k**2-q**2)**3*(2.d0*
     &k**2+7.d0*q**2)*log((k-q)**2/(k+q)**2)))/(k**3*q**5)
     
      af=af*powlin(q)*4.d0*pi*q**2
      return 
      end

![4]

      real*8    function P1loop(k)   

      implicit  none
      real*8    pi,ans,k,kk,P1loopq,eps,kc
      external  P1loopq,G,gabqx

      common    / klimits / eps,kc
      common    / varsP /   kk

      integer   limit
      parameter (limit=1000)
      integer   neval,ier,iord(limit),last
      real*8    alist(limit),blist(limit),elist(limit),rlist(limit)
      real*8    epsabs,epsrel,abserr

      integer   iwr
      real*8    tol

      pi     = 3.141592654d0
      kk     = k

      epsabs = 0.d0
      epsrel = 0.001d0         !! Relative Error !!

      call dqage(P1loopq,eps,kc,epsabs,epsrel,30,limit,
     $ ans,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
      P1loop = 4.d0*pi*ans

      return
      end
      
      real*8    function P1loopq(q)   !  22 q-integrand

      implicit  none
      integer   iwr
      real*8    powlin,qq,tol,P1loopx,ans,q
      common    / loopP / qq
      external  powlin,gabqy,P1loopx

      qq   = q
      tol  = 1.d-2        !! Relative Error !!                  
      iwr  = 0                                                             
      call gabqy(P1loopx,-1.d0,1.d0,ans,tol,iwr)
      P1loopq = q**2*powlin(q)*ans      
      return
      end

      real*8    function P1loopx(x)   !  22 x-integrand

      implicit  none
      real*8    powlin,F2,k1q,a1q,q,x,k
      external  powlin,F2
      common    / varsP / k
      common    / loopP / q

      k1q = dsqrt(k**2+q**2-2.d0*k*q*x)
      a1q = (k*x-q)/k1q
      P1loopx=powlin(k1q)*F2(k1q,q,a1q)**2 
      
      return
      end

![5]

      real*8 function P2loop(k)   ! 2L power spectrum

      include   'header-vegas.f'
      real*8    pi,k,ak,eps,kc
      external  vegas,integrand
      common    / wavevec / ak
      common    / klimits / eps,kc
      
      pi = 3.141592654d0
      ak = k

      call vegas(ndim, ncomp, integrand,
     &  epsrel, epsabs, verbose, mineval, maxeval,
     &  nstart, nincrease,
     &  neval, fail, integral, error, prob)
      P2loop = integral(1)
      
      return
      end

      subroutine integrand(ndim,xx,ncomp,ff)

      implicit  none
      integer   ndim, ncomp
      real*8    xx(ndim),ff(ncomp),f
      real*8    ak,q,p,x,y,phi
      real*8    F3,F3s,powlin,pi,cosxy,kqp,a1,a2,a3
      external  F3,F3s,powlin

      real*8    qmin,qmax,pmin,pmax,xmin,xmax,ymin,ymax,phimin,phimax
      real*8    eps,kc
      common    / klimits / eps,kc
      common    /wavevec/ ak
      
      pi     = 3.141592654d0

      qmin   = eps
      qmax   = kc
      pmin   = eps
      pmax   = kc
      xmin   = -1.d0
      xmax   = 1.d0
      ymin   = -1.d0
      ymax   = 1.d0
      phimin = 0.d0
      phimax = 2.d0*pi

      q   = qmax*xx(1)+qmin*(1.d0-xx(1))
      p   = pmax*xx(2)+pmin*(1.d0-xx(2))
      x   = xmax*xx(3)+xmin*(1.d0-xx(3))
      y   = ymax*xx(4)+ymin*(1.d0-xx(4))
      phi = phimax*xx(5)+phimin*(1.d0-xx(5))

      cosxy = (x*y+dsqrt(1.d0-x**2)*dsqrt(1.d0-y**2)*cos(phi))
      kqp   = dsqrt(ak**2+q**2+p**2-2.*(ak*p*y+ak*q*x-p*q*cosxy))
      
      a1 = (ak*q*x-q**2-p*q*cosxy)/(kqp*q)
      a2 = cosxy
      a3 = (ak*p*y-p**2-p*q*cosxy)/(kqp*p)

      f=F3s(kqp,q,p,a1,a2,a3)**2*powlin(kqp)*powlin(q)*powlin(p)

      f=f*q**2*p**2  

      ff(1)=f*12.d0*pi*(qmax-qmin)*(xmax-xmin)
     &*(pmax-pmin)*(ymax-ymin)*(phimax-phimin)

      return
      end

      real*8  function F3s(q1,q2,q3,x12,x23,x31)   ! symmetrized F3 kernel

      implicit  none
      real*8    q1,q2,q3,x12,x23,x31,F3
      external  F3      
      
      F3s = F3(q1,q2,q3,x12,x23,x31)+F3(q2,q1,q3,x12,x31,x23)+
     &      F3(q3,q2,q1,x23,x12,x31)+F3(q1,q3,q2,x31,x23,x12)+
     &      F3(q2,q3,q1,x23,x31,x12)+F3(q3,q1,q2,x31,x12,x23)
      F3s = F3s/6.d0
      
      return
      end

      real*8 function F3(q1,q2,q3,x12,x23,x31)   ! F3 (needs k=q123 as common)

      implicit none
      real*8   q1,q2,q3,x12,x23,x31,al1,al2,be1,be2,ak,F2,G2
      common   / wavevec / ak
      external F2,G2
      
      al1 = 1.d0+(q2*x12+q3*x31)/q1
      al2 = 1.d0+(q3*q1*x31+q2*q3*x23)/(q1**2+q2**2+2.d0*q1*q2*x12)
      be1 = 0.5d0*ak**2 *(q1*q2*x12+q3*q1*x31)/q1**2
      be1 = be1/(q2**2+q3**2+2.d0*q2*q3*x23)
      be2 = 0.5d0*ak**2 *(q2*q3*x23+q3*q1*x31)/q3**2
      be2 = be2/(q1**2+q2**2+2.d0*q1*q2*x12)
      
      F3  = 7.d0*al1*F2(q2,q3,x23) + 2.d0*be1* G2(q2,q3,x23)+
     &      (7.d0*al2 + 2.d0*be2)*G2(q1,q2,x12) 
      
      F3 =  F3/18.d0

      if(F3.ne.F3) F3 = 0.d0

      return
      end

![6]

      real*8    function F2(q1,q2,x12)   ! F2 kernel

      implicit  none
      real*8    q1,q2,x12
      real*8    epsilon,Om

      F2 = (5.d0/7.d0 + x12/2.d0 *(q1/q2+q2/q1) + 2.d0/7.d0 *x12**2)

      return
      end

      real*8 function G2(q1,q2,x12)      ! G2 kernel

      implicit  none
      real*8    q1,q2,x12

      G2 = 3.d0/7.d0 + x12/2.d0*(q1/q2+q2/q1) + 4.d0/7.d0*x12**2.d0

      return
      end


      include 'subs/dqage.f'
      include 'subs/d1mach.f'
      include 'subs/spline_dp.f'
      include 'subs/splint_dp.f'
      include 'subs/dqawfe.f'      
      include 'subs/gabqx.f'
      include 'subs/gabqy.f'
      include 'subs/gabqz.f'
      include 'subs/GFw.f'

module Reionization
 use Precision
 use AMLutils
 implicit none  

!This module puts smooth tanh reionization of specified mid-point (z_{re}) and width
!The tanh function is in the variable (1+z)**Rionization_zexp

!Rionization_zexp=1.5 has the property that for the same z_{re} 
!the optical depth agrees with infinitely sharp model for matter domination 
!So tau and zre can be mapped into each other easily (for any symmetric window)
!However for generality the module maps tau into z_{re} using a binary search
!so could be easily modified for other monatonic parameterizations.

!AL March 2008
!AL July 2008 - added trap for setting optical depth without use_optical_depth

!See CAMB notes for further discussion: http://cosmologist.info/notes/CAMB.pdf

       character(LEN=*), parameter :: Reionization_Name = 'CAMB_reionization'

       real(dl), parameter :: Reionization_DefFraction = -1._dl 
        !if -1 set from YHe assuming Hydrogen and first ionization of Helium follow each other
       
       real(dl) :: Reionization_AccuracyBoost = 1._dl
       real(dl) :: Rionization_zexp = 1.5_dl

       logical :: include_helium_fullreion = .true.
       real(dl) :: helium_fullreion_redshift  = 3.5_dl
       real(dl) :: helium_fullreion_deltaredshift  = 0.5
       real(dl) :: helium_fullreion_redshiftstart  = 5._dl
       
       
       type ReionizationParams
             logical    :: Reionization
             logical    :: use_optical_depth
             real(dl)   :: redshift, delta_redshift, fraction
             real(dl)   :: optical_depth
        end type ReionizationParams
  
        type ReionizationHistory
!These two are used by main code to bound region where xe changing 
          real(dl) :: tau_start, tau_complete
!This is set from main code          
          real(dl) :: akthom, fHe

!The rest are internal to this module.
          real(dl) :: WindowVarMid, WindowVarDelta

        end type ReionizationHistory

      real(dl), parameter :: Reionization_maxz = 50._dl
      real(dl), private, parameter :: Reionization_tol = 1d-5

      real(dl), private, external :: dtauda, rombint,rombint2

    Type(ReionizationParams), private, pointer ::  ThisReion
    Type(ReionizationHistory), private, pointer :: ThisReionHist

contains

 
 function Reionization_xe(a, tau, xe_recomb)
 !a and time tau and redundant, both provided for convenience
 !xe_recomb is xe(tau_start) from recombination (typically very small, ~2e-4)
 !xe should map smoothly onto xe_recomb
  real(dl), intent(in) :: a
  real(dl), intent(in), optional :: tau, xe_recomb
  real(dl) Reionization_xe
  real(dl) tgh, xod
  real(dl) xstart
  
        if (present(xe_recomb)) then
        xstart = xe_recomb
        else
        xstart = 0._dl
        end if
        
        xod = (ThisReionHist%WindowVarMid - 1._dl/a**Rionization_zexp)/ThisReionHist%WindowVarDelta
        if (xod > 100) then
            tgh=1.d0
        else
            tgh=tanh(xod)
        end if
        Reionization_xe =(ThisReion%fraction-xstart)*(tgh+1._dl)/2._dl+xstart
     
        if (include_helium_fullreion .and. a > (1/(1+ helium_fullreion_redshiftstart))) then
        
         !Effect of Helium becoming fully ionized at z <~ 3.5 is very small so details not important
          xod = (1+helium_fullreion_redshift - 1._dl/a)/helium_fullreion_deltaredshift
          if (xod > 100) then
             tgh=1.d0
          else
             tgh=tanh(xod)
          end if
      
        Reionization_xe =  Reionization_xe + ThisReionHist%fHe*(tgh+1._dl)/2._dl
  
       end if
      
 end function Reionization_xe  
 
 function Reionization_timesteps(ReionHist)
 !minimum number of time steps to use between tau_start and tau_complete
 !Scaled by AccuracyBoost later
 !steps may be set smaller than this anyway
  Type(ReionizationHistory) :: ReionHist
  integer Reionization_timesteps
  
  Reionization_timesteps = 50 
  
 end  function Reionization_timesteps
 
 subroutine Reionization_ReadParams(Reion, Ini)
  use IniFile
  Type(ReionizationParams) :: Reion
  Type(TIniFile) :: Ini

   Reion%Reionization = Ini_Read_Logical_File(Ini,'reionization')
   if (Reion%Reionization) then
   
    Reion%use_optical_depth = Ini_Read_Logical_File(Ini,'re_use_optical_depth') 
  
    if (Reion%use_optical_depth) then
              Reion%optical_depth = Ini_Read_Double_File(Ini,'re_optical_depth')
    else 
              Reion%redshift = Ini_Read_Double_File(Ini,'re_redshift')
    end if 

    Reion%delta_redshift = Ini_Read_Double_File(Ini,'re_delta_redshift', 0.5_dl) !default similar to CMBFAST original
    Reion%fraction = Ini_Read_Double_File(Ini,'re_ionization_frac',Reionization_DefFraction)
  
  end if

 end subroutine Reionization_ReadParams 

 subroutine Reionization_SetParamsForZre(Reion,ReionHist)
  Type(ReionizationParams), target :: Reion
  Type(ReionizationHistory), target :: ReionHist 
     
       ReionHist%WindowVarMid = (1._dl+Reion%redshift)**Rionization_zexp
       ReionHist%WindowVarDelta = &
         Rionization_zexp*(1._dl+Reion%redshift)**(Rionization_zexp-1._dl)*Reion%delta_redshift
 
 end subroutine Reionization_SetParamsForZre

 subroutine Reionization_Init(Reion, ReionHist, Yhe, akthom, tau0, FeedbackLevel)
  use constants
  Type(ReionizationParams), target :: Reion
  Type(ReionizationHistory), target :: ReionHist
  real(dl), intent(in) :: akthom, tau0, Yhe 
  integer, intent(in) :: FeedbackLevel
  real(dl) astart

     ReionHist%akthom = akthom  
     ReionHist%fHe =  YHe/(mass_ratio_He_H*(1.d0-YHe))
 
     ReionHist%tau_start=tau0
     ReionHist%tau_complete=tau0
      
     ThisReion => Reion
     ThisReionHist => ReionHist

     if (Reion%Reionization) then
 
            if (Reion%optical_depth /= 0._dl .and. .not. Reion%use_optical_depth) &
             write (*,*) 'WARNING: You seem to have set the optical depth, but use_optical_depth = F'
    

           if (Reion%use_optical_depth.and.Reion%optical_depth<0.001 &
                .or. .not.Reion%use_optical_depth .and. Reion%Redshift<0.001) then
               Reion%Reionization = .false.
           end if
          
      end if   
     
     if (Reion%Reionization) then
           
        if (Reion%fraction==Reionization_DefFraction) &
                 Reion%fraction = 1._dl + ReionHist%fHe  !H + singly ionized He
          
       if (Reion%use_optical_depth) then
        call Reionization_SetFromOptDepth(Reion,ReionHist)
        if (FeedbackLevel > 0) write(*,'("Reion redshift       =  ",f6.3)') Reion%redshift
       end if

       call Reionization_SetParamsForZre(ThisReion,ThisReionHist)
       
      !this is a check, agrees very well in default parameterization
       if (FeedbackLevel > 1) write(*,'("Integrated opt depth = ",f7.4)') &
            Reionization_GetOptDepth(Reion, ReionHist) 

      !Get relevant times       
       astart=1.d0/(1.d0+Reion%redshift + Reion%delta_redshift*8)
       ReionHist%tau_start = max(0.05_dl, rombint(dtauda,0._dl,astart,1d-3))
          !Time when a very small reionization fraction (assuming tanh fitting)

       ReionHist%tau_complete = min(tau0, &
          ReionHist%tau_start+ rombint(dtauda,astart,1.d0/(1.d0+max(0.d0,Reion%redshift-Reion%delta_redshift*8)),1d-3))

    end if   
       
 end subroutine Reionization_Init
 
 
 subroutine Reionization_SetDefParams(Reion)
  Type(ReionizationParams) :: Reion
 
       Reion%Reionization = .true.
       Reion%use_optical_depth = .false.
       Reion%optical_depth = 0._dl
       Reion%redshift = 10
       Reion%fraction = Reionization_DefFraction
       Reion%delta_redshift = 0.5_dl

 end subroutine Reionization_SetDefParams

 subroutine Reionization_Validate(Reion, OK)
  Type(ReionizationParams),intent(in) :: Reion
  logical, intent(inout) :: OK
 
      if (Reion%Reionization) then
        if (Reion%use_optical_depth) then
            if (Reion%optical_depth<0 .or. Reion%optical_depth > 0.9  .or. &
               include_helium_fullreion .and. Reion%optical_depth<0.01) then
             OK = .false.
             write(*,*) 'Optical depth is strange. You have:', Reion%optical_depth 
            end if
        else
            if (Reion%redshift < 0 .or. Reion%Redshift +Reion%delta_redshift*3 > Reionization_maxz .or. &
              include_helium_fullreion .and. Reion%redshift < helium_fullreion_redshift) then
                OK = .false.
                write(*,*) 'Reionization redshift strange. You have: ',Reion%Redshift
            end if
        end if
        if (Reion%fraction/= Reionization_DefFraction .and. (Reion%fraction < 0 .or. Reion%fraction > 1.5)) then
                OK = .false.
                write(*,*) 'Reionization fraction strange. You have: ',Reion%fraction
        end if
        if (Reion%delta_redshift > 3 .or. Reion%delta_redshift<0.1 ) then
        !Very narrow windows likely to cause problems in interpolation etc.
        !Very broad likely to conflic with quasar data at z=6
                OK = .false.
                write(*,*) 'Reionization delta_redshift is strange. You have: ',Reion%delta_redshift
        end if


      end if
             
  end  subroutine Reionization_Validate


 function Reionization_doptdepth_dz(z)
   real(dl) :: Reionization_doptdepth_dz
   real(dl), intent(in) :: z
   real(dl) a
   
   a = 1._dl/(1._dl+z)
   
   Reionization_doptdepth_dz = Reionization_xe(a)*ThisReionHist%akthom*dtauda(a)

 end function Reionization_doptdepth_dz

function Reionization_GetOptDepth(Reion, ReionHist) 
 Type(ReionizationParams), target :: Reion
 Type(ReionizationHistory), target :: ReionHist
 real(dl) Reionization_GetOptDepth      
  
  ThisReion => Reion
  ThisReionHist => ReionHist
  Reionization_GetOptDepth = rombint2(Reionization_doptdepth_dz,0.d0,Reionization_maxz,&
         Reionization_tol, 20, nint(Reionization_maxz/Reion%delta_redshift*5))

end function Reionization_GetOptDepth

 subroutine Reionization_zreFromOptDepth(Reion, ReionHist)
 !General routine to find zre parameter given optical depth
 !Not used for Rionization_zexp = 1.5
  Type(ReionizationParams) :: Reion
  Type(ReionizationHistory) :: ReionHist
  real(dl) try_b, try_t
  real(dl) tau
  integer i
  
  try_b = 0
  try_t = Reionization_maxz
  i=0
  do 
       i=i+1  
       Reion%redshift = (try_t + try_b)/2
       call Reionization_SetParamsForZre(Reion,ReionHist)
       tau = Reionization_GetOptDepth(Reion, ReionHist)
       
       if (tau > Reion%optical_depth) then
                  try_t = Reion%redshift
          else
                  try_b = Reion%redshift
       end if
       if (abs(try_b - try_t) < 2e-3/Reionization_AccuracyBoost) exit
       if (i>100) call mpiStop('Reionization_zreFromOptDepth: failed to converge')
  end do
  
  
   if (abs(tau - Reion%optical_depth) > 0.002) then
    write (*,*) 'Reionization_zreFromOptDepth: Did not converge to optical depth'
    write (*,*) 'tau =',tau, 'optical_depth = ', Reion%optical_depth
    write (*,*) try_t, try_b
    call mpiStop()
  end if
    
 end subroutine Reionization_zreFromOptDepth 


 
 subroutine Reionization_SetFromOptDepth(Reion, ReionHist)
  Type(ReionizationParams) :: Reion
  Type(ReionizationHistory) :: ReionHist
   
! This subroutine calculates the redshift of reionization

! This implementation is approximate but quite accurate and fast

      real(dl) dz, optd
      real(dl) z, tmp, tmpHe
      integer na
      
      Reion%redshift = 0

      if (Reion%Reionization .and. Reion%optical_depth /= 0) then

           !Do binary search to find zre from z
           !This is general method
           call Reionization_zreFromOptDepth(Reion, ReionHist)

        if (.false.) then
          !Use equivalence with sharp for special case
            optd=0
            na=1
            dz=1._dl/2000/Reionization_AccuracyBoost
            tmp = dz*Reion%fraction*ThisReionHist%akthom
            tmpHe = dz*(Reion%fraction+ReionHist%fHe)*ThisReionHist%akthom
            z=0
            do while (optd < Reion%optical_depth)
                z=na*dz
                if (include_helium_fullreion .and. z < helium_fullreion_redshift) then
                optd=optd+ tmpHe*dtauda(1._dl/(1._dl+z))
                else
                optd=optd+tmp*dtauda(1._dl/(1._dl+z))
                end if
                na=na+1
            end do
         end if
      else
         Reion%Reionization = .false.
      end if
 
 end  subroutine Reionization_SetFromOptDepth 



end module Reionization

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gspher(area,bound,vert,w,lmax1,im,nw,rp,cm,np,npc,ibv,
     *  iphi,tol,phw,iord,v,ldegen)
      integer lmax1,im,nw,np,npc,ibv,iphi
      logical ldegen
      real*10 area,bound(2),vert(2),w(im,nw),rp(3,np),cm(np),tol
c        work arrays (could be automatic if compiler supports it)
      integer iord(2*np)
      real*10 phw(2,np),v(lmax1)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        externals
      integer garpi,gsegij,gzeroar
c        data variables
      real*10 big
      real*10 dphmin
c        local (automatic) variables
      integer i,iarea,ik,iseg,j,jm,jml,jmu,jp,jpl,jpu,k,km,kp,l,
     *  nbd,nbd0m,nbd0p,ni,nmult,retry,scmi
C     logical warn
      logical whole
      real*10 bik,ci,cmi,cmik,cmk,cti,ctk,ctpsi,
     *  d,darea,dbound(2),dph,dvert(2),ikchk,ikran,
     *  ph,phi,phii,phm,php,psi,psip,ri,rii,si,sk,sqrt4pi,t,tolin,
     *  xi(3),yi(3)
c *
c * Spherical transform of region W of sphere of unit radius bounded by
c *    1 - r.rp(i) < cm(i)  (if cm(i).ge.0)
c *    1 - r.rp(i) > -cm(i)  (if cm(i).lt.0)
c * for i=1,np where rp(i) are unit directions.
c * See AJSH notes Multfn C115.
c *
c * bound (boundary) and vert (vertex) are related to the coefficients
c * of the 1st & 2nd order terms of the power series expansion
c * in sin(th/2) of the correlation <WW> at angular separation th:
c *    <WW> = sum(lm) |W_lm|^2 P_l(cos th)
c *         = 2*pi*area - 4*bound*sin(th/2) + 2*vert*sin^2(th/2) + ...
c * In fact bound is just the total length of the boundary in radians,
c * and vert is the sum over vertex terms of 1-psi/tan(psi), where
c * psi is the exterior angle (=pi-interior angle) at the vertex.
c * The range of validity of the power series expansion in sin(th/2)
c * depends on the tortuousness of the boundary: the more convoluted the
c * boundary, and the sharper the vertex angles, the shorter the range.
c *
c * Oct 1992: next order term incorporated
c *    <WW> = 2*pi*area - 4*bound(1)*sin(th/2) + 2*vert(1)*sin^2(th/2)
c *           + [2/3*bound(2) + 8/9*vert(2)]*sin^3(th/2) + ...
c *
c * The option ibv modifies the evaluation of bound and vert,
c * and determines the sign of the returned harmonics.
c * ibv = 0: standard option, for <WW>.
c *          The code returns the harmonics of W in the array w.
c * ibv = 1: to take the cross-correlation between a region W1 and
c *          its intersection W12 with region W2.
c *          Here <W12 W1> = <W12^2> + <W12(W1-W12)>
c *          and this is what the code evaluates bound and vert for.
c *          The code returns the harmonics of W12 in the array w.
c * ibv = 2: to take region W1 less its intersection W12 with region W2.
c *          Here <WW> = <(W1-W12)(W1-W12)>
c *                    = <W1^2> - <W12^2> - 2<W12(W1-W12)>
c *          The code evaluates bound and vert for
c *                               <W12^2> + 2<W12(W1-W12)>.
c *          The code returns MINUS the harmonics of W12 in the array w.
c * ibv = 3: to take the union of regions W1 and W2.
c *          Here <WW> = <(W1+W2-W12)(W1+W2-W12)>
c *                    = <W1^2> + <W2^2> - <W12^2> + 2<(W1-W12)(W2-W12)>
c *          The code evaluates bound and vert for
c *                               <W12^2> - 2<(W1-W12)(W2-W12)>.
c *          The code returns MINUS the harmonics of W12 in the array w.
c * The correct calling procedure in each case is exampled below.
c *
c * Complement of a region:
c *    area -> 4*pi-area,  w(1,1) -> sqrt(4*pi)-w(1,1)
c *    bound -> bound
c *    vert -> vert
c *    w -> -w   except monopole term w(1,1) as above
c *
c * To get intersection W12 of regions W1 & W2,
c * but evaluate bound & vert for cross-correlation between W12 and W1:
c *    put the np2 constraints of region W2 in 1 to npc
c *      & the np1 constraints of region W1 in npc+1 to np
c *    call gspher(area,bound,vert,w,parameters of W1,npc=np2,1,...)
c *
c * To get region W1 less its intersection with region W2:
c *    call gspher(area,bound,vert,w,parameters of W1,npc=0,0,...)
c *    put the np2 constraints of region W2 in 1 to npc
c *      & the np1 constraints of region W1 in npc+1 to np
c *    call gspher(darea,dbound,dvert,w,params of W1 & W2,npc=np2,2,...)
c *    area=area-darea
c *    bound=bound-dbound
c *    vert=vert-dvert
c *
c * To get the union of two regions W1 & W2:
c *    call gspher(area,bound,vert,w,parameters of W1,npc=0,0,...)
c *    call gspher(darea,dbound,dvert,w,parameters of W2,npc=0,0,...)
c *    area=area+darea
c *    bound=bound+dbound
c *    vert=dvert+dvert
c *    put the np2 constraints of region W2 in 1 to npc
c *      & the np1 constraints of region W1 in npc+1 to np
c *    call gspher(darea,dbound,dvert,w,params of W1 & W2,npc=np2,3,...)
c *    area=area-darea
c *    bound=bound-dbound
c *    vert=dvert-dvert
c *
c * Cautions:
c * (1) This subroutine underestimates the area (monopole harmonic)
c *     by 2*pi (sqrt(pi)) if 2*pi <= area < 4*pi
c *     and the area is bounded by more than one arc.
c * (2) This subroutine will usually work correctly when there are near
c *     multiple (.ge. 3) intersections of boundaries, but in rare
c *     instances it may fail.  If so, it should flag the failure with
c *     ldegen=.true.  This error condition should NOT be ignored.
c * (3) There is a mathematical ambiguity in the boundary term bound
c *     whenever two (or more) boundaries coincide.  To resolve the
c *     ambiguity correctly, perturb the boundaries slightly.
c *     Likewise there is a mathematical ambiguity in the vertex term
c *     vert whenever there are multiple (.ge. 3) intersections.
c *     Again, to resolve the ambiguity correctly, perturb the
c *     boundaries slightly.
c *     It should be noted that if these problems exist, then the series
c *     expansion of <WW>, whose coefficients involve bound and vert,
c *     probably breaks down already at tiny values of the separation
c *     angle th.
c *
c  Input: lmax1 = lmax+1 where lmax is maximum desired l of transform.
c         im = 1 means compute only real part of harmonics;
c              2 means compute both real and imaginary parts.
c              Note harmonics are real if region possesses reflection
c              symmetry through plane defined by z-axis and direction
c              rp(iphi).
c         nw = [(lmax+1)*(lmax+2)]/2
c         rp(3,i),i=1,np = x, y, z coordinates of a set of unit
c              directions defining the region.
c              It is assumed without checking that
c              rp(1)^2 + rp(2)^2 + rp(3)^2 = 1 .
c         cm(i),i=1,np = set of 1-cos's defining the region.
c         np = number of directions.
c         npc = part number of directions, used in conjunction with ibv;
c               see above for more details;
c               npc is irrelevant if ibv = 0.
c         ibv = 0 to 3 controls evaluation of bound & vert;
c               see above for more details.
c         iphi > 0 means compute harmonics in frame of reference where
c                  y-axis is along z x rp(iphi);
c              = 0 means use the input frame of reference.
c Output: area = area of region in steradians.
c         bound = length of boundary of region in radians if ibv=0,
c                 or as explained above if ibv>0.
c         vert = sum over vertices of 1-psi/tan(psi) if ibv=0,
c                where psi is exterior angle (=pi-interior angle)
c                at vertex, or as explained above if ibv>0.
c         ldegen = .true. signals an error: the code dealt incorrectly
c                  with a multiply intersecting boundary.
c Input/Output: w(i,lm) = spherical transform, dimensioned w(im,nw)
c            w(i,lm), i=1,im, lm=l*(l+1)/2+m+1, l=0,lmax, m=0,l;
c            w(1,lm) is real part, w(2,lm) is imaginary part (if im=2).
c            Note w(l,-m)=(-)**m*[Complex conjugate of w(l,m)], just as
c                 Y(l,-m)=(-)**m*[Complex conjugate of Y(l,m)].
c            tol
c Work arrays: phw and iord should be dimensioned at least 2*np.
c              v should be dimensioned at least lmax1.
c
c        set azimuthal angle of non-intersection to big
      data big /1.e6_10/
c        possible multiple intersection when dph < dphmin
      data dphmin /1.e-8_10/
c
c        input tolerance to multiple intersections
      tolin=tol
C     print *,'--------------------'
c        come here with modified tolerance
  100 continue
c        initialise error flag to no error
      ldegen=.false.
C     warn=.false.
c        zero stuff
      area=0._10
      bound(1)=0._10
      bound(2)=0._10
      vert(1)=0._10
      vert(2)=0._10
      do j=1,nw
        do i=1,im
          w(i,j)=0._10
        enddo
      enddo
c        check for zero area because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        no constraints at all will mean area is whole sphere
      whole=.true.
c        number of intersecting arc segments bounding area
      nbd=0
c        number of non-intersecting circles bounding area
      nbd0m=0
      nbd0p=0
c        error check on evaluation of vertex terms
      ikchk=0._10
c        area=sqrt(4pi)*monopole
      sqrt4pi=sqrt(4._10*PI)
c        harmonics defined so point iphi is at zero azimuthal angle
      rii=0._10
      if (iphi.ge.1) rii=sqrt(rp(1,iphi)**2+rp(2,iphi)**2)
      phii=0._10
      if (rii.gt.0._10) phii=atan2(rp(2,iphi),rp(1,iphi))
c--------identify boundary segments around each circle i in turn
      do 280 i=1,np
c        cm(i).ge.2 means include whole sphere, which is no constraint
        if (cm(i).ge.2._10) goto 280
c        there is a constraint, so area is not whole sphere
        whole=.false.
c        scmi * cmi = 1-cos th(i)
        if (cm(i).ge.0._10) then
          scmi=1
        else
          scmi=-1
        endif
        cmi=abs(cm(i))
c        ci = cos th(i)
        ci=1._10-cmi
c        si = sin th(i)
        si=sqrt(cmi*(2._10-cmi))
c........ri, phi, rp(3,i) are cylindrical coordinates of rp(i)
        ri=sqrt(rp(1,i)**2+rp(2,i)**2)
        if (ri.eq.0._10.or.i.eq.iphi) then
          phi=0._10
        else
          phi=atan2(rp(2,i),rp(1,i))-phii
        endif
c........construct cartesian axes with z-axis along rp(i)
c The direction of yi is important here,
c unlike some other subroutines (gphi, garea, gphbv, gvlim, gvphi)
c where yi can point in any abitrary direction.
c        set yi in direction z x rp(i)
        if (ri.gt.0._10) then
          yi(1)=-rp(2,i)/ri
          yi(2)=rp(1,i)/ri
          yi(3)=0._10
c        if rp(i) is along z-axis, set yi in direction z x rp(iphi)
        elseif (rii.gt.0._10) then
          yi(1)=-rp(2,iphi)/rii
          yi(2)=rp(1,iphi)/rii
          yi(3)=0._10
c        if rp(iphi) is also along z-axis, set yi along y-axis
        elseif (ri.eq.0._10.and.rii.eq.0._10) then
          yi(1)=0._10
          yi(2)=1._10
          yi(3)=0._10
        endif
c        xi in direction yi x rp(i)
        xi(1)=yi(2)*rp(3,i)-yi(3)*rp(2,i)
        xi(2)=yi(3)*rp(1,i)-yi(1)*rp(3,i)
        xi(3)=yi(1)*rp(2,i)-yi(2)*rp(1,i)
c........angles phi about z-axis rp(i) of intersection of i & j circles
        call gphij(rp,cm,np,i,rp(1,i),scmi,cmi,xi,yi,big,tol,ni,phw)
c        i circle lies outside polygon
        if (ni.eq.-1) goto 280
c        area of polygon is zero
        if (ni.eq.-2) then
c        area can be non-zero from psi at multiple intersections
          area=0._10
          bound(1)=0._10
          bound(2)=0._10
          vert(1)=0._10
          vert(2)=0._10
          do l=1,nw
            do k=1,im
              w(k,l)=0._10
            enddo
          enddo
          goto 410
        endif
c........i circle has no intersections
        if (ni.eq.0) then
          if (scmi.ge.0) then
            nbd0p=nbd0p+1
          else
            nbd0m=nbd0m+1
          endif
          dph=TWOPI
          if (scmi.lt.0) dph=-dph
          ph=0._10
c        increment area
          darea=cmi*dph
          area=area+darea
c        bound(1) term is length of boundary
          dbound(1)=si*abs(dph)
          dbound(2)=(1._10/si-2._10*si)*abs(dph)
c        standard
          if (ibv.eq.0
c        cross
     *      .or.(ibv.eq.1.and.i.gt.npc)
c        intersection
     *      .or.(ibv.eq.2.and.i.gt.npc)
c        union
     *      .or.(ibv.eq.3)) then
            bound(1)=bound(1)+dbound(1)
            bound(2)=bound(2)+dbound(2)
c        intersection
          elseif (ibv.eq.2.and.i.le.npc) then
            bound(1)=bound(1)-dbound(1)
            bound(2)=bound(2)-dbound(2)
          endif
C         print *,'at',i,': full circle area +=',darea,' =',area
C         print *,'dbound =',dbound(1),dbound(2),
C    *      ' bound =',bound(1),bound(2)
c        increment spherical transform
          if (ibv.ge.2) dph=-dph
          call wlm(w,lmax1,im,nw,ri,phi,0,rp(3,i),ci,si,ph,dph,v)
c........i circle has intersections
        elseif (ni.gt.0) then
c        find ordering of intersection angles around i circle
          call findbot(phw,2*np,iord,ni)
c........contribution from each segment of i circle
          jpl=0
c        come here to do another segment
  220     continue
c........is segment edge of polygon?
            iseg=gsegij(rp,cm,np,0,0,i,rp(1,i),scmi,cmi,tol,ni,
     *        phw,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
c        error
            if (iseg.eq.-1) goto 420
c        not an edge
            if (iseg.eq.0) goto 220
c        gone full circle
            if (iseg.eq.2) goto 280
c        near multiple intersection
            if (dph.lt.dphmin) then
c        increment count of near multiple intersections
              nmult=nmult+1
c             warn=.true.
c             print *,
c    *          '*** warning from gspher: near multiple intersection at'
c    *          ,i,': segment',km,kp,' dph=',dph
            endif
c........segment satisfies conditions
            nbd=nbd+1
c        contribution to area from the boundary segment
            if (scmi.lt.0) dph=-dph
            darea=cmi*dph-dph
            area=area+darea
c        bound(1) term is length of boundary
            dbound(1)=si*abs(dph)
            dbound(2)=(1._10/si-2._10*si)*abs(dph)
c        standard
            if (ibv.eq.0
c        cross
     *        .or.(ibv.eq.1.and.i.gt.npc)
c        intersection
     *        .or.(ibv.eq.2.and.i.gt.npc)
c        union
     *        .or.(ibv.eq.3)) then
              bound(1)=bound(1)+dbound(1)
              bound(2)=bound(2)+dbound(2)
c        intersection
            elseif (ibv.eq.2.and.i.le.npc) then
              bound(1)=bound(1)-dbound(1)
              bound(2)=bound(2)-dbound(2)
            endif
C           print *,'at',i,': edge',km,kp,
C    *       ' (',jm,' in',jml,jmu,',',jp,' in',jpl,jpu,' of',ni,')'
C           print *,'dph =',dph,' area +=',darea,' =',area
C           print *,'dbound =',dbound(1),dbound(2),
C    *        ' bound =',bound(1),bound(2)
c        contribution to area and vert from end points of the segment
            do 240 l=1,2
c        end point is intersection of i circle with k circle
              if (l.eq.1) then
                k=km
              elseif (l.eq.2) then
                k=kp
              endif
c        only do ik intersection once,
c        but check both ik and ki intersections made it here
c        from segment k to segment i right-handedly through vertex
              if ((l.eq.1.and.scmi.ge.0).or.(l.eq.2.and.scmi.lt.0)) then
                ik=k+np*i
                if (k.lt.i) ik=ik+1
c        from segment i to segment k right-handedly through vertex
              else
                ik=i+np*k
                if (i.lt.k) ik=ik+1
              endif
c        pseudo-random number from ik
              call ikrand(ik,ikran)
              if (i.gt.k) then
c        ikchk = ikchk - ikran, subtracted as unsigned long long's
                call ikrandm(ikchk,ikran)
                goto 240
              endif
c        ikchk = ikchk + ikran, added as unsigned long long's
              call ikrandp(ikchk,ikran)
              cmk=abs(cm(k))
              sk=sqrt(cmk*(2._10-cmk))
c        cmik = 1-cos th(ik)
              cmik=((rp(1,i)-rp(1,k))**2+(rp(2,i)-rp(2,k))**2
     *          +(rp(3,i)-rp(3,k))**2)/2._10
c        bik = cik-ci*ck
c        d = 1-ci^2-ck^2-cik^2+2*ci*ck*cik
c        cos psi = bik/(si*sk)
c        sin psi = sqrt(d)/(si*sk)
c        psi = atan(sqrt(d)/bik) is exterior angle at intersection
              bik=(cmi+cmk)-cmi*cmk-cmik
              if ((scmi.ge.0.and.cm(k).lt.0._10)
     *          .or.(scmi.lt.0.and.cm(k).ge.0._10)) bik=-bik
c        i and k circles kiss
              if (phw(1,k).eq.phw(2,k)) then
                d=0._10
              else
                d=-(cmi-cmk)**2+cmik*(2._10*((cmi+cmk)-cmi*cmk)-cmik)
c        assert that circles at least touch
                if (d.lt.0._10) d=0._10
                d=sqrt(d)
              endif
              ctpsi=bik/d
              psi=atan2(d,bik)
c        increment area
              area=area-psi
c        t=tan psi/2
              if (bik.gt.0._10) then
                t=d/(bik+sqrt(bik**2+d**2))
              elseif (bik.lt.0._10) then
                t=(-bik+sqrt(bik**2+d**2))/d
              elseif (bik.eq.0._10) then
                t=1._10
              endif
c        cti = cot th(i)
              cti=(1._10-cmi)/si
              if (scmi.lt.0) cti=-cti
c        ctk = cot th(k)
              ctk=(1._10-cmk)/sk
              if (cm(k).lt.0._10) ctk=-ctk
c        standard
              if (ibv.eq.0
     *          .or.(ibv.eq.1.and.i.gt.npc.and.k.gt.npc)
     *          .or.(ibv.eq.2.and.i.gt.npc.and.k.gt.npc)
     *          .or.(ibv.eq.3.and.((i.gt.npc.and.k.gt.npc)
     *                         .or.(i.le.npc.and.k.le.npc)))) then
                if (psi.eq.0._10) then
                  dvert(1)=0._10
                  dvert(2)=0._10
                else
                  dvert(1)=1._10-psi*ctpsi
                  dvert(2)=t*(3._10+t**2)*(cti+ctk)/2._10
                endif
                vert(1)=vert(1)+dvert(1)
                vert(2)=vert(2)+dvert(2)
c        cross
              elseif (ibv.eq.1) then
                if (i.le.npc.and.k.le.npc) then
                  continue
                else
                  dvert(1)=PI/2._10*ctpsi
                  dvert(2)=t*(3._10+t**2)*(cti+ctk)/2._10
                  vert(1)=vert(1)-dvert(1)
                  vert(2)=vert(2)+dvert(2)/2._10
                  t=1._10/t
                  dvert(2)=t*(3._10+t**2)*(cti-ctk)/2._10
                  if (i.gt.npc) then
                    vert(2)=vert(2)-dvert(2)/2._10
                  elseif (k.gt.npc) then
                    vert(2)=vert(2)+dvert(2)/2._10
                  endif
                endif
c        intersection
              elseif (ibv.eq.2) then
                if (i.le.npc.and.k.le.npc) then
                  if (psi.eq.0._10) then
                    dvert(1)=0._10
                    dvert(2)=0._10
                  else
                    dvert(1)=1._10-psi*ctpsi
                    dvert(2)=t*(3._10+t**2)*(cti+ctk)/2._10
                  endif
                  vert(1)=vert(1)-dvert(1)
                  vert(2)=vert(2)-dvert(2)
                else
c        psip = pi - psi
                  psip=atan2(d,-bik)
                  if (psip.eq.0._10) then
                    dvert(1)=0._10
                    dvert(2)=0._10
                  else
                    dvert(1)=1._10+psip*ctpsi
                    t=1._10/t
                    dvert(2)=t*(3._10+t**2)*(cti-ctk)/2._10
                  endif
                  vert(1)=vert(1)-dvert(1)
                  if (i.gt.npc) then
                    vert(2)=vert(2)-dvert(2)
                  elseif (k.gt.npc) then
                    vert(2)=vert(2)+dvert(2)
                  endif
                endif
c        union
              elseif (ibv.eq.3) then
                if (psi.eq.0._10) then
                  dvert(1)=0._10
                  dvert(2)=0._10
                else
                  dvert(1)=1._10-psi*ctpsi
                  dvert(2)=t*(3._10+t**2)*(cti+ctk)/2._10
                endif
                vert(1)=vert(1)-dvert(1)
                vert(2)=vert(2)+dvert(2)
              endif
C             print *,'     intersect',i,k,' area +=',-psi,' =',area
C             print *,'     dvert =',dvert(1),dvert(2),
C    *          ' vert =',vert(1),vert(2)
C             print *,' cot(',psi,') =',1._10/tan(psi),
C    *          ' should =',ctpsi
C             print *,' tan(',psi,'/2) =',tan(psi/2._10),
C    *          ' should =',t 
C             print *,' cot(th_i) =',cti,' cot(th_k) =',ctk
c        peculiar monopole term
              if (ibv.ge.2) psi=-psi
              w(1,1)=w(1,1)-psi/sqrt4pi
  240       continue
c        increment spherical transform
            if (ibv.ge.2) dph=-dph
            call wlm(w,lmax1,im,nw,ri,phi,0,rp(3,i),ci,si,ph,dph,v)
c        do another segment
          goto 220
        endif
  280 continue
c--------check on whether ik endpoints matched ki endpoints
      if (ikchk.ne.0._10) then
C       warn=.true.
c       print *,'*** from gspher: at tol =',tol,
c    *    ', ikchk=',ikchk,' should be 0'
c        retry with enlarged tolerance
        call gtol(tol,tolin)
        goto 100
      endif
c--------add/subtract 2*pi's to area
      retry=garpi(area,iarea,rp,cm,np,whole,nbd0m,nbd0p,nbd,nmult)
c        adjust monopole harmonic by corresponding 2*pi/sqrt(4*pi)
      if (ibv.eq.0.or.ibv.eq.1) then
        i=nint((w(1,1)*sqrt4pi-area)/TWOPI)
      elseif (ibv.eq.2.or.ibv.eq.3) then
        i=nint((w(1,1)*sqrt4pi+area)/TWOPI)
      endif
      w(1,1)=w(1,1)-i*TWOPI/sqrt4pi
c        retry with modified tolerance
      if (retry.eq.1) then
C       warn=.true.
        call gtol(tol,tolin)
        goto 100
      endif
c--------done
  410 continue
C     if (warn) then
C       write (*,'(a3,a20,4a24)')
C    *    ' ','x','y','z',
c    *    'r',
C    *    '1-c'
C       do j=1,np
C         write (*,'(i3,5g24.16)')
C    *      j,(rp(i,j),i=1,3),
c    *      sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
C    *      cm(j)
C       enddo
C     endif
C     print *,'final area =',area,' bound =',bound(1),bound(2),
C    *  ' vert =',vert(1),vert(2)
C     print *,'....................'
      return
c
  420 print *,'*** from gspher: total failure at tol =',tol
      ldegen=.true.
      write (*,'(a3,a20,4a24)')
     *  ' ','x','y','z',
c    *  'r',
     *  '1-c'
      do j=1,np
        write (*,'(i3,5g24.16)')
     *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *    cm(j)
      enddo
C     print *,'....................'
      return
c
      end
c

!First version AL October 2010

!Calculates local fnl and CMB lensing bispectra
!CMB lensing bispectra are calculated in the approximation in which the first-order
!result is used replacing the unlensed with the lensing power spectra
!This is non-perturbatively correct to about 1%
!Note the lensing bispectrum only includes the linear potentials, no Rees-Sciama or SZ
!See Lewis, Challinor & Hanson 2010 for details

!Note that the primordial local bispectra are unlensed (see arXiv: 0905.4732)

!Compile with LAPACK and -DFISHER if you want to get the fisher matrix outputs
!This is disabled by default in order not to require LAPACK

!Fisher results are with and without the cosmic variance from low L_1

module Bispectrum
 use ModelParams
 use ModelData
 use InitialPower
 use SpherBessels
 use IniFile
 implicit none
 
   integer, parameter :: max_bispectrum_deltas = 5, max_bispectrum_fields=3

   Type TBispectrumParams
     logical do_lensing_bispectrum 
     logical do_primordial_bispectrum
     integer nfields
     integer Slice_Base_L, ndelta, deltas(max_bispectrum_deltas)
     logical do_parity_odd
     logical DoFisher
     logical export_alpha_beta
     real(dl) FisherNoise, FisherNoisePol, FisherNoiseFwhmArcmin
     character(LEN=Ini_max_string_len)  FullOutputFile
     logical SparseFullOutput
   end Type

    !global parameter for now, only intend for this module to be used interactively for the moment
    Type(TBispectrumParams)  :: BispectrumParams

   Type TBispectrum
      real(dl), pointer :: b(:,:)
   end Type 
   Type TCov
      real(dl), pointer :: C(:,:)
   end type TCov

   Type TCov2
      real(dl) :: C(2,2)
   end type TCov2

   Type TCov3
      real(dl) :: C(3,3)
   end type TCov3
 
   real(dl), allocatable :: dJl(:,:), dddJl(:,:)
   real(dl), parameter :: InternalScale = 1d10
   character(LEN=1024) :: output_root =''
   integer, parameter :: shape_local = 1, shape_warm = 2, shape_warm2 = 3
   integer, parameter :: shape = shape_local

   real(dl), allocatable :: TransferPolFac(:)      !sqrt((l+2)!/(l-2)!)      
contains
        
        subroutine InitBesselDerivs(CTrans)
         ! j_l' array for interpolation if needed; not needed for local fnl
         Type(ClTransferData) :: CTrans
         integer i,l1,j
         real(dl) Jm, Jp
         
           if (allocated(dJl)) then
            deallocate(dJL, dddJl)
           end if
           allocate(dJl(BessRanges%npoints,CTrans%ls%l0),dddJl(BessRanges%npoints,CTrans%ls%l0))
           
           do i=1, CTrans%ls%l0
           !Spline agrees well
           !  call spline_deriv(BessRanges%points,ajl(1,i),ajlpr(1,i),dJl(1,i),BessRanges%npoints)
           !  call spline(BessRanges%points,dJl(1,i),BessRanges%npoints,spl_large,spl_large,dddJl(1,i))
           
             l1 = CTrans%ls%l(i)
             do j=1, BessRanges%npoints
              call BJL(l1-1,BessRanges%points(j),Jm)
              call BJL(l1+1,BessRanges%points(j),Jp)
              dJl(j,i)=  ( l1*Jm - (l1+1)*Jp)/(2*l1+1)
             end do
            call spline(BessRanges%points,dJl(1,i),BessRanges%npoints,spl_large,spl_large,dddJl(1,i))
           
           end do           
        
        end subroutine InitBesselDerivs

     subroutine NonGauss_l_r_localOpt(CTrans, ind, indP, res, resP, nfields, r)
         !functions of the form int dk k^2 k^i j_l(kr) Delta_l(k) [P]
         !ind and indP are arrays of required k^i powers
         !res and resP are the results without and with the power spectrum P in the integrand
          Type(ClTransferData) :: CTrans
          integer, intent(in) :: ind(:), indP(:) 
          integer :: nfields
          real(dl) res(CTrans%ls%l0,size(ind),nfields), resP(CTrans%ls%l0,size(indP),nfields)
          real(dl), intent(in) :: r
          integer q_ix, j, bes_ix
          integer n, nP, ellmax
          real(dl) xf , J_l, fac, a2, k, dlnk, term, P, kpow, kpowP        
          
          n = size(ind)
          nP =size(indP)          
          res=0
          resP = 0
          do q_ix = 1, CTrans%q%npoints 
            k = CTrans%q%points(q_ix)
            xf = k*r  
            bes_ix=Ranges_indexOf(BessRanges,xf)
            fac=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
            a2=(BessRanges%points(bes_ix+1)-xf)/fac
            fac=fac**2*a2/6
            dlnk = CTrans%q%dpoints(q_ix) /k
            P = ScalarPower(k, 1)*InternalScale  !!only first index for now
          
            ellmax = max(xf/(1-xlimfrac), xf + xlimmin) * AccuracyBoost
            kpow =  k**(ind(1)+3)  
            kpowP = k**indP(1) * P      
            do j=1,CTrans%ls%l0
             if (CTrans%ls%l(j) <= ellmax) then
              J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                         *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac) !cubic spline
              term = CTrans%Delta_p_l_k(1,j,q_ix)*J_l*dlnk  
              res(j,1,1) = res(j,1,1) + term * kpow
              resP(j,1,1) = resP(j,1,1) + term * kpowP
              if (nfields>1) then
                !E pol
                  term = CTrans%Delta_p_l_k(2,j,q_ix)*J_l*dlnk * TransferPolFac(CTrans%ls%l(j))  
                  res(j,1,2) = res(j,1,2) + term * kpow
                  resP(j,1,2) = resP(j,1,2) + term * kpowP
                  if (nfields>2) then
                  !lensing potential
                  term = CTrans%Delta_p_l_k(3,j,q_ix)*J_l*dlnk 
                  res(j,1,3) = res(j,1,3) + term * kpow
                  resP(j,1,3) = resP(j,1,3) + term * kpowP
                  end if
              end if
             
             end if
           end do
         end do
         resP = resP * fourpi
         res = res * 2/pi
               
        end subroutine NonGauss_l_r_localOpt

        subroutine NonGauss_l_r(CTrans, ind, indP,res, resP,nfields, r)
         !functions of the form int dk k^2 k^i j_l(kr) Delta_l(k) [P]
         !ind and indP are arrays of required k^i powers
         !res and resP are the results without and with the power spectrum P in the integrand
         !Output of P scaled by 1d10 (so bispectrum by 1d20)
          Type(ClTransferData) :: CTrans
          integer:: nfields
          integer, intent(in) :: ind(:), indP(:) 
          real(dl) res(CTrans%ls%l0,size(ind),nfields), resP(CTrans%ls%l0,size(indP),nfields)
          real(dl), intent(in) :: r
          integer q_ix, j, bes_ix, i
          integer n, nP, ellmax
          real(dl) xf , J_l, fac, a2, k, dlnk, term, P, kpow(size(ind)), kpow2(size(indP))        
     
          if (shape == shape_local) then
            call NonGauss_l_r_localOpt(CTrans, ind, indP,res, resP, nfields, r)
            return
          end if
          
          n = size(ind)
          nP =size(indP)          
          res=0
          resP = 0
          do q_ix = 1, CTrans%q%npoints 
            k = CTrans%q%points(q_ix)
            xf = k*r  
            bes_ix=Ranges_indexOf(BessRanges,xf)
            fac=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
            a2=(BessRanges%points(bes_ix+1)-xf)/fac
            fac=fac**2*a2/6
            dlnk = CTrans%q%dpoints(q_ix) /k
            P = ScalarPower(k, 1)*InternalScale  !!only first index for now
          
            ellmax = max(xf/(1-xlimfrac), xf + xlimmin) * AccuracyBoost
            do i=1,n
              kpow(i)=k**(ind(i)+3)
            end do
            do i=1,nP
              kpow2(i)=k**indP(i) * P
            end do
                      
            do j=1,CTrans%ls%l0
             if (CTrans%ls%l(j) <= ellmax) then

              J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                         *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac) !cubic spline
              !call BJL(CTrans%ls%l(j), xf, J_l)           
              term = CTrans%Delta_p_l_k(1,j,q_ix)*J_l*dlnk  
              do i=1,n
               res(j,i,1) = res(j,i,1) + term *kpow(i)
              end do
              do i=1,nP
               resP(j,i,1) = resP(j,i,1) + term * kpow2(i)
              end do
         !     if (CTrans%ls%l(j)==8) write (1,'(9D20.7)') &
         !      k, xf, real(term * k**3/dlnk), real(term * k**indP(1) * P), &
         !      real(res(j,1)),real(resP(j,1)), J_l, real(term), real(CTrans%Delta_p_l_k(1,j,q_ix))
              if (nfields>1) then
                !E pol
                  term = CTrans%Delta_p_l_k(2,j,q_ix)*J_l*dlnk* TransferPolFac(CTrans%ls%l(j))  
                  do i=1,n
                   res(j,i,2) = res(j,i,2) + term *kpow(i)
                  end do
                  do i=1,nP
                   resP(j,i,2) = resP(j,i,2) + term * kpow2(i)
                  end do
                  if (nfields>2) then
                  !lensing potential
                  term = CTrans%Delta_p_l_k(3,j,q_ix)*J_l*dlnk 
                      do i=1,n
                       res(j,i,3) = res(j,i,3) + term *kpow(i)
                      end do
                      do i=1,nP
                       resP(j,i,3) = resP(j,i,3) + term * kpow2(i)
                      end do
                  end if
              end if
                              
             end if
           end do
         end do
         resP = resP * fourpi
         res = res * 2/pi
               
        end subroutine NonGauss_l_r


        subroutine GetBispectrum(CTrans)
         !Note: may need high maxetak to make sure oscillatory k integrals cancel correctly
         !for accurate alpha(r), beta(r), e.g. 8000; not so important for bispectrum
         !increase accuracy_boost
          use lensing
          use lvalues
          use constants
          use Ranges
#ifdef FISHER
          use MatrixUtils
#endif          
          integer, parameter :: max_bispectra = 2  !fnl, lensing
          Type(ClTransferData) :: CTrans
          Type(Regions) :: TimeStepsNongauss
          integer, allocatable ::  ind(:), indP(:), indPd(:)
          real(dl), allocatable :: res(:,:,:), resP(:,:,:), resPd(:,:)
          real(dl), allocatable :: res_l(:,:,:), resP_l(:,:,:), resPd_l(:,:)
          real(dl) r, term
          Type(TBispectrum), target,allocatable :: Bispectra(:,:,:,:), OddBispectra (:)
            !TTT, TTE, etc; last index is bispectrum kind, default 1=fnl, 2=lensing
            !OddBispectra are parity odd terms like TEB (if do_parity_odd requested for lensing)
          Type(TBispectrum), pointer :: Bispectrum
              !For use in Fisher approximations 
          real(dl) test(lmin:CTrans%ls%l(CTrans%ls%l0))
          integer i, j, l1,l2,l3, il1, n,np, npd
          integer min_l, max_l, lmax
          real(dl) tmp, tmp1, tmp2, tmp3
          real(dl) a3j(0:CTrans%ls%l(CTrans%ls%l0)*2+1)         
          real(dl) a3j2(0:CTrans%ls%l(CTrans%ls%l0)*2+1,4,2)
          real(dl) CLForLensingIn(4,lmin:CTrans%ls%l(CTrans%ls%l0)),CPhi(3,lmin:CTrans%ls%l(CTrans%ls%l0))
          Type(lSamples) :: SampleL
          real starttime  
          real(dl) Bscale
          integer field, field1,field2,field3, bi_ix,bix
          Type(TCov2), allocatable :: CForLensing(:)
          integer nfields, nbispectra, bispectrum_type      
          integer :: fnl_bispectrum_ix = 1
          integer :: lens_bispectrum_ix = 2
          character(LEN=256) ::  file_tag = ''
          integer idelta, fileid
          character(LEN=26) :: BispectrumNames(max_bispectra)
          integer :: parities(3), oddix  
          integer, parameter :: lmax_lensing_corrT = 300 
            !assume C^{T\psi} zero above this for CMB lensing; also neglect lensing contributions to variance
          integer, parameter :: lmax_lensing_corrE = 40 !assume C^{E\psi} zero above this for CMB lensing

          integer, parameter :: first_order_unlensed = 1, first_order_lensed = 2
          integer, parameter :: lens_bispectrum_approx = first_order_lensed
#ifdef FISHER
         Type(TBispectrum), pointer :: Bispectrum2
          real(dl) Cl(4,lmin:CTrans%ls%l(CTrans%ls%l0))
          real(dl)  a3j_00(0:CTrans%ls%l(CTrans%ls%l0)*2+1)          
          integer lstart
          real(dl) Noise, NoiseP, bias
          real(dl), allocatable:: fish_contribs(:,:,:)
          real(dl) fish_contribs_sig(lmin:CTrans%ls%l(CTrans%ls%l0))
          real(dl), allocatable :: ifish_contribs(:,:,:,:,:), Fisher(:,:), tmpFisher(:,:),OptimalFisher(:,:)
          real(dl), allocatable :: tmpBigFisher(:,:), Fisher_L1(:,:,:),tmpProjFisher(:,:)
          real(dl), allocatable :: fish_l1(:,:,:,:), fish_L_ij(:,:), fish_L_noise(:,:)
          Type(TBispectrum), target,allocatable :: SqueezedLensingKernel(:,:)
          real(dl) sigma2, xlc, tmpf(3)
          integer  f1,f2,f3, minl2,bigi,bigj, bispectrum_type2, lmaxcuti
          integer sz,corrsize
          Type(TCov), allocatable :: InvC(:)
          integer ix1,ix2
          real(dl) tmpArr(lmin:CTrans%ls%l(CTrans%ls%l0))
#endif
          
          parities(1)=1  !T
          parities(2)=1  !E
          parities(3)=-1 !B


          if (BispectrumParams%do_primordial_bispectrum) then
           fnl_bispectrum_ix = 1
           nbispectra=1
           BispectrumNames(fnl_bispectrum_ix)='fnl'
          else
           fnl_bispectrum_ix = 0
           nbispectra=0
          end if
          if (BispectrumParams%do_lensing_bispectrum) then
           lens_bispectrum_ix = fnl_bispectrum_ix+1
           nbispectra=nbispectra+1
           BispectrumNames(lens_bispectrum_ix)='lensing'
          end if
          if (nbispectra>max_bispectra) stop 'check max_bispectra'
           
          if (CP%InitPower%nn>1) stop 'Bispectrum: multiple initial power spectra not supported'         
                
          nfields=BispectrumParams%nfields    
               
          if (lSampleBoost <50) stop 'Bispectrum assumes lSampleBoost=50 (all L sampled)'     
          
          if (lens_bispectrum_approx == first_order_unlensed) file_tag='_unlens'
          
          lmax = CTrans%ls%l(CTrans%ls%l0)      
          if (CP%DoLensing) lmax = lmax_lensed
          SampleL%l0=0
          l1=1
          do 
            if (l1<=lmax_lensing_corrE) then
             l1 = l1+1
            else if (l1<120) then
             l1 =l1+nint(7/AccuracyBoost)
            else 
             l1 =l1+nint(50/AccuracyBoost)
            end if    
            if (l1>lmax) then 
              l1 =lmax
            end if
            if (BispectrumParams%Slice_Base_L>0 .and. SampleL%l0>0) then
              !Make sure requested slice base is actually calculated   
              if ( BispectrumParams%Slice_Base_L <l1 .and. BispectrumParams%Slice_Base_L>SampleL%l(SampleL%l0)) then
                SampleL%l0= SampleL%l0 + 1
                SampleL%l(SampleL%l0) = BispectrumParams%Slice_Base_L                
              end if
            end if
            SampleL%l0= SampleL%l0 + 1
           ! print *,l1          
            SampleL%l(SampleL%l0) = l1
            if (l1 == lmax) exit
          end do  
          
          allocate(Bispectra(nfields,nfields,nfields,nbispectra))
          do field1=1,nfields
             do field2=1,nfields
                  do field3=1,nfields
                    !Only store l2,l3 that are non-zero, array size is approx
                    do bispectrum_type=1,nbispectra
                    allocate(Bispectra(field1,field2,field3,bispectrum_type)%b((lmax*(lmax+1))/4,SampleL%l0))
                    Bispectra(field1,field2,field3,bispectrum_type)%b=0
                    end do
                  end do
             end do
          end do  

          if (BispectrumParams%do_lensing_bispectrum) then
              
              if (.not. CP%DoLensing) stop 'Must turn on lensing to get lensing bispectra'
              print *,'Getting lensing reduced bispectra'
              
              allocate(CForLensing(lmax))

              CPhi=0  
              do i=lmin,lmax
                 CPhi(1,i) = Cl_scalar(i,1,C_Phi)/real(i,dl)**4 * InternalScale
                 !set correlations to zero where very small to avoid numerical issues
                 if (i<=lmax_lensing_corrT) then
                  CPhi(2,i) = Cl_scalar(i,1,C_PhiTemp) /real(i,dl)**3 * InternalScale
                 end if
                 if (i<=lmax_lensing_corrE) then
                  CPhi(3,i) = Cl_scalar(i,1,C_PhiE) /real(i,dl)**3 * InternalScale
                 end if
                 tmp = i*(i+1)/(2*pi)
                 CLForLensingIn(:,i) = CL_lensed(i,1,CT_Temp:CT_Cross) * InternalScale/tmp
                ! CForLensing(i)%C=0
                 CForLensing(i)%C(1,1)=CLForLensingIn(1,i)
                 CForLensing(i)%C(1,2)=CLForLensingIn(4,i)
                 CForLensing(i)%C(2,1)=CLForLensingIn(4,i)
                 CForLensing(i)%C(2,2)=CLForLensingIn(2,i)
                ! CForLensing(i)%C(3,3)=CL_lensed(i,1,CT_B) * InternalScale/tmp
              end do

#ifdef FISHER             
              allocate(SqueezedLensingKernel(nfields,nfields))
              do field2=1,nfields
                      do field3=1,nfields
                        allocate(SqueezedLensingKernel(field2,field3)%b((lmax*(lmax+1))/4,SampleL%l0))
                        SqueezedLensingKernel(field2,field3)%b=0
                      end do
              end do  
#endif
              if (DebugMsgs) starttime=GetTestTime()         
                        
          
           !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDULE(STATIC,3) &
           !$OMP PRIVATE(il1,l1,l2,l3,max_l,min_l,bix,bi_ix, tmp1,tmp2,tmp3), &
           !$OMP PRIVATE(field1,field2,field3, Bispectrum, a3j,a3j2)

            do il1= 1, SampleL%l0
                l1 = SampleL%l(il1)
                if (l1 > lmax_lensing_corrT) cycle !no exit in parallel loop
                tmp1=l1*(l1+1)
                bi_ix=0
                do l2= max(lmin,l1), lmax 
                  tmp2=l2*(l2+1)
                  min_l = max(abs(l1-l2),l2)
                  if (mod(l1+l2+min_l,2)/=0) then
                     min_l = min_l+1
                  end if 
                  max_l = min(lmax,l1+l2) 
                  bix=bi_ix
                  a3j2(:,:,1)=0.5d0
                  if (nfields>1) then
                    call GetThreeJs(a3j(abs(l2-l1)),l1,l2,0,0)   
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),1,2),l1,l2,2,0)   
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),2,2),l1,l2,0,2)   
                    call GetThreeJs(a3j2(max(0,abs(l2-l1)),3,2),l1,l2,2,-2)                                       
                    do l3=min_l,max_l ,2
                      a3j2(l3,:,2) = a3j2(l3,:,2)/a3j(l3)*0.5d0           
                    end do
                  end if
                  do field1=1,nfields
                     do field2=1,nfields
                          do field3=1,nfields
                            Bispectrum=> Bispectra(field1,field2,field3, lens_bispectrum_ix)
                            bi_ix=bix   
                             do l3=min_l,max_l ,2
                              bi_ix=bi_ix+1
                              tmp3=l3*(l3+1)
                              !bispectrum is the reduced bispectrum 
#ifdef FISHER             
                             if (field1==1) then  
                              SqueezedLensingKernel(field2,field3)%b(bi_ix,il1)=  &
                               (-tmp2+tmp3+tmp1)*(a3j2(l3,2,field2)*CForLensing(l3)%C(field2,field3)) + &       
                               (-tmp3+tmp1+tmp2)*(a3j2(l3,2,field3)*CForLensing(l2)%C(field3,field2))
                             end if
#endif            
                     
                              Bispectrum%b(bi_ix,il1)=  &
                                 (-tmp1+tmp2+tmp3) *  &
                                 (a3j2(l3,1,field1)*CPhi(1+field2,l2)*CForLensing(l3)%C(field1,field3) + &
                                  a3j2(l3,3,field1)*CPhi(1+field3,l3)*CForLensing(l2)%C(field1,field2) ) + &       
                                 (-tmp2+tmp3+tmp1)* &
                                 (a3j2(l3,3,field2)*CPhi(1+field3,l3)*CForLensing(l1)%C(field2,field1) + &
                                  a3j2(l3,2,field2)*CPhi(1+field1,l1)*CForLensing(l3)%C(field2,field3) ) + &       
                                 (-tmp3+tmp1+tmp2)* &
                                 (a3j2(l3,2,field3)*CPhi(1+field1,l1)*CForLensing(l2)%C(field3,field2) + &
                                  a3j2(l3,1,field3)*CPhi(1+field2,l2)*CForLensing(l1)%C(field3,field1) )         
                              
                             end do
                            
                          end do
                     end do
                  end do  
                  
              end do
             end do  
            !$OMP END PARAllEl DO
            if (DebugMsgs) print *,'Time for lensing:', GetTestTime()-starttime
           
            if (nfields==1) BispectrumParams%do_parity_odd=.false.
            
            if (BispectrumParams%do_parity_odd) then 
  
              allocate(OddBispectra(12))
              oddix=0
              do field1=1,3
                 do field2=1,3
                      do field3=1,3
                        if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                        oddix=oddix+1
                        !Only store l2,l3 that are non-zero, array size is approx
                        allocate(OddBispectra(oddix)%b((lmax*(lmax+1))/4,SampleL%l0))
                        OddBispectra(oddix)%b=0
                      end do
                 end do
              end do  
  
           !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDULE(STATIC,3) &
           !$OMP PRIVATE(il1,l1,l2,l3,max_l,min_l,bix,bi_ix, tmp1,tmp2,tmp3), &
           !$OMP PRIVATE(field1,field2,field3, Bispectrum, a3j2, oddix)

            do il1= 1, SampleL%l0
                l1 = SampleL%l(il1)
                if (l1 > lmax_lensing_corrT) cycle !no exit in parallel loop
                tmp1=l1*(l1+1)
                bi_ix=0
                do l2= max(lmin,l1), lmax 
                  tmp2=l2*(l2+1)
                  min_l = max(abs(l1-l2),l2)
                  if (mod(l1+l2+min_l,2)/=1) then
                     min_l = min_l+1
                  end if 
                  max_l = min(lmax,l1+l2) 
                  bix=bi_ix
                    
                    a3j2(:,:,1)=0.5d0
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),1,2),l1,l2,2,0)   
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),2,2),l1,l2,0,2)   
                    call GetThreeJs(a3j2(max(0,abs(l2-l1)),3,2),l1,l2,2,-2)                                       
                    do l3=min_l,max_l ,2
                     a3j2(l3,:,2) = a3j2(l3,:,2)*0.5d0*sqrt(real((2*L1+1)*(2*L2+1),dl)*(2*L3+1)/(3.1415926535*4))            
                    end do

                    
                  oddix=0
                  do field1=1,3
                     do field2=1,3
                         do field3=1,3
                            !Only calculate terms with one B
                            if (parities(field1)+parities(field2)+parities(field3)/=1) cycle               
                            oddix=oddix+1
                            Bispectrum=> OddBispectra(oddix)
                            bi_ix=bix   
                             do l3=min_l,max_l ,2
                              bi_ix=bi_ix+1
                              
                              tmp3=l3*(l3+1)
                              !bispectrum the non-reduced bispectrum without the i
                              if (parities(field1)==-1) then
                               Bispectrum%b(bi_ix,il1)=  &
                                 (-tmp1+tmp2+tmp3) *  &
                                 (a3j2(l3,1,min(2,field1))*CPhi(1+field2,l2)*CForLensing(l3)%C(2,field3)  &
                                  -a3j2(l3,3,min(2,field1))*CPhi(1+field3,l3)*CForLensing(l2)%C(2,field2) ) 
                              elseif (parities(field2)==-1) then
                               Bispectrum%b(bi_ix,il1)=  &
                                   (-tmp2+tmp3+tmp1)* &
                                 (-a3j2(l3,3,min(2,field2))*CPhi(1+field3,l3)*CForLensing(l1)%C(2,field1)  &
                                  -a3j2(l3,2,min(2,field2))*CPhi(1+field1,l1)*CForLensing(l3)%C(2,field3) )  
                              else if (parities(field3)==-1) then
                               Bispectrum%b(bi_ix,il1)=  &
                                 (-tmp3+tmp1+tmp2)* &
                                 (-a3j2(l3,2,min(2,field3))*CPhi(1+field1,l1)*CForLensing(l2)%C(2,field2) + &
                                  a3j2(l3,1,min(2,field3))*CPhi(1+field2,l2)*CForLensing(l1)%C(2,field1) )         
                              end if
                              
                             end do
                            
                          end do
                     end do
                  end do  
                  
              end do
             end do  
            !$OMP END PARAllEl DO
            end if

          end if

          if (BispectrumParams%do_primordial_bispectrum) then

          print *,'getting reduced local fnl bispectra'
          
          allocate(TransferPolFac(lmax))
          do i=2,lmax
           TransferPolFac(i) =sqrt( real((i+1)*i,dl)*(i+2)*(i-1))
          end do
          
          if (shape /= shape_local) stop 'Non-local shapes not working'
    
          if (shape == shape_local) then
           n=1
           np=1
           npd=0 !derivatives of function
          else if (shape == shape_warm) then
           n=2
           np=3
           npd=0
          else if (shape == shape_warm2) then
           n=1
           np=2
           npd=2
          else
           stop 'unknown shape'
          end if        
                         
          allocate(ind(n))
          allocate(indP(np))
          
          if (npd>0) then
              call InitBesselDerivs(CTrans)
              allocate(indPd(npd))
          end if   
        
          if (shape==shape_warm) then
           !Separable form is very unstable and unworkable probably
           ind(1) = 0
           ind(2) = 2
           indP(1) = 0
           indP(2) = 2           
           indP(3) = -2
          else if (shape==shape_warm2) then
           ind(1) = 0
           indP(1) = 0
           indP(2) = -2
           indPd(1) = 0
           indPd(2) = -2           
          else
           ind(1) = 0
           indP(1) = 0
          end if
          
          test=0
          call Ranges_Nullify(TimeStepsNongauss)
          call Ranges_Assign(TimeStepsNongauss,TimeSteps)
          call Ranges_Add_delta(TimeStepsNongauss, -taurst*10*AccuracyBoost, taurst, dtaurec)
          call Ranges_getArray(TimeStepsNongauss, .true.)
     
!$        if (BispectrumParams%export_alpha_beta) call OMP_SET_NUM_THREADS(1)
          if (BispectrumParams%export_alpha_beta) then 
               !Note that all the points outside recombination are not really needed
               !And these are for curvature perturbation, so do not include 3/5 factor
               call CreateTxtFile(trim(output_root)//'_alpha.txt',100)
               call CreateTxtFile(trim(output_root)//'_beta.txt',101)
               call CreateTxtFile(trim(output_root)//'_alpha_beta_r.txt',102)
          end if

          if (DebugMsgs) starttime=GetTestTime()
         
         !$OMP PARALLEL DO DEFAUlT(SHARED),SCHEDULE(STATIC,3) &
         !$OMP PRIVATE(i,r,res,resP,resPd,res_l,resP_l,resPd_l,term,j), &
         !$OMP PRIVATE(il1,l1,l2,l3,min_l,max_l,tmp,tmp1,tmp2,Bispectrum), &
         !$OMP PRIVATE(bi_ix,bix,field1,field2,field3,field)

          do i= TimeStepsNongauss%npoints-1, 2,-1 
          r=(CP%tau0-TimeStepsNongauss%points(i))

          allocate(res(CTrans%ls%l0,n,nfields))
          allocate(resP(CTrans%ls%l0,np,nfields))
          
          allocate(res_l(1:CTrans%ls%l(CTrans%ls%l0),n,nfields))
          allocate(resP_l(1:CTrans%ls%l(CTrans%ls%l0),np,nfields))
          if (npd>0) then
              allocate(resPd(CTrans%ls%l0,npd))
              allocate(resPd_l(1:CTrans%ls%l(CTrans%ls%l0),npd))
           end if   
           
            call NonGauss_l_r(CTrans, ind, indP,res, resP, nfields, r)
            if (npd>0) call NonGauss_deriv_l_r(CTrans, indPd,resPd, r, dJl,dddJl)

            do field=1,nfields
             do j=1,n
              call InterpolateClArr(CTransScal%ls,res(1,j,field),res_l(lmin,j,field),CTransScal%ls%l0)
             end do
             do j=1,np
              call InterpolateClArr(CTransScal%ls,resP(1,j,field),resP_l(lmin,j,field),CTransScal%ls%l0)
             end do
            end do
            deallocate(res,resP)
 
            if (BispectrumParams%export_alpha_beta) then
             write(100,concat('(',lmax-lmin+1 ,'E15.5)')) res_l(lmin:lmax,1,1)
             write(101,concat('(',lmax-lmin+1 ,'E15.5)')) resP_l(lmin:lmax,1,1)
             write(102,'(1E15.5)') r
            end if
            
            if (npd>0) then
             do j=1,npd
               call InterpolateClArr(CTransScal%ls,resPd(1,j),resPd_l(lmin,j),CTransScal%ls%l0)
             end do
             deallocate(resPd)
            end if
            
            term = r**2 * TimeStepsNongauss%dpoints(i) * (3./5) 

        
 !Restrict to l1<=l2<=l3
           do il1= 1, SampleL%l0
            l1 = SampleL%l(il1)
            bi_ix=0
            do l2= max(lmin,l1), lmax 
              min_l = max(abs(l1-l2),l2)
              if (mod(l1+l2+min_l,2)/=0) then
                 min_l = min_l+1
              end if 
              max_l = min(lmax,l1+l2) 
              do field1=1,nfields
                 do field2=1,nfields
                     tmp1 = 2*term*(res_l(l1,1,field1)*resP_l(l2,1,field2) + &
                                    res_l(l2,1,field2)*resP_l(l1,1,field1))
                     tmp2 = 2*term*(resP_l(l1,1,field1)*resP_l(l2,1,field2))
                  do field3=1,nfields
                     Bispectrum => Bispectra(field1,field2,field3,fnl_bispectrum_ix)
                     bix=bi_ix    
                     do l3=min_l,max_l ,2
                       bix=bix+1
                       Bispectrum%b(bix,il1) = Bispectrum%b(bix,il1) + &
                           (tmp1*resP_l(l3,1,field3) +   tmp2*res_l(l3,1,field3))
                     end do
                  end do
                 end do
              end do
              bi_ix=bix    
              
            end do !l2
           end do !il1

            deallocate(res_l,resP_l)           
            if (npd>0) deallocate(resPd_l)            
          end do !TimeStepsNongauss   
 !$OMP END PARAllEl DO
          if (BispectrumParams%export_alpha_beta) then
            close(100)
            close(101)
            close(102)
          end if
          deallocate(TransferPolFac)
          call Ranges_Free(TimeStepsNongauss)
  
          if (DebugMsgs) print *,'Time for fnl bispectrum:', GetTestTime()-starttime
          
          end if !DoPrimordial  
   
          if (BispectrumParams%Slice_Base_L>0 .or. BispectrumParams%FullOutputFile/='') then
          !write out slice in (muK)^3 units
           Bscale=(COBE_CMBTemp*1d6)**3/InternalScale**2;
           do bispectrum_type=1,nbispectra
            if (BispectrumParams%Slice_Base_L>0) then
             do idelta=1,BispectrumParams%ndelta
             if (mod(BispectrumParams%Slice_Base_L + BispectrumParams%deltas(idelta),2)==1 &
                      .and. bispectrum_type/=lens_bispectrum_ix) cycle
             call CreateTxtFile(concat(trim(output_root)//'bispectrum_'//trim(BispectrumNames(bispectrum_type))//'_base_', &
                            BispectrumParams%Slice_Base_L,'_delta_',BispectrumParams%deltas(idelta),trim(file_tag)//'.dat'),&
                            nbispectra +BispectrumParams%ndelta*(bispectrum_type-1)+idelta)
             end do
            end if                          
            if (BispectrumParams%FullOutputFile/='') then
             call CreateTxtFile(concat(output_root,BispectrumParams%FullOutputFile, &
                  '_', BispectrumNames(bispectrum_type), file_tag, '.dat'),bispectrum_type)
            end if                
           end do
           do il1= 1, SampleL%l0
            l1 = SampleL%l(il1)
            bi_ix=0
            do l2= max(lmin,l1), lmax 
              min_l = max(abs(l1-l2),l2)
              if (mod(l1+l2+min_l,2)/=0) then
                 min_l = min_l+1
              end if 
              max_l = min(lmax,l1+l2) 
              do l3=min_l, max_l ,2
                  bi_ix=bi_ix+1
                  if (l1==BispectrumParams%Slice_Base_L &
                   .and. any(l3-l2==BispectrumParams%deltas(1:BispectrumParams%ndelta))) then
                  !Particular slice
                   idelta=IndexOf(l3-l2,BispectrumParams%deltas,BispectrumParams%ndelta)
                   do bispectrum_type=1,nbispectra
                    fileid=nbispectra +BispectrumParams%ndelta*(bispectrum_type-1)+idelta
                    write (fileid,'(1I5)', advance='NO') L2
                    do field1=1,nfields
                     do field2=1,nfields
                       do field3=1,nfields
                           write(fileid,'(1E15.5)', advance='NO') &
                                   Bispectra(field1,field2,field3,bispectrum_type)%b(bi_ix,il1)*Bscale
                       end do
                      end do
                     end do   
                    write (fileid,'(a)') ''                            
                   end do
                  end if !slice
                  if (BispectrumParams%FullOutputFile/='') then
                    if (BispectrumParams%SparseFullOutput .and. .not. any( SampleL%l(1:SampleL%l0)==L2) .or. &
                          l1 > 30 .and. mod(l3-min_l,10)/=0 .and. l3 /= max_l) cycle

                     do bispectrum_type=1,nbispectra
                       if (bispectrum_type==lens_bispectrum_ix .and. L1 > lmax_lensing_corrT) cycle
                       write(bispectrum_type,'(3I5)', advance='NO') L1, L2, L3
                       do field1=1,nfields
                        do field2=1,nfields
                         do field3=1,nfields
                         write(bispectrum_type,'(1E14.5)', advance='NO') &
                                 Bispectra(field1,field2,field3,bispectrum_type)%b(bi_ix,il1)*Bscale
                        end do
                       end do
                      end do  
                      write (bispectrum_type,'(a)') ''       
                     end do
                  end if
                   
              end do    
            end do          
          end do
          if (BispectrumParams%do_parity_odd) then          
              do il1= 1, SampleL%l0
                l1 = SampleL%l(il1)
                bi_ix=0
                do l2= max(lmin,l1), lmax 
                  min_l = max(abs(l1-l2),l2)
                  if (mod(l1+l2+min_l,2)/=1) then
                     min_l = min_l+1
                  end if 
                  max_l = min(lmax,l1+l2) 
                  do l3=min_l, max_l ,2
                      bi_ix=bi_ix+1
                      if (l1==BispectrumParams%Slice_Base_L &
                       .and. any(l3-l2==BispectrumParams%deltas(1:BispectrumParams%ndelta))) then
                      !Particular slice
                       idelta=IndexOf(l3-l2,BispectrumParams%deltas,BispectrumParams%ndelta)
                       do bispectrum_type=1,nbispectra
                        if (bispectrum_type/=lens_bispectrum_ix) cycle
                        fileid=nbispectra +BispectrumParams%ndelta*(bispectrum_type-1)+idelta
                        write (fileid,'(1I5)', advance='NO') L2
                        oddix=0
                        do field1=1,3
                         do field2=1,3
                           do field3=1,3
                              if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                              oddix=oddix+1
                              write(fileid,'(1E15.5)', advance='NO') OddBispectra(oddix)%b(bi_ix,il1)*Bscale
                           end do
                          end do
                         end do   
                        write (fileid,'(a)') ''                            
                       end do
                      end if !slice
                     
                  end do    
                end do          
              end do
         end if
          
          do bispectrum_type=1,nbispectra
            if (BispectrumParams%Slice_Base_L>0) then
             do idelta=1,BispectrumParams%ndelta
              if (mod(BispectrumParams%Slice_Base_L + BispectrumParams%deltas(idelta),2)==1 &
                      .and. bispectrum_type/=lens_bispectrum_ix) cycle
              close(nbispectra +BispectrumParams%ndelta*(bispectrum_type-1)+idelta)
             end do
            end if
            if (BispectrumParams%FullOutputFile/='') close(bispectrum_type)                            
          end do
   
          end if

#ifdef FISHER
          if (BispectrumParams%DoFisher) then
 !Get stuff for Fisher etc.
 
          print *,'Getting Fisher for lmax = ', lmax
         
          Noise = BispectrumParams%FisherNoise/ (COBE_CMBTemp*1e6)**2  !Planckish, dimensionless units  
          NoiseP = BispectrumParams%FisherNoisePol/ (COBE_CMBTemp*1e6)**2 
             
          do i=lmin,lmax
             if (CP%DoLensing) then
              cl(:,i) = CL_lensed(i,1,CT_Temp:CT_Cross)
             else
              cl(1,i) = CL_Scalar(i,1,C_Temp)
              cl(2,i) = CL_Scalar(i,1,C_E)
              cl(4,i) = CL_Scalar(i,1,C_Cross)
              cl(3,i) = 0              
             end if 
          end do
          if (.false.) then
              call OpenTxtFile('CAMBdefault_lensedCls.dat',3)
              do i=lmin,lmax
               !Assume T,E,B,X ordering
               read(3,*) j, cl(1:4,i)
               if (j<lmin) read(3,*) j, cl(1:4,i)
               cl(:,i)=cl(:,i)/(COBE_CMBTemp*1e6)**2 
              end do
              close(3)
          end if

          if (Noise >0) then
           file_tag = concat(file_tag,'_noise')
          end if
          xlc= 180*sqrt(8.*log(2.))/3.14159
          sigma2 = (BispectrumParams%FisherNoiseFwhmArcmin/60/xlc)**2
          allocate(InvC(lmax))
          do l1= lmin, lmax
             tmp = l1*(l1+1)/(2*pi)
             Cl(1,l1) = Cl(1,l1)/tmp + Noise*exp(l1*(l1+1)*sigma2)
             Cl(2:3,l1) = Cl(2:3,l1)/tmp + NoiseP*exp(l1*(l1+1)*sigma2)
             Cl(4,l1) = Cl(4,l1)/tmp  
             allocate(InvC(l1)%C(nfields,nfields))
             if (nfields > 2) stop 'Not implemented nfields>2 in detail'
             if (nfields==1) then
              InvC(l1)%C(1,1)=(2*l1+1)/cl(1,l1)/InternalScale
             else 
              InvC(l1)%C(1,1)=cl(2,l1)
              InvC(l1)%C(1,2)=-cl(4,l1)
              InvC(l1)%C(2,1)=-cl(4,l1)
              InvC(l1)%C(2,2)=cl(1,l1)              
              InvC(l1)%C= InvC(l1)%C * (2*l1+1)/(cl(1,l1)*cl(2,l1)-cl(4,l1)**2)/InternalScale
             end if
          end do
   
        if (debugMsgs) starttime=GetTestTime() 
        allocate(ifish_contribs(SampleL%l0,nbispectra,nbispectra,nfields,nfields) )
        !This loop is just in case want to plot out lmax dependence
        do lmaxcuti=SampleL%l0, SampleL%l0
     !    call CreateTxtFile('TE-Planck-LensFish.txt',20)
     !   do lmaxcuti=1, SampleL%l0
     !   if (SampleL%l(lmaxcuti) < 425) cycle
         
          lmax= SampleL%l(lmaxcuti)    
            
          ifish_contribs=0
          lstart = 2 !lmin
         !$OMP PARAllEl DO DEFAUlT(SHARED),SCHEDULE(STATIC,3) &
         !$OMP PRIVATE(il1,l1,l2,l3,fish_l1,bi_ix,min_l,max_l,a3j_00,a3j), &
         !$OMP PRIVATE(Bispectrum,Bispectrum2,minl2,bix,tmp,tmp1,tmp2,tmpf), &
         !$OMP PRIVATE(field1,field2,field3,f1,f2,f3,bispectrum_type,bispectrum_type2)

          do il1= 1,  lmaxcuti !!!SampleL%l0
            allocate(fish_l1(nbispectra,nbispectra,nfields,nfields)) !last indices are field1,f1
            l1 = SampleL%l(il1)
            if (l1< lstart) cycle
            fish_l1=0
            bi_ix=0
            do l2 = l1,lmax
              if (l2< lstart) cycle
              min_l = max(lstart,max(abs(l1-l2),l2))
              if (mod(l1+l2+min_l,2)/=0) then
                 min_l = min_l+1
              end if 
              max_l = min(lmax,l1+l2) 
              call GetThreeJs(a3j(abs(l2-l1)),l1,l2,0,0)
              do l3=min_l,max_l ,2    
                a3j_00(l3)=a3j(l3)**2
              end do
              
              tmp1= 1.d0/(4*pi)  !(2l+1) factors included in InvC
              minl2=min_l
              bix=bi_ix
               do field1=1,nfields
                do f1=1,nfields
                 tmpf(1)= InvC(l1)%C(field1,f1)*tmp1
                 do field2=1,nfields
                   do f2=1,nfields
                    tmpf(2)= InvC(l2)%C(field2,f2)*tmpf(1)
                     do field3=1,nfields
                      do bispectrum_type=1,nbispectra
                      if (bispectrum_type==lens_bispectrum_ix) then
                        Bispectrum=>SqueezedLensingKernel(field2,field3)
                      else
                        Bispectrum=>bispectra(field1,field2,field3,bispectrum_type)
                      end if
                      do f3=1,nfields
                        
                        do bispectrum_type2=bispectrum_type,nbispectra
                        if (bispectrum_type2==lens_bispectrum_ix) then
                          Bispectrum2=>SqueezedLensingKernel(f2,f3)
                        else
                          Bispectrum2=>Bispectra(f1,f2,f3,bispectrum_type2)
                        end if
   
          
                        min_l=minl2          
                        bi_ix=bix
                        if (min_l==l2) then
                            !Symmetry factors
                             bi_ix=bi_ix+1
                             l3=l2
                             if (l2==l1) then
                              !l1=l2=l3
                              tmp = Bispectrum%b(bi_ix,il1)*tmpf(2)*Bispectrum2%b(bi_ix,il1) &
                                      *InvC(l3)%C(field3,f3)*a3j_00(l3)/6  
                             else
                              !l3=l2 (l3=l1<>l2 can't happen because l1<=l2<=l3)
                              tmp = Bispectrum%b(bi_ix,il1)*tmpf(2)*Bispectrum2%b(bi_ix,il1) &
                                      * InvC(l3)%C(field3,f3)*a3j_00(l3)/2 
                             end if
                             min_l = min_l+2
                        else
                         tmp=0
                        end if
                        tmp2=0  
                        do l3=min_l,max_l ,2    
                            bi_ix=bi_ix+1
                            tmp2 = tmp2 + Bispectrum%b(bi_ix,il1)*Bispectrum2%b(bi_ix,il1) &
                                   * InvC(l3)%C(field3,f3)*a3j_00(l3)
                        end do  
                        if (l2==l1) then
                           tmp2=tmp2*tmpf(2)/2
                          else
                           tmp2=tmp2*tmpf(2)     
                        end if     
                        fish_l1(bispectrum_type,bispectrum_type2,field1,f1)= &
                         fish_l1(bispectrum_type,bispectrum_type2,field1,f1)+(tmp+tmp2) 
                        
                        end do !bispectrum_type2
   
                      end do
                      end do !bispectrum_type
                     end do !field3
                    end do !f2                   
                  end do !field2
                 end do !f1
               end do  !field1

            end do !l2

            ifish_contribs(il1,:,:,:,:)=fish_l1(1:nbispectra,1:nbispectra,:,:) /InternalScale
            deallocate(fish_L1) 
 
          end do
         !$OMP END PARAllEl DO
          if (DebugMsgs) print *,'Time for Fisher:', GetTestTime()-starttime
    
          
          allocate(fish_contribs(lmin:CTrans%ls%l(CTrans%ls%l0),nfields,nfields))
          allocate(Fisher(nbispectra,nbispectra))
          allocate(tmpFisher(nbispectra,nbispectra))
          allocate(Fisher_L1(lmin:CTrans%ls%l(CTrans%ls%l0),nbispectra*nfields,nbispectra*nfields))
          
          do bispectrum_type=1,nbispectra
           do bispectrum_type2=bispectrum_type,nbispectra

           fish_contribs=0 
           do field1=1,nfields
            do f1=1,nfields
            call InterpolateClArr(SampleL,ifish_contribs(1,bispectrum_type,bispectrum_type2,field1,f1), &
                        fish_contribs(lmin,field1,f1),lmaxcuti)  !SampleL%l0)
            end do
           end do          
           Fisher(bispectrum_type,bispectrum_type2)=0
           do i=lmin, CTrans%ls%l(CTrans%ls%l0)
            do field1=1,nfields
             do f1=1,nfields
              Fisher_L1(i,(bispectrum_type-1)*nfields+field1,(bispectrum_type2-1)*nfields+f1) = fish_contribs(i,field1,f1)
              Fisher_L1(i,(bispectrum_type2-1)*nfields+f1,(bispectrum_type-1)*nfields+field1) = fish_contribs(i,field1,f1)
              tmp=fish_contribs(i,field1,f1)
              if (bispectrum_type==lens_bispectrum_ix) then
               tmp = tmp * CPhi(1+field1,i)
              end if
              if (bispectrum_type2==lens_bispectrum_ix) then
               tmp = tmp * CPhi(1+f1,i)
              end if              
              Fisher(bispectrum_type,bispectrum_type2)=Fisher(bispectrum_type,bispectrum_type2)+ tmp
             end do
            end do 
           end do
           Fisher(bispectrum_type2,bispectrum_type) = Fisher(bispectrum_type,bispectrum_type2) 
           
           print *,'Zero-signal Fisher ',trim(BispectrumNames(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type2)), &
                      ':', Fisher(bispectrum_type2,bispectrum_type) 
           
!!!! contribution of lensing to the fnl variance for temperature:
!           if (bispectrum_type == fnl_bispectrum_ix .and. bispectrum_type2 == fnl_bispectrum_ix ) then 
!              fish_contribs_sig=0
!              tmpArr=0
!              call InterpolateClArr(SampleL,ifish_contribs(1,1,2,1,1),tmpArr(lmin),lmaxcuti) 
!               do i=lmin, lmax_lensing_corrT
!               if (CPhi(1+1,i)/=0) then
!                 fish_contribs_sig(i) = &
!                  tmpArr(i)**2*(1+ CPhi(1,i)*CForLensing(i)%C(1,1)/(CPhi(1+1,i)*CPhi(1+1,i)))/(2*i+1)
!               end if
!              end do
!              print *,'signal contribution to fnl variance', sum(fish_contribs_sig)/Fisher(bispectrum_type,bispectrum_type2)**2
!           end if
 !!! same with polarization
!  if (bispectrum_type == fnl_bispectrum_ix .and. bispectrum_type2 == lens_bispectrum_ix ) then 
!            fish_contribs_sig=0
!            do i=lmin, lmax_lensing_corrT
!             corrsize = count(CPhi(2:1+nfields,i)/=0)
!             allocate(fish_L_ij(corrsize,corrsize))
!             allocate(fish_L_noise(corrsize,corrsize))
!             fish_L_ij=0 
!             ix1=0
!             do field1=1,nfields
!              ix1=ix1+1
!              ix2=0
!              do f1=1,nfields
!                 ix2=ix2+1
!                 fish_L_noise(ix1,ix2)= fish_contribs(i,field1, f1)
!                 fish_L_ij(ix1,ix2) = (CPhi(1+f1,i)*CPhi(1+field1,i) + &
!                     CPhi(1,i)*CForLensing(i)%C(field1,f1) )/(2*i+1)
!              end do
!             end do 
!             fish_L_ij=matmul(matmul((fish_L_noise(:,:)),fish_L_ij),transpose(fish_L_noise(:,:)))
!             fish_contribs_sig(i) = sum(fish_L_ij)!Matrix_trace(fish_L_ij)
!             deallocate(fish_L_ij)
!             deallocate(fish_L_noise)
!            end do
!            print *,'fnl signal factor', sum(fish_contribs_sig)
!       end if                 
            

           if (bispectrum_type == lens_bispectrum_ix .and. bispectrum_type2 == lens_bispectrum_ix ) then 
            print *,'doing signal part of the lensing variance'
            fish_contribs_sig=0
            do i=lmin, lmax_lensing_corrT
             corrsize = count(CPhi(2:1+nfields,i)/=0)
             allocate(fish_L_ij(corrsize,corrsize))
             allocate(fish_L_noise(corrsize,corrsize))
             fish_L_ij=0 
             ix1=0
             do field1=1,nfields
              if (CPhi(1+field1,i)/=0) then
              ix1=ix1+1
              ix2=0
              do f1=1,nfields
               if (CPhi(1+f1,i)/=0) then
                 ix2=ix2+1
                 fish_L_noise(ix1,ix2)= fish_contribs(i,field1, f1)*CPhi(1+f1,i)*CPhi(1+field1,i)
                 fish_L_ij(ix1,ix2) =  (1 + &
                     CPhi(1,i)*CForLensing(i)%C(field1,f1)/(CPhi(1+f1,i)*CPhi(1+field1,i)))/(2*i+1)

               end if
              end do
              end if
             end do 
              call Matrix_Inverse(fish_L_noise)
              fish_L_ij=fish_L_ij+fish_L_noise
              call Matrix_Inverse(fish_L_ij) 
              fish_contribs_sig(i) = sum(fish_L_ij)  
             deallocate(fish_L_ij)
             deallocate(fish_L_noise)
            end do
            print *,'Lensing Fisher including lensing variance ', sum(fish_contribs_sig)
    
           end if
           
           end do
          end do
         deallocate(fish_contribs)
      
          print *, 'Results assuming zero fiducial bispectra' 
          do bispectrum_type=1,nbispectra
           print *,trim(IntToStr(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type)), &
                      ': 1/sqrt(F_ii) = ',1/sqrt(Fisher(bispectrum_type,bispectrum_type))
          end do

          do bispectrum_type=1,nbispectra
           do bispectrum_type2=bispectrum_type+1,nbispectra
            bias = Fisher(bispectrum_type2,bispectrum_type)/Fisher(bispectrum_type,bispectrum_type)
            print *,'Bias of ',trim(BispectrumNames(bispectrum_type2)),' on ', &
             trim(BispectrumNames(bispectrum_type)),':', bias 
           end do
!           if (bispectrum_type==1) write(1,concat('(1I10,',nbispectra,'E15.5)')) lmax, Fisher(1,1), &
!                                  Fisher(2:nbispectra,1)/Fisher(1,1)
          end do 
          
          tmpFisher=Fisher
          do bispectrum_type=1,nbispectra
            tmp = sqrt(tmpFisher(bispectrum_type,bispectrum_type))
            tmpFisher(bispectrum_type,:)=tmpFisher(bispectrum_type,:)/tmp
            tmpFisher(:,bispectrum_type)=tmpFisher(:,bispectrum_type)/tmp
          end do     
          if (nbispectra>1) then
           print *,'Zero-signal Bispectrum correlation matrix:'
           do bispectrum_type=1,nbispectra
            print *,tmpFisher(:,bispectrum_type)
           end do
         
          if (nbispectra > 1) then
              allocate(OptimalFisher(nbispectra,nbispectra))
              allocate(tmpBigFisher(nbispectra*nfields,nbispectra*nfields))
!              allocate(diag(nbispectra*nfields))
              OptimalFisher=0
              do i=lmin, lmax  
                 tmpBigFisher=Fisher_L1(i,:,:)
                 if (lens_bispectrum_ix/=0 .and. i<=lmax_lensing_corrT) then

                     call Matrix_Inverse(tmpBigFisher)
                     do field1 = 1,nfields
                       do field2 =1, nfields
                        tmpBigFisher((lens_bispectrum_ix-1)*nfields+field1, &
                                     (lens_bispectrum_ix-1)*nfields+field2) = &
                              tmpBigFisher((lens_bispectrum_ix-1)*nfields+field1, &
                                     (lens_bispectrum_ix-1)*nfields+field2) + &
                       (CPhi(1+field1,i)*CPhi(1+field2,i) + CPhi(1,i)*CForLensing(i)%C(field1,field2))/(2*i+1)
                       end do
                     end do  
                     call Matrix_Inverse(tmpBigFisher)
                     
                 end if
                           
                 do field1=1,nfields
                  do field2=1,nfields
                   do bispectrum_type=1,nbispectra
                     do bispectrum_type2=1,nbispectra
                       if (bispectrum_type==lens_bispectrum_ix) then
                        tmp=CPhi(1+field1,i)
                       else
                        tmp=1 
                       end if
                       if (bispectrum_type2==lens_bispectrum_ix) then
                        tmp=tmp*CPhi(1+field2,i)
                       end if
                       OptimalFisher(bispectrum_type,bispectrum_type2)=OptimalFisher(bispectrum_type,bispectrum_type2)+ &
                         tmp*tmpBigFisher((bispectrum_type-1)*nfields+field1,(bispectrum_type2-1)*nfields+field2)
                     end do
                   end do
                  end do
                 end do      
              end do
              deallocate(tmpBigFisher)
          end if

          do bispectrum_type=1,nbispectra
           print *,'Optimal Inc. lensing:', trim(IntToStr(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type)), &
                      ': 1/sqrt(F_ii) = ',1/sqrt(OptimalFisher(bispectrum_type,bispectrum_type))
          end do
          tmpFisher=OptimalFisher
          call Matrix_Inverse(tmpFIsher)
          do bispectrum_type=1,nbispectra
           print *,'Optimal Inc. lensing:', trim(IntToStr(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type)), &
                      ': Cov_ii = ', sqrt(tmpFIsher(bispectrum_type,bispectrum_type))
          end do
          tmpFisher=OptimalFisher
          do bispectrum_type=1,nbispectra
            tmp = sqrt(tmpFisher(bispectrum_type,bispectrum_type))
            tmpFisher(bispectrum_type,:)=tmpFisher(bispectrum_type,:)/tmp
            tmpFisher(:,bispectrum_type)=tmpFisher(:,bispectrum_type)/tmp
          end do     
           print *,'Optimal Bispectrum correlation matrix with lensing variance:'
           do bispectrum_type=1,nbispectra
            print *,tmpFisher(:,bispectrum_type)
           end do
          end if
          
          deallocate(Fisher, tmpFisher)
 
          end do
  
          deallocate(ifish_contribs)
          deallocate(InvC)

          end if !DoFIsher
#else
          if (BispectrumParams%DoFisher) stop 'compile with FISHER defined'
#endif                    
          
          !Tidy up a bit
          do field1=1,nfields
             do field2=1,nfields
                  do field3=1,nfields
                    do bispectrum_type=1,nbispectra
                    deallocate(Bispectra(field1,field2,field3,bispectrum_type)%b)
                    end do
                  end do
             end do
          end do  
          deallocate(Bispectra)   
          if (allocated(CForLensing)) deallocate(CForLensing)

         if (allocated(OddBispectra)) then 
              oddix=0
              do field1=1,3
                 do field2=1,3
                      do field3=1,3
                        if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                        oddix=oddix+1
                        deallocate(OddBispectra(oddix)%b)
                      end do
                 end do
              end do  
           deallocate(OddBispectra)
          end if   
          
        end subroutine GetBispectrum


!not needed for local NG
        subroutine NonGauss_deriv_l_r(CTrans, indP,resP, r, dJl, dddJl)
        !As above, but integral against derivative of bessel function to get derivative of function
          Type(ClTransferData) :: CTrans
          real(dl), intent(in) :: dJl(BessRanges%npoints,CTrans%ls%l0), dddJl(BessRanges%npoints,CTrans%ls%l0)        
          integer, intent(in) :: indP(:) 
          real(dl) resP(CTrans%ls%l0,size(indP))
          real(dl), intent(in) :: r
          integer q_ix, j, bes_ix, i
          integer nP, ellmax
         real(dl) xf , dJ_l, fac, a2,  k, dlnk, term, P        
     
          nP =size(indP)          
          resP = 0
          do q_ix = 1, CTrans%q%npoints 
            
            k = CTrans%q%points(q_ix)
            xf = k*r  !kr
            bes_ix=Ranges_indexOf(BessRanges,xf)
            fac=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
            a2=(BessRanges%points(bes_ix+1)-xf)/fac
            fac=fac**2*a2/6
            dlnk = CTrans%q%dpoints(q_ix) /k
            P = ScalarPower(k, 1)  !!only first index for now
            ellmax = max(xf/(1-xlimfrac), xf + xlimmin) * AccuracyBoost
            
            do j=1,CTrans%ls%l0
             if (CTrans%ls%l(j) <= ellmax) then
             dJ_l=a2*djl(bes_ix,j)+(1-a2)*(djl(bes_ix+1,j) - ((a2+1) &
                        *dddjl(bes_ix,j)+(2-a2)*dddjl(bes_ix+1,j))* fac) !cubic spline
     
             term = CTrans%Delta_p_l_k(1,j,q_ix)*dJ_l*dlnk *k  
             do i=1,nP
              resP(j,i) = resP(j,i) + term * k**indP(i) * P
             end do
            
            end if
           end do
         end do
         resP = resP * fourpi
               
        end subroutine NonGauss_deriv_l_r

       subroutine Bispectrum_SetDefParams(B)
       Type(TBispectrumParams) :: B
       
          B%nfields=2
          B%Slice_Base_L=0
          B%ndelta=0
          B%DoFisher = .true.
          B%FisherNoise = 0 !2d-4 !Planckish
          B%FisherNoisePol = 4*B%FisherNoise
          B%FisherNoiseFwhmArcmin = 7
          B%FullOutputFile='' !quite large
          B%SparseFullOutput = .false.
          B%do_lensing_bispectrum = .true.
          B%do_primordial_bispectrum = .true.
          B%do_parity_odd = .false.
          B%export_alpha_beta = .false.
       
       end subroutine Bispectrum_SetDefParams      
       
                
       subroutine Bispectrum_ReadParams(B, Ini, outroot)
          use IniFile
          Type(TBispectrumParams) :: B
          character(LEN=*), intent(in) :: outroot
          Type(TIniFile) :: Ini
          integer i
          
          call Bispectrum_SetDefParams(B)
   
          B%do_lensing_bispectrum = Ini_Read_Logical_File(Ini,'do_lensing_bispectrum',.false.)
          B%do_primordial_bispectrum = Ini_Read_Logical_File(Ini,'do_primordial_bispectrum',.false.)
       
          do_bispectrum= B%do_lensing_bispectrum .or. B%do_primordial_bispectrum
          
          if (do_bispectrum) then
          
          output_root = outroot
          
          B%nfields = Ini_Read_Int_File(Ini,'bispectrum_nfields',B%nfields)
          if (B%nfields /= 2 .and. B%nfields/=1) stop 'Bispectrum: nfields=1 for T only or 2 for polarization'
          B%do_parity_odd = Ini_Read_Logical_File(Ini,'do_parity_odd',.false.)
          if (B%do_parity_odd .and. (.not.  B%do_lensing_bispectrum .or. B%nfields==1)) then
             B%do_parity_odd = .false.
             write(*,*) 'Ignoring do_parity_odd since do_lensing_bispectrum=F or no polarization'
          end if   
          B%Slice_Base_L = Ini_Read_Int_File(Ini,'bispectrum_slice_base_L',B%Slice_Base_L)
          if (B%Slice_Base_L>0) then
           B%ndelta = Ini_Read_Int_File(Ini,'bispectrum_ndelta',B%ndelta)
           if (B%ndelta > max_bispectrum_deltas) stop 'Bispectrum : increase max_bispectrum_deltas'
           do i=1, B%ndelta
              B%deltas(i) = Ini_Read_Int_Array_File(Ini,'bispectrum_delta', i)
           end do    
           if (.not. B%do_parity_odd .and. B%Slice_Base_L>0 .and. &
             any(mod(B%Slice_Base_L + B%deltas(1:B%ndelta),2) /= 0)) &
               stop 'Slice is zero for even parity with L1+L2+L3 odd, i.e. Base+DeltaL3 odd'
              
          end if
          B%DoFisher = Ini_Read_Logical_File(Ini,'bispectrum_do_fisher',B%DoFisher)        
          if (B%DoFisher) then
           B%FisherNoise = Ini_Read_Double_File(Ini,'bispectrum_fisher_noise',B%FisherNoise)        
           B%FisherNoisePol = Ini_Read_Double_File(Ini,'bispectrum_fisher_noise_pol',B%FisherNoisePol )        
           B%FisherNoiseFwhmArcmin = Ini_Read_Double_File(Ini,'bispectrum_fisher_fwhm_arcmin',B%FisherNoiseFwhmArcmin)
          end if
          B%FullOutputFile = Ini_Read_String_File(Ini,'bispectrum_full_output_file') 
          if (B%FullOutputFile /='') then
           B%SparseFullOutput = Ini_Read_Logical_file(Ini,'bispectrum_full_output_sparse',B%SparseFullOutput)
          end if
          
          if (B%do_primordial_bispectrum) then
             B%export_alpha_beta = Ini_Read_Logical_file(Ini,'bispectrum_export_alpha_beta', B%export_alpha_beta)
          end if
          
          end if
          
        end subroutine Bispectrum_ReadParams  
 
end module Bispectrum

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine findtop(a,na,iord,nb)
      integer na,nb,iord(nb)
      real*10 a(na)
c
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of real*10 a having the largest value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having largest value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a that are equal are left in their original order.
c *
      order(ia,ja)=a(ia).gt.a(ja).or.(a(ia).eq.a(ja).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine findbot(a,na,iord,nb)
      integer na,nb,iord(nb)
      real*10 a(na)
c
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of real*10 a having the smallest value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having smallest value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a that are equal are left in their original order.
c *
      order(ia,ja)=a(ia).lt.a(ja).or.(a(ia).eq.a(ja).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine findtpa(a,na,iord,nb)
      integer na,nb,iord(nb)
      real*10 a(na)
c
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of real*10 a having the largest absolute value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having largest absolute value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a equal in abs value are left in their original order.
c *
      order(ia,ja)=abs(a(ia)).gt.abs(a(ja))
     *  .or.(abs(a(ia)).eq.abs(a(ja)).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine findbta(a,na,iord,nb)
      integer na,nb,iord(nb)
      real*10 a(na)
c
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of real*10 a having the smallest absolute value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having smallest absolute value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a equal in abs value are left in their original order.
c *
      order(ia,ja)=abs(a(ia)).lt.abs(a(ja))
     *  .or.(abs(a(ia)).eq.abs(a(ja)).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine finitop(a,na,iord,nb)
      integer na,nb,iord(nb)
      integer a(na)
c
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of integer a having the largest value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having largest value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a that are equal are left in their original order.
c *
      order(ia,ja)=a(ia).gt.a(ja).or.(a(ia).eq.a(ja).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine finibot(a,na,iord,nb)
      integer na,nb,iord(nb)
      integer a(na)
c
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of integer a having the smallest value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having smallest value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a that are equal are left in their original order.
c *
      order(ia,ja)=a(ia).lt.a(ja).or.(a(ia).eq.a(ja).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine finitpa(a,na,iord,nb)
      integer na,nb,iord(nb)
      integer a(na)
c
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of integer a having the largest absolute value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having largest absolute value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a equal in abs value are left in their original order.
c *
      order(ia,ja)=abs(a(ia)).gt.abs(a(ja))
     *  .or.(abs(a(ia)).eq.abs(a(ja)).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c
c-----------------------------------------------------------------------
      subroutine finibta(a,na,iord,nb)
      integer na,nb,iord(nb)
      integer a(na)
c
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer i,ia,ib,it,n,ja
      logical order
c *
c * Find nb elements of integer a having the smallest absolute value.
c * Returns index iord of these elements, ordered so iord(1) corresponds
c * to element a(iord(1)) having smallest absolute value.
c * If nb .gt. na, last nb-na elements of iord are undefined.
c * Elements of a equal in abs value are left in their original order.
c *
      order(ia,ja)=abs(a(ia)).lt.abs(a(ja))
     *  .or.(abs(a(ia)).eq.abs(a(ja)).and.ia.lt.ja)
      include 'heapsort.inc'
      return
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine braktop(aa,ia,a,n,l)
      integer ia,n,l
      real*10 aa,a(n)
      integer idir,istep
c *
c * Bracket aa in table a ordered in decreasing order,
c * i.e. find ia such that
c *    a(ia) >= aa > a(ia+1)   (l.eq.0)
c * or a(ia) > aa >= a(ia+1)   (l.eq.1).
c * Gives ia=0 if
c *    aa > a(1)   (l.eq.0)
c * or aa >= a(1)  (l.eq.1).
c * Gives ia=n if
c *    aa <= a(1)  (l.eq.0)
c * or aa < a(1)   (l.eq.1).
c *
c  Input: aa = value to bracket
c         a = ordered array of length n
c         n = length of a array
c         l = 0 or 1 to choose equality on lower or upper limit.
c Input/Output: ia on input = element of a to start search from;
c                  on output = as above.
c
      if (ia.lt.1) ia=1
      if (ia.gt.n) ia=n
c        idir is which way to search, up or down
      if (aa.lt.a(ia)) then
        idir=1
      elseif (aa.gt.a(ia)) then
        idir=-1
      elseif (aa.eq.a(ia)) then
        ia=ia-l
        goto 200
      endif
c        istep is how far to leap from present position
      istep=1
c        leap
  120 ia=ia+idir*istep
c        keep doubling leap till you've straddled desired place
      if (ia.lt.1.or.ia.gt.n) then
        continue
      elseif (idir*aa.lt.idir*a(ia)) then
        istep=istep*2
        goto 120
      elseif (aa.eq.a(ia)) then
        ia=ia-l
        goto 200
      endif
      idir=-idir
c        binary chop homes in on desired place in table
  140 if (istep.gt.1) then
        istep=istep/2
        ia=ia+idir*istep
        if (ia.lt.1) then
          idir=1
        elseif (ia.gt.n) then
          idir=-1
        elseif (aa.lt.a(ia)) then
          idir=1
        elseif (aa.gt.a(ia)) then
          idir=-1
        elseif (aa.eq.a(ia)) then
          ia=ia-l
          goto 200
        endif
        goto 140
      endif
      if (idir.eq.-1) ia=ia-1
  200 continue
      return
      end
c
c-----------------------------------------------------------------------
      subroutine brakbot(aa,ia,a,n,l)
      integer ia,n,l
      real*10 aa,a(n)
      integer idir,istep
c *
c * Bracket aa in table a ordered in increasing order,
c * i.e. find ia such that
c *    a(ia) <= aa < a(ia+1)   (l.eq.0)
c * or a(ia) < aa <= a(ia+1)   (l.eq.1).
c * Gives ia=0 if
c *    aa < a(1)   (l.eq.0)
c * or aa <= a(1)  (l.eq.1).
c * Gives ia=n if
c *    aa <= a(1)  (l.eq.0)
c * or aa < a(1)   (l.eq.1).
c *
c  Input: aa = value to bracket
c         a = ordered array of length n
c         n = length of a array
c         l = 0 or 1 to choose equality on lower or upper limit.
c Input/Output: ia on input = element of a to start search from;
c                  on output = as above.
c
      if (ia.lt.1) ia=1
      if (ia.gt.n) ia=n
c        idir is which way to search, up or down
      if (aa.gt.a(ia)) then
        idir=1
      elseif (aa.lt.a(ia)) then
        idir=-1
      elseif (aa.eq.a(ia)) then
        ia=ia-l
        goto 200
      endif
c        istep is how far to leap from present position
      istep=1
c        leap
  120 ia=ia+idir*istep
c        keep doubling leap till you've straddled desired place
      if (ia.lt.1.or.ia.gt.n) then
        continue
      elseif (idir*aa.gt.idir*a(ia)) then
        istep=istep*2
        goto 120
      elseif (aa.eq.a(ia)) then
        ia=ia-l
        goto 200
      endif
      idir=-idir
c        binary chop homes in on desired place in table
  140 if (istep.gt.1) then
        istep=istep/2
        ia=ia+idir*istep
        if (ia.lt.1) then
          idir=1
        elseif (ia.gt.n) then
          idir=-1
        elseif (aa.gt.a(ia)) then
          idir=1
        elseif (aa.lt.a(ia)) then
          idir=-1
        elseif (aa.eq.a(ia)) then
          ia=ia-l
          goto 200
        endif
        goto 140
      endif
      if (idir.eq.-1) ia=ia-1
  200 continue
      return
      end
c
c-----------------------------------------------------------------------
      subroutine braktpa(aa,ia,a,n,l)
      integer ia,n,l
      real*10 aa,a(n)
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer idir,istep
c *
c * Bracket aa in table a ordered in decreasing order of absolute value,
c * i.e. find ia such that
c *    |a(ia)| >= aa > |a(ia+1)|   (l.eq.0)
c * or |a(ia)| > aa >= |a(ia+1)|   (l.eq.1).
c * Gives ia=0 if
c *    aa > |a(1)|   (l.eq.0)
c * or aa >= |a(1)|  (l.eq.1).
c * Gives ia=n if
c *    aa <= |a(1)|  (l.eq.0)
c * or aa < |a(1)|   (l.eq.1).
c *
c  Input: aa = value to bracket
c         a = ordered array of length n
c         n = length of a array
c         l = 0 or 1 to choose equality on lower or upper limit.
c Input/Output: ia on input = element of a to start search from;
c                  on output = as above.
c
      if (ia.lt.1) ia=1
      if (ia.gt.n) ia=n
c        idir is which way to search, up or down
      if (aa.lt.abs(a(ia))) then
        idir=1
      elseif (aa.gt.abs(a(ia))) then
        idir=-1
      elseif (aa.eq.abs(a(ia))) then
        ia=ia-l
        goto 200
      endif
c        istep is how far to leap from present position
      istep=1
c        leap
  120 ia=ia+idir*istep
c        keep doubling leap till you've straddled desired place
      if (ia.lt.1.or.ia.gt.n) then
        continue
      elseif (idir*aa.lt.idir*abs(a(ia))) then
        istep=istep*2
        goto 120
      elseif (aa.eq.abs(a(ia))) then
        ia=ia-l
        goto 200
      endif
      idir=-idir
c        binary chop homes in on desired place in table
  140 if (istep.gt.1) then
        istep=istep/2
        ia=ia+idir*istep
        if (ia.lt.1) then
          idir=1
        elseif (ia.gt.n) then
          idir=-1
        elseif (aa.lt.abs(a(ia))) then
          idir=1
        elseif (aa.gt.abs(a(ia))) then
          idir=-1
        elseif (aa.eq.abs(a(ia))) then
          ia=ia-l
          goto 200
        endif
        goto 140
      endif
      if (idir.eq.-1) ia=ia-1
  200 continue
      return
      end
c
c-----------------------------------------------------------------------
      subroutine brakbta(aa,ia,a,n,l)
      integer ia,n,l
      real*10 aa,a(n)
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer idir,istep
c *
c * Bracket aa in table a ordered in increasing order of absolute value,
c * i.e. find ia such that
c *    |a(ia)| <= aa < |a(ia+1)|   (l.eq.0)
c * or |a(ia)| < aa <= |a(ia+1)|   (l.eq.1).
c * Gives ia=0 if
c *    aa < |a(1)|   (l.eq.0)
c * or aa <= |a(1)|  (l.eq.1).
c * Gives ia=n if
c *    aa <= |a(1)|  (l.eq.0)
c * or aa < |a(1)|   (l.eq.1).
c *
c  Input: aa = value to bracket
c         a = ordered array of length n
c         n = length of a array
c         l = 0 or 1 to choose equality on lower or upper limit.
c Input/Output: ia on input = element of a to start search from;
c                  on output = as above.
c
      if (ia.lt.1) ia=1
      if (ia.gt.n) ia=n
c        idir is which way to search, up or down
      if (aa.gt.abs(a(ia))) then
        idir=1
      elseif (aa.lt.abs(a(ia))) then
        idir=-1
      elseif (aa.eq.abs(a(ia))) then
        ia=ia-l
        goto 200
      endif
c        istep is how far to leap from present position
      istep=1
c        leap
  120 ia=ia+idir*istep
c        keep doubling leap till you've straddled desired place
      if (ia.lt.1.or.ia.gt.n) then
        continue
      elseif (idir*aa.gt.idir*abs(a(ia))) then
        istep=istep*2
        goto 120
      elseif (aa.eq.abs(a(ia))) then
        ia=ia-l
        goto 200
      endif
      idir=-idir
c        binary chop homes in on desired place in table
  140 if (istep.gt.1) then
        istep=istep/2
        ia=ia+idir*istep
        if (ia.lt.1) then
          idir=1
        elseif (ia.gt.n) then
          idir=-1
        elseif (aa.gt.abs(a(ia))) then
          idir=1
        elseif (aa.lt.abs(a(ia))) then
          idir=-1
        elseif (aa.eq.abs(a(ia))) then
          ia=ia-l
          goto 200
        endif
        goto 140
      endif
      if (idir.eq.-1) ia=ia-1
  200 continue
      return
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      logical function gptin(rp,cm,np,rpi)
      integer np
      real*10 rp(3,np),cm(np),rpi(3)
c
c        intrinsics
      intrinsic abs
c        externals
      integer gzeroar
c        local (automatic) variables
      integer j
      real*10 cmij,cmj
c *
c * Determine whether unit direction rpi lies within region bounded by
c *    1 - r.rp(j) <= cm(j)  (if cm(j).ge.0)
c *    1 - r.rp(j) > -cm(j)  (if cm(j).lt.0)
c * for j=1,np where rp(j) are unit directions.
c *
c  Input: rp(3,j),j=1,np
c         cm(j),j=1,np
c         np
c         rpi(3)
c Output: gptin = .true. if point lies within region
c                 .false. if outside.
c
      gptin=.false.
c        check for point outside because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        check each boundary
      do 140 j=1,np
c        null boundary means no constraint
        if (cm(j).ge.2._10) goto 140
        cmj=abs(cm(j))
c        1-cos of angle between point and rp(j) direction
        cmij=((rpi(1)-rp(1,j))**2+(rpi(2)-rp(2,j))**2
     *    +(rpi(3)-rp(3,j))**2)/2._10
c        check if point is outside rp(j) boundary
        if (cm(j).ge.0._10) then
          if (cmij.gt.cmj) goto 410
        elseif (cm(j).lt.0._10) then
          if (cmij.le.cmj) goto 410
        endif
  140 continue
c        point survived all assails
      gptin=.true.
c        done
  410 continue
      return
      end
c

c-----------------------------------------------------------------------
c * This is fftlogtest.f
c *
c * This is a simple test program to illustrate how FFTLog works.
c * The test transform is
c *    inf
c *    /   mu+1                               mu+1
c *    |  r     exp(-r^2/2) J_mu(k r) k dr = k     exp(-k^2/2)
c *    /
c *   0
c *
c * Disclaimer:
c * FFTLog does NOT claim to provide the most accurate possible
c * solution of the continuous transform (which is the stated aim
c * of some other codes).  Rather, FFTLog claims to solve the exact
c * discrete transform of a logarithmically-spaced periodic sequence.
c * If the periodic interval is wide enough, the resolution high
c * enough, and the function well enough behaved outside the periodic
c * interval, then FFTLog may yield a satisfactory approximation
c * to the continuous transform.
c *
c * Observe:
c * (1) How the result improves as the periodic interval is enlarged.
c *     With the normal FFT, one is not used to ranges orders of
c *     magnitude wide, but this is how FFTLog prefers it.
c * (2) How the result improves as the resolution is increased.
c *     Because the function is rather smooth, modest resolution
c *     actually works quite well here.
c * (3) That the central part of the transform is more reliable
c *     than the outer parts.  Experience suggests that a good general
c *     strategy is to double the periodic interval over which the
c *     input function is defined, and then to discard the outer
c *     half of the transform.
c * (4) That the best bias exponent seems to be q = 0.
c * (5) That for the critical index mu = -1, the result seems to be
c *     offset by a constant from the `correct' answer.
c * (6) That the result grows progressively worse as mu decreases
c *     below -1.
c *
c * The analytic integral above fails for mu <= -1, but FFTLog
c * still returns answers.  Namely, FFTLog returns the analytic
c * continuation of the discrete transform.  Because of ambiguity
c * in the path of integration around poles, this analytic continuation
c * is liable to differ, for mu <= -1, by a constant from the `correct'
c * continuation given by the above equation.
c *
c * FFTLog begins to have serious difficulties with aliasing as
c * mu decreases below -1, because then r^(mu+1) exp(-r^2/2) is
c * far from resembling a periodic function.
c * You might have thought that it would help to introduce a bias
c * exponent q = mu, or perhaps q = mu+1, or more, to make the
c * function a(r) = A(r) r^-q input to fhtq more nearly periodic.
c * In practice a nonzero q makes things worse.
c *
c * A symmetry argument lends support to the notion that the best
c * exponent here should be q = 0, as empirically appears to be true.
c * The symmetry argument is that the function r^(mu+1) exp(-r^2/2)
c * happens to be the same as its transform k^(mu+1) exp(-k^2/2).
c * If the best bias exponent were q in the forward transform, then
c * the best exponent would be -q that in the backward transform;
c * but the two transforms happen to be the same in this case,
c * suggesting q = -q, hence q = 0.
c *
c * This example illustrates that you cannot always tell just by
c * looking at a function what the best bias exponent q should be.
c * You also have to look at its transform.  The best exponent q is,
c * in a sense, the one that makes both the function and its transform
c * look most nearly periodic.
c *
c        parameters
      integer NMAX
      parameter (NMAX=4096)
c        externals
      integer lnblnk
c        local variables
      character*128 outfile
      integer dir,i,kropt,n,unit
      logical ok
      real*8 a(NMAX),dlnr,dlogr,k,kr,logkc,logrc,logrmax,logrmin,
     *  mu,nc,q,r,rk
      real*8 wsave(2*NMAX+3*(NMAX/2)+19)
c
      print *,'test integral_0^inf r^(mu+1) exp(-r^2/2) J_mu(k r) k dr =
     * k^(mu+1) exp(-k^2/2)'
c--------reasonable choices of parameters
c        range of periodic interval
      logrmin=-4.d0
      logrmax=4.d0
c        number of points
      n=64
c        order of Bessel function
      mu=0.d0
c        bias exponent: q = 0 is unbiased
      q=0.d0
c        sensible approximate choice of k_c r_c
      kr=1.d0
c        tell fhti to change kr to low-ringing value
      kropt=3
c        forward transform
      dir=1
c--------choose parameters
  100 print *,'enter period range log10(r_min), log10(r_max) [',
     *  logrmin,',',logrmax,']'
      read (*,*,end=300,err=300) logrmin,logrmax
c        central point log10(r_c) of periodic interval
      logrc=(logrmin+logrmax)/2.d0
      print *,'central point of periodic interval at log10(r_c) =',logrc
      print *,'enter number of points [',n,']'
      read (*,*,end=300,err=300) n
      if (n.gt.NMAX) then
        print *,n,' exceeds declared maximum',NMAX
        goto 100
      endif
c        central index (1/2 integral if n is even)
      nc=dble(n+1)/2.d0
c        log spacing of points
      dlogr=(logrmax-logrmin)/n
      dlnr=dlogr*log(10.d0)
c        order mu of Bessel function
      print *,'enter order mu of Bessel function [',mu,']'
      read (*,*,end=300,err=300) mu
c        bias exponent q
      print *,'enter bias exponent q [',q,']'
      read (*,*,end=300,err=300) q
c        kr = k_c r_c
      print *,'enter kr = k_c r_c [',kr,']'
      read (*,*,end=300,err=300) kr
c--------r^(mu+1) exp(-r^2/2)
      do i=1,n
        r=10.d0**(logrc+(i-nc)*dlogr)
        a(i)=r**(mu+1.d0)*exp(-r**2/2.d0)
      enddo
c--------initialize FFTLog transform - note fhti resets kr
      call fhti(n,mu,q,dlnr,kr,kropt,wsave,ok)
      if (.not.ok) goto 100
      logkc=log10(kr)-logrc
      print *,'central point in k-space at log10(k_c) =',logkc
c        rk = r_c/k_c
      rk=10.d0**(logrc-logkc)
c--------transform
c     call fftl(n,a,rk,dir,wsave)
      call fht(n,a,dir,wsave)
c--------print/write result
      print *,'enter name of file to save transform [CR=screen]'
      read (*,'(a128)') outfile
      if (outfile.eq.' ') then
        unit=6
      else
        unit=7
        open (unit,file=outfile)
        rewind (unit)
      endif
      write (unit,'(3a24)') 'k    ','a(k)    ','k^(mu+1) exp(-k^2/2)'
      do i=1,n
        k=10.d0**(logkc+(i-nc)*dlogr)
        write (unit,'(3g24.16)') k,a(i),k**(mu+1.d0)*exp(-k**2/2.d0)
      enddo
      call flush(unit)
      if (outfile.ne.' ') then
        print *,'header +',n,' lines written to file ',
     *    outfile(1:lnblnk(outfile))
      endif
c--------end of test loop
      goto 100
  300 continue
      end
c

	implicit none

	!! Common arguments !! 

	integer   ndim, ncomp, mineval, maxeval, verbose, neval, fail
	real*8    epsrel, epsabs
	parameter (ndim = 5)
	parameter (ncomp = 1)
	parameter (mineval = 0)
	parameter (maxeval = 110000000)
	real*8    integral(ncomp), error(ncomp), prob(ncomp)

	!! VEGAS !!

	parameter (epsrel = 0.01)            !! Relative Error !! 
	parameter (epsabs = 0.0)      
	parameter (verbose = 0*8+0*4+0*2+0*1)
	integer   nstart, nincrease
	parameter (nstart = 4000)    
	parameter (nincrease = 700)

c-----------------------------------------------------------------------
      subroutine iylm(thmin,thmax,w,lmax1,nw,v)
      integer lmax1,nw
      real*10 thmin,thmax,w(nw)
c        work array (could be automatic if compiler supports it)
      real*10 v(lmax1)
c
c        parameters
      include 'pi.par'
c        data variables
      real*10 tiny
c        local (automatic) variables
      integer lm,lmx1,qphi
      real*10 ri,phi,zi,ci,si,ph,dph
c *
c * w_lm = integral from thmin to thmax Y_lm(th,0) sin th d th
c *
c * ISN'T THERE A FASTER WAY OF DOING THIS?
c * I can find an expansion in incomplete beta functions,
c * but the expansion is not much shorter, and not as pretty.
c *
c  Input: thmin, thmax = minimum, maximum polar angle in radians.
c         lmax1 = lmax+1 where lmax is maximum desired l of transform.
c         nw = [(lmax+1)*(lmax+2)]/2 .
c Output: w(lm) = integral from thmax to thmin Y_lm(th,0) d cos th .
c Work array: v should be dimensioned at least lmax1 .
c
      data tiny /1.e-30_10/
c
      do 120 lm=1,nw
        w(lm)=0._10
  120 continue
c        upper latitude term
      ri=0._10
      zi=1._10
      phi=0._10
      ph=0._10
      dph=-tiny
      if (thmin.eq.0._10.or.thmin.eq.PI) then
        si=0._10
        lmx1=1
      else
        si=sin(thmin)
        lmx1=lmax1
      endif
      ci=cos(thmin)
      call wlm(w,lmx1,1,nw,ri,phi,0,zi,ci,si,ph,dph,v)
c        lower latitude term
      dph=tiny
      if (thmax.eq.0._10.or.thmax.eq.PI) then
        si=0._10
        lmx1=1
      else
        si=sin(thmax)
        lmx1=lmax1
      endif
      ci=cos(thmax)
      call wlm(w,lmx1,1,nw,ri,phi,0,zi,ci,si,ph,dph,v)
c        longitude term
      ri=1._10
      zi=0._10
      ci=0._10
      si=1._10
      phi=tiny
      qphi=-1
      ph=PI-(thmin+thmax)/2._10
      dph=thmax-thmin
      call wlm(w,lmax1,1,nw,ri,phi,qphi,zi,ci,si,ph,dph,v)
      do 140 lm=1,nw
        w(lm)=w(lm)/tiny
  140 continue
      return
      end
c

    ! Modules used by cmbmain and other routines.

    !     Code for Anisotropies in the Microwave Background
    !     by Antony Lewis (http://cosmologist.info) and Anthony Challinor
    !     See readme.html for documentation.
    !
    !     Based on CMBFAST  by  Uros Seljak and Matias Zaldarriaga, itself based
    !     on Boltzmann code written by Edmund Bertschinger, Chung-Pei Ma and Paul Bode.
    !     Original CMBFAST copyright and disclaimer:
    !
    !     Copyright 1996 by Harvard-Smithsonian Center for Astrophysics and
    !     the Massachusetts Institute of Technology.  All rights reserved.
    !
    !     THIS SOFTWARE IS PROVIDED "AS IS", AND M.I.T. OR C.f.A. MAKE NO
    !     REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
    !     By way of example, but not limitation,
    !     M.I.T. AND C.f.A MAKE NO REPRESENTATIONS OR WARRANTIES OF
    !     MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT
    !     THE USE OF THE LICENSED SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE
    !     ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.
    !
    !     portions of this software are based on the COSMICS package of
    !     E. Bertschinger.  See the LICENSE file of the COSMICS distribution
    !     for restrictions on the modification and distribution of this software.


    module ModelParams
    use precision
    use Ranges
    use InitialPower
    use Reionization
    use Recombination
    use Errors

    implicit none
    public

    character(LEN=*), parameter :: version = 'Mar_13b'

    integer :: FeedbackLevel = 0 !if >0 print out useful information about the model

    logical, parameter :: DebugMsgs=.false. !Set to true to view progress and timing

    logical, parameter :: DebugEvolution = .false. !Set to true to do all the evolution for all k

    logical ::  do_bispectrum  = .false.
    logical, parameter :: hard_bispectrum = .false. ! e.g. warm inflation where delicate cancellations

    logical, parameter :: full_bessel_integration = .false. !(go into the tails when calculating the sources)

    integer, parameter :: Nu_int = 0, Nu_trunc=1, Nu_approx = 2, Nu_best = 3
    !For CAMBparams%MassiveNuMethod
    !Nu_int: always integrate distribution function
    !Nu_trunc: switch to expansion in velocity once non-relativistic
    !Nu_approx: approximate scheme - good for CMB, but not formally correct and no good for matter power
    !Nu_best: automatically use mixture which is fastest and most accurate

    integer, parameter :: max_Nu = 5 !Maximum number of neutrino species
    integer, parameter :: max_transfer_redshifts = 150
    integer, parameter :: fileio_unit = 13 !Any number not used elsewhere will do
    integer, parameter :: outCOBE=0, outNone=1

    integer :: max_bessels_l_index  = 1000000
    real(dl) :: max_bessels_etak = 1000000*2


    real(dl), parameter ::  OutputDenominator =twopi
    !When using outNone the output is l(l+1)Cl/OutputDenominator


    Type(Regions) :: TimeSteps


    type TransferParams
        logical     ::  high_precision
        integer     ::  num_redshifts
        real(dl)    ::  kmax         !these are acutally q values, but same as k for flat
        integer     ::  k_per_logint ! ..
        real(dl)    ::  redshifts(max_transfer_redshifts)
    end type TransferParams

    !other variables, options, derived variables, etc.

    integer, parameter :: NonLinear_none=0, NonLinear_Pk =1, NonLinear_Lens=2

    ! Main parameters type
    type CAMBparams

    logical   :: WantCls, WantTransfer
    logical   :: WantScalars, WantTensors, WantVectors
    logical   :: DoLensing
    logical   :: want_zstar, want_zdrag     !!JH for updated BAO likelihood.
    integer   :: NonLinear

    integer   :: Max_l, Max_l_tensor
    real(dl)  :: Max_eta_k, Max_eta_k_tensor
    ! _tensor settings only used in initialization,
    !Max_l and Max_eta_k are set to the tensor variables if only tensors requested

    real(dl)  :: omegab, omegac, omegav, omegan
    !Omega baryon, CDM, Lambda and massive neutrino
    real(dl)  :: H0,TCMB,yhe,Num_Nu_massless
    integer   :: Num_Nu_massive
    logical :: Nu_mass_splittings
    integer   :: Nu_mass_eigenstates  !1 for degenerate masses
    logical   :: same_neutrino_Neff !take fractional part to heat all eigenstates the same
    real(dl)  :: Nu_mass_degeneracies(max_nu)
    real(dl)  :: Nu_mass_fractions(max_nu)
    !The ratios of the masses

    integer   :: Scalar_initial_condition
    !must be one of the initial_xxx values defined in GaugeInterface

    integer   :: OutputNormalization
    !outNone, outCOBE, or C_OutputNormalization=1 if > 1

    logical   :: AccuratePolarization
    !Do you care about the accuracy of the polarization Cls?

    logical   :: AccurateBB
    !Do you care about BB accuracy (e.g. in lensing)

    !Reionization settings - used if Reion%Reionization=.true.
    logical   :: AccurateReionization
    !Do you care about pecent level accuracy on EE signal from reionization?

    integer   :: MassiveNuMethod

    type(InitialPowerParams) :: InitPower  !see power_tilt.f90 - you can change this
    type(ReionizationParams) :: Reion
    type(RecombinationParams):: Recomb
    type(TransferParams)     :: Transfer

    real(dl) ::  InitialConditionVector(1:10) !Allow up to 10 for future extensions
    !ignored unless Scalar_initial_condition == initial_vector

    logical OnlyTransfers !Don't use initial power spectrum data, instead get Delta_q_l array
    !If true, sigma_8 is not calculated either

    logical DerivedParameters !calculate various derived parameters  (ThermoDerivedParams)

    !Derived parameters, not set initially
    type(ReionizationHistory) :: ReionHist

    logical flat,closed,open
    real(dl) omegak
    real(dl) curv,r, Ksign !CP%r = 1/sqrt(|CP%curv|), CP%Ksign = 1,0 or -1
    real(dl) tau0,chi0 !time today and rofChi(CP%tau0/CP%r)

    end type CAMBparams

    type(CAMBparams) CP  !Global collection of parameters


    real(dl) scale !relative to CP%flat. e.g. for scaling lSamp%l sampling.

    logical ::call_again = .false.
    !if being called again with same parameters to get different thing


    !     grhom =kappa*a^2*rho_m0
    !     grhornomass=grhor*number of massless neutrino species
    !     taurst,taurend - time at start/end of recombination
    !     dtaurec - dtau during recombination
    !     adotrad - a(tau) in radiation era

    real(dl) grhom,grhog,grhor,grhob,grhoc,grhov,grhornomass,grhok
    real(dl) taurst,dtaurec,taurend, tau_maxvis,adotrad

    !Neutrinos
    real(dl) grhormass(max_nu)

    !     nu_masses=m_nu*c**2/(k_B*T_nu0)
    real(dl) :: nu_masses(max_nu)

    real(dl) akthom !sigma_T * (number density of protons now)
    real(dl) fHe !n_He_tot / n_H_tot
    real(dl) Nnow


    integer :: ThreadNum = 0
    !If zero assigned automatically, obviously only used if parallelised

    !Parameters for checking/changing overall accuracy
    !If HighAccuracyDefault=.false., the other parameters equal to 1 corresponds to ~0.3% scalar C_l accuracy
    !If HighAccuracyDefault=.true., the other parameters equal to 1 corresponds to ~0.1% scalar C_l accuracy (at L>600)
    logical :: HighAccuracyDefault = .false.

    real(dl) :: lSampleBoost=1._dl
    !Increase lSampleBoost to increase sampling in lSamp%l for Cl interpolation

    real(dl) :: AccuracyBoost =1._dl

    !Decrease step sizes, etc. by this parameter. Useful for checking accuracy.
    !Can also be used to improve speed significantly if less accuracy is required.
    !or improving accuracy for extreme models.
    !Note this does not increase lSamp%l sampling or massive neutrino q-sampling

    real(sp) :: lAccuracyBoost=1.
    !Boost number of multipoles integrated in Boltzman heirarchy

    integer, parameter :: lmin = 2
    !must be either 1 or 2

    real(dl), parameter :: OmegaKFlat = 5e-7_dl !Value at which to use flat code

    real(dl),parameter :: tol=1.0d-4 !Base tolerance for integrations

    !     used as parameter for spline - tells it to use 'natural' end values
    real(dl), parameter :: spl_large=1.e40_dl

    integer, parameter:: l0max=4000

    !     lmax is max possible number of l's evaluated
    integer, parameter :: lmax_arr = l0max

    character(LEN=1024) :: highL_unlensed_cl_template = 'HighLExtrapTemplate_lenspotentialCls.dat'
    !fiducial high-accuracy high-L C_L used for making small cosmology-independent numerical corrections
    !to lensing and C_L interpolation. Ideally close to models of interest, but dependence is weak.
    logical :: use_spline_template = .true.
    integer, parameter :: lmax_extrap_highl = 6000
    real(dl), allocatable :: highL_CL_template(:,:)

    integer, parameter :: derived_age=1, derived_zstar=2, derived_rstar=3, derived_thetastar=4,derived_zdrag=5, &
    derived_rdrag=6,derived_kD=7,derived_thetaD=8 , derived_zEQ =9, derived_thetaEQ=10 
    integer, parameter :: nthermo_derived = 10

    real(dl) ThermoDerivedParams(nthermo_derived)

    Type TBackgroundOutputs
        real(dl), pointer :: z_outputs(:) => null()
        real(dl), allocatable :: H(:), DA(:), rs_by_D_v(:)
    end Type TBackgroundOutputs

    Type(TBackgroundOutputs), save :: BackgroundOutputs

    contains


    subroutine CAMBParams_Set(P, error, DoReion)
    use constants
    type(CAMBparams), intent(in) :: P
    real(dl) GetOmegak, fractional_number, conv
    integer, optional :: error !Zero if OK
    logical, optional :: DoReion
    logical WantReion
    integer nu_i,actual_massless
    external GetOmegak
    real(dl), save :: last_tau0
    !Constants in SI units

    global_error_flag = 0

    if ((P%WantTensors .or. P%WantVectors).and. P%WantTransfer .and. .not. P%WantScalars) then
        call GlobalError( 'Cannot generate tensor C_l and transfer without scalar C_l',error_unsupported_params)
    end if

    if (present(error)) error = global_error_flag
    if (global_error_flag/=0) return

    if (present(DoReion)) then
        WantReion = DoReion
    else
        WantReion = .true.
    end if

    CP=P
    if (call_again) CP%DerivedParameters = .false.

    CP%Max_eta_k = max(CP%Max_eta_k,CP%Max_eta_k_tensor)

    if (CP%WantTransfer) then
        CP%WantScalars=.true.
        if (.not. CP%WantCls) then
            CP%AccuratePolarization = .false.
            CP%Reion%Reionization = .false.
        end if
    else
        CP%transfer%num_redshifts=0
    end if

    if (CP%Omegan == 0 .and. CP%Num_Nu_Massive /=0) then
        CP%Num_Nu_Massless = CP%Num_Nu_Massless + CP%Num_Nu_Massive
        CP%Num_Nu_Massive  = 0
    end if

    if (CP%Num_nu_massive > 0) then
        if (.not. CP%Nu_mass_splittings) then
            !Default totally degenerate masses
            CP%Nu_mass_eigenstates = 1
            CP%Nu_mass_degeneracies(1) = CP%Num_Nu_Massive
            CP%Nu_mass_fractions(1) = 1
        else
            if (CP%Nu_mass_degeneracies(1)==0) then
                CP%Nu_mass_degeneracies(1) = CP%Num_Nu_Massive
                CP%same_neutrino_Neff = .true.
            end if
            if (abs(sum(CP%Nu_mass_fractions(1:CP%Nu_mass_eigenstates))-1) > 1e-4) &
            stop 'Nu_mass_fractions do not add up to 1'

            !                 if (abs(sum(CP%Nu_mass_degeneracies(1:CP%Nu_mass_eigenstates))-CP%Num_nu_massive) >1e-4 ) &
            !                   stop 'nu_mass_eigenstates do not add up to num_nu_massive'
            if (CP%Nu_mass_eigenstates==0) stop 'Have Num_nu_massive>0 but no nu_mass_eigenstates'

        end if
    else
        CP%Nu_mass_eigenstates = 0
    end if

    if ((CP%WantTransfer).and. CP%MassiveNuMethod==Nu_approx) then
        CP%MassiveNuMethod = Nu_trunc
    end if

    CP%omegak = GetOmegak()

    CP%flat = (abs(CP%omegak) <= OmegaKFlat)
    CP%closed = CP%omegak < -OmegaKFlat

    CP%open = .not.CP%flat.and..not.CP%closed
    if (CP%flat) then
        CP%curv=0
        CP%Ksign=0
        CP%r=1._dl !so we can use tau/CP%r, etc, where CP%r's cancel
    else
        CP%curv=-CP%omegak/((c/1000)/CP%h0)**2
        CP%Ksign =sign(1._dl,CP%curv)
        CP%r=1._dl/sqrt(abs(CP%curv))
    end if
    !  grho gives the contribution to the expansion rate from: (g) photons,
    !  (r) one flavor of relativistic neutrino (2 degrees of freedom),
    !  (m) nonrelativistic matter (for Omega=1).  grho is actually
    !  8*pi*G*rho/c^2 at a=1, with units of Mpc**(-2).
    !  a=tau(Mpc)*adotrad, with a=1 today, assuming 3 neutrinos.
    !  (Used only to set the initial conformal time.)

    !H0 is in km/s/Mpc

    grhom = 3*CP%h0**2/c**2*1000**2 !3*h0^2/c^2 (=8*pi*G*rho_crit/c^2)

    !grhom=3.3379d-11*h0*h0
    grhog = kappa/c**2*4*sigma_boltz/c**3*CP%tcmb**4*Mpc**2 !8*pi*G/c^2*4*sigma_B/c^3 T^4
    ! grhog=1.4952d-13*tcmb**4
    grhor = 7._dl/8*(4._dl/11)**(4._dl/3)*grhog !7/8*(4/11)^(4/3)*grhog (per neutrino species)
    !grhor=3.3957d-14*tcmb**4
    !correction for fractional number of neutrinos, e.g. 3.04 to give slightly higher T_nu hence rhor
    !Num_Nu_massive is already integer, Num_Nu_massless can contain fraction
    !We assume all eigenstates affected the same way

    !With mass splitting=True, the Nu_mass_degeneracies parameters account for heating from grhor
    !Otherwise we set from Neff
    if (CP%same_neutrino_Neff) then
        fractional_number = CP%Num_Nu_massless + CP%Num_Nu_massive
        actual_massless = int(CP%Num_Nu_massless + 1e-6_dl)
        if (actual_massless + CP%Num_Nu_massive /= 0) then
            grhor = grhor * fractional_number/(actual_massless + CP%Num_Nu_massive)
            grhornomass=grhor*actual_massless
        else
            grhornomass=grhor*CP%Num_Nu_massless
        end if
    else
        grhornomass=grhor*CP%Num_Nu_massless
    end if
    grhormass=0
    do nu_i = 1, CP%Nu_mass_eigenstates
        grhormass(nu_i)=grhor*CP%Nu_mass_degeneracies(nu_i)
    end do
    grhoc=grhom*CP%omegac
    grhob=grhom*CP%omegab
    grhov=grhom*CP%omegav
    grhok=grhom*CP%omegak
    !  adotrad gives the relation a(tau) in the radiation era:
    adotrad = sqrt((grhog+grhornomass+sum(grhormass(1:CP%Nu_mass_eigenstates)))/3)


    Nnow = CP%omegab*(1-CP%yhe)*grhom*c**2/kappa/m_H/Mpc**2

    akthom = sigma_thomson*Nnow*Mpc
    !sigma_T * (number density of protons now)

    fHe = CP%YHe/(mass_ratio_He_H*(1.d0-CP%YHe))  !n_He_tot / n_H_tot

    if (CP%omegan==0) then
        CP%Num_nu_massless = CP%Num_nu_massless + CP%Num_nu_massive
        CP%Num_nu_massive = 0
    end if

    if (.not.call_again) then

    call init_massive_nu(CP%omegan /=0)
    call init_background
    if (global_error_flag==0) then
        CP%tau0=TimeOfz(0._dl)
        ! print *, 'chi = ',  (CP%tau0 - TimeOfz(0.15_dl)) * CP%h0/100
        last_tau0=CP%tau0
        if (WantReion) call Reionization_Init(CP%Reion,CP%ReionHist, CP%YHe, akthom, CP%tau0, FeedbackLevel)
    end if
    else
        CP%tau0=last_tau0
    end if

    if ( CP%NonLinear==NonLinear_Lens) then
        CP%Transfer%kmax = max(CP%Transfer%kmax, CP%Max_eta_k/CP%tau0)
        if (FeedbackLevel > 0 .and. CP%Transfer%kmax== CP%Max_eta_k/CP%tau0) &
        write (*,*) 'max_eta_k changed to ', CP%Max_eta_k
    end if

    if (CP%closed .and. CP%tau0/CP%r >3.14) then
        call GlobalError('chi >= pi in closed model not supported',error_unsupported_params)
    end if

    if (global_error_flag/=0) then
        if (present(error)) error = global_error_flag
        return
    end if

    if (present(error)) then
        error = 0
    else if (FeedbackLevel > 0 .and. .not. call_again) then
        write(*,'("Om_b h^2             = ",f9.6)') CP%omegab*(CP%H0/100)**2
        write(*,'("Om_c h^2             = ",f9.6)') CP%omegac*(CP%H0/100)**2
        write(*,'("Om_nu h^2            = ",f9.6)') CP%omegan*(CP%H0/100)**2
        write(*,'("Om_Lambda            = ",f9.6)') CP%omegav
        write(*,'("Om_K                 = ",f9.6)') CP%omegak
        write(*,'("Om_m (1-Om_K-Om_L)   = ",f9.6)') 1-CP%omegak-CP%omegav
        write(*,'("100 theta (CosmoMC)  = ",f9.6)') 100*CosmomcTheta()
        if (CP%Num_Nu_Massive > 0) then
            conv = k_B*(8*grhor/grhog/7)**0.25*CP%tcmb/eV !approx 1.68e-4
            do nu_i=1, CP%Nu_mass_eigenstates
                write(*,'(f7.4, " nu, m_nu*c^2/k_B/T_nu0   = ",f9.2," (m_nu = ",f6.3," eV)")') &
                CP%nu_mass_degeneracies(nu_i), nu_masses(nu_i),conv*nu_masses(nu_i)
            end do
        end if
    end if
    CP%chi0=rofChi(CP%tau0/CP%r)
    scale= CP%chi0*CP%r/CP%tau0  !e.g. change l sampling depending on approx peak spacing

    end subroutine CAMBParams_Set


    function GetTestTime()
    real(sp) GetTestTime
    real(sp) atime

    !           GetTestTime = etime(tarray)
    !Can replace this if etime gives problems
    !Or just comment out - only used if DebugMsgs = .true.
    call cpu_time(atime)
    GetTestTime = atime

    end function GetTestTime


    function rofChi(Chi) !sinh(chi) for open, sin(chi) for closed.
    real(dl) Chi,rofChi

    if (CP%closed) then
        rofChi=sin(chi)
    else if (CP%open) then
        rofChi=sinh(chi)
    else
        rofChi=chi
    endif
    end function rofChi


    function cosfunc (Chi)
    real(dl) Chi,cosfunc

    if (CP%closed) then
        cosfunc= cos(chi)
    else if (CP%open) then
        cosfunc=cosh(chi)
    else
        cosfunc = 1._dl
    endif
    end function cosfunc

    function tanfunc(Chi)
    real(dl) Chi,tanfunc
    if (CP%closed) then
        tanfunc=tan(Chi)
    else if (CP%open) then
        tanfunc=tanh(Chi)
    else
        tanfunc=Chi
    end if

    end  function tanfunc

    function invsinfunc(x)
    real(dl) invsinfunc,x

    if (CP%closed) then
        invsinfunc=asin(x)
    else if (CP%open) then
        invsinfunc=log((x+sqrt(1._dl+x**2)))
    else
        invsinfunc = x
    endif
    end function invsinfunc

    function f_K(x)
    real(dl) :: f_K
    real(dl), intent(in) :: x
    f_K = CP%r*rofChi(x/CP%r)

    end function f_K


    function DeltaTime(a1,a2, in_tol)
    implicit none
    real(dl) DeltaTime, atol
    real(dl), intent(IN) :: a1,a2
    real(dl), optional, intent(in) :: in_tol
    real(dl) dtauda, rombint !diff of tau w.CP%r.t a and integration
    external dtauda, rombint

    if (present(in_tol)) then
        atol = in_tol
    else
        atol = tol/1000/exp(AccuracyBoost-1)
    end if
    DeltaTime=rombint(dtauda,a1,a2,atol)

    end function DeltaTime

    function TimeOfz(z)
    implicit none
    real(dl) TimeOfz
    real(dl), intent(IN) :: z

    TimeOfz=DeltaTime(0._dl,1._dl/(z+1._dl))
    end function TimeOfz

    function DeltaPhysicalTimeGyr(a1,a2, in_tol)
    use constants
    real(dl), intent(in) :: a1, a2
    real(dl), optional, intent(in) :: in_tol
    real(dl) rombint,DeltaPhysicalTimeGyr, atol
    external rombint

    if (present(in_tol)) then
        atol = in_tol
    else
        atol = 1d-4/exp(AccuracyBoost-1)
    end if
    DeltaPhysicalTimeGyr = rombint(dtda,a1,a2,atol)*Mpc/c/Gyr
    end function DeltaPhysicalTimeGyr

    function AngularDiameterDistance(z)
    !This is the physical (non-comoving) angular diameter distance in Mpc
    real(dl) AngularDiameterDistance
    real(dl), intent(in) :: z

    AngularDiameterDistance = CP%r/(1+z)*rofchi(ComovingRadialDistance(z) /CP%r)

    end function AngularDiameterDistance

    function LuminosityDistance(z)
    real(dl) LuminosityDistance
    real(dl), intent(in) :: z

    LuminosityDistance = AngularDiameterDistance(z)*(1+z)**2

    end function LuminosityDistance

    function ComovingRadialDistance(z) 
    real(dl) ComovingRadialDistance
    real(dl), intent(in) :: z

    ComovingRadialDistance = DeltaTime(1/(1+z),1._dl)

    end function ComovingRadialDistance

    function Hofz(z) 
    !!non-comoving Hubble in MPC units, divide by MPC_in_sec to get in SI units
    real(dl) Hofz, dtauda,a
    real(dl), intent(in) :: z
    external dtauda

    a = 1/(1+z)
    Hofz = 1/(a**2*dtauda(a))

    end function Hofz

    real(dl) function BAO_D_v_from_DA_H(z, DA, Hz)
    real(dl), intent(in) :: z, DA, Hz
    real(dl) ADD

    ADD = DA*(1.d0+z)
    BAO_D_v_from_DA_H = ((ADD)**2.d0*z/Hz)**(1.d0/3.d0)

    end function BAO_D_v_from_DA_H

    real(dl) function BAO_D_v(z)
    real(dl), intent(IN) :: z

    BAO_D_v = BAO_D_v_from_DA_H(z,AngularDiameterDistance(z), Hofz(z))

    end function BAO_D_v

    function dsound_da_exact(a)
    implicit none
    real(dl) dsound_da_exact,dtauda,a,R,cs
    external dtauda

    R = 3*grhob*a / (4*grhog) 
    cs=1.0d0/sqrt(3*(1+R))
    dsound_da_exact=dtauda(a)*cs

    end function dsound_da_exact


    function dsound_da(a)
    !approximate form used e.g. by CosmoMC for theta
    implicit none
    real(dl) dsound_da,dtauda,a,R,cs
    external dtauda

    R=3.0d4*a*CP%omegab*(CP%h0/100.0d0)**2
    !          R = 3*grhob*a / (4*grhog) //above is mostly within 0.2% and used for previous consistency
    cs=1.0d0/sqrt(3*(1+R))
    dsound_da=dtauda(a)*cs

    end function dsound_da

    function dtda(a)
    real(dl) dtda,dtauda,a
    external dtauda
    dtda= dtauda(a)*a
    end function

    function CosmomcTheta()
    real(dl) zstar, astar, atol, rs, DA
    real(dl) CosmomcTheta
    real(dl) ombh2, omdmh2
    real(dl) rombint
    external rombint

    ombh2 = CP%omegab*(CP%h0/100.0d0)**2
    omdmh2 = (CP%omegac+CP%omegan)*(CP%h0/100.0d0)**2

    !!From Hu & Sugiyama
    zstar =  1048*(1+0.00124*ombh2**(-0.738))*(1+ &
    (0.0783*ombh2**(-0.238)/(1+39.5*ombh2**0.763)) * &
    (omdmh2+ombh2)**(0.560/(1+21.1*ombh2**1.81)))

    astar = 1/(1+zstar)
    atol = 1e-6
    rs = rombint(dsound_da,1d-8,astar,atol)
    DA = AngularDiameterDistance(zstar)/astar
    CosmomcTheta = rs/DA
    !       print *,'z* = ',zstar, 'r_s = ',rs, 'DA = ',DA, rs/DA

    end function CosmomcTheta

    end module ModelParams



    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module lvalues
    use precision
    use ModelParams
    implicit none
    public

    Type lSamples
        integer l0
        integer l(lmax_arr)
    end Type lSamples

    Type(lSamples) :: lSamp

    contains


    subroutine initlval(lSet,max_l)

    ! This subroutines initializes lSet%l arrays. Other values will be interpolated.

    implicit none
    type(lSamples) :: lSet

    integer, intent(IN) :: max_l
    integer lind, lvar, step,top,bot,ls(lmax_arr)
    real(dl) AScale

    Ascale=scale/lSampleBoost

    if (lSampleBoost >=50) then
        !just do all of them
        lind=0
        do lvar=lmin, max_l
            lind=lind+1
            ls(lind)=lvar
        end do
        lSet%l0=lind
        lSet%l(1:lind) = ls(1:lind)
        return
    end if

    lind=0
    do lvar=lmin, 10
        lind=lind+1
        ls(lind)=lvar
    end do

    if (CP%AccurateReionization) then
        if (lSampleBoost > 1) then
            do lvar=11, 37,1
                lind=lind+1
                ls(lind)=lvar
            end do
        else
            do lvar=11, 37,2
                lind=lind+1
                ls(lind)=lvar
            end do
        end if

        step = max(nint(5*Ascale),2)
        bot=40
        top=bot + step*10
    else

    if (lSampleBoost >1) then
        do lvar=11, 15
            lind=lind+1
            ls(lind)=lvar
        end do
    else
        lind=lind+1
        ls(lind)=12
        lind=lind+1
        ls(lind)=15
    end if
    step = max(nint(10*Ascale),3)
    bot=15+max(step/2,2)
    top=bot + step*7
    end if

    do lvar=bot, top, step
        lind=lind+1
        ls(lind)=lvar
    end do

    step=max(nint(20*Ascale),4)
    bot=ls(lind)+step
    top=bot+step*2

    do lvar = bot,top,step
        lind=lind+1
        ls(lind)=lvar
    end do

    if (ls(lind)>=max_l) then
        do lvar=lind,1,-1
            if (ls(lvar)<=max_l) exit
        end do
        lind=lvar
        if (ls(lind)<max_l) then
            lind=lind+1
            ls(lind)=max_l
        end if
    else

    step=max(nint(25*Ascale),4)
    !Get EE right around l=200 by putting extra point at 175
    bot=ls(lind)+step
    top=bot+step

    do lvar = bot,top,step
        lind=lind+1
        ls(lind)=lvar
    end do


    if (ls(lind)>=max_l) then
        do lvar=lind,1,-1
            if (ls(lvar)<=max_l) exit
        end do
        lind=lvar
        if (ls(lind)<max_l) then
            lind=lind+1
            ls(lind)=max_l
        end if
    else

    if (HighAccuracyDefault .and. .not. use_spline_template) then
        step=max(nint(42*Ascale),7)
    else
        step=max(nint(50*Ascale),7)
    end if
    bot=ls(lind)+step
    top=min(5000,max_l)

    do lvar = bot,top,step
        lind=lind+1
        ls(lind)=lvar
    end do

    if (max_l > 5000) then
        !Should be pretty smooth or tiny out here
        step=max(nint(400*Ascale),50)
        lvar = ls(lind)

        do
            lvar = lvar + step
            if (lvar > max_l) exit
            lind=lind+1
            ls(lind)=lvar
            step = nint(step*1.5) !log spacing
        end do

    end if

    if (ls(lind) /=max_l) then
        lind=lind+1
        ls(lind)=max_l
    end if
    if (.not. CP%flat) ls(lind-1)=int(max_l+ls(lind-2))/2
    !Not in CP%flat case so interpolation table is the same when using lower l_max
    end if
    end if
    lSet%l0=lind
    lSet%l(1:lind) = ls(1:lind)

    end subroutine initlval

    subroutine InterpolateClArr(lSet,iCl, all_Cl, max_ind)
    type (lSamples), intent(in) :: lSet
    real(dl), intent(in) :: iCl(*)
    real(dl), intent(out):: all_Cl(lmin:*)
    integer, intent(in) :: max_ind
    integer il,llo,lhi, xi
    real(dl) ddCl(lSet%l0)
    real(dl) xl(lSet%l0)

    real(dl) a0,b0,ho
    real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl

    if (max_ind > lSet%l0) stop 'Wrong max_ind in InterpolateClArr'

    xl = real(lSet%l(1:lSet%l0),dl)
    call spline(xl,iCL(1),max_ind,cllo,clhi,ddCl(1))

    llo=1
    do il=lmin,lSet%l(max_ind)
        xi=il
        if ((xi > lSet%l(llo+1)).and.(llo < max_ind)) then
            llo=llo+1
        end if
        lhi=llo+1
        ho=lSet%l(lhi)-lSet%l(llo)
        a0=(lSet%l(lhi)-xi)/ho
        b0=(xi-lSet%l(llo))/ho

        all_Cl(il) = a0*iCl(llo)+ b0*iCl(lhi)+((a0**3-a0)* ddCl(llo) &
        +(b0**3-b0)*ddCl(lhi))*ho**2/6

    end do

    end subroutine InterpolateClArr

    subroutine InterpolateClArrTemplated(lSet,iCl, all_Cl, max_ind, template_index)
    type (lSamples), intent(in) :: lSet
    real(dl), intent(in) :: iCl(*)
    real(dl), intent(out):: all_Cl(lmin:*)
    integer, intent(in) :: max_ind
    integer, intent(in), optional :: template_index
    integer maxdelta, il
    real(dl) DeltaCL(lSet%l0)
    real(dl), allocatable :: tmpall(:)

    if (max_ind > lSet%l0) stop 'Wrong max_ind in InterpolateClArrTemplated'

    if (use_spline_template .and. present(template_index)) then
        if (template_index<=3) then
            !interpolate only the difference between the C_l and an accurately interpolated template. Temp only for the mo.
            !Using unlensed for template, seems to be good enough
            maxdelta=max_ind
            do while (lSet%l(maxdelta) > lmax_extrap_highl)
                maxdelta=maxdelta-1
            end do
            DeltaCL(1:maxdelta)=iCL(1:maxdelta)- highL_CL_template(lSet%l(1:maxdelta), template_index)

            call InterpolateClArr(lSet,DeltaCl, all_Cl, maxdelta)

            do il=lmin,lSet%l(maxdelta)
                all_Cl(il) = all_Cl(il) +  highL_CL_template(il,template_index)
            end do

            if (maxdelta < max_ind) then
                !directly interpolate high L where no template (doesn't effect lensing spectrum much anyway)
                allocate(tmpall(lmin:lSet%l(max_ind)))
                call InterpolateClArr(lSet,iCl, tmpall, max_ind)
                !overlap to reduce interpolation artefacts
                all_cl(lSet%l(maxdelta-2):lSet%l(max_ind) ) = tmpall(lSet%l(maxdelta-2):lSet%l(max_ind))
                deallocate(tmpall)
            end if
            return
        end if
    end if

    call InterpolateClArr(lSet,iCl, all_Cl, max_ind)


    end subroutine InterpolateClArrTemplated





    !ccccccccccccccccccccccccccc

    end module lvalues



    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module ModelData
    use precision
    use ModelParams
    use InitialPower
    use lValues
    use Ranges
    use AMlUtils
    implicit none
    public

    Type ClTransferData
        !Cl transfer function variables
        !values of q for integration over q to get C_ls
        Type (lSamples) :: ls ! scalar and tensor l that are computed
        integer :: NumSources
        !Changes -scalars:  2 for just CMB, 3 for lensing
        !- tensors: T and E and phi (for lensing), and T, E, B respectively

        Type (Regions) :: q

        real(dl), dimension(:,:,:), pointer :: Delta_p_l_k => NULL()

    end Type ClTransferData

    Type(ClTransferData), save, target :: CTransScal, CTransTens, CTransVec

    !Computed output power spectra data

    integer, parameter :: C_Temp = 1, C_E = 2, C_Cross =3, C_Phi = 4, C_PhiTemp = 5, C_PhiE=6
    integer :: C_last = C_PhiE
    integer, parameter :: CT_Temp =1, CT_E = 2, CT_B = 3, CT_Cross=  4


    real(dl), dimension (:,:,:), allocatable :: Cl_scalar, Cl_tensor, Cl_vector
    !Indices are Cl_xxx( l , intial_power_index, Cl_type)
    !where Cl_type is one of the above constants

    !The following are set only if doing lensing
    integer lmax_lensed !Only accurate to rather less than this
    real(dl) , dimension (:,:,:), allocatable :: Cl_lensed
    !Cl_lensed(l, power_index, Cl_type) are the interpolated Cls

    real(dl), dimension (:), allocatable ::  COBElikelihoods,COBE_scales
    !Set by COBEnormalize if using outCOBE
    contains


    subroutine Init_ClTransfer(CTrans)
    !Need to set the Ranges array q before calling this
    Type(ClTransferData) :: CTrans
    integer st

    deallocate(CTrans%Delta_p_l_k, STAT = st)
    call Ranges_getArray(CTrans%q, .true.)

    allocate(CTrans%Delta_p_l_k(CTrans%NumSources,min(max_bessels_l_index,CTrans%ls%l0), CTrans%q%npoints))
    CTrans%Delta_p_l_k = 0


    end subroutine Init_ClTransfer


    subroutine Free_ClTransfer(CTrans)
    Type(ClTransferData) :: CTrans
    integer st

    deallocate(CTrans%Delta_p_l_k, STAT = st)
    nullify(CTrans%Delta_p_l_k)
    call Ranges_Free(CTrans%q)

    end subroutine Free_ClTransfer

    subroutine CheckLoadedHighLTemplate
    integer L
    real(dl) array(7)

    if (.not. allocated(highL_CL_template)) then
        allocate(highL_CL_template(lmin:lmax_extrap_highl, C_Temp:C_Phi))
        call OpenTxtFile(highL_unlensed_cl_template,fileio_unit)
        if (lmin==1) highL_CL_template(lmin,:)=0
        do
            read(fileio_unit,*, end=500) L , array
            if (L>lmax_extrap_highl) exit
            !  array = array * (2*l+1)/(4*pi) * 2*pi/(l*(l+1))
            highL_CL_template(L, C_Temp:C_E) =array(1:2)
            highL_CL_template(L, C_Cross) =array(4)
            highL_CL_template(L, C_Phi) =array(5)
        end do

500     close(fileio_unit)
    end if

    end subroutine CheckLoadedHighLTemplate



    subroutine Init_Cls

    call CheckLoadedHighLTemplate
    if (CP%WantScalars) then
        if (allocated(Cl_scalar)) deallocate(Cl_scalar)
        allocate(Cl_scalar(lmin:CP%Max_l, CP%InitPower%nn, C_Temp:C_last))
        Cl_scalar = 0
    end if

    if (CP%WantVectors) then
        if (allocated(Cl_vector)) deallocate(Cl_vector)
        allocate(Cl_vector(lmin:CP%Max_l, CP%InitPower%nn, CT_Temp:CT_Cross))
        Cl_vector = 0
    end if


    if (CP%WantTensors) then
        if (allocated(Cl_tensor)) deallocate(Cl_tensor)
        allocate(Cl_tensor(lmin:CP%Max_l_tensor, CP%InitPower%nn, CT_Temp:CT_Cross))
        Cl_tensor = 0
    end if

    end subroutine Init_Cls

    subroutine output_cl_files(ScalFile,TensFile, TotFile, LensFile, LensTotFile, factor)
    implicit none
    integer in,il
    character(LEN=*) ScalFile, TensFile, TotFile, LensFile, LensTotFile
    real(dl), intent(in), optional :: factor
    real(dl) fact
    integer last_C

    if (present(factor)) then
        fact = factor
    else
        fact =1
    end if

    if (CP%WantScalars .and. ScalFile /= '') then
        last_C=min(C_PhiTemp,C_last)
        open(unit=fileio_unit,file=ScalFile,form='formatted',status='replace')
        do in=1,CP%InitPower%nn
            do il=lmin,min(10000,CP%Max_l)
                write(fileio_unit,trim(numcat('(1I6,',last_C))//'E15.5)')il ,fact*Cl_scalar(il,in,C_Temp:last_C)
            end do
            do il=10100,CP%Max_l, 100
                write(fileio_unit,trim(numcat('(1E15.5,',last_C))//'E15.5)') real(il),&
                fact*Cl_scalar(il,in,C_Temp:last_C)
            end do
        end do
        close(fileio_unit)
    end if

    if (CP%WantTensors .and. TensFile /= '') then
        open(unit=fileio_unit,file=TensFile,form='formatted',status='replace')
        do in=1,CP%InitPower%nn
            do il=lmin,CP%Max_l_tensor
                write(fileio_unit,'(1I6,4E15.5)')il, fact*Cl_tensor(il, in, CT_Temp:CT_Cross)
            end do
        end do
        close(fileio_unit)
    end if

    if (CP%WantTensors .and. CP%WantScalars .and. TotFile /= '') then
        open(unit=fileio_unit,file=TotFile,form='formatted',status='replace')
        do in=1,CP%InitPower%nn
            do il=lmin,CP%Max_l_tensor

            write(fileio_unit,'(1I6,4E15.5)')il, fact*(Cl_scalar(il, in, C_Temp:C_E)+ Cl_tensor(il,in, C_Temp:C_E)), &
            fact*Cl_tensor(il,in, CT_B), fact*(Cl_scalar(il, in, C_Cross) + Cl_tensor(il, in, CT_Cross))
            end do
            do il=CP%Max_l_tensor+1,CP%Max_l
                write(fileio_unit,'(1I6,4E15.5)')il ,fact*Cl_scalar(il,in,C_Temp:C_E), 0._dl, fact*Cl_scalar(il,in,C_Cross)
            end do
        end do
        close(fileio_unit)
    end if

    if (CP%WantScalars .and. CP%DoLensing .and. LensFile /= '') then
        open(unit=fileio_unit,file=LensFile,form='formatted',status='replace')
        do in=1,CP%InitPower%nn
            do il=lmin, lmax_lensed
                write(fileio_unit,'(1I6,4E15.5)')il, fact*Cl_lensed(il, in, CT_Temp:CT_Cross)
            end do
        end do
        close(fileio_unit)
    end if


    if (CP%WantScalars .and. CP%WantTensors .and. CP%DoLensing .and. LensTotFile /= '') then
        open(unit=fileio_unit,file=LensTotFile,form='formatted',status='replace')
        do in=1,CP%InitPower%nn
            do il=lmin,min(CP%Max_l_tensor,lmax_lensed)
                write(fileio_unit,'(1I6,4E15.5)')il, fact*(Cl_lensed(il, in, CT_Temp:CT_Cross)+ Cl_tensor(il,in, CT_Temp:CT_Cross))
            end do
            do il=min(CP%Max_l_tensor,lmax_lensed)+1,lmax_lensed
                write(fileio_unit,'(1I6,4E15.5)')il, fact*Cl_lensed(il, in, CT_Temp:CT_Cross)
            end do
        end do

    end if
    end subroutine output_cl_files

    subroutine output_lens_pot_files(LensPotFile, factor)
    !Write out L TT EE BB TE PP PT PE where P is the lensing potential, all unlensed
    !This input supported by LensPix from 2010
    implicit none
    integer in,il
    real(dl), intent(in), optional :: factor
    real(dl) fact, scale, BB, TT, TE, EE
    character(LEN=*) LensPotFile
    !output file of dimensionless [l(l+1)]^2 C_phi_phi/2pi and [l(l+1)]^(3/2) C_phi_T/2pi
    !This is the format used by Planck_like but original LensPix uses scalar_output_file.

    !(Cl_scalar and scalar_output_file numbers are instead l^4 C_phi and l^3 C_phi
    ! - for historical reasons)

    if (present(factor)) then
        fact = factor
    else
        fact =1
    end if

    if (CP%WantScalars .and. CP%DoLensing .and. LensPotFile/='') then

    open(unit=fileio_unit,file=LensPotFile,form='formatted',status='replace')
    do in=1,CP%InitPower%nn
        do il=lmin,min(10000,CP%Max_l)

        TT = Cl_scalar(il, in, C_Temp)
        EE = Cl_scalar(il, in, C_E)
        TE = Cl_scalar(il, in, C_Cross)
        if (CP%WantTensors .and. il <= CP%Max_l_tensor) then
            TT= TT+Cl_tensor(il,in, CT_Temp)
            EE= EE+Cl_tensor(il,in, CT_E)
            TE= TE+Cl_tensor(il,in, CT_Cross)
            BB= Cl_tensor(il,in, CT_B)
        else
            BB=0
        end if
        scale = (real(il+1)/il)**2/OutputDenominator !Factor to go from old l^4 factor to new

        write(fileio_unit,'(1I6,7E15.5)') il , fact*TT, fact*EE, fact*BB, fact*TE, scale*Cl_scalar(il,in,C_Phi),&
        (real(il+1)/il)**1.5/OutputDenominator*sqrt(fact)*Cl_scalar(il,in,C_PhiTemp:C_PhiE)

        end do
        do il=10100,CP%Max_l, 100
            scale = (real(il+1)/il)**2/OutputDenominator
            write(fileio_unit,'(1E15.5,7E15.5)') real(il), fact*Cl_scalar(il,in,C_Temp:C_E),0.,fact*Cl_scalar(il,in,C_Cross), &
            scale*Cl_scalar(il,in,C_Phi),&
            (real(il+1)/il)**1.5/OutputDenominator*sqrt(fact)*Cl_scalar(il,in,C_PhiTemp:C_PhiE)
        end do
    end do
    close(fileio_unit)
    end if
    end subroutine output_lens_pot_files


    subroutine output_veccl_files(VecFile, factor)
    implicit none
    integer in,il
    character(LEN=*) VecFile
    real(dl), intent(in), optional :: factor
    real(dl) fact


    if (present(factor)) then
        fact = factor
    else
        fact =1
    end if


    if (CP%WantVectors .and. VecFile /= '') then
        open(unit=fileio_unit,file=VecFile,form='formatted',status='replace')
        do in=1,CP%InitPower%nn
            do il=lmin,CP%Max_l
                write(fileio_unit,'(1I5,4E15.5)')il, fact*Cl_vector(il, in, CT_Temp:CT_Cross)
            end do
        end do

        close(fileio_unit)
    end if

    end subroutine output_veccl_files


    subroutine output_COBElikelihood
    integer in
    do in=1, CP%InitPower%nn
        write(*,*)'COBE Likelihood relative to CP%flat=',COBElikelihoods(in)
    end do
    end  subroutine output_COBElikelihood


    subroutine NormalizeClsAtL(lnorm)
    implicit none
    integer, intent(IN) :: lnorm
    integer in
    real(dl) Norm

    do in=1,CP%InitPower%nn

    if (CP%WantScalars) then
        Norm=1/Cl_scalar(lnorm,in, C_Temp)
        Cl_scalar(lmin:CP%Max_l, in, C_Temp:C_Cross) = Cl_scalar(lmin:CP%Max_l, in, C_Temp:C_Cross) * Norm
    end if

    if (CP%WantTensors) then
        if (.not.CP%WantScalars) Norm = 1/Cl_tensor(lnorm,in, C_Temp)
        !Otherwise Norm already set correctly
        Cl_tensor(lmin:CP%Max_l_tensor, in, CT_Temp:CT_Cross) =  &
        Cl_tensor(lmin:CP%Max_l_tensor, in, CT_Temp:CT_Cross) * Norm
    end if
    end do

    end  subroutine NormalizeClsAtL

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    subroutine COBEnormalize
    use precision
    use ModelParams


    integer in
    real(dl) xlog10
    real(dl) c10, d1,d2,d3,d4,d5,d6,d7, xlogl, COBE_scale
    real(dl) x1, x2,x3,x4,x5,x6,x7,sy,s,sx,sxy,sxx,delt,d1pr,d1ppr
    real(dl) Ctot(lmin:20)


    if (allocated(COBElikelihoods)) deallocate(COBElikelihoods)
    if (allocated(COBE_scales)) deallocate(COBE_scales)
    allocate(COBElikelihoods(CP%InitPower%nn))
    allocate(COBE_scales(CP%InitPower%nn))



    xlog10=log(10._dl)


    ! COBE normalization
    ! fit the spectrum to a quadratic around C_10 with equal weights in logl

    do in=1,CP%InitPower%nn

    if (CP%WantTensors) then
        Ctot =  Cl_tensor(lmin:20, in, C_Temp)
    else
        Ctot = 0
    end if
    if (CP%WantScalars) then
        Ctot=Ctot + Cl_scalar(lmin:20, in, C_Temp)

    end if
    c10=Ctot(10)

    d1=(Ctot(3))/c10-1._dl
    d2=(Ctot(4))/c10-1._dl
    d3=(Ctot(6))/c10-1._dl
    d4=(Ctot(8))/c10-1._dl
    d5=(Ctot(12))/c10-1._dl
    d6=(Ctot(15))/c10-1._dl
    d7=(Ctot(20))/c10-1._dl


    x1=log(3._dl)/xlog10-1._dl
    x2=log(4._dl)/xlog10-1._dl
    x3=log(6._dl)/xlog10-1._dl
    x4=log(8._dl)/xlog10-1._dl
    x5=log(12._dl)/xlog10-1._dl
    x6=log(15._dl)/xlog10-1._dl
    x7=log(20._dl)/xlog10-1._dl
    sy=x1*d1+x2*d2+x3*d3+x4*d4+x5*d5+x6*d6+x7*d7
    s=x1*x1+x2*x2+x3*x3+x4*x4+x5*x5+x6*x6+x7*x7
    sx=x1**3+x2**3+x3**3+x4**3+x5**3+x6**3+x7**3
    sxy=x1**2*d1+x2**2*d2+x3**2*d3+x4**2*d4+ &
    x5**2*d5+x6**2*d6+x7**2*d7
    sxx=x1**4+x2**4+x3**4+x4**4+x5**4+x6**4+x7**4
    delt=s*sxx-sx*sx
    d1pr=(sxx*sy-sx*sxy)/delt
    d1ppr=2._dl*(s*sxy-sx*sy)/delt

    ! Bunn and White fitting formula
    c10=(0.64575d0+0.02282d0*d1pr+0.01391d0*d1pr*d1pr &
    -0.01819d0*d1ppr-0.00646d0*d1pr*d1ppr &
    +0.00103d0*d1ppr*d1ppr)/c10
    ! logl
    xlogl=-0.01669d0+1.19895d0*d1pr-0.83527d0*d1pr*d1pr &
    -0.43541d0*d1ppr-0.03421d0*d1pr*d1ppr &
    +0.01049d0*d1ppr*d1ppr
    ! write(*,*)'COBE Likelihood relative to CP%flat=',exp(xlogl)
    COBElikelihoods(in) = exp(xlogl)

    ! density power spectrum normalization;

    COBE_scale=c10/OutputDenominator*1.1d-9
    COBE_scales(in)=COBE_scale

    !!$!delta^2 = k^4*(tf)^2*ScalarPower(k,in)*COBE_scale where (tf) is output in the transfer function file
    !!$!delta^2 = 4*pi*k^3 P(k)


    ! C_l normalization; output l(l+1)C_l/twopi
    c10=c10*2.2d-9/fourpi

    if (CP%WantScalars) Cl_scalar(lmin:CP%Max_l, in, C_Temp:C_last) = &
    Cl_scalar(lmin:CP%Max_l, in, C_Temp:C_last)*c10
    if (CP%WantTensors) Cl_tensor(lmin:CP%Max_l_tensor, in, CT_Temp:CT_Cross) = &
    Cl_tensor(lmin:CP%Max_l_tensor, in, CT_Temp:CT_Cross)*c10

    end do !in
    end subroutine COBEnormalize

    subroutine ModelData_Free

    call Free_ClTransfer(CTransScal)
    call Free_ClTransfer(CTransVec)
    call Free_ClTransfer(CTransTens)
    if (allocated(Cl_vector)) deallocate(Cl_vector)
    if (allocated(Cl_tensor)) deallocate(Cl_tensor)
    if (allocated(Cl_scalar)) deallocate(Cl_scalar)
    if (allocated(Cl_lensed)) deallocate(Cl_lensed)
    if (allocated(COBElikelihoods)) deallocate(COBElikelihoods)
    if (allocated(COBE_scales)) deallocate(COBE_scales)

    end subroutine ModelData_Free

    end module ModelData


    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    module MassiveNu
    use precision
    use ModelParams
    implicit none
    private

    real(dl), parameter  :: const  = 7._dl/120*pi**4 ! 5.68219698_dl
    !const = int q^3 F(q) dq = 7/120*pi^4
    real(dl), parameter  :: const2 = 5._dl/7/pi**2   !0.072372274_dl
    real(dl), parameter  :: zeta3  = 1.2020569031595942853997_dl
    real(dl), parameter  :: zeta5  = 1.0369277551433699263313_dl
    real(dl), parameter  :: zeta7  = 1.0083492773819228268397_dl

    integer, parameter  :: nrhopn=2000
    real(dl), parameter :: am_min = 0.01_dl  !0.02_dl
    !smallest a*m_nu to integrate distribution function rather than using series
    real(dl), parameter :: am_max = 600._dl
    !max a*m_nu to integrate

    real(dl),parameter  :: am_minp=am_min*1.1
    real(dl), parameter :: am_maxp=am_max*0.9

    real(dl) dlnam

    real(dl), dimension(:), allocatable ::  r1,p1,dr1,dp1,ddr1

    !Sample for massive neutrino momentum
    !These settings appear to be OK for P_k accuate at 1e-3 level
    integer, parameter :: nqmax0=80 !maximum array size of q momentum samples
    real(dl) :: nu_q(nqmax0), nu_int_kernel(nqmax0)

    integer nqmax !actual number of q modes evolves

    public const,Nu_Init,Nu_background, Nu_rho, Nu_drho,  nqmax0, nqmax, &
    nu_int_kernel, nu_q
    contains
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    subroutine Nu_init

    !  Initialize interpolation tables for massive neutrinos.
    !  Use cubic splines interpolation of log rhonu and pnu vs. log a*m.

    integer i
    real(dl) dq,dlfdlq, q, am, rhonu,pnu
    real(dl) spline_data(nrhopn)

    !  nu_masses=m_nu(i)*c**2/(k_B*T_nu0).
    !  Get number density n of neutrinos from
    !  rho_massless/n = int q^3/(1+e^q) / int q^2/(1+e^q)=7/180 pi^4/Zeta(3)
    !  then m = Omega_nu/N_nu rho_crit /n
    !  Error due to velocity < 1e-5

    do i=1, CP%Nu_mass_eigenstates
        nu_masses(i)=const/(1.5d0*zeta3)*grhom/grhor*CP%omegan*CP%Nu_mass_fractions(i) &
        /CP%Nu_mass_degeneracies(i)
    end do

    if (allocated(r1)) return
    allocate(r1(nrhopn),p1(nrhopn),dr1(nrhopn),dp1(nrhopn),ddr1(nrhopn))


    nqmax=3
    if (AccuracyBoost >1) nqmax=4
    if (AccuracyBoost >2) nqmax=5
    if (AccuracyBoost >3) nqmax=nint(AccuracyBoost*10)
    !note this may well be worse than the 5 optimized points

    if (nqmax > nqmax0) call MpiStop('Nu_Init: qmax > nqmax0')

    !We evolve evolve 4F_l/dlfdlq(i), so kernel includes dlfdlnq factor
    !Integration scheme gets (Fermi-Dirac thing)*q^n exact,for n=-4, -2..2
    !see CAMB notes
    if (nqmax==3) then
        !Accurate at 2e-4 level
        nu_q(1:3) = (/0.913201, 3.37517, 7.79184/)
        nu_int_kernel(1:3) = (/0.0687359, 3.31435, 2.29911/)

    else if (nqmax==4) then
        !This seems to be very accurate (limited by other numerics)
        nu_q(1:4) = (/0.7, 2.62814, 5.90428, 12.0/)
        nu_int_kernel(1:4) = (/0.0200251, 1.84539, 3.52736, 0.289427/)

    else if (nqmax==5) then
        !exact for n=-4,-2..3
        !This seems to be very accurate (limited by other numerics)
        nu_q(1:5) = (/0.583165, 2.0, 4.0, 7.26582, 13.0/)
        nu_int_kernel(1:5) = (/0.0081201, 0.689407, 2.8063, 2.05156, 0.126817/)

    else
        dq = (12 + nqmax/5)/real(nqmax)
        do i=1,nqmax
            q=(i-0.5d0)*dq
            nu_q(i) = q
            dlfdlq=-q/(1._dl+exp(-q))
            nu_int_kernel(i)=dq*q**3/(exp(q)+1._dl) * (-0.25_dl*dlfdlq) !now evolve 4F_l/dlfdlq(i)

        end do
    end if
    nu_int_kernel=nu_int_kernel/const

    dlnam=-(log(am_min/am_max))/(nrhopn-1)


    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC) &
    !$OMP & PRIVATE(am, rhonu,pnu)
    do i=1,nrhopn
        am=am_min*exp((i-1)*dlnam)
        call nuRhoPres(am,rhonu,pnu)
        r1(i)=log(rhonu)
        p1(i)=log(pnu)
    end do
    !$OMP END PARALLEL DO


    call splini(spline_data,nrhopn)
    call splder(r1,dr1,nrhopn,spline_data)
    call splder(p1,dp1,nrhopn,spline_data)
    call splder(dr1,ddr1,nrhopn,spline_data)


    end subroutine Nu_init

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine nuRhoPres(am,rhonu,pnu)
    !  Compute the density and pressure of one eigenstate of massive neutrinos,
    !  in units of the mean density of one flavor of massless neutrinos.

    real(dl),  parameter :: qmax=30._dl
    integer, parameter :: nq=100
    real(dl) dum1(nq+1),dum2(nq+1)
    real(dl), intent(in) :: am
    real(dl), intent(out) ::  rhonu,pnu
    integer i
    real(dl) q,aq,v,aqdn,adq


    !  q is the comoving momentum in units of k_B*T_nu0/c.
    !  Integrate up to qmax and then use asymptotic expansion for remainder.
    adq=qmax/nq
    dum1(1)=0._dl
    dum2(1)=0._dl
    do  i=1,nq
        q=i*adq
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        aqdn=adq*q*q*q/(exp(q)+1._dl)
        dum1(i+1)=aqdn/v
        dum2(i+1)=aqdn*v
    end do
    call splint(dum1,rhonu,nq+1)
    call splint(dum2,pnu,nq+1)
    !  Apply asymptotic corrrection for q>qmax and normalize by relativistic
    !  energy density.
    rhonu=(rhonu+dum1(nq+1)/adq)/const
    pnu=(pnu+dum2(nq+1)/adq)/const/3._dl

    end subroutine nuRhoPres

    !cccccccccccccccccccccccccccccccccccccccccc
    subroutine Nu_background(am,rhonu,pnu)
    use precision
    use ModelParams
    real(dl), intent(in) :: am
    real(dl), intent(out) :: rhonu, pnu

    !  Compute massive neutrino density and pressure in units of the mean
    !  density of one eigenstate of massless neutrinos.  Use cubic splines to
    !  interpolate from a table.

    real(dl) d
    integer i

    if (am <= am_minp) then
        rhonu=1._dl + const2*am**2
        pnu=(2-rhonu)/3._dl
        return
    else if (am >= am_maxp) then
        rhonu = 3/(2*const)*(zeta3*am + (15*zeta5)/2/am)
        pnu = 900._dl/120._dl/const*(zeta5-63._dl/4*Zeta7/am**2)/am
        return
    end if


    d=log(am/am_min)/dlnam+1._dl
    i=int(d)
    d=d-i

    !  Cubic spline interpolation.
    rhonu=r1(i)+d*(dr1(i)+d*(3._dl*(r1(i+1)-r1(i))-2._dl*dr1(i) &
    -dr1(i+1)+d*(dr1(i)+dr1(i+1)+2._dl*(r1(i)-r1(i+1)))))
    pnu=p1(i)+d*(dp1(i)+d*(3._dl*(p1(i+1)-p1(i))-2._dl*dp1(i) &
    -dp1(i+1)+d*(dp1(i)+dp1(i+1)+2._dl*(p1(i)-p1(i+1)))))
    rhonu=exp(rhonu)
    pnu=exp(pnu)

    end subroutine Nu_background

    !cccccccccccccccccccccccccccccccccccccccccc
    subroutine Nu_rho(am,rhonu)
    use precision
    use ModelParams
    real(dl), intent(in) :: am
    real(dl), intent(out) :: rhonu

    !  Compute massive neutrino density in units of the mean
    !  density of one eigenstate of massless neutrinos.  Use cubic splines to
    !  interpolate from a table.

    real(dl) d
    integer i

    if (am <= am_minp) then
        rhonu=1._dl + const2*am**2
        return
    else if (am >= am_maxp) then
        rhonu = 3/(2*const)*(zeta3*am + (15*zeta5)/2/am)
        return
    end if

    d=log(am/am_min)/dlnam+1._dl
    i=int(d)
    d=d-i

    !  Cubic spline interpolation.
    rhonu=r1(i)+d*(dr1(i)+d*(3._dl*(r1(i+1)-r1(i))-2._dl*dr1(i) &
    -dr1(i+1)+d*(dr1(i)+dr1(i+1)+2._dl*(r1(i)-r1(i+1)))))
    rhonu=exp(rhonu)
    end subroutine Nu_rho

    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    function Nu_drho(am,adotoa,rhonu) result (rhonudot)
    use precision
    use ModelParams

    !  Compute the time derivative of the mean density in massive neutrinos
    !  and the shear perturbation.
    real(dl) adotoa,rhonu,rhonudot
    real(dl) d
    real(dl), intent(IN) :: am
    integer i

    if (am< am_minp) then

    rhonudot = 2*const2*am**2*adotoa

    else if (am>am_maxp) then

    rhonudot = 3/(2*const)*(zeta3*am - (15*zeta5)/2/am)*adotoa

    else

    d=log(am/am_min)/dlnam+1._dl
    i=int(d)
    d=d-i
    !  Cubic spline interpolation for rhonudot.
    rhonudot=dr1(i)+d*(ddr1(i)+d*(3._dl*(dr1(i+1)-dr1(i)) &
    -2._dl*ddr1(i)-ddr1(i+1)+d*(ddr1(i)+ddr1(i+1) &
    +2._dl*(dr1(i)-dr1(i+1)))))

    rhonudot=rhonu*adotoa*rhonudot/dlnam
    end if

    end function Nu_drho

    end module MassiveNu

    ! wrapper function to avoid cirular module references
    subroutine init_massive_nu(has_massive_nu)
    use MassiveNu
    use ModelParams
    implicit none
    logical, intent(IN) :: has_massive_nu

    if (has_massive_nu) then
        call Nu_Init
    else
        nu_masses = 0
    end if
    end subroutine init_massive_nu


    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module Transfer
    use ModelData
    use Errors
    implicit none
    public
    integer, parameter :: Transfer_kh =1, Transfer_cdm=2,Transfer_b=3,Transfer_g=4, &
    Transfer_r=5, Transfer_nu = 6,  & !massless and massive neutrino
    Transfer_tot=7

    integer, parameter :: Transfer_max = Transfer_tot

    logical :: transfer_interp_matterpower  = .true. !output regular grid in log k
    !set to false to output calculated values for later interpolation

    integer :: transfer_power_var = Transfer_tot
    !What to use to calulcate the output matter power spectrum and sigma_8
    !Transfer_tot uses total matter perturbation

    Type MatterTransferData
        !Computed data
        integer   ::  num_q_trans   !    number of steps in k for transfer calculation
        real(dl), dimension (:), pointer :: q_trans => NULL()
        real(dl), dimension (:,:), pointer ::  sigma_8 => NULL()
        real, dimension(:,:,:), pointer :: TransferData => NULL()
        !TransferData(entry,k_index,z_index) for entry=Tranfer_kh.. Transfer_tot
    end Type MatterTransferData

    Type MatterPowerData
        !everything is a function of k/h
        integer   ::  num_k, num_z
        real(dl), dimension(:), pointer :: log_kh => NULL(), redshifts => NULL()
        !matpower is log(P_k)
        real(dl), dimension(:,:), allocatable :: matpower, ddmat 
        !if NonLinear, nonlin_ratio =  sqrt(P_nonlinear/P_linear)
        !function of k and redshift NonLinearScaling(k_index,z_index)
        real(dl), dimension(:,:), pointer :: nonlin_ratio => NULL()
    end Type MatterPowerData

    Type (MatterTransferData), save :: MT

    interface Transfer_GetMatterPower
    module procedure Transfer_GetMatterPowerD,Transfer_GetMatterPowerS
    end interface

    contains

    subroutine Transfer_GetMatterPowerData(MTrans, PK_data, in, itf_only)
    !Does *NOT* include non-linear corrections
    !Get total matter power spectrum in units of (h Mpc^{-1})^3 ready for interpolation.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
    !sepctrum is generated to beyond the CMB k_max
    Type(MatterTransferData), intent(in) :: MTrans
    Type(MatterPowerData) :: PK_data
    integer, intent(in) :: in
    integer, intent(in), optional :: itf_only
    real(dl) h, kh, k, power
    integer ik
    integer nz,itf, itf_start, itf_end

    if (present(itf_only)) then
        itf_start=itf_only
        itf_end = itf_only
        nz = 1
    else
        itf_start=1
        nz= size(MTrans%TransferData,3)
        itf_end = nz
    end if
    PK_data%num_k = MTrans%num_q_trans
    PK_Data%num_z = nz

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%nonlin_ratio(PK_data%num_k,nz))
    allocate(PK_data%log_kh(PK_data%num_k))
    allocate(PK_data%redshifts(nz))
    PK_data%redshifts = CP%Transfer%Redshifts(itf_start:itf_end)

    h = CP%H0/100

    do ik=1,MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,1)
        k = kh*h
        PK_data%log_kh(ik) = log(kh)
        power = ScalarPower(k,in)
        if (global_error_flag/=0) then
            call MatterPowerdata_Free(PK_data)
            return
        end if
        do itf = 1, nz
            PK_data%matpower(ik,itf) = &
            log(MTrans%TransferData(transfer_power_var,ik,itf_start+itf-1)**2*k &
            *pi*twopi*h**3*power)
        end do
    end do

    call MatterPowerdata_getsplines(PK_data)

    end subroutine Transfer_GetMatterPowerData

    subroutine MatterPowerData_Load(PK_data,fname)
    !Loads in kh, P_k from file for one redshiftr and one initial power spectrum
    !Not redshift is not stored in file, so not set correctly
    !Also note that output _matterpower file is already interpolated, so re-interpolating is probs not a good idea

    !Get total matter power spectrum in units of (h Mpc^{-1})^3 ready for interpolation.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    use AmlUtils
    character(LEN=*) :: fname
    Type(MatterPowerData) :: PK_data
    real(dl)kh, Pk
    integer ik
    integer nz


    nz = 1
    call openTxtFile(fname, fileio_unit)

    PK_data%num_k = FileLines(fileio_unit)
    PK_Data%num_z = 1

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%nonlin_ratio(PK_data%num_k,nz))
    allocate(PK_data%log_kh(PK_data%num_k))

    allocate(PK_data%redshifts(nz))
    PK_data%redshifts = 0

    do ik=1,PK_data%num_k
        read (fileio_unit,*) kh, Pk
        PK_data%matpower(ik,1) = log(Pk)
        PK_data%log_kh(ik) = log(kh)
    end do

    call MatterPowerdata_getsplines(PK_data)

    end subroutine MatterPowerData_Load


    subroutine MatterPowerdata_getsplines(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i
    real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl

    do i = 1,PK_Data%num_z

    call spline(PK_data%log_kh,PK_data%matpower(1,i),PK_data%num_k,&
    cllo,clhi,PK_data%ddmat(1,i))
    end do

    end subroutine MatterPowerdata_getsplines

    subroutine MatterPowerdata_MakeNonlinear(PK_data)
    Type(MatterPowerData) :: PK_data

    call NonLinear_GetRatios(PK_data)
    PK_data%matpower = PK_data%matpower +  2*log(PK_data%nonlin_ratio)
    call MatterPowerdata_getsplines(PK_data)

    end subroutine MatterPowerdata_MakeNonlinear

    subroutine MatterPowerdata_Free(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i

    deallocate(PK_data%log_kh,stat=i)
    deallocate(PK_data%matpower,stat=i)
    deallocate(PK_data%ddmat,stat=i)
    deallocate(PK_data%nonlin_ratio,stat=i)
    deallocate(PK_data%redshifts,stat=i)
    nullify(PK_data%log_kh, & !PK_data%matpower,PK_data%ddmat 
    PK_data%nonlin_ratio,PK_data%redshifts)

    end subroutine MatterPowerdata_Free

    function MatterPowerData_k(PK,  kh, itf) result(outpower)
    !Get matter power spectrum at particular k/h by interpolation
    Type(MatterPowerData) :: PK
    integer, intent(in) :: itf
    real (dl), intent(in) :: kh
    real(dl) :: logk
    integer llo,lhi
    real(dl) outpower, dp
    real(dl) ho,a0,b0
    integer, save :: i_last = 1

    logk = log(kh)
    if (logk < PK%log_kh(1)) then
        dp = (PK%matpower(2,itf) -  PK%matpower(1,itf)) / &
        ( PK%log_kh(2)-PK%log_kh(1) )
        outpower = PK%matpower(1,itf) + dp*(logk - PK%log_kh(1))
    else if (logk > PK%log_kh(PK%num_k)) then
        !Do dodgy linear extrapolation on assumption accuracy of result won't matter

        dp = (PK%matpower(PK%num_k,itf) -  PK%matpower(PK%num_k-1,itf)) / &
        ( PK%log_kh(PK%num_k)-PK%log_kh(PK%num_k-1) )
        outpower = PK%matpower(PK%num_k,itf) + dp*(logk - PK%log_kh(PK%num_k))
    else

    llo=min(i_last,PK%num_k)
    do while (PK%log_kh(llo) > logk)
        llo=llo-1
    end do
    do while (PK%log_kh(llo+1)< logk)
        llo=llo+1
    end do
    i_last =llo
    lhi=llo+1
    ho=PK%log_kh(lhi)-PK%log_kh(llo)
    a0=(PK%log_kh(lhi)-logk)/ho
    b0=1-a0

    outpower = a0*PK%matpower(llo,itf)+ b0*PK%matpower(lhi,itf)+&
    ((a0**3-a0)* PK%ddmat(llo,itf) &
    +(b0**3-b0)*PK%ddmat(lhi,itf))*ho**2/6

    end if

    outpower = exp(max(-30._dl,outpower))

    end function MatterPowerData_k

    subroutine Transfer_GetMatterPowerS(MTrans,outpower, itf, in, minkh, dlnkh, npoints)
    Type(MatterTransferData), intent(in) :: MTrans
    integer, intent(in) :: itf, in, npoints
    real, intent(out) :: outpower(*)
    real, intent(in) :: minkh, dlnkh
    real(dl) :: outpowerd(npoints)
    real(dl):: minkhd, dlnkhd

    minkhd = minkh; dlnkhd = dlnkh
    call Transfer_GetMatterPowerD(MTrans,outpowerd, itf, in, minkhd, dlnkhd, npoints)
    outpower(1:npoints) = outpowerd(1:npoints)

    end subroutine Transfer_GetMatterPowerS

    subroutine Transfer_GetMatterPowerD(MTrans,outpower, itf, in, minkh, dlnkh, npoints)
    !Allows for non-smooth priordial spectra
    !if CP%Nonlinear/ = NonLinear_none includes non-linear evolution
    !Get total matter power spectrum at logarithmically equal intervals dlnkh of k/h starting at minkh
    !in units of (h Mpc^{-1})^3.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
    !sepctrum is generated to beyond the CMB k_max
    Type(MatterTransferData), intent(in) :: MTrans
    Type(MatterPowerData) :: PK

    integer, intent(in) :: itf, in, npoints
    real(dl), intent(out) :: outpower(npoints)
    real(dl), intent(in) :: minkh, dlnkh
    real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl
    integer ik, llo,il,lhi,lastix
    real(dl) matpower(MTrans%num_q_trans), kh, kvals(MTrans%num_q_trans), ddmat(MTrans%num_q_trans)
    real(dl) atransfer,xi, a0, b0, ho, logmink,k, h


    if (npoints < 2) stop 'Need at least 2 points in Transfer_GetMatterPower'

    !         if (minkh < MTrans%TransferData(Transfer_kh,1,itf)) then
    !            stop 'Transfer_GetMatterPower: kh out of computed region'
    !          end if
    if (minkh*exp((npoints-1)*dlnkh) > MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf) &
    .and. FeedbackLevel > 0 ) &
    write(*,*) 'Warning: extrapolating matter power in Transfer_GetMatterPower'


    if (CP%NonLinear/=NonLinear_None) then
        call Transfer_GetMatterPowerData(MTrans, PK, in, itf)
        call NonLinear_GetRatios(PK)
    end if

    h = CP%H0/100
    logmink = log(minkh)
    do ik=1,MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,itf)
        k = kh*h
        kvals(ik) = log(kh)
        atransfer=MTrans%TransferData(transfer_power_var,ik,itf)
        if (CP%NonLinear/=NonLinear_None) &
        atransfer = atransfer* PK%nonlin_ratio(ik,1) !only one element, this itf
        matpower(ik) = log(atransfer**2*k*pi*twopi*h**3)
        !Put in power spectrum later: transfer functions should be smooth, initial power may not be
    end do

    call spline(kvals,matpower,MTrans%num_q_trans,cllo,clhi,ddmat)

    llo=1
    lastix = npoints + 1
    do il=1, npoints
        xi=logmink + dlnkh*(il-1)
        if (xi < kvals(1)) then
            outpower(il)=-30.
            cycle
        end if
        do while ((xi > kvals(llo+1)).and.(llo < MTrans%num_q_trans))
            llo=llo+1
            if (llo >= MTrans%num_q_trans) exit
        end do
        if (llo == MTrans%num_q_trans) then
            lastix = il
            exit
        end if
        lhi=llo+1
        ho=kvals(lhi)-kvals(llo)
        a0=(kvals(lhi)-xi)/ho
        b0=(xi-kvals(llo))/ho

        outpower(il) = a0*matpower(llo)+ b0*matpower(lhi)+((a0**3-a0)* ddmat(llo) &
        +(b0**3-b0)*ddmat(lhi))*ho**2/6

    end do

    do while (lastix <= npoints)
        !Do linear extrapolation in the log
        !Obviouly inaccurate, non-linear etc, but OK if only using in tails of window functions
        outpower(lastix) = 2*outpower(lastix-1) - outpower(lastix-2)
        lastix = lastix+1
    end do

    outpower = exp(max(-30.d0,outpower))

    do il = 1, npoints
        k = exp(logmink + dlnkh*(il-1))*h
        outpower(il) = outpower(il) * ScalarPower(k,in)
        if (global_error_flag /= 0) exit
    end do

    if (CP%NonLinear/=NonLinear_None) call MatterPowerdata_Free(PK)

    end subroutine Transfer_GetMatterPowerD

    subroutine Transfer_Get_sigma8(MTrans, sigr8)
    use MassiveNu
    Type(MatterTransferData) :: MTrans
    integer ik, itf, in
    real(dl) kh, k, h, x, win, delta
    real(dl) lnk, dlnk, lnko
    real(dl) dsig8, dsig8o, sig8, sig8o, powers
    real(dl), intent(IN) :: sigr8

    !Calculate MTrans%sigma_8^2 = int dk/k win**2 T_k**2 P(k), where win is the FT of a spherical top hat
    !of radius sigr8 h^{-1} Mpc

    if (global_error_flag /= 0) return

    H=CP%h0/100._dl
    do in = 1, CP%InitPower%nn
        do itf=1,CP%Transfer%num_redshifts
            lnko=0
            dsig8o=0
            sig8=0
            sig8o=0
            do ik=1, MTrans%num_q_trans
                kh = MTrans%TransferData(Transfer_kh,ik,itf)
                if (kh==0) cycle
                k = kh*H

                delta = k**2*MTrans%TransferData(transfer_power_var,ik,itf)
                !if (CP%NonLinear/=NonLinear_None) delta= delta* MTrans%NonLinearScaling(ik,itf)
                !sigma_8 defined "as though it were linear"

                x= kh *sigr8
                win =3*(sin(x)-x*cos(x))/x**3
                lnk=log(k)
                if (ik==1) then
                    dlnk=0.5_dl
                    !Approx for 2._dl/(CP%InitPower%an(in)+3)  [From int_0^k_1 dk/k k^4 P(k)]
                    !Contribution should be very small in any case
                else
                    dlnk=lnk-lnko
                end if
                powers = ScalarPower(k,in)
                dsig8=(win*delta)**2*powers
                sig8=sig8+(dsig8+dsig8o)*dlnk/2
                dsig8o=dsig8
                lnko=lnk


            end do

            MTrans%sigma_8(itf,in) = sqrt(sig8)
        end do
    end do

    end subroutine Transfer_Get_sigma8

    subroutine Transfer_output_Sig8(MTrans)
    Type(MatterTransferData), intent(in) :: MTrans

    integer in, j

    do in=1, CP%InitPower%nn
        if (CP%InitPower%nn>1)  write(*,*) 'Power spectrum : ', in
        do j = 1, CP%Transfer%num_redshifts
            write(*,*) 'at z = ',real(CP%Transfer%redshifts(j)), ' sigma8 (all matter)=', real(MTrans%sigma_8(j,in))
        end do
    end do

    end subroutine Transfer_output_Sig8


    subroutine Transfer_output_Sig8AndNorm(MTrans)
    Type(MatterTransferData), intent(in) :: MTrans
    integer in, j

    do in=1, CP%InitPower%nn
        write(*,*) 'Power spectrum ',in, ' COBE_scale = ',real(COBE_scales(in))
        do j = 1, CP%Transfer%num_redshifts
            write(*,*) 'at z = ',real(CP%Transfer%redshifts(j)), ' sigma8(all matter) = ', &
            real(MTrans%sigma_8(j,in)*sqrt(COBE_scales(in)))
        end do
    end do

    end subroutine Transfer_output_Sig8AndNorm


    subroutine Transfer_Allocate(MTrans)
    Type(MatterTransferData) :: MTrans
    integer st

    deallocate(MTrans%q_trans, STAT = st)
    deallocate(MTrans%TransferData, STAT = st)
    deallocate(MTrans%sigma_8, STAT = st)
    allocate(MTrans%q_trans(MTrans%num_q_trans))
    allocate(MTrans%TransferData(Transfer_max,MTrans%num_q_trans,CP%Transfer%num_redshifts))
    allocate(MTrans%sigma_8(CP%Transfer%num_redshifts, CP%InitPower%nn))

    end  subroutine Transfer_Allocate

    subroutine Transfer_Free(MTrans)
    Type(MatterTransferData):: MTrans
    integer st

    deallocate(MTrans%q_trans, STAT = st)
    deallocate(MTrans%TransferData, STAT = st)
    deallocate(MTrans%sigma_8, STAT = st)
    nullify(MTrans%q_trans)
    nullify(MTrans%TransferData)
    nullify(MTrans%sigma_8)

    end subroutine Transfer_Free

    subroutine Transfer_SetForNonlinearLensing(P)
    Type(TransferParams) :: P
    integer i
    real maxRedshift

    P%kmax = 5*AccuracyBoost
    P%k_per_logint  = 0
    maxRedshift = 10
    P%num_redshifts =  nint(10*AccuracyBoost)
    if (HighAccuracyDefault) then
        !only notionally more accuracy, more stable for RS
        maxRedshift =15
        P%num_redshifts = P%num_redshifts *3
    end if
    if (P%num_redshifts > max_transfer_redshifts) &
    stop 'Transfer_SetForNonlinearLensing: Too many redshifts'
    do i=1,P%num_redshifts
        P%redshifts(i) = real(P%num_redshifts-i)/(P%num_redshifts/maxRedshift)

    end do

    end subroutine Transfer_SetForNonlinearLensing



    subroutine Transfer_SaveToFiles(MTrans,FileNames)
    use IniFile
    Type(MatterTransferData), intent(in) :: MTrans
    integer i,ik
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)

    do i=1, CP%Transfer%num_redshifts
        if (FileNames(i) /= '') then
            open(unit=fileio_unit,file=FileNames(i),form='formatted',status='replace')
            do ik=1,MTrans%num_q_trans
                if (MTrans%TransferData(Transfer_kh,ik,i)/=0) then
                    write(fileio_unit,'(7E14.6)') MTrans%TransferData(Transfer_kh:Transfer_max,ik,i)
                end if
            end do
            close(fileio_unit)
        end if
    end do


    end subroutine Transfer_SaveToFiles

    subroutine Transfer_SaveMatterPower(MTrans, FileNames)
    use IniFile
    !Export files of total  matter power spectra in h^{-1} Mpc units, against k/h.
    Type(MatterTransferData), intent(in) :: MTrans
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)
    integer itf,in,i
    integer points
    real, dimension(:,:), allocatable :: outpower
    character(LEN=80) fmt
    real minkh,dlnkh
    Type(MatterPowerData) :: PK_data


    write (fmt,*) CP%InitPower%nn+1
    fmt = '('//trim(adjustl(fmt))//'E15.5)'
    do itf=1, CP%Transfer%num_redshifts
        if (FileNames(itf) /= '') then


        if (.not. transfer_interp_matterpower ) then

        points = MTrans%num_q_trans
        allocate(outpower(points,CP%InitPower%nn))

        do in = 1, CP%InitPower%nn

        call Transfer_GetMatterPowerData(MTrans, PK_data, in, itf)

        if (CP%NonLinear/=NonLinear_None) call MatterPowerdata_MakeNonlinear(PK_Data)

        outpower(:,in) = exp(PK_data%matpower(:,1))
        call MatterPowerdata_Free(PK_Data)
        end do

        open(unit=fileio_unit,file=FileNames(itf),form='formatted',status='replace')
        do i=1,points
            write (fileio_unit, fmt) MTrans%TransferData(Transfer_kh,i,1),outpower(i,1:CP%InitPower%nn)
        end do
        close(fileio_unit)

        else


        minkh = 1e-4
        dlnkh = 0.02
        points = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/dlnkh+1
        !             dlnkh = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/(points-0.999)
        allocate(outpower(points,CP%InitPower%nn))
        do in = 1, CP%InitPower%nn
            call Transfer_GetMatterPowerS(MTrans,outpower(1,in), itf, in, minkh,dlnkh, points)
            if (CP%OutputNormalization == outCOBE) then
                if (allocated(COBE_scales)) then
                    outpower(:,in) = outpower(:,in)*COBE_scales(in)
                else
                    if (FeedbackLevel>0) write (*,*) 'Cannot COBE normalize - no Cls generated'
                end if
            end if
        end do

        open(unit=fileio_unit,file=FileNames(itf),form='formatted',status='replace')
        do i=1,points
            write (fileio_unit, fmt) minkh*exp((i-1)*dlnkh),outpower(i,1:CP%InitPower%nn)
        end do
        close(fileio_unit)

        end if

        deallocate(outpower)

        end if
    end do

    end subroutine Transfer_SaveMatterPower

    end module Transfer


    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module ThermoData
    use ModelData
    implicit none
    private
    integer,parameter :: nthermo=20000

    real(dl) tb(nthermo),cs2(nthermo),xe(nthermo)
    real(dl) dcs2(nthermo)
    real(dl) dotmu(nthermo), ddotmu(nthermo)
    real(dl) sdotmu(nthermo),emmu(nthermo)
    real(dl) demmu(nthermo)
    real(dl) dddotmu(nthermo),ddddotmu(nthermo)
    real(dl) winlens(nthermo),dwinlens(nthermo), scalefactor(nthermo)
    real(dl) tauminn,dlntau,Maxtau
    real(dl), dimension(:), allocatable :: vis,dvis,ddvis,expmmu,dopac, opac, lenswin
    logical, parameter :: dowinlens = .false.

    real(dl) :: tight_tau, actual_opt_depth
    !Times when 1/(opacity*tau) = 0.01, for use switching tight coupling approximation
    real(dl) :: matter_verydom_tau
    real(dl) :: r_drag0, z_star, z_drag  !!JH for updated BAO likelihood.

    public thermo,inithermo,vis,opac,expmmu,dvis,dopac,ddvis,lenswin, tight_tau,&
    Thermo_OpacityToTime,matter_verydom_tau, ThermoData_Free,&
    z_star, z_drag  !!JH for updated BAO likelihood.
    contains

    subroutine thermo(tau,cs2b,opacity, dopacity)
    !Compute unperturbed sound speed squared,
    !and ionization fraction by interpolating pre-computed tables.
    !If requested also get time derivative of opacity
    implicit none
    real(dl) tau,cs2b,opacity
    real(dl), intent(out), optional :: dopacity

    integer i
    real(dl) d

    d=log(tau/tauminn)/dlntau+1._dl
    i=int(d)
    d=d-i
    if (i < 1) then
        !Linear interpolation if out of bounds (should not occur).
        cs2b=cs2(1)+(d+i-1)*dcs2(1)
        opacity=dotmu(1)+(d-1)*ddotmu(1)
        stop 'thermo out of bounds'
    else if (i >= nthermo) then
        cs2b=cs2(nthermo)+(d+i-nthermo)*dcs2(nthermo)
        opacity=dotmu(nthermo)+(d-nthermo)*ddotmu(nthermo)
        if (present(dopacity)) then
            dopacity = 0
            stop 'thermo: shouldn''t happen'
        end if
    else
        !Cubic spline interpolation.
        cs2b=cs2(i)+d*(dcs2(i)+d*(3*(cs2(i+1)-cs2(i))  &
        -2*dcs2(i)-dcs2(i+1)+d*(dcs2(i)+dcs2(i+1)  &
        +2*(cs2(i)-cs2(i+1)))))
        opacity=dotmu(i)+d*(ddotmu(i)+d*(3*(dotmu(i+1)-dotmu(i)) &
        -2*ddotmu(i)-ddotmu(i+1)+d*(ddotmu(i)+ddotmu(i+1) &
        +2*(dotmu(i)-dotmu(i+1)))))

        if (present(dopacity)) then

        dopacity=(ddotmu(i)+d*(dddotmu(i)+d*(3*(ddotmu(i+1)  &
        -ddotmu(i))-2*dddotmu(i)-dddotmu(i+1)+d*(dddotmu(i) &
        +dddotmu(i+1)+2*(ddotmu(i)-ddotmu(i+1))))))/(tau*dlntau)

        end if
    end if
    end subroutine thermo



    function Thermo_OpacityToTime(opacity)
    real(dl), intent(in) :: opacity
    integer j
    real(dl) Thermo_OpacityToTime
    !Do this the bad slow way for now..
    !The answer is approximate
    j =1
    do while(dotmu(j)> opacity)
        j=j+1
    end do

    Thermo_OpacityToTime = exp((j-1)*dlntau)*tauminn

    end function Thermo_OpacityToTime

    subroutine inithermo(taumin,taumax)
    !  Compute and save unperturbed baryon temperature and ionization fraction
    !  as a function of time.  With nthermo=10000, xe(tau) has a relative
    ! accuracy (numerical integration precision) better than 1.e-5.
    use constants
    use precision
    use ModelParams
    use MassiveNu
    real(dl) taumin,taumax


    real(dl) tau01,adot0,a0,a02,x1,x2,barssc,dtau
    real(dl) xe0,tau,a,a2
    real(dl) adot,tg0,ahalf,adothalf,fe,thomc,thomc0,etc,a2t
    real(dl) dtbdla,vfi,cf1,maxvis, vis
    integer ncount,i,j1,j2,iv,ns
    real(dl) spline_data(nthermo)
    real(dl) last_dotmu
    real(dl) dtauda  !diff of tau w.CP%r.t a and integration
    external dtauda
    real(dl) a_verydom
    real(dl) awin_lens1,awin_lens2,dwing_lens, rs, DA
    real(dl) rombint
    integer noutput
    external rombint

    call Recombination_Init(CP%Recomb, CP%omegac, CP%omegab,CP%Omegan, CP%Omegav, &
    CP%h0,CP%tcmb,CP%yhe,CP%Num_Nu_massless + CP%Num_Nu_massive)
    !almost all the time spent here
    if (global_error_flag/=0) return
    Maxtau=taumax
    tight_tau = 0
    actual_opt_depth = 0
    ncount=0
    z_star=0.d0
    z_drag=0.d0
    thomc0= Compton_CT * CP%tcmb**4
    r_drag0 = 3.d0/4.d0*CP%omegab*grhom/grhog
    !thomc0=5.0577d-8*CP%tcmb**4

    tauminn=0.05d0*taumin
    dlntau=log(CP%tau0/tauminn)/(nthermo-1)
    last_dotmu = 0

    matter_verydom_tau = 0
    a_verydom = AccuracyBoost*5*(grhog+grhornomass)/(grhoc+grhob)

    !  Initial conditions: assume radiation-dominated universe.
    tau01=tauminn
    adot0=adotrad
    a0=adotrad*tauminn
    a02=a0*a0
    !  Assume that any entropy generation occurs before tauminn.
    !  This gives wrong temperature before pair annihilation, but
    !  the error is harmless.
    tb(1)=CP%tcmb/a0
    xe0=1._dl
    x1=0._dl
    x2=1._dl
    xe(1)=xe0+0.25d0*CP%yhe/(1._dl-CP%yhe)*(x1+2*x2)
    barssc=barssc0*(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*xe(1))
    cs2(1)=4._dl/3._dl*barssc*tb(1)
    dotmu(1)=xe(1)*akthom/a02
    sdotmu(1)=0

    do i=2,nthermo
        tau=tauminn*exp((i-1)*dlntau)
        dtau=tau-tau01
        !  Integrate Friedmann equation using inverse trapezoidal rule.

        a=a0+adot0*dtau
        scaleFactor(i)=a
        a2=a*a

        adot=1/dtauda(a)

        if (matter_verydom_tau ==0 .and. a > a_verydom) then
            matter_verydom_tau = tau
        end if

        a=a0+2._dl*dtau/(1._dl/adot0+1._dl/adot)
        !  Baryon temperature evolution: adiabatic except for Thomson cooling.
        !  Use  quadrature solution.
        ! This is redundant as also calculated in REFCAST, but agrees well before reionization
        tg0=CP%tcmb/a0
        ahalf=0.5d0*(a0+a)
        adothalf=0.5d0*(adot0+adot)
        !  fe=number of free electrons divided by total number of free baryon
        !  particles (e+p+H+He).  Evaluate at timstep i-1 for convenience; if
        !  more accuracy is required (unlikely) then this can be iterated with
        !  the solution of the ionization equation.
        fe=(1._dl-CP%yhe)*xe(i-1)/(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*xe(i-1))
        thomc=thomc0*fe/adothalf/ahalf**3
        etc=exp(-thomc*(a-a0))
        a2t=a0*a0*(tb(i-1)-tg0)*etc-CP%tcmb/thomc*(1._dl-etc)
        tb(i)=CP%tcmb/a+a2t/(a*a)

        ! If there is re-ionization, smoothly increase xe to the
        ! requested value.
        if (CP%Reion%Reionization .and. tau > CP%ReionHist%tau_start) then
            if(ncount == 0) then
                ncount=i-1
            end if

            xe(i) = Reionization_xe(a, tau, xe(ncount))
            !print *,1/a-1,xe(i)
            if (CP%AccurateReionization .and. CP%DerivedParameters) then
                dotmu(i)=(Recombination_xe(a) - xe(i))*akthom/a2

                if (last_dotmu /=0) then
                    actual_opt_depth = actual_opt_depth - 2._dl*dtau/(1._dl/dotmu(i)+1._dl/last_dotmu)
                end if
                last_dotmu = dotmu(i)
            end if

        else
            xe(i)=Recombination_xe(a)
        end if


        !  Baryon sound speed squared (over c**2).
        dtbdla=-2._dl*tb(i)-thomc*adothalf/adot*(a*tb(i)-CP%tcmb)
        barssc=barssc0*(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*xe(i))
        cs2(i)=barssc*tb(i)*(1-dtbdla/tb(i)/3._dl)


        ! Calculation of the visibility function
        dotmu(i)=xe(i)*akthom/a2

        if (tight_tau==0 .and. 1/(tau*dotmu(i)) > 0.005) tight_tau = tau !0.005
        !Tight coupling switch time when k/opacity is smaller than 1/(tau*opacity)

        if (tau < 0.001) then
            sdotmu(i)=0
        else
            sdotmu(i)=sdotmu(i-1)+2._dl*dtau/(1._dl/dotmu(i)+1._dl/dotmu(i-1))
        end if

        a0=a
        tau01=tau
        adot0=adot
    end do !i

    if (CP%Reion%Reionization .and. (xe(nthermo) < 0.999d0)) then
        write(*,*)'Warning: xe at redshift zero is < 1'
        write(*,*) 'Check input parameters an Reionization_xe'
        write(*,*) 'function in the Reionization module'
    end if

    do j1=1,nthermo
        if (sdotmu(j1) - sdotmu(nthermo)< -69) then
            emmu(j1)=1.d-30
        else
            emmu(j1)=exp(sdotmu(j1)-sdotmu(nthermo))
            if (.not. CP%AccurateReionization .and. &
            actual_opt_depth==0 .and. xe(j1) < 1e-3) then
                actual_opt_depth = -sdotmu(j1)+sdotmu(nthermo)
            end if
            if (CP%AccurateReionization .and. CP%DerivedParameters .and. z_star==0.d0) then
                if (sdotmu(nthermo)-sdotmu(j1) - actual_opt_depth < 1) then
                    tau01=1-(sdotmu(nthermo)-sdotmu(j1) - actual_opt_depth)
                    tau01=tau01*(1._dl/dotmu(j1)+1._dl/dotmu(j1-1))/2
                    z_star = 1/(scaleFactor(j1)- tau01/dtauda(scaleFactor(j1))) -1
                end if
            end if
        end if
    end do

    if (CP%AccurateReionization .and. FeedbackLevel > 0 .and. CP%DerivedParameters) then
        write(*,'("Reion opt depth      = ",f7.4)') actual_opt_depth
    end if


    iv=0
    vfi=0._dl
    ! Getting the starting and finishing times for decoupling and time of maximum visibility
    if (ncount == 0) then
        cf1=1._dl
        ns=nthermo
    else
        cf1=exp(sdotmu(nthermo)-sdotmu(ncount))
        ns=ncount
    end if
    maxvis = 0
    do j1=1,ns
        vis = emmu(j1)*dotmu(j1)
        tau = tauminn*exp((j1-1)*dlntau)
        vfi=vfi+vis*cf1*dlntau*tau
        if ((iv == 0).and.(vfi > 1.0d-7/AccuracyBoost)) then
            taurst=9._dl/10._dl*tau
            iv=1
        elseif (iv == 1) then
            if (vis > maxvis) then
                maxvis=vis
                tau_maxvis = tau
            end if
            if (vfi > 0.995) then
                taurend=tau
                iv=2
                exit
            end if
        end if
    end do

    if (iv /= 2) then
        call GlobalError('inithermo: failed to find end of recombination',error_reionization)
        return
    end if

    if (dowinlens) then
        vfi=0
        awin_lens1=0
        awin_lens2=0
        winlens=0
        do j1=1,nthermo-1
            vis = emmu(j1)*dotmu(j1)
            tau = tauminn*exp((j1-1)*dlntau)
            vfi=vfi+vis*cf1*dlntau*tau
            if (vfi < 0.995) then
                dwing_lens =  vis*cf1*dlntau*tau / 0.995

                awin_lens1 = awin_lens1 + dwing_lens
                awin_lens2 = awin_lens2 + dwing_lens/(CP%tau0-tau)
            end if
            winlens(j1)= awin_lens1/(CP%tau0-tau) - awin_lens2
        end do
    end if

    ! Calculating the timesteps during recombination.

    if (CP%WantTensors) then
        dtaurec=min(dtaurec,taurst/160)/AccuracyBoost
    else
        dtaurec=min(dtaurec,taurst/40)/AccuracyBoost
        if (do_bispectrum .and. hard_bispectrum) dtaurec = dtaurec / 4
    end if

    if (CP%Reion%Reionization) taurend=min(taurend,CP%ReionHist%tau_start)

    if (DebugMsgs) then
        write (*,*) 'taurst, taurend = ', taurst, taurend
    end if

    call splini(spline_data,nthermo)
    call splder(cs2,dcs2,nthermo,spline_data)
    call splder(dotmu,ddotmu,nthermo,spline_data)
    call splder(ddotmu,dddotmu,nthermo,spline_data)
    call splder(dddotmu,ddddotmu,nthermo,spline_data)
    call splder(emmu,demmu,nthermo,spline_data)
    if (dowinlens) call splder(winlens,dwinlens,nthermo,spline_data)

    call SetTimeSteps

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do j2=1,TimeSteps%npoints
        call DoThermoSpline(j2,TimeSteps%points(j2))
    end do
    !$OMP END PARALLEL DO


    if ((CP%want_zstar .or. CP%DerivedParameters) .and. z_star==0.d0) call find_z(optdepth,z_star)
    if (CP%want_zdrag .or. CP%DerivedParameters) call find_z(dragoptdepth,z_drag)

    if (CP%DerivedParameters) then
        rs =rombint(dsound_da_exact,1d-8,1/(z_star+1),1d-6)
        DA = AngularDiameterDistance(z_star)/(1/(z_star+1))

        ThermoDerivedParams( derived_Age ) = DeltaPhysicalTimeGyr(0.0_dl,1.0_dl)
        ThermoDerivedParams( derived_zstar ) = z_star
        ThermoDerivedParams( derived_rstar ) = rs
        ThermoDerivedParams( derived_thetastar ) = 100*rs/DA
        ThermoDerivedParams( derived_zdrag ) = z_drag
        rs =rombint(dsound_da_exact,1d-8,1/(z_drag+1),1d-6)
        ThermoDerivedParams( derived_rdrag ) = rs
        ThermoDerivedParams( derived_kD ) =  sqrt(1.d0/(rombint(ddamping_da, 1d-8, 1/(z_star+1), 1d-6)/6))
        ThermoDerivedParams( derived_thetaD ) =  100*pi/ThermoDerivedParams( derived_kD )/DA
        ThermoDerivedParams( derived_zEQ ) = (grhob+grhoc)/(grhog+grhornomass+sum(grhormass(1:CP%Nu_mass_eigenstates))) -1
        ThermoDerivedParams( derived_thetaEQ ) = 100*timeOfz( ThermoDerivedParams( derived_zEQ ))/DA

        if (associated(BackgroundOutputs%z_outputs)) then
            if (allocated(BackgroundOutputs%H)) &
            deallocate(BackgroundOutputs%H, BackgroundOutputs%DA, BackgroundOutputs%rs_by_D_v)
            noutput = size(BackgroundOutputs%z_outputs)
            allocate(BackgroundOutputs%H(noutput), BackgroundOutputs%DA(noutput), BackgroundOutputs%rs_by_D_v(noutput))
            do i=1,noutput
                BackgroundOutputs%H(i) = HofZ(BackgroundOutputs%z_outputs(i))
                BackgroundOutputs%DA(i) = AngularDiameterDistance(BackgroundOutputs%z_outputs(i))
                BackgroundOutputs%rs_by_D_v(i) = rs/BAO_D_v_from_DA_H(BackgroundOutputs%z_outputs(i), &
                BackgroundOutputs%DA(i),BackgroundOutputs%H(i))
            end do
        end if

        if (FeedbackLevel > 0) then

        write(*,'("Age of universe/GYr  = ",f7.3)') ThermoDerivedParams( derived_Age )
        write(*,'("zstar                = ",f8.2)') ThermoDerivedParams( derived_zstar )
        write(*,'("r_s(zstar)/Mpc       = ",f7.2)') ThermoDerivedParams( derived_rstar )
        write(*,'("100*theta            = ",f9.6)') ThermoDerivedParams( derived_thetastar )

        write(*,'("zdrag                = ",f8.2)') ThermoDerivedParams( derived_zdrag )
        write(*,'("r_s(zdrag)/Mpc       = ",f7.2)') ThermoDerivedParams( derived_rdrag )

        write(*,'("k_D(zstar) Mpc       = ",f7.4)') ThermoDerivedParams( derived_kD )
        write(*,'("100*theta_D          = ",f9.6)') ThermoDerivedParams( derived_thetaD )

        write(*,'("z_EQ (if v_nu=1)     = ",f8.2)') ThermoDerivedParams( derived_zEQ )
        write(*,'("100*theta_EQ         = ",f9.6)') ThermoDerivedParams( derived_thetaEQ )
        end if
    end if

    end subroutine inithermo


    subroutine SetTimeSteps
    real(dl) dtau0
    integer nri0, nstep

    call Ranges_Init(TimeSteps)

    call Ranges_Add_delta(TimeSteps, taurst, taurend, dtaurec)

    ! Calculating the timesteps after recombination
    if (CP%WantTensors) then
        dtau0=max(taurst/40,Maxtau/2000._dl/AccuracyBoost)
    else
        dtau0=Maxtau/500._dl/AccuracyBoost
        if (do_bispectrum) dtau0 = dtau0/3
        !Don't need this since adding in Limber on small scales
        !  if (CP%DoLensing) dtau0=dtau0/2
        !  if (CP%AccurateBB) dtau0=dtau0/3 !Need to get C_Phi accurate on small scales
    end if

    call Ranges_Add_delta(TimeSteps,taurend, CP%tau0, dtau0)

    if (CP%Reion%Reionization) then

    nri0=int(Reionization_timesteps(CP%ReionHist)*AccuracyBoost)
    !Steps while reionization going from zero to maximum
    call Ranges_Add(TimeSteps,CP%ReionHist%tau_start,CP%ReionHist%tau_complete,nri0)

    end if

    !Create arrays out of the region information.
    call Ranges_GetArray(TimeSteps)
    nstep = TimeSteps%npoints

    if (allocated(vis)) then
        deallocate(vis,dvis,ddvis,expmmu,dopac, opac)
        if (dowinlens) deallocate(lenswin)
    end if
    allocate(vis(nstep),dvis(nstep),ddvis(nstep),expmmu(nstep),dopac(nstep),opac(nstep))
    if (dowinlens) allocate(lenswin(nstep))

    if (DebugMsgs .and. FeedbackLevel > 0) write(*,*) 'Set ',nstep, ' time steps'

    end subroutine SetTimeSteps


    subroutine ThermoData_Free
    if (allocated(vis)) then
        deallocate(vis,dvis,ddvis,expmmu,dopac, opac)
        if (dowinlens) deallocate(lenswin)
    end if
    call Ranges_Free(TimeSteps)

    end subroutine ThermoData_Free

    !cccccccccccccc
    subroutine DoThermoSpline(j2,tau)
    integer j2,i
    real(dl) d,ddopac,tau

    !     Cubic-spline interpolation.
    d=log(tau/tauminn)/dlntau+1._dl
    i=int(d)

    d=d-i
    if (i < nthermo) then
        opac(j2)=dotmu(i)+d*(ddotmu(i)+d*(3._dl*(dotmu(i+1)-dotmu(i)) &
        -2._dl*ddotmu(i)-ddotmu(i+1)+d*(ddotmu(i)+ddotmu(i+1) &
        +2._dl*(dotmu(i)-dotmu(i+1)))))
        dopac(j2)=(ddotmu(i)+d*(dddotmu(i)+d*(3._dl*(ddotmu(i+1)  &
        -ddotmu(i))-2._dl*dddotmu(i)-dddotmu(i+1)+d*(dddotmu(i) &
        +dddotmu(i+1)+2._dl*(ddotmu(i)-ddotmu(i+1))))))/(tau &
        *dlntau)
        ddopac=(dddotmu(i)+d*(ddddotmu(i)+d*(3._dl*(dddotmu(i+1) &
        -dddotmu(i))-2._dl*ddddotmu(i)-ddddotmu(i+1)  &
        +d*(ddddotmu(i)+ddddotmu(i+1)+2._dl*(dddotmu(i) &
        -dddotmu(i+1)))))-(dlntau**2)*tau*dopac(j2)) &
        /(tau*dlntau)**2
        expmmu(j2)=emmu(i)+d*(demmu(i)+d*(3._dl*(emmu(i+1)-emmu(i)) &
        -2._dl*demmu(i)-demmu(i+1)+d*(demmu(i)+demmu(i+1) &
        +2._dl*(emmu(i)-emmu(i+1)))))

        if (dowinlens) then
            lenswin(j2)=winlens(i)+d*(dwinlens(i)+d*(3._dl*(winlens(i+1)-winlens(i)) &
            -2._dl*dwinlens(i)-dwinlens(i+1)+d*(dwinlens(i)+dwinlens(i+1) &
            +2._dl*(winlens(i)-winlens(i+1)))))
        end if
        vis(j2)=opac(j2)*expmmu(j2)
        dvis(j2)=expmmu(j2)*(opac(j2)**2+dopac(j2))
        ddvis(j2)=expmmu(j2)*(opac(j2)**3+3*opac(j2)*dopac(j2)+ddopac)
    else
        opac(j2)=dotmu(nthermo)
        dopac(j2)=ddotmu(nthermo)
        ddopac=dddotmu(nthermo)
        expmmu(j2)=emmu(nthermo)
        vis(j2)=opac(j2)*expmmu(j2)
        dvis(j2)=expmmu(j2)*(opac(j2)**2+dopac(j2))
        ddvis(j2)=expmmu(j2)*(opac(j2)**3+3._dl*opac(j2)*dopac(j2)+ddopac)

    end if
    end subroutine DoThermoSpline


    function ddamping_da(a)
    real(dl) :: ddamping_da
    real(dl), intent(in) :: a
    real(dl) :: R
    real(dl) :: dtauda
    external dtauda

    R=r_drag0*a
    !ignoring reionisation, not relevant for distance measures
    ddamping_da = (R**2 + 16*(1+R)/15)/(1+R)**2*dtauda(a)*a**2/(Recombination_xe(a)*akthom)

    end function ddamping_da


    !!!!!!!!!!!!!!!!!!!
    !JH: functions and subroutines for calculating z_star and z_drag

    function doptdepth_dz(z)
    real(dl) :: doptdepth_dz
    real(dl), intent(in) :: z
    real(dl) :: a
    real(dl) :: dtauda
    external dtauda

    a = 1._dl/(1._dl+z)

    !ignoring reionisation, not relevant for distance measures
    doptdepth_dz = Recombination_xe(a)*akthom*dtauda(a)

    end function doptdepth_dz

    function optdepth(z)
    real(dl) :: rombint2
    external rombint2
    real(dl) optdepth
    real(dl),intent(in) :: z

    optdepth = rombint2(doptdepth_dz, 0.d0, z, 1d-5, 20, 100)

    end function optdepth


    function ddragoptdepth_dz(z)
    real(dl) :: ddragoptdepth_dz
    real(dl), intent(in) :: z
    real(dl) :: a
    real(dl) :: dtauda
    external dtauda

    a = 1._dl/(1._dl+z)
    ddragoptdepth_dz = doptdepth_dz(z)/r_drag0/a

    end function ddragoptdepth_dz


    function dragoptdepth(z)
    real(dl) :: rombint2
    external rombint2
    real(dl) dragoptdepth
    real(dl),intent(in) :: z

    dragoptdepth =  rombint2(ddragoptdepth_dz, 0.d0, z, 1d-5, 20, 100)

    end function dragoptdepth


    subroutine find_z(func,zout)  !find redshift at which (photon/drag) optical depth = 1
    real(dl), external :: func
    real(dl), intent(out) :: zout
    real(dl) :: try1,try2,diff,avg
    integer :: i

    try1 = 0.d0
    try2 = 10000.d0

    i=0
    diff = 10.d0
    do while (diff .gt. 1d-3)
        i=i+1
        if (i .eq. 100) then
            call GlobalError('optical depth redshift finder did not converge',error_reionization)
            zout=0
            return
        end if

        diff = func(try2)-func(try1)
        avg = 0.5d0*(try2+try1)
        if (func(avg) .gt. 1.d0) then
            try2 = avg
        else
            try1 = avg
        end if
    end do

    zout = avg

    end subroutine find_z

    !!!!!!!!!!!!!!!!!!! end JH

    end module ThermoData

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine garea(area,rp,cm,np,tol,verb,phi,iord,ldegen)
      integer np,verb
      logical ldegen
      real*10 area,rp(3,np),cm(np),tol
c        work arrays (could be automatic if compiler supports it)
      integer iord(2*np)
      real*10 phi(2,np)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        externals
      integer garpi,gsegij,gzeroar
c        data variables
      real*10 big
      real*10 dphmin
c        local variables
      integer i,iarea,ik,iseg,j,jm,jml,jmu,jp,jpl,jpu,k,km,kp,l,
     *  nbd,nbd0m,nbd0p,ni,nmult,retry,scmi
C     logical warn
      logical whole
      real*10 bik,cmi,cmik,cmk,d,darea,dph,ikchk,ikran,
     *  ph,phm,php,psi,si,tolin,xi(3),yi(3)
c *
c * Area of surface of sphere of unit radius bounded by
c *    1 - r.rp(i) < cm(i)  (if cm(i).ge.0)
c *    1 - r.rp(i) > -cm(i)  (if cm(i).lt.0)
c * for i=1,np where rp(i) are unit directions.
c * See AJSH notes Multfn C115.
c * Cautions:
c * (1) This subroutine underestimates the area by 2*pi
c *     if 2*pi <= area < 4*pi
c *     and the area is bounded by more than one arc.
c * (2) This subroutine will usually work correctly when there are near
c *     multiple (.ge. 3) intersections of boundaries, but in rare
c *     instances it may fail.  If so, it should flag the failure with
c *     ldegen=.true.  This error condition should NOT be ignored.
c *
c  Input: rp(3,i),i=1,np
c         cm(i),i=1,np
c         np
c         verb
c Output: area
c         ldegen = .true. means there's a problem with multiply
c                  intersecting boundary.
c Input/Output: tol
c Work arrays: phi and iord should be dimensioned at least 2*np
c
c        set azimuthal angle of non-intersection to big
      data big /1.e6_10/
c        possible multiple intersection when dph < dphmin
      data dphmin /1.e-8_10/
c
c        input tolerance to multiple intersections
      tolin=tol
C     print *,'--------------------'
c        come here with modified tolerance to multiple intersections
  100 continue
C     write (*,'(a3,a20,4a24)')
C    *  ' ','x','y','z',
c    *  'r',
C    *  '1-c'
C     do j=1,np
C       write (*,'(i3,5g24.16)')
C    *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
C    *    cm(j)
C     enddo
c        initialise error flag to no error
      ldegen=.false.
C     warn=.false.
c        initialize count of near multiple intersections to zero
      nmult=0
c        zero area
      area=0._10
c        check for zero area because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        no constraints at all will mean area is whole sphere
      whole=.true.
c        number of intersecting arc segments bounding area
      nbd=0
c        number of non-intersecting circles bounding area
      nbd0m=0
      nbd0p=0
c        error check on evaluation of vertex terms
      ikchk=0._10
c--------identify boundary segments around each circle i in turn
      do 280 i=1,np
c        cm(i).ge.2 means include whole sphere, which is no constraint
        if (cm(i).ge.2._10) goto 280
c        there is a constraint, so area is not whole sphere
        whole=.false.
c        scmi * cmi = 1-cos th(i)
        if (cm(i).ge.0._10) then
          scmi=1
        else
          scmi=-1
        endif
        cmi=abs(cm(i))
c        si = sin th(i)
        si=sqrt(cmi*(2._10-cmi))
c........construct cartesian axes with z-axis along rp(i)
        call gaxisi(rp(1,i),xi,yi)
c........angles phi about z-axis rp(i) of intersection of i & j circles
        call gphij(rp,cm,np,i,rp(1,i),scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside polygon
        if (ni.eq.-1) goto 280
c        area of polygon is zero
        if (ni.eq.-2) then
c        area can be non-zero from psi at multiple intersections
          area=0._10
          goto 410
        endif
c........i circle has no intersections
        if (ni.eq.0) then
          if (scmi.ge.0) then
            nbd0p=nbd0p+1
          else
            nbd0m=nbd0m+1
          endif
          darea=cm(i)*TWOPI
          area=area+darea
C         print *,'at',i,': full circle area +=',darea,' =',area
c........i circle has intersections
        elseif (ni.gt.0) then
c        find ordering of intersection angles around i circle
          call findbot(phi,2*np,iord,ni)
C         write (*,'("phi")')
C         write (*,'(i4,2g24.16)') (j,(phi(k,j),k=1,2),j=1,np)
c........contribution to area from each segment of i circle
          jpl=0
c        come here to do another segment
  220     continue
c........is segment edge of polygon?
            iseg=gsegij(rp,cm,np,0,0,i,rp(1,i),scmi,cmi,tol,ni,
     *        phi,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
C           print *,'at',i,': iseg =',iseg
c        error
            if (iseg.eq.-1) goto 420
c        not an edge
            if (iseg.eq.0) goto 220
c        gone full circle
            if (iseg.eq.2) goto 280
c        near multiple intersection
            if (dph.lt.dphmin) then
c        increment count of near multiple intersections
              nmult=nmult+1
C             warn=.true.
C             print *,
C    *          '*** warning from garea: near multiple intersection at',
C    *          i,': edge',km,kp,' dph =',dph
            endif
c........segment satisfies conditions
            nbd=nbd+1
c        there's a contribution to area from the segment...
            if (scmi.lt.0) dph=-dph
            darea=cmi*dph-dph
            area=area+darea
C           print *,'at',i,': edge',km,kp,
C    *       ' (',jm,' in',jml,jmu,',',jp,' in',jpl,jpu,' of',ni,')'
C           print *,'dph =',dph,' area +=',darea,' =',area
c        ...and from the end points of the segment
            do 240 l=1,2
c        end point is intersection of i circle with k circle
              if (l.eq.1) then
                k=km
              elseif (l.eq.2) then
                k=kp
              endif
c        only do ik intersection once,
c        but check both ik and ki intersections made it here
c        from segment k to segment i right-handedly through vertex
              if ((l.eq.1.and.scmi.ge.0).or.(l.eq.2.and.scmi.lt.0)) then
                ik=k+np*i
                if (k.lt.i) ik=ik+1
c        from segment i to segment k right-handedly through vertex
              else
                ik=i+np*k
                if (i.lt.k) ik=ik+1
              endif
c        pseudo-random number from ik
              call ikrand(ik,ikran)
              if (i.gt.k) then
c        ikchk = ikchk - ikran, subtracted as unsigned long long's
                call ikrandm(ikchk,ikran)
C               print *,'    (intersect',i,k,')'
                goto 240
              endif
c        ikchk = ikchk + ikran, added as unsigned long long's
              call ikrandp(ikchk,ikran)
              cmk=abs(cm(k))
c        cmik = 1-cos th(ik)
              cmik=((rp(1,i)-rp(1,k))**2+(rp(2,i)-rp(2,k))**2
     *          +(rp(3,i)-rp(3,k))**2)/2._10
c        bik = cik-ci*ck
c        d = 1-ci^2-ck^2-cik^2+2*ci*ck*cik
c        cos psi = bik/(si*sk)
c        sin psi = sqrt(d)/(si*sk)
c        psi = atan(sqrt(d)/bik) is exterior angle at intersection
              bik=(cmi+cmk)-cmi*cmk-cmik
              if ((scmi.ge.0.and.cm(k).lt.0._10)
     *          .or.(scmi.lt.0.and.cm(k).ge.0._10)) bik=-bik
c        i and k circles kiss
              if (phi(1,k).eq.phi(2,k)) then
                d=0._10
              else
                d=-(cmi-cmk)**2+cmik*(2._10*((cmi+cmk)-cmi*cmk)-cmik)
c        assert that circles at least touch
                if (d.lt.0._10) d=0._10
                d=sqrt(d)
              endif
              psi=atan2(d,bik)
              area=area-psi
C             print *,'     intersect',i,k,' area +=',-psi,' =',area
  240       continue
c        do another segment
          goto 220
        endif
  280 continue
c--------check on whether ik endpoints matched ki endpoints
      if (ikchk.ne.0._10) then
C       warn=.true.
C       print *,'*** from garea: at tol =',tol,
C    *    ', ikchk=',ikchk,' should be 0'
c       write (*,'(a3,a20,3a24)')
c    *    ' ','x','y','z','1-c'
c       write (*,'(i3,4g24.16)')
c    *    (j,(rp(i,j),i=1,3),
c    *    cm(j),j=1,np)
c        retry with modified tolerance
        call gtol(tol,tolin)
        goto 100
      elseif (tol.gt.0._10) then
C       print *,'... from garea: success at tol =',tol
      endif
c--------add/subtract 2*pi's to area
      retry=garpi(area,iarea,rp,cm,np,whole,nbd0m,nbd0p,nbd,nmult)
c        retry with modified tolerance
      if (retry.eq.1) then
C       warn=.true.
        call gtol(tol,tolin)
        goto 100
      endif
c--------done
  410 continue
C     if (warn) then
C       write (*,'(a3,a20,4a24)')
C    *    ' ','x','y','z',
c    *    'r',
C    *    '1-c'
C       do j=1,np
C         write (*,'(i3,5g24.16)')
C    *      j,(rp(i,j),i=1,3),
c    *      sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
C    *      cm(j)
C       enddo
C     endif
C     print *,'final area =',area
C     print *,'....................'
      return
c
  420 continue
c     if (verb.ge.1) then
        print *,'*** from garea: total failure at tol =',tol
        write (*,'(a3,a20,4a24)')
     *    ' ','x','y','z',
c    *    'r',
     *    '1-c'
        do j=1,np
          write (*,'(i3,5g24.16)')
     *      j,(rp(i,j),i=1,3),
c    *      sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *      cm(j)
        enddo
c     endif
C     print *,'....................'
      ldegen=.true.
      return
c
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine wlm(w,lmax1,im,nw,ri,phi,qphi,zi,ci,si,ph,dph,v)
      integer lmax1,im,nw,qphi
      real*10 w(im,nw),ri,phi,zi,ci,si,ph,dph,v(lmax1)
c
c        parameters
      real*10 HALF
      parameter (HALF=1._10/2._10)
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)

c largest non-overflowing 2^(DBL_MAX_EXP-1) for real*10 (from values.h)
      integer DBL_MAX_EXP
      parameter (DBL_MAX_EXP=1024)

c        intrinsics
      intrinsic abs,max
c        local variables
      integer l,lm,l1,m,mmax1,mmin1,mn,mn1,mq,m1,n,nmax1,n1
      integer ed,edm,edn,ee,eem,een,ez,ezn,iez
      real*10 al,al1,am,an,cm,cmp,cmphi,cnph,cp,
     *  d,dim,dm,dme,dn,dpe,dre,d0,d1,d2,e,ed0,em,en,e1,e2,fn,q,qq,q1,
     *  smphi,snph,t,z,zm,zn,zp
      real*10 OVFLOW,UNFLOW
c *
c * Calculates contribution to spherical transform w(lm)
c * by boundary segment of window function w=sum w(lm)*Y(l,m).
c * See AJSH Notes V2 210.
c *
c * Definition: z(l,m)*sqrt(2*l+1)*exp(i*m*phi)=Y(l,m) (m.ge.0).
c * d(l,m,n) is matrix for rotation about cone y-axis which takes
c * the north pole (=z-axis) to cone north pole.
c *
c * Underflow:
c * Is a pain!  It only matters when lmax is large,
c * and in most cases the underflow doesn't matter anway,
c * and it requires a pile of ugly coding.
c * But there are cases where it matters.
c *
c * Here's a quick argument for the Legendre polynomials.
c * z(n,n) is [sin(th)]^n up to a factor of order 1,
c * and can underflow if sin(th) is small and n is large.
c * z(l,n) is obtained by recursion from z(n,n),
c * and is `not small' for |sin(th)| > n/l
c * (the classically allowed regime),
c * so underflow causes z(l,n) to be underestimated when
c * l > n/|sin(th)| = n/[epsilon^(1/n)],
c * where epsilon is a number small enough to underflow.
c * The smallest l occurs when n = - ln(epsilon), whereat sin(th) = 1/e
c * and l = e n, with e = 2.718... being the exponential.
c * If epsilon = 2^-1023 = 1e-308,
c * then the smallest l occurs when n = 709, whereat l = 1928.
c *
c * Numerical experiment indicates that underflow sets in earlier
c * for the rotation matrix -- about l = 200, for sin(th) = 1/e.
c *
c  Input: lmax1 = lmax+1 where lmax is maximum desired l of transform.
c         im = 1 means compute real part of harmonics only;
c              2 means compute both real and imaginary parts.
c              Note a region has pure real harmonics if it has mirror
c              symmetry through x-z plane.
c         nw = [(lmax+1)*(lmax+2)]/2
c         ri,phi,zi = axis of segment cone in cylindrical coordinates.
c         qphi: use phi+qphi*pi/2 in place of phi,
c               for better precision near phi = integer*pi/2 .
c         ci,si = cos and sin of opening angle of segment cone.
c         ph = azimuthal angle of centre point of segment,
c              zero being such that rotation from z-axis to cone axis
c              is about cone's y-axis.
c         dph = azimuthal angle subtended by segment.
c Input/Output: w(i,lm) = spherical transform
c            w(i,lm), i=1,im, lm=l*(l+1)/2+m+1, l=0,lmax, m=0,l;
c            w(1,lm) is real part, w(2,lm) is imaginary part;
c            w(i,lm) is ADDED to input w(i,lm).
c         Note w(l,-m)=(-)^m*[Complex conjugate of w(l,m)], just as
c              Y(l,-m)=(-)^m*[Complex conjugate of Y(l,m)].
c Work array: v should be dimensioned at least lmax1
c
      if (lmax1.le.0) goto 300
      if (dph.eq.0._10) goto 300
c        largest non-overflowing power of 2 for real*10
      OVFLOW=2._10**(DBL_MAX_EXP-1)
      UNFLOW=1._10/OVFLOW
      z=OVFLOW*0._10
      if (z.ne.0._10.or.UNFLOW.eq.0._10) then
        print *,'*** from wlm: DBL_MAX_EXP on your machine appears to be
     * <',DBL_MAX_EXP
        print *,' please modify DBL_MAX_EXP in wlm.s.f in the mangle dir
     *ectory, and recompile;'
        print *,' DBL_MAX_EXP may be defined in float.h somewhere on you
     *r machine'
        stop
      endif
c        cm=(zi-1)/2; cp=(zi+1)/2
c        done this way to ensure accuracy at small ri
      cm=-((1._10-zi)**2+ri**2)/4._10
      cp=((1._10+zi)**2+ri**2)/4._10
      nmax1=lmax1
      if (dph.eq.TWOPI.or.dph.eq.-TWOPI) nmax1=1
      if (si.eq.0._10) nmax1=1
      mmin1=1
      mmax1=lmax1
      do 280 n1=1,nmax1
        n=n1-1
        an=n
c--------calculate spherical harmonics v(l,n) in cone frame
        do l1=n1,lmax1
          al1=l1
          l=l1-1
          al=l
c........l = n = 0
          if (n.eq.0) then
            if (l.eq.0) then
c        zn=z(0,0)
              zn=1._10/sqrt(2._10*TWOPI)
              ezn=0
              ez=ezn
              fn=dph
c        z=z(0,0); zp=z(1,0)
              z=zn
              zp=ci*z
c        v(0,0)
              v(l1)=-fn*zp
c........l > 0, n = 0
            elseif (l.gt.0) then
c        zm=z(l-1,0); z=z(l,0); zp=z(l+1,0)
              qq=al1+al
              zm=z
              z=zp
              zp=(qq*ci*z-al*zm)/al1
c        v(l,0)
              v(l1)=fn/sqrt(qq)*(zm-zp)
            endif
c........l = n > 0
          elseif (l.eq.n) then
c        zn=z(l,l)
            t=-sqrt((an-HALF)/an)*si
            z=t*zn
c        zn may underflow
            if (abs(z).le.UNFLOW) then
              zn=zn*OVFLOW
              z=t*zn
              ezn=ezn+1
            endif
            ez=ezn
            zn=z
            fn=2._10*sin(an*dph/2._10)/an
c        z=z(l,l); zp=z(l+1,l)
            q=sqrt(al1+al)
            zp=q*ci*z
c        v=v(l,l)
            v(l1)=-fn/al1*zp
c........l > n > 0
          elseif (l.gt.n) then
c        zm=z(l-1,n); z=z(l,n); zp=z(l+1,n)
            qq=al1+al
            q1=q
            q=sqrt((al1+an)*(al1-an))
            zm=z
            z=zp
            zp=(qq*ci*z-q1*zm)/q
            if (ez.gt.0) then
c        recover from underflow
              if (abs(zp).ge.1._10
     *          .and.(abs(z).ge.1._10.or.z.eq.0._10)
     *          .and.(abs(zm).ge.1._10.or.zm.eq.0._10)) then
                ez=ez-1
                zm=zm*UNFLOW
                z=z*UNFLOW
                zp=zp*UNFLOW
              endif
            endif
c        v=v(l,n)
            v(l1)=fn/sqrt(qq)*(q1/al*zm-q/al1*zp)
          endif
c........restore correct scaling
          if (ez.gt.0) then
            do iez=1,ez
              v(l1)=v(l1)*UNFLOW
            enddo
          endif
        enddo
c........skip rotation if harmonics in cone frame are all zero
        do l1=lmax1,n1,-1
          if (v(l1).ne.0._10) goto 220
        enddo
        goto 280
  220   continue
c--------matrix d(l,m,n) to rotate v(l,n) about cone y-axis
        cnph=cos(an*ph)
        snph=sin(an*ph)
c        cone axis is parallel to desired axis
        if (ri.eq.0._10) then
          mmin1=n1
          mmax1=n1
        endif
        do m1=mmin1,mmax1
          m=m1-1
          am=m
          cmphi=cos(am*phi)
          smphi=sin(am*phi)
          if (qphi.ne.0) then
            mq=m*qphi
            if (mod(mq/2,2).ne.0) then
              cmphi=-cmphi
              smphi=-smphi
            endif
            if (mod(mq,2).eq.1) then
              cmp=cmphi
              cmphi=-smphi
              smphi=cmp
            elseif (mod(mq,2).eq.-1) then
              cmp=cmphi
              cmphi=smphi
              smphi=-cmp
            endif
          endif
c........m = n = 0
          if (m.eq.0) then
            if (n.eq.0) then
c        d0=d(0,0,0)
              d0=1._10
              ed0=0
c        initialize dn, en
              dn=d0
              en=d0
              edn=ed0
              een=ed0
c........m = 0, n > 0
            elseif (n.gt.0) then
c        d0=d(n,0,n)=(-)^n*d(n,0,-n)
              t=sqrt((an-HALF)/an)*ri
              d=d0*t
c        d0 may underflow
              if (abs(d).le.UNFLOW) then
                d0=d0*OVFLOW
                d=d0*t
                ed0=ed0+1
              endif
              d0=d
            endif
c        initialize dm, em
            dm=d0
            em=d0
            edm=ed0
            eem=ed0
c........0 < m < n
          elseif (m.lt.n) then
c        dm=d(n,m,n); em=(-)^n*d(n,m,-n)
            t=sqrt((an-am+1._10)/(an+am))*2._10/ri
c        dm
            d=dm*cp*t
c        dm may underflow ...
            if (abs(d).le.UNFLOW.and.dm.ne.0._10) then
              dm=dm*OVFLOW
              d=dm*cp*t
              edm=edm+1
c        ... or may recover from underflow
            elseif (edm.gt.0) then
              if (abs(d).ge.1._10) then
                d=d*UNFLOW
                edm=edm-1
              endif
            endif
            dm=d
c        em
            e=em*cm*t
c        em may underflow ...
            if (abs(e).le.UNFLOW.and.em.ne.0._10) then
              em=em*OVFLOW
              e=em*cm*t
              eem=eem+1
c        ... or may recover from underflow
            elseif (eem.gt.0) then
              if (abs(e).ge.1._10) then
                e=e*UNFLOW
                eem=eem-1
              endif
            endif
            em=e
c........0 < m = n
          elseif (m.eq.n) then
c        dn=d(n,n,n); en=(-)^n*d(n,n,-n)
c        dn
            d=cp*dn
c        dn may underflow
            if (abs(d).le.UNFLOW.and.dn.ne.0._10) then
              dn=dn*OVFLOW
              d=cp*dn
              edn=edn+1
            endif
            dn=d
c        en
            e=cm*en
c        en may underflow
            if (abs(e).le.UNFLOW.and.en.ne.0._10) then
              en=en*OVFLOW
              e=cm*en
              een=een+1
            endif
            en=e
c        initialize dm, em
            dm=dn
            em=en
            edm=edn
            eem=een
c........m > n
          elseif (m.gt.n) then
c        dm=d(m,m,n); em=(-)^n*d(m,m,-n)
            t=-sqrt(am*(am-HALF)/((am+an)*(am-an)))*ri
c        dm
            d=t*dm
c        dm may underflow ...
            if (abs(d).le.UNFLOW.and.dm.ne.0._10) then
              dm=dm*OVFLOW
              d=t*dm
              edm=edm+1
c        ... or may recover from underflow
            elseif (edm.gt.0) then
              if (abs(d).ge.1._10) then
                d=d*UNFLOW
                edm=edm-1
              endif
            endif
            dm=d
c        em
            if (n.gt.0) then
              e=t*em
c        em may underflow ...
              if (abs(e).le.UNFLOW.and.em.ne.0._10) then
                em=em*OVFLOW
                e=t*em
                eem=eem+1
c        ... or may recover from underflow
              elseif (eem.gt.0) then
                if (abs(e).ge.1._10) then
                  e=e*UNFLOW
                  eem=eem-1
                endif
              endif
              em=e
            endif
          endif
c........l >= m, n
          mn=max(m,n)
          mn1=mn+1
          do 240 l1=mn1,lmax1
            l=l1-1
            al=l
c        d=d(l,m,n); e=(-)^n*d(l,m,-n)
            if (l.eq.mn) then
              lm=(l*l1)/2+m1
              q=0._10
              d1=0._10
              d=dm
              ed=edm
              if (n.eq.0) then
                e=0._10
                ee=0
              elseif (n.gt.0) then
                e1=0._10
                e=em
                ee=eem
              endif
            elseif (l.gt.mn) then
              lm=lm+l
              qq=2._10*al-1._10
              q1=q
              q=sqrt((al+am)*(al-am)*(al+an)*(al-an))/al
              t=0._10
              if (m*n.gt.0) t=am*an/((al-1._10)*al)
              d2=d1
              d1=d
              d=(qq*(zi-t)*d1-q1*d2)/q
c        recover d from underflow
              if (ed.gt.0) then
                if (abs(d).ge.1._10
     *            .and.(abs(d1).ge.1._10.or.e1_10.eq.0._10)
     *            .and.(abs(d2).ge.1._10.or.e2_10.eq.0._10)) then
                  d2=d2*UNFLOW
                  d1=d1*UNFLOW
                  d=d*UNFLOW
                  ed=ed-1
                endif
              endif
              if (n.gt.0) then
                e2=e1
                e1=e
                e=(qq*(zi+t)*e1-q1*e2)/q
c        recover e from underflow
                if (ee.gt.0) then
                  if (abs(e).ge.1._10
     *              .and.(abs(e1).ge.1._10.or.e1.eq.0._10)
     *              .and.(abs(e2).ge.1._10.or.e2.eq.0._10)) then
                    e2=e2*UNFLOW
                    e1=e1*UNFLOW
                    e=e*UNFLOW
                    ee=ee-1
                  endif
                endif
              endif
            endif
c--------rotate: w(l,m) = d(l,m,0)*v(l,0) +
c            sum (n=1,l) [d(l,m,n)*v(l,n) + d(l,m,-n)*v(l,-n)]
c           if ((l1.eq.lmax1.or.l1.eq.n1)
c    *        .and.(m1.eq.n1.or.m1.eq.1)) then
c             write (*,'("l m n = ",3i4," d(l,m,n) = ",
c    *          2g13.5,i3,"   (-)^n d(l,m,-n) = ",2g13.5,i3)')
c    *          l1-1,m1-1,n1-1,d,d*UNFLOW**ed,ed,e,e*UNFLOW**ee,ee
c           endif
            if (ed.eq.0) then
              if (ee.eq.0) then
                dpe=d+e
                dme=d-e
              else
                dpe=d
                dme=d
              endif
            else
              if (ee.eq.0) then
                dpe=e
                dme=-e
              else
                goto 240
              endif
            endif
            dre=cnph*dpe*v(l1)
            dim=snph*dme*v(l1)
            w(1,lm)=w(1,lm)+cmphi*dre-smphi*dim
            if (im.eq.2) w(2,lm)=w(2,lm)-cmphi*dim-smphi*dre
  240     continue
        enddo
  280 continue
c--------done
  300 continue
      return
      end
c

!Recombination module for CAMB, using RECFAST

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!C Integrator for Cosmic Recombination of Hydrogen and Helium,
!C developed by Douglas Scott (dscott@astro.ubc.ca)
!C based on calculations in the paper Seager, Sasselov & Scott
!C (ApJ, 523, L1, 1999).
!and "fudge" updates in Wong, Moss & Scott (2008).
!C
!C Permission to use, copy, modify and distribute without fee or royalty at
!C any tier, this software and its documentation, for any purpose and without
!C fee or royalty is hereby granted, provided that you agree to comply with
!C the following copyright notice and statements, including the disclaimer,
!C and that the same appear on ALL copies of the software and documentation,
!C including modifications that you make for internal use or for distribution:
!C
!C Copyright 1999-2010 by University of British Columbia.  All rights reserved.
!C
!C THIS SOFTWARE IS PROVIDED "AS IS", AND U.B.C. MAKES NO 
!C REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.  
!C BY WAY OF EXAMPLE, BUT NOT LIMITATION,
!c U.B.C. MAKES NO REPRESENTATIONS OR WARRANTIES OF 
!C MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT 
!C THE USE OF THE LICENSED SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE 
!C ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.   
!C
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
!CN     Name:        RECFAST
!CV     Version: 1.5.2
!C 
!CP     Purpose:  Calculate ionised fraction as a function of redshift.
!CP            Solves for H and He simultaneously, and includes
!CP           H "fudge factor" for low z effect, as well as
!CP           HeI fudge factor.
!C
!CD     Description: Solves for ionisation history since recombination
!CD     using the equations in Seager, Sasselov & Scott (ApJ, 1999).
!CD     The Cosmological model can be flat or open.
!CD	 The matter temperature is also followed, with an update from
!CD	 Scott & Scott (2009).
!CD	 The values for \alpha_B for H are from Hummer (1994).
!CD	 The singlet HeI coefficient is a fit from the full code.
!CD	 Additional He "fudge factors" are as described in Wong, Moss
!CD	 and Scott (2008).
!CD	 Extra fitting function included (in optical depth) to account
!CD	 for extra H physics described in Rubino-Martin et al. (2010).
!CD	 Care is taken to use the most accurate constants.
!C            
!CA     Arguments:
!CA     Name, Description
!CA     real(dl) throughout
!CA
!CA     z is redshift - W is sqrt(1+z), like conformal time
!CA     x is total ionised fraction, relative to H
!CA     x_H is ionized fraction of H - y(1) in R-K routine
!CA     x_He is ionized fraction of He - y(2) in R-K routine
!CA       (note that x_He=n_He+/n_He here and not n_He+/n_H)
!CA     Tmat is matter temperature - y(3) in R-K routine
!CA     f's are the derivatives of the Y's
!CA     alphaB is case B recombination rate
!CA     alpHe is the singlet only HeII recombination rate
!CA     a_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
!CA     b_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
!CA     c_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
!CA     d_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
!CA     a_VF is Verner and Ferland type fitting parameter for Helium
!CA     b_VF is Verner and Ferland type fitting parameter for Helium
!CA     T_0 is Verner and Ferland type fitting parameter for Helium
!CA     T_1 is Verner and Ferland type fitting parameter for Helium
!CA     Tnow is the observed CMB temperature today
!CA     Yp is the primordial helium abundace
!CA     fHe is He/H number ratio = Yp/4(1-Yp)
!CA     Trad and Tmat are radiation and matter temperatures
!CA	    epsilon is the approximate difference (=Trad-Tmat) at high z
!CA     OmegaB is Omega in baryons today
!CA     H is Hubble constant in units of 100 km/s/Mpc
!CA     HO is Hubble constant in SI units
!CA     bigH is 100 km/s/Mpc in SI units
!CA	    Hz is the value of H at the specific z (in ION)
!CA     G is grvitational constant
!CA     n is number density of hydrogen
!CA     Nnow is number density today
!CA     x0 is initial ionized fraction
!CA     x_H0 is initial ionized fraction of Hydrogen
!CA     x_He0 is initial ionized fraction of Helium
!CA     rhs is dummy for calculating x0
!CA     zinitial and zfinal are starting and ending redshifts
!CA     zeq is the redshift of matter-radiation equality
!CA     zstart and zend are for each pass to the integrator
!CA     C,k_B,h_P: speed of light, Boltzmann's and Planck's constants
!CA     m_e,m_H: electron mass and mass of H atom in SI
!CA     not4: ratio of 4He atomic mass to 1H atomic mass
!CA     sigma: Thomson cross-section
!CA     a_rad: radiation constant for u=aT^4
!CA     Lambda: 2s-1s two photon rate for Hydrogen
!CA     Lambda_He: 2s-1s two photon rate for Helium
!CA     DeltaB: energy of first excited state from continuum = 3.4eV
!CA     DeltaB_He: energy of first excited state from cont. for He = 3.4eV
!CA     L_H_ion: level for H ionization in m^-1
!CA     L_H_alpha: level for H Ly alpha in m^-1
!CA     L_He1_ion: level for HeI ionization
!CA     L_He2_ion: level for HeII ionization
!CA     L_He_2s: level for HeI 2s
!CA     L_He_2p: level for HeI 2p (21P1-11S0) in m^-1
!CA     Lalpha: Ly alpha wavelength in SI
!CA     Lalpha_He: Helium I 2p-1s wavelength in SI
!CA     mu_H,mu_T: mass per H atom and mass per particle
!CA     H_frac: follow Tmat when t_Compton / t_Hubble > H_frac
!CA     CDB=DeltaB/k_B                     Constants derived from B1,B2,R
!CA     CDB_He=DeltaB_He/k_B  n=2-infinity for He in Kelvin
!CA     CB1=CDB*4.         Lalpha and sigma_Th, calculated
!CA     CB1_He1: CB1 for HeI ionization potential
!CA     CB1_He2: CB1 for HeII ionization potential
!CA     CR=2*Pi*(m_e/h_P)*(k_B/h_P)  once and passed in a common block
!CA     CK=Lalpha**3/(8.*Pi)
!CA     CK_He=Lalpha_He**3/(8.*Pi)
!CA     CL=C*h_P/(k_B*Lalpha)
!CA     CL_He=C*h_P/(k_B*Lalpha_He)
!CA     CT=(8./3.)*(sigma/(m_e*C))*a
!CA     Bfact=exp((E_2p-E_2s)/kT)    Extra Boltzmann factor
!CA b_He= "fudge factor" for HeI, to approximate higher z behaviour
!CA Heswitch=integer for modifying HeI recombination
!CA Parameters and quantities to describe the extra triplet states
!CA  and also the continuum opacity of H, with a fitting function
!CA  suggested by KIV, astro-ph/0703438
!CA a_trip: used to fit HeI triplet recombination rate
!CA b_trip: used to fit HeI triplet recombination rate
!CA L_He_2Pt: level for 23P012-11S0 in m^-1
!CA L_He_2St: level for 23S1-11S0 in m^-1
!CA L_He2St_ion: level for 23S1-continuum in m^-1
!CA A2P_s: Einstein A coefficient for He 21P1-11S0
!CA A2P_t: Einstein A coefficient for He 23P1-11S0    
!CA sigma_He_2Ps: H ionization x-section at HeI 21P1-11S0 freq. in m^2
!CA sigma_He_2Pt: H ionization x-section at HeI 23P1-11S0 freq. in m^2
!CA CL_PSt = h_P*C*(L_He_2Pt - L_He_2st)/k_B
!CA CfHe_t: triplet statistical correction
!CA	Hswitch is an boolean for modifying the H recombination
!CA	AGauss1 is the amplitude of the 1st Gaussian for the H fudging
!CA	AGauss2 is the amplitude of the 2nd Gaussian for the H fudging
!CA	zGauss1 is the ln(1+z) central value of the 1st Gaussian
!CA	zGauss2 is the ln(1+z) central value of the 2nd Gaussian
!CA	wGauss1 is the width of the 1st Gaussian
!CA	wGauss2 is the width of the 2nd Gaussian


!CA     tol: tolerance for the integrator
!CA     cw(24),w(3,9): work space for DVERK
!CA     Ndim: number of d.e.'s to solve (integer)
!CA     Nz: number of output redshitf (integer)
!CA     I: loop index (integer)
!CA     ind,nw: work-space for DVERK (integer)
!C
!CF     File & device access:
!CF     Unit /I,IO,O  /Name (if known)
!C
!CM     Modules called:
!CM     DVERK (numerical integrator)
!CM     GET_INIT (initial values for ionization fractions)
!CM     ION (ionization and Temp derivatives)
!C
!CC     Comments:
!CC     none
!C
!CH     History:
!CH     CREATED            (simplest version) 19th March 1989
!CH     RECREATED    11th January 1995
!CH               includes variable Cosmology
!CH               uses DVERK integrator
!CH               initial conditions are Saha
!CH     TESTED              a bunch, well, OK, not really
!CH     MODIFIED     January 1995 (include Hummer's 1994 alpha table)
!CH               January 1995 (include new value for 2s-1s rate)
!CH               January 1995 (expand comments)
!CH               March 1995 (add Saha for Helium)
!CH               August 1997 (add HeII alpha table)
!CH               July 1998 (include OmegaT correction and H fudge factor)
!CH               Nov 1998 (change Trad to Tmat in Rup)
!CH               Jan 1999 (tidied up for public consumption)
!CH               Sept 1999 (switch to formula for alpha's, fix glitch)
!CH                  Sept 1999 modified to CMBFAST by US & MZ          
!CH                     Nov 1999 modified for F90 and CAMB (AML)
!CH                     Aug 2000 modified to prevent overflow erorr in He_Boltz (AML)
!CH                     Feb 2001 corrected fix of Aug 2000 (AML)
!CH                     Oct 2001 fixed error in hubble parameter, now uses global function (AML)
!                       March 2003 fixed bugs reported by savita gahlaut
!                       March 2005 added option for corrections from astro-ph/0501672.
!                                  thanks to V.K.Dubrovich, S.I.Grachev
!                       June 2006 defined RECFAST_fudge as free parameter (AML)
!                       October 2006 (included new value for G)
!                       October 2006 (improved m_He/m_H to be "not4")
!                       October 2006 (fixed error, x for x_H in part of f(1))
!CH              January 2008 (improved HeI recombination effects,
!CH                       including HeI rec. fudge factor)
!                Feb 2008   Recfast 1.4 changes above added (AML)
!                           removed Dubrovich option (wrong anyway)
!CH   			 Sept 2008 (added extra term to make transition, smoother for Tmat evolution)
!                Sept 2008 Recfast 1.4.2 changes above added (AML) 
!                          General recombination module structure, fix to make He x_e smooth also in recfast (AML)
!CH		 Jan 2010 (added fitting function to modify K
!CH			 	 to match x_e(z) for new H physics)
!AL             June 2012 updated fudge parameters to match HyRec and CosmoRec (AML)
!AL             Sept 2012 changes now in public recfast, version number changed to match Recfast 1.5.2.

!!      ===============================================================

       module RECDATA
        use constants
        implicit none
         

        real(dl) Lambda,DeltaB,DeltaB_He,Lalpha,mu_H,mu_T,H_frac
        real(dl) Lambda_He,Lalpha_He,Bfact,CK_He,CL_He
        real(dl) L_H_ion,L_H_alpha,L_He1_ion,L_He2_ion,L_He_2s,L_He_2p
        real(dl) CB1,CDB,CR,CK,CL,CT,CB1_He1,CB1_He2,CDB_He,fu
        real(dl) A2P_s,A2P_t,sigma_He_2Ps,sigma_He_2Pt
        real(dl)  L_He_2Pt,L_He_2St,L_He2St_ion


        real(dl), parameter :: bigH=100.0D3/Mpc !Ho in s-1
        real(dl), parameter :: sigma = sigma_thomson
        real(dl), parameter :: not4  = mass_ratio_He_H    !mass He/H atom

        real(dl) Tnow,HO
        integer :: n_eq = 3

!The following only used for approximations where small effect
       real(dl) OmegaK, OmegaT, z_eq


!Fundamental constants in SI units
!      ("not4" pointed out by Gary Steigman)

        data    Lambda      /8.2245809d0/
        data    Lambda_He   /51.3d0/    !new value from Dalgarno
        data    L_H_ion     /1.096787737D7/ !level for H ion. (in m^-1)
        data    L_H_alpha   /8.225916453D6/ !averaged over 2 levels
        data    L_He1_ion   /1.98310772D7/  !from Drake (1993)
        data    L_He2_ion   /4.389088863D7/ !from JPhysChemRefData (1987)
        data    L_He_2s     /1.66277434D7/  !from Drake (1993)
        data    L_He_2p     /1.71134891D7/  !from Drake (1993)
!   2 photon rates and atomic levels in SI units

        data    A2P_s       /1.798287D9/    !Morton, Wu & Drake (2006)
        data    A2P_t       /177.58D0/      !Lach & Pachuski (2001)
        data    L_He_2Pt    /1.690871466D7/ !Drake & Morton (2007)
        data    L_He_2St    /1.5985597526D7/ !Drake & Morton (2007)
        data    L_He2St_ion /3.8454693845D6/ !Drake & Morton (2007)
        data    sigma_He_2Ps    /1.436289D-22/  !Hummer & Storey (1998)
        data    sigma_He_2Pt    /1.484872D-22/  !Hummer & Storey (1998)
!    Atomic data for HeI 


       end module RECDATA


        module Recombination
        use constants
        use AMLUtils
        implicit none
        private

        real(dl), parameter ::  zinitial = 1e4_dl !highest redshift
        real(dl), parameter ::  zfinal=0._dl
        integer,  parameter :: Nz=10000  
        real(dl), parameter :: delta_z = (zinitial-zfinal)/Nz

        integer, parameter ::  RECFAST_Heswitch_default = 6
        real(dl), parameter :: RECFAST_fudge_He_default = 0.86_dl !Helium fudge parameter
        logical, parameter  :: RECFAST_Hswitch_default = .true. !include H corrections (v1.5, 2010)
        real(dl), parameter :: RECFAST_fudge_default = 1.14_dl !1.14_dl
        real(dl), parameter :: RECFAST_fudge_default2 = 1.105d0 + 0.02d0
              !fudge parameter if RECFAST_Hswitch
        
        real(dl) :: AGauss1 =      -0.14D0  !Amplitude of 1st Gaussian
        real(dl) :: AGauss2 =       0.079D0 ! 0.05D0  !Amplitude of 2nd Gaussian
        real(dl) :: zGauss1 =       7.28D0  !ln(1+z) of 1st Gaussian
        real(dl) :: zGauss2=        6.73D0  !ln(1+z) of 2nd Gaussian
        real(dl) :: wGauss1=        0.18D0  !Width of 1st Gaussian
        real(dl) :: wGauss2=        0.33D0  !Width of 2nd Gaussian
        !Gaussian fits for extra H physics (fit by Adam Moss , modified by Antony Lewis)

        type RecombinationParams

          real(dl) :: RECFAST_fudge 
          real(dl) :: RECFAST_fudge_He 
          integer  :: RECFAST_Heswitch
          logical  :: RECFAST_Hswitch  
         !0) no change from old Recfast'
         !1) full expression for escape probability for singlet'
         !'   1P-1S transition'
         !2) also including effect of contiuum opacity of H on HeI'
         !'   singlet (based in fitting formula suggested by'
         !'   Kholupenko, Ivanchik & Varshalovich, 2007)'
         !3) only including recombination through the triplets'
         !4) including 3 and the effect of the contiuum '
         !'   (although this is probably negligible)' 
         !5) including only 1, 2 and 3'
         !6) including all of 1 to 4'
   
        end  type RecombinationParams

        character(LEN=*), parameter :: Recombination_Name = 'Recfast_1.5.2'
      
        real(dl) zrec(Nz),xrec(Nz),dxrec(Nz), Tsrec(Nz) ,dTsrec(Nz), tmrec(Nz),dtmrec(Nz)

        real(dl), parameter :: Do21cm_mina = 1/(1+900.) !at which to start evolving Delta_TM
        logical, parameter :: evolve_Ts = .false. !local equilibrium is very accurate
        real(dl), parameter :: Do21cm_minev = 1/(1+400.) !at which to evolve T_s
       
 
        real(dl), parameter :: B01 = 3*B10
        real(dl) :: NNow, fHe 
               

        logical :: Do21cm = .false.
        logical :: doTmatTspin = .false.

        real(dl) :: recombination_saha_z !Redshift at which saha OK
        real(dl) :: recombination_saha_tau !set externally


        public RecombinationParams, Recombination_xe, Recombination_tm,Recombination_ts ,Recombination_init,   &
               Recombination_ReadParams, Recombination_SetDefParams, Recombination_Validate, Recombination_Name, &
               kappa_HH_21cm,kappa_eH_21cm,kappa_pH_21cm, &
               Do21cm, doTmatTspin, Do21cm_mina, dDeltaxe_dtau, &
               recombination_saha_tau, recombination_saha_z
 
       contains



         subroutine Recombination_ReadParams(R, Ini)
          use IniFile
          Type(RecombinationParams) :: R
          Type(TIniFile) :: Ini


             R%RECFAST_fudge_He = Ini_Read_Double_File(Ini,'RECFAST_fudge_He',RECFAST_fudge_He_default)
             R%RECFAST_Heswitch = Ini_Read_Int_File(Ini, 'RECFAST_Heswitch',RECFAST_Heswitch_default)
             R%RECFAST_Hswitch = Ini_Read_Logical_File(Ini, 'RECFAST_Hswitch',RECFAST_Hswitch_default)
             R%RECFAST_fudge = Ini_Read_Double_File(Ini,'RECFAST_fudge',RECFAST_fudge_default)
             AGauss1 = Ini_REad_Double_File(Ini,'AGauss1',AGauss1)
             AGauss2 = Ini_REad_Double_File(Ini,'AGauss2',AGauss2)
             zGauss1 = Ini_REad_Double_File(Ini,'zGauss1',zGauss1)
             zGauss2 = Ini_REad_Double_File(Ini,'zGauss2',zGauss2)
             wGauss1 = Ini_REad_Double_File(Ini,'wGauss1',wGauss1)
             wGauss2 = Ini_REad_Double_File(Ini,'wGauss2',wGauss2)
             if (R%RECFAST_Hswitch) then
                R%RECFAST_fudge = R%RECFAST_fudge - (RECFAST_fudge_default - RECFAST_fudge_default2)
             end if   
         end subroutine Recombination_ReadParams

        subroutine Recombination_SetDefParams(R)
         type (RecombinationParams) ::R

      
          R%RECFAST_fudge = RECFAST_fudge_default
          R%RECFAST_fudge_He = RECFAST_fudge_He_default !Helium fudge parameter
          R%RECFAST_Heswitch = RECFAST_Heswitch_default
          R%RECFAST_Hswitch =  RECFAST_Hswitch_default
          if (R%RECFAST_Hswitch) then
                R%RECFAST_fudge = RECFAST_fudge_default2
          end if   
    
        end subroutine Recombination_SetDefParams


        subroutine Recombination_Validate(R, OK)
          Type(RecombinationParams),intent(in) :: R
          logical, intent(inout) :: OK
 
              if (R%RECFAST_Heswitch<0 .or. R%RECFAST_Heswitch > 6) then
                     OK = .false.
                     write(*,*) 'RECFAST_Heswitch unknown'
               end if
             
         end subroutine Recombination_Validate


        function Recombination_tm(a)
        use RECDATA, only : Tnow
        real(dl) zst,a,z,az,bz,Recombination_tm
        integer ilo,ihi
        
        if (.not. doTmatTspin) stop 'RECFAST: Recombination_tm not stored'
        z=1/a-1
        if (z >= zrec(1)) then
            Recombination_tm=Tnow/a
        else
         if (z <=zrec(nz)) then
          Recombination_tm=Tmrec(nz)
         else
          zst=(zinitial-z)/delta_z
          ihi= int(zst)
          ilo = ihi+1
          az=zst - int(zst)
          bz=1-az     
          Recombination_tm=az*Tmrec(ilo)+bz*Tmrec(ihi)+ &
           ((az**3-az)*dTmrec(ilo)+(bz**3-bz)*dTmrec(ihi))/6._dl
         endif
        endif

        end function Recombination_tm


        function Recombination_ts(a)
        !zrec(1) is zinitial-delta_z
        real(dl), intent(in) :: a
        real(dl) zst,z,az,bz,Recombination_ts
        integer ilo,ihi
        
        z=1/a-1
        if (z.ge.zrec(1)) then
          Recombination_ts=tsrec(1)
        else
         if (z.le.zrec(nz)) then
          Recombination_ts=tsrec(nz)
         else
          zst=(zinitial-z)/delta_z
          ihi= int(zst)
          ilo = ihi+1
          az=zst - int(zst)
          bz=1-az     

          Recombination_ts=az*tsrec(ilo)+bz*tsrec(ihi)+ &
           ((az**3-az)*dtsrec(ilo)+(bz**3-bz)*dtsrec(ihi))/6._dl
         endif
        endif

        end function Recombination_ts


        function Recombination_xe(a)
        real(dl), intent(in) :: a
        real(dl) zst,z,az,bz,Recombination_xe
        integer ilo,ihi
        
        z=1/a-1
        if (z.ge.zrec(1)) then
          Recombination_xe=xrec(1)
        else
         if (z.le.zrec(nz)) then
          Recombination_xe=xrec(nz)
         else
          zst=(zinitial-z)/delta_z
          ihi= int(zst)
          ilo = ihi+1
          az=zst - int(zst)
          bz=1-az     
          Recombination_xe=az*xrec(ilo)+bz*xrec(ihi)+ &
           ((az**3-az)*dxrec(ilo)+(bz**3-bz)*dxrec(ihi))/6._dl
         endif
        endif

        end function Recombination_xe



        subroutine Recombination_init(Recomb, OmegaC, OmegaB, Omegan, Omegav, h0inp,tcmb,yp, nnu)
        !Would love to pass structure as arguments, but F90 would give circular reference...
        !hence mess passing parameters explcitly and non-generally
        !Note recfast only uses OmegaB, h0inp, tcmb and yp - others used only for Tmat approximation where effect small
        !nnu currently not used here
        use RECDATA
        use AMLUtils
        implicit none
        Type (RecombinationParams) :: Recomb
 
        real(dl), save :: last_OmB =0, Last_YHe=0, Last_H0=0, Last_dtauda=0, last_fudge, last_fudgeHe 

        real(dl) Trad,Tmat,Tspin,d0hi,d0lo
        integer I

        real(dl), intent(in) :: OmegaB,OmegaC, Omegan, Omegav, h0inp, yp
        real(dl), intent(in), optional :: nnu
        real(dl) z,n,x,x0,rhs,x_H,x_He,x_H0,x_He0,H
        real(dl) zstart,zend,tcmb
        real(dl) cw(24)
        real(dl), dimension(:,:), allocatable :: w
        real(dl) y(4)
        real(dl) C10, tau_21Ts
        real(dl) fnu
        integer ind,nw

!       --- Parameter statements
        real(dl), parameter :: tol=1.D-5                !Tolerance for R-K

        real(dl) dtauda
        external dtauda, dverk

!       ===============================================================

        if (Last_OmB==OmegaB .and. Last_H0 == h0inp .and. yp == Last_YHe .and. & 
             dtauda(0.2352375823_dl) == Last_dtauda .and. last_fudge == Recomb%RECFAST_fudge &
              .and. last_fudgeHe==Recomb%RECFAST_fudge_He) return
           !This takes up most of the single thread time, so cache if at all possible
           !For example if called with different reionization, or tensor rather than scalar
        
        Last_dtauda =  dtauda(0.2352375823_dl) !Just get it at a random scale factor
        Last_OmB = OmegaB
        Last_H0 = h0inp
        Last_YHe=yp
        last_fudge = Recomb%RECFAST_FUDGE
        last_fudgeHe = Recomb%RECFAST_FUDGE_He

        if (Do21cm) doTmatTspin = .true.


!       write(*,*)'recfast version 1.0'
!       write(*,*)'Using Hummer''s case B recombination rates for H'
!       write(*,*)' with fudge factor = 1.14'
!       write(*,*)'and tabulated HeII singlet recombination rates'
!       write(*,*)

        n_eq = 3
        if (Evolve_Ts) n_eq=4
        allocate(w(n_eq,9))

        recombination_saha_z=0.d0

        Tnow=tcmb
!       These are easy to inquire as input, but let's use simple values
        z = zinitial
!       will output every 1 in z, but this is easily changed also

 !Not general, but only for approx 
        OmegaT=OmegaC+OmegaB            !total dark matter + baryons
        OmegaK=1.d0-OmegaT-OmegaV       !curvature
    
  
!       convert the Hubble constant units
        H = H0inp/100._dl
        HO = H*bigH


!       sort out the helium abundance parameters
        mu_H = 1.d0/(1.d0-Yp)           !Mass per H atom
        mu_T = not4/(not4-(not4-1.d0)*Yp)   !Mass per atom
        fHe = Yp/(not4*(1.d0-Yp))       !n_He_tot / n_H_tot


        Nnow = 3._dl*HO*HO*OmegaB/(8._dl*Pi*G*mu_H*m_H)

        n = Nnow * (1._dl+z)**3
        fnu = (21.d0/8.d0)*(4.d0/11.d0)**(4.d0/3.d0)
!	(this is explictly for 3 massless neutrinos - change if N_nu.ne.3; but only used for approximation so not critical)
        z_eq = (3.d0*(HO*C)**2/(8.d0*Pi*G*a_rad*(1.d0+fnu)*Tnow**4))*(OmegaB+OmegaC)
        z_eq = z_eq - 1.d0

      
!       Set up some constants so they don't have to be calculated later
        Lalpha = 1.d0/L_H_alpha
        Lalpha_He = 1.d0/L_He_2p
        DeltaB = h_P*C*(L_H_ion-L_H_alpha)
        CDB = DeltaB/k_B
        DeltaB_He = h_P*C*(L_He1_ion-L_He_2s)   !2s, not 2p
        CDB_He = DeltaB_He/k_B
        CB1 = h_P*C*L_H_ion/k_B
        CB1_He1 = h_P*C*L_He1_ion/k_B   !ionization for HeI
        CB1_He2 = h_P*C*L_He2_ion/k_B   !ionization for HeII
        CR = 2.d0*Pi*(m_e/h_P)*(k_B/h_P)
        CK = Lalpha**3/(8.d0*Pi)
        CK_He = Lalpha_He**3/(8.d0*Pi)
        CL = C*h_P/(k_B*Lalpha)
        CL_He = C*h_P/(k_B/L_He_2s) !comes from det.bal. of 2s-1s
        CT = Compton_CT / MPC_in_sec

        Bfact = h_P*C*(L_He_2p-L_He_2s)/k_B

        
!       Matter departs from radiation when t(Th) > H_frac * t(H)
!       choose some safely small number
        H_frac = 1D-3

!       Fudge factor to approximate for low z out of equilibrium effect
        fu=Recomb%RECFAST_fudge

!       Set initial matter temperature
        y(3) = Tnow*(1._dl+z)            !Initial rad. & mat. temperature
        Tmat = y(3)
        y(4) = Tmat
        Tspin = Tmat

        call get_init(z,x_H0,x_He0,x0)
    
        y(1) = x_H0
        y(2) = x_He0

!       OK that's the initial conditions, now start writing output file


!       Set up work-space stuff for DVERK
        ind  = 1
        nw   = n_eq
        do i = 1,24
          cw(i) = 0._dl
        end do

        do i = 1,Nz
!       calculate the start and end redshift for the interval at each z
!       or just at each z
          zstart = zinitial  - real(i-1,dl)*delta_z
          zend   = zinitial  - real(i,dl)*delta_z

! Use Saha to get x_e, using the equation for x_e for ionized helium
! and for neutral helium.
! Everything ionized above z=8000.  First ionization over by z=5000.
! Assume He all singly ionized down to z=3500, then use He Saha until
! He is 99% singly ionized, and *then* switch to joint H/He recombination.

          z = zend
        
          if (zend > 8000._dl) then

            x_H0 = 1._dl
            x_He0 = 1._dl
            x0 = 1._dl+2._dl*fHe
            y(1) = x_H0
            y(2) = x_He0
            y(3) = Tnow*(1._dl+z)
            y(4) = y(3)

          else if(z > 5000._dl)then

            x_H0 = 1._dl
            x_He0 = 1._dl
            rhs = exp( 1.5d0 * log(CR*Tnow/(1._dl+z)) &
                - CB1_He2/(Tnow*(1._dl+z)) ) / Nnow
            rhs = rhs*1._dl            !ratio of g's is 1 for He++ <-> He+
            x0 = 0.5d0 * ( sqrt( (rhs-1._dl-fHe)**2 &
                + 4._dl*(1._dl+2._dl*fHe)*rhs) - (rhs-1._dl-fHe) )
            y(1) = x_H0
            y(2) = x_He0
            y(3) = Tnow*(1._dl+z)
            y(4) = y(3)

          else if(z > 3500._dl)then

            x_H0 = 1._dl
            x_He0 = 1._dl
            x0 = x_H0 + fHe*x_He0
            y(1) = x_H0
            y(2) = x_He0
            y(3) = Tnow*(1._dl+z)
            y(4) = y(3)

          else if(y(2) > 0.99)then

            x_H0 = 1._dl
            rhs = exp( 1.5d0 * log(CR*Tnow/(1._dl+z)) &
                - CB1_He1/(Tnow*(1._dl+z)) ) / Nnow
            rhs = rhs*4._dl            !ratio of g's is 4 for He+ <-> He0
            x_He0 = 0.5d0 * ( sqrt( (rhs-1._dl)**2 &
                + 4._dl*(1._dl+fHe)*rhs )- (rhs-1._dl))
            x0 = x_He0
            x_He0 = (x0 - 1._dl)/fHe
            y(1) = x_H0
            y(2) = x_He0
            y(3) = Tnow*(1._dl+z)
            y(4) = y(3)

          else if (y(1) > 0.99d0) then

            rhs = exp( 1.5d0 * log(CR*Tnow/(1._dl+z)) &
                - CB1/(Tnow*(1._dl+z)) ) / Nnow
            x_H0 = 0.5d0 * (sqrt( rhs**2+4._dl*rhs ) - rhs )

            call DVERK(Recomb,3,ION,zstart,y,zend,tol,ind,cw,nw,w)
            y(1) = x_H0
            x0 = y(1) + fHe*y(2)
            y(4)=y(3)
          else
            
            call DVERK(Recomb,nw,ION,zstart,y,zend,tol,ind,cw,nw,w)
          
            x0 = y(1) + fHe*y(2)
          
          end if
          
          Trad = Tnow * (1._dl+zend)
          Tmat = y(3)
          x_H = y(1)
          x_He = y(2)
          x = x0

          zrec(i)=zend
          xrec(i)=x

    
          if (doTmatTspin) then
              if (Evolve_Ts .and. zend< 1/Do21cm_minev-1 ) then
               Tspin = y(4)
              else 
               C10 = Nnow * (1._dl+zend)**3*(kappa_HH_21cm(Tmat,.false.)*(1-x_H) + kappa_eH_21cm(Tmat,.false.)*x)
               tau_21Ts = line21_const*NNow*(1+zend)*dtauda(1/(1+zend))/1000
        
               Tspin = Trad*( C10/Trad + A10/T_21cm)/(C10/Tmat + A10/T_21cm) + &
                     tau_21Ts/2*A10*( 1/(C10*T_21cm/Tmat+A10) -  1/(C10*T_21cm/Trad+A10) )
          
               y(4) = Tspin
              end if

              tsrec(i) = Tspin
              tmrec(i) = Tmat
           
          end if   

!          write (*,'(5E15.5)') zend, Trad, Tmat, Tspin, x
     
        end do
        
        d0hi=1.0d40
        d0lo=1.0d40
        call spline(zrec,xrec,nz,d0lo,d0hi,dxrec)
        if (doTmatTspin) then
         call spline(zrec,tsrec,nz,d0lo,d0hi,dtsrec)
         call spline(zrec,tmrec,nz,d0lo,d0hi,dtmrec)
        end if
        deallocate(w)
        
        end subroutine Recombination_init

!       ===============================================================
        subroutine GET_INIT(z,x_H0,x_He0,x0)

!       Set up the initial conditions so it will work for general,
!       but not pathological choices of zstart
!       Initial ionization fraction using Saha for relevant species
        use RECDATA
        implicit none
  
        
        real(dl) z,x0,rhs,x_H0,x_He0
  

        if(z > 8000._dl)then

            x_H0 = 1._dl
            x_He0 = 1._dl
            x0 = 1._dl+2._dl*fHe

        else if(z > 3500._dl)then

            x_H0 = 1._dl
            x_He0 = 1._dl
            rhs = exp( 1.5d0 * log(CR*Tnow/(1._dl+z)) &
                - CB1_He2/(Tnow*(1._dl+z)) ) / Nnow
        rhs = rhs*1._dl    !ratio of g's is 1 for He++ <-> He+
        x0 = 0.5d0 * ( sqrt( (rhs-1._dl-fHe)**2 &
                + 4._dl*(1._dl+2._dl*fHe)*rhs) - (rhs-1._dl-fHe) )

        else if(z > 2000._dl)then

        x_H0 = 1._dl
            rhs = exp( 1.5d0 * log(CR*Tnow/(1._dl+z)) &
                - CB1_He1/(Tnow*(1._dl+z)) ) / Nnow
        rhs = rhs*4._dl    !ratio of g's is 4 for He+ <-> He0
            x_He0 = 0.5d0  * ( sqrt( (rhs-1._dl)**2 + 4._dl*(1._dl+fHe)*rhs )- (rhs-1._dl))
            x0 = x_He0
            x_He0 = (x0 - 1._dl)/fHe

        else

            rhs = exp( 1.5d0 * log(CR*Tnow/(1._dl+z)) &
                - CB1/(Tnow*(1._dl+z)) ) / Nnow
            x_H0 = 0.5d0 * (sqrt( rhs**2+4._dl*rhs ) - rhs )
            x_He0 = 0._dl
            x0 = x_H0

        end if

        
        end subroutine GET_INIT



        subroutine ION(Recomb,Ndim,z,Y,f)
        use RECDATA
        implicit none

        integer Ndim
        Type (RecombinationParams) :: Recomb

        real(dl) z,x,n,n_He,Trad,Tmat,Tspin,x_H,x_He, Hz
        real(dl) y(Ndim),f(Ndim)
        real(dl) Rup,Rdown,K,K_He,Rup_He,Rdown_He,He_Boltz
        real(dl) timeTh,timeH
        real(dl) a_VF,b_VF,T_0,T_1,sq_0,sq_1,a_PPB,b_PPB,c_PPB,d_PPB
        real(dl) tauHe_s,pHe_s
        real(dl) a_trip,b_trip,Rdown_trip,Rup_trip
        real(dl) Doppler,gamma_2Ps,pb,qb,AHcon
        real(dl) tauHe_t,pHe_t,CL_PSt,CfHe_t,gamma_2Pt
        real(dl) epsilon
        integer Heflag
        real(dl) dtauda
        real(dl) C10, dHdz
        external dtauda

!       the Pequignot, Petitjean & Boisson fitting parameters for Hydrogen    
        a_PPB = 4.309d0
        b_PPB = -0.6166d0
        c_PPB = 0.6703d0
        d_PPB = 0.5300d0
!       the Verner and Ferland type fitting parameters for Helium
!       fixed to match those in the SSS papers, and now correct
        a_VF = 10.d0**(-16.744d0)
        b_VF = 0.711d0
        T_0 = 10.d0**(0.477121d0)   !3K
        T_1 = 10.d0**(5.114d0)
!      fitting parameters for HeI triplets
!      (matches Hummer's table with <1% error for 10^2.8 < T/K < 10^4)

        a_trip = 10.d0**(-16.306d0)
        b_trip = 0.761D0

       
        x_H = y(1)
        x_He = y(2)
        x = x_H + fHe * x_He
        Tmat = y(3)
!        Tspin = y(4)

        n = Nnow * (1._dl+z)**3
        n_He = fHe * Nnow * (1._dl+z)**3
        Trad = Tnow * (1._dl+z)

        Hz = 1/dtauda(1/(1._dl+z))*(1._dl+z)**2/MPC_in_sec       
     

!       Get the radiative rates using PPQ fit, identical to Hummer's table
        
        Rdown=1.d-19*a_PPB*(Tmat/1.d4)**b_PPB &
                /(1._dl+c_PPB*(Tmat/1.d4)**d_PPB)
        Rup = Rdown * (CR*Tmat)**(1.5d0)*exp(-CDB/Tmat)
      
!       calculate He using a fit to a Verner & Ferland type formula
        sq_0 = sqrt(Tmat/T_0)
        sq_1 = sqrt(Tmat/T_1)
!       typo here corrected by Wayne Hu and Savita Gahlaut
        Rdown_He = a_VF/(sq_0*(1.d0+sq_0)**(1.d0-b_VF))
        Rdown_He = Rdown_He/(1.d0+sq_1)**(1.d0+b_VF)
        Rup_He = Rdown_He*(CR*Tmat)**(1.5d0)*exp(-CDB_He/Tmat)
        Rup_He = 4.d0*Rup_He    !statistical weights factor for HeI
!       Avoid overflow (pointed out by Jacques Roland)
        if((Bfact/Tmat) > 680.d0)then
          He_Boltz = exp(680.d0)
        else
          He_Boltz = exp(Bfact/Tmat)
        end if
!	now deal with H and its fudges
    if (.not. Recomb%RECFAST_Hswitch) then
      K = CK/Hz !Peebles coefficient K=lambda_a^3/8piH
    else
!c	fit a double Gaussian correction function
      K = CK/Hz*(1.0d0 &
        +AGauss1*exp(-((log(1.0d0+z)-zGauss1)/wGauss1)**2.d0) &
        +AGauss2*exp(-((log(1.0d0+z)-zGauss2)/wGauss2)**2.d0))
    end if        
        
        
 !  add the HeI part, using same T_0 and T_1 values
    Rdown_trip = a_trip/(sq_0*(1.d0+sq_0)**(1.0-b_trip))
    Rdown_trip = Rdown_trip/((1.d0+sq_1)**(1.d0+b_trip))
    Rup_trip = Rdown_trip*dexp(-h_P*C*L_He2St_ion/(k_B*Tmat))
    Rup_trip = Rup_trip*((CR*Tmat)**(1.5d0))*(4.d0/3.d0)
!   last factor here is the statistical weight

!       try to avoid "NaN" when x_He gets too small
    if ((x_He.lt.5.d-9) .or. (x_He.gt.0.98d0)) then 
      Heflag = 0
    else
      Heflag = Recomb%RECFAST_Heswitch
    end if
    if (Heflag.eq.0)then        !use Peebles coeff. for He
      K_He = CK_He/Hz
    else    !for Heflag>0       !use Sobolev escape probability
      tauHe_s = A2P_s*CK_He*3.d0*n_He*(1.d0-x_He)/Hz
      pHe_s = (1.d0 - dexp(-tauHe_s))/tauHe_s
      K_He = 1.d0/(A2P_s*pHe_s*3.d0*n_He*(1.d0-x_He))
!      if (((Heflag.eq.2) .or. (Heflag.ge.5)) .and. x_H < 0.99999d0) then 
      if (((Heflag.eq.2) .or. (Heflag.ge.5)) .and. x_H < 0.9999999d0) then
       !AL changed July 08 to get smoother Helium

!   use fitting formula for continuum opacity of H
!   first get the Doppler width parameter
        Doppler = 2.D0*k_B*Tmat/(m_H*not4*C*C)
        Doppler = C*L_He_2p*dsqrt(Doppler)
        gamma_2Ps = 3.d0*A2P_s*fHe*(1.d0-x_He)*C*C &
            /(dsqrt(Pi)*sigma_He_2Ps*8.d0*Pi*Doppler*(1.d0-x_H)) &
            /((C*L_He_2p)**2.d0)
        pb = 0.36d0  !value from KIV (2007)
        qb = Recomb%RECFAST_fudge_He
!   calculate AHcon, the value of A*p_(con,H) for H continuum opacity
        AHcon = A2P_s/(1.d0+pb*(gamma_2Ps**qb))
        K_He=1.d0/((A2P_s*pHe_s+AHcon)*3.d0*n_He*(1.d0-x_He))
      end if
      if (Heflag.ge.3) then     !include triplet effects
        tauHe_t = A2P_t*n_He*(1.d0-x_He)*3.d0
        tauHe_t = tauHe_t /(8.d0*Pi*Hz*L_He_2Pt**(3.d0))
        pHe_t = (1.d0 - dexp(-tauHe_t))/tauHe_t
        CL_PSt = h_P*C*(L_He_2Pt - L_He_2st)/k_B
        if ((Heflag.eq.3) .or. (Heflag.eq.5).or.(x_H.gt.0.99999d0)) then !Recfast 1.4.2 (?)
!        if ((Heflag.eq.3) .or. (Heflag.eq.5) .or. x_H >= 0.9999999d0) then    !no H cont. effect
            CfHe_t = A2P_t*pHe_t*dexp(-CL_PSt/Tmat)
            CfHe_t = CfHe_t/(Rup_trip+CfHe_t)   !"C" factor for triplets
        else                  !include H cont. effect
            Doppler = 2.d0*k_B*Tmat/(m_H*not4*C*C)
            Doppler = C*L_He_2Pt*dsqrt(Doppler)
            gamma_2Pt = 3.d0*A2P_t*fHe*(1.d0-x_He)*C*C &
            /(dsqrt(Pi)*sigma_He_2Pt*8.d0*Pi*Doppler*(1.d0-x_H)) &
            /((C*L_He_2Pt)**2.d0)
    !   use the fitting parameters from KIV (2007) in this case
            pb = 0.66d0
            qb = 0.9d0
            AHcon = A2P_t/(1.d0+pb*gamma_2Pt**qb)/3.d0
            CfHe_t = (A2P_t*pHe_t+AHcon)*dexp(-CL_PSt/Tmat)
            CfHe_t = CfHe_t/(Rup_trip+CfHe_t)   !"C" factor for triplets
        end if
      end if
    end if
        
        
!       Estimates of Thomson scattering time and Hubble time
        timeTh=(1._dl/(CT*Trad**4))*(1._dl+x+fHe)/x       !Thomson time
        timeH=2./(3.*HO*(1._dl+z)**1.5)      !Hubble time

!       calculate the derivatives
!       turn on H only for x_H<0.99, and use Saha derivative for 0.98<x_H<0.99
!       (clunky, but seems to work)
        if (x_H > 0.99) then   !don't change at all
                f(1) = 0._dl
!!        else if (x_H > 0.98_dl) then
      else if (x_H.gt.0.985d0) then     !use Saha rate for Hydrogen
            f(1) = (x*x_H*n*Rdown - Rup*(1.d0-x_H)*dexp(-CL/Tmat)) /(Hz*(1.d0+z))
            recombination_saha_z = z  
!AL: following commented as not used
!   for interest, calculate the correction factor compared to Saha
!   (without the fudge)
!       factor=(1.d0 + K*Lambda*n*(1.d0-x_H))
!       /(Hz*(1.d0+z)*(1.d0+K*Lambda*n*(1.d0-x)
!       +K*Rup*n*(1.d0-x)))       
      else !use full rate for H

        f(1) = ((x*x_H*n*Rdown - Rup*(1.d0-x_H)*exp(-CL/Tmat)) &
                *(1.d0 + K*Lambda*n*(1.d0-x_H))) &
                /(Hz*(1.d0+z)*(1.d0/fu+K*Lambda*n*(1.d0-x_H)/fu &
                +K*Rup*n*(1.d0-x_H)))

      end if
   
!       turn off the He once it is small
      if (x_He < 1.e-15) then 
                f(2)=0.d0
      else

        f(2) = ((x*x_He*n*Rdown_He &
            - Rup_He*(1-x_He)*exp(-CL_He/Tmat)) &
                *(1 + K_He*Lambda_He*n_He*(1.d0-x_He)*He_Boltz)) &
                /(Hz*(1+z) &
                * (1 + K_He*(Lambda_He+Rup_He)*n_He*(1.d0-x_He)*He_Boltz))
                
!   Modification to HeI recombination including channel via triplets
          if (Heflag.ge.3) then
            f(2) = f(2)+ (x*x_He*n*Rdown_trip & 
             - (1.d0-x_He)*3.d0*Rup_trip*dexp(-h_P*C*L_He_2st/(k_B*Tmat))) &
             *CfHe_t/(Hz*(1.d0+z))
          end if

        end if

        if (timeTh < H_frac*timeH) then
!                f(3)=Tmat/(1._dl+z)      !Tmat follows Trad
!	additional term to smooth transition to Tmat evolution,
!	(suggested by Adam Moss)
         dHdz = (HO**2/2.d0/Hz)*(4.d0*(1.d0+z)**3/(1.d0+z_eq)*OmegaT &
         + 3.d0*OmegaT*(1.d0+z)**2 + 2.d0*OmegaK*(1.d0+z) )

        epsilon = Hz*(1.d0+x+fHe)/(CT*Trad**3*x)
        f(3) = Tnow &
        + epsilon*((1.d0+fHe)/(1.d0+fHe+x))*((f(1)+fHe*f(2))/x) &
        - epsilon* dHdz/Hz + 3.0d0*epsilon/(1.d0+z) 
                
        else
                f(3)= CT * (Trad**4) * x / (1._dl+x+fHe) &
                        * (Tmat-Trad) / (Hz*(1._dl+z)) + 2._dl*Tmat/(1._dl+z)    
        end if

         ! print *, z, f(3)*(1+z)/Tmat
         
        if (Do21cm .and. evolve_Ts) then

    !       follow the matter temperature once it has a chance of diverging
            if (timeTh < H_frac*timeH) then
                f(4) = Tnow !spin follows Trad and Tmat
            else
                if (z< 1/Do21cm_minev-1) then
       
                 Tspin = y(4) 
                 C10 = n*(kappa_HH_21cm(Tmat,.false.)*(1-x_H) + kappa_eH_21cm(Tmat,.false.)*x)
       
                 f(4) = 4*Tspin/Hz/(1+z)*( (Tspin/Tmat-1._dl)*C10 + Trad/T_21cm*(Tspin/Trad-1._dl)*A10) - f(1)*Tspin/(1-x_H)
                else
                 f(4)=f(3)
                end if
            end if
      
        end if

        end subroutine ION



        function dDeltaxe_dtau(a, Delta_xe,Delta_nH, Delta_Tm, hdot, kvb)
        !d x_e/d tau assuming Helium all neutral and temperature perturbations negligible
        !it is not accurate for x_e of order 1
        use RECDATA
        implicit none
        real(dl) dDeltaxe_dtau
        real(dl), intent(in):: a, Delta_xe,Delta_nH, Delta_Tm, hdot, kvb
        real(dl) Delta_Tg
        real(dl) xedot,z,x,n,n_He,Trad,Tmat,x_H,Hz, C_r, dlnC_r
        real(dl) Rup,Rdown,K
        real(dl) a_PPB,b_PPB,c_PPB,d_PPB
        real(dl) delta_alpha, delta_beta, delta_K, clh
        real(dl) dtauda
        external dtauda

       
        Delta_tg =Delta_Tm
        x_H = min(1._dl,Recombination_xe(a))

!       the Pequignot, Petitjean & Boisson fitting parameters for Hydrogen    
        a_PPB = 4.309d0
        b_PPB = -0.6166d0
        c_PPB = 0.6703d0
        d_PPB = 0.5300d0
 
        z=1/a-1

        x = x_H 

        n = Nnow /a**3
        n_He = fHe * n
        Trad = Tnow /a
        clh = 1/dtauda(a)/a !conformal time
        Hz = clh/a/MPC_in_sec !normal time in seconds

        Tmat = Recombination_tm(a)

!       Get the radiative rates using PPQ fit, identical to Hummer's table
        
        Rdown=1.d-19*a_PPB*(Tmat/1.d4)**b_PPB &
                /(1._dl+c_PPB*(Tmat/1.d4)**d_PPB)   !alpha
        Rup = Rdown * (CR*Tmat)**(1.5d0)*exp(-CDB/Tmat)
      
        K = CK/Hz              !Peebles coefficient K=lambda_a^3/8piH


        Rdown = Rdown*fu
        Rup = Rup*fu
        C_r =  a*(1.d0 + K*Lambda*n*(1.d0-x_H)) /( 1.d0+K*(Lambda+Rup)*n*(1.d0-x_H) )*MPC_in_sec
 
        xedot = -(x*x_H*n*Rdown - Rup*(1.d0-x_H)*exp(-CL/Tmat))*C_r
               
        delta_alpha = (b_PPB + c_PPB*(Tmat/1d4)**d_PPB*(b_PPB-d_PPB))/(1+c_PPB*(Tmat/1d4)**d_PPB)*Delta_Tg
        delta_beta = delta_alpha + (3./2 + CDB/Tmat)*delta_Tg !(Rup = beta)
        delta_K = - hdot/clh - kvb/clh/3


        dlnC_r = -Rup*K*n*( (Delta_nH+Delta_K + Delta_beta*(1+K*Lambda*n*(1-x_H)))*(1-x_H) - x_H*Delta_xe) &
          / ( 1.d0+K*(Lambda+Rup)*n*(1.d0-x_H) ) /(1.d0 + K*Lambda*n*(1.d0-x_H)) 
             
        dDeltaxe_dtau= xedot/x_H*(dlnC_r +Delta_alpha - Delta_xe) &
         - C_r*( (2*Delta_xe + Delta_nH)*x_H*n*Rdown + (Delta_xe - (3./2+ CB1/Tmat)*(1/x_H-1)*Delta_Tg)*Rup*exp(-CL/Tmat))
        
 
!Approximate form valid at late times
!        dDeltaxe_dtau= xedot/x_H*(Delta_alpha + Delta_xe + Delta_nH)


        end function dDeltaxe_dtau

!  ===============================================================


          function polevl(x,coef,N)
          implicit none
          integer N
          real(dl) polevl
          real(dl) x,ans
          real(dl) coef(N+1)

          integer i

          ans=coef(1)
          do i=2,N+1
             ans=ans*x+coef(i)
          end do
          polevl=ans
      
          end function polevl


          function derivpolevl(x,coef,N)
          implicit none
          integer N
          real(dl) derivpolevl
          real(dl) x,ans
          real(dl) coef(N+1)
          integer i

          ans=coef(1)*N
          do i=2,N
             ans=ans*x+coef(i)*(N-i+1)
          end do
          derivpolevl=ans
      
          end function derivpolevl


        function kappa_HH_21cm(T, deriv)
        !Polynomail fit to Hydrogen-Hydrogen collision rate as function of Tmatter, from astro-ph/0608032
        !if deriv return d log kappa / d log T
         real(dl), intent(in) :: T
         logical, intent(in) :: deriv
 !        real(dl), dimension(8), parameter :: fit = &
 !         (/ 0.00120402_dl, -0.0322247_dl,0.339581_dl, -1.75094_dl,4.3528_dl,-4.03562_dl, 1.26899_dl, -29.6113_dl /)
         integer, parameter :: n_table = 27
         integer, dimension(n_table), parameter :: Temps = &
          (/ 1, 2, 4, 6,8,10,15,20,25,30,40,50,60,70,80,90,100,200,300,500,700,1000,2000,3000,5000,7000,10000/) 
         real, dimension(n_table), parameter :: rates = &
          (/ 1.38e-13, 1.43e-13,2.71e-13, 6.60e-13,1.47e-12,2.88e-12,9.10e-12,1.78e-11,2.73e-11,&
           3.67e-11,5.38e-11,6.86e-11,8.14e-11,9.25e-11, &
           1.02e-10,1.11e-10,1.19e-10,1.75e-10,2.09e-10,2.56e-10,2.91e-10,3.31e-10,4.27e-10,&
           4.97e-10,6.03e-10,6.87e-10,7.87e-10/) 
          
         real(dl) kappa_HH_21cm, logT, logRate
         real(dl), save, dimension(:), allocatable :: logRates, logTemps, ddlogRates
         integer xlo, xhi
         real(dl) :: a0, b0, ho

         if (.not. allocated(logRates)) then

             allocate(logRates(n_table),logTemps(n_table),ddlogRates(n_table))
             logRates = log(real(rates,dl)*0.01**3)
             logTemps = log(real(Temps,dl))
             call spline(logTemps,logRates,n_table,1d30,1d30,ddlogRates)
         end if

         if (T<=Temps(1)) then
             if (deriv) then
              kappa_HH_21cm = 0
             else
              kappa_HH_21cm = rates(1)*0.01**3
             end if
            return
         elseif (T >=Temps(n_table)) then
             if (deriv) then
              kappa_HH_21cm = 0
             else
              kappa_HH_21cm = rates(n_table)*0.01**3
             end if
             return
         end if
         
         logT = log(T)
         xlo=0
         do xhi=2, n_table
          if (logT < logTemps(xhi)) then
            xlo = xhi-1
            exit
          end  if
         end do
         xhi = xlo+1
 
         ho=logTemps(xhi)-logTemps(xlo) 
         a0=(logTemps(xhi)-logT)/ho
         b0=1-a0
 
         if (deriv) then
          kappa_HH_21cm  = (logRates(xhi) - logRates(xlo))/ho + &
              ( ddlogRates(xhi)*(3*b0**2-1) - ddlogRates(xlo)*(3*a0**2-1))*ho/6
!          kappa_HH_21cm = derivpolevl(logT,fit,7)     
         else
          logRate = a0*logRates(xlo)+ b0*logRates(xhi)+ ((a0**3-a0)* ddlogRates(xlo) +(b0**3-b0)*ddlogRates(xhi))*ho**2/6
          kappa_HH_21cm = exp(logRate)
!          kappa_HH_21cm = exp(polevl(logT,fit,7))*0.01**3          
  
         end if

        end function kappa_HH_21cm


        function kappa_eH_21cm(T, deriv)
        !Polynomail fit to electron-Hydrogen collision rate as function of Tmatter; from astro-ph/0608032
        !if deriv return d log kappa / d log T
        ! from astro-ph/0608032
        !    1 2.39e-10
        !    2 3.37e-10
        !    5 5.3e-10
        !    10 7.46e-10
        !    20 1.05e-9
        !    50 1.63e-9
        !    100 2.26e-9
        !    200 3.11e-9
        !    500 4.59e-9
        !    1000 5.92e-9
        !    2000 7.15e-9
        !    5000 8.17e-9
        !    10000 8.37e-9
        !    15000 8.29e-9
        !    20000 8.11e-9
         real(dl), intent(in) :: T
         logical, intent(in) :: deriv
         real(dl), dimension(6), parameter :: fit = &
          (/5.86236d-005,  -0.00171375_dl, 0.0137303_dl, -0.0435277_dl, 0.540905_dl,-22.1596_dl /)
       
         real(dl) kappa_eH_21cm, logT

         logT = log(T)
         if (deriv) then
          kappa_eH_21cm = derivpolevl(logT,fit,5)      
         else
          kappa_eH_21cm = exp(polevl(logT,fit,5))*0.01**3          
         end if

        end function kappa_eH_21cm




        function kappa_pH_21cm(T, deriv) ! from astro-ph/0702487
        !Not actually used
        !Polynomail fit to proton-Hydrogen collision rate as function of Tmatter
        !if deriv return d log kappa / d log T
         real(dl), intent(in) :: T
         logical, intent(in) :: deriv
         integer, parameter :: n_table = 17
         integer, dimension(n_table), parameter :: Temps = &
          (/ 1, 2, 5, 10,20,50,100,200,500,1000,2000,3000,5000,7000,10000,15000,20000/) 
         real, dimension(n_table), parameter :: rates = &
          (/ 0.4028, 0.4517,0.4301,0.3699,0.3172,0.3047, 0.3379, 0.4043, 0.5471, 0.7051, 0.9167, 1.070, &
              1.301, 1.48,1.695,1.975,2.201/) 
          
         real(dl) kappa_pH_21cm, logT, logRate
         real(dl), save, dimension(:), allocatable :: logRates, logTemps, ddlogRates
         integer xlo, xhi
         real(dl) :: a0, b0, ho
         real(dl):: factor = 0.01**3*1e-9

         if (.not. allocated(logRates)) then

             allocate(logRates(n_table),logTemps(n_table),ddlogRates(n_table))
             logRates = log(real(rates,dl)*factor)
             logTemps = log(real(Temps,dl))
             call spline(logTemps,logRates,n_table,1d30,1d30,ddlogRates)
         end if

         if (T<=Temps(1)) then
             if (deriv) then
              kappa_pH_21cm = 0
             else
              kappa_pH_21cm = rates(1)*factor
             end if
            return
         elseif (T >=Temps(n_table)) then
             if (deriv) then
              kappa_pH_21cm = 0
             else
              kappa_pH_21cm = rates(n_table)*factor
             end if
             return
         end if
         
         logT = log(T)
         xlo=0
         do xhi=2, n_table
          if (logT < logTemps(xhi)) then
            xlo = xhi-1
            exit
          end  if
         end do
         xhi = xlo+1
 
         ho=logTemps(xhi)-logTemps(xlo) 
         a0=(logTemps(xhi)-logT)/ho
         b0=1-a0
 
         if (deriv) then
          kappa_pH_21cm  = (logRates(xhi) - logRates(xlo))/ho + &
           ( ddlogRates(xhi)*(3*b0**2-1) - ddlogRates(xlo)*(3*a0**2-1))*ho/6
         else
          logRate = a0*logRates(xlo)+ b0*logRates(xhi)+ ((a0**3-a0)* ddlogRates(xlo) +(b0**3-b0)*ddlogRates(xhi))*ho**2/6
          kappa_pH_21cm = exp(logRate)
         end if

        end function kappa_pH_21cm


        end module Recombination

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gcmlim(rp,cm,np,rpi,cmimin,cmimax,tol,phi,iord)
      integer np
      real*10 rp(3,np),cm(np),rpi(3),cmimin,cmimax,tol
c        work arrays (could be automatic if compiler supports it)
      integer iord(2*np)
      real*10 phi(2,np)
c
c        parameters
      include 'pi.par'
c        intrinsics
      intrinsic abs
c        externals
      integer gsegij,gzeroar
c        data variables
      real*10 big
c        local variables
      integer i,iseg,jm,jml,jmu,jp,jpl,jpu,ni,scmi
      integer km,kp
      logical inmax,inmin
      real*10 cmi,cmik,cmim,dph,ph,phm,php,phimax,phimin,
     *  si,sik,xi(3),yi(3)
c *
c * Minimum and maximum values of cmi = 1-cos(th)
c * between unit direction rpi
c * and surface of sphere of unit radius bounded by
c *    1 - r.rp(i) < cm(i)  (if cm(i).ge.0)
c *    1 - r.rp(i) > -cm(i)  (if cm(i).lt.0)
c * for i=1,np where rp(i) are unit directions.
c *
c  Input: rp(3,i),i=1,np
c         cm(i),i=1,np
c         np
c         rpi(3)
c         tol
c Output: cmimin, cmimax = min, max values of cmi
c            < 0 means region encloses limiting circle
c            > 0 means region excludes limiting circle
c Work arrays: phi and iord should be dimensioned at least 2*np
c
      data big /1.e6_10/
c
c        check for zero area because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
      cmimin=2._10
      cmimax=0._10
      inmin=.true.
      inmax=.true.
c--------identify boundary segments around each circle i in turn
      do 280 i=1,np
c        cm(i).ge.2 means include whole sphere, which is no constraint
        if (cm(i).ge.2._10) goto 280
c        scmi * cmi = 1-cos th(i)
        if (cm(i).ge.0._10) then
          scmi=1
        else
          scmi=-1
        endif
        cmi=abs(cm(i))
c        si = sin th(i)
        si=sqrt(cmi*(2._10-cmi))
c        cmik = 1-cos th(ik), th(ik)=angle twixt rpi & rp(i)
        cmik=((rpi(1)-rp(1,i))**2+(rpi(2)-rp(2,i))**2
     *    +(rpi(3)-rp(3,i))**2)/2._10
c        sik = sin th(ik)
        sik=sqrt(cmik*(2._10-cmik))
c        min circle is outside area
        if ((cm(i).ge.0._10.and.cmik.ge.cmi)
     *    .or.(cm(i).lt.0._10.and.cmik.le.cmi)) inmin=.false.
c        max circle is outside area
        if ((cm(i).ge.0._10.and.cmik.le.2._10-cmi)
     *    .or.(cm(i).lt.0._10.and.cmik.ge.2._10-cmi)) inmax=.false.
c........cartesian axes with z-axis along rp(i), x-axis towards rpi
        call gaxisii(rpi,rp(1,i),xi,yi)
c........angles phi about z-axis rp(i) of intersection of i & j circles
        call gphij(rp,cm,np,i,rp(1,i),scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside polygon
        if (ni.eq.-1) goto 280
c        area of polygon is zero
        if (ni.eq.-2) goto 410
c........i circle has no intersections
        if (ni.eq.0) then
c        reduce cmimin?
          cmim=cmi+cmik-cmi*cmik-si*sik
          if (cmim.lt.cmimin) cmimin=cmim
c        increase cmimax?
          cmim=cmi+cmik-cmi*cmik+si*sik
          if (cmim.gt.cmimax) cmimax=cmim
c........i circle has intersections
        elseif (ni.gt.0) then
c        find ordering of intersection angles around i circle
          call findbot(phi,2*np,iord,ni)
c        phimin, max are nearest, furthest points from rpi
          phimin=big
          phimax=big
c........vertices around i circle
          jpl=0
c        come here to do another segment
  220     continue
c........is segment edge of polygon?
            iseg=gsegij(rp,cm,np,0,0,i,rp(1,i),scmi,cmi,tol,ni,
     *        phi,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
c        error
            if (iseg.eq.-1) goto 420
c        not an edge
            if (iseg.eq.0) goto 220
c        gone full circle
            if (iseg.eq.2) goto 240
            if (php.ge.phm) then
c        segment contains nearest point in i circle, phi=0
              if (phm.le.0._10.and.php.ge.0._10) phimin=0._10
            elseif (php.lt.phm) then
c        segment contains nearest point in i circle, phi=0
              if (phm.le.0._10.or.php.ge.0._10) phimin=0._10
c        segment contains furthest point in i circle, phi=pi
              phimax=0._10
            endif
c        check if segment endpoints tighten limits
            phm=abs(phm)
            php=abs(php)
            if (phm.lt.phimin) phimin=phm
            if (php.lt.phimin) phimin=php
            if (PI-phm.lt.phimax) phimax=PI-phm
            if (PI-php.lt.phimax) phimax=PI-php
c        do another segment
          goto 220
c        reduce cmimin?
  240     if (phimin.ne.big) then
            cmim=cmi+cmik-cmi*cmik-si*sik*cos(phimin)
            if (cmim.lt.cmimin) cmimin=cmim
          endif
c        increase cmimax?
          if (phimax.ne.big) then
            cmim=cmi+cmik-cmi*cmik+si*sik*cos(phimax)
            if (cmim.gt.cmimax) cmimax=cmim
          endif
        endif
  280 continue
c        region encloses limiting circle
      if (inmin) cmimin=-cmimin
      if (inmax) cmimax=-cmimax
      return
c
c        null area
  410 cmimin=2._10
      cmimax=2._10
      return
c
  420 print *,'*** from gmclim: total failure at tol =',tol
      return
c
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      real*10 function wrho(az,el,w,lmax,mmax,im,nw,lsmooth,esmooth)
      integer lmax,mmax,im,nw
      real*10 el,az,w(im,nw),lsmooth,esmooth
c
c        parameters
      real*10 HALF
      parameter (HALF=1._10/2._10)
      include 'pi.par'
c        local variables
c     integer i
      integer l,lm,lmax1,l1,m,mmax1,m1
      real*10 al,al1,am,cel,cm,dwrho,lsmoot1,phi,
     *  sel,sm,smooth,t,tm,tp,y,z,zm,zn,zp
c *
c * Given window harmonics w_lm, returns value of window function
c *    sum w_lm Y_lm exp{-[l(l+1)/lsmooth(lsmooth+1)]**(esmooth/2)]}
c * at azimuthal angle az radians, elevation el radians.
c *
c  Input: az = azimuthal angle (= longitude) in radians.
c         el = elevation (= latitude = pi/2 - polar angle) in radians.
c         w(i,lm) = spherical transform, dimensioned w(im,nw)
c            w(i,lm), i=1,im, lm=l*(l+1)/2+m+1, l=0,lmax, m=0,l;
c            w(1,lm) is real part, w(2,lm) is imaginary part (if im>=2).
c         lmax = maximum harmonic number of harmonics to include.
c         mmax = include azimuthal harmonics -mmax to + mmax
c              = lmax normally, but other values are acceptable.
c         im = row dimension of harmonics w.
c         nw = [(lmax+1)*(lmax+2)]/2
c         lsmooth = smoothing harmonic number
c                 = 0 (or < 0) to skip smoothing.
c         esmooth = exponent of smoothing, ignored if lsmooth <= 0
c                 = 2 for Gaussian smoothing.
c Output: wrho = sum w_lm Y_lm
c                    * exp{-[l(l+1)/lsmooth(lsmooth+1)]**(esmooth/2)]}
c
      lmax1=lmax+1
      mmax1=mmax+1
      lsmoot1=lsmooth+1._10
      cel=cos(el)
      sel=sin(el)
      phi=az
      wrho=0._10
      do 180 m1=1,mmax1
        m=m1-1
        am=m
        if (m.eq.0) then
c        zn=z(0,0)
          zn=1._10/sqrt(4._10*PI)
          cm=1._10
          sm=0._10
        elseif (m.gt.0) then
c        zn=z(m,m)
          zn=-sqrt((am-HALF)/am)*cel*zn
          cm=2._10*cos(am*phi)
          if (im.eq.2) sm=2._10*sin(am*phi)
        endif
        z=0._10
        zp=zn
        lm=(m*m1)/2+1
        do 160 l1=m1,lmax1
          al1=l1
          l=l1-1
          al=l
c        zm=z(l-1,m); z=z(l,m); zp=z(l+1,m)
          zm=z
          z=zp
          t=al1+al
          tm=sqrt((al+am)*(al-am))
          tp=sqrt((al1+am)*(al1-am))
          zp=(t*sel*z-tm*zm)/tp
          y=z*sqrt(t)
c        dwrho=w(l,m)*Y(l,m)+w(l,-m)*Y(l,-m)
          lm=lm+l
          dwrho=cm*w(1,lm)
          if (im.eq.2) dwrho=dwrho-sm*w(2,lm)
          dwrho=dwrho*y
          if (lsmooth.gt.0._10) then
            smooth=exp(-(al/lsmooth*al1/lsmoot1)**(esmooth/2._10))
            dwrho=dwrho*smooth
          endif
          wrho=wrho+dwrho
c         write (*,'(2i4,i6,5g12.4)') l,m,lm,sm,cm,y,(w(i,lm),i=1,im)
  160   continue
  180 continue
      return
      end
c

!CAMB spherical and hyperspherical Bessel function routines
!This version May 2006 - minor changes to bjl (http://cosmocoffee.info/viewtopic.php?t=530)
!Feb 2007: fixed for high l, uses Ranges
!Feb 2009: minor fix for non-flat compiled with non-smart IF evaluation
!Dec 2011: minor tweak to DoRecurs for smoother errors across flat for L~O(30)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!Flat bessel function module

        module SpherBessels
        use Precision
        use ModelParams
        use Ranges
        implicit none
        private
        
!     Bessel functions and their second derivatives for interpolation
    
        real(dl), dimension(:,:), allocatable ::  ajl,ajlpr, ddajlpr

        integer  num_xx, kmaxfile, file_numl,  file_l(lmax_arr)
!      parameters for working out where the flat Bessel functions are small
!      Both should increase for higher accuracy
!        real(dl), parameter :: xlimmin=15._dl  , xlimfrac = 0.05_dl 
         real(dl), parameter :: xlimmin=35._dl  , xlimfrac = 0.05_dl 
        
        Type(Regions):: BessRanges

        public ajl, ajlpr, ddajlpr, BessRanges, InitSpherBessels, xlimmin, xlimfrac
        public USpherBesselWithDeriv, phi_recurs,phi_langer, bjl, Bessels_Free
 
       contains

         
      subroutine InitSpherBessels
!     This subroutine reads the jl files from disk (or generates them if not on disk)
      use lvalues
      implicit none

      !See if already loaded with enough (and correct) lSamp%l values and k*eta values
      if (allocated(ajl) .and. (lSamp%l0 <= file_numl) .and. all(file_l(1:lSamp%l0)-lSamp%l(1:lSamp%l0)==0) &
                    .and. (int(min(max_bessels_etak,CP%Max_eta_k))+1 <= kmaxfile)) return

      !Haven't made them before, so make them now
      call GenerateBessels
    
      if (DebugMsgs .and. FeedbackLevel > 0) write(*,*) 'Calculated Bessels'

      end subroutine InitSpherBessels

     subroutine GenerateBessels
       use lvalues
       real(dl) x
       real(dl) xlim
       integer i,j
       integer max_ix
       real(dl), parameter :: bessel_boost =1._dl 

 
        if (DebugMsgs .and. FeedbackLevel > 0) write (*,*) 'Generating flat Bessels...'
      

        file_numl= lSamp%l0 
        file_l(1:lSamp%l0) = lSamp%l(1:lSamp%l0)
        kmaxfile = int(min(CP%Max_eta_k,max_bessels_etak))+1
        if (do_bispectrum) kmaxfile = kmaxfile*2
     

        call Ranges_Init(BessRanges)

        call Ranges_Add_delta(BessRanges,0._dl, 1._dl,0.01_dl/bessel_boost)
        call Ranges_Add_delta(BessRanges,1._dl, 5._dl,0.1_dl/bessel_boost)
        call Ranges_Add_delta(BessRanges,5._dl, 25._dl,0.2_dl/bessel_boost)
        call Ranges_Add_delta(BessRanges,25._dl, 150._dl,0.5_dl/bessel_boost/AccuracyBoost)
        call Ranges_Add_delta(BessRanges,150._dl, real(kmaxfile,dl),0.8_dl/bessel_boost/AccuracyBoost)

        call Ranges_GetArray(bessRanges, .false.)
        num_xx = BessRanges%npoints


       max_ix = min(max_bessels_l_index,lSamp%l0)

       if (allocated(ajl)) deallocate(ajl)
       if (allocated(ajlpr)) deallocate(ajlpr)
       if (allocated(ddajlpr)) deallocate(ddajlpr)
       Allocate(ajl(1:num_xx,1:max_ix))
       Allocate(ajlpr(1:num_xx,1:max_ix))
       Allocate(ddajlpr(1:num_xx,1:max_ix))

       !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC), PRIVATE(j,i,x,xlim)
       do j=1,max_ix
       
         do  i=1,num_xx
            x=BessRanges%points(i)
            xlim=xlimfrac*lSamp%l(j)
            xlim=max(xlim,xlimmin)
            xlim=lSamp%l(j)-xlim
            if (x > xlim) then
               if ((lSamp%l(j)==3).and.(x <=0.2) .or. (lSamp%l(j) > 3).and.(x < 0.5) .or. &
                            (lSamp%l(j)>5).and.(x < 1.0)) then
                   ajl(i,j)=0
                 else
                  !if ( lSamp%l(j) > 40000) then
                  ! ajl(i,j) = phi_langer(lSamp%l(j),0,1._dl,x)
                  !else
                   call bjl(lSamp%l(j),x,ajl(i,j))
                  !end if
               end if
            else
                  ajl(i,j)=0
            end if
         end do

!     get the interpolation matrix for bessel functions
        call spline(BessRanges%points,ajl(1,j),num_xx,spl_large,spl_large,ajlpr(1,j))
        call spline(BessRanges%points,ajlpr(1,j),num_xx,spl_large,spl_large,ddajlpr(1,j))
         
      end do
     !$OMP END PARALLEL DO

     end subroutine GenerateBessels

     subroutine Bessels_Free

       if (allocated(ajl)) deallocate(ajl)
       if (allocated(ajlpr)) deallocate(ajlpr)
       if (allocated(ddajlpr)) deallocate(ddajlpr)
       call Ranges_Free(BessRanges)

     end  subroutine Bessels_Free

 
         SUBROUTINE BJL(L,X,JL)
        !!== MODIFIED SUBROUTINE FOR SPHERICAL BESSEL FUNCTIONS.                       ==!!
        !!== CORRECTED THE SMALL BUGS IN PACKAGE CMBFAST&CAMB(for l=4,5, x~0.001-0.002)==!! 
        !!== CORRECTED THE SIGN OF J_L(X) FOR X<0 CASE                                 ==!!
        !!== WORKS FASTER AND MORE ACCURATE FOR LOW L, X<<L, AND L<<X cases            ==!! 
        !!== zqhuang@astro.utoronto.ca                                                 ==!!
        IMPLICIT NONE
        INTEGER L
        real(dl) X,JL
        real(dl) AX,AX2
        real(dl),PARAMETER::LN2=0.6931471805599453094D0
        real(dl),PARAMETER::ONEMLN2=0.30685281944005469058277D0
        real(dl),PARAMETER::PID2=1.5707963267948966192313217D0
        real(dl),PARAMETER::PID4=0.78539816339744830961566084582D0
        real(dl),parameter::ROOTPI12 = 21.269446210866192327578D0
        real(dl),parameter::GAMMA1 =   2.6789385347077476336556D0 !/* Gamma function of 1/3 */
        real(dl),parameter::GAMMA2 =   1.3541179394264004169452D0 !/* Gamma function of 2/3 */
        real(dl),PARAMETER::PI=3.141592653589793238463D0
        real(dl) NU,NU2,BETA,BETA2,COSB
        real(dl) sx,sx2
        real(dl) cotb,cot3b,cot6b,secb,sec2b
        real(dl) trigarg,expterm,L3

        IF(L.LT.0)THEN
            write(*,*) 'Can not evaluate Spherical Bessel Function with index l<0'
            STOP
        ENDIF
        AX=DABS(X)
        AX2=AX**2
        IF(L.LT.7)THEN
            IF(L.EQ.0)THEN
                IF(AX.LT.1.D-1)THEN
                    JL=1.D0-AX2/6.D0*(1.D0-AX2/20.D0)
                ELSE
                    JL=DSIN(AX)/AX
                ENDIF

            ELSEIF(L.EQ.1)THEN
                IF(AX.LT.2.D-1)THEN
                    JL=AX/3.D0*(1.D0-AX2/10.D0*(1.D0-AX2/28.D0))
                ELSE
                    JL=(DSIN(AX)/AX-DCOS(AX))/AX
                ENDIF
            ELSEIF(L.EQ.2)THEN
                IF(AX.LT.3.D-1)THEN
                    JL=AX2/15.D0*(1.D0-AX2/14.D0*(1.D0-AX2/36.D0))
                ELSE
                    JL=(-3.0D0*DCOS(AX)/AX-DSIN(AX)*(1.D0-3.D0/AX2))/AX
                ENDIF
            ELSEIF(L.EQ.3)THEN
                IF(AX.LT.4.D-1)THEN
                    JL=AX*AX2/105.D0*(1.D0-AX2/18.D0*(1.D0-AX2/44.D0))
                ELSE
                    JL=(DCOS(AX)*(1.D0-15.D0/AX2)-DSIN(AX)*(6.D0-15.D0/AX2)/AX)/AX
                ENDIF
            ELSEIF(L.EQ.4)THEN
                IF(AX.LT.6.D-1)THEN
                    JL=AX2**2/945.D0*(1.D0-AX2/22.D0*(1.D0-AX2/52.D0))
                ELSE
                    JL=(DSIN(AX)*(1.D0-(45.D0-105.D0/AX2)/AX2)+DCOS(AX)*(10.D0-105.D0/AX2)/AX)/AX
                ENDIF
            ELSEIF(L.EQ.5)THEN
                IF(AX.LT.1.D0)THEN
                    JL=AX2**2*AX/10395.D0*(1.D0-AX2/26.D0*(1.D0-AX2/60.D0))
                ELSE
                    JL=(DSIN(AX)*(15.D0-(420.D0-945.D0/AX2)/AX2)/AX-DCOS(AX)*(1.D0-(105.D0-945.0d0/AX2)/AX2))/AX
                ENDIF
            ELSE
                IF(AX.LT.1.D0)THEN
                    JL=AX2**3/135135.D0*(1.D0-AX2/30.D0*(1.D0-AX2/68.D0))
                ELSE
                    JL=(DSIN(AX)*(-1.D0+(210.D0-(4725.D0-10395.D0/AX2)/AX2)/AX2)+ &
                        DCOS(AX)*(-21.D0+(1260.D0-10395.D0/AX2)/AX2)/AX)/AX
                ENDIF
            ENDIF
        ELSE
            NU=0.5D0+L
            NU2=NU**2
            IF(AX.LT.1.D-40)THEN
                JL=0.D0
            ELSEIF((AX2/L).LT.5.D-1)THEN
                JL=DEXP(L*DLOG(AX/NU)-LN2+NU*ONEMLN2-(1.D0-(1.D0-3.5D0/NU2)/NU2/30.D0)/12.D0/NU) &
                   /NU*(1.D0-AX2/(4.D0*NU+4.D0)*(1.D0-AX2/(8.D0*NU+16.D0)*(1.D0-AX2/(12.D0*NU+36.D0))))
            ELSEIF((real(L,dl)**2/AX).LT.5.D-1)THEN
                BETA=AX-PID2*(L+1)
                JL=(DCOS(BETA)*(1.D0-(NU2-0.25D0)*(NU2-2.25D0)/8.D0/AX2*(1.D0-(NU2-6.25)*(NU2-12.25D0)/48.D0/AX2)) &
                   -DSIN(BETA)*(NU2-0.25D0)/2.D0/AX* (1.D0-(NU2-2.25D0)*(NU2-6.25D0)/24.D0/AX2*(1.D0-(NU2-12.25)* &
                       (NU2-20.25)/80.D0/AX2)) )/AX   
            ELSE
                L3=NU**0.325
                IF(AX .LT. NU-1.31*L3) then
                    COSB=NU/AX
                    SX = DSQRT(NU2-AX2)
                    COTB=NU/SX
                    SECB=AX/NU
                    BETA=DLOG(COSB+SX/AX)
                    COT3B=COTB**3
                    COT6B=COT3B**2
                    SEC2B=SECB**2
                    EXPTERM=( (2.D0+3.D0*SEC2B)*COT3B/24.D0 &
                       - ( (4.D0+SEC2B)*SEC2B*COT6B/16.D0 &
                       + ((16.D0-(1512.D0+(3654.D0+375.D0*SEC2B)*SEC2B)*SEC2B)*COT3B/5760.D0 &
                       + (32.D0+(288.D0+(232.D0+13.D0*SEC2B)*SEC2B)*SEC2B)*SEC2B*COT6B/128.D0/NU)*COT6B/NU) &
                       /NU)/NU
                    JL=DSQRT(COTB*COSB)/(2.D0*NU)*DEXP(-NU*BETA+NU/COTB-EXPTERM)

                !          /**************** Region 2: x >> l ****************/

                ELSEIF (AX .GT. NU+1.48*L3) then
                    COSB=NU/AX
                    SX=DSQRT(AX2-NU2)
                    COTB=NU/SX
                    SECB=AX/NU
                    BETA=DACOS(COSB)
                    COT3B=COTB**3
                    COT6B=COT3B**2
                    SEC2B=SECB**2
                    TRIGARG=NU/COTB-NU*BETA-PID4 &
                           -((2.0+3.0*SEC2B)*COT3B/24.D0  &
                           +(16.D0-(1512.D0+(3654.D0+375.D0*SEC2B)*SEC2B)*SEC2B)*COT3B*COT6B/5760.D0/NU2)/NU
                    EXPTERM=( (4.D0+sec2b)*sec2b*cot6b/16.D0 &
                           -(32.D0+(288.D0+(232.D0+13.D0*SEC2B)*SEC2B)*SEC2B)*SEC2B*COT6B**2/128.D0/NU2)/NU2
                    JL=DSQRT(COTB*COSB)/NU*DEXP(-EXPTERM)*DCOS(TRIGARG)

                !          /***************** Region 3: x near l ****************/

                ELSE
                    BETA=AX-NU
                    BETA2=BETA**2
                    SX=6.D0/AX
                    SX2=SX**2
                    SECB=SX**0.3333333333333333d0
                    SEC2B=SECB**2
                    JL=( GAMMA1*SECB + BETA*GAMMA2*SEC2B &
                          -(BETA2/18.D0-1.D0/45.D0)*BETA*SX*SECB*GAMMA1 &
                          -((BETA2-1.D0)*BETA2/36.D0+1.D0/420.D0)*SX*SEC2B*GAMMA2   &
                          +(((BETA2/1620.D0-7.D0/3240.D0)*BETA2+1.D0/648.D0)*BETA2-1.D0/8100.D0)*SX2*SECB*GAMMA1 &
                          +(((BETA2/4536.D0-1.D0/810.D0)*BETA2+19.D0/11340.D0)*BETA2-13.D0/28350.D0)*BETA*SX2*SEC2B*GAMMA2 &
                          -((((BETA2/349920.D0-1.D0/29160.D0)*BETA2+71.D0/583200.D0)*BETA2-121.D0/874800.D0)* &
                           BETA2+7939.D0/224532000.D0)*BETA*SX2*SX*SECB*GAMMA1)*DSQRT(SX)/ROOTPI12
                ENDIF
            ENDIF
        ENDIF
        IF(X.LT.0.AND.MOD(L,2).NE.0)JL=-JL
        END SUBROUTINE BJL    

 !    end module SpherBessels




!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!                                                                      c
! Calculation of ultraspherical Bessel functions.                      c
! Fortran version of the c program hyperjl.c by Arthur Kosowsky.       c
! WKB approx described in astro-ph/9805173                             c
!                                                                      c
! Modifications by Anthony Challinor and Antony Lewis                  c
! Minor modifications to correct K=1 case outside [0,pi],              c
! the small chi approximations for lSamp%l=0 and lSamp%l=1, and                    c
! the quadratic approximation to Q(x) around Q(x)=0.                   c
! Bug fixed in downwards recursion (phi_recurs)                        c
!                                                                      c
! The routine phi_recurs uses recursion relations to calculate         c
! the functions, which is accurate but relatively slow.                c  
!   ***NOT STABLE FOR K=1 or for all cases ***                         c
!                                                                      c
! The routine phi_langer uses Langer's formula for a                   c
! uniform first-order asymptotic approximation in the open, closed     c
! and flat cases. This approximation is EXCELLENT for all lSamp%l >= 3.      c
!                                                                      c
! The routine qintegral calculates the closed-form answer              c
! to the eikonal integral used in the WKB approximation.               c
!                                                                      c
! The routine airy_ai returns the Airy function Ai(x) of the argument  c
! passed. It employs a Pade-type approximation away from zero and      c
! a Taylor expansion around zero. Highly accurate.                     c
!                                                                      c
! The routines polevl and p1evl are auxiliary polynomial               c
! evaluation routines used in the airy function calculation.           c
!                                                                      c
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



! module USpherBessels
! use Precision
! implicit none
! private 
 
 
 !public USpherBesselWithDeriv, phi_recurs,phi_langer
 
 
! contains

        subroutine USpherBesselWithDeriv(closed,Chi,l,beta,y1,y2)
          !returns y1=ujl*sinhChi and y2=diff(y1,Chi)
          !aim for accuracy > 1% for all inputs
        real(dl) Chi,beta,y1,y2,sinhChi,cothChi
        real(dl) sin_K, cot_K
        integer l,K
        logical, intent(IN) :: closed
        logical DoRecurs
        
        if (closed) then
            sin_K = sin(Chi) 
            cot_K= 1._dl/tan(Chi)
            K=1
         else 
            sin_K=sinh(Chi)
            cot_K = 1._dl/tanh(Chi)
            K=-1
         end if
      
        sinhChi = sin_K
        cothChi = cot_K
   
       DoRecurs = ((l<=45*AccuracyBoost).OR.((.not.closed.or.(abs(Chi-pi/2)>0.2d0)).and.(beta*l<750) &
            .or.closed.and.(beta*l<4000)))

!Deep in the tails the closed recursion relation is not stable
!Added July 2003 to prevent problems with very nearly flat models
       if (DoRecurs .and. closed) then
        if  (Chi < asin(sqrt(l*(l+1._dl))/beta) - 2/beta) then
           if (phi_langer(l,K,beta,Chi) < 1e-7) then
             call phi_small_closed_int(l,beta,chi,y1,y2)
             return
           end if 
       end if    
     end if        

     if (DoRecurs) then 
             !use recursive evaluation where WKB is poor and recurs is fast anyway.
         y1=phi_recurs(l,K,beta,Chi)*sinhChi
         y2=y1*(l+1)*cothChi
         if (.not.closed.or.(l+1<nint(beta))) y2=y2 - &
              sqrt(beta**2-(K*(l+1)**2))*phi_recurs(l+1,K,beta,Chi)*sinhChi
          !of course we could get y2 much more quickly by modifying
          !phi_recurs to return l and l+1 for each beta,Chi...


         else !WKB approx
         y1=phi_langer(l,K,beta,Chi)*sinhChi
         y2=y1*(l+1)*cothChi   
         if (.not.closed.or.(l+1<nint(beta))) y2=y2 - &
              sqrt(beta**2-(K*(l+1)**2))*phi_langer(l+1,K,beta,Chi)*sinhChi  
         
         end if
        
        end subroutine USpherBesselWithDeriv



!Calculates y1,y2 (noramlized to a value near the turning point)  
!by integrating up the differential equation and normalizing to phi_recurs
!in the region in which phi_recurs is stable
!This allows closed functions to be computed where chi << turning point
   subroutine phi_small_closed_int(l,beta,chi,y1,y2)
   integer, intent(IN) :: l
   real(dl), intent(IN) :: beta, chi
   real(dl) y1,y2
   
   integer nsteps,i
  
   real(dl) ap1,nu2,dydchi1,dydchi2,yt1,yt2,dyt1,dyt2,dym1,dym2
   real(dl) x0, delchi,sh, h6,x
   real(dl) y1_x,y2_x, tmp,xh,hh
 
   nsteps = 200
   ap1 = l*(l+1)
   x0 = sqrt(ap1)/beta
   nu2 = beta**2

   if ((beta*chi)**2/l < 0.005) then
 !Series solution
    
     x = chi
     sh = sin(x)
     tmp=(ap1/sh**2 - nu2)
     y1=1e-20  
     y2 = ((l+1)/x - (nu2-ap1/3)/(2*l+3)*x) * y1
   else

   x = max(1d-7,chi - 50._dl/l)
   y1=1e-20  
   y2 = (l+1)*y1/x
   
   delchi = (chi-x)/nSteps
   h6=delchi/6
   hh=delchi/2
   sh = sin(x)
   tmp=(ap1/sh**2 - nu2) 
   
          do i=1,nSteps          
! One step in the ujl integration
! fourth-order Runge-Kutta method to integrate equation for ujl

            dydchi1=y2         !deriv y1
            dydchi2=tmp*y1     !deriv y2     
            xh=x+hh          !midpoint of step
            yt1=y1+hh*dydchi1  !y1 at midpoint
            yt2=y2+hh*dydchi2  !y2 at midpoint
            dyt1=yt2           !deriv y1 at mid
            tmp=(ap1/sin(xh)**2 - nu2) 
            
            
            dyt2=tmp*yt1       !deriv y2 at mid
       
            yt1=y1+hh*dyt1     !y1 at mid
            yt2=y2+hh*dyt2     !y2 at mid
           
            dym1=yt2           !deriv y1 at mid
            dym2=tmp*yt1       !deriv y2 at mid
            yt1=y1+delchi*dym1 !y1 at end
            dym1=dyt1+dym1     
            yt2=y2+delchi*dym2 !y2 at end
            dym2=dyt2+dym2
            
            x=x+delchi     !end point
            sh=sin(x)    
            dyt1=yt2           !deriv y1 at end
            tmp=(ap1/sh**2 - nu2)
            dyt2=tmp*yt1       !deriv y2 at end
            y1=y1+h6*(dydchi1+dyt1+2*dym1) !add up
            y2=y2+h6*(dydchi2+dyt2+2*dym2)       
           if (y1 > 1d10 .or. y2> 1d10) then
         
              y1=y1/1d10
              y2=y2/1d10
        
           end if
         end do

      end if     
   
       y1_x = y1; y2_x = y2 

       delchi = (x0 - chi)/nSteps
       h6=delchi/6
       hh=delchi/2

          do i=1,nSteps          
! One step in the ujl integration
! fourth-order Runge-Kutta method to integrate equation for ujl

            dydchi1=y2         !deriv y1
            dydchi2=tmp*y1     !deriv y2     
            xh=x+hh          !midpoint of step
            yt1=y1+hh*dydchi1  !y1 at midpoint
            yt2=y2+hh*dydchi2  !y2 at midpoint
            dyt1=yt2           !deriv y1 at mid
            tmp=(ap1/sin(xh)**2 - nu2) 
            
            
            dyt2=tmp*yt1       !deriv y2 at mid
       
            yt1=y1+hh*dyt1     !y1 at mid
            yt2=y2+hh*dyt2     !y2 at mid
           
            dym1=yt2           !deriv y1 at mid
            dym2=tmp*yt1       !deriv y2 at mid
            yt1=y1+delchi*dym1 !y1 at end
            dym1=dyt1+dym1     
            yt2=y2+delchi*dym2 !y2 at end
            dym2=dyt2+dym2
            
            x=x+delchi     !end point
            sh=sin(x)    
            dyt1=yt2           !deriv y1 at end
            tmp=(ap1/sh**2 - nu2)
            dyt2=tmp*yt1       !deriv y2 at end
            y1=y1+h6*(dydchi1+dyt1+2*dym1) !add up
            y2=y2+h6*(dydchi2+dyt2+2*dym2)       
            if (y1 > 1d10 .or. y2 > 1d10) then
              y1=y1/1d10
              y2=y2/1d10
              y1_x = y1_x/1d10
              y2_x = y2_x/1d10
        
            end if
         end do


         tmp = phi_recurs(l,1,beta,x0)*sin(x0) / y1
         y1 = y1_x * tmp
         y2 = y2_x * tmp


   end subroutine phi_small_closed_int
 
!***********************************************************************
!                                                                      *
! Calculates Phi(l,beta,chi) using recursion on l.                     *
! See Abbot and Schaefer, ApJ 308, 546 (1986) for needed               *
! recursion relations and closed-form expressions for l=0,1.           *
! (Note: Their variable y is the same as chi here.)                    *
!                                                                      *
! When the flag direction is negative, downwards recursion on l        *
! must be used because the upwards direction is unstable to roundoff   *
! errors. The downwards recursion begins with arbitrary values and     *
! continues downwards to l=1, where the desired l value is normalized  *
! using the closed form solution for l=1. (See, e.g., Numerical        *
! Recipes of Bessel functions for more detail)                         *
!                                                                      *
!***********************************************************************

  function phi_recurs(l, K, beta, chi)
  !doesn't like values which give exponentially small phi
  integer, intent(IN) :: l, K
  real(dl), intent(IN) :: beta, chi
  real(dl) phi_recurs
  integer j, direction, lstart,ibeta
  real(dl) ell, kay, arg, answer,beta2
  real(dl) root_K
  real(dl) phi0, phi1, phi_plus, phi_zero, phi_minus, b_zero, b_minus 
  real(dl), parameter :: ACC=40._dl, BIG=1.d10
  real(dl) sin_K, cot_K

  ell=dble(l)
 
 
  ! Test input values

  if(l<0) then
     write(*,*) "Bessel function index ell < 0"
     stop
  endif
  if(beta<0._dl) then
     write(*,*) "Wavenumber beta < 0"
     stop
  endif
  if ((abs(K)/=1).and.(K/=0)) then
     write(*,*) "K must be 1, 0 or -1"
     stop
  end if
  
  if(K==1) then    
     ibeta=nint(beta)
     if(ibeta<3) then
        write(*,*) "Wavenumber beta < 3 for K=1"
        stop
     endif
     if(ibeta<=l) then
        write(*,*) "Wavenumber beta <= l"
        stop
     endif
  endif
 
  if (chi<1/BIG) then
     phi_recurs=0
     return
  end if
 
  kay = dble(K)
  arg = beta * chi
  beta2 = beta**2

  if(K == 0) then
     cot_K = 1._dl/chi
     sin_K = chi
     root_K = beta
  else 
   root_K = sqrt(beta2 -kay*ell*ell)
  
    if(K == -1) then
    cot_K = 1._dl/tanh(chi)
    sin_K = sinh(chi)   
    else
    cot_K = 1._dl/tan(chi)
    sin_K = sin(chi)   
    end if
  
  endif
 
  
  ! Closed form solution for l=0
 
  if (abs(chi) < 1.d-4) then
    if (abs(arg)<1.d-4) then
     phi0 = 1._dl-chi**2*(beta*beta-kay)/6._dl
    else
     phi0=sin(arg)/arg
    end if
  else     
     phi0 = sin(arg) / (beta * sin_K)
  end if

  if (l==0) then
       phi_recurs=phi0
       return 
   end if


     ! Closed form solution for l=1

     if((abs(chi) < 1.d-4).and.(K/=0)) then
        if(arg < 1.d-4) then
           phi1 = chi*sqrt(beta*beta-kay)/3._dl
           !beta2 * chi / (3._dl * sqrt(1._dl+ kay * beta2))
        else 
           phi1 = (sin(arg)/arg-cos(arg))/(sqrt(beta*beta-kay)*chi)
             !(sin(arg)/arg - cos(arg))/arg
        end if
     elseif ((abs(arg) < 1.d-4).and.(K == 0)) then
        phi1 = arg / 3._dl
     else 
        if (K /= 0 ) then
           phi1 = sin(arg) * cot_K / (beta * sin_K) - cos(arg) / sin_K
           phi1 = phi1/sqrt(beta2 - kay)
        else
           phi1 = (sin(arg)/arg - cos(arg))/arg
        end if
     end if
     if(l==1) then
        phi_recurs=phi1
        return
     end if
     ! Find recursion direction
     !  direction = +1 for upward recursion, -1 for downward

     if(abs(cot_K) < root_K / ell) then 
        direction = 1
     else 
        direction = -1
     end if
    
     ! For K=1, must do upwards recursion:
     ! NOT STABLE for all values of chi

     if(K==1) direction = 1

     ! Do upwards recursion on l
    
     
     if(direction == 1)then
        b_minus = sqrt(beta2 - kay)
        phi_minus = phi0
        phi_zero = phi1
      
        do j=2,l 
           
           if(K == 0) then
              phi_plus = ((2*j-1) * cot_K * phi_zero - beta*phi_minus)/ beta
           else 
              b_zero = sqrt(beta2 - (K*j*j))  
              phi_plus = ((2*j-1) * cot_K * phi_zero - b_minus * phi_minus) / b_zero
              b_minus = b_zero
           end if
           phi_minus = phi_zero
           phi_zero = phi_plus
        end do
      
      
        phi_recurs=phi_plus
        
     
        return

        ! Do downwards recursion on l

     else 
        lstart = l + 2 * int(sqrt(ell*ACC))
      
        b_zero = sqrt(beta2 - dble(K*lstart*lstart))
        phi_plus = 0._dl
        phi_zero = 1._dl
        answer = 0._dl
       
        do j= lstart - 2,1,-1
           
           if(K == 0) then
              phi_minus = ((2*j + 3) * cot_K * phi_zero - beta * phi_plus) / beta
           else
              b_minus = sqrt(beta2 - (K*(j+1)**2))  
              phi_minus = ((2*j + 3) * cot_K * phi_zero - b_zero * phi_plus) / b_minus
              b_zero = b_minus
           end if
           phi_plus = phi_zero
           phi_zero = phi_minus

           if(j == l) answer = phi_minus
           if((abs(phi_zero) > BIG).and.(j/=1)) then
              phi_plus = phi_plus/BIG
              phi_zero = phi_zero/BIG            
              answer = answer/BIG
           end if
        end do

        ! Normalize answer to previously computed phi1

        answer = answer*phi1 / phi_minus
        phi_recurs=answer    
       
     end if
 
   end function phi_recurs


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!                                                                      c
! Calculates Phi(l,beta,chi) using the Langer uniform approximation    c
! to the first-order WKB approximation.                                c
! See C.M. Bender and S.A. Orszag,  Mathematical Methods for           c
! Scientists and Engineers (McGraw-Hill, 1978; LC QA371.B43),          c
! chapter 10.                                                          c
!                                                                      c
! Differential equation for needed function can be cast into the       c
! Schrodinger form      \epsilon^2 y'' = Q(x) y                        c
! where \epsilon^2 = 1/l(l+1) and Q(x) depends on the parameter        c
! alpha \equiv beta * epsilon.                                         c
!                                                                      c
! In the K= +1 case, the function is                                   c
! determined by its value on the interval [0, pi/2] and the symmetry   c
! conditions Phi(chi + pi) = (-1)^{beta - l - 1} Phi(chi),             c
!            Phi(pi - chi) = (-1)^{beta - l - 1} Phi(chi).             c
! This interval contains one turning point, so the Langer formula      c
! can be used.                                                         c
! Note that the second condition at chi = pi/2 gives an eigenvalue     c
! condition on beta, which  must corrected. For the lowest             c
! eigenvalue(s), the region between the turning points is not large    c
! enough for the asymptotic solution to be valid, so the functions     c
! have a small discontinuity or discontinuous derivative at pi/2;      c
! this behavior is corrected by employing a 4-term asymptotic          c
! series around the regular point chi=pi/2.                            c
! The exact eigenvalue condition requires that beta must be an         c
! integer >= 3 with beta > l. Note this implies alpha > 1.             c
!                                                                      c
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      


      function phi_langer(l,K,beta,chi)
      integer l,K,ibeta,kay
      real(dl) phi_langer
      real(dl) ell,symm, anu, alpha2
      real(dl) beta,chi,eikonal, wkb, arg, arg2, tmp
      real(dl) epsilon, alpha, chi0, x, a, b,achi 
    
      real(dl) cot_K, sin_K
      real(dl), parameter :: PI=3.1415926536d0,ROOTPI=1.772453851d0,ROOT2PI=2.506628275d0, &
                           PIOVER2=1.570796327d0

      ell=dble(l)
      achi=chi
   
      symm=1._dl
!
! Test input values
!
      if(l<0) then
         write(*,*) "Bessel function index ell < 0"
         stop
      endif
      if(beta<0._dl) then
         write(*,*) "Wavenumber beta < 0"
         stop
      endif
      if ((abs(K)/=1).and.(K/=0)) then
        write(*,*) "K must be 1, 0 or -1"
        stop
      end if

      
      if(K == 1) then        
         ibeta=nint(beta)
         if(ibeta<3) then
            write(*,*) "Wavenumber beta < 3 for K=1"
            stop
         endif
         if(ibeta<=l) then
            write(*,*) "Wavenumber beta <= l"
            stop
         endif
      endif
   
      kay=K


! For closed case, find equivalent chi in [0,pi/2]
!
      if(K==1) then
         achi=achi-2._dl*Pi*int(achi/2._dl/PI)
         if(achi>PI) then
            achi=2._dl*PI-achi
            if(2*(l/2).eq.l) then
               symm=symm
            else
               symm=-symm
            endif
         endif
         if(achi>PI/2._dl) then
            achi=PI-achi
            if(2*((ibeta-l-1)/2).eq.(ibeta-l-1)) then
               symm=symm
            else
               symm=-symm
            endif
         endif
      endif

! Definitions
      if(K == 0) then
          sin_K = achi         
      else 
            if(K == -1) then
               sin_K = sinh(achi)   
             else
               sin_K = sin(achi)   
            end if           
      endif 

! Closed form solution for l=0
!
      if(l == 0) then
         arg=beta*achi
       
         if((abs(achi)<1.d-4).and.(K/=0)) then
            if(abs(arg)<1.d-4) then
               wkb=1._dl-achi*achi*(beta*beta-kay)/6._dl
            else
               wkb=sin(arg)/arg
            endif
         else if((abs(arg)<1.d-4).and.(K==0)) then
            wkb=1._dl-arg*arg/6._dl
         else
            wkb=sin(arg)/(beta*sin_K)
         endif
         phi_langer=symm*wkb
         return
      endif
!
! Closed form solution for l=1
!
      if(l==1) then
         arg=beta*achi
      
         if((abs(achi)<1.d-4).and.(K/=0)) then
            if(abs(arg)<1.d-4) then
               wkb=achi*sqrt(beta*beta-kay)/3._dl
            else
               wkb=(sin(arg)/arg-cos(arg))/(sqrt(beta*beta-kay)*achi)
            endif
         else if((abs(arg)<1.d-4).and.(K==0)) then
            wkb=arg/3._dl
         else 
          if(K/=0) then
            if(K==1) then
               cot_K=1._dl/tan(achi)
            else
               cot_K=1._dl/tanh(achi)
            endif
            wkb=sin(arg)*cot_K/(beta*sin_K)-cos(arg)/sin_K
            wkb=wkb/sqrt(beta*beta-kay)
         else
            wkb=(sin(arg)/arg-cos(arg))/arg
         endif
         end if
         phi_langer=symm*wkb
         return
      endif
!
! Closed form solution for K=1 and beta = l+1 (lowest eigenfunction)
!
      if((K==1).and.(ibeta == (l+1))) then
         wkb=(sin_K**ell)* &
              sqrt(sqrt(2._dl*PI/(2._dl*ell+1._dl))*ell/((ell+1._dl)*(2._dl*ell+1._dl)))
         wkb=wkb*(1+0.1875d0/ell-0.013671875/(ell*ell))
         phi_langer=symm*wkb
         return
      endif

! Very close to 0, return 0 (exponentially damped)
!
      if(abs(achi)<1.d-8) then
         phi_langer=0._dl
         return
      endif


! For closed case, find corrected eigenvalue beta
!
      if(K==1) then
         anu=dble(ibeta)-1._dl/(8._dl*ell)+1._dl/(16._dl*ell*ell)
      else
         anu=beta
      endif
!
! Evaluate epsilon using asymptotic form for large l
!
      if(l<20) then
         epsilon=1._dl/sqrt(ell*(ell+1._dl))
      else
         epsilon=1._dl/ell-0.5d0/(ell*ell)+0.375d0/(ell*ell*ell)
      endif
     
      alpha=epsilon*anu
!
! Calculate the turning point where Q(x)=0.
! Function in question has only a single simple turning point.
!
      if(K==-1) chi0=log((1._dl+sqrt(1._dl+alpha*alpha))/alpha)
      if(K==0) chi0=1._dl/alpha
      if(K==1) chi0=asin(1._dl/alpha)
 

! Very close to chi0, use usual wkb form to avoid dividing by zero
!
      if(abs(achi-chi0)<1.d-5) then

! Calculate coefficients of linear and quadratic terms in Q(x) expansion
! in the neighborhood of the turning point
! Q(chi)=a*(chi0-chi)+b*(chi0-chi)**2
         alpha2=alpha*alpha
       
         if(K==-1) then
            a=2._dl*alpha2*sqrt(alpha2+1._dl)
            b=3._dl*alpha2**2+2._dl*alpha2
         endif
         if(K==0) then
            a=2._dl*alpha2*alpha
            b=3._dl*alpha2**2
         endif
         if(K==1) then
            a=2._dl*alpha2*sqrt(alpha2-1._dl)
            b=3._dl*alpha2**2-2._dl*alpha2
         endif
       
! Dependent variable x for which Q(x)=0 at x=0
! x>0 is the evanescent region
!
         x=chi0-achi
!
! Argument of Airy function
!
         arg=(x+b*x*x/(5._dl*a))/(epsilon*epsilon/a)**(0.333333333d0)
!
! Evaluate Airy function
!
         wkb=airy_ai(arg)
!
! Rest of functional dependence
!
         wkb=wkb*(1._dl-b*x/(5._dl*a))/sin_K 
!  Normalization factor:

         wkb=wkb*symm*ROOTPI*((a*epsilon)**(-0.1666667d0))*sqrt(epsilon/anu)
         phi_langer=wkb  
        
         return
      endif


! Langer approximation.
!
! Transport factor:
!
      tmp=sqrt(abs(1._dl/(sin_K*sin_K)-alpha*alpha))
     
! Eikonal factor
!
      eikonal=qintegral(sin_K,alpha,K)

    
     
      arg=(1.5d0*eikonal/epsilon)**(1._dl/3._dl)
   
      arg2=arg*arg
      if(achi>chi0) arg2=-arg2
      
! Multiply factors together

      wkb=airy_ai(arg2)*symm*ROOTPI*sqrt(arg*epsilon/anu/tmp)/Sin_K
      phi_langer=wkb

      end function phi_langer

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!                                                                       c
! Evaluates the exact solution to  the integral giving the WKB          c
! eikonal solution,   \int^x sqrt(abs(Q(x))) dx                         c
!                                                                       c
! In the open case, this integral costs 1 or 2 square roots, an atan    c
! and a log; its evaluation will be roughly as expensive as the rest    c
! of the Phi routine. An analytic fit cannot be substantially faster    c
! because the dependence on alpha of the y-intercept of the linear      c
! region of the integrand contains a log and an atan, so at best a fit  c
! can only save the computation of the square roots.                    c
!                                                                       c
! The integrals are very bland functions of chi and alpha and could     c
! be precomputed and cached to save computation time; interpolation     c
! on a relatively small number of points should be very accurate        c
!                                                                       c
! Note that for the closed case, the variable arg must be between 0     c
! and alpha; for arg > alpha, symmetry properties reduce the needed     c
! integral to this case.                                                c
!                                                                       c
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function qintegral(sin_K,alpha, K)
      implicit none
      real(dl) qintegral, sin_K
      integer K
      real(dl) alpha,exact,arg, root1, root2, dummyarg
     
      real(dl), parameter :: PI=3.1415926536d0,ROOTPI=1.772453851d0,ROOT2PI=2.506628275d0, &
                           PIOVER2=1.570796327d0

      arg=alpha*sin_K

      if(K==0) then
         if(arg>1._dl) then
            exact=sqrt(arg*arg-1._dl)-acos(1._dl/arg)
            qintegral=exact
            return
         else
            root1=sqrt(1._dl-arg*arg)
            exact=log((1._dl+root1)/arg)-root1
            qintegral=exact
            return
         endif
      else if(K==-1) then
         if(arg>1._dl) then
            root1=sqrt(arg*arg-1._dl)
            root2=sqrt(arg*arg+alpha*alpha)
            exact=alpha/2._dl*log((2._dl*arg*arg+alpha*alpha-1._dl+ &
                  2._dl*root1*root2)/(1._dl+alpha*alpha))+atan(root2/ &
                  (alpha*root1))-PIOVER2
            qintegral=exact
            return
         else
            root1=sqrt((1._dl-arg*arg)*(arg*arg+alpha*alpha))
            exact=alpha/2._dl*atan(-2._dl*root1/(2*arg*arg+alpha*alpha- &
                  1._dl))+0.5d0*log((2._dl*alpha*root1+2._dl*alpha*alpha+ &
                  arg*arg*(1._dl-alpha*alpha))/(arg*arg*(1._dl+ &
                  alpha*alpha)))
            if(2._dl*arg*arg+alpha*alpha-1._dl<0._dl) then
               exact=exact-alpha*PIOVER2
            endif
            qintegral=exact
            return
         endif
      else
         if(arg>1._dl) then
            root1=sqrt(arg*arg-1._dl)
            root2=sqrt(alpha*alpha-arg*arg)
            exact=alpha/2._dl*atan(-2._dl*root1*root2/ &
               (2._dl*arg*arg-alpha*alpha-1._dl))- &
               atan(-root2/(root1*alpha))-PIOVER2
            if(2._dl*arg*arg-alpha*alpha-1._dl>0._dl) then
               exact=exact+alpha*PIOVER2
            endif
         else
            root1=sqrt((1._dl-arg*arg)*(alpha*alpha-arg*arg))
            dummyarg=alpha*(1._dl-arg*arg)/root1
            exact=0.5d0*log((1._dl+dummyarg)/(1._dl-dummyarg))- &
             alpha/2._dl*log((alpha*alpha-2._dl*arg*arg+1._dl+2._dl*root1)/ &
             (alpha*alpha-1._dl))
         endif
         qintegral=exact
         return
      endif
   
      end function qintegral 

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!                                                                      c
!       Airy function                                                  c
!                                                                      c
! Modified from original routine by Stephen Moshier, available         c
! as part of the Cephes library at www.netlib.com                      c
! Modifications: eliminates calculation of Bi(x), Ai'(x), Bi'(x)       c
! and translation to Fortran                                           c
!                                                                      c
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
! DESCRIPTION:
!
! Solution of the differential equation
!
!       y"(x) = xy.
!
! The function returns the two independent solutions Ai, Bi
! and their first derivatives Ai'(x), Bi'(x).
!
! Evaluation is by power series summation for small x,
! by rational minimax approximations for large x.
!
!
!
! ACCURACY:
! Error criterion is absolute when function <= 1, relative
! when function > 1, except * denotes relative error criterion.
! For large negative x, the absolute error increases as x^1.5.
! For large positive x, the relative error increases as x^1.5.
!
! Arithmetic  domain   function  # trials      peak         rms
! IEEE        -10, 0     Ai        10000       1.6e-15     2.7e-16
! IEEE          0, 10    Ai        10000       2.3e-14*    1.8e-15*
! IEEE        -10, 0     Ai'       10000       4.6e-15     7.6e-16
! IEEE          0, 10    Ai'       10000       1.8e-14*    1.5e-15*
! IEEE        -10, 10    Bi        30000       4.2e-15     5.3e-16
! IEEE        -10, 10    Bi'       30000       4.9e-15     7.3e-16
! DEC         -10, 0     Ai         5000       1.7e-16     2.8e-17
! DEC           0, 10    Ai         5000       2.1e-15*    1.7e-16*
! DEC         -10, 0     Ai'        5000       4.7e-16     7.8e-17
! DEC           0, 10    Ai'       12000       1.8e-15*    1.5e-16*
! DEC         -10, 10    Bi        10000       5.5e-16     6.8e-17
! DEC         -10, 10    Bi'        7000       5.3e-16     8.7e-17
!
!
! Cephes Math Library Release 2.1:  January, 1989
! Copyright 1984, 1987, 1989 by Stephen lSamp%l. Moshier
! Direct inquiries to 30 Frost Street, Cambridge, MA 02140
!

      function airy_ai(x)
      implicit none
      real(dl) airy_ai
      real(dl) x,z, zz, t, f, g, uf, ug, zeta, theta
      real(dl) ak
      real(dl) AN(8),AD(8),AFN(9),AFD(9),AGN(11),AGD(10)
      real(dl), parameter :: AMAXAIRY=25.77d0,ACC=1.d-8,PI=3.1415926536d0
      real(dl), parameter :: c1=0.35502805388781723926d0, c2=0.258819403792806798405d0
      real(dl), parameter :: sqrt3=1.732050807568877293527d0,sqpii=5.64189583547756286948d-1
     
      
      AN(1)=3.46538101525629032477d-1
      AN(2)=1.20075952739645805542d1
      AN(3)=7.62796053615234516538d1
      AN(4)=1.68089224934630576269d2
      AN(5)=1.59756391350164413639d2
      AN(6)=7.05360906840444183113d1
      AN(7)=1.40264691163389668864d1
      AN(8)=9.99999999999999995305d-1

      AD(1)=5.67594532638770212846d-1
      AD(2)=1.47562562584847203173d1
      AD(3)=8.45138970141474626562d1
      AD(4)=1.77318088145400459522d2
      AD(5)=1.64234692871529701831d2
      AD(6)=7.14778400825575695274d1
      AD(7)=1.40959135607834029598d1
      AD(8)=1.00000000000000000470d0

      AFN(1)=-1.31696323418331795333d-1
      AFN(2)=-6.26456544431912369773d-1
      AFN(3)=-6.93158036036933542233d-1
      AFN(4)=-2.79779981545119124951d-1
      AFN(5)=-4.91900132609500318020d-2
      AFN(6)=-4.06265923594885404393d-3
      AFN(7)=-1.59276496239262096340d-4
      AFN(8)=-2.77649108155232920844d-6
      AFN(9)=-1.67787698489114633780d-8

      AFD(1)=1.33560420706553243746d1
      AFD(2)=3.26825032795224613948d1
      AFD(3)=2.67367040941499554804d1
      AFD(4)=9.18707402907259625840d0
      AFD(5)=1.47529146771666414581d0
      AFD(6)=1.15687173795188044134d-1
      AFD(7)=4.40291641615211203805d-3
      AFD(8)=7.54720348287414296618d-5
      AFD(9)=4.51850092970580378464d-7

      AGN(1)=1.97339932091685679179d-2
      AGN(2)=3.91103029615688277255d-1
      AGN(3)=1.06579897599595591108d0
      AGN(4)=9.39169229816650230044d-1
      AGN(5)=3.51465656105547619242d-1
      AGN(6)=6.33888919628925490927d-2
      AGN(7)=5.85804113048388458567d-3
      AGN(8)=2.82851600836737019778d-4
      AGN(9)=6.98793669997260967291d-6
      AGN(10)=8.11789239554389293311d-8
      AGN(11)=3.41551784765923618484d-10

      AGD(1)=9.30892908077441974853d0
      AGD(2)=1.98352928718312140417d1
      AGD(3)=1.55646628932864612953d1
      AGD(4)=5.47686069422975497931d0
      AGD(5)=9.54293611618961883998d-1
      AGD(6)=8.64580826352392193095d-2
      AGD(7)=4.12656523824222607191d-3
      AGD(8)=1.01259085116509135510d-4
      AGD(9)=1.17166733214413521882d-6
      AGD(10)=4.91834570062930015649d-9
!
! Exponentially tiny for large enough argument
!
      if(x>AMAXAIRY) then
         airy_ai=0._dl
         return
      endif
!
! Pade fit for large negative arguments
!
      if(x<-2.09d0) then
         t=sqrt(-x)
         zeta=-2._dl*x*t/3._dl
         t=sqrt(t)
         ak=sqpii/t
         z=1._dl/zeta
         zz=z*z
         uf=1._dl+zz*polevl(zz,AFN,8)/p1evl(zz,AFD,9)
         ug=z*polevl(zz,AGN,10)/p1evl(zz,AGD,10)
         theta=zeta+0.25d0*PI
         f=sin(theta)
         g=cos(theta)
         airy_ai=ak*(f*uf-g*ug)
         return
      endif
!
! Pade fit for large positive arguments
!
      if(x>=2.09) then
         t=sqrt(x)
         zeta=2._dl*x*t/3._dl
         g=exp(zeta)
         t=sqrt(t)
         ak=2._dl*t*g
         z=1._dl/zeta
         f=polevl(z,AN,7)/polevl(z,AD,7)
         airy_ai=sqpii*f/ak
         return
      endif
!
! Taylor series for region around x=0
!

      f=1._dl
      g=x
      t=1._dl
      uf=1._dl
      ug=x
      ak=1._dl
      z=x*x*x
     do while (t>ACC) 
         uf=uf*z
         ak=ak+1._dl
         uf=uf/ak
         ug=ug*z
         ak=ak+1._dl
         ug=ug/ak
         uf=uf/ak
         f=f+uf
         ak=ak+1._dl
         ug=ug/ak
         g=g+ug
         t=abs(uf/f)
      end do
     

      airy_ai=c1*f-c2*g
      
      end function airy_ai

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  Evaluate polynomial                                          c
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! DESCRIPTION:
!
! Evaluates polynomial of degree N:
!
!                     2          N
! y  =  C  + C x + C x  +...+ C x
!        0    1     2          N
!
! Coefficients are stored in reverse order:
!
! coef(1) = C  , ..., coef(N+1) = C  .
!            N                     0
!
! The function p1evl() assumes that C = 1.0 and is
!                                    N
! omitted from the array.  Its calling arguments are
! otherwise the same as polevl().
!
!
! SPEED:
!
! In the interest of speed, there are no checks for out
! of bounds arithmetic.  This routine is used by most of
! the functions in the library.  Depending on available
! equipment features, the user may wish to rewrite the
! program in microcode or assembly language.
!
! Cephes Math Library Release 2.1:  December, 1988
! Copyright 1984, 1987, 1988 by Stephen lSamp%l. Moshier
! Direct inquiries to 30 Frost Street, Cambridge, MA 02140
!
      function polevl(x,coef,N)
      implicit none
      real(dl) polevl
      real(dl) x,ans
      real(dl) coef
      integer N,i

      dimension coef(N+1)

      ans=coef(1)
      do i=2,N+1
         ans=ans*x+coef(i)
      end do
      polevl=ans
      
      end function polevl

!
!                                      
! Evaluate polynomial when coefficient of x  is 1.0.
! Otherwise same as polevl.
!
      function p1evl(x,coef,N)
      implicit none
      real(dl) p1evl
      real(dl) x,coef,ans
      integer N,i
      dimension coef(N)

      ans=x+coef(1)
      do i=2,N
         ans=ans*x+coef(i)
      end do
      p1evl=ans
     
      end function p1evl



  end module SpherBessels !USpherBessels



        SUBROUTINE BJL_EXTERNAL(L,X,JL)
        use SpherBessels
        use Precision
        !!== MODIFIED SUBROUTINE FOR SPHERICAL BESSEL FUNCTIONS.                       ==!!
        !!== CORRECTED THE SMALL BUGS IN PACKAGE CMBFAST&CAMB(for l=4,5, x~0.001-0.002)==!! 
        !!== CORRECTED THE SIGN OF J_L(X) FOR X<0 CASE                                 ==!!
        !!== WORKS FASTER AND MORE ACCURATE FOR LOW L, X<<L, AND L<<X cases            ==!! 
        !!== zqhuang@astro.utoronto.ca                                                 ==!!
        IMPLICIT NONE
        INTEGER L
        real(dl) X,JL

        call BJL(L,X,JL)
         
        END SUBROUTINE BJL_EXTERNAL

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! The `halofit' code models the nonlinear evolution of cold matter 
! cosmological power spectra. The full details of the way in which 
! this is done are presented in Smith et al. (2002), MNRAS, ?, ?. 
!
! The code `halofit' was written by R. E. Smith & J. A. Peacock. 
! See http://www.astro.upenn.edu/~res, 
! Last edited 8/5/2002.

! Only tested for plain LCDM models with power law initial power spectra

! Adapted for F90 and CAMB, AL March 2005
!!BR09 Oct 09: generalized expressions for om(z) and ol(z) to include w

! RT12 Oct: update some fitting parameters in the code to enhance
!           the power spectrum at small scales (arXiv:1208.2701)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      module NonLinear
      use ModelParams
      use transfer
      use LambdaGeneral
      implicit none 
      private
       
       real, parameter :: Min_kh_nonlinear = 0.005
       real(dl):: om_m,om_v,fnu,omm0

      public Min_kh_nonlinear,NonLinear_GetNonLinRatios
      
      contains

     subroutine NonLinear_GetNonLinRatios(CAMB_Pk)
     !Fill the CAMB_Pk%nonlin_scaling array with sqrt(non-linear power/linear power)
     !for each redshift and wavenumber
     !This implementation uses Halofit
      type(MatterPowerData) :: CAMB_Pk
      integer itf
      real(dl) a,plin,pq,ph,pnl,rk
      real(dl) sig,rknl,rneff,rncur,d1,d2
      real(dl) diff,xlogr1,xlogr2,rmid
      integer i

       !!BR09 putting neutrinos into the matter as well, not sure if this is correct, but at least one will get a consisent omk.
       omm0 = CP%omegac+CP%omegab+CP%omegan
       fnu = CP%omegan/omm0

       CAMB_Pk%nonlin_ratio = 1

       do itf = 1, CAMB_Pk%num_z


! calculate nonlinear wavenumber (rknl), effective spectral index (rneff) and 
! curvature (rncur) of the power spectrum at the desired redshift, using method 
! described in Smith et al (2002).
       a = 1/real(1+CAMB_Pk%Redshifts(itf),dl)
       om_m = omega_m(a, omm0, CP%omegav, w_lam)  
       om_v = omega_v(a, omm0, CP%omegav, w_lam)

      xlogr1=-2.0
      xlogr2=3.5
      do
          rmid=(xlogr2+xlogr1)/2.0
          rmid=10**rmid
          call wint(CAMB_Pk,itf,rmid,sig,d1,d2)
          diff=sig-1.0
          if (abs(diff).le.0.001) then
             rknl=1./rmid
             rneff=-3-d1
             rncur=-d2                  
             exit
          elseif (diff.gt.0.001) then
             xlogr1=log10(rmid)
          elseif (diff.lt.-0.001) then
             xlogr2=log10(rmid)
          endif
          if (xlogr2 < -1.9999) then
               !is still linear, exit
               goto 101
         end if
      end do

! now calculate power spectra for a logarithmic range of wavenumbers (rk)

      do i=1, CAMB_PK%num_k
         rk = exp(CAMB_Pk%log_kh(i))

         if (rk > Min_kh_nonlinear) then

    ! linear power spectrum !! Remeber => plin = k^3 * P(k) * constant
    ! constant = 4*pi*V/(2*pi)^3 

             plin= MatterPowerData_k(CAMB_PK, rk, itf)*(rk**3/(2*pi**2)) 

    ! calculate nonlinear power according to halofit: pnl = pq + ph,
    ! where pq represents the quasi-linear (halo-halo) power and 
    ! where ph is represents the self-correlation halo term. 
 
             call halofit(rk,rneff,rncur,rknl,plin,pnl,pq,ph)   ! halo fitting formula 
             CAMB_Pk%nonlin_ratio(i,itf) = sqrt(pnl/plin)

         end if

      enddo

101   continue
      end do
            
      end subroutine NonLinear_GetNonLinRatios
       
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! halo model nonlinear fitting formula as described in 
! Appendix C of Smith et al. (2002)

      subroutine halofit(rk,rn,rncur,rknl,plin,pnl,pq,ph)
      implicit none

      real(dl) gam,a,b,c,xmu,xnu,alpha,beta,f1,f2,f3
      real(dl) rk,rn,plin,pnl,pq,ph,plinaa
      real(dl) rknl,y,rncur
      real(dl) f1a,f2a,f3a,f1b,f2b,f3b,frac

!RT12 Oct: the halofit in Smith+ 2003 predicts a smaller power
!than latest N-body simulations at small scales.
!Update the following fitting parameters of gam,a,b,c,xmu,xnu,
!alpha & beta from the simulations in Takahashi+ 2012.
!The improved halofit accurately provide the power spectra for WMAP
!cosmological models with constant w.
      gam=0.1971-0.0843*rn+0.8460*rncur
      a=1.5222+2.8553*rn+2.3706*rn*rn+0.9903*rn*rn*rn+ &
           0.2250*rn*rn*rn*rn-0.6038*rncur+0.1749*om_v*(1.+w_lam)
      a=10**a      
      b=10**(-0.5642+0.5864*rn+0.5716*rn*rn-1.5474*rncur+ &
           0.2279*om_v*(1.+w_lam))
      c=10**(0.3698+2.0404*rn+0.8161*rn*rn+0.5869*rncur)
      xmu=0.
      xnu=10**(5.2105+3.6902*rn)
      alpha=abs(6.0835+1.3373*rn-0.1959*rn*rn-5.5274*rncur)
      beta=2.0379-0.7354*rn+0.3157*rn**2+1.2490*rn**3+ &
           0.3980*rn**4-0.1682*rncur

      if(abs(1-om_m).gt.0.01) then ! omega evolution 
         f1a=om_m**(-0.0732)
         f2a=om_m**(-0.1423)
         f3a=om_m**(0.0725)
         f1b=om_m**(-0.0307)
         f2b=om_m**(-0.0585)
         f3b=om_m**(0.0743)       
         frac=om_v/(1.-om_m) 
         f1=frac*f1b + (1-frac)*f1a
         f2=frac*f2b + (1-frac)*f2a
         f3=frac*f3b + (1-frac)*f3a
      else         
         f1=1.0
         f2=1.
         f3=1.
      endif

      y=(rk/rknl)

      ph=a*y**(f1*3)/(1+b*y**(f2)+(f3*c*y)**(3-gam))
      ph=ph/(1+xmu*y**(-1)+xnu*y**(-2))*(1+fnu*(2.080-12.39*(omm0-0.3))/(1+1.201e-03*y**3))
      plinaa=plin*(1+fnu*26.29*rk**2/(1+1.5*rk**2))
      pq=plin*(1+plinaa)**beta/(1+plinaa*alpha)*exp(-y/4.0-y**2/8.0)

      pnl=pq+ph

      end subroutine halofit       


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! The subroutine wint, finds the effective spectral quantities
! rknl, rneff & rncur. This it does by calculating the radius of 
! the Gaussian filter at which the variance is unity = rknl.
! rneff is defined as the first derivative of the variance, calculated 
! at the nonlinear wavenumber and similarly the rncur is the second
! derivative at the nonlinear wavenumber. 

      subroutine wint(CAMB_Pk,itf,r,sig,d1,d2)
      implicit none
      integer, intent(in) :: itf
      type(MatterPowerData) :: CAMB_Pk
      real(dl) sum1,sum2,sum3,t,y,x,w1,w2,w3
      real(dl) x2,rk, fac,r, sig, d1,d2, anorm
      integer i,nint

      nint=3000
      sum1=0.d0
      sum2=0.d0
      sum3=0.d0
      anorm = 1/(2*pi**2)
      do i=1,nint
         t=(i-0.5_dl)/nint
         y=-1.d0+1.d0/t
         rk=y
         d2=MatterPowerData_k(CAMB_PK, rk, itf)*(rk**3*anorm) 
         x=y*r
         x2=x*x
         w1=exp(-x2)
         w2=2*x2*w1
         w3=4*x2*(1-x2)*w1
         fac=d2/y/t/t
         sum1=sum1+w1*fac
         sum2=sum2+w2*fac
         sum3=sum3+w3*fac
      enddo
      sum1=sum1/nint
      sum2=sum2/nint
      sum3=sum3/nint
      sig=sqrt(sum1)
      d1=-sum2/sum1
      d2=-sum2*sum2/sum1/sum1 - sum3/sum1
      
      end subroutine wint
      
!!BR09 generalize to constant w

      function omega_m(aa,om_m0,om_v0,wval)
      implicit none
      real(dl) omega_m,omega_t,om_m0,om_v0,aa,wval
      omega_t=1.0+(om_m0+om_v0-1.0)/(1-om_m0-om_v0+om_v0*((aa)**(-1.0-3.0*wval))+om_m0/aa)
      omega_m=omega_t*om_m0/(om_m0+om_v0*((aa)**(-3.0*wval)))
      end function omega_m

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! evolution of omega lambda with expansion factor

      function omega_v(aa,om_m0,om_v0,wval)      
      implicit none
      real(dl) aa,omega_v,om_m0,om_v0,omega_t,wval
      omega_t=1.0+(om_m0+om_v0-1.0)/(1-om_m0-om_v0+om_v0*((aa)**(-1.0-3.0*wval))+om_m0/aa)
      omega_v=omega_t*om_v0*((aa)**(-3.0-3.0*wval))/(om_v0*((aa)**(-3.0-3.0*wval))+om_m0/aa/aa/aa)
      end function omega_v

!!BR09 end generalize to constant w

end module NonLinear


!workaround for f90 circular-module reference
     subroutine NonLinear_GetRatios(CAMB_Pk)
      use Transfer
      use NonLinear
      type(MatterPowerData) :: CAMB_Pk

      call NonLinear_GetNonLinRatios(CAMB_Pk)      

     end subroutine NonLinear_GetRatios
     


     subroutine NonLinear_GetRatios_all(CAMB_Pk)
      use Transfer
      use NonLinear
      type(MatterPowerData) :: CAMB_Pk

       stop 'Halofit module doesn''t support non-linear velocities'

     end subroutine NonLinear_GetRatios_All

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gaream(area,areat,rp,cm,np,tol,verb,npg,npp,
     *  cmimin,cmimax,phi,iord,ldegen)
      integer np,verb,npg,npp,iord(np)
      logical ldegen
      real*10 area,areat,rp(3,np),cm(np),tol,cmimin,cmimax,phi(2,np)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c *
c * Same as garea, but speed up matters by checking first whether
c * cm(npg) or cm(npp) lie outside |cmimin| and |cmimax|,
c * giving simpler result.
c * cmimin and cmimax are gotten from prior call to gcmlim.
c *
c * Note this subroutine assumes, without checking, that:
c * if np.eq.npg,
c *    then cm(npg).ge.0;
c * elseif np.eq.npp,
c *    then cm(npg).ge.0 & cm(npp).lt.0 & rp(.,npg)=rp(.,npp).
c *
c        sphere
      if (np.eq.npg) then
        if (cm(npg).le.abs(cmimin)) then
c        region excludes sphere
          if (cmimin.ge.0._10) then
            area=0._10
c        region encloses sphere
          elseif (cmimin.lt.0._10) then
            area=TWOPI*cm(npg)
          endif
        elseif (cm(npg).ge.abs(cmimax)) then
c        sphere encloses region
          if (cmimax.ge.0._10) then
            area=areat
c        sphere and region enclose each other
          elseif (cmimax.lt.0._10) then
            area=areat-TWOPI*(2._10-cm(npg))
          endif
c        sphere intersects boundary of region
        else
          call garea(area,rp,cm,np,tol,verb,phi,iord,ldegen)
        endif
c        annulus
      elseif (np.eq.npp) then
c        region is null
        if (cm(npg).le.-cm(npp)) then
          area=0._10
        elseif (cm(npg).le.abs(cmimin)) then
c        region excludes annulus
          if (cmimin.ge.0._10) then
            area=0._10
c        region encloses annulus
          elseif (cmimin.lt.0._10) then
            area=TWOPI*(cm(npg)+cm(npp))
          endif
        elseif (-cm(npp).ge.abs(cmimax)) then
c        annulus encloses region
          if (cmimax.ge.0._10) then
            area=0._10
c        annulus and region enclose each other
          elseif (cmimax.lt.0._10) then
            area=TWOPI*(cm(npg)+cm(npp))
          endif
        elseif (cm(npg).ge.abs(cmimax)
     *    .and.-cm(npp).le.abs(cmimin)) then
          if (cmimin.ge.0._10) then
c        annulus contains region
            if (cmimax.ge.0._10) then
              area=areat
c        outer ring of annulus and region enclose each other
            elseif (cmimax.lt.0._10) then
              area=areat-TWOPI*(2._10-cm(npg))
            endif
          elseif (cmimin.lt.0._10) then
c        inner ring of annulus and region enclose each other
            if (cmimax.ge.0._10) then
              area=areat-TWOPI*(2._10+cm(npp))
c        annulus and region enclose each other
            elseif (cmimax.lt.0._10) then
              area=areat-TWOPI*(2._10-cm(npg)-cm(npp))
            endif
          endif
c        annulus intersects boundary of region
        else
          call garea(area,rp,cm,np,tol,verb,phi,iord,ldegen)
        endif
c        np .ne. npg or npp
      else
        call garea(area,rp,cm,np,tol,verb,phi,iord,ldegen)
      endif
      return
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      real*10 function twoqz(ra,dec,verbose)
      real*10 ra,dec
      integer verbose
c
c        parameters
      integer NHEM
      parameter (NHEM=2)
c        externals
      integer access,lnblnk
c        data variables
      include 'mangdir.inc'
      character*24 subdir
      integer unit
      logical init
c        local (automatic) variables
      character*1 go
      character*64 dat
      character*128 tmpnam
      integer idec,idir,ihem,ifmt,ira,found
      real*4 decmn,decmx,r,ramn,ramx
c        local variables to be saved
      integer ndec(NHEM),nra(NHEM)
      real*4 decmin(NHEM),decstep(NHEM),ramin(NHEM),rastep(NHEM)
      real*4 array(4510,330,2)
      save ndec,nra
      save decmin,decstep,ramin,rastep
      save array
      logical ex
      character*3 re
c *
c * Completeness of 2QZ, the April 2001 2dF 10k quasar redshift survey.
c *
c  Input: ra, dec = RA & Dec in degrees.
c         verbose = 0 quiet
c                 = 1 normal verbosity
c                 = 3 details (useful if twoqz is run interactively)
c Output: twoqz: 0 = empty to 1 = complete.
c
c        mangle directory
      include 'mangdir.data'
c        subdirectory of mangle directory containing 2QZ mask data
      data subdir /'masks/2qz10k'/
c        initialize on first call
      data init /.true./
c        fortran unit
      data unit /7/
c
c--------read arrays
      if (init) then
c        each hemisphere
        do 170 ihem=1,NHEM
          found=0
c        try current directory, then subdirectory, then mangle directory
          do 160 idir=1,3
c        try unformatted then formatted files
            do 150 ifmt=1,2
c        unformatted
              if (ifmt.eq.1) then
                if (ihem.eq.1) then
                  dat='ngc_obscomp.dat'
                elseif (ihem.eq.2) then
                  dat='sgc_obscomp.dat'
                endif
c        formatted
              elseif (ifmt.eq.2) then
                if (ihem.eq.1) then
                  dat='ngc_obscomp.txt'
                elseif (ihem.eq.2) then
                  dat='sgc_obscomp.txt'
                endif
              endif
c        current directory
              if (idir.eq.1) then
                tmpnam=dat
c        subdirectory
              elseif (idir.eq.2) then
                tmpnam=subdir(1:lnblnk(subdir))
     *            //'/'//dat(1:lnblnk(dat))
c        mangle directory
              elseif (idir.eq.3) then
                call getenv(mangenv,tmpnam)
                if (found.eq.1) goto 310
                if (tmpnam.eq.' ') goto 320
                mangdir=tmpnam
                tmpnam=mangdir(1:lnblnk(mangdir))
     *            //'/'//subdir(1:lnblnk(subdir))
     *            //'/'//dat(1:lnblnk(dat))
              endif
c        found the file
              inquire(FILE=tmpnam(1:lnblnk(tmpnam)), EXIST=ex, READ=re)
              if (ex.and.(re.eq.'YES')) then
c              if (access(tmpnam(1:lnblnk(tmpnam)),' r').eq.0) then
                if (ifmt.eq.1) then
                  open (unit,file=tmpnam,form='unformatted',
     *              status='old',err=340)
                else
                  open (unit,file=tmpnam,status='old',err=340)
                endif
                found=1
c        did not find the file
              else
c        try formatted file
                if (ifmt.eq.1) goto 150
c        try another directory
                if (idir.le.2) goto 160
                if (found.eq.1) goto 310
c        ran out of options
                goto 330
              endif
c        found the file: now read it
              rewind (unit)
              if (verbose.ge.1)
     *          print *,'reading ',tmpnam(1:lnblnk(tmpnam)),' ...'
c        unformatted
              if (ifmt.eq.1) then
                read (unit,end=120,err=120) ramin(ihem)
                read (unit,end=120,err=120) decmin(ihem)
                read (unit,end=120,err=120) nra(ihem)
                read (unit,end=120,err=120) ndec(ihem)
                read (unit,end=120,err=120) rastep(ihem)
                read (unit,end=120,err=120) decstep(ihem)
                read (unit,end=120,err=120) ((array(ira,idec,ihem),
     *            ira=1,nra(ihem)),idec=1,ndec(ihem))
                goto 130
c        error reading unformatted file
  120           if (verbose.ge.1)
     *            print *,'error reading ',tmpnam(1:lnblnk(tmpnam)),
     *            '; retry:'
c        try formatted file
                goto 150
c        successful read
  130           continue
c        formatted
              elseif (ifmt.eq.2) then
                read (unit,*,end=350,err=360) ramin(ihem)
                read (unit,*,end=350,err=360) decmin(ihem)
                read (unit,*,end=350,err=360) nra(ihem)
                read (unit,*,end=350,err=360) ndec(ihem)
                read (unit,*,end=350,err=360) rastep(ihem)
                read (unit,*,end=350,err=360) decstep(ihem)
                read (unit,*,end=350,err=360) ((array(ira,idec,ihem),
     *            ira=1,nra(ihem)),idec=1,ndec(ihem))
              endif
c        close file
              close (unit)
c             write (*,'(2x,i8,9i12)') (ira,ira=1,10)
c             do idec=1,10
c               write (*,'(i2,10g12.4)')
c    *            idec,(array(ira,idec,ihem),ira=1,10)
c             enddo

c        option to write formatted copy
              if (verbose.ge.2.and.ifmt.eq.1) then
                write (*,'(" write formatted copy of ",a,
     *            "? [CR,n=no, y=yes]: ",$)') tmpnam(1:lnblnk(tmpnam))
                read (*,'(a1)',end=135,err=135) go
                if (go.eq.' '.or.go.eq.'n'.or.go.eq.'N'
     *            .or.go.eq.'x'.or.go.eq.'X'
     *            .or.go.eq.'q'.or.go.eq.'Q') then
                  continue
                else
                  if (ihem.eq.1) then
                    dat='ngc_obscomp.txt'
                  elseif (ihem.eq.2) then
                    dat='sgc_obscomp.txt'
                  endif
c        current directory
                  if (idir.eq.1) then
                    tmpnam=dat
c        subdirectory
                  elseif (idir.eq.2) then
                    tmpnam=subdir(1:lnblnk(subdir))
     *                //'/'//dat(1:lnblnk(dat))
c        mangle directory
                  elseif (idir.eq.3) then
                    tmpnam=mangdir(1:lnblnk(mangdir))
     *                //'/'//subdir(1:lnblnk(subdir))
     *                //'/'//dat(1:lnblnk(dat))
                  endif
                  open (unit,file=tmpnam,err=370)
                  rewind (unit)
                  print *,'writing ',tmpnam(1:lnblnk(tmpnam)),' ...'
                  write (unit,'(g16.8)',err=380) ramin(ihem)
                  write (unit,'(g16.8)',err=380) decmin(ihem)
                  write (unit,'(i8)',err=380) nra(ihem)
                  write (unit,'(i8)',err=380) ndec(ihem)
                  write (unit,'(g16.8)',err=380) rastep(ihem)
                  write (unit,'(g16.8)',err=380) decstep(ihem)
                  write (unit,'(6g16.8)',err=380)((array(ira,idec,ihem),
     *              ira=1,nra(ihem)),idec=1,ndec(ihem))
                  close (unit)
                endif
 135            continue
              endif

c        option to write unformatted copy
c              if (verbose.ge.2.and.ifmt.eq.2) then
              if (verbose.ge.1.and.ifmt.eq.2) then
                write (*,'(" write unformatted copy of ",a,
     *            "? [CR,n=no, y=yes]: ",$)') tmpnam(1:lnblnk(tmpnam))
                read (*,'(a1)',end=140,err=140) go
                if (go.eq.' '.or.go.eq.'n'.or.go.eq.'N'
     *            .or.go.eq.'x'.or.go.eq.'X'
     *            .or.go.eq.'q'.or.go.eq.'Q') then
                  continue
                else
                  if (ihem.eq.1) then
                    dat='ngc_obscomp.dat'
                  elseif (ihem.eq.2) then
                    dat='sgc_obscomp.dat'
                  endif
c        current directory
                  if (idir.eq.1) then
                    tmpnam=dat
c        subdirectory
                  elseif (idir.eq.2) then
                    tmpnam=subdir(1:lnblnk(subdir))
     *                //'/'//dat(1:lnblnk(dat))
c        mangle directory
                  elseif (idir.eq.3) then
                    tmpnam=mangdir(1:lnblnk(mangdir))
     *                //'/'//subdir(1:lnblnk(subdir))
     *                //'/'//dat(1:lnblnk(dat))
                  endif
                  open (unit,file=tmpnam,form='unformatted',err=370)
                  rewind (unit)
                  print *,'writing ',tmpnam(1:lnblnk(tmpnam)),' ...'
                  write (unit,err=380) ramin(ihem)
                  write (unit,err=380) decmin(ihem)
                  write (unit,err=380) nra(ihem)
                  write (unit,err=380) ndec(ihem)
                  write (unit,err=380) rastep(ihem)
                  write (unit,err=380) decstep(ihem)
                  write (unit,err=380) ((array(ira,idec,ihem),
     *              ira=1,nra(ihem)),idec=1,ndec(ihem))
                  close (unit)
                endif
  140           continue
              endif
c        successful read
              goto 170
  150       continue
  160     continue
  170   continue
        init=.false.
      endif
c--------the routine
      twoqz=0._10
      do ihem=1,NHEM
        decmn=decmin(ihem)-decstep(ihem)*.5_10
        decmx=decmn+decstep(ihem)*ndec(ihem)
        if (dec.ge.decmn.and.dec.le.decmx) then
          ramn=ramin(ihem)-rastep(ihem)*.5_10
          ramx=ramn+rastep(ihem)*nra(ihem)
          ira=(ra-ramn)/360._10
          r=ra-ira*360._10
          if (r.lt.ramn) r=r+360._10
          if (verbose.ge.3) then
            print *,'ra, ramin, ramax =',r,ramn,ramx
            print *,'dec, decmin, decmax =',dec,decmn,decmx
          endif
          if (r.le.ramx) then
            ira=1+int((r-ramn)/rastep(ihem))
            idec=1+int((dec-decmn)/decstep(ihem))
            if (verbose.ge.3) then
              print *,'ira, idec, ihem, ra, dec =',ira,idec,ihem,
     *          ramin(ihem)+(ira-1)*rastep(ihem),
     *          decmin(ihem)+(idec-1)*decstep(ihem)
            endif
            twoqz=array(ira,idec,ihem)
c        round to 6 sig fig
            twoqz=dble(nint(twoqz*1.e6_10))/1.e6_10
            goto 200
          endif
        endif
      enddo
  200 continue
      return
c
c--------errors
  310 print *,'twoqz: you may have a problem with endianness;'
      print *,'please read HELP.unformatted in the mangle directory'
      stop
  320 print *,'twoqz: can''t find ',dat(1:lnblnk(dat))
      print *,'maybe I''d find it if environment variable ',
     *  mangenv(1:lnblnk(mangenv)),' were set to'
      print *,mangdir(1:lnblnk(mangdir))
      stop
  330 print *,'twoqz: can''t find ',dat(1:lnblnk(dat)),
     *  ' in directories . or '
      print *,mangdir(1:lnblnk(mangdir))//'/'//subdir(1:lnblnk(subdir))
      stop
  340 print *,'twoqz: error opening ',tmpnam(1:lnblnk(tmpnam))
      stop
  350 print *,'twoqz: premature EOF on ',tmpnam(1:lnblnk(tmpnam))
      stop
  360 print *,'twoqz: error reading ',tmpnam(1:lnblnk(tmpnam))
      stop
  370 print *,'twoqz: error opening ',tmpnam(1:lnblnk(tmpnam))
      stop
  380 print *,'twoqz: error writing to ',tmpnam(1:lnblnk(tmpnam))
      stop
c
      end
c

    !---------------------------------------------------------------------------------------------------
    ! Recombination module for CAMB, using CosmoRec 
    ! Author: Richard Shaw (CITA)
    !---------------------------------------------------------------------------------------------------
    ! 08.06.2012: added possibility to communicate Hubble (Jens Chluba)
    ! 12.06.2012: AL, changed interface to pass nnu directly; fixed spline extrapolation

    module Recombination
    use constants
    use AMLUtils
    implicit none
    private

    type RecombinationParams

        integer :: runmode
        real(dl) :: fdm  ! Dark matter annihilation efficiency

        ! Internal accuracy of CosmoRec (0 - normal, 3 - most accurate
        ! other values defined in CosmoRec.cpp source file)
        real(dl) :: accuracy 

    end type RecombinationParams

    character(LEN=*), parameter :: Recombination_Name = 'CosmoRec'

    logical :: first_run = .true.
    integer, parameter :: Nz = 10000
    real(dl) :: zmax = 1d4
    real(dl) :: zmin = 0._dl
    real(dl), dimension(Nz) :: zrec, arec, Hz
    real(dl), dimension(Nz) :: xrec, tmrec, x2rec, tm2rec

    public RecombinationParams, Recombination_xe, Recombination_tm, Recombination_init,   &
    Recombination_ReadParams, Recombination_SetDefParams, &
    Recombination_Validate, Recombination_Name


    contains

    subroutine Recombination_ReadParams(R, Ini)
    use IniFile
    Type(RecombinationParams) :: R
    Type(TIniFile) :: Ini

    R%runmode = Ini_Read_Int_File(Ini, 'cosmorec_runmode', 0)
    R%accuracy = Ini_Read_Double_File(Ini, 'cosmorec_accuracy', 0.0D0)
    R%fdm = Ini_Read_Double_File(Ini, 'cosmorec_fdm', 0.0D0)

    end subroutine Recombination_ReadParams


    subroutine Recombination_SetDefParams(R)
    type (RecombinationParams) ::R

    R%runmode = 0
    R%fdm = 0.0
    R%accuracy = 0

    end subroutine Recombination_SetDefParams


    subroutine Recombination_Validate(R, OK)
    Type(RecombinationParams), intent(in) :: R
    logical, intent(inout) :: OK

    if(R%runmode < 0 .or. R%runmode > 3) then
        write(*,*) "Invalid runmode for CosmoRec,"
        OK = .false.
    end if

    if(R%runmode < 2 .and. R%fdm > 1d-23) then
        write(*,*) "Dark matter annihilation rate too high. Will crash CosmoRec."
        OK = .false.
    end if

    if(R%accuracy < 0.0 .or. R%accuracy > 3.0) then
        write(*,*) "CosmoRec accuracy mode undefined."
        OK = .false.
    end if

    end subroutine Recombination_Validate



    function Recombination_tm(a)
    real(dl), intent(in) :: a
    real(dl) Recombination_tm

    Recombination_tm = spline_val(a, arec, tmrec, tm2rec, Nz)

    end function Recombination_tm


    function Recombination_xe(a)
    real(dl), intent(in) :: a
    real(dl) Recombination_xe

    Recombination_xe = spline_val(a, arec, xrec, x2rec, Nz)

    end function Recombination_xe




    subroutine Recombination_init(Recomb, OmegaC, OmegaB, OmegaN, Omegav, h0inp, tcmb, yp, num_nu)
    !Would love to pass structure as arguments, but F90 would give circular reference...
    !hence mess passing parameters explcitly and non-generally

    use AMLUtils
    implicit none
    Type (RecombinationParams), intent(in) :: Recomb
    real(dl), intent(in) :: OmegaC, OmegaB, OmegaN, OmegaV, h0inp, tcmb, yp, num_nu

    real(dl) OmegaK
    integer :: i, label
    real(dl), dimension(5) :: runpars

    real(dl) dtauda
    external dtauda

    ! Calculate the curvature
    OmegaK = 1._dl - OmegaC - OmegaB - OmegaV
#ifdef MPI
    label = GetMpiRank()
#else
    label = 0
#endif
    ! Some feedback

    if (Feedback >1) then
        print *, "" ;
        print *, "==== CosmoRec parameters ====" ;

        print *, "Runmode: ", Recomb%runmode
        print "(a,f10.5)", " Omega_c: ", OmegaC
        print "(a,f10.5)", " Omega_b: ", OmegaB
        print "(a,f10.5)", " Omega_k: ", OmegaK
        print "(a,f10.5)", " Num_nu : ", num_nu
        print "(a,f10.5)", " Hubble : ", h0inp
        print "(a,f10.5)", " T_cmb  : ", tcmb
        print "(a,f10.5)", " Y_He   : ", yp
        print "(a,f10.5)", " f_dm   : ", Recomb%fdm
    end if

    ! Set runtime parameters
    runpars = 0._dl
    runpars(1) = Recomb%fdm ! Set dark matter annihilation efficiency
    runpars(2) = Recomb%accuracy

    ! Set redshifts to calculate at.
    do i=1,Nz
        zrec(i) = zmax - i*((zmax - zmin) / Nz)
        arec(i) = 1d0 / (1.0D0 + zrec(i))
        Hz(i) = 1/dtauda(1/(1._dl+zrec(i)))*(1._dl+zrec(i))**2/MPC_in_sec  
    end do

    ! internal Hubble function of CosmoRec is used
    !call CosmoRec_calc_cpp(Recomb%runmode, runpars, &
    !     OmegaC, OmegaB, OmegaK, num_nu, h0inp, tcmb, yp, &
    !     zrec, xrec, tmrec, Nz, label)

    ! version which uses camb Hubble function
    call CosmoRec_calc_h_cpp(Recomb%runmode, runpars, &
    OmegaC, OmegaB, OmegaK, num_nu, h0inp, tcmb, yp, &
    zrec, Hz, Nz, zrec, xrec, tmrec, Nz, label)

    call spline_double(arec, xrec, Nz, x2rec)
    call spline_double(arec, tmrec, Nz, tm2rec)

    ! print some output
    !open(unit=267,file="CosmoRec.out.Xe.II.dat")
    !do i=1,Nz
    !   write (267,*) zrec(i), xrec(i), tmrec(i)
    !end do
    !close(267)

    end subroutine Recombination_init



    ! General routine for cubic spline interpolation (see NR)
    real(dl) function spline_val(x, xv, yv, y2, n)

    real(dl), intent(in) :: x
    real(dl), intent(in) :: xv(n), yv(n), y2(n)
    integer, intent(in) :: n

    integer :: kh,kl,kn
    real(dl) :: h,a,b,c,d

    ! Extrapolate if value is above or below interval
    if(x < xv(1)) then
        spline_val = yv(1)
    else if(x > xv(n)) then
        spline_val = yv(n)
    else
        ! Bisection to find correct interval
        kh = n
        kl = 1
        do while(kh - kl > 1)
            kn = (kh + kl) / 2
            if(xv(kn) > x) then
                kh = kn
            else
                kl = kn
            end if
        end do

        ! Set up constants (a la NR)
        h = xv(kh) - xv(kl)

        a = (xv(kh) - x) / h
        b = (x - xv(kl)) / h
        c = (a**3 - a)* h**2 / 6
        d = (b**3 - b)* h**2 / 6

        spline_val = (a*yv(kl) + b*yv(kh) + c*y2(kl) + d*y2(kh))

    end if
    end function spline_val

    end module Recombination

!     Standalone HEALPix subroutine converted to f77 by J C Hill 07/13/06
!     Get the original at http://healpix.jpl.nasa.gov
!     a f 'f88 pix2vecnest.f'

      !=========================================================================
      subroutine pix2vec_nest(nside, ipix, vector_x, vector_y, 
     & vector_z, vertex_n_x, vertex_n_y, vertex_n_z, vertex_e_x, 
     & vertex_e_y, vertex_e_z, vertex_s_x, vertex_s_y, vertex_s_z, 
     & vertex_w_x, vertex_w_y, vertex_w_z)
      !=========================================================================
      !     renders vector (x,y,z) coordinates of the nominal pixel center
      !     for the pixel number ipix (NESTED scheme)
      !     given the map resolution parameter nside
      !     also returns the (x,y,z) position of the 4 pixel vertices (=corners)
      !     in the order N,E,S,W
      !=========================================================================
      IMPLICIT none
      INTEGER ipix, nside
      REAL*10 vector_x, vector_y, vector_z, vertex_n_x, 
     & vertex_n_y, vertex_n_z, vertex_e_x, vertex_e_y, 
     & vertex_e_z, vertex_s_x, vertex_s_y, vertex_s_z, 
     & vertex_w_x, vertex_w_y, vertex_w_z

      INTEGER npix, npface, ipf, ip_low, ip_trunc, ip_med, 
     & ip_hi, jrt, jr, nr, jpt, jp, kshift, nl4, ns_max
      parameter(ns_max=8192) ! 2^13 : largest nside allowed
      REAL*10 z, fn, fact1, fact2, sth, phi, PI
      parameter(PI=3.141592653589793238462643383279502884197_10)
      INTEGER pix2x(0:1023), pix2y(0:1023)
      INTEGER ix, iy, face_num
      ! common /xy_nest/ ix, iy, face_num ! can be useful to calling routine

      INTEGER jrll(1:12)
      INTEGER jpll(1:12)

      REAL*10 phi_nv, phi_wv, phi_sv, phi_ev, phi_up, phi_dn, 
     & z_nv, z_sv, sth_nv, sth_sv, hdelta_phi
      INTEGER iphi_mod, iphi_rat, kpix, jpix, ix_mk, 
     & iy_mk, ip_mk, id_mk, i
      ! LOGICAL do_vertex    ! this is unnecessary, since we will always want the vertices
      !------------------------------------------------------------------------
      if (nside.lt.1 .or. nside.gt.ns_max) stop 'nside out of range'
      npix = 12*nside**2     ! total number of pixels
      if (ipix.lt.0 .or. ipix.gt.npix-1) stop 'ipix out of range'

      do 10 i = 0, 1023
         pix2x(i) = 0
         pix2y(i) = 0
 10   continue

      ! coordinate of the lowest corner of each face, in unit of nside
      jrll(1) = 2
      jrll(2) = 2
      jrll(3) = 2
      jrll(4) = 2
      jrll(5) = 3
      jrll(6) = 3
      jrll(7) = 3
      jrll(8) = 3
      jrll(9) = 4
      jrll(10) = 4
      jrll(11) = 4
      jrll(12) = 4

      ! coordinate of the lowest corner of each face, in unit of nside/2
      jpll(1) = 1
      jpll(2) = 3
      jpll(3) = 5
      jpll(4) = 7
      jpll(5) = 0
      jpll(6) = 2
      jpll(7) = 4
      jpll(8) = 6
      jpll(9) = 1
      jpll(10) = 3
      jpll(11) = 5
      jpll(12) = 7

      !     initializes the array for the pixel number -> (x,y) mapping
      if (pix2x(1023).le.0) then
         ! constructs the array giving x and y in the face from pixel number
         ! for the nested (quad-cube like) ordering of pixels
         !
         ! the bits corresponding to x and y are interleaved in the pixel number
         ! one breaks up the pixel number by even and odd bits

         ! cc cf block data      data      pix2x(1023) /0/
         !
         !      print *, 'initiate pix2xy'
         do kpix = 0,1023               ! pixel number
            jpix = kpix
            ix_mk = 0
            iy_mk = 0
            ip_mk = 1                 ! bit position (in x and y)
         ! do while (jpix/=0)         ! go through all the bits
            do
               if (jpix.eq.0) exit    ! go through all the bits
!               id_mk = jpix           ! this and the next 4 lines are equivalent to id_mk=MODULO(jpix,2)
! 10            continue
!                  if (id_mk.ge.2) id_mk = id_mk - 2
!                  if (id_mk.lt.0) id_mk = id_mk + 2
!               if (id_mk.ge.2 .or. id_mk.lt.0) goto 10  ! bit value (in kpix), goes in ix_mk
               id_mk = MOD(jpix,2)
               jpix = jpix/2
               ix_mk = id_mk*ip_mk + ix_mk

!               id_mk = jpix           ! this and the next 4 lines are equivalent to id_mk=MODULO(jpix,2)
! 20            continue
!                  if (id_mk.ge.2) id_mk = id_mk - 2
!                  if (id_mk.lt.0) id_mk = id_mk + 2
!               if (id_mk.ge.2 .or. id_mk.lt.0) goto 20  ! bit value (in kpix), goes in iy_mk
               id_mk = MOD(jpix,2)
               jpix = jpix/2
               iy_mk = id_mk*ip_mk + iy_mk

               ip_mk = 2*ip_mk        ! next bit (in x and y)
            enddo
            pix2x(kpix) = ix_mk       ! in 0,31
            pix2y(kpix) = iy_mk       ! in 0,31
         enddo
      endif

      fn = DBLE(nside)
      fact1 = 1.0_10/(3.0_10*fn*fn)
      fact2 = 2.0_10/(3.0_10*fn)
      nl4   = 4*nside

      !    finds the face, and the number in the face
      npface = nside**2

      face_num = ipix/npface  ! face number in {0,11}
      ipf = MOD(ipix,npface)  ! pixel number in the face {0,npface-1}

      !     finds the x,y on the face (starting from the lowest corner)
      !     from the pixel number
      ip_low = MOD(ipf,1024)          ! content of the last 10 bits
      ip_trunc = ipf/1024             ! truncation of the last 10 bits
      ip_med = MOD(ip_trunc,1024)     ! content of the next 10 bits
      ip_hi = ip_trunc/1024           ! content of the high weight 10 bits
      
      ix = 1024*pix2x(ip_hi) + 32*pix2x(ip_med) + pix2x(ip_low)
      iy = 1024*pix2y(ip_hi) + 32*pix2y(ip_med) + pix2y(ip_low)

      !     transforms this in (horizontal, vertical) coordinates
      jrt = ix + iy  ! 'vertical' in {0,2*(nside-1)}
      jpt = ix - iy  ! 'horizontal' in {-nside+1,nside-1}
      
      !     computes the z coordinate on the sphere
      jr = jrll(face_num+1)*nside - jrt - 1  ! ring number in {1,4*nside-1}

      nr = nside                 ! equatorial region (the most frequent)
      z = (2*nside-jr)*fact2
      kshift = MOD(jr - nside, 2)
      
      z_nv = (2*nside-jr+1)*fact2
      z_sv = (2*nside-jr-1)*fact2
      if (jr.eq.nside) then ! northern transition
         z_nv = 1.0_10 - (nside-1)**2 * fact1
      elseif (jr.eq.3*nside) then  ! southern transition
         z_sv = -1.0_10 + (nside-1)**2 * fact1
      endif

      if (jr.lt.nside) then     ! north pole region
         nr = jr
         z = 1.0_10 - nr*nr*fact1
         kshift = 0
         z_nv = 1.0_10 - (nr-1)**2 * fact1
         z_sv = 1.0_10 - (nr+1)**2 * fact1
      elseif (jr.gt.3*nside) then ! south pole region
         nr = nl4 - jr
         z = -1.0_10 + nr*nr*fact1
         kshift = 0
         z_nv = -1.0_10 + (nr+1)**2 * fact1
         z_sv = -1.0_10 + (nr-1)**2 * fact1
      endif

      !     computes the phi coordinate on the sphere, in [0,2Pi]
      jp = (jpll(face_num+1)*nr + jpt + 1 + kshift)/2  ! 'phi' number in the ring in {1,4*nr}
      if (jp.gt.nl4) jp = jp - nl4
      if (jp.lt.1)   jp = jp + nl4

      phi = (jp - (kshift+1)*0.5_10) * (PI/(2.0_10*nr))

      sth = SQRT((1.0_10-z)*(1.0_10+z))
      vector_x = sth * COS(phi)
      vector_y = sth * SIN(phi)
      vector_z = z

      phi_nv = phi
      phi_sv = phi

      phi_up = 0.0_10
      iphi_mod = MOD(jp-1,nr) ! in {0,1,... nr-1}
      iphi_rat = (jp-1) / nr  ! in {0,1,2,3}
      if (nr.gt.1) phi_up=(PI/2.0_10)*(iphi_rat+iphi_mod/(DBLE(nr-1)))
      phi_dn         =(PI/2.0_10)*(iphi_rat+(iphi_mod+1)/(DBLE(nr+1)))
      if (jr.lt.nside) then          ! North polar cap
         phi_nv = phi_up
         phi_sv = phi_dn
      elseif (jr.gt.3*nside) then    ! South polar cap
         phi_nv = phi_dn
         phi_sv = phi_up
      elseif (jr.eq.nside) then      ! North transition
         phi_nv = phi_up
      elseif (jr.eq.3*nside) then    ! South transition
         phi_sv = phi_up
      endif

      hdelta_phi = PI / (4.0_10*nr)

      ! west vertex
      phi_wv     = phi - hdelta_phi
      vertex_w_x = sth * COS(phi_wv)
      vertex_w_y = sth * SIN(phi_wv)
      vertex_w_z = z

      ! east vertex
      phi_ev     = phi + hdelta_phi
      vertex_e_x = sth * COS(phi_ev)
      vertex_e_y = sth * SIN(phi_ev)
      vertex_e_z = z

      ! north vertex
      sth_nv = SQRT((1.0_10-z_nv)*(1.0_10+z_nv))
      vertex_n_x = sth_nv * COS(phi_nv)
      vertex_n_y = sth_nv * SIN(phi_nv)
      vertex_n_z = z_nv

      ! south vertex
      sth_sv = SQRT((1.0_10-z_sv)*(1.0_10+z_sv))
      vertex_s_x = sth_sv * COS(phi_sv)
      vertex_s_y = sth_sv * SIN(phi_sv)
      vertex_s_z = z_sv

      return
      end subroutine pix2vec_nest ! pix2vec_nest

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine azel(ra,dec,raz,elp,azp,az,el)
      real*10 ra,dec,raz,elp,azp,az,el
c
c        parameters
      real*10 CIRCLE,PI,RADIAN
      parameter (CIRCLE = 360._10,
     *           PI = 3.1415926535897932384626_10,
     *           RADIAN = 180._10/PI)
c        local (automatic) variables
      integer iz
      real*10 cazm,cdec,cel,celp,cra,sazm,sdec,sel,selp,sra
c *
c * Convert RA & Dec ra, dec -> azimuth & elevation.
c * To accomplish the inverse operation, az, el -> ra, dec,
c *   call azel(az, el, azp, elp, raz, ra, dec);
c * To convert RA & Dec to Galactic Longitude and Latitude, use
c *   raz = 192.25, elp = 27.4, azp = 123.
c *
c  Input: ra = RA in degrees.
c         dec = Dec in degrees.
c         raz = RA of zenith in degrees.
c         elp = elevation of NCP in degrees = Dec of zenith.
c         azp = azimuth of NCP in degrees.
c Output: az = azimuth in degrees (0.le.az.lt.360).
c         el = elevation in degrees (-90.le.el.le.90).
c
c        sines and cosines of input angles
      sdec=sin(dec/RADIAN)
      cdec=cos(dec/RADIAN)
      selp=sin(elp/RADIAN)
      celp=cos(elp/RADIAN)
      sra=sin((ra-raz)/RADIAN)
      cra=cos((ra-raz)/RADIAN)
c        sine and cosine of elevation
      sel=cdec*celp*cra+sdec*selp
      if (sel.gt.1._10) then
        sel=1._10
      elseif (sel.lt.-1._10) then
        sel=-1._10
      endif
      cel=sqrt(1._10-sel**2)
c        elevation in degrees
      el=asin(sel)*RADIAN
c        if elevation is +90 or -90 degrees, set azimuth to that of NCP
      if (cel.eq.0._10) then
        az=azp
      elseif (cel.ne.0._10) then
c        sine and cosine of azimuth relative to NCP azimuth
        sazm=-cdec*sra/cel
        cazm=(sdec*celp-cdec*selp*cra)/cel
c        azimuth in degrees
        az=atan2(sazm,cazm)*RADIAN+azp
c        ensure azimuth is in interval [0,360)
        iz=az/CIRCLE
        if (az.lt.0._10) iz=iz-1
        az=az-iz*CIRCLE
      endif
      return
      end
c

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      integer function gzeroar(cm,np)
      integer np
      real*10 cm(np)
c
c        local (automatic) variables
      integer i
c *
c * Check for zero area because one circle is null.
c *
c  Input: cm
c         np
c Return value: 0 if area is zero because one circle is null,
c               1 otherwise
c
      do i=1,np
        if (cm(i).eq.0._10) goto 200
        if (cm(i).le.-2._10) goto 200
      enddo
      gzeroar=1
      return
c
  200 gzeroar=0
      return
c
      end
c
c-----------------------------------------------------------------------
      subroutine gaxisi(rp,xi,yi)
      real*10 rp(3),xi(3),yi(3)
c
c        local (automatic) variables
      real*10 sx
c *
c * Cartesian axes with z-axis along rp.
c *
c  Input: rp
c Output: xi, yi forming right-handed orthonormal system with rp
c
      sx=rp(1)**2+rp(3)**2
      if (sx.gt..5_10) then
        sx=sqrt(sx)
c        xi in direction y x rp (= x direction if rp is along z)
        xi(1)=rp(3)/sx
        xi(2)=0._10
        xi(3)=-rp(1)/sx
      else
        sx=sqrt(rp(1)**2+rp(2)**2)
c        xi in direction rp x z
        xi(1)=rp(2)/sx
        xi(2)=-rp(1)/sx
        xi(3)=0._10
      endif
c        yi in direction rp x xi (= y direction if rp is along z)
      yi(1)=xi(3)*rp(2)-xi(2)*rp(3)
      yi(2)=xi(1)*rp(3)-xi(3)*rp(1)
      yi(3)=xi(2)*rp(1)-xi(1)*rp(2)
      return
c
      end
c
c-----------------------------------------------------------------------
      subroutine gaxisii(rpi,rp,xi,yi)
      real*10 rpi(3),rp(3),xi(3),yi(3)
c
c        local (automatic) variables
      real*10 ri,sik
c *
c * Cartesian axes with z-axis along rp, x-axis towards rpi.
c *
c  Input: rpi
c Output: xi, yi forming right-handed orthonormal system with rpi
c
c        set yi in direction rp x rpi
      yi(1)=rpi(3)*rp(2)-rpi(2)*rp(3)
      yi(2)=rpi(1)*rp(3)-rpi(3)*rp(1)
      yi(3)=rpi(2)*rp(1)-rpi(1)*rp(2)
c        project yi orthogonal to rp, to avoid problems near yi=0
      ri=yi(1)*rp(1)+yi(2)*rp(2)+yi(3)*rp(3)
      yi(1)=yi(1)-ri*rp(1)
      yi(2)=yi(2)-ri*rp(2)
      yi(3)=yi(3)-ri*rp(3)
      sik=yi(1)**2+yi(2)**2+yi(3)**2
      if (sik.gt.0._10) then
c        sik = sin th(ik)
        sik=sqrt(sik)
        yi(1)=yi(1)/sik
        yi(2)=yi(2)/sik
        yi(3)=yi(3)/sik
c        rpi is same/opposite direction to rp: set yi along z x rp
      else
        ri=sqrt(rp(1)**2+rp(2)**2)
        if (ri.gt.0._10) then
          yi(1)=-rp(2)/ri
          yi(2)=rp(1)/ri
          yi(3)=0._10
c        if rp is also along z-axis, set yi along y-axis
        else
          yi(1)=0._10
          yi(2)=1._10
          yi(3)=0._10
        endif
      endif
c        xi in direction yi x rp
      xi(1)=yi(2)*rp(3)-yi(3)*rp(2)
      xi(2)=yi(3)*rp(1)-yi(1)*rp(3)
      xi(3)=yi(1)*rp(2)-yi(2)*rp(1)
      return
c
      end
c
c-----------------------------------------------------------------------
      subroutine gphij(rp,cm,np,i,rpi,scmi,cmi,xi,yi,big,tol,ni,phi)
      integer np,i,scmi,ni
      real*10 rp(3,np),cm(np),rpi(3),cmi,xi(3),yi(3),big,tol,phi(2,np)
c
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer j
      real*10 bi,bj,cmij,cmj,d,dc,xj,yj
c *
c * angles phi about z-axis rp(i) of intersection of i & j circles
c * phi = big means no intersection
c *
c  Input: rp, cm
c         np = number of caps
c         i
c         rpi = rp(i)
c         scmi = sign(cm(i))
c         cmi = abs(cm(i))
c         xi, yi form orthonormal axes with rp(i)
c         big
c         tol = great circle angle closer than which
c               i & j circles are considered coincident
c Output: ni = number of intersections of i circle with j circles
c            = -1 if circle i is entirely outside another circle
c            = -2 if area of polygon is zero
c         phi(1,j), phi(2,j) = azimuthal angle about rpi
c              of intersection of j circle with i circle;
c              zero azimuthal angle is in direction xi.
c
c--------initialise phi to big, meaning no intersection
      do j=1,np
        phi(1,j)=big
        phi(2,j)=big
      enddo
c        set count of number of intersections with i circle to zero
      ni=0
c--------find intersection of i circle with each j circle in turn
      do 150 j=1,np
c        skip self
        if (j.eq.i) goto 150
c        cm(j).ge.2 means include whole sphere, so no intersection
        if (cm(j).ge.2._10) goto 150
c        cmij = 2 sin^2[th(ij)/2] = 1-cos th(ij)
        cmij=((rpi(1)-rp(1,j))**2+(rpi(2)-rp(2,j))**2
     *    +(rpi(3)-rp(3,j))**2)/2._10
c        cmj = 1-cos th(j)
c        bj = cj-ci*cij
c        d = 1-ci^2-cj^2-cij^2+2*ci*cj*cij
c        dph = atan(sqrt(d)/bj) is angle from rp(j) to intersection
        cmj=abs(cm(j))
        bj=(cmi-cmj)+cmij*(1._10-cmi)
        d=-(cmi-cmj)**2+cmij*(2._10*((cmi+cmj)-cmi*cmj)-cmij)
c        if i and j circles are angle e apart at closest approach, then
c        d approx 2 sin th(i) sin th(j) sin th(ij) * e for small e
        dc=2._10*sqrt(cmi*cmj*cmij*(2._10-cmi)*(2._10-cmj)*(2._10-cmij))
c........positive d means i and j circles intersect
c        if i and j circles are <= tol apart, treat d as zero
        if (d.gt.tol*dc) then
          d=sqrt(d)
c        ph = atan(yj/xj) is angle from xi to rp(j)
          xj=xi(1)*rp(1,j)+xi(2)*rp(2,j)+xi(3)*rp(3,j)
          yj=yi(1)*rp(1,j)+yi(2)*rp(2,j)+yi(3)*rp(3,j)
c        order intersection angles so segment from first to second angle
c        is inside j circle
c Notice order of evaluation of RHS of phi(1,j) and phi(2,j) is same;
c this ensures that gcc evaluates identically for identical arguments.
          if (cm(j).ge.0._10) then
c        phi(1,j)=ph-dph , phi(2,j)=ph+dph
            phi(1,j)=atan2(yj*bj-xj*d,xj*bj+yj*d)
            phi(2,j)=atan2(yj*bj+xj*d,xj*bj-yj*d)
          elseif (cm(j).lt.0._10) then
c        phi(1,j)=ph+dph , phi(2,j)=ph-dph
            phi(2,j)=atan2(yj*bj-xj*d,xj*bj+yj*d)
            phi(1,j)=atan2(yj*bj+xj*d,xj*bj-yj*d)
          endif
c        increment count of number of intersections
          ni=ni+2
c........zero d means i and j circles just touch;
c        negative d means i and j circles don't intersect
        else
c        bi = ci-cj*cij
          bi=(cmj-cmi)+cmij*(1._10-cmj)
c. . . . bi=0 means i and j circles coincide, implying also bj=0 and d=0
c        but test both bi and bj to guard against numerics
          if (bi.eq.0._10.or.bj.eq.0._10) then
c        null intersection of areas:
c        rp(i) and rp(j) point in same direction
            if (cmij.lt.1._10) then
c        cm(i) and cm(j) have opposite sign
              if ((scmi.ge.0.and.cm(j).lt.0._10)
     *          .or.(scmi.lt.0.and.cm(j).ge.0._10)) goto 220
c        rp(i) and rp(j) point in opposite directions
            elseif (cmij.gt.1._10) then
c        cm(i) and cm(j) have same sign
              if ((scmi.ge.0.and.cm(j).ge.0._10)
     *          .or.(scmi.lt.0.and.cm(j).lt.0._10)) goto 220
            endif
c        only do later of the two degenerate circles
            if (i.lt.j) goto 210
c. . . . i circle does not coincide with j circle
          else
c. . . . i circle is outside j circle
            if ((cm(j).ge.0._10.and.bj.gt.0._10)
     *        .or.(cm(j).lt.0._10.and.bj.lt.0._10)) then
c        j circle also outside i circle means null intersection area
              if ((scmi.ge.0.and.bi.gt.0._10)
     *          .or.(scmi.lt.0.and.bi.lt.0._10)) goto 220
c        skip i circle since it's entirely outside j circle
              goto 210
            endif
c. . . . i circle is inside j circle, and just touches it
            if (d.ge.-tol*dc) then
c. . . . j circle is also inside i circle, and just touches it
              if ((scmi.ge.0.and.bi.lt.0._10)
     *          .or.(scmi.lt.0.and.bi.gt.0._10)) then
c        ph = atan(yj/xj) is angle from xi to rp(j)
                xj=xi(1)*rp(1,j)+xi(2)*rp(2,j)+xi(3)*rp(3,j)
                yj=yi(1)*rp(1,j)+yi(2)*rp(2,j)+yi(3)*rp(3,j)
c        phi(1,j)=phi(2,j)=ph
                phi(1,j)=atan2(yj*bj,xj*bj)
                phi(2,j)=phi(1,j)
c        increment count of number of intersections
                ni=ni+2
              endif
            endif
          endif
        endif
  150 continue
c--------normal return
      return
c
c--------circle lies entirely outside another circle
  210 ni=-1
      return
c
c--------area is zero
  220 ni=-2
      return
c
      end
c
c-----------------------------------------------------------------------
      subroutine ggpij(np,gp,i,big,phi)
      integer np,gp(np),i
      real*10 big,phi(2,np)
c
c        local (automatic) variables
      integer j
c *
c * Called after gphij().
c * Identify friends:
c * if circle j intersects circle i, then i and j are friends.
c *
c  Input: np = number of caps.
c         i = circle
c         big = value of phi if i and j do not intersect.
c         phi(1,j), phi(2,j) = azimuthal angle about rp(i)
c              of intersection of j circle with i circle.
c Input/Output:
c         gp(j),j=1,np = which group of friends circle j belongs to:
c               i and j are friends
c               if i and j circles intersect (anywhere).
c
      do j=1,np
c      j circle intersects i circle
        if (phi(1,j).ne.big) then
c      make j group same as i group
          if (gp(i).lt.gp(j)) then
            gp(j)=gp(i)
c      make i group same as j group
          elseif (gp(j).lt.gp(i)) then
            gp(i)=gp(j)
          endif
        endif
      enddo
      return
      end
c
c-----------------------------------------------------------------------
      subroutine ggp(np,gp)
      integer np,gp(np)
c
c        local (automatic) variables
      integer j
c *
c * Called after all friends have been identified.
c * Consolidate groups by letting friends of friends be friends.
c *
c  Input: np = number of caps.
c Input/Output:
c         gp(j),j=1,np = which group of friends circle j belongs to:
c               i and j are friends
c               if i and j circles intersect (anywhere),
c               and friends of friends are friends.
c
      do j=1,np
  200   if (gp(j).ne.gp(gp(j))) then
          gp(j)=gp(gp(j))
          goto 200
        endif
      enddo
      return
      end
c
c-----------------------------------------------------------------------
      integer function gsegij(rp,cm,np,npb,npc,i,rpi,scmi,cmi,tol,ni,
     *  phi,iord,jml,jmu,jpl,jpu,nphbv,jm,jp,km,kp,phm,php,ph,dph)
      integer np,npb,npc,i,scmi,ni,iord(2*np),
     *  jml,jmu,jpl,jpu,nphbv,jm(nphbv),jp(nphbv),km(nphbv),kp(nphbv)
      real*10 rp(3,np),cm(np),rpi(3),cmi,tol,phi(2,np),phm,php,ph,dph
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        local (automatic) variables
      integer iphbv,j,jj,k,kk
      logical ismax
      real*10 bik,cmik,cmk,d,psi,psim(2),dphc,si
c        local variables to be saved
      integer jl,ju
      save jl,ju
c *
c * Determine whether next segment of i circle
c * is an edge of the polygon.
c * The thing that complicates this subroutine is the need
c * to deal with near multiple intersections, where several
c * j circles intersect the i circle at almost the same point.
c * Intersections closer than angle tol (great circle separation)
c * are considered coincident.
c *
c * If the segment is an edge, then km and kp are the circles
c * crossing at the lower and upper limits of the edge,
c * with multiple intersections correctly taken into account.
c * The values of phm and php are those corresponding to the
c * intersection with the km and kp circles.
c *
c * Normally nphbv = 1, but nphbv = 2 when called from gphbv.
c * If nphbv = 2, then the intersections of the i circle
c * are collected into two sets, those from the same polygon
c * as the i circle, and those from the abutting polygon.
c *
c  Input: rp
c         cm
c         npb
c         npc
c         i
c         rpi = rp(i)
c         scmi = sign(cm(i))
c         cmi = abs(cm(i))
c         np
c         tol = great circle angle closer than which
c               points on i circle are considered coincident
c         ni = number of intersections of j circles with i circle
c         phi = angles of j circles about i circle
c         iord = order of j circles about i circle
c         jpl = 0 on first call
c             = per output of previous call subsequently
c Output: jml, jmu = points jml to jmu are at lower point
c         jpl, jpu = points jpl to jpu are at upper point
c                    jml <= jmu < jpl <= jpu
c                    1 <= jmu <= ni
c                    jml may be <= 0, and jpl & jpu may be >= ni
c         nphbv = number of elements of arrays jm, jp, km, kp
c         jm = lower point to use
c         jp = upper point to use
c         km = circle at lower limit of segment
c         kp = circle at upper limit of segment
c         phm = azimuthal angle at lower limit of segment
c         php = azimuthal angle at upper limit of segment
c         ph = azimuthal angle at centre of segment
c         dph = azimuthal length of segment between limits
c Return value: -1 = error (tol is too large)
c               0 = segment is not edge of polygon
c               1 = segment is edge of polygon
c               2 = done all segments
c
      if (jpl.ne.0) then
c        done
        if (jpl.eq.jl+ni) goto 220
      endif
c        sin th(i)
      si=sqrt(cmi*(2._10-cmi))
c        dphc = azimuthal angle corresponding to great circle angle tol
      if (tol.gt.PI) goto 300
      dphc=sin(tol/2._10)/si
c        abort if tol/2 exceeds th(i)
      if (dphc.gt.1._10) goto 300
      dphc=2._10*asin(dphc)
c--------first segment: jml <= 1 <= jmu < jpl <= jpu < jml+ni
      if (jpl.eq.0) then
c        lower point: jml to jmu are all at the same azimuth phi
        jml=1
        do j=jml,ni
          jmu=j
          jp(1)=mod(j,ni)+1
          km(1)=(iord(j)+1)/2
          kp(1)=(iord(jp(1))+1)/2
c        lower and upper angles of segment
          phm=phi(1+mod(iord(j)+1,2),km(1))
          php=phi(1+mod(iord(jp(1))+1,2),kp(1))
          dph=php-phm
          if (dph.lt.0._10) dph=dph+TWOPI
          if (dph.gt.dphc) goto 110
        enddo
  110   continue
c        check if lower point goes lower than 1
        do j=ni,jmu+1,-1
          jp(1)=mod(j,ni)+1
          km(1)=(iord(j)+1)/2
          kp(1)=(iord(jp(1))+1)/2
c        lower and upper angles of segment
          phm=phi(1+mod(iord(j)+1,2),km(1))
          php=phi(1+mod(iord(jp(1))+1,2),kp(1))
          dph=php-phm
          if (dph.lt.0._10) dph=dph+TWOPI
          if (dph.gt.dphc) goto 120
          jml=j
        enddo
  120   continue
        if (jml.gt.jmu) jml=jml-ni
c        record range jl to ju of lower point of first segment
        jl=jml
        ju=jmu
c        segment is entire circle
        if (jmu-jml+1.ge.ni) then
c         print *,'gsegij: segment',jml,' to',jmu,
c    *      ' includes all',ni,' intersections'
          jpl=jmu+1
          jpu=jmu+ni
        else
c        upper point: jpl to jpu are all at the same azimuth phi
          jpl=jmu+1
          do j=jpl,jl-1+ni
            jpu=j
            jp(1)=mod(j,ni)+1
            km(1)=(iord(j)+1)/2
            kp(1)=(iord(jp(1))+1)/2
c        lower and upper angles of segment
            phm=phi(1+mod(iord(j)+1,2),km(1))
            php=phi(1+mod(iord(jp(1))+1,2),kp(1))
            dph=php-phm
            if (dph.lt.0._10) dph=dph+TWOPI
            if (dph.gt.dphc) goto 130
          enddo
  130     continue
c        first segment: jml <= 1 <= jmu < jpl <= jpu < jl+ni
          if (jml.gt.1.or.jml.gt.jmu.or.jmu.lt.1.or.jmu.gt.ni
     *      .or.jmu.ge.jpl.or.jpl.gt.jpu.or.jpu.ge.jl+ni) then
c        shouldn't happen
            print *,'*** error from gsegij: 1st segment,',
     *        ni,' intersections:',jml,jmu,jpl,jpu
          endif
        endif
c--------subsequent segments: jml <= jmu < jpl <= jpu <= ju+ni
      elseif (jpl.ne.0) then
c        lower point: jml to jmu are all at the same azimuth phi
        jml=jpl
        do j=jml,jl-1+ni
          jmu=j
          jp(1)=mod(j,ni)+1
          km(1)=(iord(j)+1)/2
          kp(1)=(iord(jp(1))+1)/2
c        lower and upper angles of segment
          phm=phi(1+mod(iord(j)+1,2),km(1))
          php=phi(1+mod(iord(jp(1))+1,2),kp(1))
          dph=php-phm
          if (dph.lt.0._10) dph=dph+TWOPI
          if (dph.gt.dphc) goto 140
        enddo
  140   continue
c        upper point: jpl to jpu are all at the same azimuth phi
        jpl=jmu+1
        do j=jpl,ni+ju
          jpu=j
          jm(1)=mod(j-1+ni,ni)+1
          jp(1)=mod(j,ni)+1
          km(1)=(iord(jm(1))+1)/2
          kp(1)=(iord(jp(1))+1)/2
c        lower and upper angles of segment
          phm=phi(1+mod(iord(jm(1))+1,2),km(1))
          php=phi(1+mod(iord(jp(1))+1,2),kp(1))
          dph=php-phm
          if (dph.lt.0._10) dph=dph+TWOPI
          if (dph.gt.dphc) goto 150
        enddo
  150   continue
c        subsequent segments: 1 < jml <= jmu < jpl <= jpu <= ju+ni
        if (jml.le.1.or.jml.gt.jmu.or.jmu.lt.1.or.jmu.gt.ni
     *    .or.jmu.ge.jpl.or.jpl.gt.jpu.or.jpu.gt.ju+ni) then
c        shouldn't happen
          print *,'*** error from gsegij: >= 2nd segment,',
     *      ni,' intersections:',jml,jmu,jpl,jpu
        endif
      endif
c--------process segment
c        lower angle(s) must be lower limit of segments jml to jmu
      do j=jml,jmu
        jm(1)=mod(j-1+ni,ni)+1
c        lower angle is an upper limit
        if (mod(iord(jm(1)),2).eq.0) then
          km(1)=(iord(jm(1))+1)/2
c        lower angle is not a lower limit
          if (phi(1,km(1)).ne.phi(2,km(1))) goto 210
        endif
      enddo
c        upper angle(s) must be upper limit of segments jpl to jpu
      do j=jpl,jpu
        jp(1)=mod(j-1+ni,ni)+1
c        upper angle is a lower limit
        if (mod(iord(jp(1)),2).eq.1) then
          kp(1)=(iord(jp(1))+1)/2
c        upper angle is not an upper limit
          if (phi(1,kp(1)).ne.phi(2,kp(1))) goto 210
        endif
      enddo
      jm(1)=mod(jml-1+ni,ni)+1
      jp(1)=mod(jpu-1+ni,ni)+1
      km(1)=(iord(jm(1))+1)/2
      kp(1)=(iord(jp(1))+1)/2
      phm=phi(1+mod(iord(jm(1))+1,2),km(1))
      php=phi(1+mod(iord(jp(1))+1,2),kp(1))
c        check segment satisfies all conditions
      if (php.gt.phm) then
        do j=1,ni
c        need to check against k circle only once, at lower limit
          if (mod(iord(j),2).eq.1) then
            k=(iord(j)+1)/2
c        require order   k- ...ph- ph+... k+
            if (phi(2,k).gt.phi(1,k)) then
              if (php.le.phi(1,k).or.phm.ge.phi(2,k)) goto 210
c        or   k+ k- ...ph- ph+...   or   ...ph- ph+... k+ k-
            elseif (phi(2,k).lt.phi(1,k)) then
              if (php.le.phi(1,k).and.phm.ge.phi(2,k)) goto 210
            endif
          endif
        enddo
      elseif (php.lt.phm) then
        do j=1,ni
c        need to check against k circle only once, at lower limit
          if (mod(iord(j),2).eq.1) then
            k=(iord(j)+1)/2
c        require order   ph+... k+ k- ...ph-
            if (phi(2,k).gt.phi(1,k)) then
              if (php.le.phi(1,k).and.phm.ge.phi(2,k)) goto 210
            endif
          endif
        enddo
      endif
c........point at lower limit is one with largest exterior angle psi
      if (jml.eq.jmu) then
        if (nphbv.eq.2) then
          jj=jm(1)
          kk=km(1)
          do iphbv=1,nphbv
            if ((iphbv.eq.1
     *        .and.((i.le.npb.and.kk.le.npb)
     *          .or.(i.gt.npb.and.kk.gt.npb)
     *          .or.kk.gt.npc))
     *      .or.(iphbv.eq.2
     *        .and.((i.le.npb.and.kk.gt.npb)
     *          .or.(i.gt.npb.and.kk.le.npb)
     *          .or.kk.gt.npc))) then
              jm(iphbv)=jj
              km(iphbv)=kk
            else
              jm(iphbv)=0
              km(iphbv)=0
            endif
          enddo
        endif
      else
        do iphbv=1,nphbv
          psim(iphbv)=-1._10-2._10*tol
        enddo
        if (nphbv.eq.2) then
          do iphbv=1,nphbv
            jm(iphbv)=0
            km(iphbv)=0
          enddo
        endif
        do j=jml,jmu
          jj=mod(j-1+ni,ni)+1
c        lower angle is a lower limit
          if (mod(iord(jj),2).eq.1) then
            kk=(iord(jj)+1)/2
            cmk=abs(cm(kk))
c        cmik = 1-cos th(ik)
            cmik=((rpi(1)-rp(1,kk))**2+(rpi(2)-rp(2,kk))**2
     *        +(rpi(3)-rp(3,kk))**2)/2._10
c        bik = cik-ci*ck
c        d = 1-ci^2-ck^2-cik^2+2*ci*ck*cik
c        cos psi = bik/(si*sk)
c        sin psi = sqrt(d)/(si*sk)
c        psi = atan(sqrt(d)/bik) is exterior angle at intersection
            bik=(cmi+cmk)-cmi*cmk-cmik
            d=-(cmi-cmk)**2+cmik*(2._10*((cmi+cmk)-cmi*cmk)-cmik)
            if (d.lt.0._10) d=0._10
            if ((scmi.ge.0.and.cm(kk).lt.0._10)
     *        .or.(scmi.lt.0.and.cm(kk).ge.0._10)) bik=-bik
            do iphbv=1,nphbv
              if (iphbv.eq.2) bik=-bik
              psi=atan2(sqrt(d),bik)
              ismax=.false.
              if (nphbv.eq.1
     *          .or.(iphbv.eq.1
     *            .and.((i.le.npb.and.kk.le.npb)
     *              .or.(i.gt.npb.and.kk.gt.npb)
     *              .or.kk.gt.npc))
     *          .or.(iphbv.eq.2
     *            .and.((i.le.npb.and.kk.gt.npb)
     *              .or.(i.gt.npb.and.kk.le.npb)
     *              .or.kk.gt.npc))) then
c        choose largest exterior angle psi
                if (psi.gt.psim(iphbv)+tol) then
                  ismax=.true.
                elseif (psi.ge.psim(iphbv)-tol) then
                  if (cm(kk).ge.0._10) then
                    if (cm(km(iphbv)).ge.0._10) then
c        only do tighter of two circles with same exterior angle
                      if (cm(kk).lt.cm(km(iphbv))) then
                        ismax=.true.
c        or later of two degenerate circles
                      elseif (cm(kk).eq.cm(km(iphbv))
     *                  .and.kk.gt.km(iphbv)) then
                        ismax=.true.
                      endif
                    else
                      if (cm(kk)-1._10.lt.cm(km(iphbv))+1._10) then
                        ismax=.true.
                      elseif (cm(kk)-1._10.eq.cm(km(iphbv))+1._10
     *                  .and.kk.gt.km(iphbv)) then
                        ismax=.true.
                      endif
                    endif
                  else
                    if (cm(km(iphbv)).lt.0._10) then
                      if (cm(kk).lt.cm(km(iphbv))) then
                        ismax=.true.
                      elseif (cm(kk).eq.cm(km(iphbv))
     *                  .and.kk.gt.km(iphbv)) then
                        ismax=.true.
                      endif
                    else
                      if (cm(kk)+1._10.lt.cm(km(iphbv))-1._10) then
                        ismax=.true.
                      elseif (cm(kk)+1._10.eq.cm(km(iphbv))-1._10
     *                  .and.kk.gt.km(iphbv)) then
                        ismax=.true.
                      endif
                    endif
                  endif
                endif
              endif
              if (ismax) then
                jm(iphbv)=jj
                km(iphbv)=kk
                psim(iphbv)=psi
              endif
            enddo
          endif
        enddo
      endif
c........point at upper limit is one with largest exterior angle psi
      if (jpl.eq.jpu) then
        if (nphbv.eq.2) then
          jj=jp(1)
          kk=kp(1)
          do iphbv=1,nphbv
            if ((iphbv.eq.1
     *        .and.((i.le.npb.and.kk.le.npb)
     *          .or.(i.gt.npb.and.kk.gt.npb)
     *          .or.kk.gt.npc))
     *      .or.(iphbv.eq.2
     *        .and.((i.le.npb.and.kk.gt.npb)
     *          .or.(i.gt.npb.and.kk.le.npb)
     *          .or.kk.gt.npc))) then
              jp(iphbv)=jj
              kp(iphbv)=kk
            else
              jp(iphbv)=0
              kp(iphbv)=0
            endif
          enddo
        endif
      else
        do iphbv=1,nphbv
          psim(iphbv)=-1._10-2._10*tol
        enddo
        if (nphbv.eq.2) then
          do iphbv=1,nphbv
            jp(iphbv)=0
            kp(iphbv)=0
          enddo
        endif
        do j=jpl,jpu
          jj=mod(j-1+ni,ni)+1
c        upper angle is an upper limit
          if (mod(iord(jj),2).eq.0) then
            kk=(iord(jj)+1)/2
            cmk=abs(cm(kk))
c        cmik = 1-cos th(ik)
            cmik=((rpi(1)-rp(1,kk))**2+(rpi(2)-rp(2,kk))**2
     *        +(rpi(3)-rp(3,kk))**2)/2._10
c        bik = cik-ci*ck
c        d = 1-ci^2-ck^2-cik^2+2*ci*ck*cik
c        cos psi = bik/(si*sk)
c        sin psi = sqrt(d)/(si*sk)
c        psi = atan(sqrt(d)/bik) is exterior angle at intersection
            bik=(cmi+cmk)-cmi*cmk-cmik
            d=-(cmi-cmk)**2+cmik*(2._10*((cmi+cmk)-cmi*cmk)-cmik)
            if (d.lt.0._10) d=0._10
            if ((scmi.ge.0.and.cm(kk).lt.0._10)
     *        .or.(scmi.lt.0.and.cm(kk).ge.0._10)) bik=-bik
            do iphbv=1,nphbv
              if (iphbv.eq.2) bik=-bik
              psi=atan2(sqrt(d),bik)
              ismax=.false.
              if (nphbv.eq.1
     *          .or.(iphbv.eq.1
     *            .and.((i.le.npb.and.kk.le.npb)
     *              .or.(i.gt.npb.and.kk.gt.npb)
     *              .or.kk.gt.npc))
     *          .or.(iphbv.eq.2
     *            .and.((i.le.npb.and.kk.gt.npb)
     *              .or.(i.gt.npb.and.kk.le.npb)
     *              .or.kk.gt.npc))) then
c        choose largest exterior angle psi
                if (psi.gt.psim(iphbv)+tol) then
                  ismax=.true.
                elseif (psi.ge.psim(iphbv)-tol) then
                  if (cm(kk).ge.0._10) then
                    if (cm(kp(iphbv)).ge.0._10) then
c        only do tighter of two circles with same exterior angle
                      if (cm(kk).lt.cm(kp(iphbv))) then
                        ismax=.true.
c        or later of two degenerate circles
                      elseif (cm(kk).eq.cm(kp(iphbv))
     *                  .and.kk.gt.kp(iphbv)) then
                        ismax=.true.
                      endif
                    else
                      if (cm(kk)-1._10.lt.cm(kp(iphbv))+1._10) then
                        ismax=.true.
                      elseif (cm(kk)-1._10.eq.cm(kp(iphbv))+1._10
     *                  .and.kk.gt.kp(iphbv)) then
                        ismax=.true.
                      endif
                    endif
                  else
                    if (cm(kp(iphbv)).lt.0._10) then
                      if (cm(kk).lt.cm(kp(iphbv))) then
                        ismax=.true.
                      elseif (cm(kk).eq.cm(kp(iphbv))
     *                  .and.kk.gt.kp(iphbv)) then
                        ismax=.true.
                      endif
                    else
                      if (cm(kk)+1._10.lt.cm(kp(iphbv))-1._10) then
                        ismax=.true.
                      elseif (cm(kk)+1._10.eq.cm(kp(iphbv))-1._10
     *                  .and.kk.gt.kp(iphbv)) then
                        ismax=.true.
                      endif
                    endif
                  endif
                endif
              endif
              if (ismax) then
                jp(iphbv)=jj
                kp(iphbv)=kk
                psim(iphbv)=psi
              endif
            enddo
          endif
        enddo
      endif
c        circles at upper and lower limits
      if (km(1).ne.0) then
        phm=phi(1+mod(iord(jm(1))+1,2),km(1))
      else
        phm=phi(1+mod(iord(jm(2))+1,2),km(2))
      endif
      if (kp(1).ne.0) then
        php=phi(1+mod(iord(jp(1))+1,2),kp(1))
      else
        php=phi(1+mod(iord(jp(2))+1,2),kp(2))
      endif
c        angular length, centre point of segment
      if (php.gt.phm) then
        dph=php-phm
        ph=(php+phm)/2._10
      elseif (php.le.phm) then
        ph=(php+phm)/2._10
        if (ph.le.0._10) then
          ph=ph+PI
          php=php+TWOPI
        elseif (ph.gt.0._10) then
          ph=ph-PI
          phm=phm-TWOPI
        endif
        dph=php-phm
      endif
c      segment is edge of polygon
  200 gsegij=1
      return
c
c------segment is not edge of polygon
  210 gsegij=0
      return
c
c------done full circle
  220 gsegij=2
      return
c
c------tol is too large
  300 gsegij=-1
      return
c
      end
c
c-----------------------------------------------------------------------
      subroutine gvtrail(scmi,np,i,km,kp,vtrail,vik,nvmax,nv,ik,ikchk)
      integer scmi,np,i,km,kp,nvmax,vtrail(nvmax),vik(nvmax,2),nv,ik
      real*10 ikchk
c
c        externals
      integer ik2ik
c     integer ik2i,ik2k
c        local (automatic) variables
      integer iv,k,l
      real*10 ikran
c *
c * Record endpoints of edge.
c *
c  Input: scmi
c         np
c         i
c         km, kp
c         nvmax
c         nv
c Output: vtrail
c         vik
c         ik
c Input/Output: ikchk
c         
c        two end points of the edge, going right-handedly around edge
      do l=1,2
c        end point is intersection of i circle with k circle
        if ((l.eq.1.and.scmi.ge.0).or.(l.eq.2.and.scmi.lt.0)) then
          k=km
        else
          k=kp
        endif
c       print *,'     intersect',i,k
c        from edge k to edge i right-handedly through vertex
        if (l.eq.1) then
          ik=ik2ik(np,k,i)
c        from edge i to edge k right-handedly through vertex
        else
          ik=ik2ik(np,i,k)
        endif
        if (nv.le.nvmax) then
          vik(nv,l)=ik
        endif
c        pseudo-random number from ik
        call ikrand(ik,ikran)
c        new intersection
        if (i.lt.k) then
c        ikchk = ikchk + ikran, added as unsigned long long's
          call ikrandp(ikchk,ikran)
c        intersection already met
        else
c        ikchk = ikchk - ikran, subtracted as unsigned long long's
          call ikrandm(ikchk,ikran)
          if (nv.le.nvmax) then
c        index of vertex already met
            if (l.eq.1) then
              do iv=1,nv
                if (vik(iv,2).eq.ik) then
c        vertex after iv is nv
                  vtrail(iv)=nv
                  goto 240
                endif
              enddo
            elseif (l.eq.2) then
              do iv=1,nv
                if (vik(iv,1).eq.ik) then
c        vertex after nv is iv
                  vtrail(nv)=iv
                  goto 240
                endif
              enddo
            endif
c        can happen if near multiple intersection is inconsistent
c           print *,'*** from gvtrail: no vertex',
c    *        ' (',ik2i(np,ik),ik2k(np,ik),')',
c    *        ' found at',i,', edge',km,kp,'???'
c           write (*,'(" vertices so far are:",$)')
c           do iv=1,nv
c             write (*,'(" (",i2,i3,") (",i2,i3,")",$)')
c    *          ik2k(np,vik(iv,1)),ik2i(np,vik(iv,1)),
c    *          ik2i(np,vik(iv,2)),ik2k(np,vik(iv,2))
c           enddo
c           write (*,'(/$)')
  240       continue
          endif
        endif
      enddo
      return
      end
c
c-----------------------------------------------------------------------
      integer function ik2ik(np,i,k)
      integer np,i,k
c
      integer ik
c
c        gives ik = 1,2,...,np(np-1) for i,k = 0,1,...,np with i != k
      ik=i+np*k
      if (i.lt.k) ik=ik+1
      ik2ik=ik
      return
      end
c
c-----------------------------------------------------------------------
      integer function ik2i(np,ik)
      integer np,ik
c
      integer i,k
c
      i=mod(ik-1,np)
      k=(ik-1)/np
      if (i.ge.k) i=i+1
      ik2i=i
      return
      end
c
c-----------------------------------------------------------------------
      integer function ik2k(np,ik)
      integer np,ik
c
      integer k
c
      k=(ik-1)/np
      ik2k=k
      return
      end
c
c-----------------------------------------------------------------------
      subroutine gvord(np,nv,ipv,gp,ev,nev,vtrail,vord,vik,gord)
      integer np,nv,ipv(nv),gp(np),ev(nv),nev,
     *  vtrail(nv),vord(nv),vik(nv),gord(nv)
c
c        externals
      integer ik2i,ik2k
c        local (automatic) variables
      integer iev,inter,iv,ivm,jv,kv,nvm
c *
c * Order of vertices around polygon.
c *
c  Input: np = number of caps
c         nv = number of vertices
c         ipv(iv) = circle number of vertex iv
c         gp(i) = group to which circle i belongs
c         vtrail = vertex trail
c         vik(iv) = value of ik at iv'th vertex
c Output: vord = vertex order
c         ev = end indices of each connected sequence of vertices
c         nev = number of connected sequences of vertices
c
      nev=0
      if (nv.gt.0) then
c       print *,'gvord: vertex trail:',(vtrail(iv),iv=1,nv)
c       print *,'gvord: vik_1 on input:',(vord(iv),iv=1,nv)
c       print *,'gvord: vik_2 on input:',(vik(iv),iv=1,nv)
c        group vertex belongs to
        do iv=1,nv
          vord(iv)=gp(ipv(iv))
        enddo
c        order vertices by group
        call finibot(vord,nv,gord,nv)
c        initialize vord to zero
        do iv=1,nv
          vord(iv)=0
        enddo
        jv=0
        iev=0
c        do intersecting, then non-intersecting circles
        do inter=1,2
          do 320 ivm=1,nv
c        order connected sequences by group
            nvm=gord(ivm)
c        find first vertex not already traversed
            do iv=1,nv
              if (vord(iv).eq.nvm) goto 320
            enddo
            if (inter.eq.1) then
              if (ik2i(np,vik(nvm)).eq.0.or.ik2k(np,vik(nvm)).eq.0)
     *          goto 320
            else
              if (ik2i(np,vik(nvm)).ne.0.and.ik2k(np,vik(nvm)).ne.0)
     *          goto 320
            endif
c        index of first vertex of this boundary
            jv=jv+1
            vord(jv)=nvm
c        circulate
            kv=jv+1
            do jv=kv,nv
c        next vertex of this boundary
              vord(jv)=vtrail(vord(jv-1))
c        gone full circle
              if (vtrail(vord(jv)).eq.nvm) then
c        record cumulative length
                iev=iev+1
                ev(iev)=jv
                nev=nev+1
                if (jv.eq.nv) goto 330
                goto 320
              endif
            enddo
  320     continue
        enddo
  330   continue
c       print *,'vertex order:',(vord(iv),iv=1,nv)
c       print *,'vertex groups:',(gp(ipv(iv)),iv=1,nv)
c        should not happen
        if (vtrail(vord(nv)).ne.nvm) then
          print *,'*** from gvord: last vertex',vord(nv),
     *      ' should connect to',nvm,'???'
        endif
      endif
      return
c
      end
c
c-----------------------------------------------------------------------
      real*10 function cmijf(rpi,rpj)
      real*10 rpi(3),rpj(3)
c *
c * 1 - cos th(ij)
c * where th(ij) is angle between unit vectors rpi and rpj.
c *
c * Input: rpi, rpj = unit vectors
c  Output: cmij = 1 - cos th(ij)
c
      cmijf=((rpi(1)-rpj(1))**2+(rpi(2)-rpj(2))**2
     *  +(rpi(3)-rpj(3))**2)/2._10
c
      return
      end
c
c-----------------------------------------------------------------------
      subroutine vpermi(ix,n,iperm,iwk)
      integer n,iperm(n)
      integer ix(n),iwk(n)
c
c        local (automatic) variables
      integer i,j
c *
c * Permutes elements of integer array ix(n) by permutation iperm(n).
c *
c  Input: n = dimension of array ix
c         iperm = array of dimension n specifying permutation of ix
c Input/Output: ix = integer array of dimension n
c Work array: wk of dimension n
c
      do i=1,n
        iwk(i)=ix(i)
      enddo
      do i=1,n
        j=iperm(i)
        ix(i)=iwk(j)
      enddo
      return
      end
c
c-----------------------------------------------------------------------
      subroutine vpermd(x,n,iperm,wk)
      integer n,iperm(n)
      real*10 x(n),wk(n)
c
c        local (automatic) variables
      integer i,j
c *
c * Permutes elements of real*10 array x(n) by permutation iperm(n).
c *
c  Input: n = dimension of array x
c         iperm = array of dimension n specifying permutation of x
c Input/Output: x = real*10 array of dimension n
c Work array: wk of dimension n
c
      do i=1,n
        wk(i)=x(i)
      enddo
      do i=1,n
        j=iperm(i)
        x(i)=wk(j)
      enddo
      return
      end
c
c-----------------------------------------------------------------------
      subroutine vpermdd(x,m,n,iperm,wk)
      integer m,n,iperm(n)
      real*10 x(m,n),wk(n)
c
c        local (automatic) variables
      integer i,j,k
c *
c * Permutes each column of real*10 array x(m,n) by permutation iperm(n).
c *
c  Input: m,n = dimensions of array x
c         iperm = array of dimension n specifying permutation
c                 of each column x
c Input/Output: x = real*10 array of dimension m,n
c Work array: wk of dimension n
c
      do k=1,m
        do i=1,n
          wk(i)=x(k,i)
        enddo
        do i=1,n
          j=iperm(i)
          x(k,i)=wk(j)
        enddo
      enddo
      return
      end
c
c-----------------------------------------------------------------------
      integer function garpi(area,iarea,rp,cm,np,
     *  whole,nbd0m,nbd0p,nbd,nmult,tol)
      integer iarea,np,nbd0m,nbd0p,nbd,nmult
      logical whole
      real*10 area,rp(3,np),cm(np),tol
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        data variables
      real*10 areatol
c        local (automatic) variables
      integer i,icmmin
      real*10 cmmin,darea,p
c *
c * Add iarea*2*pi to area.
c *
c  Input: rp
c         cm
c         np
c         whole = whether region is whole sphere.
c         nbd0m = number of non-intersecting circles bounding polygon
c                 with cm < 0.
c         nbd0p = number of non-intersecting circles bounding polygon
c                 with cm >= 0.
c         nbd = number of edges bounding polygon,
c               excluding non-intersecting circles.
c         nmult = number of near multiply-intersecting circles
c                 on boundary of polygon.
c Output: iarea = number of 2*pi's by which area was adjusted.
c Input/Output: area -> area+iarea*2*pi.
c Return value: 0 = ok;
c               1 = recommend retry with enlarged tol.
c
c        ok if area tests not too far outside [0,max]
      data areatol /1.e-10_10/
c
      if (whole) then
        iarea=2
        area=area+iarea*TWOPI
c        all boundaries are non-intersecting circles
      elseif (nbd.eq.0) then
        if (nbd0m.eq.0.and.nbd0p.eq.0) then
          iarea=0
        else
c        from area formula involving the Euler characteristic
          iarea=2*(1-nbd0p)
          area=area+iarea*TWOPI
        endif
c        some boundaries are intersecting circles
      else
c        add/subtract 2*pi's to area to ensure 0.le.area.lt.2*pi
        iarea=area/TWOPI
        area=area-iarea*TWOPI
C       if (iarea.ne.0) print *,'area +=',iarea,' * TWOPI =',area
        if (area.lt.0._10) then
          iarea=iarea+1
          area=area+TWOPI
C         print *,'area += TWOPI =',area
        endif
c        there were near multiple intersections
        if (nmult.ge.1) then
c        chances are area just less than 2*pi is actually zero
          if (area.ge.TWOPI-areatol) then
            iarea=iarea-1
            area=0._10
            goto 400
          endif
        endif
c        check area does not exceed area within any one circle
        cmmin=2._10
        do i=1,np
          if (cm(i).ge.0._10) then
            if (cm(i).lt.cmmin) then
              cmmin=cm(i)
              icmmin=i
            endif
          elseif (cm(i).lt.0._10) then
            if (2._10+cm(i).lt.cmmin) then
              cmmin=2._10+cm(i)
              icmmin=i
            endif
          endif
        enddo
        darea=TWOPI*cmmin
        p=area/darea
C       print *,'area/area(',icmmin,')=',area,' /',darea,' =',p
        if (p.gt.1._10) then
c        check if discrepancy is from numerical roundoff
          if (abs(area-TWOPI).le.areatol) then
            area=0._10
          elseif (area.le.darea+areatol) then
            area=darea
c        problem is genuine: can happen with nearly kissing circles
          else
C           print *,'*** from garpi: at tol =',tol,
C    *        ' area/area(',icmmin,')=',area,' /',darea,
C    *        ' =',p,'  should be .le. 1'
            goto 410
          endif
        endif
      endif
c        done
 400  garpi=0
      return
c
c        return with recommendation to retry with enlarged tol
 410  garpi=1
      return
      end
c
c-----------------------------------------------------------------------
      subroutine gtol(tol,tolin)
      real*10 tol,tolin
c *
c * Modify tolerance tol to multiple intersections.
c * The tolerance tol is changed by successive factors of 2
c * from the original input tolerance tolin,
c * see-sawing between smaller and larger values.
c *
      if (tolin.le.0._10) then
c        write(*,*) 'tolin =', tolin
        if (tol.le.0._10) then
          tol=1.e-15_10
c          write(*,*) 'tol =', tol
        else
          tol=tol*4._10
c          write(*,*) 'tol =', tol
        endif
c        see-saw tolerance between smaller and larger values
      else
        if (tol.ge.tolin) then
c          write(*,*) '(GE) before: TOL=', tol
c          write(*,*) '(ge) before: tolin=', tolin
          tol=tolin*tolin/tol/6._10
c          if (tol.gt.0.00001) then
c            write(*,*) '(ge) after: tol=', tol
c          endif
c          write(*,*) '(ge) after: tolin=', tolin
        else
c          write(*,*) '(lt) before: tol=', tol
c          write(*,*) '(lt) before: tolin=', tolin
          tol=tolin*tolin/tol
c          if (tol.ge.1.e-5_10) then
c            write(*,*) '(lt) after: tol=', tol
c          endif
c          write(*,*) '(lt) after: tolin=', tolin
        endif
      endif
      return
      end
c

subroutine basis_function_b_val ( tdata, tval, yval )

!*****************************************************************************80
!
!! BASIS_FUNCTION_B_VAL evaluates the B spline basis function.
!
!  Discussion:
!
!    The B spline basis function is a piecewise cubic which
!    has the properties that:
!
!    * it equals 2/3 at TDATA(3), 1/6 at TDATA(2) and TDATA(4);
!    * it is 0 for TVAL <= TDATA(1) or TDATA(5) <= TVAL;
!    * it is strictly increasing from TDATA(1) to TDATA(3),
!      and strictly decreasing from TDATA(3) to TDATA(5);
!    * the function and its first two derivatives are continuous
!      at each node TDATA(I).
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    06 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Alan Davies, Philip Samuels,
!    An Introduction to Computational Geometry for Curves and Surfaces,
!    Clarendon Press, 1996,
!    ISBN: 0-19-851478-6,
!    LC: QA448.D38.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) TDATA(5), the nodes associated with the 
!    basis function.  The entries of TDATA are assumed to be distinct 
!    and increasing.
!
!    Input, real ( kind = 8 ) TVAL, a point at which the B spline basis 
!    function is to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the function at TVAL.
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 5

  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) u
  real    ( kind = 8 ) yval

  if ( tval <= tdata(1) .or. tdata(ndata) <= tval ) then
    yval = 0.0D+00
    return
  end if
!
!  Find the interval [ TDATA(LEFT), TDATA(RIGHT) ] containing TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  U is the normalized coordinate of TVAL in this interval.
!
  u = ( tval - tdata(left) ) / ( tdata(right) - tdata(left) )
!
!  Now evaluate the function.
!
  if ( tval < tdata(2) ) then
    yval = u**3 / 6.0D+00
  else if ( tval < tdata(3) ) then
    yval = ( ( (    - 3.0D+00   &
                * u + 3.0D+00 ) &
                * u + 3.0D+00 ) &
                * u + 1.0D+00 ) / 6.0D+00
  else if ( tval < tdata(4) ) then
    yval = ( ( (    + 3.0D+00   &
                * u - 6.0D+00 ) &
                * u + 0.0D+00 ) &
                * u + 4.0D+00 ) / 6.0D+00
  else if ( tval < tdata(5) ) then
    yval = ( 1.0D+00 - u )**3 / 6.0D+00
  end if

  return
end
subroutine basis_function_beta_val ( beta1, beta2, tdata, tval, yval )

!*****************************************************************************80
!
!! BASIS_FUNCTION_BETA_VAL evaluates the beta spline basis function.
!
!  Discussion:
!
!    With BETA1 = 1 and BETA2 = 0, the beta spline basis function 
!    equals the B spline basis function.
!
!    With BETA1 large, and BETA2 = 0, the beta spline basis function
!    skews to the right, that is, its maximum increases, and occurs
!    to the right of the center.
!
!    With BETA1 = 1 and BETA2 large, the beta spline becomes more like
!    a linear basis function; that is, its value in the outer two intervals
!    goes to zero, and its behavior in the inner two intervals approaches
!    a piecewise linear function that is 0 at the second node, 1 at the
!    third, and 0 at the fourth.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    09 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Alan Davies, Philip Samuels,
!    An Introduction to Computational Geometry for Curves and Surfaces,
!    Clarendon Press, 1996,
!    ISBN: 0-19-851478-6,
!    LC: QA448.D38.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BETA1, the skew or bias parameter.
!    BETA1 = 1 for no skew or bias.
!
!    Input, real ( kind = 8 ) BETA2, the tension parameter.
!    BETA2 = 0 for no tension.
!
!    Input, real ( kind = 8 ) TDATA(5), the nodes associated with the 
!    basis function.  The entries of TDATA are assumed to be distinct 
!    and increasing.
!
!    Input, real ( kind = 8 ) TVAL, a point at which the B spline 
!    basis function is to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the function at TVAL.
!
  implicit none

  integer ( kind = 4 ), parameter :: ndata = 5

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) beta1
  real    ( kind = 8 ) beta2
  real    ( kind = 8 ) c
  real    ( kind = 8 ) d
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) u
  real    ( kind = 8 ) yval

  if ( tval <= tdata(1) .or. tdata(ndata) <= tval ) then
    yval = 0.0D+00
    return
  end if
!
!  Find the interval [ TDATA(LEFT), TDATA(RIGHT) ] containing TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  U is the normalized coordinate of TVAL in this interval.
!
  u = ( tval - tdata(left) ) / ( tdata(right) - tdata(left) )
!
!  Now evaluate the function.
!
  if ( tval < tdata(2) ) then

    yval = 2.0D+00 * u**3 

  else if ( tval < tdata(3) ) then

    a = beta2 + 4.0D+00 * beta1 + 4.0D+00 * beta1 * beta1 &
      + 6.0D+00 * ( 1.0D+00 - beta1 * beta1 ) &
      - 3.0D+00 * ( 2.0D+00 + beta2 + 2.0D+00 * beta1 ) &
      + 2.0D+00 * ( 1.0D+00 + beta2 + beta1 + beta1 * beta1 )

    b = - 6.0D+00 * ( 1.0D+00 - beta1 * beta1 ) &
        + 6.0D+00 * ( 2.0D+00 + beta2 + 2.0D+00 * beta1 ) &
        - 6.0D+00 * ( 1.0D+00 + beta2 + beta1 + beta1 * beta1 )

    c = - 3.0D+00 * ( 2.0D+00 + beta2 + 2.0D+00 * beta1 ) &
        + 6.0D+00 * ( 1.0D+00 + beta2 + beta1 + beta1 * beta1 )

    d = - 2.0D+00 * ( 1.0D+00 + beta2 + beta1 + beta1 * beta1 )

    yval = ( ( d * u + c ) * u + b ) * u + a

  else if ( tval < tdata(4) ) then

    a = beta2 + 4.0D+00 * beta1 + 4.0D+00 * beta1 * beta1

    b = - 6.0D+00 * beta1 * ( 1.0D+00 - beta1 * beta1 )

    c = - 3.0D+00 * ( beta2 + 2.0D+00 * beta1**2 + 2.0D+00 * beta1**3 )

    d = 2.0D+00 * ( beta2 + beta1 + beta1**2 + beta1**3 )

    yval = ( ( d * u + c ) * u + b ) * u + a

  else if ( tval < tdata(5) ) then

    yval = 2.0D+00 * beta1**3 * ( 1.0D+00 - u )**3

  end if

  yval = yval / ( 2.0D+00 + beta2 + 4.0D+00 * beta1 + 4.0D+00 * beta1**2 &
    + 2.0D+00 * beta1**3 )

  return
end
subroutine basis_matrix_b_uni ( mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_B_UNI sets up the uniform B spline basis matrix.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    James Foley, Andries vanDam, Steven Feiner, John Hughes,
!    Computer Graphics, Principles and Practice,
!    Second Edition,
!    Addison Wesley, 1995,
!    ISBN: 0201848406,
!    LC: T385.C5735.
!
!  Parameters:
!
!    Output, real ( kind = 8 ) MBASIS(4,4), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) mbasis(4,4)
!
!  In the following statement, the matrix appears as though it
!  has been transposed.
!
  mbasis(1:4,1:4) = real ( reshape ( &
    (/ -1,  3, -3, 1,                &
        3, -6,  0, 4,                &
       -3,  3,  3, 1,                &
        1,  0,  0, 0 /),             &
    (/ 4, 4 /) ), kind = 8 ) / 6.0D+00

  return
end
subroutine basis_matrix_beta_uni ( beta1, beta2, mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_BETA_UNI sets up the uniform beta spline basis matrix.
!
!  Discussion:
!
!    If BETA1 = 1 and BETA2 = 0, then the beta spline reduces to 
!    the B spline.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    12 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    James Foley, Andries vanDam, Steven Feiner, John Hughes,
!    Computer Graphics, Principles and Practice,
!    Second Edition,
!    Addison Wesley, 1995,
!    ISBN: 0201848406,
!    LC: T385.C5735.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BETA1, the skew or bias parameter.
!    BETA1 = 1 for no skew or bias.
!
!    Input, real ( kind = 8 ) BETA2, the tension parameter.
!    BETA2 = 0 for no tension.
!
!    Output, real ( kind = 8 ) MBASIS(4,4), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) beta1
  real    ( kind = 8 ) beta2
  real    ( kind = 8 ) delta
  real    ( kind = 8 ) mbasis(4,4)

  mbasis(1,1) = - 2.0D+00 * beta1 * beta1 * beta1
  mbasis(1,2) =   2.0D+00 * beta2 &
    + 2.0 * beta1 * ( beta1 * beta1 + beta1 + 1.0D+00 )
  mbasis(1,3) = - 2.0D+00 * ( beta2 + beta1 * beta1 + beta1 + 1.0D+00 )
  mbasis(1,4) =   2.0D+00

  mbasis(2,1) =   6.0D+00 * beta1 * beta1 * beta1
  mbasis(2,2) = - 3.0D+00 * beta2 &
    - 6.0D+00 * beta1 * beta1 * ( beta1 + 1.0D+00 )
  mbasis(2,3) =   3.0D+00 * beta2 + 6.0D+00 * beta1 * beta1
  mbasis(2,4) =   0.0D+00

  mbasis(3,1) = - 6.0D+00 * beta1 * beta1 * beta1
  mbasis(3,2) =   6.0D+00 * beta1 * ( beta1 - 1.0D+00 ) * ( beta1 + 1.0D+00 )
  mbasis(3,3) =   6.0D+00 * beta1
  mbasis(3,4) =   0.0D+00

  mbasis(4,1) =   2.0D+00 * beta1 * beta1 * beta1
  mbasis(4,2) =   4.0D+00 * beta1 * ( beta1 + 1.0D+00 ) + beta2
  mbasis(4,3) =   2.0D+00
  mbasis(4,4) =   0.0D+00

  delta = ( ( 2.0D+00   &
    * beta1 + 4.0D+00 ) &
    * beta1 + 4.0D+00 ) &
    * beta1 + 2.0D+00 + beta2

  mbasis(1:4,1:4) = mbasis(1:4,1:4) / delta

  return
end
subroutine basis_matrix_bezier ( mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_BEZIER sets up the cubic Bezier spline basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points are stored as
!    ( P1, P2, P3, P4 ).  P1 is the function value at T = 0, while
!    P2 is used to approximate the derivative at T = 0 by
!    dP/dt = 3 * ( P2 - P1 ).  Similarly, P4 is the function value
!    at T = 1, and P3 is used to approximate the derivative at T = 1
!    by dP/dT = 3 * ( P4 - P3 ).
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    James Foley, Andries vanDam, Steven Feiner, John Hughes,
!    Computer Graphics, Principles and Practice,
!    Second Edition,
!    Addison Wesley, 1995,
!    ISBN: 0201848406,
!    LC: T385.C5735.
!
!  Parameters:
!
!    Output, real ( kind = 8 ) MBASIS(4,4), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) mbasis(4,4)

  mbasis(1,1) = -1.0D+00
  mbasis(1,2) =  3.0D+00
  mbasis(1,3) = -3.0D+00
  mbasis(1,4) =  1.0D+00

  mbasis(2,1) =  3.0D+00
  mbasis(2,2) = -6.0D+00
  mbasis(2,3) =  3.0D+00
  mbasis(2,4) =  0.0D+00

  mbasis(3,1) = -3.0D+00
  mbasis(3,2) =  3.0D+00
  mbasis(3,3) =  0.0D+00
  mbasis(3,4) =  0.0D+00

  mbasis(4,1) =  1.0D+00
  mbasis(4,2) =  0.0D+00
  mbasis(4,3) =  0.0D+00
  mbasis(4,4) =  0.0D+00

  return
end
subroutine basis_matrix_hermite ( mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_HERMITE sets up the Hermite spline basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points are stored as
!    ( P1, P2, P1', P2' ), with P1 and P1' being the data value and 
!    the derivative dP/dT at T = 0, while P2 and P2' apply at T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    06 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    James Foley, Andries vanDam, Steven Feiner, John Hughes,
!    Computer Graphics, Principles and Practice,
!    Second Edition,
!    Addison Wesley, 1995,
!    ISBN: 0201848406,
!    LC: T385.C5735.
!
!  Parameters:
!
!    Output, real ( kind = 8 ) MBASIS(4,4), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) mbasis(4,4)

  mbasis(1,1) =  2.0D+00
  mbasis(1,2) = -2.0D+00
  mbasis(1,3) =  1.0D+00
  mbasis(1,4) =  1.0D+00

  mbasis(2,1) = -3.0D+00
  mbasis(2,2) =  3.0D+00
  mbasis(2,3) = -2.0D+00
  mbasis(2,4) = -1.0D+00

  mbasis(3,1) =  0.0D+00
  mbasis(3,2) =  0.0D+00
  mbasis(3,3) =  1.0D+00
  mbasis(3,4) =  0.0D+00

  mbasis(4,1) =  1.0D+00
  mbasis(4,2) =  0.0D+00
  mbasis(4,3) =  0.0D+00
  mbasis(4,4) =  0.0D+00

  return
end
subroutine basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_OVERHAUSER_NONUNI: nonuniform Overhauser spline basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points P1, P2, P3 and
!    P4 are not uniformly spaced in T, and that P2 corresponds to T = 0,
!    and P3 to T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real ( kind = 8 ) ALPHA, BETA.
!    ALPHA = || P2 - P1 || / ( || P3 - P2 || + || P2 - P1 || )
!    BETA  = || P3 - P2 || / ( || P4 - P3 || + || P3 - P2 || ).
!
!    Output, real ( kind = 8 ) MBASIS(4,4), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) alpha
  real    ( kind = 8 ) beta
  real    ( kind = 8 ) mbasis(4,4)

  mbasis(1,1) = - ( 1.0D+00 - alpha ) * ( 1.0D+00 - alpha ) / alpha
  mbasis(1,2) =   beta + ( 1.0D+00 - alpha ) / alpha
  mbasis(1,3) =   alpha - 1.0D+00 / ( 1.0D+00 - beta )
  mbasis(1,4) =   beta * beta / ( 1.0D+00 - beta )

  mbasis(2,1) =   2.0D+00 * ( 1.0D+00 - alpha ) * ( 1.0D+00 - alpha ) / alpha
  mbasis(2,2) = ( - 2.0D+00 * ( 1.0D+00 - alpha ) - alpha * beta ) / alpha
  mbasis(2,3) = ( 2.0D+00 * ( 1.0D+00 - alpha ) &
    - beta * ( 1.0D+00 - 2.0D+00 * alpha ) ) / ( 1.0D+00 - beta )
  mbasis(2,4) = - beta * beta / ( 1.0D+00 - beta )

  mbasis(3,1) = - ( 1.0D+00 - alpha ) * ( 1.0D+00 - alpha ) / alpha
  mbasis(3,2) =   ( 1.0D+00 - 2.0D+00 * alpha ) / alpha
  mbasis(3,3) =   alpha
  mbasis(3,4) =   0.0D+00

  mbasis(4,1) =   0.0D+00
  mbasis(4,2) =   1.0D+00
  mbasis(4,3) =   0.0D+00
  mbasis(4,4) =   0.0D+00

  return
end
subroutine basis_matrix_overhauser_nul ( alpha, mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_OVERHAUSER_NUL sets the nonuniform left Overhauser basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points P1, P2, and
!    P3 are not uniformly spaced in T, and that P1 corresponds to T = 0,
!    and P2 to T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    27 August 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real ( kind = 8 ) ALPHA.
!    ALPHA = || P2 - P1 || / ( || P3 - P2 || + || P2 - P1 || )
!
!    Output, real ( kind = 8 ) MBASIS(3,3), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) alpha
  real    ( kind = 8 ) mbasis(3,3)

  mbasis(1,1) =   1.0D+00 / alpha
  mbasis(1,2) = - 1.0D+00 / ( alpha * ( 1.0D+00 - alpha ) )
  mbasis(1,3) =   1.0D+00 / ( 1.0D+00 - alpha )

  mbasis(2,1) = - ( 1.0D+00 + alpha ) / alpha
  mbasis(2,2) =   1.0D+00 / ( alpha * ( 1.0D+00 - alpha ) )
  mbasis(2,3) = - alpha / ( 1.0D+00 - alpha )

  mbasis(3,1) =   1.0D+00
  mbasis(3,2) =   0.0D+00
  mbasis(3,3) =   0.0D+00

  return
end
subroutine basis_matrix_overhauser_nur ( beta, mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_OVERHAUSER_NUR: the nonuniform right Overhauser basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points PN-2, PN-1, and
!    PN are not uniformly spaced in T, and that PN-1 corresponds to T = 0,
!    and PN to T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    27 August 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BETA.
!    BETA = || P(N) - P(N-1) || / ( || P(N) - P(N-1) || + || P(N-1) - P(N-2) || )
!
!    Output, real ( kind = 8 ) MBASIS(3,3), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) beta
  real    ( kind = 8 ) mbasis(3,3)

  mbasis(1,1) =   1.0D+00 / beta
  mbasis(1,2) = - 1.0D+00 / ( beta * ( 1.0D+00 - beta ) )
  mbasis(1,3) =   1.0D+00 / ( 1.0D+00 - beta )

  mbasis(2,1) = - ( 1.0D+00 + beta ) / beta
  mbasis(2,2) =   1.0D+00 / ( beta * ( 1.0D+00 - beta ) )
  mbasis(2,3) = - beta / ( 1.0D+00 - beta )

  mbasis(3,1) =   1.0D+00
  mbasis(3,2) =   0.0D+00
  mbasis(3,3) =   0.0D+00

  return
end
subroutine basis_matrix_overhauser_uni ( mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_OVERHAUSER_UNI sets the uniform Overhauser spline basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points P1, P2, P3 and
!    P4 are uniformly spaced in T, and that P2 corresponds to T = 0,
!    and P3 to T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    James Foley, Andries vanDam, Steven Feiner, John Hughes,
!    Computer Graphics, Principles and Practice,
!    Second Edition,
!    Addison Wesley, 1995,
!    ISBN: 0201848406,
!    LC: T385.C5735.
!
!  Parameters:
!
!    Output, real ( kind = 8 ) MBASIS(4,4), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) mbasis(4,4)

  mbasis(1,1) = - 1.0D+00 / 2.0D+00
  mbasis(1,2) =   3.0D+00 / 2.0D+00
  mbasis(1,3) = - 3.0D+00 / 2.0D+00
  mbasis(1,4) =   1.0D+00 / 2.0D+00

  mbasis(2,1) =   2.0D+00 / 2.0D+00
  mbasis(2,2) = - 5.0D+00 / 2.0D+00
  mbasis(2,3) =   4.0D+00 / 2.0D+00
  mbasis(2,4) = - 1.0D+00 / 2.0D+00

  mbasis(3,1) = - 1.0D+00 / 2.0D+00
  mbasis(3,2) =   0.0D+00
  mbasis(3,3) =   1.0D+00 / 2.0D+00
  mbasis(3,4) =   0.0D+00

  mbasis(4,1) =   0.0D+00
  mbasis(4,2) =   2.0D+00 / 2.0D+00
  mbasis(4,3) =   0.0D+00
  mbasis(4,4) =   0.0D+00

  return
end
subroutine basis_matrix_overhauser_uni_l ( mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_OVERHAUSER_UNI_L sets the left uniform Overhauser basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points P1, P2, and P3
!    are not uniformly spaced in T, and that P1 corresponds to T = 0,
!    and P2 to T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Output, real ( kind = 8 ) MBASIS(3,3), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) mbasis(3,3)

  mbasis(1,1) =   2.0D+00
  mbasis(1,2) = - 4.0D+00
  mbasis(1,3) =   2.0D+00

  mbasis(2,1) = - 3.0D+00
  mbasis(2,2) =   4.0D+00
  mbasis(2,3) = - 1.0D+00

  mbasis(3,1) =   1.0D+00
  mbasis(3,2) =   0.0D+00
  mbasis(3,3) =   0.0D+00

  return
end
subroutine basis_matrix_overhauser_uni_r ( mbasis )

!*****************************************************************************80
!
!! BASIS_MATRIX_OVERHAUSER_UNI_R sets the right uniform Overhauser basis matrix.
!
!  Discussion:
!
!    This basis matrix assumes that the data points P(N-2), P(N-1), 
!    and P(N) are uniformly spaced in T, and that P(N-1) corresponds to 
!    T = 0, and P(N) to T = 1.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Output, real ( kind = 8 ) MBASIS(3,3), the basis matrix.
!
  implicit none

  real    ( kind = 8 ) mbasis(3,3)

  mbasis(1,1) =   2.0D+00
  mbasis(1,2) = - 4.0D+00
  mbasis(1,3) =   2.0D+00

  mbasis(2,1) = - 3.0D+00
  mbasis(2,2) =   4.0D+00
  mbasis(2,3) = - 1.0D+00

  mbasis(3,1) =   1.0D+00
  mbasis(3,2) =   0.0D+00
  mbasis(3,3) =   0.0D+00

  return
end
subroutine basis_matrix_tmp ( left, n, mbasis, ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! BASIS_MATRIX_TMP computes Q = T * MBASIS * P
!
!  Discussion:
!
!    YDATA is a vector of data values, most frequently the values of some
!    function sampled at uniformly spaced points.  MBASIS is the basis
!    matrix for a particular kind of spline.  T is a vector of the
!    powers of the normalized difference between TVAL and the left
!    endpoint of the interval.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    10 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) LEFT, indicats that TVAL is in the interval
!    [ TDATA(LEFT), TDATA(LEFT+1) ], or that this is the "nearest"
!    interval to TVAL.
!    For TVAL < TDATA(1), use LEFT = 1.
!    For TDATA(NDATA) < TVAL, use LEFT = NDATA - 1.
!
!    Input, integer ( kind = 4 ) N, the order of the basis matrix.
!
!    Input, real ( kind = 8 ) MBASIS(N,N), the basis matrix.
!
!    Input, integer ( kind = 4 ) NDATA, the dimension of the vectors TDATA 
!    and YDATA.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissa values.  This routine
!    assumes that the TDATA values are uniformly spaced, with an
!    increment of 1.0.
!
!    Input, real ( kind = 8 ) YDATA(NDATA), the data values to be 
!    interpolated or approximated.
!
!    Input, real ( kind = 8 ) TVAL, the value of T at which the spline is to be
!    evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the spline at TVAL.
!
  implicit none

  integer ( kind = 4 ), parameter :: maxn = 4
  integer ( kind = 4 ) n
  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) arg
  integer ( kind = 4 ) first
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) left
  real    ( kind = 8 ) mbasis(n,n)
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) tvec(maxn)
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval

  if ( left == 1 ) then
    arg = 0.5D+00 * ( tval - tdata(left) )
    first = left
  else if ( left < ndata - 1 ) then
    arg = tval - tdata(left)
    first = left - 1
  else if ( left == ndata - 1 ) then
    arg = 0.5D+00 * ( 1.0D+00 + tval - tdata(left) )
    first = left - 1
  end if
!
!  TVEC(I) = ARG**(N-I).
!
  tvec(n) = 1.0D+00
  do i = n-1, 1, -1
    tvec(i) = arg * tvec(i+1)
  end do

  yval = 0.0D+00
  do j = 1, n
    yval = yval + dot_product ( tvec(1:n), mbasis(1:n,j) ) &
      * ydata(first - 1 + j)
  end do

  return
end
subroutine bc_val ( n, t, xcon, ycon, xval, yval )

!*****************************************************************************80
!
!! BC_VAL evaluates a parameterized N-th degree Bezier curve in 2D.
!
!  Discussion:
!
!    BC_VAL(T) is the value of a vector function of the form
!
!      BC_VAL(T) = ( X(T), Y(T) )
!
!    where
!
!      X(T) = sum ( 0 <= I <= N ) XCON(I) * BERN(I,N)(T)
!      Y(T) = sum ( 0 <= I <= N ) YCON(I) * BERN(I,N)(T)
!
!    BERN(I,N)(T) is the I-th Bernstein polynomial of order N
!    defined on the interval [0,1],
!
!    XCON(0:N) and YCON(0:N) are the coordinates of N+1 "control points".
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    12 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    David Kahaner, Cleve Moler, Steven Nash,
!    Numerical Methods and Software,
!    Prentice Hall, 1989,
!    ISBN: 0-13-627258-4,
!    LC: TA345.K34.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the degree of the Bezier curve.
!    N must be at least 0.
!
!    Input, real ( kind = 8 ) T, the point at which the Bezier curve should
!    be evaluated.  The best results are obtained within the interval
!    [0,1] but T may be anywhere.
!
!    Input, real ( kind = 8 ) XCON(0:N), YCON(0:N), the X and Y coordinates
!    of the control points.  The Bezier curve will pass through
!    the points ( XCON(0), YCON(0) ) and ( XCON(N), YCON(N) ), but
!    generally NOT through the other control points.
!
!    Output, real ( kind = 8 ) XVAL, YVAL, the X and Y coordinates of the point
!    on the Bezier curve corresponding to the given T value.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) bval(0:n)
  real    ( kind = 8 ) t
  real    ( kind = 8 ) xcon(0:n)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) ycon(0:n)
  real    ( kind = 8 ) yval

  call bp01 ( n, t, bval )

  xval = dot_product ( xcon(0:n), bval(0:n) )
  yval = dot_product ( ycon(0:n), bval(0:n) )

  return
end
function bez_val ( n, x, a, b, y )

!*****************************************************************************80
!
!! BEZ_VAL evaluates an N-th degree Bezier function at a point.
!
!  Discussion:
!
!    The Bezier function has the form:
!
!      BEZ(X) = sum ( 0 <= I <= N ) Y(I) * BERN(N,I)( (X-A)/(B-A) )
!
!    BERN(N,I)(X) is the I-th Bernstein polynomial of order N
!    defined on the interval [0,1], 
!
!    Y(0:N) is a set of coefficients,
!
!    and if, for I = 0 to N, we define the N+1 points
!
!      X(I) = ( (N-I)*A + I*B) / N, 
!
!    equally spaced in [A,B], the pairs ( X(I), Y(I) ) can be regarded as
!    "control points".
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    12 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    David Kahaner, Cleve Moler, Steven Nash,
!    Numerical Methods and Software,
!    Prentice Hall, 1989,
!    ISBN: 0-13-627258-4,
!    LC: TA345.K34.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the degree of the Bezier function.
!    N must be at least 0.  
!
!    Input, real ( kind = 8 ) X, the point at which the Bezier function should
!    be evaluated.  The best results are obtained within the interval
!    [A,B] but X may be anywhere.
!
!    Input, real ( kind = 8 ) A, B, the interval over which the Bezier function
!    has been defined.  This is the interval in which the control
!    points have been set up.  Note BEZ(A) = Y(0) and BEZ(B) = Y(N),
!    although BEZ will not, in general pass through the other
!    control points.  A and B must not be equal.
!
!    Input, real ( kind = 8 ) Y(0:N), a set of data defining the Y coordinates
!    of the control points.
!
!    Output, real ( kind = 8 ) BEZ_VAL, the value of the Bezier function at X.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) bez_val
  real    ( kind = 8 ) bval(0:n)
  real    ( kind = 8 ) x
  real    ( kind = 8 ) x01
  real    ( kind = 8 ) y(0:n)

  if ( b - a == 0.0D+00 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'BEZ_VAL - Fatal error!'
    write ( *, '(a,g14.6)' ) '  Null interval, A = B = ', a
    stop
  end if
!
!  X01 lies in [0,1], in the same relative position as X in [A,B].
!
  x01 = ( x - a ) / ( b - a )

  call bp01 ( n, x01, bval )

  bez_val = dot_product ( y(0:n), bval(0:n) )

  return
end
subroutine bp_approx ( n, a, b, ydata, xval, yval )

!*****************************************************************************80
!
!! BP_APPROX evaluates the Bernstein polynomial approximant to F(X) on [A,B].
!
!  Formula:
!
!    BERN(F)(X) = sum ( 0 <= I <= N ) F(X(I)) * B_BASE(I,X)
!
!    where
!
!      X(I) = ( ( N - I ) * A + I * B ) / N
!      B_BASE(I,X) is the value of the I-th Bernstein basis polynomial at X.
!
!  Discussion:
!
!    The Bernstein polynomial BERN(F) for F(X) is an approximant, not an
!    interpolant; in other words, its value is not guaranteed to equal
!    that of F at any particular point.  However, for a fixed interval
!    [A,B], if we let N increase, the Bernstein polynomial converges
!    uniformly to F everywhere in [A,B], provided only that F is continuous.
!    Even if F is not continuous, but is bounded, the polynomial converges
!    pointwise to F(X) at all points of continuity.  On the other hand,
!    the convergence is quite slow compared to other interpolation
!    and approximation schemes.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    12 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    David Kahaner, Cleve Moler, Steven Nash,
!    Numerical Methods and Software,
!    Prentice Hall, 1989,
!    ISBN: 0-13-627258-4,
!    LC: TA345.K34.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the degree of the Bernstein polynomial 
!    to be used.  N must be at least 0.
!
!    Input, real ( kind = 8 ) A, B, the endpoints of the interval on which the
!    approximant is based.  A and B should not be equal.
!
!    Input, real ( kind = 8 ) YDATA(0:N), the data values at N+1 equally 
!    spaced points in [A,B].  If N = 0, then the evaluation point should 
!    be 0.5 * ( A + B).  Otherwise, evaluation point I should be 
!    ( (N-I)*A + I*B ) / N ).
!
!    Input, real ( kind = 8 ) XVAL, the point at which the Bernstein polynomial 
!    approximant is to be evaluated.  XVAL does not have to lie in the 
!    interval [A,B].
!
!    Output, real ( kind = 8 ) YVAL, the value of the Bernstein polynomial
!    approximant for F, based in [A,B], evaluated at XVAL.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) bvec(0:n)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) ydata(0:n)
  real    ( kind = 8 ) yval
!
!  Evaluate the Bernstein basis polynomials at XVAL.
!
  call bpab ( n, a, b, xval, bvec )
!
!  Now compute the sum of YDATA(I) * BVEC(I).
!
  yval = dot_product ( ydata(0:n), bvec(0:n) )

  return
end
subroutine bp01 ( n, x, bern )

!*****************************************************************************80
!
!! BP01 evaluates the Bernstein basis polynomials for [0,1] at a point.
!
!  Discussion:
!
!    For any N greater than or equal to 0, there is a set of N+1 Bernstein
!    basis polynomials, each of degree N, which form a basis for
!    all polynomials of degree N on [0,1].
!
!    BERN(N,I,X) = [N!/(I!*(N-I)!)] * (1-X)**(N-I) * X**I
!
!    N is the degree;
!
!    0 <= I <= N indicates which of the N+1 basis polynomials 
!    of degree N to choose;
!
!    X is a point in [0,1] at which to evaluate the basis polynomial.
!
!  First values:
!
!    B(0,0,X) = 1
!
!    B(1,0,X) =      1-X
!    B(1,1,X) =                X
!
!    B(2,0,X) =     (1-X)**2
!    B(2,1,X) = 2 * (1-X)    * X
!    B(2,2,X) =                X**2
!
!    B(3,0,X) =     (1-X)**3
!    B(3,1,X) = 3 * (1-X)**2 * X
!    B(3,2,X) = 3 * (1-X)    * X**2
!    B(3,3,X) =                X**3
!
!    B(4,0,X) =     (1-X)**4
!    B(4,1,X) = 4 * (1-X)**3 * X
!    B(4,2,X) = 6 * (1-X)**2 * X**2
!    B(4,3,X) = 4 * (1-X)    * X**3
!    B(4,4,X) =                X**4
!
!  Special values:
!
!    B(N,I,1/2) = C(N,K) / 2**N
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    12 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    David Kahaner, Cleve Moler, Steven Nash,
!    Numerical Methods and Software,
!    Prentice Hall, 1989,
!    ISBN: 0-13-627258-4,
!    LC: TA345.K34.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the degree of the Bernstein basis polynomials.
!    N must be at least 0.
!
!    Input, real ( kind = 8 ) X, the evaluation point.
!
!    Output, real ( kind = 8 ) BERN(0:N), the values of the N+1 Bernstein basis
!    polynomials at X.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) bern(0:n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  real    ( kind = 8 ) x

  if ( n == 0 ) then

    bern(0) = 1.0D+00

  else if ( 0 < n ) then

    bern(0) = 1.0D+00 - x
    bern(1) = x

    do i = 2, n
      bern(i) = x * bern(i-1)
      do j = i-1, 1, -1
        bern(j) = x * bern(j-1) + ( 1.0D+00 - x ) * bern(j)
      end do
      bern(0) = ( 1.0D+00 - x ) * bern(0)
    end do

  end if

  return
end
subroutine bpab ( n, a, b, x, bern )

!*****************************************************************************80
!
!! BPAB evaluates the Bernstein basis polynomials for [A,B] at a point.
!
!  Discussion:
!
!    BERN(N,I,X) = [N!/(I!*(N-I)!)] * (B-X)**(N-I) * (X-A)**I / (B-A)**N
!
!    B(0,0,X) =   1
!
!    B(1,0,X) = (      B-X                ) / (B-A)
!    B(1,1,X) = (                 X-A     ) / (B-A)
!
!    B(2,0,X) = (     (B-X)**2            ) / (B-A)**2
!    B(2,1,X) = ( 2 * (B-X)    * (X-A)    ) / (B-A)**2
!    B(2,2,X) = (                (X-A)**2 ) / (B-A)**2
!
!    B(3,0,X) = (     (B-X)**3            ) / (B-A)**3
!    B(3,1,X) = ( 3 * (B-X)**2 * (X-A)    ) / (B-A)**3
!    B(3,2,X) = ( 3 * (B-X)    * (X-A)**2 ) / (B-A)**3
!    B(3,3,X) = (                (X-A)**3 ) / (B-A)**3
!
!    B(4,0,X) = (     (B-X)**4            ) / (B-A)**4
!    B(4,1,X) = ( 4 * (B-X)**3 * (X-A)    ) / (B-A)**4
!    B(4,2,X) = ( 6 * (B-X)**2 * (X-A)**2 ) / (B-A)**4
!    B(4,3,X) = ( 4 * (B-X)    * (X-A)**3 ) / (B-A)**4
!    B(4,4,X) = (                (X-A)**4 ) / (B-A)**4
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    12 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    David Kahaner, Cleve Moler, Steven Nash,
!    Numerical Methods and Software,
!    Prentice Hall, 1989,
!    ISBN: 0-13-627258-4,
!    LC: TA345.K34.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the degree of the Bernstein basis polynomials.
!    There is a set of N+1 Bernstein basis polynomials, each of degree N, 
!    which form a basis for polynomials of degree N on [A,B].  N must
!    be at least 0.
!
!    Input, real ( kind = 8 ) A, B, the endpoints of the interval on which the
!    polynomials are to be based.  A and B should not be equal.
!
!    Input, real ( kind = 8 ) X, the point at which the polynomials are to be
!    evaluated.  X need not lie in the interval [A,B].
!
!    Output, real ( kind = 8 ) BERN(0:N), the values of the N+1 Bernstein basis
!    polynomials at X.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) bern(0:n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  real    ( kind = 8 ) x

  if ( b == a ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'BPAB - Fatal error!'
    write ( *, '(a,g14.6)' ) '  A = B = ', a
    stop
  end if

  if ( n == 0 ) then

    bern(0) = 1.0D+00

  else if ( 0 < n ) then

    bern(0) = ( b - x ) / ( b - a )
    bern(1) = ( x - a ) / ( b - a )

    do i = 2, n
      bern(i) = ( x - a ) * bern(i-1) / ( b - a )
      do j = i-1, 1, -1
        bern(j) = ( ( b - x ) * bern(j) + ( x - a ) * bern(j-1) ) / ( b - a )
      end do
      bern(0) = ( b - x ) * bern(0) / ( b - a )
    end do

  end if

  return
end
subroutine chfev ( x1, x2, f1, f2, d1, d2, ne, xe, fe, next, ierr )

!*****************************************************************************80
!
!! CHFEV evaluates a cubic polynomial given in Hermite form.
!
!  Discussion:
!
!    This routine evaluates a cubic polynomial given in Hermite form at an
!    array of points.  While designed for use by SPLINE_PCHIP_VAL, it may
!    be useful directly as an evaluator for a piecewise cubic
!    Hermite function in applications, such as graphing, where
!    the interval is known in advance.
!
!    The cubic polynomial is determined by function values
!    F1, F2 and derivatives D1, D2 on the interval [X1,X2].
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    25 June 2008
!
!  Author:  
!
!    Original FORTRAN77 version by Fred Fritsch.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Fred Fritsch, Ralph Carlson, 
!    Monotone Piecewise Cubic Interpolation,
!    SIAM Journal on Numerical Analysis,
!    Volume 17, Number 2, April 1980, pages 238-246.
!
!    David Kahaner, Cleve Moler, Steven Nash,
!    Numerical Methods and Software,
!    Prentice Hall, 1989,
!    ISBN: 0-13-627258-4,
!    LC: TA345.K34.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) X1, X2, the endpoints of the interval of
!    definition of the cubic.  X1 and X2 must be distinct.
!
!    Input, real ( kind = 8 ) F1, F2, the values of the function at X1 and
!    X2, respectively.
!
!    Input, real ( kind = 8 ) D1, D2, the derivative values at X1 and
!    X2, respectively.
!
!    Input, integer ( kind = 4 ) NE, the number of evaluation points.
!
!    Input, real ( kind = 8 ) XE(NE), the points at which the function is to
!    be evaluated.  If any of the XE are outside the interval
!    [X1,X2], a warning error is returned in NEXT.
!
!    Output, real ( kind = 8 ) FE(NE), the value of the cubic function
!    at the points XE.
!
!    Output, integer ( kind = 4 ) NEXT(2), indicates the number of 
!    extrapolation points:
!    NEXT(1) = number of evaluation points to the left of interval.
!    NEXT(2) = number of evaluation points to the right of interval.
!
!    Output, integer ( kind = 4 ) IERR, error flag.
!    0, no errors.
!    -1, NE < 1.
!    -2, X1 == X2.
!
  implicit none

  integer ( kind = 4 ) ne

  real    ( kind = 8 ) c2
  real    ( kind = 8 ) c3
  real    ( kind = 8 ) d1
  real    ( kind = 8 ) d2
  real    ( kind = 8 ) del1
  real    ( kind = 8 ) del2
  real    ( kind = 8 ) delta
  real    ( kind = 8 ) f1
  real    ( kind = 8 ) f2
  real    ( kind = 8 ) fe(ne)
  real    ( kind = 8 ) h
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ierr
  integer ( kind = 4 ) next(2)
  real    ( kind = 8 ) x
  real    ( kind = 8 ) x1
  real    ( kind = 8 ) x2
  real    ( kind = 8 ) xe(ne)
  real    ( kind = 8 ) xma
  real    ( kind = 8 ) xmi

  if ( ne < 1 ) then
    ierr = -1
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'CHFEV - Fatal error!'
    write ( *, '(a)' ) '  Number of evaluation points is less than 1.'
    write ( *, '(a,i8)' ) '  NE = ', ne
    stop
  end if

  h = x2 - x1

  if ( h == 0.0D+00 ) then
    ierr = -2
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'CHFEV - Fatal error!'
    write ( *, '(a)' ) '  The interval [X1,X2] is of zero length.'
    stop
  end if
!
!  Initialize.
!
  ierr = 0
  next(1) = 0
  next(2) = 0
  xmi = min ( 0.0D+00, h )
  xma = max ( 0.0D+00, h )
!
!  Compute cubic coefficients expanded about X1.
!
  delta = ( f2 - f1 ) / h
  del1 = ( d1 - delta ) / h
  del2 = ( d2 - delta ) / h
  c2 = -( del1 + del1 + del2 )
  c3 = ( del1 + del2 ) / h
!
!  Evaluation loop.
!
  do i = 1, ne

    x = xe(i) - x1
    fe(i) = f1 + x * ( d1 + x * ( c2 + x * c3 ) )
!
!  Count the extrapolation points.
!
    if ( x < xmi ) then
      next(1) = next(1) + 1
    end if

    if ( xma < x ) then
      next(2) = next(2) + 1
    end if

  end do

  return
end
subroutine data_to_dif ( ntab, xtab, ytab, diftab )

!*****************************************************************************80
!
!! DATA_TO_DIF sets up a divided difference table from raw data.
!
!  Discussion:
!
!    Space can be saved by using a single array for both the DIFTAB and
!    YTAB dummy parameters.  In that case, the divided difference table will
!    overwrite the Y data without interfering with the computation.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    04 September 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NTAB, the number of pairs of points
!    (XTAB(I),YTAB(I)) which are to be used as data.  The
!    number of entries to be used in DIFTAB, XTAB and YTAB.
!
!    Input, real ( kind = 8 ) XTAB(NTAB), the X values at which data was taken.
!    These values must be distinct.
!
!    Input, real ( kind = 8 ) YTAB(NTAB), the corresponding Y values.
!
!    Output, real ( kind = 8 ) DIFTAB(NTAB), the divided difference coefficients
!    corresponding to the input (XTAB,YTAB).
!
  implicit none

  integer ( kind = 4 ) ntab

  real    ( kind = 8 ) diftab(ntab)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  logical r8vec_distinct
  real    ( kind = 8 ) xtab(ntab)
  real    ( kind = 8 ) ytab(ntab)

  if ( .not. r8vec_distinct ( ntab, xtab ) ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DATA_TO_DIF - Fatal error!'
    write ( *, '(a)' ) '  Two entries of XTAB are equal!'
    return
  end if
!
!  Copy the data values into DIFTAB.
!
  diftab(1:ntab) = ytab(1:ntab)
!
!  Compute the divided differences.
!
  do i = 2, ntab
    do j = ntab, i, -1

      diftab(j) = ( diftab(j) - diftab(j-1) ) / ( xtab(j) - xtab(j+1-i) )

    end do
  end do

  return
end
subroutine dif_val ( ntab, xtab, diftab, xval, yval )

!*****************************************************************************80
!
!! DIF_VAL evaluates a divided difference polynomial at a point.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 September 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NTAB, the number of divided difference
!    coefficients in DIFTAB, and the number of points XTAB.
!
!    Input, real ( kind = 8 ) XTAB(NTAB), the X values upon which the
!    divided difference polynomial is based.
!
!    Input, real ( kind = 8 ) DIFTAB(NTAB), the divided difference 
!    polynomial coefficients.
!
!    Input, real ( kind = 8 ) XVAL, the value where the polynomial 
!    is to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the polynomial at XVAL.
!
  implicit none

  integer ( kind = 4 ) ntab

  real    ( kind = 8 ) diftab(ntab)
  integer ( kind = 4 ) i
  real    ( kind = 8 ) xtab(ntab)
  real    ( kind = 8 ) xval
  real    ( kind = 8 ) yval

  yval = diftab(ntab)
  do i = 1, ntab-1
    yval = diftab(ntab-i) + ( xval - xtab(ntab-i) ) * yval
  end do

  return
end
subroutine least_set_old ( ntab, xtab, ytab, ndeg, ptab, b, c, d, eps, ierror )

!*****************************************************************************80
!
!! LEAST_SET_OLD constructs the least squares polynomial approximation to data.
!
!  Discussion:
!
!    The least squares polynomial is not returned directly as a simple
!    polynomial.  Instead, it is represented in terms of a set of
!    orthogonal polynomials appopriate for the given data.  This makes
!    the computation more accurate, but means that the user can not
!    easily evaluate the computed polynomial.  Instead, the routine 
!    LEAST_EVAL should be used to evaluate the least squares polynomial
!    at any point.  (However, the value of the least squares polynomial
!    at each of the data points is returned as part of this computation.)
!
!
!    A discrete unweighted inner product is used, so that
!
!      ( F(X), G(X) ) = sum ( 1 <= I <= NTAB ) F(XTAB(I)) * G(XTAB(I)).
!
!    The least squares polynomial is determined using a set of
!    orthogonal polynomials PHI.  These polynomials can be defined
!    recursively by:
!
!      PHI(0)(X) = 1
!      PHI(1)(X) = X - B(1)
!      PHI(I)(X) = ( X - B(I) ) * PHI(I-1)(X) - D(I) * PHI(I-2)(X)
!
!    The array B(1:NDEG) contains the values
!
!      B(I) = ( X*PHI(I-1), PHI(I-1) ) / ( PHI(I-1), PHI(I-1) )
!
!    The array D(2:NDEG) contains the values
!
!      D(I) = ( PHI(I-1), PHI(I-1) ) / ( PHI(I-2), PHI(I-2) )
!
!    Using this basis, the least squares polynomial can be represented as
!
!      P(X)(I) = sum ( 0 <= I <= NDEG ) C(I) * PHI(I)(X)
!
!    The array C(0:NDEG) contains the values
!
!      C(I) = ( YTAB(I), PHI(I) ) / ( PHI(I), PHI(I) )
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 May 2004
!
!  Author:
!
!    FORTRAN90 version by John Burkardt
!
!  Reference:
!
!    Gisela Engeln-Muellges, Frank Uhlig,
!    Numerical Algorithms with C,
!    Springer, 1996,
!    ISBN: 3-540-60530-4.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NTAB, the number of data points.
!
!    Input, real ( kind = 8 ) XTAB(NTAB), the X data.  The values in XTAB
!    should be distinct, and in increasing order.
!
!    Input, real ( kind = 8 ) YTAB(NTAB), the Y data values corresponding
!    to the X data in XTAB.
!
!    Input, integer ( kind = 4 ) NDEG, the degree of the polynomial which the
!    program is to use.  NDEG must be at least 0, and less than or 
!    equal to NTAB-1.
!
!    Output, real ( kind = 8 ) PTAB(NTAB), the value of the least 
!    squares polynomial at the points XTAB(1:NTAB).
!
!    Output, real ( kind = 8 ) B(1:NDEG), C(0:NDEG), D(2:NDEG), arrays 
!    needed to evaluate the polynomial.
!
!    Output, real ( kind = 8 ) EPS, the root-mean-square discrepancy of the
!    polynomial fit.
!
!    Output, integer ( kind = 4 ) IERROR, error flag.
!    zero, no error occurred;
!    nonzero, an error occurred, and the polynomial could not be computed.
!
  implicit none

  integer ( kind = 4 ) ndeg
  integer ( kind = 4 ) ntab

  real    ( kind = 8 ) b(1:ndeg)
  real    ( kind = 8 ) c(0:ndeg)
  real    ( kind = 8 ) d(2:ndeg)
  real    ( kind = 8 ) eps
  integer ( kind = 4 ) i
  integer ( kind = 4 ) i0l1
  integer ( kind = 4 ) i1l1
  integer ( kind = 4 ) ierror
  integer ( kind = 4 ) it
  integer ( kind = 4 ) k
  integer ( kind = 4 ) mdeg
  real    ( kind = 8 ) ptab(ntab)
  real    ( kind = 8 ) rn0
  real    ( kind = 8 ) rn1
  real    ( kind = 8 ) s
  real    ( kind = 8 ) sum2
  real    ( kind = 8 ) xtab(ntab)
  real    ( kind = 8 ) y_sum
  real    ( kind = 8 ) ytab(ntab)
  real    ( kind = 8 ) ztab(2*ntab)

  ierror = 0
!
!  Check NDEG.
!
  if ( ndeg < 0 ) then
    ierror = 1
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'LEAST_SET_OLD - Fatal error!'
    write ( *, '(a)' ) '  NDEG < 0.'
    stop
  end if

  if ( ntab <= ndeg ) then
    ierror = 1
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'LEAST_SET_OLD - Fatal error!'
    write ( *, '(a)' ) '  NTAB <= NDEG.'
    stop
  end if
!
!  Check that the abscissas are strictly increasing.
!
  do i = 1, ntab-1
    if ( xtab(i+1) <= xtab(i) ) then
      ierror = 1
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'LEAST_SET_OLD - Fatal error!'
      write ( *, '(a)' ) '  XTAB must be strictly increasing, but'
      write ( *, '(a,i8,a,g14.6)' ) '  XTAB(', i, ') = ', xtab(i)
      write ( *, '(a,i8,a,g14.6)' ) '  XTAB(', i+1, ') = ', xtab(i+1)
      stop
    end if
  end do

  i0l1 = 0
  i1l1 = ntab
!
!  The polynomial is of degree at least 0.
!
  y_sum = sum ( ytab(1:ntab) )
  rn0 = ntab
  c(0) = y_sum / real ( ntab, kind = 8 )

  ptab(1:ntab) = y_sum / real ( ntab, kind = 8 )

  if ( ndeg == 0 ) then
    eps = sum ( ptab(1:ntab) - ytab(1:ntab) )**2
    eps = sqrt ( eps / real ( ntab, kind = 8 ) )
    return
  end if
!
!  The polynomial is of degree at least 1.
!
  b(1) = sum ( xtab(1:ntab) ) / real ( ntab, kind = 8 )

  s = 0.0D+00
  sum2 = 0.0D+00
  do i = 1, ntab
    ztab(i1l1+i) = xtab(i) - b(1)
    s = s + ztab(i1l1+i)**2
    sum2 = sum2 + ztab(i1l1+i) * ( ytab(i) - ptab(i) )
  end do

  rn1 = s
  c(1) = sum2 / s

  do i = 1, ntab
    ptab(i) = ptab(i) + c(1) * ztab(i1l1+i)
  end do

  if ( ndeg == 1 ) then
    eps = sum ( ( ptab(1:ntab) - ytab(1:ntab) )**2 )
    eps = sqrt ( eps / real ( ntab, kind = 8 ) )
    return
  end if

  ztab(1:ntab) = 1.0D+00

  mdeg = 2
  k = 2

  do

    d(k) = rn1 / rn0

    sum2 = 0.0D+00
    do i = 1, ntab
      sum2 = sum2 + xtab(i) * ztab(i1l1+i) * ztab(i1l1+i)
    end do

    b(k) = sum2 / rn1

    s = 0.0D+00
    sum2 = 0.0D+00
    do i = 1, ntab
      ztab(i0l1+i) = ( xtab(i) - b(k) ) * ztab(i1l1+i) &
        - d(k) * ztab(i0l1+i)
      s = s + ztab(i0l1+i) * ztab(i0l1+i)
      sum2 = sum2 + ztab(i0l1+i) * ( ytab(i) - ptab(i) )
    end do

    rn0 = rn1
    rn1 = s

    c(k) = sum2 / rn1

    it = i0l1
    i0l1 = i1l1
    i1l1 = it

    do i = 1, ntab
      ptab(i) = ptab(i) + c(k) * ztab(i1l1+i)
    end do

    if ( ndeg <= mdeg ) then
      exit
    end if

    mdeg = mdeg + 1
    k = k + 1

  end do
!
!  Compute the RMS error.
!
  eps = sum ( ( ptab(1:ntab) - ytab(1:ntab) )**2 )
  eps = sqrt ( eps / real ( ntab, kind = 8 ) )

  return
end
subroutine least_val_old ( x, ndeg, b, c, d, value )

!*****************************************************************************80
!
!! LEAST_VAL_OLD evaluates a least squares polynomial defined by LEAST_SET_OLD.
!
!  Discussion:
!
!    This is an "old" version of the routine.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 May 2004
!
!  Author:
!
!    FORTRAN90 version by John Burkardt
!
!  Reference:
!
!    Gisela Engeln-Muellges, Frank Uhlig,
!    Numerical Algorithms with C,
!    Springer, 1996,
!    ISBN: 3-540-60530-4.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) X, the point at which the polynomial is 
!    to be evaluated.
!
!    Input, integer ( kind = 4 ) NDEG, the degree of the least squares 
!    polynomial.
!
!    Input, real ( kind = 8 ) B(1:NDEG), C(0:NDEG), D(2:NDEG), arrays 
!    defined by LEAST_SET_OLD, and needed to evaluate the polynomial.
!
!    Output, real ( kind = 8 ) VALUE, the value of the polynomial at X.
!
  implicit none

  integer ( kind = 4 ) ndeg

  real    ( kind = 8 ) b(1:ndeg)
  real    ( kind = 8 ) c(0:ndeg)
  real    ( kind = 8 ) d(2:ndeg)
  integer ( kind = 4 ) k
  real    ( kind = 8 ) sk
  real    ( kind = 8 ) skp1
  real    ( kind = 8 ) skp2
  real    ( kind = 8 ) value
  real    ( kind = 8 ) x

  if ( ndeg <= 0 ) then

    value = c(0)

  else if ( ndeg == 1 ) then

    value = c(0) + c(1) * ( x - b(1) )

  else

    skp2 = c(ndeg)
    skp1 = c(ndeg-1) + ( x - b(ndeg) ) * skp2

    do k = ndeg-2, 0, -1
      sk = c(k) + ( x - b(k+1) ) * skp1 - d(k+2) * skp2
      skp2 = skp1
      skp1 = sk
    end do

    value = sk

  end if

  return
end
subroutine least_set ( point_num, x, f, w, nterms, b, c, d )

!*****************************************************************************80
!
!! LEAST_SET defines a least squares polynomial for given data.
!
!  Discussion:
!
!    This routine is based on ORTPOL by Conte and deBoor.
!
!    The polynomial may be evaluated at any point X by calling LEAST_VAL.
!
!    Thanks to Andrew Telford for pointing out a mistake in the form of
!    the check that there are enough unique data points, 25 June 2008.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    25 June 2008
!
!  Author:
!
!    Original FORTRAN77 version by Samuel Conte, Carl deBoor.
!    FORTRAN90 version by John Burkardt
!
!  Reference:
!
!    Samuel Conte, Carl deBoor,
!    Elementary Numerical Analysis,
!    Second Edition,
!    McGraw Hill, 1972,
!    ISBN: 07-012446-4,
!    LC: QA297.C65.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) POINT_NUM, the number of data values.
!
!    Input, real ( kind = 8 ) X(POINT_NUM), the abscissas of the data points.
!    At least NTERMS of the values in X must be distinct.
!
!    Input, real ( kind = 8 ) F(POINT_NUM), the data values at the points X(*).
!
!    Input, real ( kind = 8 ) W(POINT_NUM), the weights associated with
!    the data points.  Each entry of W should be positive.
!
!    Input, integer ( kind = 4 ) NTERMS, the number of terms to use in the
!    approximating polynomial.  NTERMS must be at least 1.
!    The degree of the polynomial is NTERMS-1.
!
!    Output, real ( kind = 8 ) B(NTERMS), C(NTERMS), D(NTERMS), are quantities
!    defining the least squares polynomial for the input data,
!    which will be needed to evaluate the polynomial.
!
  implicit none

  integer ( kind = 4 ) point_num
  integer ( kind = 4 ) nterms

  real    ( kind = 8 ) b(nterms)
  real    ( kind = 8 ) c(nterms)
  real    ( kind = 8 ) d(nterms)
  real    ( kind = 8 ) f(point_num)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  real    ( kind = 8 ) p
  real    ( kind = 8 ) pj(point_num)
  real    ( kind = 8 ) pjm1(point_num)
  real    ( kind = 8 ) s(nterms)
  real    ( kind = 8 ), parameter :: tol = 0.0D+00
  integer ( kind = 4 ) unique_num
  real    ( kind = 8 ) w(point_num)
  real    ( kind = 8 ) x(point_num)
!
!  Make sure at least NTERMS X values are unique.
!
  call r8vec_unique_count ( point_num, x, tol, unique_num )

  if ( unique_num < nterms ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'LEAST_SET - Fatal error!'
    write ( *, '(a)' ) '  The number of distinct X values must be'
    write ( *, '(a,i8)') '  at least NTERMS = ', nterms
    write ( *, '(a,i8)' ) '  but the input data has only ', unique_num
    write ( *, '(a)' ) '  distinct entries.'
    return
  end if
!
!  Make sure all W entries are positive.
!
  do i = 1, point_num
    if ( w(i) <= 0.0D+00 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'LEAST_SET - Fatal error!'
      write ( *, '(a)' ) '  All weights W must be positive,'
      write ( *, '(a,i8)' ) '  but weight ', i
      write ( *, '(a,g14.6)' ) '  is ', w(i)
      return
    end if
  end do
!
!  Start inner product summations at zero.
!
  b(1:nterms) = 0.0D+00
  c(1:nterms) = 0.0D+00
  d(1:nterms) = 0.0D+00
  s(1:nterms) = 0.0D+00
!
!  Set the values of P(-1,X) and P(0,X) at all data points.
!
  pjm1(1:point_num) = 0.0D+00
  pj(1:point_num) = 1.0D+00
!
!  Now compute the value of P(J,X(I)) as
!
!    P(J,X(I)) = ( X(I) - B(J) ) * P(J-1,X(I)) - C(J) * P(J-2,X(I))
!
!  where
!
!    S(J) = < P(J,X), P(J,X) >
!    B(J) = < x*P(J,X), P(J,X) > / < P(J,X), P(J,X) >
!    C(J) = S(J) / S(J-1)
!
!  and the least squares coefficients are
!
!    D(J) = < F(X), P(J,X) > / < P(J,X), P(J,X) >
!
  do j = 1, nterms

    d(j) = d(j) + sum ( w(1:point_num) * f(1:point_num) * pj(1:point_num) )
    b(j) = b(j) + sum ( w(1:point_num) * x(1:point_num) * pj(1:point_num)**2 )
    s(j) = s(j) + sum ( w(1:point_num) * pj(1:point_num)**2 )

    d(j) = d(j) / s(j)

    if ( j == nterms ) then
      c(j) = 0.0D+00
      return
    end if

    b(j) = b(j) / s(j)

    if ( j == 1 ) then
      c(j) = 0.0D+00
    else
      c(j) = s(j) / s(j-1)
    end if

    do i = 1, point_num
      p = pj(i)
      pj(i) = ( x(i) - b(j) ) * pj(i) - c(j) * pjm1(i)
      pjm1(i) = p
    end do

  end do

  return
end
subroutine least_val ( nterms, b, c, d, x, px )

!*****************************************************************************80
!
!! LEAST_VAL evaluates a least squares polynomial defined by LEAST_SET.
!
!  Discussion:
!
!    The least squares polynomial is assumed to be defined as a sum
!
!      P(X) = sum ( 1 <= I <= NTERMS ) D(I) * P(I-1,X)
!
!    where the orthogonal basis polynomials P(I,X) satisfy the following
!    three term recurrence:
!
!      P(-1,X) = 0
!      P(0,X) = 1
!      P(I,X) = ( X - B(I-1) ) * P(I-1,X) - C(I-1) * P(I-2,X)
!
!    Therefore, the least squares polynomial can be evaluated as follows:
!
!    If NTERMS is 1, then the value of P(X) is D(1) * P(0,X) = D(1).
!
!    Otherwise, P(X) is defined as the sum of NTERMS > 1 terms.  We can
!    reduce the number of terms by 1, because the polynomial P(NTERMS,X)
!    can be rewritten as a sum of polynomials;  Therefore, P(NTERMS,X)
!    can be eliminated from the sum, and its coefficient merged in with
!    those of other polynomials.  Repeat this process for P(NTERMS-1,X)
!    and so on until a single term remains.
!    P(NTERMS,X) of P(NTERMS-1,X)
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 May 2005
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Samuel Conte, Carl deBoor,
!    Elementary Numerical Analysis,
!    Second Edition,
!    McGraw Hill, 1972,
!    ISBN: 07-012446-4,
!    LC: QA297.C65.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NTERMS, the number of terms in the least 
!    squares polynomial.  NTERMS must be at least 1.  The input value of NTERMS
!    may be reduced from the value given to LEAST_SET.  This will
!    evaluate the least squares polynomial of the lower degree specified.
!
!    Input, real ( kind = 8 ) B(NTERMS), C(NTERMS), D(NTERMS), the information
!    computed by LEAST_SET.
!
!    Input, real ( kind = 8 ) X, the point at which the least squares polynomial
!    is to be evaluated.
!
!    Output, real ( kind = 8 ) PX, the value of the least squares 
!    polynomial at X.
!
  implicit none

  integer ( kind = 4 ) nterms

  real    ( kind = 8 ) b(nterms)
  real    ( kind = 8 ) c(nterms)
  real    ( kind = 8 ) d(nterms)
  integer ( kind = 4 ) i
  real    ( kind = 8 ) prev
  real    ( kind = 8 ) prev2
  real    ( kind = 8 ) px
  real    ( kind = 8 ) x

  px = d(nterms)
  prev = 0.0D+00

  do i = nterms - 1, 1, -1

    prev2 = prev
    prev = px

    if ( i == nterms-1 ) then
      px = d(i) + ( x - b(i) ) * prev
    else
      px = d(i) + ( x - b(i) ) * prev - c(i+1) * prev2
    end if

  end do

  return
end
subroutine least_val2 ( nterms, b, c, d, x, px, pxp )

!*****************************************************************************80
!
!! LEAST_VAL2 evaluates a least squares polynomial defined by LEAST_SET.
!
!  Discussion:
!
!    This routine also computes the derivative of the polynomial.
!
!    The least squares polynomial is assumed to be defined as a sum
!
!      P(X) = sum ( 1 <= I <= NTERMS ) D(I) * P(I-1,X)
!
!    where the orthogonal basis polynomials P(I,X) satisfy the following
!    three term recurrence:
!
!      P(-1,X) = 0
!      P(0,X) = 1
!      P(I,X) = ( X - B(I-1) ) * P(I-1,X) - C(I-1) * P(I-2,X)
!
!    Therefore, the least squares polynomial can be evaluated as follows:
!
!    If NTERMS is 1, then the value of P(X) is D(1) * P(0,X) = D(1).
!
!    Otherwise, P(X) is defined as the sum of NTERMS > 1 terms.  We can
!    reduce the number of terms by 1, because the polynomial P(NTERMS,X)
!    can be rewritten as a sum of polynomials;  Therefore, P(NTERMS,X)
!    can be eliminated from the sum, and its coefficient merged in with
!    those of other polynomials.  Repeat this process for P(NTERMS-1,X)
!    and so on until a single term remains.
!    P(NTERMS,X) of P(NTERMS-1,X)
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 May 2005
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NTERMS, the number of terms in the least squares
!    polynomial.  NTERMS must be at least 1.  The value of NTERMS
!    may be reduced from the value given to LEAST_SET.
!    This will cause LEAST_VAL to evaluate the least squares polynomial
!    of the lower degree specified.
!
!    Input, real ( kind = 8 ) B(NTERMS), C(NTERMS), D(NTERMS), the information
!    computed by LEAST_SET.
!
!    Input, real ( kind = 8 ) X, the point at which the least squares polynomial
!    is to be evaluated.
!
!    Output, real ( kind = 8 ) PX, PXP, the value and derivative of the least
!    squares polynomial at X.
!
  implicit none

  integer ( kind = 4 ) nterms

  real    ( kind = 8 ) b(nterms)
  real    ( kind = 8 ) c(nterms)
  real    ( kind = 8 ) d(nterms)
  integer ( kind = 4 ) i
  real    ( kind = 8 ) px
  real    ( kind = 8 ) pxm1
  real    ( kind = 8 ) pxm2
  real    ( kind = 8 ) pxp
  real    ( kind = 8 ) pxpm1
  real    ( kind = 8 ) pxpm2
  real    ( kind = 8 ) x

  px = d(nterms)
  pxp = 0.0D+00
  pxm1 = 0.0D+00
  pxpm1 = 0.0D+00

  do i = nterms - 1, 1, -1

    pxm2 = pxm1
    pxpm2 = pxpm1
    pxm1 = px
    pxpm1 = pxp

    if ( i == nterms - 1 ) then
      px = d(i) + ( x - b(i) ) * pxm1
      pxp = pxm1 + ( x - b(i) ) * pxpm1
    else
      px = d(i) + ( x - b(i) ) * pxm1 - c(i+1) * pxm2
      pxp = pxm1 + ( x - b(i) ) * pxpm1 - c(i+1) * pxpm2
    end if

  end do

  return
end
subroutine parabola_val2 ( dim_num, ndata, tdata, ydata, left, tval, yval )

!*****************************************************************************80
!
!! PARABOLA_VAL2 evaluates a parabolic interpolant through tabular data.
!
!  Discussion:
!
!    This routine is a utility routine used by OVERHAUSER_SPLINE_VAL.
!    It constructs the parabolic interpolant through the data in
!    3 consecutive entries of a table and evaluates this interpolant
!    at a given abscissa value.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    26 January 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) DIM_NUM, the dimension of a single data point.
!    DIM_NUM must be at least 1.
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points.
!    NDATA must be at least 3.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data 
!    points.  The values in TDATA must be in strictly ascending order.
!
!    Input, real ( kind = 8 ) YDATA(DIM_NUM,NDATA), the data points 
!    corresponding to the abscissas.
!
!    Input, integer ( kind = 4 ) LEFT, the location of the first of the three
!    consecutive data points through which the parabolic interpolant
!    must pass.  1 <= LEFT <= NDATA - 2.
!
!    Input, real ( kind = 8 ) TVAL, the value of T at which the parabolic
!    interpolant is to be evaluated.  Normally, TDATA(1) <= TVAL <= T(NDATA),
!    and the data will be interpolated.  For TVAL outside this range,
!    extrapolation will be used.
!
!    Output, real ( kind = 8 ) YVAL(DIM_NUM), the value of the parabolic
!    interpolant at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata
  integer ( kind = 4 ) dim_num

  real    ( kind = 8 ) dif1
  real    ( kind = 8 ) dif2
  integer ( kind = 4 ) i
  integer ( kind = 4 ) left
  real    ( kind = 8 ) t1
  real    ( kind = 8 ) t2
  real    ( kind = 8 ) t3
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) ydata(dim_num,ndata)
  real    ( kind = 8 ) y1
  real    ( kind = 8 ) y2
  real    ( kind = 8 ) y3
  real    ( kind = 8 ) yval(dim_num)
!
!  Check.
!
  if ( left < 1 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'PARABOLA_VAL2 - Fatal error!'
    write ( *, '(a)' ) '  LEFT < 1.'
    write ( *, '(a,i8)' ) '  LEFT = ', left
    stop
  end if

  if ( ndata-2 < left ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'PARABOLA_VAL2 - Fatal error!'
    write ( *, '(a)' ) '  NDATA-2 < LEFT.'
    write ( *, '(a,i8)' ) '  NDATA = ', ndata
    write ( *, '(a,i8)' ) '  LEFT =  ', left
    stop
  end if

  if ( dim_num < 1 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'PARABOLA_VAL2 - Fatal error!'
    write ( *, '(a)' ) '  DIM_NUM < 1.'
    stop
  end if
!
!  Copy out the three abscissas.
!
  t1 = tdata(left)
  t2 = tdata(left+1)
  t3 = tdata(left+2)

  if ( t2 <= t1 .or. t3 <= t2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'PARABOLA_VAL2 - Fatal error!'
    write ( *, '(a)' ) '  T2 <= T1 or T3 <= T2.'
    stop
  end if
!
!  Construct and evaluate a parabolic interpolant for the data
!  in each dimension.
!
  do i = 1, dim_num

    y1 = ydata(i,left)
    y2 = ydata(i,left+1)
    y3 = ydata(i,left+2)

    dif1 = ( y2 - y1 ) / ( t2 - t1 )
    dif2 = ( ( y3 - y1 ) / ( t3 - t1 ) &
         - ( y2 - y1 ) / ( t2 - t1 ) ) / ( t3 - t2 )

    yval(i) = y1 + ( tval - t1 ) * ( dif1 + ( tval - t2 ) * dif2 )

  end do

  return
end
function pchst ( arg1, arg2 )

!*****************************************************************************80
!
!! PCHST: PCHIP sign-testing routine.
!
!  Discussion:
!
!    This routine essentially computes the sign of ARG1 * ARG2.
!
!    The object is to do this without multiplying ARG1 * ARG2, to avoid
!    possible over/underflow problems.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    25 June 2008
!
!  Author:
!
!    Original FORTRAN77 version by Fred Fritsch.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Fred Fritsch, Ralph Carlson, 
!    Monotone Piecewise Cubic Interpolation,
!    SIAM Journal on Numerical Analysis,
!    Volume 17, Number 2, April 1980, pages 238-246.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) ARG1, ARG2, two values to check.
!
!    Output, real ( kind = 8 ) PCHST,
!    -1.0, if ARG1 and ARG2 are of opposite sign.
!     0.0, if either argument is zero.
!    +1.0, if ARG1 and ARG2 are of the same sign.
!
  implicit none

  real    ( kind = 8 ) arg1
  real    ( kind = 8 ) arg2
  real    ( kind = 8 ) pchst

  pchst = sign ( 1.0D+00, arg1 ) * sign ( 1.0D+00, arg2 )

  if ( arg1 == 0.0D+00 .or. arg2 == 0.0D+00 ) then
    pchst = 0.0D+00
  end if

  return
end
subroutine r8_swap ( x, y )

!*****************************************************************************80
!
!! R8_SWAP swaps two real values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    01 May 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, real ( kind = 8 ) X, Y.  On output, the values of X and
!    Y have been interchanged.
!
  implicit none

  real    ( kind = 8 ) x
  real    ( kind = 8 ) y
  real    ( kind = 8 ) z

  z = x
  x = y
  y = z

  return
end
function r8_uniform_01 ( seed )

!*****************************************************************************80
!
!! R8_UNIFORM_01 is a portable pseudorandom number generator.
!
!  Discussion:
!
!    This routine implements the recursion
!
!      seed = 16807 * seed mod ( 2**31 - 1 )
!      unif = seed / ( 2**31 - 1 )
!
!    The integer arithmetic never requires more than 32 bits,
!    including a sign bit.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    11 August 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Paul Bratley, Bennett Fox, Linus Schrage,
!    A Guide to Simulation,
!    Springer Verlag, pages 201-202, 1983.
!
!    Bennett Fox,
!    Algorithm 647:
!    Implementation and Relative Efficiency of Quasirandom
!    Sequence Generators,
!    ACM Transactions on Mathematical Software,
!    Volume 12, Number 4, pages 362-376, 1986.
!
!  Parameters:
!
!    Input/output, integer ( kind = 4 ) SEED, the "seed" value, which should
!    NOT be 0. (Otherwise, the output values of SEED and UNIFORM will be zero.)
!    On output, SEED has been updated.
!
!    Output, real ( kind = 8 ) R8_UNIFORM_01, a new pseudorandom variate,
!    strictly between 0 and 1.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) seed
  real    ( kind = 8 ) r8_uniform_01

  k = seed / 127773

  seed = 16807 * ( seed - k * 127773 ) - k * 2836

  if ( seed < 0 ) then
    seed = seed + 2147483647
  end if
!
!  Although SEED can be represented exactly as a 32 bit integer,
!  it generally cannot be represented exactly as a 32 bit real number!
!
  r8_uniform_01 = real ( seed, kind = 8 ) * 4.656612875E-10

  return
end
subroutine r83_mxv ( n, a, x, b )

!*****************************************************************************80
!
!! R83_MXV multiplies an R83 matrix times a vector.
!
!  Discussion:
!
!    The R83 storage format is used for a tridiagonal matrix.
!    The superdiagonal is stored in entries (1,2:N), the diagonal in
!    entries (2,1:N), and the subdiagonal in (3,1:N-1).  Thus, the
!    original matrix is "collapsed" vertically into the array.
!
!  Example:
!
!    Here is how an R83 matrix of order 5 would be stored:
!
!       *  A12 A23 A34 A45
!      A11 A22 A33 A44 A55
!      A21 A32 A43 A54  *
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    02 November 2003
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the order of the linear system.
!
!    Input, real ( kind = 8 ) A(3,N), the R83 matrix.
!
!    Input, real ( kind = 8 ) X(N), the vector to be multiplied by A.
!
!    Output, real ( kind = 8 ) B(N), the product A * x.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(3,n)
  real    ( kind = 8 ) b(n)
  real    ( kind = 8 ) x(n)

  b(1:n)   =            a(2,1:n)   * x(1:n)
  b(1:n-1) = b(1:n-1) + a(1,2:n)   * x(2:n)
  b(2:n)   = b(2:n)   + a(3,1:n-1) * x(1:n-1)

  return
end
subroutine r83_np_fs ( n, a, b, x )

!*****************************************************************************80
!
!! R83_NP_FS factors and solves an R83 system.
!
!  Discussion:
!
!    The R83 storage format is used for a tridiagonal matrix.
!    The superdiagonal is stored in entries (1,2:N), the diagonal in
!    entries (2,1:N), and the subdiagonal in (3,1:N-1).  Thus, the
!    original matrix is "collapsed" vertically into the array.
!
!    This algorithm requires that each diagonal entry be nonzero.
!    It does not use pivoting, and so can fail on systems that
!    are actually nonsingular.
!
!    Here is how an R83 matrix of order 5 would be stored:
!
!       *  A12 A23 A34 A45
!      A11 A22 A33 A44 A55
!      A21 A32 A43 A54  *
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    02 November 2003
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the order of the linear system.
!
!    Input/output, real ( kind = 8 ) A(3,N).
!    On input, the tridiagonal matrix.
!    On output, the data in these vectors has been overwritten
!    by factorization information.
!
!    Input, real ( kind = 8 ) B(N), the right hand side of the linear system.
!
!    Output, real ( kind = 8 ) X(N), the solution of the linear system.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(3,n)
  real    ( kind = 8 ) b(n)
  integer ( kind = 4 ) i
  real    ( kind = 8 ) x(n)
  real    ( kind = 8 ) xmult
!
!  The diagonal entries can't be zero.
!
  do i = 1, n
    if ( a(2,i) == 0.0D+00 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'R83_NP_FS - Fatal error!'
      write ( *, '(a,i8,a)' ) '  A(2,', i, ') = 0.'
      return
    end if
  end do

  x(1:n) = b(1:n)

  do i = 2, n
    xmult = a(3,i-1) / a(2,i-1)
    a(2,i) = a(2,i) - xmult * a(1,i)
    x(i)   = x(i)   - xmult * x(i-1)
  end do

  x(n) = x(n) / a(2,n)
  do i = n-1, 1, -1
    x(i) = ( x(i) - a(1,i+1) * x(i+1) ) / a(2,i)
  end do

  return
end
subroutine r83_uniform ( n, seed, a )

!*****************************************************************************80
!
!! R83_UNIFORM randomizes an R83 matrix.
!
!  Discussion:
!
!    The R83 storage format is used for a tridiagonal matrix.
!    The superdiagonal is stored in entries (1,2:N), the diagonal in
!    entries (2,1:N), and the subdiagonal in (3,1:N-1).  Thus, the
!    original matrix is "collapsed" vertically into the array.
!
!    Here is how an R83 matrix of order 5 would be stored:
!
!       *  A12 A23 A34 A45
!      A11 A22 A33 A44 A55
!      A21 A32 A43 A54  *
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    19 September 2003
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the order of the linear system.
!
!    Input/output, integer ( kind = 4 ) SEED, a seed for the random number 
!    generator.
!
!    Output, real ( kind = 8 ) A(3,N), the R83 matrix.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(3,n)
  integer ( kind = 4 ) seed

  a(1,1) = 0.0D+00
  call r8vec_uniform_01 ( n-1, seed, a(1,2:n) )

  call r8vec_uniform_01 ( n,   seed, a(2,1:n) )

  call r8vec_uniform_01 ( n-1, seed, a(3,1:n-1) )
  a(3,n) = 0.0D+00

  return
end
subroutine r8vec_bracket ( n, x, xval, left, right )

!*****************************************************************************80
!
!! R8VEC_BRACKET searches a sorted R8VEC for successive brackets of a value.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!    If the values in the vector are thought of as defining intervals
!    on the real line, then this routine searches for the interval
!    nearest to or containing the given value.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    06 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, length of input array.
!
!    Input, real ( kind = 8 ) X(N), an array sorted into ascending order.
!
!    Input, real ( kind = 8 ) XVAL, a value to be bracketed.
!
!    Output, integer ( kind = 4 ) LEFT, RIGHT, the results of the search.
!    Either:
!      XVAL < X(1), when LEFT = 1, RIGHT = 2;
!      X(N) < XVAL, when LEFT = N-1, RIGHT = N;
!    or
!      X(LEFT) <= XVAL <= X(RIGHT).
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) i
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) x(n)
  real    ( kind = 8 ) xval

  do i = 2, n - 1

    if ( xval < x(i) ) then
      left = i - 1
      right = i
      return
    end if

   end do

  left = n - 1
  right = n

  return
end
subroutine r8vec_bracket3 ( n, t, tval, left )

!*****************************************************************************80
!
!! R8VEC_BRACKET3 finds the interval containing or nearest a given value.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!    The routine always returns the index LEFT of the sorted array
!    T with the property that either
!    *  T is contained in the interval [ T(LEFT), T(LEFT+1) ], or
!    *  T < T(LEFT) = T(1), or
!    *  T > T(LEFT+1) = T(N).
!
!    The routine is useful for interpolation problems, where
!    the abscissa must be located within an interval of data
!    abscissas for interpolation, or the "nearest" interval
!    to the (extreme) abscissa must be found so that extrapolation
!    can be carried out.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, length of the input array.
!
!    Input, real ( kind = 8 ) T(N), an array sorted into ascending order.
!
!    Input, real ( kind = 8 ) TVAL, a value to be bracketed by entries of T.
!
!    Input/output, integer ( kind = 4 ) LEFT.
!
!    On input, if 1 <= LEFT <= N-1, LEFT is taken as a suggestion for the
!    interval [ T(LEFT), T(LEFT+1) ] in which TVAL lies.  This interval
!    is searched first, followed by the appropriate interval to the left
!    or right.  After that, a binary search is used.
!
!    On output, LEFT is set so that the interval [ T(LEFT), T(LEFT+1) ]
!    is the closest to TVAL; it either contains TVAL, or else TVAL
!    lies outside the interval [ T(1), T(N) ].
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) high
  integer ( kind = 4 ) left
  integer ( kind = 4 ) low
  integer ( kind = 4 ) mid
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
!
!  Check the input data.
!
  if ( n < 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'R8VEC_BRACKET3 - Fatal error!'
    write ( *, '(a)' ) '  N must be at least 2.'
    stop
  end if
!
!  If LEFT is not between 1 and N-1, set it to the middle value.
!
  if ( left < 1 .or. n - 1 < left ) then
    left = ( n + 1 ) / 2
  end if
!
!  CASE 1: TVAL < T(LEFT):
!  Search for TVAL in [T(I), T(I+1)] for intervals I = 1 to LEFT-1.
!
  if ( tval < t(left) ) then

    if ( left == 1 ) then
      return
    else if ( left == 2 ) then
      left = 1
      return
    else if ( t(left-1) <= tval ) then
      left = left - 1
      return
    else if ( tval <= t(2) ) then
      left = 1
      return
    end if
!
!  ...Binary search for TVAL in [T(I), T(I+1)] for intervals I = 2 to LEFT-2.
!
    low = 2
    high = left - 2

    do

      if ( low == high ) then
        left = low
        return
      end if

      mid = ( low + high + 1 ) / 2

      if ( t(mid) <= tval ) then
        low = mid
      else
        high = mid - 1
      end if

    end do
!
!  CASE2: T(LEFT+1) < TVAL:
!  Search for TVAL in {T(I),T(I+1)] for intervals I = LEFT+1 to N-1.
!
  else if ( t(left+1) < tval ) then

    if ( left == n - 1 ) then
      return
    else if ( left == n - 2 ) then
      left = left + 1
      return
    else if ( tval <= t(left+2) ) then
      left = left + 1
      return
    else if ( t(n-1) <= tval ) then
      left = n - 1
      return
    end if
!
!  ...Binary search for TVAL in [T(I), T(I+1)] for intervals I = LEFT+2 to N-2.
!
    low = left + 2
    high = n - 2

    do

      if ( low == high ) then
        left = low
        return
      end if

      mid = ( low + high + 1 ) / 2

      if ( t(mid) <= tval ) then
        low = mid
      else
        high = mid - 1
      end if

    end do
!
!  CASE3: T(LEFT) <= TVAL <= T(LEFT+1):
!  T is in [T(LEFT), T(LEFT+1)], as the user said it might be.
!
  else

  end if

  return
end
function r8vec_distinct ( n, x )

!*****************************************************************************80
!
!! R8VEC_DISTINCT is true if the entries in an R8VEC are distinct.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    16 September 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real ( kind = 8 ) X(N), the vector to be checked.
!
!    Output, logical R8VEC_DISTINCT is TRUE if all N elements of X 
!    are distinct.
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  logical r8vec_distinct
  real    ( kind = 8 ) x(n)

  r8vec_distinct = .false.

  do i = 2, n
    do j = 1, i - 1 
      if ( x(i) == x(j) ) then
        return
      end if
    end do
  end do

  r8vec_distinct = .true.

  return
end
subroutine r8vec_even ( n, alo, ahi, a )

!*****************************************************************************80
!
!! R8VEC_EVEN returns N real values, evenly spaced between ALO and AHI.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of values.
!
!    Input, real ( kind = 8 ) ALO, AHI, the low and high values.
!
!    Output, real ( kind = 8 ) A(N), N evenly spaced values.
!    Normally, A(1) = ALO and A(N) = AHI.
!    However, if N = 1, then A(1) = 0.5*(ALO+AHI).
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(n)
  real    ( kind = 8 ) ahi
  real    ( kind = 8 ) alo
  integer ( kind = 4 ) i

  if ( n == 1 ) then

    a(1) = 0.5D+00 * ( alo + ahi )

  else

    do i = 1, n
      a(i) = ( real ( n - i,     kind = 8 ) * alo   &
             + real (     i - 1, kind = 8 ) * ahi ) &
             / real ( n     - 1, kind = 8 )
    end do

  end if

  return
end
subroutine r8vec_indicator ( n, a )

!*****************************************************************************80
!
!! R8VEC_INDICATOR sets an R8VEC to the indicator vector.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    09 February 2001
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of elements of A.
!
!    Output, real ( kind = 8 ) A(N), the array to be initialized.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(n)
  integer ( kind = 4 ) i

  do i = 1, n
    a(i) = real ( i, kind = 8 )
  end do

  return
end
subroutine r8vec_order_type ( n, a, order )

!*****************************************************************************80
!
!! R8VEC_ORDER_TYPE determines the order type of an R8VEC.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!    We assume the array is increasing or decreasing, and we want to
!    verify that.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    20 July 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries of the array.
!
!    Input, real ( kind = 8 ) A(N), the array to be checked.
!
!    Output, integer ( kind = 4 ) ORDER, order indicator:
!    -1, no discernable order;
!    0, all entries are equal;
!    1, ascending order;
!    2, strictly ascending order;
!    3, descending order;
!    4, strictly descending order.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) order
!
!  Search for the first value not equal to A(1).
!
  i = 1

  do

    i = i + 1

    if ( n < i ) then
      order = 0
      return
    end if

    if ( a(1) < a(i) ) then

      if ( i == 2 ) then
        order = 2
      else
        order = 1
      end if

      exit

    else if ( a(i) < a(1) ) then

      if ( i == 2 ) then
        order = 4
      else
        order = 3
      end if

      exit

    end if

  end do
!
!  Now we have a "direction".  Examine subsequent entries.
!
  do

    i = i + 1
    if ( n < i ) then
      exit
    end if

    if ( order == 1 ) then

      if ( a(i) < a(i-1) ) then
        order = -1
        exit
      end if

    else if ( order == 2 ) then

      if ( a(i) < a(i-1) ) then
        order = -1
        exit
      else if ( a(i) == a(i-1) ) then
        order = 1
      end if

    else if ( order == 3 ) then

      if ( a(i-1) < a(i) ) then
        order = -1
        exit
      end if

    else if ( order == 4 ) then

      if ( a(i-1) < a(i) ) then
        order = -1
        exit
      else if ( a(i) == a(i-1) ) then
        order = 3
      end if

    end if

  end do
 
  return
end
subroutine r8vec_print ( n, a, title )

!*****************************************************************************80
!
!! R8VEC_PRINT prints an R8VEC.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    16 December 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of components of the vector.
!
!    Input, real ( kind = 8 ) A(N), the vector to be printed.
!
!    Input, character ( len = * ) TITLE, a title to be printed first.
!    TITLE may be blank.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(n)
  integer ( kind = 4 ) i
  character ( len = * ) title

  if ( title /= ' ' ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) trim ( title )
  end if

  write ( *, '(a)' ) ' '
  do i = 1, n
    write ( *, '(i8,g14.6)' ) i, a(i)
  end do

  return
end
subroutine r8vec_sort_bubble_a ( n, a )

!*****************************************************************************80
!
!! R8VEC_SORT_BUBBLE_A ascending sorts an R8VEC using bubble sort.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!    Bubble sort is simple to program, but inefficient.  It should not
!    be used for large arrays.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    01 February 2001
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the array.
!
!    Input/output, real ( kind = 8 ) A(N).
!    On input, an unsorted array.
!    On output, the array has been sorted.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j

  do i = 1, n-1
    do j = i+1, n
      if ( a(j) < a(i) ) then
        call r8_swap ( a(i), a(j) )
      end if
    end do
  end do

  return
end
subroutine r8vec_uniform_01 ( n, seed, r )

!*****************************************************************************80
!
!! R8VEC_UNIFORM_01 returns a unit pseudorandom R8VEC.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    19 August 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Paul Bratley, Bennett Fox, Linus Schrage,
!    A Guide to Simulation,
!    Springer Verlag, pages 201-202, 1983.
!
!    Bennett Fox,
!    Algorithm 647:
!    Implementation and Relative Efficiency of Quasirandom
!    Sequence Generators,
!    ACM Transactions on Mathematical Software,
!    Volume 12, Number 4, pages 362-376, 1986.
!
!    Peter Lewis, Allen Goodman, James Miller,
!    A Pseudo-Random Number Generator for the System/360,
!    IBM Systems Journal,
!    Volume 8, pages 136-143, 1969.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) M, the number of entries in the vector.
!
!    Input/output, integer ( kind = 4 ) SEED, the "seed" value, which should
!    NOT be 0.  On output, SEED has been updated.
!
!    Output, real ( kind = 8 ) R(N), the vector of pseudorandom values.
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) i
  integer ( kind = 4 ) k
  integer ( kind = 4 ) seed
  real    ( kind = 8 ) r(n)

  do i = 1, n

    k = seed / 127773

    seed = 16807 * ( seed - k * 127773 ) - k * 2836

    if ( seed < 0 ) then
      seed = seed + 2147483647
    end if

    r(i) = real ( seed, kind = 8 ) * 4.656612875D-10

  end do

  return
end
subroutine r8vec_unique_count ( n, a, tol, unique_num )

!*****************************************************************************80
!
!! R8VEC_UNIQUE_COUNT counts the unique elements in an unsorted R8VEC.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!    Because the array is unsorted, this algorithm is O(N^2).
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    08 December 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of elements of A.
!
!    Input, real ( kind = 8 ) A(N), the unsorted array to examine.
!
!    Input, real ( kind = 8 ) TOL, a nonnegative tolerance for equality. 
!    Set it to 0.0 for the strictest test.
!
!    Output, integer ( kind = 4 ) UNIQUE_NUM, the number of unique elements of A.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) unique_num
  real    ( kind = 8 ) tol

  unique_num = 0

  do i = 1, n

    unique_num = unique_num + 1

    do j = 1, i - 1

      if ( abs ( a(i) - a(j) ) <= tol ) then
        unique_num = unique_num - 1
        exit
      end if

    end do

  end do

  return
end
subroutine spline_b_val ( ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! SPLINE_B_VAL evaluates a cubic B spline approximant.
!
!  Discussion:
!
!    The cubic B spline will approximate the data, but is not 
!    designed to interpolate it.
!
!    In effect, two "phantom" data values are appended to the data,
!    so that the spline will interpolate the first and last data values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    11 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data values.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data.
!
!    Input, real ( kind = 8 ) YDATA(NDATA), the data values.
!
!    Input, real ( kind = 8 ) TVAL, a point at which the spline is 
!    to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the function at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) bval
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) u
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval
!
!  Find the nearest interval [ TDATA(LEFT), TDATA(RIGHT) ] to TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Evaluate the 5 nonzero B spline basis functions in the interval,
!  weighted by their corresponding data values.
!
  u = ( tval - tdata(left) ) / ( tdata(right) - tdata(left) )
  yval = 0.0D+00
!
!  B function associated with node LEFT - 1, (or "phantom node"),
!  evaluated in its 4th interval.
!
  bval = ( ( (     - 1.0D+00   &
               * u + 3.0D+00 ) &
               * u - 3.0D+00 ) &
               * u + 1.0D+00 ) / 6.0D+00

  if ( 0 < left-1 ) then
    yval = yval + ydata(left-1) * bval
  else
    yval = yval + ( 2.0D+00 * ydata(1) - ydata(2) ) * bval
  end if
!
!  B function associated with node LEFT,
!  evaluated in its third interval.
!
  bval = ( ( (       3.0D+00   &
               * u - 6.0D+00 ) &
               * u + 0.0D+00 ) &
               * u + 4.0D+00 ) / 6.0D+00

  yval = yval + ydata(left) * bval
!
!  B function associated with node RIGHT,
!  evaluated in its second interval.
!
  bval = ( ( (     - 3.0D+00   &
               * u + 3.0D+00 ) &
               * u + 3.0D+00 ) &
               * u + 1.0D+00 ) / 6.0D+00

  yval = yval + ydata(right) * bval
!
!  B function associated with node RIGHT+1, (or "phantom node"),
!  evaluated in its first interval.
!
  bval = u**3 / 6.0D+00

  if ( right+1 <= ndata ) then
    yval = yval + ydata(right+1) * bval
  else
    yval = yval + ( 2.0D+00 * ydata(ndata) - ydata(ndata-1) ) * bval
  end if

  return
end
subroutine spline_beta_val ( beta1, beta2, ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! SPLINE_BETA_VAL evaluates a cubic beta spline approximant.
!
!  Discussion:
!
!    The cubic beta spline will approximate the data, but is not 
!    designed to interpolate it.
!
!    If BETA1 = 1 and BETA2 = 0, the cubic beta spline will be the
!    same as the cubic B spline approximant.
!
!    With BETA1 = 1 and BETA2 large, the beta spline becomes more like
!    a linear spline.
!
!    In effect, two "phantom" data values are appended to the data,
!    so that the spline will interpolate the first and last data values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    11 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BETA1, the skew or bias parameter.
!    BETA1 = 1 for no skew or bias.
!
!    Input, real ( kind = 8 ) BETA2, the tension parameter.
!    BETA2 = 0 for no tension.
!
!    Input, integer ( kind = 4 ) NDATA, the number of data values.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data.
!
!    Input, real ( kind = 8 ) YDATA(NDATA), the data values.
!
!    Input, real ( kind = 8 ) TVAL, a point at which the spline is
!    to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the function at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) beta1
  real    ( kind = 8 ) beta2
  real    ( kind = 8 ) bval
  real    ( kind = 8 ) c
  real    ( kind = 8 ) d
  real    ( kind = 8 ) delta
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) u
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval
!
!  Find the nearest interval [ TDATA(LEFT), TDATA(RIGHT) ] to TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Evaluate the 5 nonzero beta spline basis functions in the interval,
!  weighted by their corresponding data values.
!
  u = ( tval - tdata(left) ) / ( tdata(right) - tdata(left) )

  delta = ( ( 2.0D+00   &
    * beta1 + 4.0D+00 ) &
    * beta1 + 4.0D+00 ) &
    * beta1 + 2.0D+00 + beta2

  yval = 0.0D+00
!
!  Beta function associated with node LEFT - 1, (or "phantom node"),
!  evaluated in its 4th interval.
!
  bval = 2.0D+00 * ( beta1 * ( 1.0D+00 - u ) )**3  / delta

  if ( 0 < left-1 ) then
    yval = yval + ydata(left-1) * bval
  else
    yval = yval + ( 2.0D+00 * ydata(1) - ydata(2) ) * bval
  end if
!
!  Beta function associated with node LEFT,
!  evaluated in its third interval.
!
  a = beta2 + ( 4.0D+00 + 4.0D+00 * beta1 ) * beta1

  b = - 6.0D+00 * beta1 * ( 1.0D+00 - beta1 ) * ( 1.0D+00 + beta1 )

  c = ( (     - 6.0D+00   &
      * beta1 - 6.0D+00 ) &
      * beta1 + 0.0D+00 ) &
      * beta1 - 3.0D+00 * beta2

  d = ( (     + 2.0D+00   &
      * beta1 + 2.0D+00 ) &
      * beta1 + 2.0D+00 ) &
      * beta1 + 2.0D+00 * beta2

  bval = ( a + u * ( b + u * ( c + u * d ) ) ) / delta

  yval = yval + ydata(left) * bval
!
!  Beta function associated with node RIGHT,
!  evaluated in its second interval.
!
  a = 2.0D+00

  b = 6.0D+00 * beta1

  c = 3.0D+00 * beta2 + 6.0D+00 * beta1 * beta1

  d = - 2.0D+00 * ( 1.0D+00 + beta2 + beta1 + beta1 * beta1 )

  bval = ( a + u * ( b + u * ( c + u * d ) ) ) / delta

  yval = yval + ydata(right) * bval
!
!  Beta function associated with node RIGHT+1, (or "phantom node"),
!  evaluated in its first interval.
!
  bval = 2.0D+00 * u**3 / delta

  if ( right + 1 <= ndata ) then
    yval = yval + ydata(right+1) * bval
  else
    yval = yval + ( 2.0D+00 * ydata(ndata) - ydata(ndata-1) ) * bval
  end if

  return
end
subroutine spline_bezier_val ( dim_num, interval_num, data_val, point_num, &
  point_t, point_val )

!*****************************************************************************80
!
!! SPLINE_BEZIER_VAL evaluates a cubic Bezier spline.
!
!  Discussion:
!
!    The cubic Bezier spline of N parts is defined by choosing 
!    3*N+1 equally spaced T-abscissa values in the interval [0,N].
!    This defines N subintervals, each of length 1, and each containing
!    4 successives T abscissa values.
!
!    At each abscissa value, a DIM_NUM-dimensional Bezier control
!    value is assigned.  Over each interval, a Bezier cubic function
!    is used to define the value of the Bezier spline.  To the left of
!    the first interval, or to the right of the last interval,
!    extrapolation may be used to extend the spline definition to
!    the entire real line.
!
!    Note that the Bezier spline will pass through the 1st, 4th,
!    and in general 3*I+1 control values exactly.  The other control
!    values are not interpolating points.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    17 June 2006
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) DIM_NUM, the spatial dimension.
!
!    Input, integer ( kind = 4 ) INTERVAL_NUM, the number of intervals.
!
!    Input, real ( kind = 8 ) DATA_VAL(DIM_NUM,3*INTERVAL_NUM+1), the control
!    values.
!
!    Input, integer ( kind = 4 ) POINT_NUM, the number of sample points at 
!    which the Bezier cubic spline is to be evaluated.
!
!    Input, real ( kind = 8 ) POINT_T(POINT_NUM), the "T" values associated
!    with the points.  A value of T between 0 and 1, for instance,
!    is associated with the first interval, and a value of T between
!    INTERVAL_NUM-1 and INTERVAL_NUM is in the last interval. 
!
!    Output, real ( kind = 8 ) POINT_VAL(DIM_NUM,POINT_NUM), the value
!    of the Bezier cubic spline at the sample points.
!
  implicit none

  integer ( kind = 4 ), parameter :: cubic = 3
  integer ( kind = 4 ) interval_num
  integer ( kind = 4 ) dim_num
  integer ( kind = 4 ) point_num

  real    ( kind = 8 ) bernstein_val(0:cubic)
  real    ( kind = 8 ) data_val(dim_num,cubic*interval_num+1)
  integer ( kind = 4 ) dim
  integer ( kind = 4 ) interval
  integer ( kind = 4 ) offset
  integer ( kind = 4 ) point
  real    ( kind = 8 ) point_t(point_num)
  real    ( kind = 8 ) point_val(dim_num,point_num)
  real    ( kind = 8 ) t
  real    ( kind = 8 ) t_01

  do point = 1, point_num

    t = point_t(point)

    interval = int ( t + 1 )

    interval = max ( interval, 1 )
    interval = min ( interval, interval_num )

    offset = 1 + ( interval - 1 ) * cubic

    t_01 = t - real ( interval - 1, kind = 8 )

    call bp01 ( cubic, t_01, bernstein_val )

    do dim = 1, dim_num
      point_val(dim,point) = dot_product ( &
        data_val(dim,offset:offset+cubic), bernstein_val(0:cubic) )
    end do

  end do

  return
end
subroutine spline_constant_val ( ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! SPLINE_CONSTANT_VAL evaluates a piecewise constant spline at a point.
!
!  Discussion:
!
!    NDATA-1 points TDATA define NDATA intervals, with the first
!    and last being semi-infinite.
!
!    The value of the spline anywhere in interval I is YDATA(I).
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    16 November 2001
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points defining 
!    the spline.  NDATA must be at least 1.
!
!    Input, real ( kind = 8 ) TDATA(NDATA-1), the breakpoints.  The values 
!    of TDATA should be distinct and increasing.
!
!    Input, real ( kind = 8 ) YDATA(NDATA), the values of the spline in
!    the intervals defined by the breakpoints.
!
!    Input, real ( kind = 8 ) TVAL, the point at which the spline is 
!    to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the spline at TVAL.  
!
  implicit none

  integer ( kind = 4 ) ndata

  integer ( kind = 4 ) i
  real    ( kind = 8 ) tdata(ndata-1)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval
!
!  Check NDATA.
!
  if ( ndata < 1 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CONSTANT_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 1.'
    stop
  end if

  do i = 1, ndata-1
    if ( tval <= tdata(i) ) then
      yval = ydata(i)
      return
    end if
  end do

  yval = ydata(ndata)

  return
end
subroutine spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

!*****************************************************************************80
!
!! SPLINE_CUBIC_SET computes the second derivatives of a piecewise cubic spline.
!
!  Discussion:
!
!    For data interpolation, the user must call SPLINE_CUBIC_SET to 
!    determine the second derivative data, passing in the data to be 
!    interpolated, and the desired boundary conditions.
!
!    The data to be interpolated, plus the SPLINE_CUBIC_SET output, 
!    defines the spline.  The user may then call SPLINE_CUBIC_VAL to 
!    evaluate the spline at any point.
!
!    The cubic spline is a piecewise cubic polynomial.  The intervals
!    are determined by the "knots" or abscissas of the data to be
!    interpolated.  The cubic spline has continous first and second
!    derivatives over the entire interval of interpolation.  
!
!    For any point T in the interval T(IVAL), T(IVAL+1), the form of
!    the spline is
!
!      SPL(T) = A(IVAL)
!             + B(IVAL) * ( T - T(IVAL) ) 
!             + C(IVAL) * ( T - T(IVAL) )**2
!             + D(IVAL) * ( T - T(IVAL) )**3
!
!    If we assume that we know the values Y(*) and YPP(*), which represent
!    the values and second derivatives of the spline at each knot, then
!    the coefficients can be computed as:
!
!      A(IVAL) = Y(IVAL)
!      B(IVAL) = ( Y(IVAL+1) - Y(IVAL) ) / ( T(IVAL+1) - T(IVAL) )
!        - ( YPP(IVAL+1) + 2 * YPP(IVAL) ) * ( T(IVAL+1) - T(IVAL) ) / 6
!      C(IVAL) = YPP(IVAL) / 2
!      D(IVAL) = ( YPP(IVAL+1) - YPP(IVAL) ) / ( 6 * ( T(IVAL+1) - T(IVAL) ) )
!
!    Since the first derivative of the spline is
!
!      SPL'(T) =     B(IVAL)
!              + 2 * C(IVAL) * ( T - T(IVAL) )
!              + 3 * D(IVAL) * ( T - T(IVAL) )**2,
!
!    the requirement that the first derivative be continuous at interior
!    knot I results in a total of N-2 equations, of the form:
!
!      B(IVAL-1) + 2 C(IVAL-1) * (T(IVAL)-T(IVAL-1)) 
!      + 3 * D(IVAL-1) * (T(IVAL) - T(IVAL-1))**2 = B(IVAL)
!
!    or, setting H(IVAL) = T(IVAL+1) - T(IVAL)
!
!      ( Y(IVAL) - Y(IVAL-1) ) / H(IVAL-1)
!      - ( YPP(IVAL) + 2 * YPP(IVAL-1) ) * H(IVAL-1) / 6
!      + YPP(IVAL-1) * H(IVAL-1)
!      + ( YPP(IVAL) - YPP(IVAL-1) ) * H(IVAL-1) / 2
!      = 
!      ( Y(IVAL+1) - Y(IVAL) ) / H(IVAL)
!      - ( YPP(IVAL+1) + 2 * YPP(IVAL) ) * H(IVAL) / 6
!
!    or
!
!      YPP(IVAL-1) * H(IVAL-1) + 2 * YPP(IVAL) * ( H(IVAL-1) + H(IVAL) )
!      + YPP(IVAL) * H(IVAL) 
!      =
!      6 * ( Y(IVAL+1) - Y(IVAL) ) / H(IVAL)
!      - 6 * ( Y(IVAL) - Y(IVAL-1) ) / H(IVAL-1)    
!
!    Boundary conditions must be applied at the first and last knots.  
!    The resulting tridiagonal system can be solved for the YPP values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    27 January 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of data points; N must be 
!    at least 2. 
!
!    Input, real ( kind = 8 ) T(N), the points where data is specified.  
!    The values should be distinct, and increasing.
!
!    Input, real ( kind = 8 ) Y(N), the data values to be interpolated.
!
!    Input, integer ( kind = 4 ) IBCBEG, the left boundary condition flag:
!
!      0: the spline should be a quadratic over the first interval;
!      1: the first derivative at the left endpoint should be YBCBEG;
!      2: the second derivative at the left endpoint should be YBCBEG.
!
!    Input, real ( kind = 8 ) YBCBEG, the left boundary value, if needed.
!
!    Input, integer ( kind = 4 ) IBCEND, the right boundary condition flag:
!
!      0: the spline should be a quadratic over the last interval;
!      1: the first derivative at the right endpoint should be YBCEND;
!      2: the second derivative at the right endpoint should be YBCEND.
!
!    Input, real ( kind = 8 ) YBCEND, the right boundary value, if needed.
!
!    Output, real ( kind = 8 ) YPP(N), the second derivatives of 
!    the cubic spline.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(3,n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ybcbeg
  real    ( kind = 8 ) ybcend
  real    ( kind = 8 ) ypp(n)
!
!  Check.
!
  if ( n <= 1 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
    write ( *, '(a)' ) '  The number of knots must be at least 2.'
    write ( *, '(a,i8)' ) '  The input value of N = ', n
    stop
  end if

  do i = 1, n-1
    if ( t(i+1) <= t(i) ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
      write ( *, '(a)' ) '  The knots must be strictly increasing, but'
      write ( *, '(a,i8,a,g14.6)' ) '  T(',  i,') = ', t(i)
      write ( *, '(a,i8,a,g14.6)' ) '  T(',i+1,') = ', t(i+1)
      stop
    end if
  end do
!
!  Set the first equation.
!
  if ( ibcbeg == 0 ) then
    ypp(1) = 0.0D+00
    a(2,1) = 1.0D+00
    a(1,2) = -1.0D+00
  else if ( ibcbeg == 1 ) then
    ypp(1) = ( y(2) - y(1) ) / ( t(2) - t(1) ) - ybcbeg
    a(2,1) = ( t(2) - t(1) ) / 3.0D+00 
    a(1,2) = ( t(2) - t(1) ) / 6.0D+00
  else if ( ibcbeg == 2 ) then
    ypp(1) = ybcbeg
    a(2,1) = 1.0D+00
    a(1,2) = 0.0D+00
  else
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
    write ( *, '(a)' ) '  The boundary flag IBCBEG must be 0, 1 or 2.'
    write ( *, '(a,i8)' ) '  The input value is IBCBEG = ', ibcbeg
    stop
  end if
!
!  Set the intermediate equations.
!
  do i = 2, n-1
    ypp(i) = ( y(i+1) - y(i) ) / ( t(i+1) - t(i) ) &
           - ( y(i) - y(i-1) ) / ( t(i) - t(i-1) )
    a(3,i-1) = ( t(i) - t(i-1) ) / 6.0D+00
    a(2,i) = ( t(i+1) - t(i-1) ) / 3.0D+00
    a(1,i+1) = ( t(i+1) - t(i) ) / 6.0D+00
  end do
!
!  Set the last equation.
!
  if ( ibcend == 0 ) then
    ypp(n) = 0.0D+00
    a(3,n-1) = -1.0D+00
    a(2,n) = 1.0D+00
  else if ( ibcend == 1 ) then
    ypp(n) = ybcend - ( y(n) - y(n-1) ) / ( t(n) - t(n-1) )
    a(3,n-1) = ( t(n) - t(n-1) ) / 6.0D+00
    a(2,n) = ( t(n) - t(n-1) ) / 3.0D+00
  else if ( ibcend == 2 ) then
    ypp(n) = ybcend
    a(3,n-1) = 0.0D+00
    a(2,n) = 1.0D+00
  else
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
    write ( *, '(a)' ) '  The boundary flag IBCEND must be 0, 1 or 2.'
    write ( *, '(a,i8)' ) '  The input value is IBCEND = ', ibcend
    stop
  end if
!
!  Special case:
!    N = 2, IBCBEG = IBCEND = 0.
!
  if ( n == 2 .and. ibcbeg == 0 .and. ibcend == 0 ) then

    ypp(1) = 0.0D+00
    ypp(2) = 0.0D+00
!
!  Solve the linear system.
!
  else

    call r83_np_fs ( n, a, ypp, ypp )

  end if

  return
end
subroutine spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )

!*****************************************************************************80
!
!! SPLINE_CUBIC_VAL evaluates a piecewise cubic spline at a point.
!
!  Discussion:
!
!    SPLINE_CUBIC_SET must have already been called to define the 
!    values of YPP.
!
!    For any point T in the interval T(IVAL), T(IVAL+1), the form of
!    the spline is
!
!      SPL(T) = A 
!             + B * ( T - T(IVAL) ) 
!             + C * ( T - T(IVAL) )**2
!             + D * ( T - T(IVAL) )**3
!
!    Here:
!      A = Y(IVAL)
!      B = ( Y(IVAL+1) - Y(IVAL) ) / ( T(IVAL+1) - T(IVAL) )
!        - ( YPP(IVAL+1) + 2 * YPP(IVAL) ) * ( T(IVAL+1) - T(IVAL) ) / 6
!      C = YPP(IVAL) / 2
!      D = ( YPP(IVAL+1) - YPP(IVAL) ) / ( 6 * ( T(IVAL+1) - T(IVAL) ) )
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    20 November 2000
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of data values.
!
!    Input, real ( kind = 8 ) T(N), the knot values.
!
!    Input, real ( kind = 8 ) Y(N), the data values at the knots.
!
!    Input, real ( kind = 8 ) YPP(N), the second derivatives of the 
!    spline at the knots.
!
!    Input, real ( kind = 8 ) TVAL, a point, typically between T(1) and 
!    T(N), at which the spline is to be evalulated.  If TVAL lies outside 
!    this range, extrapolation is used.
!
!    Output, real ( kind = 8 ) YVAL, YPVAL, YPPVAL, the value of the spline, and
!    its first two derivatives at TVAL.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) dt
  real    ( kind = 8 ) h
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval
!
!  Determine the interval [T(LEFT), T(RIGHT)] that contains TVAL.
!  Values below T(1) or above T(N) use extrapolation.
!
  call r8vec_bracket ( n, t, tval, left, right )
!
!  Evaluate the polynomial.
!
  dt = tval - t(left)
  h = t(right) - t(left)

  yval = y(left) &
       + dt * ( ( y(right) - y(left) ) / h &
              - ( ypp(right) / 6.0D+00 + ypp(left) / 3.0D+00 ) * h &
       + dt * ( 0.5D+00 * ypp(left) &
       + dt * ( ( ypp(right) - ypp(left) ) / ( 6.0D+00 * h ) ) ) )

  ypval = ( y(right) - y(left) ) / h &
       - ( ypp(right) / 6.0D+00 + ypp(left) / 3.0D+00 ) * h &
       + dt * ( ypp(left) &
       + dt * ( 0.5D+00 * ( ypp(right) - ypp(left) ) / h ) )

  yppval = ypp(left) + dt * ( ypp(right) - ypp(left) ) / h 

  return
end
subroutine spline_cubic_val2 ( n, t, y, ypp, left, tval, yval, ypval, yppval )

!*****************************************************************************80
!
!! SPLINE_CUBIC_VAL2 evaluates a piecewise cubic spline at a point.
!
!  Discussion:
!
!    This routine is a modification of SPLINE_CUBIC_VAL; it allows the
!    user to speed up the code by suggesting the appropriate T interval
!    to search first.
!
!    SPLINE_CUBIC_SET must have already been called to define the
!    values of YPP.
!
!    In the LEFT interval, let RIGHT = LEFT+1.  The form of the spline is
!
!      SPL(T) = 
!          A
!        + B * ( T - T(LEFT) )
!        + C * ( T - T(LEFT) )**2
!        + D * ( T - T(LEFT) )**3
!
!    Here:
!      A = Y(LEFT)
!      B = ( Y(RIGHT) - Y(LEFT) ) / ( T(RIGHT) - T(LEFT) )
!        - ( YPP(RIGHT) + 2 * YPP(LEFT) ) * ( T(RIGHT) - T(LEFT) ) / 6
!      C = YPP(LEFT) / 2
!      D = ( YPP(RIGHT) - YPP(LEFT) ) / ( 6 * ( T(RIGHT) - T(LEFT) ) )
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of knots.
!
!    Input, real ( kind = 8 ) T(N), the knot values.
!
!    Input, real ( kind = 8 ) Y(N), the data values at the knots.
!
!    Input, real ( kind = 8 ) YPP(N), the second derivatives of the spline at
!    the knots.
!
!    Input/output, integer ( kind = 4 ) LEFT, the suggested T interval to search.
!    LEFT should be between 1 and N-1.  If LEFT is not in this range,
!    then its value will be ignored.  On output, LEFT is set to the
!    actual interval in which TVAL lies.
!
!    Input, real ( kind = 8 ) TVAL, a point, typically between T(1) and T(N), at
!    which the spline is to be evalulated.  If TVAL lies outside
!    this range, extrapolation is used.
!
!    Output, real ( kind = 8 ) YVAL, YPVAL, YPPVAL, the value of the spline, and
!    its first two derivatives at TVAL.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) dt
  real    ( kind = 8 ) h
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) t(n)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y(n)
  real    ( kind = 8 ) ypp(n)
  real    ( kind = 8 ) yppval
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval
!
!  Determine the interval [T(LEFT), T(RIGHT)] that contains TVAL.
!  
!  What you want from R8VEC_BRACKET3 is that TVAL is to be computed
!  by the data in interval {T(LEFT), T(RIGHT)].
!
  call r8vec_bracket3 ( n, t, tval, left )
  right = left + 1
!
!  In the interval LEFT, the polynomial is in terms of a normalized
!  coordinate  ( DT / H ) between 0 and 1.
!
  dt = tval - t(left)
  h = t(right) - t(left)

  yval = y(left) + dt * ( ( y(right) - y(left) ) / h &
              - ( ypp(right) / 6.0D+00 + ypp(left) / 3.0D+00 ) * h &
       + dt * ( 0.5D+00 * ypp(left) &
       + dt * ( ( ypp(right) - ypp(left) ) / ( 6.0D+00 * h ) ) ) )

  ypval = ( y(right) - y(left) ) / h &
      - ( ypp(right) / 6.0D+00 + ypp(left) / 3.0D+00 ) * h &
      + dt * ( ypp(left) &
      + dt * ( 0.5D+00 * ( ypp(right) - ypp(left) ) / h ) )

  yppval = ypp(left) + dt * ( ypp(right) - ypp(left) ) / h

  return
end
subroutine spline_hermite_set ( ndata, tdata, ydata, ypdata, c )

!*****************************************************************************80
!
!! SPLINE_HERMITE_SET sets up a piecewise cubic Hermite interpolant.
!
!  Discussion:
!
!    Once the array C is computed, then in the interval 
!    (TDATA(I), TDATA(I+1)), the interpolating Hermite polynomial 
!    is given by
!
!      SVAL(TVAL) =                 C(1,I)
!         + ( TVAL - TDATA(I) ) * ( C(2,I)
!         + ( TVAL - TDATA(I) ) * ( C(3,I)
!         + ( TVAL - TDATA(I) ) *   C(4,I) ) )
!
!    This is algorithm CALCCF of Conte and deBoor.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    11 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Samuel Conte, Carl deBoor,
!    Elementary Numerical Analysis,
!    Second Edition,
!    McGraw Hill, 1972,
!    ISBN: 07-012446-4,
!    LC: QA297.C65.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points.
!    NDATA must be at least 2.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data points.
!    The entries of TDATA are assumed to be strictly increasing.
!
!    Input, real ( kind = 8 ) Y(NDATA), YP(NDATA), the value of the
!    function and its derivative at TDATA(1:NDATA).
!
!    Output, real ( kind = 8 ) C(4,NDATA), the coefficients of the 
!    Hermite polynomial.
!    C(1,1:NDATA) = Y(1:NDATA) and C(2,1:NDATA) = YP(1:NDATA).
!    C(3,1:NDATA-1) and C(4,1:NDATA-1) are the quadratic and cubic 
!    coefficients.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) c(4,ndata)
  real    ( kind = 8 ) divdif1
  real    ( kind = 8 ) divdif3
  real    ( kind = 8 ) dt
  integer ( kind = 4 ) i
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) ypdata(ndata)
!
!  Check NDATA.
!
  if ( ndata < 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_HERMITE_SET - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 2.'
    stop
  end if

  c(1,1:ndata) = ydata(1:ndata)
  c(2,1:ndata) = ypdata(1:ndata)

  do i = 1, ndata-1
    dt = tdata(i+1) - tdata(i)
    divdif1 = ( c(1,i+1) - c(1,i) ) / dt
    divdif3 = c(2,i) + c(2,i+1) - 2.0D+00 * divdif1
    c(3,i) = ( divdif1 - c(2,i) - divdif3 ) / dt
    c(4,i) = divdif3 / ( dt * dt )
  end do

  c(3,ndata) = 0.0D+00
  c(4,ndata) = 0.0D+00

  return
end
subroutine spline_hermite_val ( ndata, tdata, c, tval, sval, spval )

!*****************************************************************************80
!
!! SPLINE_HERMITE_VAL evaluates a piecewise cubic Hermite interpolant.
!
!  Discussion:
!
!    SPLINE_HERMITE_SET must be called first, to set up the
!    spline data from the raw function and derivative data.
!
!    In the interval (TDATA(I), TDATA(I+1)), the interpolating 
!    Hermite polynomial is given by
!
!      SVAL(TVAL) =                 C(1,I)
!         + ( TVAL - TDATA(I) ) * ( C(2,I)
!         + ( TVAL - TDATA(I) ) * ( C(3,I)
!         + ( TVAL - TDATA(I) ) *   C(4,I) ) )
!
!    and
!
!      SVAL'(TVAL) =                    C(2,I)
!         + ( TVAL - TDATA(I) ) * ( 2 * C(3,I)
!         + ( TVAL - TDATA(I) ) *   3 * C(4,I) )
!
!    This is algorithm PCUBIC of Conte and deBoor.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    11 February 2004
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Samuel Conte, Carl deBoor,
!    Elementary Numerical Analysis,
!    Second Edition,
!    McGraw Hill, 1972,
!    ISBN: 07-012446-4,
!    LC: QA297.C65.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points.
!    NDATA must be at least 2.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data points.
!    The entries of TDATA are assumed to be strictly increasing.
!
!    Input, real ( kind = 8 ) C(4,NDATA), the coefficient data computed by
!    SPLINE_HERMITE_SET.
!
!    Input, real ( kind = 8 ) TVAL, the point where the interpolant is to
!    be evaluated.
!
!    Output, real ( kind = 8 ) SVAL, SPVAL, the value of the interpolant 
!    and its derivative at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) c(4,ndata)
  real    ( kind = 8 ) dt
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) spval
  real    ( kind = 8 ) sval
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
!
!  Check NDATA.
!
  if ( ndata < 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_HERMITE_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 2.'
    stop
  end if
!
!  Find the interval [ TDATA(LEFT), TDATA(RIGHT) ] that contains
!  or is nearest to TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Evaluate the cubic polynomial.
!
  dt = tval - tdata(left)

  sval = c(1,left) + dt * ( c(2,left) + dt * ( c(3,left) + dt * c(4,left) ) )

  spval = c(2,left) + dt * ( 2.0D+00 * c(3,left) + dt * 3.0D+00 * c(4,left) )

  return
end
subroutine spline_linear_int ( ndata, tdata, ydata, a, b, int_val )

!*****************************************************************************80
!
!! SPLINE_LINEAR_INT evaluates the integral of a piecewise linear spline.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    01 November 2001
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points defining 
!    the spline.  NDATA must be at least 2.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), YDATA(NDATA), the values of 
!    the independent and dependent variables at the data points.  The
!    values of TDATA should be distinct and increasing.
!
!    Input, real ( kind = 8 ) A, B, the interval over which the 
!    integral is desired.
!
!    Output, real ( kind = 8 ) INT_VAL, the value of the integral.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) a
  real    ( kind = 8 ) a_copy
  integer ( kind = 4 ) a_left
  integer ( kind = 4 ) a_right
  real    ( kind = 8 ) b
  real    ( kind = 8 ) b_copy
  integer ( kind = 4 ) b_left
  integer ( kind = 4 ) b_right
  integer ( kind = 4 ) i_left
  real    ( kind = 8 ) int_val
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yp
  real    ( kind = 8 ) yval
!
!  Check NDATA.
!
  if ( ndata < 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_LINEAR_INT - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 2.'
    stop
  end if

  int_val = 0.0D+00 

  if ( a == b ) then
    return
  end if

  a_copy = min ( a, b )
  b_copy = max ( a, b )
!
!  Find the interval [ TDATA(A_LEFT), TDATA(A_RIGHT) ] that contains, or is
!  nearest to, A.
!
  call r8vec_bracket ( ndata, tdata, a_copy, a_left, a_right )
!
!  Find the interval [ TDATA(B_LEFT), TDATA(B_RIGHT) ] that contains, or is
!  nearest to, B.
!
  call r8vec_bracket ( ndata, tdata, b_copy, b_left, b_right )
!
!  If A and B are in the same interval...
!
  if ( a_left == b_left ) then

    tval = ( a_copy + b_copy ) / 2.0D+00

    yp = ( ydata(a_right) - ydata(a_left) ) / &
         ( tdata(a_right) - tdata(a_left) )

    yval = ydata(a_left) + ( tval - tdata(a_left) ) * yp

    int_val = yval * ( b_copy - a_copy )

    return
  end if
!
!  Otherwise, integrate from:
!
!  A               to TDATA(A_RIGHT),
!  TDATA(A_RIGHT)  to TDATA(A_RIGHT+1),...
!  TDATA(B_LEFT-1) to TDATA(B_LEFT),
!  TDATA(B_LEFT)   to B.
!
!  Use the fact that the integral of a linear function is the
!  value of the function at the midpoint times the width of the interval.
!
  tval = ( a_copy + tdata(a_right) ) / 2.0D+00

  yp = ( ydata(a_right) - ydata(a_left) ) / &
       ( tdata(a_right) - tdata(a_left) )

  yval = ydata(a_left) + ( tval - tdata(a_left) ) * yp

  int_val = int_val + yval * ( tdata(a_right) - a_copy )

  do i_left = a_right, b_left - 1

    tval = ( tdata(i_left+1) + tdata(i_left) ) / 2.0D+00

    yp = ( ydata(i_left+1) - ydata(i_left) ) / &
         ( tdata(i_left+1) - tdata(i_left) )

    yval = ydata(i_left) + ( tval - tdata(i_left) ) * yp

    int_val = int_val + yval * ( tdata(i_left + 1) - tdata(i_left) )

  end do

  tval = ( tdata(b_left) + b_copy ) / 2.0D+00

  yp = ( ydata(b_right) - ydata(b_left) ) / &
       ( tdata(b_right) - tdata(b_left) )

  yval = ydata(b_left) + ( tval - tdata(b_left) ) * yp

  int_val = int_val + yval * ( b_copy - tdata(b_left) )

  if ( b < a ) then
    int_val = - int_val
  end if

  return
end
subroutine spline_linear_intset ( n, int_x, int_v, data_x, data_y )

!*****************************************************************************80
!
!! SPLINE_LINEAR_INTSET sets a piecewise linear spline with given integral properties.
!
!  Discussion:
!
!    The user has in mind an interval, divided by INT_N+1 points into
!    INT_N intervals.  A linear spline is to be constructed,
!    with breakpoints at the centers of each interval, and extending
!    continuously to the left of the first and right of the last
!    breakpoints.  The constraint on the linear spline is that it is
!    required that it have a given integral value over each interval.
!
!    A tridiagonal linear system of equations is solved for the
!    values of the spline at the breakpoints.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    27 January 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of intervals.
!
!    Input, real ( kind = 8 ) INT_X(N+1), the points that define the intervals.
!    Interval I lies between INT_X(I) and INT_X(I+1).
!
!    Input, real ( kind = 8 ) INT_V(N), the desired value of the integral of the
!    linear spline over each interval.
!
!    Output, real ( kind = 8 ) DATA_X(N), DATA_Y(N), the values of the
!    independent and dependent variables at the data points.  The values 
!    of DATA_X are the interval midpoints.  The values of DATA_Y are 
!    determined in such a way that the exact integral of the linear 
!    spline over interval I is equal to INT_V(I).
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) a(3,n)
  real    ( kind = 8 ) data_x(n)
  real    ( kind = 8 ) data_y(n)
  real    ( kind = 8 ) int_v(n)
  real    ( kind = 8 ) int_x(n+1)
!
!  Set up the easy stuff.
!
  data_x(1:n) = 0.5D+00 * ( int_x(1:n) + int_x(2:n+1) )
!
!  Set up C, D, E, the coefficients of the linear system.
!
  a(3,1:n-2) = 1.0D+00 &
    - ( 0.5D+00 * ( data_x(2:n-1) + int_x(2:n-1) ) - data_x(1:n-2) ) &
    / ( data_x(2:n-1) - data_x(1:n-2) )
  a(3,n-1) = 0.0D+00
  a(3,n) = 0.0D+00

  a(2,1) = int_x(2) - int_x(1)

  a(2,2:n-1) = 1.0D+00 &
    + ( 0.5D+00 * ( data_x(2:n-1) + int_x(2:n-1) ) &
    - data_x(1:n-2) ) &
    / ( data_x(2:n-1) - data_x(1:n-2) ) &
    - ( 0.5D+00 * ( data_x(2:n-1) + int_x(3:n) ) - data_x(2:n-1) ) &
    / ( data_x(3:n) - data_x(2:n-1) )

  a(2,n) = int_x(n+1) - int_x(n)

  a(1,1) = 0.0D+00
  a(1,2) = 0.0D+00

  a(1,3:n) = ( 0.5D+00 * ( data_x(2:n-1) + int_x(3:n) ) &
    - data_x(2:n-1) ) / ( data_x(3:n) - data_x(2:n-1) )
!
!  Set up DATA_Y, which begins as the right hand side of the linear system.
!
  data_y(1) = int_v(1)
  data_y(2:n-1) = 2.0D+00 * int_v(2:n-1) / ( int_x(3:n) - int_x(2:n-1) )
  data_y(n) = int_v(n)
!
!  Solve the linear system.
!
  call r83_np_fs ( n, a, data_y, data_y )

  return
end
subroutine spline_linear_val ( ndata, tdata, ydata, tval, yval, ypval )

!*****************************************************************************80
!
!! SPLINE_LINEAR_VAL evaluates a piecewise linear spline at a point.
!
!  Discussion:
!
!    Because of the extremely simple form of the linear spline,
!    the raw data points ( TDATA(I), YDATA(I)) can be used directly to
!    evaluate the spline at any point.  No processing of the data
!    is required.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    06 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points defining 
!    the spline.  NDATA must be at least 2.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), YDATA(NDATA), the values of 
!    the independent and dependent variables at the data points.  The 
!    values of TDATA should be distinct and increasing.
!
!    Input, real ( kind = 8 ) TVAL, the point at which the spline is
!    to be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, YPVAL, the value of the spline and 
!    its first derivative dYdT at TVAL.  YPVAL is not reliable if TVAL 
!    is exactly equal to TDATA(I) for some I.
!
  implicit none

  integer ( kind = 4 ) ndata

  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval
!
!  Check NDATA.
!
  if ( ndata < 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_LINEAR_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 2.'
    stop
  end if
!
!  Find the interval [ TDATA(LEFT), TDATA(RIGHT) ] that contains, or is
!  nearest to, TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Now evaluate the piecewise linear function.
!
  ypval = ( ydata(right) - ydata(left) ) / ( tdata(right) - tdata(left) )

  yval = ydata(left) +  ( tval - tdata(left) ) * ypval

  return
end
subroutine spline_overhauser_nonuni_val ( ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! SPLINE_OVERHAUSER_NONUNI_VAL evaluates the nonuniform Overhauser spline.
!
!  Discussion:
!
!    The nonuniformity refers to the fact that the abscissas values
!    need not be uniformly spaced.
!
!    Thanks to Doug Fortune for pointing out that the point distances
!    used to define ALPHA and BETA should be the Euclidean distances
!    between the points.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    08 May 2007
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points.
!    3 <= NDATA is required.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data points.
!    The values of TDATA are assumed to be distinct and increasing.
!
!    Input, real ( kind = 8 ) YDATA(NDATA), the data values.
!
!    Input, real ( kind = 8 ) TVAL, the value where the spline is to
!    be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the spline at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) alpha
  real    ( kind = 8 ) beta
  real    ( kind = 8 ) d21
  real    ( kind = 8 ) d32
  real    ( kind = 8 ) d43
  integer ( kind = 4 ) left
  real    ( kind = 8 ) mbasis(4,4)
  real    ( kind = 8 ) mbasis_l(3,3)
  real    ( kind = 8 ) mbasis_r(3,3)
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval
!
!  Check NDATA.
!
  if ( ndata < 3 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_OVERHAUSER_NONUNI_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 3.'
    stop
  end if
!
!  Find the nearest interval [ TDATA(LEFT), TDATA(RIGHT) ] to TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Evaluate the spline in the given interval.
!
  if ( left == 1 ) then

    d21 = sqrt ( ( tdata(2) - tdata(1) )**2 &
               + ( ydata(2) - ydata(1) )**2 )

    d32 = sqrt ( ( tdata(3) - tdata(2) )**2 &
               + ( ydata(3) - ydata(2) )**2 )

    alpha = d21 / ( d32 + d21 )

    call basis_matrix_overhauser_nul ( alpha, mbasis_l )

    call basis_matrix_tmp ( left, 3, mbasis_l, ndata, tdata, ydata, tval, yval )

  else if ( left < ndata-1 ) then

    d21 = sqrt ( ( tdata(left) - tdata(left-1) )**2 &
               + ( ydata(left) - ydata(left-1) )**2 )

    d32 = sqrt ( ( tdata(left+1) - tdata(left) )**2 &
               + ( ydata(left+1) - ydata(left) )**2 )

    d43 = sqrt ( ( tdata(left+2) - tdata(left+1) )**2 &
               + ( ydata(left+2) - ydata(left+1) )**2 )

    alpha = d21 / ( d32 + d21 )
    beta  = d32 / ( d43 + d32 )

    call basis_matrix_overhauser_nonuni ( alpha, beta, mbasis )

    call basis_matrix_tmp ( left, 4, mbasis, ndata, tdata, ydata, tval, yval )

  else if ( left == ndata-1 ) then

    d32 = sqrt ( ( tdata(ndata-1) - tdata(ndata-2) )**2 &
               + ( ydata(ndata-1) - ydata(ndata-2) )**2 )

    d43 = sqrt ( ( tdata(ndata) - tdata(ndata-1) )**2 &
               + ( ydata(ndata) - ydata(ndata-1) )**2 )

    beta  = d32 / ( d43 + d32 )

    call basis_matrix_overhauser_nur ( beta, mbasis_r )

    call basis_matrix_tmp ( left, 3, mbasis_r, ndata, tdata, ydata, tval, yval )

  else

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_OVERHAUSER_NONUNI_VAL - Fatal error!'
    write ( *, '(a,i8)' ) '  Nonsensical value of LEFT = ', left
    write ( *, '(a,i8)' ) '  but 0 < LEFT < NDATA = ', ndata
    write ( *, '(a)' ) '  is required.'
    stop

  end if

  return
end
subroutine spline_overhauser_uni_val ( ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! SPLINE_OVERHAUSER_UNI_VAL evaluates the uniform Overhauser spline.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    06 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points.
!    NDATA must be at least 3.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data points.
!    The values of TDATA are assumed to be distinct and increasing.
!    This routine also assumes that the values of TDATA are uniformly
!    spaced; for instance, TDATA(1) = 10, TDATA(2) = 11, TDATA(3) = 12...
!
!    Input, real ( kind = 8 ) YDATA(NDATA), the data values.
!
!    Input, real ( kind = 8 ) TVAL, the value where the spline is to
!    be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, the value of the spline at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata

  integer ( kind = 4 ) left
  real    ( kind = 8 ) mbasis(4,4)
  real    ( kind = 8 ) mbasis_l(3,3)
  real    ( kind = 8 ) mbasis_r(3,3)
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) yval
!
!  Check NDATA.
!
  if ( ndata < 3 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_OVERHAUSER_UNI_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 3.'
    stop
  end if
!
!  Find the nearest interval [ TDATA(LEFT), TDATA(RIGHT) ] to TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Evaluate the spline in the given interval.
!
  if ( left == 1 ) then

    call basis_matrix_overhauser_uni_l ( mbasis_l )

    call basis_matrix_tmp ( left, 3, mbasis_l, ndata, tdata, ydata, tval, yval )

  else if ( left < ndata-1 ) then

    call basis_matrix_overhauser_uni ( mbasis )

    call basis_matrix_tmp ( left, 4, mbasis, ndata, tdata, ydata, tval, yval )

  else if ( left == ndata-1 ) then

    call basis_matrix_overhauser_uni_r ( mbasis_r )

    call basis_matrix_tmp ( left, 3, mbasis_r, ndata, tdata, ydata, tval, yval )

  end if

  return
end
subroutine spline_overhauser_val ( dim_num, ndata, tdata, ydata, tval, yval )

!*****************************************************************************80
!
!! SPLINE_OVERHAUSER_VAL evaluates an Overhauser spline.
!
!  Discussion:
!
!    Over the first and last intervals, the Overhauser spline is a 
!    quadratic.  In the intermediate intervals, it is a piecewise cubic.
!    The Overhauser spline is also known as the Catmull-Rom spline.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!   08 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    JA Brewer, DC Anderson,
!    Visual Interaction with Overhauser Curves and Surfaces,
!    SIGGRAPH 77,
!    in Proceedings of the 4th Annual Conference on Computer Graphics
!    and Interactive Techniques,
!    ASME, July 1977, pages 132-137.
!
!    Edwin Catmull, Raphael Rom,
!    A Class of Local Interpolating Splines,
!    in Computer Aided Geometric Design,
!    edited by Robert Barnhill, Richard Reisenfeld,
!    Academic Press, 1974, pages 317-326,
!    ISBN: 0120790505.
!
!    David Rogers, Alan Adams,
!    Mathematical Elements of Computer Graphics,
!    Second Edition,
!    McGraw Hill, 1989,
!    ISBN: 0070535299.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) DIM_NUM, the dimension of a single data point.
!    DIM_NUM must be at least 1.
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points.
!    NDATA must be at least 3.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), the abscissas of the data 
!    points.  The values in TDATA must be in strictly ascending order.
!
!    Input, real ( kind = 8 ) YDATA(DIM_NUM,NDATA), the data points 
!    corresponding to the abscissas.
!
!    Input, real ( kind = 8 ) TVAL, the abscissa value at which the spline
!    is to be evaluated.  Normally, TDATA(1) <= TVAL <= T(NDATA), and 
!    the data will be interpolated.  For TVAL outside this range, 
!    extrapolation will be used.
!
!    Output, real ( kind = 8 ) YVAL(DIM_NUM), the value of the spline at TVAL.
!
  implicit none

  integer ( kind = 4 ) ndata
  integer ( kind = 4 ) dim_num

  integer ( kind = 4 ) left
  integer ( kind = 4 ) order
  integer ( kind = 4 ) right
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) ydata(dim_num,ndata)
  real    ( kind = 8 ) yl(dim_num)
  real    ( kind = 8 ) yr(dim_num)
  real    ( kind = 8 ) yval(dim_num)
!
!  Check.
!
  call r8vec_order_type ( ndata, tdata, order )

  if ( order /= 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_OVERHAUSER_VAL - Fatal error!'
    write ( *, '(a)' ) '  The data abscissas are not strictly ascending.'
    stop
  end if

  if ( ndata < 3 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_OVERHAUSER_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 3.'
    stop
  end if

  if ( dim_num < 1 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_OVERHAUSER_VAL - Fatal error!'
    write ( *, '(a)' ) '  DIM_NUM < 1.'
    stop
  end if
!
!  Locate the abscissa interval T(LEFT), T(LEFT+1) nearest to or 
!  containing TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Evaluate the "left hand" quadratic defined at T(LEFT-1), T(LEFT), T(RIGHT).
!
  if ( 0 < left-1 ) then
    call parabola_val2 ( dim_num, ndata, tdata, ydata, left-1, tval, yl )
  end if
!
!  Evaluate the "right hand" quadratic defined at T(LEFT), T(RIGHT), T(RIGHT+1).
!
  if ( right+1 <= ndata ) then
    call parabola_val2 ( dim_num, ndata, tdata, ydata, left, tval, yr )
  end if
!
!  Average the quadratics.
!
  if ( left == 1 ) then

    yval(1:dim_num) = yr(1:dim_num)

  else if ( right < ndata ) then

    yval(1:dim_num) =  &
      ( ( tdata(right) - tval               ) * yl(1:dim_num)   &
      + (                tval - tdata(left) ) * yr(1:dim_num) ) &
      / ( tdata(right)        - tdata(left) )

  else

    yval(1:dim_num) = yl(1:dim_num)

  end if

  return
end
subroutine spline_pchip_set ( n, x, f, d )

!*****************************************************************************80
!
!! SPLINE_PCHIP_SET sets derivatives for a piecewise cubic Hermite interpolant.
!
!  Discussion:
!
!    This routine computes what would normally be called a Hermite 
!    interpolant.  However, the user is only required to supply function
!    values, not derivative values as well.  This routine computes
!    "suitable" derivative values, so that the resulting Hermite interpolant
!    has desirable shape and monotonicity properties.
!
!    The interpolant will have an extremum at each point where
!    monotonicity switches direction.
!
!    The resulting piecewise cubic Hermite function may be evaluated
!    by SPLINE_PCHIP_VAL.
!
!    This routine was originally named "PCHIM".
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 December 2008
!
!  Author:
!
!    Original FORTRAN77 version by Fred Fritsch.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Fred Fritsch, Ralph Carlson,
!    Monotone Piecewise Cubic Interpolation,
!    SIAM Journal on Numerical Analysis,
!    Volume 17, Number 2, April 1980, pages 238-246.
!
!    Fred Fritsch, Judy Butland,
!    A Method for Constructing Local Monotone Piecewise Cubic Interpolants,
!    SIAM Journal on Scientific and Statistical Computing,
!    Volume 5, Number 2, 1984, pages 300-304.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of data points.  N must be 
!    at least 2.
!
!    Input, real ( kind = 8 ) X(N), the strictly increasing independent
!    variable values.
!
!    Input, real ( kind = 8 ) F(N), dependent variable values to be
!    interpolated.  F(I) is the value corresponding to X(I).
!    This routine is designed for monotonic data, but it will work for any
!    F array.  It will force extrema at points where monotonicity switches
!    direction.
!
!    Output, real ( kind = 8 ) D(N), the derivative values at the
!    data points.  If the data are monotonic, these values will determine
!    a monotone cubic Hermite function.
!
  implicit none

  integer ( kind = 4 ) n

  real    ( kind = 8 ) d(n)
  real    ( kind = 8 ) del1
  real    ( kind = 8 ) del2
  real    ( kind = 8 ) dmax
  real    ( kind = 8 ) dmin
  real    ( kind = 8 ) drat1
  real    ( kind = 8 ) drat2
  real    ( kind = 8 ) dsave
  real    ( kind = 8 ) f(n)
  real    ( kind = 8 ) h1
  real    ( kind = 8 ) h2
  real    ( kind = 8 ) hsum
  real    ( kind = 8 ) hsumt3
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ierr
  integer ( kind = 4 ) nless1
  real    ( kind = 8 ) pchst
  real    ( kind = 8 ) temp
  real    ( kind = 8 ) w1
  real    ( kind = 8 ) w2
  real    ( kind = 8 ) x(n)
!
!  Check the arguments.
!
  if ( n < 2 ) then
    ierr = -1
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_PCHIP_SET - Fatal error!'
    write ( *, '(a)' ) '  Number of data points less than 2.'
    stop
  end if

  do i = 2, n
    if ( x(i) <= x(i-1) ) then
      ierr = -3
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLINE_PCHIP_SET - Fatal error!'
      write ( *, '(a)' ) '  X array not strictly increasing.'
      stop
    end if
  end do

  ierr = 0
  nless1 = n - 1
  h1 = x(2) - x(1)
  del1 = ( f(2) - f(1) ) / h1
  dsave = del1
!
!  Special case N=2, use linear interpolation.
!
  if ( n == 2 ) then
    d(1) = del1
    d(n) = del1
    return
  end if
!
!  Normal case, 3 <= N.
!
  h2 = x(3) - x(2)
  del2 = ( f(3) - f(2) ) / h2
!
!  Set D(1) via non-centered three point formula, adjusted to be
!  shape preserving.
!
  hsum = h1 + h2
  w1 = ( h1 + hsum ) / hsum
  w2 = -h1 / hsum
  d(1) = w1 * del1 + w2 * del2

  if ( pchst ( d(1), del1 ) <= 0.0D+00 ) then

    d(1) = 0.0D+00
!
!  Need do this check only if monotonicity switches.
!
  else if ( pchst ( del1, del2 ) < 0.0D+00 ) then

     dmax = 3.0D+00 * del1

     if ( abs ( dmax ) < abs ( d(1) ) ) then
       d(1) = dmax
     end if

  end if
!
!  Loop through interior points.
!
  do i = 2, nless1

    if ( 2 < i ) then
      h1 = h2
      h2 = x(i+1) - x(i)
      hsum = h1 + h2
      del1 = del2
      del2 = ( f(i+1) - f(i) ) / h2
    end if
!
!  Set D(I)=0 unless data are strictly monotonic.
!
    d(i) = 0.0D+00

    temp = pchst ( del1, del2 )

    if ( temp < 0.0D+00 ) then

      ierr = ierr + 1
      dsave = del2
!
!  Count number of changes in direction of monotonicity.
!
    else if ( temp == 0.0D+00 ) then

      if ( del2 /= 0.0D+00 ) then
        if ( pchst ( dsave, del2 ) < 0.0D+00 ) then
          ierr = ierr + 1
        end if
        dsave = del2
      end if
!
!  Use Brodlie modification of Butland formula.
!
    else

      hsumt3 = 3.0D+00 * hsum
      w1 = ( hsum + h1 ) / hsumt3
      w2 = ( hsum + h2 ) / hsumt3
      dmax = max ( abs ( del1 ), abs ( del2 ) )
      dmin = min ( abs ( del1 ), abs ( del2 ) )
      drat1 = del1 / dmax
      drat2 = del2 / dmax
      d(i) = dmin / ( w1 * drat1 + w2 * drat2 )

    end if

  end do
!
!  Set D(N) via non-centered three point formula, adjusted to be
!  shape preserving.
!
  w1 = -h2 / hsum
  w2 = ( h2 + hsum ) / hsum
  d(n) = w1 * del1 + w2 * del2

  if ( pchst ( d(n), del2 ) <= 0.0D+00 ) then
    d(n) = 0.0D+00
  else if ( pchst ( del1, del2 ) < 0.0D+00 ) then
!
!  Need do this check only if monotonicity switches.
!
    dmax = 3.0D+00 * del2

    if ( abs ( dmax ) < abs ( d(n) ) ) then
      d(n) = dmax
    end if

  end if

  return
end
subroutine spline_pchip_val ( n, x, f, d, ne, xe, fe )

!*****************************************************************************80
!
!! SPLINE_PCHIP_VAL evaluates a piecewise cubic Hermite function.
!
!  Description:
!
!    This routine may be used by itself for Hermite interpolation, or as an
!    evaluator for SPLINE_PCHIP_SET.
!
!    This routine evaluates the cubic Hermite function at the points XE.
!
!    Most of the coding between the call to CHFEV and the end of
!    the IR loop could be eliminated if it were permissible to
!    assume that XE is ordered relative to X.
!
!    CHFEV does not assume that X1 is less than X2.  Thus, it would
!    be possible to write a version of SPLINE_PCHIP_VAL that assumes a strictly
!    decreasing X array by simply running the IR loop backwards
!    and reversing the order of appropriate tests.
!
!    The present code has a minor bug, which I have decided is not
!    worth the effort that would be required to fix it.
!    If XE contains points in [X(N-1),X(N)], followed by points less than
!    X(N-1), followed by points greater than X(N), the extrapolation points
!    will be counted (at least) twice in the total returned in IERR.
!
!    The evaluation will be most efficient if the elements of XE are
!    increasing relative to X; that is, for all J <= K,
!      X(I) <= XE(J)
!    implies
!      X(I) <= XE(K).
!
!    If any of the XE are outside the interval [X(1),X(N)],
!    values are extrapolated from the nearest extreme cubic,
!    and a warning error is returned.
!
!    This routine was originally called "PCHFE".
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    14 August 2005
!
!  Author:
!
!    Original FORTRAN77 version by Fred Fritsch.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Fred Fritsch, Ralph Carlson, 
!    Monotone Piecewise Cubic Interpolation,
!    SIAM Journal on Numerical Analysis,
!    Volume 17, Number 2, April 1980, pages 238-246.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of data points.  N must be 
!    at least 2.
!
!    Input, real ( kind = 8 ) X(N), the strictly increasing independent
!    variable values.
!
!    Input, real ( kind = 8 ) F(N), the function values.
!
!    Input, real ( kind = 8 ) D(N), the derivative values.
!
!    Input, integer ( kind = 4 ) NE, the number of evaluation points.
!
!    Input, real ( kind = 8 ) XE(NE), points at which the function is to
!    be evaluated.
!
!    Output, real ( kind = 8 ) FE(NE), the values of the cubic Hermite
!    function at XE.
!
  implicit none

  integer ( kind = 4 ) n
  integer ( kind = 4 ) ne

  real    ( kind = 8 ) d(n)
  real    ( kind = 8 ) f(n)
  real    ( kind = 8 ) fe(ne)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ierc
  integer ( kind = 4 ) ierr
  integer ( kind = 4 ) ir
  integer ( kind = 4 ) j
  integer ( kind = 4 ) j_first
  integer ( kind = 4 ) j_new
  integer ( kind = 4 ) j_save
  integer ( kind = 4 ) next(2)
  integer ( kind = 4 ) nj
  real    ( kind = 8 ) x(n)
  real    ( kind = 8 ) xe(ne)
!
!  Check arguments.
!
  if ( n < 2 ) then
    ierr = -1
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_PCHIP_VAL - Fatal error!'
    write ( *, '(a)' ) '  Number of data points less than 2.'
    stop
  end if

  do i = 2, n
    if ( x(i) <= x(i-1) ) then
      ierr = -3
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLINE_PCHIP_VAL - Fatal error!'
      write ( *, '(a)' ) '  X array not strictly increasing.'
      stop
    end if
  end do

  if ( ne < 1 ) then
    ierr = -4
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_PCHIP_VAL - Fatal error!'
    write ( *, '(a)' ) '  Number of evaluation points less than 1.'
    return
  end if

  ierr = 0
!
!  Loop over intervals.
!  The interval index is IL = IR-1.
!  The interval is X(IL) <= X < X(IR).
!
  j_first = 1
  ir = 2

  do
!
!  Skip out of the loop if have processed all evaluation points.
!
    if ( ne < j_first ) then
      exit
    end if
!
!  Locate all points in the interval.
!
    j_save = ne + 1

    do j = j_first, ne
      if ( x(ir) <= xe(j) ) then
        j_save = j
        if ( ir == n ) then
          j_save = ne + 1
        end if
        exit
      end if
    end do
!
!  Have located first point beyond interval.
!
    j = j_save

    nj = j - j_first
!
!  Skip evaluation if no points in interval.
!
    if ( nj /= 0 ) then
!
!  Evaluate cubic at XE(J_FIRST:J-1).
!
      call chfev ( x(ir-1), x(ir), f(ir-1), f(ir), d(ir-1), d(ir), &
        nj, xe(j_first:j-1), fe(j_first:j-1), next, ierc )

      if ( ierc < 0 ) then
        ierr = -5
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'SPLINE_PCHIP_VAL - Fatal error!'
        write ( *, '(a)' ) '  Error return from CHFEV.'
        stop
      end if
!
!  In the current set of XE points, there are NEXT(2) to the right of X(IR).
!
      if ( next(2) /= 0 ) then

        if ( ir < n ) then
          ierr = -5
          write ( *, '(a)' ) ' '
          write ( *, '(a)' ) 'SPLINE_PCHIP_VAL - Fatal error!'
          write ( *, '(a)' ) '  IR < N.'
          stop
        end if
!
!  These are actually extrapolation points.
!
        ierr = ierr + next(2)

      end if
!
!  In the current set of XE points, there are NEXT(1) to the left of X(IR-1).
!
      if ( next(1) /= 0 ) then
!
!  These are actually extrapolation points.
!
        if ( ir <= 2 ) then
          ierr = ierr + next(1)
        else

          j_new = -1

          do i = j_first, j-1
            if ( xe(i) < x(ir-1) ) then
              j_new = i
              exit
            end if
          end do

          if ( j_new == -1 ) then
            ierr = -5
            write ( *, '(a)' ) ' '
            write ( *, '(a)' ) 'SPLINE_PCHIP_VAL - Fatal error!'
            write ( *, '(a)' ) '  Could not bracket the data point.'
            stop
          end if
!
!  Reset J.  This will be the new J_FIRST.
!
          j = j_new
!
!  Now find out how far to back up in the X array.
!
          do i = 1, ir-1
            if ( xe(j) < x(i) ) then
              exit
            end if
          end do
!
!  At this point, either XE(J) < X(1) or X(i-1) <= XE(J) < X(I) .
!
!  Reset IR, recognizing that it will be incremented before cycling.
!
          ir = max ( 1, i-1 )

        end if

      end if

      j_first = j

    end if

    ir = ir + 1

    if ( n < ir ) then
      exit
    end if

  end do

  return
end
subroutine spline_quadratic_val ( ndata, tdata, ydata, tval, yval, ypval )

!*****************************************************************************80
!
!! SPLINE_QUADRATIC_VAL evaluates a piecewise quadratic spline at a point.
!
!  Discussion:
!
!    Because of the simple form of a piecewise quadratic spline,
!    the raw data points ( TDATA(I), YDATA(I)) can be used directly to
!    evaluate the spline at any point.  No processing of the data
!    is required.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    24 October 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NDATA, the number of data points defining 
!    the spline.  NDATA should be odd and at least 3.
!
!    Input, real ( kind = 8 ) TDATA(NDATA), YDATA(NDATA), the values of 
!    the independent and dependent variables at the data points.  The 
!    values of TDATA should be distinct and increasing.
!
!    Input, real ( kind = 8 ) TVAL, the point at which the spline is to 
!    be evaluated.
!
!    Output, real ( kind = 8 ) YVAL, YPVAL, the value of the spline and 
!    its first derivative dYdT at TVAL.  YPVAL is not reliable if TVAL 
!    is exactly equal to TDATA(I) for some I.
!
  implicit none

  integer ( kind = 4 ) ndata

  real    ( kind = 8 ) dif1
  real    ( kind = 8 ) dif2
  integer ( kind = 4 ), parameter :: i4_2 = 2
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real    ( kind = 8 ) t1
  real    ( kind = 8 ) t2
  real    ( kind = 8 ) t3
  real    ( kind = 8 ) tdata(ndata)
  real    ( kind = 8 ) tval
  real    ( kind = 8 ) y1
  real    ( kind = 8 ) y2
  real    ( kind = 8 ) y3
  real    ( kind = 8 ) ydata(ndata)
  real    ( kind = 8 ) ypval
  real    ( kind = 8 ) yval

  if ( ndata < 3 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_QUADRATIC_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA < 3.'
    stop
  end if

  if ( mod ( ndata, i4_2 ) == 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_QUADRATIC_VAL - Fatal error!'
    write ( *, '(a)' ) '  NDATA must be odd.'
    stop
  end if
!
!  Find the interval [ TDATA(LEFT), TDATA(RIGHT) ] that contains, or is
!  nearest to, TVAL.
!
  call r8vec_bracket ( ndata, tdata, tval, left, right )
!
!  Force LEFT to be odd.
!
  if ( mod ( left, i4_2 ) == 0 ) then
    left = left - 1
  end if
!
!  Copy out the three abscissas.
!
  t1 = tdata(left)
  t2 = tdata(left+1)
  t3 = tdata(left+2)

  if ( t2 <= t1 .or. t3 <= t2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_QUADRATIC_VAL - Fatal error!'
    write ( *, '(a)' ) '  T2 <= T1 or T3 <= T2.'
    stop
  end if
!
!  Construct and evaluate a parabolic interpolant for the data
!  in each dimension.
!
  y1 = ydata(left)
  y2 = ydata(left+1)
  y3 = ydata(left+2)

  dif1 = ( y2 - y1 ) / ( t2 - t1 )

  dif2 = ( ( y3 - y1 ) / ( t3 - t1 ) &
       - ( y2 - y1 ) / ( t2 - t1 ) ) / ( t3 - t2 )

  yval = y1 + ( tval - t1 ) * ( dif1 + ( tval - t2 ) * dif2 )
  ypval = dif1 + dif2 * ( 2.0D+00 * tval - t1 - t2 )

  return
end
subroutine timestamp ( )

!*****************************************************************************80
!
!! TIMESTAMP prints the current YMDHMS date as a time stamp.
!
!  Example:
!
!    31 May 2001   9:45:54.872 AM
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    06 August 2005
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    None
!
  implicit none

  character ( len = 8 ) ampm
  integer ( kind = 4 ) d
  integer ( kind = 4 ) h
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mm
  character ( len = 9 ), parameter, dimension(12) :: month = (/ &
    'January  ', 'February ', 'March    ', 'April    ', &
    'May      ', 'June     ', 'July     ', 'August   ', &
    'September', 'October  ', 'November ', 'December ' /)
  integer ( kind = 4 ) n
  integer ( kind = 4 ) s
  integer ( kind = 4 ) values(8)
  integer ( kind = 4 ) y

  call date_and_time ( values = values )

  y = values(1)
  m = values(2)
  d = values(3)
  h = values(5)
  n = values(6)
  s = values(7)
  mm = values(8)

  if ( h < 12 ) then
    ampm = 'AM'
  else if ( h == 12 ) then
    if ( n == 0 .and. s == 0 ) then
      ampm = 'Noon'
    else
      ampm = 'PM'
    end if
  else
    h = h - 12
    if ( h < 12 ) then
      ampm = 'PM'
    else if ( h == 12 ) then
      if ( n == 0 .and. s == 0 ) then
        ampm = 'Midnight'
      else
        ampm = 'AM'
      end if
    end if
  end if

  write ( *, '(i2,1x,a,1x,i4,2x,i2,a1,i2.2,a1,i2.2,a1,i3.3,1x,a)' ) &
    d, trim ( month(m) ), y, h, ':', n, ':', s, '.', mm, trim ( ampm )

  return
end

!     Code for Anisotropies in the Microwave Background
!     by Antony Lewis (http://cosmologist.info/) and Anthony Challinor
!     See readme.html for documentation. This is a sample driver routine that reads
!     in one set of parameters and produdes the corresponding output. 

    program driver
        use IniFile
        use CAMB
        use LambdaGeneral
        use Lensing
        use AMLUtils
        use Transfer
        use constants
        use Bispectrum
        use CAMBmain
#ifdef NAGF95 
        use F90_UNIX
#endif
        implicit none
      
        Type(CAMBparams) P
        
        character(LEN=Ini_max_string_len) numstr, VectorFileName, &
            InputFile, ScalarFileName, TensorFileName, TotalFileName, LensedFileName,&
            LensedTotFileName, LensPotentialFileName
        integer i
        character(LEN=Ini_max_string_len) TransferFileNames(max_transfer_redshifts), &
               MatterPowerFileNames(max_transfer_redshifts), outroot, version_check
        real(dl) output_factor, nmassive

#ifdef WRITE_FITS
       character(LEN=Ini_max_string_len) FITSfilename
#endif

        logical bad

        InputFile = GetParam(1)
        if (InputFile == '') stop 'No parameter input file'

        call Ini_Open(InputFile, 1, bad, .false.)
        if (bad) stop 'Error opening parameter file'

        Ini_fail_on_not_found = .false.
    
        outroot = Ini_Read_String('output_root')
        if (outroot /= '') outroot = trim(outroot) // '_'
        
        call CAMB_SetDefParams(P)

        P%WantScalars = Ini_Read_Logical('get_scalar_cls')
        P%WantVectors = Ini_Read_Logical('get_vector_cls',.false.)
        P%WantTensors = Ini_Read_Logical('get_tensor_cls',.false.)
        
        P%OutputNormalization=outNone
        if (Ini_Read_Logical('COBE_normalize',.false.))  P%OutputNormalization=outCOBE
        output_factor = Ini_Read_Double('CMB_outputscale',1.d0)

        P%WantCls= P%WantScalars .or. P%WantTensors .or. P%WantVectors

        P%WantTransfer=Ini_Read_Logical('get_transfer')

        AccuracyBoost  = Ini_Read_Double('accuracy_boost',AccuracyBoost)
        lAccuracyBoost = Ini_Read_Real('l_accuracy_boost',lAccuracyBoost)
        HighAccuracyDefault = Ini_Read_Logical('high_accuracy_default',HighAccuracyDefault)
        
        P%NonLinear = Ini_Read_Int('do_nonlinear',NonLinear_none)
   
        P%DoLensing = .false.
        if (P%WantCls) then
          if (P%WantScalars  .or. P%WantVectors) then
           P%Max_l = Ini_Read_Int('l_max_scalar')
           P%Max_eta_k = Ini_Read_Double('k_eta_max_scalar',P%Max_l*2._dl)
           if (P%WantScalars) then
             P%DoLensing = Ini_Read_Logical('do_lensing',.false.)
             if (P%DoLensing) lensing_method = Ini_Read_Int('lensing_method',1)
           end if
           if (P%WantVectors) then
            if (P%WantScalars .or. P%WantTensors) stop 'Must generate vector modes on their own'
            i = Ini_Read_Int('vector_mode')
            if (i==0) then 
              vec_sig0 = 1
              Magnetic = 0
            else if (i==1) then
              Magnetic = -1
              vec_sig0 = 0
            else
              stop 'vector_mode must be 0 (regular) or 1 (magnetic)'
            end if 
           end if
          end if

          if (P%WantTensors) then
           P%Max_l_tensor = Ini_Read_Int('l_max_tensor')
           P%Max_eta_k_tensor =  Ini_Read_Double('k_eta_max_tensor',Max(500._dl,P%Max_l_tensor*2._dl))
          end if
        endif

                
!  Read initial parameters.
       
       call DarkEnergy_ReadParams(DefIni)

       P%h0     = Ini_Read_Double('hubble')
 
       if (Ini_Read_Logical('use_physical',.false.)) then 

        P%omegab = Ini_Read_Double('ombh2')/(P%H0/100)**2
        P%omegac = Ini_Read_Double('omch2')/(P%H0/100)**2
        P%omegan = Ini_Read_Double('omnuh2')/(P%H0/100)**2
        P%omegav = 1- Ini_Read_Double('omk') - P%omegab-P%omegac - P%omegan
  
       else
       
        P%omegab = Ini_Read_Double('omega_baryon')
        P%omegac = Ini_Read_Double('omega_cdm')
        P%omegav = Ini_Read_Double('omega_lambda')
        P%omegan = Ini_Read_Double('omega_neutrino')

       end if

       P%tcmb   = Ini_Read_Double('temp_cmb',COBE_CMBTemp)
       P%yhe    = Ini_Read_Double('helium_fraction',0.24_dl)
       P%Num_Nu_massless  = Ini_Read_Double('massless_neutrinos')
       nmassive = Ini_Read_Double('massive_neutrinos')
       !Store fractional numbers in the massless total
       P%Num_Nu_massive   = int(nmassive+1e-6)
       P%Num_Nu_massless  = P%Num_Nu_massless + nmassive-P%Num_Nu_massive
   
       P%nu_mass_splittings = .true.
       P%Nu_mass_eigenstates = Ini_Read_Int('nu_mass_eigenstates',1)
       if (P%Nu_mass_eigenstates > max_nu) stop 'too many mass eigenstates'
       numstr = Ini_Read_String('nu_mass_degeneracies')
       if (numstr=='') then
         P%Nu_mass_degeneracies(1)= 0
       else
        read(numstr,*) P%Nu_mass_degeneracies(1:P%Nu_mass_eigenstates)
       end if
       numstr = Ini_read_String('nu_mass_fractions')
       if (numstr=='') then
        P%Nu_mass_fractions(1)=1  
        if (P%Nu_mass_eigenstates >1) stop 'must give nu_mass_fractions for the eigenstates'
       else
        read(numstr,*) P%Nu_mass_fractions(1:P%Nu_mass_eigenstates)
       end if

       if (P%NonLinear==NonLinear_lens .and. P%DoLensing) then
          if (P%WantTransfer) &
             write (*,*) 'overriding transfer settings to get non-linear lensing'
          P%WantTransfer  = .true.
          call Transfer_SetForNonlinearLensing(P%Transfer)
          P%Transfer%high_precision=  Ini_Read_Logical('transfer_high_precision',.false.)
       
       else if (P%WantTransfer)  then
        P%Transfer%high_precision=  Ini_Read_Logical('transfer_high_precision',.false.)
        P%transfer%kmax          =  Ini_Read_Double('transfer_kmax')
        P%transfer%k_per_logint  =  Ini_Read_Int('transfer_k_per_logint')
        P%transfer%num_redshifts =  Ini_Read_Int('transfer_num_redshifts')
        
        transfer_interp_matterpower = Ini_Read_Logical('transfer_interp_matterpower ', transfer_interp_matterpower)
        transfer_power_var = Ini_read_int('transfer_power_var',transfer_power_var)
        if (P%transfer%num_redshifts > max_transfer_redshifts) stop 'Too many redshifts'
        do i=1, P%transfer%num_redshifts
             P%transfer%redshifts(i)  = Ini_Read_Double_Array('transfer_redshift',i,0._dl)
             transferFileNames(i)     = Ini_Read_String_Array('transfer_filename',i)
             MatterPowerFilenames(i)  = Ini_Read_String_Array('transfer_matterpower',i)
             
             if (TransferFileNames(i) == '') then
                 TransferFileNames(i) =  trim(numcat('transfer_',i))//'.dat' 
             end if
             if (MatterPowerFilenames(i) == '') then
                 MatterPowerFilenames(i) =  trim(numcat('matterpower_',i))//'.dat' 
             end if
             if (TransferFileNames(i)/= '') &
                   TransferFileNames(i) = trim(outroot)//TransferFileNames(i)
             if (MatterPowerFilenames(i) /= '') &
                 MatterPowerFilenames(i)=trim(outroot)//MatterPowerFilenames(i)
        end do


        P%transfer%kmax=P%transfer%kmax*(P%h0/100._dl)
                
       else
         P%transfer%high_precision = .false.
       endif
  
        Ini_fail_on_not_found = .false. 
        
        ALens = Ini_Read_Double('Alens',Alens)
  
        call Reionization_ReadParams(P%Reion, DefIni)
        call InitialPower_ReadParams(P%InitPower, DefIni, P%WantTensors) 
        call Recombination_ReadParams(P%Recomb, DefIni)
        if (Ini_HasKey('recombination')) then
         i = Ini_Read_Int('recombination',1)
         if (i/=1) stop 'recombination option deprecated'
        end if
        
        call Bispectrum_ReadParams(BispectrumParams, DefIni, outroot)
        
        if (P%WantScalars .or. P%WantTransfer) then
            P%Scalar_initial_condition = Ini_Read_Int('initial_condition',initial_adiabatic)
            if (P%Scalar_initial_condition == initial_vector) then
                P%InitialConditionVector=0
              numstr = Ini_Read_String('initial_vector',.true.)
              read (numstr,*) P%InitialConditionVector(1:initial_iso_neutrino_vel)
            end if
            if (P%Scalar_initial_condition/= initial_adiabatic) use_spline_template = .false.
        end if
        
       if (P%WantScalars) then
          ScalarFileName = trim(outroot)//Ini_Read_String('scalar_output_file')
          LensedFileName =  trim(outroot) //Ini_Read_String('lensed_output_file')
          LensPotentialFileName =  Ini_Read_String('lens_potential_output_file')
          if (LensPotentialFileName/='') LensPotentialFileName = concat(outroot,LensPotentialFileName)
        end if
        if (P%WantTensors) then
          TensorFileName =  trim(outroot) //Ini_Read_String('tensor_output_file')
         if (P%WantScalars)  then
          TotalFileName =  trim(outroot) //Ini_Read_String('total_output_file')
          LensedTotFileName = Ini_Read_String('lensed_total_output_file')
          if (LensedTotFileName/='') LensedTotFileName= trim(outroot) //trim(LensedTotFileName)
         end if
        end if
        if (P%WantVectors) then
          VectorFileName =  trim(outroot) //Ini_Read_String('vector_output_file')
        end if
         
#ifdef WRITE_FITS
        if (P%WantCls) then
        FITSfilename =  trim(outroot) //Ini_Read_String('FITS_filename',.true.)
        if (FITSfilename /='') then
        inquire(file=FITSfilename, exist=bad)
        if (bad) then
         open(unit=18,file=FITSfilename,status='old')
         close(18,status='delete')
        end if
       end if
        end if
#endif        
       

       Ini_fail_on_not_found = .false. 

!optional parameters controlling the computation

       P%AccuratePolarization = Ini_Read_Logical('accurate_polarization',.true.)
       P%AccurateReionization = Ini_Read_Logical('accurate_reionization',.false.)
       P%AccurateBB = Ini_Read_Logical('accurate_BB',.false.)
       P%DerivedParameters = Ini_Read_Logical('derived_parameters',.true.)

       version_check = Ini_Read_String('version_check')
       if (version_check == '') then
          !tag the output used parameters .ini file with the version of CAMB being used now
           call TNameValueList_Add(DefIni%ReadValues, 'version_check', version)
       else if (version_check /= version) then
           write(*,*) 'WARNING: version_check does not match this CAMB version'
        end if
       !Mess here to fix typo with backwards compatibility
       if (Ini_HasKey('do_late_rad_trunction')) then
         DoLateRadTruncation = Ini_Read_Logical('do_late_rad_trunction',.true.)
         if (Ini_HasKey('do_late_rad_truncation')) stop 'check do_late_rad_xxxx'
       else
        DoLateRadTruncation = Ini_Read_Logical('do_late_rad_truncation',.true.)
       end if
       DoTensorNeutrinos = Ini_Read_Logical('do_tensor_neutrinos',DoTensorNeutrinos )
       FeedbackLevel = Ini_Read_Int('feedback_level',FeedbackLevel)
       
       P%MassiveNuMethod  = Ini_Read_Int('massive_nu_approx',Nu_best)

       ThreadNum      = Ini_Read_Int('number_of_threads',ThreadNum)
       use_spline_template = Ini_Read_Logical('use_spline_template',use_spline_template)
       if (HighAccuracyDefault) then
         P%Max_eta_k=max(min(P%max_l,3000)*2.5_dl,P%Max_eta_k)
       end if
       DoTensorNeutrinos = DoTensorNeutrinos .or. HighAccuracyDefault
       if (do_bispectrum) then
        lSampleBoost   = 50
       else
        lSampleBoost   = Ini_Read_Double('l_sample_boost',lSampleBoost)
       end if
       if (outroot /= '') then
         if (InputFile /= trim(outroot) //'params.ini') then   
          call Ini_SaveReadValues(trim(outroot) //'params.ini',1)
         else
          write(*,*) 'Output _params.ini not created as would overwrite input'    
         end if
       end if

       call Ini_Close

       if (.not. CAMB_ValidateParams(P)) stop 'Stopped due to parameter error'

#ifdef RUNIDLE
       call SetIdle
#endif 

       if (global_error_flag==0) call CAMB_GetResults(P)
       if (global_error_flag/=0) then
        write (*,*) 'Error result '//trim(global_error_message)
        stop
       endif
    
        if (P%WantTransfer .and. .not. (P%NonLinear==NonLinear_lens .and. P%DoLensing)) then
         call Transfer_SaveToFiles(MT,TransferFileNames)
         call Transfer_SaveMatterPower(MT,MatterPowerFileNames)
         if ((P%OutputNormalization /= outCOBE) .or. .not. P%WantCls)  call Transfer_output_sig8(MT)
        end if

        if (P%WantCls) then
  
         if (P%OutputNormalization == outCOBE) then

            if (P%WantTransfer) call Transfer_output_Sig8AndNorm(MT)
           
          end if

         call output_cl_files(ScalarFileName, TensorFileName, TotalFileName, &
              LensedFileName, LensedTotFilename, output_factor)
              
         call output_lens_pot_files(LensPotentialFileName, output_factor)

         if (P%WantVectors) then
           call output_veccl_files(VectorFileName, output_factor)
         end if


#ifdef WRITE_FITS
         if (FITSfilename /= '') call WriteFitsCls(FITSfilename, CP%Max_l)
#endif
        end if

        call CAMB_cleanup             
  
        end program driver


#ifdef RUNIDLE
 !If in Windows and want to run with low priorty so can multitask
   subroutine SetIdle
    USE DFWIN
    Integer dwPriority 
    Integer CheckPriority

    dwPriority = 64 ! idle priority
    CheckPriority = SetPriorityClass(GetCurrentProcess(), dwPriority)

   end subroutine SetIdle
#endif

! Equations module for dark energy with constant equation of state parameter w
! allowing for perturbations based on a quintessence model
! by Antony Lewis (http://cosmologist.info/)

! Dec 2003, fixed (fatal) bug in tensor neutrino setup
! Changes to tight coupling approximation
! June 2004, fixed problem with large scale polarized tensors; support for vector modes
! Generate vector modes on their own. The power spectrum is taken from the scalar parameters.
! August 2004, fixed reionization term in lensing potential
! Nov 2004, change massive neutrino l_max to be consistent with massless if light
! Apr 2005, added DoLateRadTruncation option
! June 2006, added support for arbitary neutrino mass splittings
! Nov 2006, tweak to high_precision transfer function accuracy at lowish k
! June 2011, improved radiation approximations from arXiv: 1104.2933; Some 2nd order tight coupling terms
!            merged fderivs and derivs so flat and non-flat use same equations; more precomputed arrays
!            optimized neutrino sampling, and reorganised neutrino integration functions
! Feb 2012, updated PPF version but now only simple case for w, w_a (no anisotropic stresses etc)
! Feb 2013: fixed various issues with accuracy at larger neutrino masses

      module LambdaGeneral
         use precision
         use  ModelParams
         implicit none
 
         real(dl)  :: w_lam = -1_dl !p/rho for the dark energy (assumed constant) 
! w_lam is now w0
!comoving sound speed. Always exactly 1 for quintessence 
!(otherwise assumed constant, though this is almost certainly unrealistic)
         real(dl) :: cs2_lam = 1_dl 
!cs2_lam now is ce^2

         logical :: use_tabulated_w = .false.
         real(dl) :: wa_ppf = 0._dl
         real(dl) :: c_Gamma_ppf = 0.4_dl
         integer, parameter :: nwmax = 5000, nde = 2000
         integer :: nw_ppf
         real(dl) w_ppf(nwmax), a_ppf(nwmax), ddw_ppf(nwmax) 
         real(dl) rde(nde),ade(nde),ddrde(nde)
         real(dl), parameter :: amin = 1.d-9
         logical :: is_cosmological_constant
         private nde,ddw_ppf,rde,ade,ddrde,amin
      contains

       subroutine DarkEnergy_ReadParams(Ini)
        use IniFile 
        Type(TIniFile) :: Ini
        character(LEN=Ini_max_string_len) wafile
        integer i

           if (Ini_HasKey_File(Ini,'usew0wa')) then
            stop 'input variables changed from usew0wa: now use_tabulated_w or w, wa'
           end if
              
           use_tabulated_w = Ini_Read_Logical_File(Ini,'use_tabulated_w',.false.) 
           if(.not. use_tabulated_w)then
               w_lam = Ini_Read_Double_File(Ini,'w', -1.d0)   
               wa_ppf = Ini_Read_Double_File(Ini,'wa', 0.d0)
               if (Feedback >0) write(*,'("(w0, wa) = (", f8.5,", ", f8.5, ")")') w_lam,wa_ppf
           else 
              wafile = Ini_Read_String_File(Ini,'wafile')    
              open(unit=10,file=wafile,status='old')
              nw_ppf=0
              do i=1,nwmax+1
                 read(10,*,end=100)a_ppf(i),w_ppf(i)  
                 a_ppf(i)=dlog(a_ppf(i))
                 nw_ppf=nw_ppf+1
              enddo 
              write(*,'("Note: ", a, " has more than ", I8, " data points")') trim(wafile), nwmax
              write(*,*)'Increase nwmax in LambdaGeneral'
              stop
    100       close(10)
              write(*,'("read in ", I8, " (a, w) data points from ", a)') nw_ppf, trim(wafile)
              call setddwa
              call interpolrde
           endif
           cs2_lam = Ini_Read_Double_File(Ini,'cs2_lam',1.d0)
           call setcgammappf
           
       end subroutine DarkEnergy_ReadParams


         subroutine setddwa
         real(dl), parameter :: wlo=1.d30, whi=1.d30

         call spline(a_ppf,w_ppf,nw_ppf,wlo,whi,ddw_ppf) !a_ppf is lna here

         end subroutine setddwa


         function w_de(a)
         real(dl) :: w_de, al
         real(dl), intent(IN) :: a

         if(.not. use_tabulated_w) then
            w_de=w_lam+wa_ppf*(1._dl-a)
         else
            al=dlog(a)
            if(al.lt.a_ppf(1)) then
                w_de=w_ppf(1)                   !if a < minimum a from wa.dat
            elseif(al.gt.a_ppf(nw_ppf)) then
                w_de=w_ppf(nw_ppf)              !if a > maximus a from wa.dat
            else
                call cubicsplint(a_ppf,w_ppf,ddw_ppf,nw_ppf,al,w_de)
        endif
         endif
         end function w_de  ! equation of state of the PPF DE 


         function drdlna_de(al)
         real(dl) :: drdlna_de, a
         real(dl), intent(IN) :: al

         a=dexp(al)
         drdlna_de=3._dl*(1._dl+w_de(a)) 
        
         end function drdlna_de


         subroutine interpolrde
         real(dl), parameter :: rlo=1.d30, rhi=1.d30
         real(dl) :: atol, almin, al, rombint, fint
         integer :: i
         external rombint
         atol=1.d-5
         almin=dlog(amin)        
         do i=1,nde
            al=almin-almin/(nde-1)*(i-1)    !interpolate between amin and today
            fint=rombint(drdlna_de, al, 0._dl, atol)+4._dl*al  
            ade(i)=al
            rde(i)=dexp(fint) !rho_de*a^4 normalize to its value at today
         enddo
         call spline(ade,rde,nde,rlo,rhi,ddrde)
         end subroutine interpolrde
      
         function grho_de(a)  !8 pi G a^4 rho_de
         real(dl) :: grho_de, al, fint
         real(dl), intent(IN) :: a
         external rombint 
         
         if(.not. use_tabulated_w) then
            grho_de=grhov*a**(1._dl-3.*w_lam-3.*wa_ppf)*exp(-3.*wa_ppf*(1._dl-a)) 
         else
            if(a.eq.0.d0)then
               grho_de=0.d0      !assume rho_de*a^4-->0, when a-->0, OK if w_de always <0.
            else
               al=dlog(a)
               if(al.lt.ade(1))then
                  fint=rde(1)*(a/amin)**(1.-3.*w_de(amin))    !if a<amin, assume here w=w_de(amin)  
               else              !if amin is small enough, this extrapolation will be unnecessary.
                  call cubicsplint(ade,rde,ddrde,nde,al,fint)
               endif
               grho_de=grhov*fint
            endif
         endif
         end function grho_de

!-------------------------------------------------------------------
        SUBROUTINE cubicsplint(xa,ya,y2a,n,x,y)
        INTEGER n
        real(dl)x,y,xa(n),y2a(n),ya(n)
        INTEGER k,khi,klo
        real(dl)a,b,h
        klo=1
        khi=n
1       if (khi-klo.gt.1) then
          k=(khi+klo)/2
          if(xa(k).gt.x)then
            khi=k
          else
            klo=k
          endif
        goto 1
        endif
        h=xa(khi)-xa(klo)
        if (h.eq.0.) stop 'bad xa input in splint'
        a=(xa(khi)-x)/h
        b=(x-xa(klo))/h
        y=a*ya(klo)+b*ya(khi)+&
       ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.d0
        END SUBROUTINE cubicsplint
!--------------------------------------------------------------------
 
         
        subroutine setcgammappf

        c_Gamma_ppf=0.4d0*sqrt(cs2_lam)

        end subroutine setcgammappf

 
        end module LambdaGeneral

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    
!Return OmegaK - modify this if you add extra fluid components
        function GetOmegak()
        use precision
        use ModelParams
        real(dl)  GetOmegak
         GetOmegak = 1 - (CP%omegab+CP%omegac+CP%omegav+CP%omegan) 
          
        end function GetOmegak
  
  
       subroutine init_background
        use LambdaGeneral
         !This is only called once per model, and is a good point to do any extra initialization.
         !It is called before first call to dtauda, but after
         !massive neutrinos are initialized and after GetOmegak
         is_cosmological_constant = .not. use_tabulated_w .and. w_lam==-1_dl .and. wa_ppf==0._dl
       end  subroutine init_background


!Background evolution
        function dtauda(a)
         !get d tau / d a
        use precision
        use ModelParams
        use MassiveNu
        use LambdaGeneral
        implicit none
        real(dl) dtauda
        real(dl), intent(IN) :: a
        real(dl) rhonu,grhoa2, a2
        integer nu_i
       
        a2=a**2

!  8*pi*G*rho*a**4.
        grhoa2=grhok*a2+(grhoc+grhob)*a+grhog+grhornomass
         if (is_cosmological_constant) then
           grhoa2=grhoa2+grhov*a2**2
         else
           grhoa2=grhoa2+ grho_de(a)
         end if

        if (CP%Num_Nu_massive /= 0) then
!Get massive neutrino density relative to massless
           do nu_i = 1, CP%nu_mass_eigenstates
            call Nu_rho(a*nu_masses(nu_i),rhonu)
            grhoa2=grhoa2+rhonu*grhormass(nu_i)
           end do
        end if

        dtauda=sqrt(3/grhoa2)
     
        end function dtauda

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!Gauge-dependent perturbation equations

        module GaugeInterface
        use precision
        use ModelParams
        use MassiveNu
        use LambdaGeneral
        use Errors
        implicit none
        public

        !Description of this file. Change if you make modifications.
        character(LEN=*), parameter :: Eqns_name = 'crossing_ppf'

        integer, parameter :: basic_num_eqns = 5
          
        logical :: DoTensorNeutrinos = .false.
        
        logical :: DoLateRadTruncation = .true.
            !if true, use smooth approx to radition perturbations after decoupling on 
            !small scales, saving evolution of irrelevant osciallatory multipole equations

        logical, parameter :: second_order_tightcoupling = .true.

        real(dl) :: Magnetic = 0._dl
            !Vector mode anisotropic stress in units of rho_gamma
        real(dl) :: vec_sig0 = 1._dl
            !Vector mode shear      
        integer, parameter :: max_l_evolve = 1024 !Maximum l we are ever likely to propagate

        !Supported scalar initial condition flags
         integer, parameter :: initial_adiabatic=1, initial_iso_CDM=2, &
         initial_iso_baryon=3,  initial_iso_neutrino=4, initial_iso_neutrino_vel=5, initial_vector = 0
         integer, parameter :: initial_nummodes =  initial_iso_neutrino_vel

        type EvolutionVars
            real(dl) q, q2
            real(dl) k_buf,k2_buf ! set in initial

            integer w_ix !Index of two quintessence equations
            integer r_ix !Index of the massless neutrino hierarchy
            integer g_ix !Index of the photon neutrino hierarchy
            
            integer q_ix !index into q_evolve array that gives the value q
            logical TransferOnly

    !       nvar  - number of scalar (tensor) equations for this k       
            integer nvar,nvart, nvarv

           !Max_l for the various hierarchies
            integer lmaxg,lmaxnr,lmaxnu,lmaxgpol,MaxlNeeded
            integer lmaxnrt, lmaxnut, lmaxt, lmaxpolt, MaxlNeededt
            logical EvolveTensorMassiveNu(max_nu)
            integer lmaxnrv, lmaxv, lmaxpolv

            integer polind  !index into scalar array of polarization hierarchy

    !array indices for massive neutrino equations
            integer nu_ix(max_nu), nu_pert_ix
            integer nq(max_nu), lmaxnu_pert
            logical has_nu_relativistic

    !Initial values for massive neutrino v*3 variables calculated when switching 
    !to non-relativistic approx
            real(dl) G11(max_nu),G30(max_nu)
    !True when using non-relativistic approximation
            logical MassiveNuApprox(max_nu)
            real(dl) MassiveNuApproxTime(max_nu)

    !True when truncating at l=2,3 when k*tau>>1 (see arXiv:1104.2933)       
            logical high_ktau_neutrino_approx

    !Massive neutrino scheme being used at the moment        
            integer NuMethod

    !True when using tight-coupling approximation (required for stability at early times)
            logical TightCoupling, TensTightCoupling
            real(dl) TightSwitchoffTime
  
    !Numer of scalar equations we are propagating
            integer ScalEqsToPropagate
            integer TensEqsToPropagate
    !beta > l for closed models 
            integer FirstZerolForBeta
    !Tensor vars
            real(dl) aux_buf

            real(dl) pig, pigdot !For tight coupling
            real(dl) poltruncfac

            !PPF parameters  
            real(dl) dgrho_e_ppf, dgq_e_ppf
            real(dl) dgrhoec_ppf, dgqec_ppf, vTc_ppf 
            
            logical no_nu_multpoles, no_phot_multpoles 
            integer lmaxnu_tau(max_nu)  !lmax for massive neutinos at time being integrated
            logical nu_nonrelativistic(max_nu)
             
            real(dl) denlk(max_l_evolve),denlk2(max_l_evolve), polfack(max_l_evolve)
            real(dl) Kf(max_l_evolve)  

            integer E_ix, B_ix !tensor polarization indices
            real(dl) denlkt(4,max_l_evolve),Kft(max_l_evolve) 
        end type EvolutionVars

!precalculated arrays
        real(dl) polfac(max_l_evolve),denl(max_l_evolve),vecfac(max_l_evolve),vecfacpol(max_l_evolve) 
        
       real(dl), parameter :: ep0=1.0d-2 
       integer, parameter :: lmaxnu_high_ktau=3

       real(dl) epsw
       real(dl) nu_tau_notmassless(nqmax0+1,max_nu), nu_tau_nonrelativistic(max_nu),nu_tau_massive(max_nu)  
       contains


        subroutine GaugeInterface_ScalEv(EV,y,tau,tauend,tol1,ind,c,w)
         type(EvolutionVars) EV
         real(dl) c(24),w(EV%nvar,9), y(EV%nvar), tol1, tau, tauend
         integer ind
            
            call dverk(EV,EV%ScalEqsToPropagate,derivs,tau,y,tauend,tol1,ind,c,EV%nvar,w)
            if (ind==-3) then
             call GlobalError('Dverk error -3: the subroutine was unable  to  satisfy  the  error ' &
                           //'requirement  with a particular step-size that is less than or * ' &
                           //'equal to hmin, which may mean that tol is too small' &
                           //'--- but most likely you''ve messed up the y array indexing; ' &
                      //'compiling with bounds checking may (or may not) help find the problem.',error_evolution)     
            end if
        end subroutine GaugeInterface_ScalEv
        
        function next_nu_nq(nq) result (next_nq)
         integer, intent(in) :: nq
         integer q, next_nq
        
         if (nq==0) then
         next_nq=1
         else
         q = nu_q(nq)         
         if (q>=10) then
           next_nq = nqmax
         else
           next_nq = nq+1
         end if
         end if
        
        end function next_nu_nq

         recursive subroutine GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
         use ThermoData
         type(EvolutionVars) EV, EVout
         real(dl) c(24),w(EV%nvar,9), y(EV%nvar), yout(EV%nvar), tol1, tau, tauend
         integer ind, nu_i
         real(dl) cs2, opacity, dopacity
         real(dl) tau_switch_ktau, tau_switch_nu_massless, tau_switch_nu_massive, next_switch
         real(dl) tau_switch_no_nu_multpoles, tau_switch_no_phot_multpoles,tau_switch_nu_nonrel
         real(dl) noSwitch, smallTime

         noSwitch= CP%tau0+1
         smallTime =  min(tau, 1/EV%k_buf)/100

         tau_switch_ktau = noSwitch
         tau_switch_no_nu_multpoles= noSwitch
         tau_switch_no_phot_multpoles= noSwitch
         
         !Massive neutrino switches
         tau_switch_nu_massless = noSwitch
         tau_switch_nu_nonrel = noSwitch
         tau_switch_nu_massive= noSwitch

         !Evolve equations from tau to tauend, performing switches in equations if necessary.
          
          if (.not. EV%high_ktau_neutrino_approx .and. .not. EV%no_nu_multpoles ) then
            tau_switch_ktau=  max(20, EV%lmaxnr-4)/EV%k_buf
          end if          

         if (CP%Num_Nu_massive /= 0) then
          do nu_i = 1, CP%Nu_mass_eigenstates       
            if (EV%nq(nu_i) /= nqmax) then
              tau_switch_nu_massless = min(tau_switch_nu_massless,nu_tau_notmassless(next_nu_nq(EV%nq(nu_i)),nu_i))
            else if (.not. EV%nu_nonrelativistic(nu_i)) then
              tau_switch_nu_nonrel = min(nu_tau_nonrelativistic(nu_i),tau_switch_nu_nonrel)            
            else if (EV%NuMethod==Nu_trunc .and..not. EV%MassiveNuApprox(nu_i)) then
              tau_switch_nu_massive = min(tau_switch_nu_massive,EV%MassiveNuApproxTime(nu_i)) 
            end if   
          end do        
         end if
         
         if (DoLateRadTruncation) then
          
          if (.not. EV%no_nu_multpoles) & !!.and. .not. EV%has_nu_relativistic .and. tau_switch_nu_massless ==noSwitch)  &
               tau_switch_no_nu_multpoles=max(15/EV%k_buf*AccuracyBoost,min(taurend,matter_verydom_tau)) 
          
          if (.not. EV%no_phot_multpoles .and. (.not.CP%WantCls .or. EV%k_buf>0.03*AccuracyBoost)) &
               tau_switch_no_phot_multpoles =max(15/EV%k_buf,taurend)*AccuracyBoost 
         end if          
         
         next_switch = min(tau_switch_ktau, tau_switch_nu_massless,EV%TightSwitchoffTime, tau_switch_nu_massive, &
               tau_switch_no_nu_multpoles, tau_switch_no_phot_multpoles, tau_switch_nu_nonrel,noSwitch)
         
         if (next_switch < tauend) then
             if (next_switch > tau+smallTime) then
                call GaugeInterface_ScalEv(EV, y, tau,next_switch,tol1,ind,c,w)
                if (global_error_flag/=0) return
             end if
   
             EVout=EV
          
            if (next_switch == EV%TightSwitchoffTime) then 
              !TightCoupling           
                 EVout%TightCoupling=.false.
                 EVout%TightSwitchoffTime = noSwitch
                 call SetupScalarArrayIndices(EVout)
                 call CopyScalarVariableArray(y,yout, EV, EVout)
                 EV=EVout
                 y=yout
                 ind=1
               !Set up variables with their tight coupling values
                 y(EV%g_ix+2) = EV%pig
                 call thermo(tau,cs2,opacity,dopacity)

                 if (second_order_tightcoupling) then
                 ! Francis-Yan Cyr-Racine November 2010
                 
                 y(EV%g_ix+3) = (3._dl/7._dl)*y(EV%g_ix+2)*(EV%k_buf/opacity)*(1._dl+dopacity/opacity**2) + &
                      (3._dl/7._dl)*EV%pigdot*(EV%k_buf/opacity**2)*(-1._dl)
                
                 y(EV%polind+2) = EV%pig/4 + EV%pigdot*(1._dl/opacity)*(-5._dl/8._dl- &
                      (25._dl/16._dl)*dopacity/opacity**2) + &
                      EV%pig*(EV%k_buf/opacity)**2*(-5._dl/56._dl)  
                 y(EV%polind+3) = (3._dl/7._dl)*(EV%k_buf/opacity)*y(EV%polind+2)*(1._dl + &
                     dopacity/opacity**2) + (3._dl/7._dl)*(EV%k_buf/opacity**2)*((EV%pigdot/4._dl)* &
                      (1._dl+(5._dl/2._dl)*dopacity/opacity**2))*(-1._dl)

                 else  
                
                 y(EV%g_ix+3) = 3./7*y(EV%g_ix+2)*EV%k_buf/opacity
                 y(EV%polind+2) = EV%pig/4   
                 y(EV%polind+3) =y(EV%g_ix+3)/4 
                 end if
                 
           else if (next_switch==tau_switch_ktau) then
            !k tau >> 1, evolve massless neutrino effective fluid up to l=2
                EVout%high_ktau_neutrino_approx=.true.
                EV%nq(1:CP%Nu_mass_eigenstates) = nqmax               
                call SetupScalarArrayIndices(EVout)
                call CopyScalarVariableArray(y,yout, EV, EVout)
                y=yout
                EV=EVout
           else if (next_switch == tau_switch_nu_massless) then
             !Mass starts to become important, start evolving next momentum mode
              do nu_i = 1, CP%Nu_mass_eigenstates       
                 if (EV%nq(nu_i) /= nqmax .and. &
                   next_switch == nu_tau_notmassless(next_nu_nq(EV%nq(nu_i)),nu_i)) then
                     EVOut%nq(nu_i) = next_nu_nq(EV%nq(nu_i))
                     call SetupScalarArrayIndices(EVout)
                     call CopyScalarVariableArray(y,yout, EV, EVout)
                     EV=EVout
                     y=yout
                     exit 
                end if
              end do
           else if (next_switch == tau_switch_nu_nonrel) then
              !Neutrino becomes non-relativistic, don't need high L              
              do nu_i = 1, CP%Nu_mass_eigenstates       
                if (.not. EV%nu_nonrelativistic(nu_i) .and.  next_switch==nu_tau_nonrelativistic(nu_i) ) then
                     EVout%nu_nonrelativistic(nu_i)=.true.
                     call SetupScalarArrayIndices(EVout)
                     call CopyScalarVariableArray(y,yout, EV, EVout)
                     EV=EVout
                     y=yout
                     exit 
                end if
              end do
           else if (next_switch == tau_switch_nu_massive) then
            !Very non-relativistic neutrinos, switch to truncated velocity-weight hierarchy
              do nu_i = 1, CP%Nu_mass_eigenstates       
                if (.not. EV%MassiveNuApprox(nu_i) .and.  next_switch== EV%MassiveNuApproxTime(nu_i) ) then
                     call SwitchToMassiveNuApprox(EV,y, nu_i)
                     exit
                end if
              end do
           else if (next_switch==tau_switch_no_nu_multpoles) then
           !Turn off neutrino hierarchies at late time where slow and not needed.
                 ind=1
                 EVout%no_nu_multpoles=.true.
                 EVOut%nq(1:CP%Nu_mass_eigenstates ) = nqmax                 
                 call SetupScalarArrayIndices(EVout)
                 call CopyScalarVariableArray(y,yout, EV, EVout)
                 y=yout
                 EV=EVout 
           else if (next_switch==tau_switch_no_phot_multpoles) then
           !Turn off photon hierarchies at late time where slow and not needed.
                 ind=1
                 EVout%no_phot_multpoles=.true.
                 call SetupScalarArrayIndices(EVout)
                 call CopyScalarVariableArray(y,yout, EV, EVout)
                 y=yout
                 EV=EVout      
           end if       
    
           call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
           return           
         
         end if
         
         call GaugeInterface_ScalEv(EV,y,tau,tauend,tol1,ind,c,w)
        
        end subroutine GaugeInterface_EvolveScal

         subroutine GaugeInterface_EvolveTens(EV,tau,y,tauend,tol1,ind,c,w)
         use ThermoData
         type(EvolutionVars) EV, EVOut
         real(dl) c(24),w(EV%nvart,9), y(EV%nvart),yout(EV%nvart), tol1, tau, tauend
         integer ind
         real(dl) opacity, cs2
         
           if (EV%TensTightCoupling .and. tauend > EV%TightSwitchoffTime) then
            if (EV%TightSwitchoffTime > tau) then
             call dverk(EV,EV%TensEqsToPropagate, derivst,tau,y,EV%TightSwitchoffTime,tol1,ind,c,EV%nvart,w)
            end if
            EVOut=EV
            EVOut%TensTightCoupling = .false.
            call SetupTensorArrayIndices(EVout)
            call CopyTensorVariableArray(y,yout,Ev, Evout)
            Ev = EvOut
            y=yout
            call thermo(tau,cs2,opacity)
            y(EV%g_ix+2)= 32._dl/45._dl*EV%k_buf/opacity*y(3)
            y(EV%E_ix+2) = y(EV%g_ix+2)/4
           end if
 
           call dverk(EV,EV%TensEqsToPropagate, derivst,tau,y,tauend,tol1,ind,c,EV%nvart,w)
 
         
         end subroutine GaugeInterface_EvolveTens

 
        subroutine GaugeInterface_Init
          !Precompute various arrays and other things independent of wavenumber
          integer j, nu_i
          real(dl) a_nonrel, a_mass,a_massive, time

          epsw = 100/CP%tau0
         
          if (CP%WantScalars) then
            do j=2,max_l_evolve
              polfac(j)=real((j+3)*(j-1),dl)/(j+1)
            end do               
          end if
      
          if (CP%WantVectors) then
            do j=2,max_l_evolve
             vecfac(j)=real((j+2),dl)/(j+1)
             vecfacpol(j)=real((j+3)*j,dl)*(j-1)*vecfac(j)/(j+1)**2
           end do
   
          end if
    
         do j=1,max_l_evolve
           denl(j)=1._dl/(2*j+1)
         end do     
    
         do nu_i=1, CP%Nu_Mass_eigenstates
            a_mass =  1.e-1_dl/nu_masses(nu_i)/lAccuracyBoost
            !if (HighAccuracyDefault) a_mass=a_mass/4
            time=DeltaTime(0._dl,nu_q(1)*a_mass)
            nu_tau_notmassless(1, nu_i) = time
            do j=2,nqmax
             !times when each momentum mode becomes signficantly nonrelativistic
             time= time + DeltaTime(nu_q(j-1)*a_mass,nu_q(j)*a_mass, 0.01_dl)
             nu_tau_notmassless(j, nu_i) = time
            end do
            
            a_nonrel =  2.5d0/nu_masses(nu_i)*AccuracyBoost !!!Feb13tweak
            nu_tau_nonrelativistic(nu_i) =DeltaTime(0._dl,a_nonrel) 
            a_massive =  17.d0/nu_masses(nu_i)*AccuracyBoost 
            nu_tau_massive(nu_i) =nu_tau_nonrelativistic(nu_i) + DeltaTime(a_nonrel,a_massive) 
            
         end do 
       
        end subroutine GaugeInterface_Init


        subroutine SetupScalarArrayIndices(EV, max_num_eqns)
          !Set up array indices after the lmax have been decided
          use MassiveNu
          !Set the numer of equations in each hierarchy, and get total number of equations for this k
          type(EvolutionVars) EV
          integer, intent(out), optional :: max_num_eqns
          integer neq, maxeq, nu_i
          
          neq=basic_num_eqns
          maxeq=neq 
          if (.not. EV%no_phot_multpoles) then
           !Photon multipoles
           EV%g_ix=basic_num_eqns+1
           if (EV%TightCoupling) then
             neq=neq+2
            else 
             neq = neq+ (EV%lmaxg+1)
            !Polarization multipoles
             EV%polind = neq -1 !polind+2 is L=2, for polarizationthe first calculated         
             neq=neq + EV%lmaxgpol-1
           end if
          end if
          if (.not. EV%no_nu_multpoles) then
           !Massless neutrino multipoles
           EV%r_ix= neq+1   
           if (EV%high_ktau_neutrino_approx) then
            neq=neq + 3
           else
            neq=neq + (EV%lmaxnr+1)
           end if 
          end if          
          maxeq = maxeq +  (EV%lmaxg+1)+(EV%lmaxnr+1)+EV%lmaxgpol-1

          !Dark energy
          if (.not. is_cosmological_constant) then
            EV%w_ix = neq+1 
            neq=neq+1 !ppf
            maxeq=maxeq+1
          else
            EV%w_ix=0
          end if

         !Massive neutrinos 
         if (CP%Num_Nu_massive /= 0) then

           EV%has_nu_relativistic = any(EV%nq(1:CP%Nu_Mass_eigenstates)/=nqmax)
           if (EV%has_nu_relativistic) then
            EV%lmaxnu_pert=EV%lmaxnu 
            EV%nu_pert_ix=neq+1
            neq = neq+ EV%lmaxnu_pert+1
            maxeq=maxeq+ EV%lmaxnu_pert+1
           else
            EV%lmaxnu_pert=0
           end if
           
           do nu_i=1, CP%Nu_Mass_eigenstates
           
            if (EV%high_ktau_neutrino_approx) then
              if (HighAccuracyDefault .and. CP%WantTransfer .and. EV%q < 1.d0) then
               EV%lmaxnu_tau(nu_i)=max(4,lmaxnu_high_ktau)
               else
               EV%lmaxnu_tau(nu_i)=lmaxnu_high_ktau
              end if
            else
              EV%lmaxnu_tau(nu_i) =max(min(nint(0.8_dl*EV%q*nu_tau_nonrelativistic(nu_i)*lAccuracyBoost),EV%lmaxnu),3) 
              !!!Feb13tweak
              if (EV%nu_nonrelativistic(nu_i)) EV%lmaxnu_tau(nu_i)=min(EV%lmaxnu_tau(nu_i),nint(4*lAccuracyBoost))
            end if
            EV%lmaxnu_tau(nu_i)=min(EV%lmaxnu,EV%lmaxnu_tau(nu_i))
        
            EV%nu_ix(nu_i)=neq+1 
            if (EV%MassiveNuApprox(nu_i)) then
                neq = neq+4
            else
                neq = neq+ EV%nq(nu_i)*(EV%lmaxnu_tau(nu_i)+1)
            endif
            maxeq = maxeq + nqmax*(EV%lmaxnu+1)
          end do
           
         else
          EV%has_nu_relativistic = .false.
         end if

         EV%ScalEqsToPropagate = neq
         if (present(max_num_eqns)) then
          max_num_eqns=maxeq
         end if
 
        end subroutine SetupScalarArrayIndices

        subroutine CopyScalarVariableArray(y,yout, EV, EVout)
          type(EvolutionVars) EV, EVOut
          real(dl), intent(in) :: y(EV%nvar)
          real(dl), intent(out) :: yout(EVout%nvar)
          integer lmax,i, nq
          integer nnueq,nu_i, ix_off, ix_off2, ind, ind2
          real(dl) q, pert_scale
          
          yout=0 
          yout(1:basic_num_eqns) = y(1:basic_num_eqns)
          if (.not. is_cosmological_constant) then
               yout(EVout%w_ix)=y(EV%w_ix)
          end if  
          
          if (.not. EV%no_phot_multpoles .and. .not. EVout%no_phot_multpoles) then
          
            if (EV%TightCoupling .or. EVOut%TightCoupling) then
             lmax=1
            else 
             lmax = min(EV%lmaxg,EVout%lmaxg)
            end if
            yout(EVout%g_ix:EVout%g_ix+lmax)=y(EV%g_ix:EV%g_ix+lmax)          
            if (.not. EV%TightCoupling .and. .not. EVOut%TightCoupling) then  
              lmax = min(EV%lmaxgpol,EVout%lmaxgpol)
              yout(EVout%polind+2:EVout%polind+lmax)=y(EV%polind+2:EV%polind+lmax)
            end if
            
          end if  

          if (.not. EV%no_nu_multpoles .and. .not. EVout%no_nu_multpoles) then
         
            if (EV%high_ktau_neutrino_approx .or. EVout%high_ktau_neutrino_approx) then
             lmax=2
            else
             lmax = min(EV%lmaxnr,EVout%lmaxnr)            
            end if
            yout(EVout%r_ix:EVout%r_ix+lmax)=y(EV%r_ix:EV%r_ix+lmax)  
          
          end if
          
         if (CP%Num_Nu_massive /= 0) then
           
           do nu_i=1,CP%Nu_mass_eigenstates
            ix_off=EV%nu_ix(nu_i)
            ix_off2=EVOut%nu_ix(nu_i)
            if (EV%MassiveNuApprox(nu_i) .and. EVout%MassiveNuApprox(nu_i)) then
                 nnueq=4
                 yout(ix_off2:ix_off2+nnueq-1)=y(ix_off:ix_off+nnueq-1)
            else if (.not. EV%MassiveNuApprox(nu_i) .and. .not. EVout%MassiveNuApprox(nu_i)) then
                 lmax=min(EV%lmaxnu_tau(nu_i),EVOut%lmaxnu_tau(nu_i))
                 nq = min(EV%nq(nu_i), EVOut%nq(nu_i))
                 do i=1,nq
                     ind= ix_off + (i-1)*(EV%lmaxnu_tau(nu_i)+1)
                     ind2=ix_off2+ (i-1)*(EVOut%lmaxnu_tau(nu_i)+1)
                     yout(ind2:ind2+lmax) = y(ind:ind+lmax) 
                 end do
                 do i=nq+1, EVOut%nq(nu_i)
                   lmax = min(EVOut%lmaxnu_tau(nu_i), EV%lmaxnr)
                   ind2=ix_off2+ (i-1)*(EVOut%lmaxnu_tau(nu_i)+1)
                   yout(ind2:ind2+lmax) = y(EV%r_ix:EV%r_ix+lmax)            
  
                  !Add leading correction for the mass
                   q=nu_q(i)
                   pert_scale=(nu_masses(nu_i)/q)**2/2
                   lmax = min(lmax,EV%lmaxnu_pert)
                   yout(ind2:ind2+lmax) = yout(ind2:ind2+lmax) &
                                   + y(EV%nu_pert_ix:EV%nu_pert_ix+lmax)*pert_scale           
                  
                 end do
            end if
           end do
           
           if (EVOut%has_nu_relativistic .and. EV%has_nu_relativistic) then   
            lmax = min(EVOut%lmaxnu_pert, EV%lmaxnu_pert)
            yout(EVout%nu_pert_ix:EVout%nu_pert_ix+lmax)=  y(EV%nu_pert_ix:EV%nu_pert_ix+lmax)
          end if
    
         end if         
          
        end subroutine CopyScalarVariableArray


        subroutine SetupTensorArrayIndices(EV, maxeq)
         type(EvolutionVars) EV          
         integer nu_i, neq
         integer, optional, intent(out) :: maxeq
          neq=3
          EV%g_ix = neq-1 !EV%g_ix+2 is quadrupole
          if (.not. EV%TensTightCoupling) then
           EV%E_ix = EV%g_ix + (EV%lmaxt-1)
           EV%B_ix = EV%E_ix + (EV%lmaxpolt-1)
           neq = neq+ (EV%lmaxt-1)+(EV%lmaxpolt-1)*2
          end if
          if (present(maxeq)) then
           maxeq =3 + (EV%lmaxt-1)+(EV%lmaxpolt-1)*2
          end if
          EV%r_ix = neq -1
          if (DoTensorNeutrinos) then           
             neq = neq + EV%lmaxnrt-1
             if (present(maxeq)) maxeq = maxeq+EV%lmaxnrt-1
             if (CP%Num_Nu_massive /= 0 ) then
               do nu_i=1, CP%nu_mass_eigenstates
                   EV%EvolveTensorMassiveNu(nu_i) = nu_tau_nonrelativistic(nu_i) < 0.8*tau_maxvis*AccuracyBoost
                   if (EV%EvolveTensorMassiveNu(nu_i)) then
                    EV%nu_ix(nu_i)=neq-1 
                    neq = neq+ nqmax*(EV%lmaxnut-1)
                    if (present(maxeq)) maxeq = maxeq + nqmax*(EV%lmaxnut-1)
                   end if
               end do
              end if 
          end if
         
         EV%TensEqsToPropagate = neq 
         
        end  subroutine SetupTensorArrayIndices

        subroutine CopyTensorVariableArray(y,yout, EV, EVout)
          type(EvolutionVars) EV, EVOut
          real(dl), intent(in) :: y(EV%nvart)
          real(dl), intent(out) :: yout(EVout%nvart)
          integer lmaxpolt, lmaxt, nu_i, ind, ind2, i
          
          yout=0 
          yout(1:3) = y(1:3)          
          if (.not. EVOut%TensTightCoupling .and. .not.EV%TensTightCoupling) then
           lmaxt = min(EVOut%lmaxt,EV%lmaxt)
           yout(EVout%g_ix+2:EVout%g_ix+lmaxt)=y(EV%g_ix+2:EV%g_ix+lmaxt)     
           lmaxpolt = min(EV%lmaxpolt, EVOut%lmaxpolt)    
           yout(EVout%E_ix+2:EVout%E_ix+lmaxpolt)=y(EV%E_ix+2:EV%E_ix+lmaxpolt)         
           yout(EVout%B_ix+2:EVout%B_ix+lmaxpolt)=y(EV%B_ix+2:EV%B_ix+lmaxpolt)         
          end if
          if (DoTensorNeutrinos) then       
             lmaxt=min(EV%lmaxnrt,EVOut%lmaxnrt)    
             yout(EVout%r_ix+2:EVout%r_ix+lmaxt)=y(EV%r_ix+2:EV%r_ix+lmaxt)     
             do nu_i =1, CP%nu_mass_eigenstates
                if (EV%EvolveTensorMassiveNu(nu_i)) then
                 lmaxt=min(EV%lmaxnut,EVOut%lmaxnut)
                 do i=1,nqmax
                     ind= EV%nu_ix(nu_i) + (i-1)*(EV%lmaxnut-1)
                     ind2=EVOut%nu_ix(nu_i)+ (i-1)*(EVOut%lmaxnut-1)
                     yout(ind2+2:ind2+lmaxt) = y(ind+2:ind+lmaxt) 
                 end do
                end if 
             end do
          end if           
          
        end subroutine CopyTensorVariableArray

        subroutine GetNumEqns(EV)
          use MassiveNu
          !Set the numer of equations in each hierarchy, and get total number of equations for this k
          type(EvolutionVars) EV
          real(dl) scal, max_nu_mass
          integer nu_i,q_rel,j

         if (CP%Num_Nu_massive == 0) then
            EV%lmaxnu=0
            max_nu_mass=0
         else 
            max_nu_mass = maxval(nu_masses(1:CP%Nu_mass_eigenstates))
            do nu_i = 1, CP%Nu_mass_eigenstates       
               !Start with momentum modes for which t_k ~ time at which mode becomes non-relativistic
               q_rel=0
               do j=1, nqmax
                 !two different q's here EV%q ~k
                if (nu_q(j) > nu_masses(nu_i)*adotrad/EV%q) exit
                q_rel = q_rel + 1 
               end do

               if (q_rel>= nqmax-2) then
                EV%nq(nu_i)=nqmax
               else
                EV%nq(nu_i)=q_rel
               end if
               !q_rel = nint(nu_masses(nu_i)*adotrad/EV%q) !two dffierent q's here EV%q ~k
               !EV%nq(nu_i)=max(0,min(nqmax0,q_rel)) !number of momentum modes to evolve intitially 
               EV%nu_nonrelativistic(nu_i) = .false.
            end do

            EV%NuMethod = CP%MassiveNuMethod
            if (EV%NuMethod == Nu_Best) EV%NuMethod = Nu_Trunc
            !l_max for massive neutrinos
            if (CP%Transfer%high_precision) then
             EV%lmaxnu=nint(25*lAccuracyBoost)
            else
             EV%lmaxnu=max(3,nint(10*lAccuracyBoost))
             if (max_nu_mass>700) EV%lmaxnu=max(3,nint(15*lAccuracyBoost)) !Feb13 tweak
            endif 
            
         end if

        if (CP%closed) then
           EV%FirstZerolForBeta = nint(EV%q*CP%r) 
        else 
           EV%FirstZerolForBeta=l0max !a large number
        end if

        EV%high_ktau_neutrino_approx = .false.
        if (CP%WantScalars) then
         EV%TightCoupling=.true.
         EV%no_phot_multpoles =.false.
         EV%no_nu_multpoles =.false.
         EV%MassiveNuApprox=.false.

         if (HighAccuracyDefault .and. CP%AccuratePolarization) then
          EV%lmaxg  = max(nint(11*lAccuracyBoost),3) 
         else
          EV%lmaxg  = max(nint(8*lAccuracyBoost),3)          
         end if
         EV%lmaxnr = max(nint(14*lAccuracyBoost),3)
         if (max_nu_mass>700 .and. HighAccuracyDefault) EV%lmaxnr = max(nint(32*lAccuracyBoost),3) !Feb13 tweak

         EV%lmaxgpol = EV%lmaxg  
         if (.not.CP%AccuratePolarization) EV%lmaxgpol=max(nint(4*lAccuracyBoost),3)
     
         if (EV%q < 0.05) then  
            !Large scales need fewer equations
            scal  = 1
            if (CP%AccuratePolarization) scal = 4  !But need more to get polarization right
            EV%lmaxgpol=max(3,nint(min(8,nint(scal* 150* EV%q))*lAccuracyBoost)) 
            EV%lmaxnr=max(3,nint(min(7,nint(sqrt(scal)* 150 * EV%q))*lAccuracyBoost)) 
            EV%lmaxg=max(3,nint(min(8,nint(sqrt(scal) *300 * EV%q))*lAccuracyBoost)) 
            if (CP%AccurateReionization) then
             EV%lmaxg=EV%lmaxg*4
             EV%lmaxgpol=EV%lmaxgpol*2
            end if
         end if              
         
         if (EV%TransferOnly) then
            EV%lmaxgpol = min(EV%lmaxgpol,nint(5*lAccuracyBoost)) 
            EV%lmaxg = min(EV%lmaxg,nint(6*lAccuracyBoost))     
         end if
         if (CP%Transfer%high_precision) then
           if (HighAccuracyDefault) then
             EV%lmaxnr=max(nint(45*lAccuracyBoost),3)
           else
             EV%lmaxnr=max(nint(30*lAccuracyBoost),3) 
           endif   
           if (EV%q > 0.04 .and. EV%q < 0.5) then !baryon oscillation scales
              EV%lmaxg=max(EV%lmaxg,10) 
           end if   
         end if
      
         if (CP%closed) then         
          EV%lmaxnu=min(EV%lmaxnu, EV%FirstZerolForBeta-1)         
          EV%lmaxnr=min(EV%lmaxnr, EV%FirstZerolForBeta-1)         
          EV%lmaxg=min(EV%lmaxg, EV%FirstZerolForBeta-1)         
          EV%lmaxgpol=min(EV%lmaxgpol, EV%FirstZerolForBeta-1)         
         end if
         
         EV%poltruncfac=real(EV%lmaxgpol,dl)/max(1,(EV%lmaxgpol-2))
         EV%MaxlNeeded=max(EV%lmaxg,EV%lmaxnr,EV%lmaxgpol,EV%lmaxnu) 
         if (EV%MaxlNeeded > max_l_evolve) stop 'Need to increase max_l_evolve'
         call SetupScalarArrayIndices(EV,EV%nvar)
         if (CP%closed) EV%nvar=EV%nvar+1 !so can reference lmax+1 with zero coefficient
         EV%lmaxt=0
         
        else
          EV%nvar=0
        end if
    
       if (CP%WantTensors) then
          EV%TensTightCoupling = .true.
          EV%lmaxt=max(3,nint(8*lAccuracyBoost)) 
          EV%lmaxpolt = max(3,nint(4*lAccuracyBoost)) 
         ! if (EV%q < 1e-3) EV%lmaxpolt=EV%lmaxpolt+1 
          if (DoTensorNeutrinos) then           
            EV%lmaxnrt=nint(6*lAccuracyBoost)
            EV%lmaxnut=EV%lmaxnrt
          else
           EV%lmaxnut=0
           EV%lmaxnrt=0
          end if
          if (CP%closed) then
            EV%lmaxt=min(EV%FirstZerolForBeta-1,EV%lmaxt)
            EV%lmaxpolt=min(EV%FirstZerolForBeta-1,EV%lmaxpolt)
            EV%lmaxnrt=min(EV%FirstZerolForBeta-1,EV%lmaxnrt)
            EV%lmaxnut=min(EV%FirstZerolForBeta-1,EV%lmaxnut)            
          end if
          EV%MaxlNeededt=max(EV%lmaxpolt,EV%lmaxt, EV%lmaxnrt, EV%lmaxnut)
          if (EV%MaxlNeededt > max_l_evolve) stop 'Need to increase max_l_evolve'
          call SetupTensorArrayIndices(EV, EV%nvart)
        else
          EV%nvart=0
        end if       


       if (CP%WantVectors) then
           EV%lmaxv=max(10,nint(8*lAccuracyBoost))
           EV%lmaxpolv = max(5,nint(5*lAccuracyBoost)) 
          
           EV%nvarv=(EV%lmaxv)+(EV%lmaxpolv-1)*2+3
          
           EV%lmaxnrv=nint(30*lAccuracyBoost)
  
           EV%nvarv=EV%nvarv+EV%lmaxnrv
           if (CP%Num_Nu_massive /= 0 ) then
                  stop 'massive neutrinos not supported for vector modes'
           end if 
        else
          EV%nvarv=0
        end if       
        
        end subroutine GetNumEqns

!cccccccccccccccccccccccccccccccccc
        subroutine SwitchToMassiveNuApprox(EV,y, nu_i)
!When the neutrinos are no longer highly relativistic we use a truncated
!energy-integrated hierarchy going up to third order in velocity dispersion
        type(EvolutionVars) EV, EVout
        integer, intent(in) :: nu_i

        real(dl) a,a2,pnu,clxnu,dpnu,pinu,rhonu
        real(dl) qnu
        real(dl) y(EV%nvar), yout(EV%nvar)
     
        a=y(1)
        a2=a*a
        EVout=EV
        EVout%MassiveNuApprox(nu_i)=.true.
        call SetupScalarArrayIndices(EVout)
        call CopyScalarVariableArray(y,yout, EV, EVout)
        
       !Get density and pressure as ratio to massles by interpolation from table
        call Nu_background(a*nu_masses(nu_i),rhonu,pnu)

       !Integrate over q
        call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu,dpnu,pinu)
        !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
        dpnu=dpnu/rhonu
        qnu=qnu/rhonu
        clxnu = clxnu/rhonu
        pinu=pinu/rhonu                     

        yout(EVout%nu_ix(nu_i))=clxnu
        yout(EVout%nu_ix(nu_i)+1)=dpnu
        yout(EVout%nu_ix(nu_i)+2)=qnu
        yout(EVout%nu_ix(nu_i)+3)=pinu

        call Nu_Intvsq(EV,y, a, nu_i, EVout%G11(nu_i),EVout%G30(nu_i))
!Analytic solution for higher moments, proportional to a^{-3}
        EVout%G11(nu_i)=EVout%G11(nu_i)*a2*a/rhonu  
        EVout%G30(nu_i)=EVout%G30(nu_i)*a2*a/rhonu   

        EV=EVout
        y=yout
         
        end subroutine SwitchToMassiveNuApprox

       subroutine MassiveNuVarsOut(EV,y,yprime,a,grho,gpres,dgrho,dgq,dgpi, gdpi_diff,pidot_sum)
        implicit none
        type(EvolutionVars) EV
        real(dl) :: y(EV%nvar), yprime(EV%nvar),a, grho,gpres,dgrho,dgq,dgpi, gdpi_diff,pidot_sum
          !grho = a^2 kappa rho
          !gpres = a^2 kappa p
          !dgrho = a^2 kappa \delta\rho
          !dgp =  a^2 kappa \delta p
          !dgq = a^2 kappa q (heat flux)
          !dgpi = a^2 kappa pi (anisotropic stress) 
          !dgpi_diff = a^2 kappa (3*p -rho)*pi

        integer nu_i
        real(dl) pinudot,grhormass_t, rhonu, pnu,  rhonudot
        real(dl) adotoa, grhonu_t,gpnu_t
        real(dl) clxnu, qnu, pinu, dpnu
        real(dl) dtauda

         do nu_i = 1, CP%Nu_mass_eigenstates

           grhormass_t=grhormass(nu_i)/a**2

           !Get density and pressure as ratio to massless by interpolation from table
           call Nu_background(a*nu_masses(nu_i),rhonu,pnu)

           if (EV%MassiveNuApprox(nu_i)) then    
              clxnu=y(EV%nu_ix(nu_i))
              !dpnu = y(EV%iq0+1+off_ix)
              qnu=y(EV%nu_ix(nu_i)+2)
              pinu=y(EV%nu_ix(nu_i)+3)
              pinudot=yprime(EV%nu_ix(nu_i)+3)
        
           else
            !Integrate over q
            call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu,dpnu,pinu)
            !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
            !dpnu=dpnu/rhonu
            qnu=qnu/rhonu
            clxnu = clxnu/rhonu
            pinu=pinu/rhonu       
            adotoa = 1/(a*dtauda(a))
            rhonudot = Nu_drho(a*nu_masses(nu_i),adotoa,rhonu)
            
            call Nu_pinudot(EV,y, yprime, a,adotoa, nu_i,pinudot)
            pinudot=pinudot/rhonu - rhonudot/rhonu*pinu    
          endif

          grhonu_t=grhormass_t*rhonu
          gpnu_t=grhormass_t*pnu
          
          grho = grho  + grhonu_t
          gpres= gpres + gpnu_t

          dgrho= dgrho + grhonu_t*clxnu  
          dgq  = dgq   + grhonu_t*qnu 
          dgpi = dgpi  + grhonu_t*pinu 
          gdpi_diff = gdpi_diff + pinu*(3*gpnu_t-grhonu_t) 
          pidot_sum = pidot_sum + grhonu_t*pinudot 

        end do

     end subroutine MassiveNuVarsOut

       subroutine Nu_Integrate_L012(EV,y,a,nu_i,drhonu,fnu,dpnu,pinu)
        type(EvolutionVars) EV
!  Compute the perturbations of density and energy flux
!  of one eigenstate of massive neutrinos, in units of the mean
!  density of one eigenstate of massless neutrinos, by integrating over
!  momentum.
        integer, intent(in) :: nu_i
        real(dl), intent(in) :: a, y(EV%nvar)
        real(dl), intent(OUT) ::  drhonu,fnu
        real(dl), optional, intent(OUT) :: dpnu,pinu
        real(dl) tmp, am, aq,v, pert_scale
        integer iq, ind
   
!  q is the comoving momentum in units of k_B*T_nu0/c.

        drhonu=0
        fnu=0
        if (present(dpnu)) then
         dpnu=0
         pinu=0
        end if
        am=a*nu_masses(nu_i)
        ind=EV%nu_ix(nu_i)
        do iq=1,EV%nq(nu_i)
            aq=am/nu_q(iq)
            v=1._dl/sqrt(1._dl+aq*aq)          
            drhonu=drhonu+ nu_int_kernel(iq)* y(ind)/v           
            fnu=fnu+nu_int_kernel(iq)* y(ind+1)
            if (present(dpnu)) then
             dpnu=dpnu+  nu_int_kernel(iq)* y(ind)*v 
             pinu=pinu+ nu_int_kernel(iq)*y(ind+2)*v
            end if  
            ind=ind+EV%lmaxnu_tau(nu_i)+1           
        end do
        ind = EV%nu_pert_ix
        do iq=EV%nq(nu_i)+1,nqmax
         !Get the rest from perturbatively relativistic expansion
            aq=am/nu_q(iq)
            v=1._dl/sqrt(1._dl+aq*aq)          
            pert_scale=(nu_masses(nu_i)/nu_q(iq))**2/2
            tmp = nu_int_kernel(iq)*(y(EV%r_ix)  + pert_scale*y(ind)  )
            drhonu=drhonu+ tmp/v           
            fnu=fnu+nu_int_kernel(iq)*(y(EV%r_ix+1)+ pert_scale*y(ind+1))
            if (present(dpnu)) then
              dpnu=dpnu+ tmp*v
              pinu = pinu+ nu_int_kernel(iq)*(y(EV%r_ix+2)+ pert_scale*y(ind+2))*v
            end if
        end do

        if (present(dpnu)) then
         dpnu = dpnu/3
        end if
     
        end subroutine Nu_Integrate_L012

       subroutine Nu_pinudot(EV,y, ydot, a,adotoa, nu_i,pinudot)
        type(EvolutionVars) EV
        integer, intent(in) :: nu_i
        real(dl), intent(in) :: a,adotoa, y(EV%nvar), ydot(EV%nvar)
           
!  Compute the time derivative of the mean density in massive neutrinos
!  and the shear perturbation.
        real(dl) pinudot
        real(dl) aq,q,v,aqdot,vdot
        real(dl) psi2,psi2dot
        real(dl) am, pert_scale
        integer iq,ind

!  q is the comoving momentum in units of k_B*T_nu0/c.
        pinudot=0._dl
        ind=EV%nu_ix(nu_i)+2
        am=a*nu_masses(nu_i)
        do iq=1,EV%nq(nu_i)
            q=nu_q(iq)
            aq=am/q
            aqdot=aq*adotoa
            v=1._dl/sqrt(1._dl+aq*aq)
            vdot=-aq*aqdot/(1._dl+aq*aq)**1.5d0
            pinudot=pinudot+nu_int_kernel(iq)*(ydot(ind)*v+y(ind)*vdot)
            ind=ind+EV%lmaxnu_tau(nu_i)+1           
        end do
        ind = EV%nu_pert_ix+2
        do iq=EV%nq(nu_i)+1,nqmax
            q=nu_q(iq)
            aq=am/q
            aqdot=aq*adotoa
            pert_scale=(nu_masses(nu_i)/q)**2/2
            v=1._dl/sqrt(1._dl+aq*aq)
            vdot=-aq*aqdot/(1._dl+aq*aq)**1.5d0
            psi2dot=ydot(EV%r_ix+2)  + pert_scale*ydot(ind)
            psi2=y(EV%r_ix+2)  + pert_scale*y(ind)
            pinudot=pinudot+nu_int_kernel(iq)*(psi2dot*v+psi2*vdot)
        end do

       end subroutine Nu_pinudot

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function Nu_pi(EV,y, a, nu_i) result(pinu)
        type(EvolutionVars) EV
        integer, intent(in) :: nu_i
        real(dl), intent(in) :: a, y(EV%nvar)
        real(dl) :: am      
        real(dl) pinu,q,aq,v
        integer iq, ind

        if (EV%nq(nu_i)/=nqmax) stop 'Nu_pi nq/=nqmax0'
        pinu=0
        ind=EV%nu_ix(nu_i)+2
        am=a*nu_masses(nu_i)
        do iq=1, EV%nq(nu_i)
            q=nu_q(iq)
            aq=am/q
            v=1._dl/sqrt(1._dl+aq*aq)          
            pinu=pinu+nu_int_kernel(iq)*y(ind)*v
            ind =ind+EV%lmaxnut+1  
        end do

        end function Nu_pi

!cccccccccccccccccccccccccccccccccccccccccccccc
      subroutine Nu_Intvsq(EV,y, a, nu_i, G11,G30)
        type(EvolutionVars) EV
        integer, intent(in) :: nu_i
        real(dl), intent(in) :: a, y(EV%nvar)
        real(dl), intent(OUT) ::  G11,G30

!  Compute the third order variables (in velocity dispersion) 
!by integrating over momentum.
        real(dl) aq,q,v, am
        integer iq, ind

!  q is the comoving momentum in units of k_B*T_nu0/c.
        am=a*nu_masses(nu_i)
        ind=EV%nu_ix(nu_i)
        G11=0._dl
        G30=0._dl
        if (EV%nq(nu_i)/=nqmax) stop 'Nu_Intvsq nq/=nqmax0'
        do iq=1, EV%nq(nu_i)
            q=nu_q(iq)
            aq=am/q
            v=1._dl/sqrt(1._dl+aq*aq)          
            G11=G11+nu_int_kernel(iq)*y(ind+1)*v**2
            if (EV%lmaxnu_tau(nu_i)>2) then
            G30=G30+nu_int_kernel(iq)*y(ind+3)*v**2
            end if
            ind = ind+EV%lmaxnu_tau(nu_i)+1     
        end do
           
        end subroutine Nu_Intvsq


     subroutine MassiveNuVars(EV,y,a,grho,gpres,dgrho,dgq, wnu_arr)
        implicit none
        type(EvolutionVars) EV
        real(dl) :: y(EV%nvar), a, grho,gpres,dgrho,dgq
        real(dl), intent(out), optional :: wnu_arr(max_nu)
          !grho = a^2 kappa rho
          !gpres = a^2 kappa p
          !dgrho = a^2 kappa \delta\rho
          !dgp =  a^2 kappa \delta p
          !dgq = a^2 kappa q (heat flux)
        integer nu_i
        real(dl) grhormass_t, rhonu, qnu, clxnu, grhonu_t, gpnu_t, pnu

         do nu_i = 1, CP%Nu_mass_eigenstates

          grhormass_t=grhormass(nu_i)/a**2

          !Get density and pressure as ratio to massless by interpolation from table
          call Nu_background(a*nu_masses(nu_i),rhonu,pnu)
 
          if (EV%MassiveNuApprox(nu_i)) then    
              clxnu=y(EV%nu_ix(nu_i))
              qnu=y(EV%nu_ix(nu_i)+2)
           else
            !Integrate over q
             call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu)
             !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
             qnu=qnu/rhonu
             clxnu = clxnu/rhonu
           endif
 
          grhonu_t=grhormass_t*rhonu
          gpnu_t=grhormass_t*pnu
                    
          grho = grho  + grhonu_t
          gpres= gpres + gpnu_t
          dgrho= dgrho + grhonu_t*clxnu
          dgq  = dgq   + grhonu_t*qnu

          if (present(wnu_arr)) then
           wnu_arr(nu_i) =pnu/rhonu
          end if

        end do

     end subroutine MassiveNuVars
     
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine output(EV,y, j,tau,sources)
        use ThermoData
        use lvalues
        use ModelData 
        implicit none
        integer j
        type(EvolutionVars) EV
        real(dl), target :: y(EV%nvar),yprime(EV%nvar)
        real(dl), dimension(:),pointer :: ypol,ypolprime
        
        real(dl) dgq,grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,sigma,polter
        real(dl) qgdot,pigdot,pirdot,vbdot,dgrho
        real(dl) a,a2,dz,z,clxc,clxb,vb,clxg,qg,pig,clxr,qr,pir

        real(dl) tau,x,divfac
        real(dl) dgpi_diff, pidot_sum
        real(dl), target :: pol(3),polprime(3) 
          !dgpi_diff = sum (3*p_nu -rho_nu)*pi_nu

        real(dl) k,k2  ,adotoa, grho, gpres,etak,phi,dgpi
        real(dl)  diff_rhopi, octg, octgprime
        real(dl) sources(CTransScal%NumSources)
!        real(dl) t4,t92
        real(dl) ISW
        real(dl) w_eff

        yprime = 0
        call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)        
        
        if (EV%TightCoupling .or. EV%no_phot_multpoles) then
         pol=0
         polprime=0
         ypolprime => polprime
         ypol => pol         
        else
         ypolprime => yprime(EV%polind+1:)
         ypol => y(EV%polind+1:)
        end if
        
        k=EV%k_buf
        k2=EV%k2_buf
     
        a   =y(1)
        a2  =a*a
        etak=y(2)
        clxc=y(3)
        clxb=y(4)
        vb  =y(5)
        vbdot =yprime(5)

!  Compute expansion rate from: grho 8*pi*rho*a**2

        grhob_t=grhob/a
        grhoc_t=grhoc/a
        grhor_t=grhornomass/a2
        grhog_t=grhog/a2

        !  8*pi*a*a*SUM[rho_i*clx_i] add radiation later
        dgrho=grhob_t*clxb+grhoc_t*clxc

!  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
        dgq=grhob_t*vb
        
        if (is_cosmological_constant) then
         w_eff = -1_dl
         grhov_t=grhov*a2 
        else 
!ppf
         w_eff=w_de(a)   !effective de
         grhov_t=grho_de(a)/a2 
         dgrho=dgrho+EV%dgrho_e_ppf
         dgq=dgq+EV%dgq_e_ppf
        end if    
        grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t
        gpres=(grhog_t+grhor_t)/3+grhov_t*w_eff

        
        dgpi= 0   
        dgpi_diff = 0
        pidot_sum = 0

        if (CP%Num_Nu_Massive /= 0) then
         call MassiveNuVarsOut(EV,y,yprime,a,grho,gpres,dgrho,dgq,dgpi, dgpi_diff,pidot_sum)
        end if

        adotoa=sqrt((grho+grhok)/3)

        if (EV%no_nu_multpoles) then
             z=(0.5_dl*dgrho/k + etak)/adotoa 
             dz= -adotoa*z - 0.5_dl*dgrho/k
             clxr=-4*dz/k
             qr=-4._dl/3*z
             pir=0
             pirdot=0
        else
            clxr=y(EV%r_ix)
            qr  =y(EV%r_ix+1)
            pir =y(EV%r_ix+2)
            pirdot=yprime(EV%r_ix+2)
        end if

        if (EV%no_phot_multpoles) then
             z=(0.5_dl*dgrho/k + etak)/adotoa 
             dz= -adotoa*z - 0.5_dl*dgrho/k
             clxg=-4*dz/k -4/k*opac(j)*(vb+z)
             qg=-4._dl/3*z
             pig=0
             pigdot=0
             octg=0
             octgprime=0
             qgdot = -4*dz/3
        else
            if (EV%TightCoupling) then
             pig = EV%pig
             !pigdot=EV%pigdot
             if (second_order_tightcoupling) then
               octg = (3._dl/7._dl)*pig*(EV%k_buf/opac(j)) 
               ypol(2) = EV%pig/4 + EV%pigdot*(1._dl/opac(j))*(-5._dl/8._dl)
               ypol(3) = (3._dl/7._dl)*(EV%k_buf/opac(j))*ypol(2)
             else
               ypol(2) = EV%pig/4
               octg=0
             end if
             octgprime=0
            else
             pig =y(EV%g_ix+2)
             pigdot=yprime(EV%g_ix+2)
             octg=y(EV%g_ix+3)
             octgprime=yprime(EV%g_ix+3)
            end if 
            clxg=y(EV%g_ix)
            qg  =y(EV%g_ix+1)
            qgdot =yprime(EV%g_ix+1)
       end if

       dgrho = dgrho + grhog_t*clxg+grhor_t*clxr
       dgq   = dgq   + grhog_t*qg+grhor_t*qr
       dgpi  = dgpi  + grhor_t*pir + grhog_t*pig


!  Get sigma (shear) and z from the constraints
!  have to get z from eta for numerical stability       
        z=(0.5_dl*dgrho/k + etak)/adotoa 
        sigma=(z+1.5_dl*dgq/k2)/EV%Kf(1)

        polter = 0.1_dl*pig+9._dl/15._dl*ypol(2)

        if (CP%flat) then
        x=k*(CP%tau0-tau)
        divfac=x*x    
        else   
        x=(CP%tau0-tau)/CP%r
        divfac=(CP%r*rofChi(x))**2*k2 
        end if


        if (EV%TightCoupling) then
          if (second_order_tightcoupling) then
            pigdot = EV%pigdot  
            ypolprime(2)= (pigdot/4._dl)*(1+(5._dl/2._dl)*(dopac(j)/opac(j)**2))
          else
           pigdot = -dopac(j)/opac(j)*pig + 32._dl/45*k/opac(j)*(-2*adotoa*sigma  &
                 +etak/EV%Kf(1)-  dgpi/k +vbdot )
           ypolprime(2)= pigdot/4
          end if
        end if

        pidot_sum =  pidot_sum + grhog_t*pigdot + grhor_t*pirdot
        diff_rhopi = pidot_sum - (4*dgpi+ dgpi_diff )*adotoa 


!Maple's fortran output - see scal_eqs.map
!2phi' term (\phi' + \psi' in Newtonian gauge)
        ISW = (4.D0/3.D0*k*EV%Kf(1)*sigma+(-2.D0/3.D0*sigma-2.D0/3.D0*etak/adotoa)*k &
              -diff_rhopi/k**2-1.D0/adotoa*dgrho/3.D0+(3.D0*gpres+5.D0*grho)*sigma/k/3.D0 &
              -2.D0/k*adotoa/EV%Kf(1)*etak)*expmmu(j)

!e.g. to get only late-time ISW
!  if (1/a-1 < 30) ISW=0

!The rest, note y(9)->octg, yprime(9)->octgprime (octopoles)
    sources(1)= ISW +  ((-9.D0/160.D0*pig-27.D0/80.D0*ypol(2))/k**2*opac(j)+(11.D0/10.D0*sigma- &
    3.D0/8.D0*EV%Kf(2)*ypol(3)+vb-9.D0/80.D0*EV%Kf(2)*octg+3.D0/40.D0*qg)/k-(- &
    180.D0*ypolprime(2)-30.D0*pigdot)/k**2/160.D0)*dvis(j)+(-(9.D0*pigdot+ &
    54.D0*ypolprime(2))/k**2*opac(j)/160.D0+pig/16.D0+clxg/4.D0+3.D0/8.D0*ypol(2)+(- &
    21.D0/5.D0*adotoa*sigma-3.D0/8.D0*EV%Kf(2)*ypolprime(3)+vbdot+3.D0/40.D0*qgdot- &
    9.D0/80.D0*EV%Kf(2)*octgprime)/k+(-9.D0/160.D0*dopac(j)*pig-21.D0/10.D0*dgpi-27.D0/ &
    80.D0*dopac(j)*ypol(2))/k**2)*vis(j)+(3.D0/16.D0*ddvis(j)*pig+9.D0/ &
    8.D0*ddvis(j)*ypol(2))/k**2+21.D0/10.D0/k/EV%Kf(1)*vis(j)*etak   


! Doppler term
!   sources(1)=  (sigma+vb)/k*dvis(j)+((-2.D0*adotoa*sigma+vbdot)/k-1.D0/k**2*dgpi)*vis(j) &
!         +1.D0/k/EV%Kf(1)*vis(j)*etak

!Equivalent full result
!    t4 = 1.D0/adotoa
!    t92 = k**2
!    sources(1) = (4.D0/3.D0*EV%Kf(1)*expmmu(j)*sigma+2.D0/3.D0*(-sigma-t4*etak)*expmmu(j))*k+ &
!        (3.D0/8.D0*ypol(2)+pig/16.D0+clxg/4.D0)*vis(j)
!    sources(1) = sources(1)-t4*expmmu(j)*dgrho/3.D0+((11.D0/10.D0*sigma- &
!         3.D0/8.D0*EV%Kf(2)*ypol(3)+vb+ 3.D0/40.D0*qg-9.D0/80.D0*EV%Kf(2)*y(9))*dvis(j)+(5.D0/3.D0*grho+ &
!        gpres)*sigma*expmmu(j)+(-2.D0*adotoa*etak*expmmu(j)+21.D0/10.D0*etak*vis(j))/ &
!        EV%Kf(1)+(vbdot-3.D0/8.D0*EV%Kf(2)*ypolprime(3)+3.D0/40.D0*qgdot-21.D0/ &
!        5.D0*sigma*adotoa-9.D0/80.D0*EV%Kf(2)*yprime(9))*vis(j))/k+(((-9.D0/160.D0*pigdot- &
!        27.D0/80.D0*ypolprime(2))*opac(j)-21.D0/10.D0*dgpi -27.D0/80.D0*dopac(j)*ypol(2) &
!        -9.D0/160.D0*dopac(j)*pig)*vis(j) - diff_rhopi*expmmu(j)+((-27.D0/80.D0*ypol(2)-9.D0/ &
!        160.D0*pig)*opac(j)+3.D0/16.D0*pigdot+9.D0/8.D0*ypolprime(2))*dvis(j)+9.D0/ &
!        8.D0*ddvis(j)*ypol(2)+3.D0/16.D0*ddvis(j)*pig)/t92


      if (x > 0._dl) then
         !E polarization source
           sources(2)=vis(j)*polter*(15._dl/8._dl)/divfac 
               !factor of four because no 1/16 later
        else
           sources(2)=0
        end if
 
      if (CTransScal%NumSources > 2) then
         !Get lensing sources
         !Can modify this here if you want to get power spectra for other tracer
       if (tau>taurend .and. CP%tau0-tau > 0.1_dl) then
         
         !phi_lens = Phi - 1/2 kappa (a/k)^2 sum_i rho_i pi_i
         !Neglect pi contributions because not accurate at late time anyway
         phi = -(dgrho +3*dgq*adotoa/k)/(k2*EV%Kf(1)*2) 
            ! - (grhor_t*pir + grhog_t*pig+ pinu*gpnu_t)/k2
         
         sources(3) = -2*phi*f_K(tau-tau_maxvis)/(f_K(CP%tau0-tau_maxvis)*f_K(CP%tau0-tau))

!         sources(3) = -2*phi*(tau-tau_maxvis)/((CP%tau0-tau_maxvis)*(CP%tau0-tau))
          !We include the lensing factor of two here
       else
         sources(3) = 0
       end if
      end if
      
     end subroutine output


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine outputt(EV,yt,n,j,tau,dt,dte,dtb)
!calculate the tensor sources for open and closed case
        use ThermoData

        implicit none
        integer j,n
        type(EvolutionVars) :: EV
        real(dl), target :: yt(n), ytprime(n)
        real(dl) tau,dt,dte,dtb,x,polterdot,polterddot,prefac
        real(dl) pig, pigdot, octg, aux, polter, shear, adotoa,a
        real(dl) sinhxr,cothxor
        real(dl) k,k2
        real(dl), dimension(:),pointer :: E,Bprime,Eprime
        real(dl), target :: pol(3),polEprime(3), polBprime(3) 
        real(dl) dtauda

        call derivst(EV,EV%nvart,tau,yt,ytprime)
      
        k2=EV%k2_buf
        k=EV%k_buf 
        aux=EV%aux_buf  
        shear = yt(3)

        x=(CP%tau0-tau)/CP%r

        !  And the electric part of the Weyl.
        if (.not. EV%TensTightCoupling) then
!  Use the full expression for pigdt
           pig=yt(EV%g_ix+2)
           pigdot=ytprime(EV%g_ix+2)
           E => yt(EV%E_ix+1:)   
           Eprime=> ytprime(EV%E_ix+1:) 
           Bprime => ytprime(EV%B_ix+1:)
           octg=ytprime(EV%g_ix+3)
        else
!  Use the tight-coupling approximation
           a =yt(1)
           adotoa = 1/(a*dtauda(a))
           pigdot=32._dl/45._dl*k/opac(j)*(2._dl*adotoa*shear+ytprime(3))
           pig = 32._dl/45._dl*k/opac(j)*shear
           pol=0
           polEprime=0
           polBprime=0
           E=>pol
           EPrime=>polEPrime
           BPrime=>polBPrime
           E(2)=pig/4._dl    
           EPrime(2)=pigdot/4   
           octg=0
        endif
       
        sinhxr=rofChi(x)*CP%r
    
        if (EV%q*sinhxr > 1.e-8_dl) then  

        prefac=sqrt(EV%q2*CP%r*CP%r-CP%Ksign)
        cothxor=cosfunc(x)/sinhxr

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)
        polterdot=9._dl/15._dl*Eprime(2) + 0.1_dl*pigdot
        polterddot = 9._dl/15._dl*(-dopac(j)*(E(2)-polter)-opac(j)*(  &
                   Eprime(2)-polterdot) + k*(2._dl/3._dl*Bprime(2)*aux - &
                   5._dl/27._dl*Eprime(3)*EV%Kft(2))) &
                   +0.1_dl*(k*(-octg*EV%Kft(2)/3._dl + 8._dl/15._dl*ytprime(3)) - &
                   dopac(j)*(pig - polter) - opac(j)*(pigdot-polterdot))

        dt=(shear*expmmu(j) + (15._dl/8._dl)*polter*vis(j)/k)*CP%r/sinhxr**2/prefac 
   
        dte=CP%r*15._dl/8._dl/k/prefac* &
            ((ddvis(j)*polter + 2._dl*dvis(j)*polterdot + vis(j)*polterddot)  &
              + 4._dl*cothxor*(dvis(j)*polter + vis(j)*polterdot) - &
                   vis(j)*polter*(k2 -6*cothxor**2))
      
        dtb=15._dl/4._dl*EV%q*CP%r/k/prefac*(vis(j)*(2._dl*cothxor*polter + polterdot) + dvis(j)*polter)
   
        else
        dt=0._dl
        dte=0._dl
        dtb=0._dl
        end if

        end subroutine outputt

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine outputv(EV,yv,n,j,tau,dt,dte,dtb)
!calculate the vector sources 
        use ThermoData

        implicit none
        integer j,n
        type(EvolutionVars) :: EV
        real(dl), target :: yv(n), yvprime(n)
        real(dl) tau,dt,dte,dtb,x,polterdot
        real(dl) vb,qg, pig, polter, sigma
        real(dl) k,k2
        real(dl), dimension(:),pointer :: E,Eprime

        call derivsv(EV,EV%nvarv,tau,yv,yvprime)
      
        k2=EV%k2_buf
        k=EV%k_buf 
        sigma = yv(2)
        vb  = yv(3)
        qg  = yv(4)
        pig = yv(5)

  
        x=(CP%tau0-tau)*k
              
        if (x > 1.e-8_dl) then  

        E => yv(EV%lmaxv+3:)
        Eprime=> yvprime(EV%lmaxv+3:) 
      
        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)
        polterdot=9._dl/15._dl*Eprime(2) + 0.1_dl*yvprime(5)
 
        if (yv(1) < 1e-3) then
         dt = 1
        else
         dt =0
        end if   
        dt= (4*(vb+sigma)*vis(j) + 15._dl/2/k*( vis(j)*polterdot + dvis(j)*polter) &
               + 4*(expmmu(j)*yvprime(2)) )/x 
   
        dte= 15._dl/2*2*polter/x**2*vis(j) + 15._dl/2/k*(dvis(j)*polter + vis(j)*polterdot)/x 
      
        dtb= -15._dl/2*polter/x*vis(j)

        else
         dt=0
         dte=0
         dtb=0
        end if

        end subroutine outputv


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine initial(EV,y, tau)
!  Initial conditions.
        use ThermoData
        implicit none
   
        type(EvolutionVars) EV
        real(dl) y(EV%nvar)
        real(dl) Rp15,tau,x,x2,x3,om,omtau, &
             Rc,Rb,Rv,Rg,grhonu,chi
        real(dl) k,k2 
        real(dl) a,a2, iqg, rhomass,a_massive, ep
        integer l,i, nu_i, j, ind
        integer, parameter :: i_clxg=1,i_clxr=2,i_clxc=3, i_clxb=4, &
                i_qg=5,i_qr=6,i_vb=7,i_pir=8, i_eta=9, i_aj3r=10,i_clxq=11,i_vq=12
        integer, parameter :: i_max = i_vq
        real(dl) initv(6,1:i_max), initvec(1:i_max)
       
        if (CP%flat) then
         EV%k_buf=EV%q
         EV%k2_buf=EV%q2     
         EV%Kf(1:EV%MaxlNeeded)=1._dl
        else
         EV%k2_buf=EV%q2-CP%curv
         EV%k_buf=sqrt(EV%k2_buf)
                    
         do l=1,EV%MaxlNeeded
           EV%Kf(l)=1._dl-CP%curv*(l*(l+2))/EV%k2_buf           
         end do
        end if
 
        k=EV%k_buf
        k2=EV%k2_buf
 
         do j=1,EV%MaxlNeeded
           EV%denlk(j)=denl(j)*k*j
           EV%denlk2(j)=denl(j)*k*EV%Kf(j)*(j+1)
           EV%polfack(j)=polfac(j)*k*EV%Kf(j)*denl(j)
         end do     
      
        !Get time to switch off tight coupling 
        !The numbers here are a bit of guesswork
        !The high k increase saves time for very small loss of accuracy
        !The lower k ones are more delicate. Nead to avoid instabilities at same time
        !as ensuring tight coupling is accurate enough
         if (EV%k_buf > epsw) then
           if (EV%k_buf > epsw*5) then
            ep=ep0*5/AccuracyBoost  
            if (HighAccuracyDefault) ep = ep*0.65  
           else
            ep=ep0
           end if
         else
           ep=ep0 
         end if
         if (second_order_tightcoupling) ep=ep*2 
         EV%TightSwitchoffTime = min(tight_tau,Thermo_OpacityToTime(EV%k_buf/ep)) 

      
        y=0   
   
!  k*tau, (k*tau)**2, (k*tau)**3
        x=k*tau
        x2=x*x
        x3=x2*x
        rhomass =  sum(grhormass(1:CP%Nu_mass_eigenstates)) 
        grhonu=rhomass+grhornomass
                                                        
        om = (grhob+grhoc)/sqrt(3*(grhog+grhonu))       
        omtau=om*tau
        Rv=grhonu/(grhonu+grhog)
        
        Rg = 1-Rv
        Rc=CP%omegac/(CP%omegac+CP%omegab)
        Rb=1-Rc
        Rp15=4*Rv+15

        if (CP%Scalar_initial_condition > initial_nummodes) &
          stop 'Invalid initial condition for scalar modes'

        a=tau*adotrad*(1+omtau/4)
        a2=a*a
        
        initv=0

!  Set adiabatic initial conditions

        chi=1  !Get transfer function for chi
        initv(1,i_clxg)=-chi*EV%Kf(1)/3*x2*(1-omtau/5)
        initv(1,i_clxr)= initv(1,i_clxg)
        initv(1,i_clxb)=0.75_dl*initv(1,i_clxg)
        initv(1,i_clxc)=initv(1,i_clxb)
        initv(1,i_qg)=initv(1,i_clxg)*x/9._dl
        initv(1,i_qr)=-chi*EV%Kf(1)*(4*Rv+23)/Rp15*x3/27
        initv(1,i_vb)=0.75_dl*initv(1,i_qg)
        initv(1,i_pir)=chi*4._dl/3*x2/Rp15*(1+omtau/4*(4*Rv-5)/(2*Rv+15))
        initv(1,i_aj3r)=chi*4/21._dl/Rp15*x3
        initv(1,i_eta)=-chi*2*EV%Kf(1)*(1 - x2/12*(-10._dl/Rp15 + EV%Kf(1)))
      
        if (CP%Scalar_initial_condition/= initial_adiabatic) then
!CDM isocurvature   
       
         initv(2,i_clxg)= Rc*omtau*(-2._dl/3 + omtau/4)
         initv(2,i_clxr)=initv(2,i_clxg)
         initv(2,i_clxb)=initv(2,i_clxg)*0.75_dl
         initv(2,i_clxc)=1+initv(2,i_clxb)
         initv(2,i_qg)=-Rc/9*omtau*x
         initv(2,i_qr)=initv(2,i_qg)
         initv(2,i_vb)=0.75_dl*initv(2,i_qg)
         initv(2,i_pir)=-Rc*omtau*x2/3/(2*Rv+15._dl)
         initv(2,i_eta)= Rc*omtau*(1._dl/3 - omtau/8)*EV%Kf(1)
         initv(2,i_aj3r)=0
!Baryon isocurvature
         if (Rc==0) stop 'Isocurvature initial conditions assume non-zero dark matter'

         initv(3,:) = initv(2,:)*(Rb/Rc)
         initv(3,i_clxc) = initv(3,i_clxb)
         initv(3,i_clxb)= initv(3,i_clxb)+1
      
!neutrino isocurvature density mode
       
         initv(4,i_clxg)=Rv/Rg*(-1 + x2/6)
         initv(4,i_clxr)=1-x2/6
         initv(4,i_clxc)=-omtau*x2/80*Rv*Rb/Rg
         initv(4,i_clxb)= Rv/Rg/8*x2
         iqg = - Rv/Rg*(x/3 - Rb/4/Rg*omtau*x)
         initv(4,i_qg) =iqg
         initv(4,i_qr) = x/3
         initv(4,i_vb)=0.75_dl*iqg
         initv(4,i_pir)=x2/Rp15
         initv(4,i_eta)=EV%Kf(1)*Rv/Rp15/3*x2
     
!neutrino isocurvature velocity mode

         initv(5,i_clxg)=Rv/Rg*x - 2*x*omtau/16*Rb*(2+Rg)/Rg**2
         initv(5,i_clxr)=-x -3*x*omtau*Rb/16/Rg
         initv(5,i_clxc)=-9*omtau*x/64*Rv*Rb/Rg
         initv(5,i_clxb)= 3*Rv/4/Rg*x - 9*omtau*x/64*Rb*(2+Rg)/Rg**2
         iqg = Rv/Rg*(-1 + 3*Rb/4/Rg*omtau+x2/6 +3*omtau**2/16*Rb/Rg**2*(Rg-3*Rb))
         initv(5,i_qg) =iqg
         initv(5,i_qr) = 1 - x2/6*(1+4*EV%Kf(1)/(4*Rv+5))
         initv(5,i_vb)=0.75_dl*iqg
         initv(5,i_pir)=2*x/(4*Rv+5)+omtau*x*6/Rp15/(4*Rv+5)
         initv(5,i_eta)=2*EV%Kf(1)*x*Rv/(4*Rv+5) + omtau*x*3*EV%Kf(1)*Rv/32*(Rb/Rg - 80/Rp15/(4*Rv+5))
         initv(5,i_aj3r) = 3._dl/7*x2/(4*Rv+5)

!quintessence isocurvature mode


         end if

       if (CP%Scalar_initial_condition==initial_vector) then
          InitVec = 0
          do i=1,initial_nummodes
          InitVec = InitVec+ initv(i,:)*CP%InitialConditionVector(i)
          end do
       else
          InitVec = initv(CP%Scalar_initial_condition,:)
          if (CP%Scalar_initial_condition==initial_adiabatic) InitVec = -InitVec
            !So we start with chi=-1 as before
       end if

        y(1)=a
        y(2)= -InitVec(i_eta)*k/2
        !get eta_s*k, where eta_s is synchronous gauge variable

!  CDM
        y(3)=InitVec(i_clxc)
  
!  Baryons
        y(4)=InitVec(i_clxb)
        y(5)=InitVec(i_vb)

!  Photons
        y(EV%g_ix)=InitVec(i_clxg)
        y(EV%g_ix+1)=InitVec(i_qg) 
              
        if (.not. is_cosmological_constant) then
         y(EV%w_ix) = InitVec(i_clxq) !ppf: Gamma=0, i_clxq stands for i_Gamma
        end if

!  Neutrinos
        y(EV%r_ix)=InitVec(i_clxr)
        y(EV%r_ix+1)=InitVec(i_qr)
        y(EV%r_ix+2)=InitVec(i_pir)

        if (EV%lmaxnr>2) then
         y(EV%r_ix+3)=InitVec(i_aj3r)
        endif

        if (CP%Num_Nu_massive == 0) return 

        do nu_i = 1, CP%Nu_mass_eigenstates       
          
          EV%MassiveNuApproxTime(nu_i) = Nu_tau_massive(nu_i)
          a_massive =  20000*k/nu_masses(nu_i)*AccuracyBoost*lAccuracyBoost
          if (a_massive >=0.99) then
            EV%MassiveNuApproxTime(nu_i)=CP%tau0+1
          else if (a_massive > 17.d0/nu_masses(nu_i)*AccuracyBoost) then
            EV%MassiveNuApproxTime(nu_i)=max(EV%MassiveNuApproxTime(nu_i),DeltaTime(0._dl,a_massive, 0.01_dl))  
          end if
          ind = EV%nu_ix(nu_i)    
          do  i=1,EV%nq(nu_i)
           y(ind:ind+2)=y(EV%r_ix:EV%r_ix+2) 
           if (EV%lmaxnu_tau(nu_i)>2) y(ind+3)=InitVec(i_aj3r)           
           ind = ind + EV%lmaxnu_tau(nu_i)+1
          end do

        end do       

        end subroutine initial


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine initialt(EV,yt,tau)
!  Initial conditions for tensors
        use ThermoData
        implicit none
        real(dl) bigR,tau,x,aj3r,elec, pir, rhomass
        integer l
         type(EvolutionVars) EV
        real(dl) k,k2 ,a, omtau
        real(dl) yt(EV%nvart)
        real(dl) tens0, ep, tensfac
        
        if (CP%flat) then
         EV%aux_buf=1._dl
         EV%k2_buf=EV%q2
         EV%k_buf=EV%q       
         EV%Kft(1:EV%MaxlNeededt)=1._dl !initialize for flat case
        else
      
         EV%k2_buf=EV%q2-3*CP%curv
         EV%k_buf=sqrt(EV%k2_buf) 
         EV%aux_buf=sqrt(1._dl+3*CP%curv/EV%k2_buf)  
        
        endif
      
        k=EV%k_buf
        k2=EV%k2_buf

        do l=1,EV%MaxlNeededt
           if (.not. CP%flat) EV%Kft(l)=1._dl-CP%curv*((l+1)**2-3)/k2
           EV%denlkt(1,l)=k*denl(l)*l !term for L-1
           tensfac=real((l+3)*(l-1),dl)/(l+1)
           EV%denlkt(2,l)=k*denl(l)*tensfac*EV%Kft(l) !term for L+1
           EV%denlkt(3,l)=k*denl(l)*tensfac**2/(l+1)*EV%Kft(l) !term for polarization 
           EV%denlkt(4,l)=k*4._dl/(l*(l+1))*EV%aux_buf !other for polarization
        end do

        if (k > 0.06_dl*epsw) then
           ep=ep0
        else
           ep=0.2_dl*ep0
        end if

    !    finished_tightcoupling = ((k/opacity > ep).or.(1._dl/(opacity*tau) > ep)) 
        EV%TightSwitchoffTime = min(tight_tau,Thermo_OpacityToTime(EV%k_buf/ep)) 
         
        a=tau*adotrad
        rhomass =  sum(grhormass(1:CP%Nu_mass_eigenstates)) 
        omtau = tau*(grhob+grhoc)/sqrt(3*(grhog+rhomass+grhornomass))       
            
        if (DoTensorNeutrinos) then
         bigR = (rhomass+grhornomass)/(rhomass+grhornomass+grhog)
        else
         bigR = 0._dl
        end if

        x=k*tau
 
        yt(1)=a
        tens0 = 1

        yt(2)= tens0 
!commented things are for the compensated mode with magnetic fields; can be neglected
!-15/28._dl*x**2*(bigR-1)/(15+4*bigR)*Magnetic*(1-5./2*omtau/(2*bigR+15))
    
        elec=-tens0*(1+2*CP%curv/k2)*(2*bigR+10)/(4*bigR+15) !elec, with H=1
       
        !shear
        yt(3)=-5._dl/2/(bigR+5)*x*elec 
!          + 15._dl/14*x*(bigR-1)/(4*bigR+15)*Magnetic*(1 - 15./2*omtau/(2*bigR+15))
        
        yt(4:EV%nvart)=0._dl
     
!  Neutrinos 
        if (DoTensorNeutrinos) then
         pir=-2._dl/3._dl/(bigR+5)*x**2*elec 
!           + (bigR-1)/bigR*Magnetic*(1-15./14*x**2/(15+4*bigR))
         aj3r=  -2._dl/21._dl/(bigR+5)*x**3*elec !&
!           + 3._dl/7*x*(bigR-1)/bigR*Magnetic
         yt(EV%r_ix+2)=pir
         yt(EV%r_ix+3)=aj3r
         !Should set up massive too, but small anyway..
        end if
    
        end subroutine initialt

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine initialv(EV,yv,tau)
!  Initial conditions for vectors

        implicit none
        real(dl) bigR,Rc,tau,x,pir
        type(EvolutionVars) EV
        real(dl) k,k2 ,a, omtau
        real(dl) yv(EV%nvarv)
        
        if (CP%flat) then
         EV%k2_buf=EV%q2
         EV%k_buf=EV%q       
        else
         stop 'Vectors not supported in non-flat models'
        endif
        
        k=EV%k_buf
        k2=EV%k2_buf

        omtau = tau*(grhob+grhoc)/sqrt(3*(grhog+grhornomass))       

        a=tau*adotrad*(1+omtau/4)
        
        x=k*tau
       
        bigR = (grhornomass)/(grhornomass+grhog)
        Rc=CP%omegac/(CP%omegac+CP%omegab)

        yv(1)=a

        
        yv(2)= vec_sig0*(1- 15._dl/2*omtau/(4*bigR+15)) + 45._dl/14*x*Magnetic*(BigR-1)/(4*BigR+15)
        !qg
        yv(4)= vec_sig0/3* (4*bigR + 5)/(1-BigR)*(1  -0.75_dl*omtau*(Rc-1)/(bigR-1)* &
               (1 - 0.25_dl*omtau*(3*Rc-2-bigR)/(BigR-1))) &
                 -x/2*Magnetic
        yv(3)= 3._dl/4*yv(4)
        
        yv(5:EV%nvarv) = 0

!        if (.false.) then
!         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1) = vec_sig0/6/bigR*x**2*(1+2*bigR*omtau/(4*bigR+15))
!         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+2) = -2/3._dl*vec_sig0/bigR*x*(1 +3*omtau*bigR/(4*bigR+15))
!         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+3) = 1/4._dl*vec_sig0/bigR*(5+4*BigR) 
!         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+4) =1/9.*x*vec_sig0*(5+4*bigR)/bigR
!         yv(4) = 0
!         yv(3)= 3._dl/4*yv(4)
!          return 
!        end if

!  Neutrinos
!q_r
         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1) = -1._dl/3*vec_sig0*(4*BigR+5)/bigR &
             + x**2*vec_sig0/6/BigR +0.5_dl*x*(1/bigR-1)*Magnetic 
!pi_r
         pir=-2._dl/3._dl*x*vec_sig0/BigR - (1/bigR-1)*Magnetic
         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1 +1)=pir
         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1 +2)=3._dl/7*x*Magnetic*(1-1/BigR)
  
        end subroutine initialv


      subroutine outtransf(EV, y, Arr)
 !write out clxc, clxb, clxg, clxn
        use Transfer
        implicit none
        type(EvolutionVars) EV
   
        real(dl) clxc, clxb, clxg, clxr, k,k2
        real(dl) grho,gpres,dgrho,dgq,a
        real Arr(:)
        real(dl) y(EV%nvar)

        a    = y(1)
        clxc = y(3)
        clxb = y(4)
        if (EV%no_nu_multpoles) then
         clxr=0
        else
         clxr = y(EV%r_ix)
        end if
        
        if (EV%no_phot_multpoles) then
         clxg=0
        else
         clxg = y(EV%g_ix)
        end if
        
        k    = EV%k_buf
        k2   = EV%k2_buf
 
        Arr(Transfer_kh) = k/(CP%h0/100._dl)
        Arr(Transfer_cdm) = clxc/k2
        Arr(Transfer_b) = clxb/k2
        Arr(Transfer_g) = clxg/k2
        Arr(Transfer_r) = clxr/k2
  
        dgrho = 0 
        grho =  0
        
        if (CP%Num_Nu_Massive > 0) then
          call MassiveNuVars(EV,y,a,grho,gpres,dgrho,dgq)
           Arr(Transfer_nu) = dgrho/grho/k2
        else
           Arr(Transfer_nu) = 0
        end if

!!!If we want DE perturbations to get \delta\rho/\rho_m    
!       dgrho=dgrho+y(EV%w_ix)*grhov*a**(-1-3*w_lam)
!        Arr(Transfer_r) = y(EV%w_ix)/k2
!
!        dgrho = dgrho+(clxc*grhoc + clxb*grhob)/a 
!        grho =  grho+(grhoc+grhob)/a + grhov*a**(-1-3*w_lam)

         dgrho = dgrho+(clxc*grhoc + clxb*grhob)/a 
         grho =  grho+(grhoc+grhob)/a
        
        Arr(Transfer_tot) = dgrho/grho/k2 
             
    
     end subroutine outtransf

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine derivs(EV,n,tau,ay,ayprime)
!  Evaluate the time derivatives of the perturbations
!  ayprime is not necessarily GaugeInterface.yprime, so keep them distinct
        use ThermoData
        use MassiveNu
        implicit none      
        type(EvolutionVars) EV

        integer n,nu_i
        real(dl) ay(n),ayprime(n)
        real(dl) tau,w
        real(dl) k,k2 

!  Internal variables.

        real(dl) opacity
        real(dl) photbar,cs2,pb43,grho,slip,clxgdot, &
                      clxcdot,clxbdot,adotdota,gpres,clxrdot,etak
        real(dl) q,aq,v
        real(dl) G11_t,G30_t, wnu_arr(max_nu)

        real(dl) dgq,grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,sigma,polter
        real(dl) qgdot,qrdot,pigdot,pirdot,vbdot,dgrho,adotoa
       real(dl) a,a2,dz,z,clxc,clxb,vb,clxg,qg,pig,clxr,qr,pir
        real(dl) E2, dopacity
        integer l,i,ind, ind2, off_ix, ix
        real(dl) dgs,sigmadot !, ddz
        !non-flat vars
        real(dl) cothxor !1/tau in flat case
!ppf
       real(dl) Gamma,S_Gamma,ckH,Gammadot,Fa,dgqe,dgrhoe, vT
       real(dl) w_eff
       
        k=EV%k_buf
        k2=EV%k2_buf     
  
        a=ay(1)
        a2=a*a

        etak=ay(2)

!  CDM variables
        clxc=ay(3)

!  Baryon variables
        clxb=ay(4)
        vb=ay(5)

!  Compute expansion rate from: grho 8*pi*rho*a**2

        grhob_t=grhob/a
        grhoc_t=grhoc/a
        grhor_t=grhornomass/a2
        grhog_t=grhog/a2
        if (is_cosmological_constant) then
          grhov_t=grhov*a2
          w_eff = -1_dl
        else
 !ppf 
         w_eff=w_de(a)   !effective de
         grhov_t=grho_de(a)/a2
        end if
        
!  Get sound speed and ionisation fraction.
        if (EV%TightCoupling) then
          call thermo(tau,cs2,opacity,dopacity)
         else
          call thermo(tau,cs2,opacity)        
        end if

        gpres=0
        grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t

!total perturbations: matter terms first, then add massive nu, de and radiation 
!  8*pi*a*a*SUM[rho_i*clx_i]
        dgrho=grhob_t*clxb+grhoc_t*clxc 
!  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
        dgq=grhob_t*vb
                
        if (CP%Num_Nu_Massive > 0) then
           call MassiveNuVars(EV,ay,a,grho,gpres,dgrho,dgq, wnu_arr)
        end if
        
        if (CP%flat) then
         adotoa=sqrt(grho/3)
         cothxor=1._dl/tau
        else
         adotoa=sqrt((grho+grhok)/3._dl)
         cothxor=1._dl/tanfunc(tau/CP%r)/CP%r
        end if
         
       ! if (w_lam /= -1 .and. w_Perturb) then
       !    clxq=ay(EV%w_ix) 
       !    vq=ay(EV%w_ix+1) 
       !    dgrho=dgrho + clxq*grhov_t
       !    dgq = dgq + vq*grhov_t*(1+w_lam)
       !end if

       if (EV%no_nu_multpoles) then
        !RSA approximation of arXiv:1104.2933, dropping opactity terms in the velocity
        !Approximate total density variables with just matter terms
        z=(0.5_dl*dgrho/k + etak)/adotoa 
        dz= -adotoa*z - 0.5_dl*dgrho/k
        clxr=-4*dz/k
        qr=-4._dl/3*z
        pir=0
       else
!  Massless neutrinos
        clxr=ay(EV%r_ix)
        qr  =ay(EV%r_ix+1)
        pir =ay(EV%r_ix+2)
       endif
        
       if (EV%no_phot_multpoles) then
         if (.not. EV%no_nu_multpoles) then
          z=(0.5_dl*dgrho/k + etak)/adotoa 
          dz= -adotoa*z - 0.5_dl*dgrho/k
          clxg=-4*dz/k-4/k*opacity*(vb+z)
          qg=-4._dl/3*z
         else
          clxg=clxr-4/k*opacity*(vb+z)
          qg=qr          
         end if
         pig=0    
       else
!  Photons
        clxg=ay(EV%g_ix)
        qg=ay(EV%g_ix+1)
        if (.not. EV%TightCoupling) pig=ay(EV%g_ix+2)
       end if

!  8*pi*a*a*SUM[rho_i*clx_i] - radiation terms
        dgrho=dgrho + grhog_t*clxg+grhor_t*clxr 
       
!  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
        dgq=dgq + grhog_t*qg+grhor_t*qr

!  Photon mass density over baryon mass density
        photbar=grhog_t/grhob_t
        pb43=4._dl/3*photbar
        
        ayprime(1)=adotoa*a

       if (.not. is_cosmological_constant) then

     !ppf
          vT= dgq/(grho+gpres)
          Gamma=ay(EV%w_ix)
    
    !sigma for ppf
          sigma = (etak + (dgrho + 3*adotoa/k*dgq)/2._dl/k)/EV%kf(1) - k*Gamma 
          sigma = sigma/adotoa
      
          S_Gamma=grhov_t*(1+w_eff)*(vT+sigma)*k/adotoa/2._dl/k2
          ckH=c_Gamma_ppf*k/adotoa    
          Gammadot=S_Gamma/(1+ckH*ckH)- Gamma -ckH*ckH*Gamma
          Gammadot=Gammadot*adotoa
          ayprime(EV%w_ix)=Gammadot
      
          if(ckH*ckH.gt.3.d1)then
                Gamma=0
                Gammadot=0.d0
                ayprime(EV%w_ix)=Gammadot
          endif
      
          Fa=1+3*(grho+gpres)/2._dl/k2/EV%kf(1)
          dgqe=S_Gamma - Gammadot/adotoa - Gamma 
          dgqe=-dgqe/Fa*2._dl*k*adotoa + vT*grhov_t*(1+w_eff)
          dgrhoe=-2*k2*EV%kf(1)*Gamma-3/k*adotoa*dgqe
          dgrho=dgrho+dgrhoe
          dgq=dgq+dgqe
      
          EV%dgrho_e_ppf=dgrhoe
          EV%dgq_e_ppf=dgqe
          EV%dgrhoec_ppf=dgrhoe+3._dl*(1+w_eff)*grhov_t*adotoa*vT/k
          EV%dgqec_ppf=dgqe+(1+w_eff)*grhov_t*sigma
          EV%vTc_ppf=vT+sigma
       end if  

!  Get sigma (shear) and z from the constraints
! have to get z from eta for numerical stability
        z=(0.5_dl*dgrho/k + etak)/adotoa 
        if (CP%flat) then
 !eta*k equation
         sigma=(z+1.5_dl*dgq/k2)
         ayprime(2)=0.5_dl*dgq
        else
         sigma=(z+1.5_dl*dgq/k2)/EV%Kf(1)
         ayprime(2)=0.5_dl*dgq + CP%curv*z
        end if

      !if (w_lam /= -1 .and. w_Perturb) then
        !
        !   ayprime(EV%w_ix)= -3*adotoa*(cs2_lam-w_lam)*(clxq+3*adotoa*(1+w_lam)*vq/k) &
        !       -(1+w_lam)*k*vq -(1+w_lam)*k*z
        !
        !   ayprime(EV%w_ix+1) = -adotoa*(1-3*cs2_lam)*vq + k*cs2_lam*clxq/(1+w_lam)
        !
        !end if
        !
!  CDM equation of motion
        clxcdot=-k*z
        ayprime(3)=clxcdot

!  Baryon equation of motion.
        clxbdot=-k*(z+vb)
        ayprime(4)=clxbdot
!  Photon equation of motion
        clxgdot=-k*(4._dl/3._dl*z+qg)

! old comment:Small k: potential problem with stability, using full equations earlier is NOT more accurate in general
! Easy to see instability in k \sim 1e-3 by tracking evolution of vb

!  Use explicit equation for vb if appropriate

         if (EV%TightCoupling) then
   
           !  ddota/a
            gpres=gpres+ (grhog_t+grhor_t)/3 +grhov_t*w_eff
            adotdota=(adotoa*adotoa-gpres)/2

            pig = 32._dl/45/opacity*k*(sigma+vb)

    !  First-order approximation to baryon-photon splip
             slip = - (2*adotoa/(1+pb43) + dopacity/opacity)* (vb-3._dl/4*qg) &
             +(-adotdota*vb-k/2*adotoa*clxg +k*(cs2*clxbdot-clxgdot/4))/(opacity*(1+pb43))
            
            if (second_order_tightcoupling) then
            ! by Francis-Yan Cyr-Racine simplified (inconsistently) by AL assuming flat
            !AL: First order slip seems to be fine here to 2e-4

             !  8*pi*G*a*a*SUM[rho_i*sigma_i]
             dgs = grhog_t*pig+grhor_t*pir

             ! Define shear derivative to first order
             sigmadot = -2*adotoa*sigma-dgs/k+etak

             !Once know slip, recompute qgdot, pig, pigdot
             qgdot = k*(clxg/4._dl-pig/2._dl) +opacity*slip 

             pig = 32._dl/45/opacity*k*(sigma+3._dl*qg/4._dl)*(1+(dopacity*11._dl/6._dl/opacity**2)) &
                 + (32._dl/45._dl/opacity**2)*k*(sigmadot+3._dl*qgdot/4._dl)*(-11._dl/6._dl)

             pigdot = -(32._dl/45._dl)*(dopacity/opacity**2)*k*(sigma+3._dl*qg/4._dl)*(1 + &
                 dopacity*11._dl/6._dl/opacity**2 ) &
                 + (32._dl/45._dl/opacity)*k*(sigmadot+3._dl*qgdot/4._dl)*(1+(11._dl/6._dl) &
                 *(dopacity/opacity**2))

             EV%pigdot = pigdot
   
            end if

    !  Use tight-coupling approximation for vb
    !  zeroth order approximation to vbdot + the pig term
            vbdot=(-adotoa*vb+cs2*k*clxb  &
                 +k/4*pb43*(clxg-2*EV%Kf(1)*pig))/(1+pb43)

            vbdot=vbdot+pb43/(1+pb43)*slip

            EV%pig = pig

        else
            vbdot=-adotoa*vb+cs2*k*clxb-photbar*opacity*(4._dl/3*vb-qg)
        end if

        ayprime(5)=vbdot
    
     if (.not. EV%no_phot_multpoles) then

 !  Photon equations of motion
        ayprime(EV%g_ix)=clxgdot
        qgdot=4._dl/3*(-vbdot-adotoa*vb+cs2*k*clxb)/pb43 &
             +EV%denlk(1)*clxg-EV%denlk2(1)*pig  
        ayprime(EV%g_ix+1)=qgdot
        
!  Use explicit equations for photon moments if appropriate       
        if (.not. EV%tightcoupling) then

            E2=ay(EV%polind+2)
            polter = pig/10+9._dl/15*E2 !2/15*(3/4 pig + 9/2 E2)
            ix= EV%g_ix+2
            if (EV%lmaxg>2) then 
              pigdot=EV%denlk(2)*qg-EV%denlk2(2)*ay(ix+1)-opacity*(pig - polter) &
                   +8._dl/15._dl*k*sigma
              ayprime(ix)=pigdot
              do  l=3,EV%lmaxg-1
                ix=ix+1
                ayprime(ix)=(EV%denlk(l)*ay(ix-1)-EV%denlk2(l)*ay(ix+1))-opacity*ay(ix)
              end do
             ix=ix+1
          !  Truncate the photon moment expansion
             ayprime(ix)=k*ay(ix-1)-(EV%lmaxg+1)*cothxor*ay(ix) -opacity*ay(ix)
            else !closed case
              pigdot=EV%denlk(2)*qg-opacity*(pig - polter) +8._dl/15._dl*k*sigma
              ayprime(ix)=pigdot
            endif 
!  Polarization
            !l=2 
            ix=EV%polind+2
            if (EV%lmaxgpol>2) then
              ayprime(ix) = -opacity*(ay(ix) - polter) - k/3._dl*ay(ix+1)
              do l=3,EV%lmaxgpol-1
               ix=ix+1
               ayprime(ix)=-opacity*ay(ix) + (EV%denlk(l)*ay(ix-1)-EV%polfack(l)*ay(ix+1))
              end do  
              ix=ix+1
              !truncate
              ayprime(ix)=-opacity*ay(ix) + &
                k*EV%poltruncfac*ay(ix-1)-(EV%lmaxgpol+3)*cothxor*ay(ix)
           else !closed case
              ayprime(ix) = -opacity*(ay(ix) - polter) 
           endif
         end if
        end if

        if (.not. EV%no_nu_multpoles) then
   
!  Massless neutrino equations of motion.
        clxrdot=-k*(4._dl/3._dl*z+qr)
        ayprime(EV%r_ix)=clxrdot
        qrdot=EV%denlk(1)*clxr-EV%denlk2(1)*pir
        ayprime(EV%r_ix+1)=qrdot              
        if (EV%high_ktau_neutrino_approx) then
        
          !ufa approximation for k*tau>>1, more accurate when there are reflections from lmax
          !Method from arXiv:1104.2933
!                if (.not. EV%TightCoupling) then
!                 gpres=gpres+ (grhog_t+grhor_t)/3 +grhov_t*w_lam
!                 adotdota=(adotoa*adotoa-gpres)/2
!                end if
!                ddz=(2*adotoa**2 - adotdota)*z  & 
!                  + adotoa/(2*k)*( 6*(grhog_t*clxg+grhor_t*clxr) + 2*(grhoc_t*clxc+grhob_t*clxb) ) &
!                   - 1._dl/(2*k)*( 2*(grhog_t*clxgdot+grhor_t*clxrdot) + grhoc_t*clxcdot + grhob_t*clxbdot ) 
!                dz= -adotoa*z - 0.5_dl*dgrho/k
!                pirdot= -3*pir*cothxor + k*(qr+4._dl/3*z) 
                 pirdot= -3*pir*cothxor - clxrdot 
                 ayprime(EV%r_ix+2)=pirdot
            
!                pirdot=k*(0.4_dl*qr-0.6_dl*ay(EV%lmaxg+10)+8._dl/15._dl*sigma)
!                ayprime(EV%lmaxg+9)=pirdot
!                ayprime(3+EV%lmaxg+7)=k*ay(3+EV%lmaxg+6)- &
!                                      (3+1)*cothxor*ay(3+EV%lmaxg+7)
!               ayprime(3+EV%lmaxg+7+1:EV%lmaxnr+EV%lmaxg+7)=0
           else
                ix=EV%r_ix+2
                if (EV%lmaxnr>2) then
                 pirdot=EV%denlk(2)*qr- EV%denlk2(2)*ay(ix+1)+8._dl/15._dl*k*sigma
                 ayprime(ix)=pirdot
                 do l=3,EV%lmaxnr-1
                   ix=ix+1
                   ayprime(ix)=(EV%denlk(l)*ay(ix-1) - EV%denlk2(l)*ay(ix+1)) 
                 end do   
            !  Truncate the neutrino expansion
                 ix=ix+1
                 ayprime(ix)=k*ay(ix-1)- (EV%lmaxnr+1)*cothxor*ay(ix)
                else
                 pirdot=EV%denlk(2)*qr +8._dl/15._dl*k*sigma
                 ayprime(ix)=pirdot
                end if
         end if     
        end if ! no_nu_multpoles

!  Massive neutrino equations of motion.
         if (CP%Num_Nu_massive == 0) return
          
          do nu_i = 1, CP%Nu_mass_eigenstates
          if (EV%MassiveNuApprox(nu_i)) then
             !Now EV%iq0 = clx, EV%iq0+1 = clxp, EV%iq0+2 = G_1, EV%iq0+3=G_2=pinu
             !see astro-ph/0203507
             G11_t=EV%G11(nu_i)/a/a2 
             G30_t=EV%G30(nu_i)/a/a2
             off_ix = EV%nu_ix(nu_i)
             w=wnu_arr(nu_i)
             ayprime(off_ix)=-k*z*(w+1) + 3*adotoa*(w*ay(off_ix) - ay(off_ix+1))-k*ay(off_ix+2)
             ayprime(off_ix+1)=(3*w-2)*adotoa*ay(off_ix+1) - 5._dl/3*k*z*w - k/3*G11_t
             ayprime(off_ix+2)=(3*w-1)*adotoa*ay(off_ix+2) - k*(2._dl/3*EV%Kf(1)*ay(off_ix+3)-ay(off_ix+1))
             ayprime(off_ix+3)=(3*w-2)*adotoa*ay(off_ix+3) + 2*w*k*sigma - k/5*(3*EV%Kf(2)*G30_t-2*G11_t)
     
          else
   
              ind=EV%nu_ix(nu_i)
              do i=1,EV%nq(nu_i)
               q=nu_q(i)
               aq=a*nu_masses(nu_i)/q
               v=1._dl/sqrt(1._dl+aq*aq)

               ayprime(ind)=-k*(4._dl/3._dl*z + v*ay(ind+1))
               ind=ind+1
               ayprime(ind)=v*(EV%denlk(1)*ay(ind-1)-EV%denlk2(1)*ay(ind+1))
               ind=ind+1
               if (EV%lmaxnu_tau(nu_i)==2) then
                 ayprime(ind)=-ayprime(ind-2) -3*cothxor*ay(ind)
               else
                 ayprime(ind)=v*(EV%denlk(2)*ay(ind-1)-EV%denlk2(2)*ay(ind+1)) &
                      +k*8._dl/15._dl*sigma
                 do l=3,EV%lmaxnu_tau(nu_i)-1
                   ind=ind+1
                   ayprime(ind)=v*(EV%denlk(l)*ay(ind-1)-EV%denlk2(l)*ay(ind+1))
                 end do
               !  Truncate moment expansion.
                 ind = ind+1
                 ayprime(ind)=k*v*ay(ind-1)-(EV%lmaxnu_tau(nu_i)+1)*cothxor*ay(ind)
               end if
               ind = ind+1                 
              end do
 
          end if
          end do

          if (EV%has_nu_relativistic) then
           ind=EV%nu_pert_ix
           ayprime(ind)=+k*a2*qr -k*ay(ind+1)  
           ind2= EV%r_ix
           do l=1,EV%lmaxnu_pert-1
            ind=ind+1
            ind2=ind2+1
            ayprime(ind)= -a2*(EV%denlk(l)*ay(ind2-1)-EV%denlk2(l)*ay(ind2+1)) &
                          +   (EV%denlk(l)*ay(ind-1)-EV%denlk2(l)*ay(ind+1))
           end do
            ind=ind+1
            ind2=ind2+1
            ayprime(ind)= k*(ay(ind-1) -a2*ay(ind2-1)) -(EV%lmaxnu_pert+1)*cothxor*ay(ind)
          end if
          
        end subroutine derivs

     

        subroutine derivsv(EV,n,tau,yv,yvprime)
!  Evaluate the time derivatives of the vector perturbations, flat case
        use ThermoData
        use MassiveNu
        implicit none      
        type(EvolutionVars) EV
        integer n,l
        real(dl), target ::  yv(n),yvprime(n)
        real(dl) ep,tau,grho,rhopi,cs2,opacity,gpres
        logical finished_tightcoupling
        real(dl), dimension(:),pointer :: neut,neutprime,E,B,Eprime,Bprime
        real(dl)  grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,polter
        real(dl) sigma, qg,pig, qr, vb, rhoq, vbdot, photbar, pb43
        real(dl) k,k2,a,a2, adotdota
        real(dl) pir,adotoa  
   
        stop 'ppf not implemented for vectors'
        
         k2=EV%k2_buf
         k=EV%k_buf       

        !E and B start at l=2. Set up pointers accordingly to fill in y arrays
        E => yv(EV%lmaxv+3:)
        Eprime=> yvprime(EV%lmaxv+3:) 
        B => E(EV%lmaxpolv:)
        Bprime => Eprime(EV%lmaxpolv:)
        neutprime => Bprime(EV%lmaxpolv+1:)
        neut => B(EV%lmaxpolv+1:)
            
        a=yv(1)        

        sigma=yv(2)

        a2=a*a

!  Get sound speed and opacity, and see if should use tight-coupling
             
        call thermo(tau,cs2,opacity)
        if (k > 0.06_dl*epsw) then
           ep=ep0
        else
           ep=0.2_dl*ep0
        end if
   
        finished_tightcoupling = &
         ((k/opacity > ep).or.(1._dl/(opacity*tau) > ep .and. k/opacity > 1d-4)) 


! Compute expansion rate from: grho=8*pi*rho*a**2
! Also calculate gpres: 8*pi*p*a**2
        grhob_t=grhob/a
        grhoc_t=grhoc/a
        grhor_t=grhornomass/a2
        grhog_t=grhog/a2
        grhov_t=grhov*a**(-1-3*w_lam)

        grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t
        gpres=(grhog_t+grhor_t)/3._dl+grhov_t*w_lam 

        adotoa=sqrt(grho/3._dl)
        adotdota=(adotoa*adotoa-gpres)/2

        photbar=grhog_t/grhob_t
        pb43=4._dl/3*photbar
       
        yvprime(1)=adotoa*a
     
        vb = yv(3)
        qg = yv(4)         
        qr = neut(1)

!  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
        rhoq=grhob_t*vb+grhog_t*qg+grhor_t*qr
     !  sigma = 2*rhoq/k**2
        !for non-large k this expression for sigma is unstable at early times
        !so propagate sigma equation separately (near total cancellation in rhoq)
        ! print *,yv(2),2*rhoq/k**2

        if (finished_tightcoupling) then
!  Use explicit equations:

        pig = yv(5) 

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)

        vbdot = -adotoa*vb-photbar*opacity*(4._dl/3*vb-qg) - 0.5_dl*k*photbar*Magnetic

!  Equation for the photon heat flux stress
  
         yvprime(4)=-0.5_dl*k*pig + opacity*(4._dl/3*vb-qg) 
      
!  Equation for the photon anisotropic stress
        yvprime(5)=k*(2._dl/5*qg -8/15._dl*yv(6))+8._dl/15._dl*k*sigma  &
                  -opacity*(pig - polter)
! And for the moments            
        do  l=3,EV%lmaxv-1
           yvprime(l+3)=k*denl(l)*l*(yv(l+2)-   &
                  vecfac(l)*yv(l+4))-opacity*yv(l+3)
        end do
!  Truncate the hierarchy
        yvprime(EV%lmaxv+3)=k*EV%lmaxv/(EV%lmaxv-1._dl)*yv(EV%lmaxv+2)- &
                       (EV%lmaxv+2._dl)*yv(EV%lmaxv+3)/tau-opacity*yv(EV%lmaxv+3)
     
!E equations
   
        Eprime(2) = - opacity*(E(2) - polter) + k*(1/3._dl*B(2) - &
                        8._dl/27._dl*E(3))
        do l=3,EV%lmaxpolv-1
        Eprime(l) =-opacity*E(l) + k*(denl(l)*(l*E(l-1) - &
                        vecfacpol(l)*E(l+1)) + 2._dl/(l*(l+1))*B(l))
        end do
!truncate
        Eprime(EV%lmaxpolv)=0._dl
                
!B-bar equations
        
        do l=2,EV%lmaxpolv-1
        Bprime(l) =-opacity*B(l) + k*(denl(l)*(l*B(l-1) - &
                        vecfacpol(l)*B(l+1)) - 2._dl/(l*(l+1))*E(l))
        end do
!truncate
        Bprime(EV%lmaxpolv)=0._dl

       else

!Tight coupling expansion results

        pig = 32._dl/45._dl*k/opacity*(vb + sigma)

        EV%pig = pig

        vbdot=(-adotoa*vb  -3._dl/8*pb43*k*Magnetic  -3._dl/8*k*pb43*pig &
                - pb43/(1+pb43)/opacity*(0.75_dl*k*adotoa*pb43**2/(pb43+1)*Magnetic + vb*&
              ( 2*pb43*adotoa**2/(1+pb43) + adotdota)) &
                  )/(1+pb43) 

!  Equation for the photon heat flux
! Get drag from vbdot expression 
        yvprime(4)=-0.5_dl*k*pig - &
           (vbdot+adotoa*vb)/photbar - 0.5_dl*k*Magnetic

!  Set the derivatives to zero
        yvprime(5:n)=0._dl
        yv(5)=pig
        E(2)=  pig/4 
        
        endif
 
        yvprime(3) = vbdot

!  Neutrino equations: 
               
!  Massless neutrino anisotropic stress
        pir=neut(2)
        neutprime(1)= -0.5_dl*k*pir
        neutprime(2)=2._dl/5*k*qr -8._dl/15._dl*k*neut(3)+ 8._dl/15._dl*k*sigma
!  And for the moments
        do  l=3,EV%lmaxnrv-1
           neutprime(l)=k*denl(l)*l*(neut(l-1)- vecfac(l)*neut(l+1))
        end do
        
!  Truncate the hierarchy
        neutprime(EV%lmaxnrv)=k*EV%lmaxnrv/(EV%lmaxnrv-1._dl)*neut(EV%lmaxnrv-1)-  &
                       (EV%lmaxnrv+2._dl)*neut(EV%lmaxnrv)/tau

    
!  Get the propagation equation for the shear
            
        rhopi=grhog_t*pig+grhor_t*pir+ grhog_t*Magnetic
                      
        yvprime(2)=-2*adotoa*sigma -rhopi/k

       end subroutine derivsv



!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
        subroutine derivst(EV,n,tau,ayt,aytprime)
!  Evaluate the time derivatives of the tensor perturbations.
        use ThermoData
        use MassiveNu
        implicit none      
        type(EvolutionVars) EV
        integer n,l,i,ind, nu_i
        real(dl), target ::  ayt(n),aytprime(n)
        real(dl) tau,grho,rhopi,cs2,opacity,pirdt
        real(dl), dimension(:),pointer :: neut,neutprime,E,B,Eprime,Bprime
        real(dl) q,aq,v
        real(dl)  grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,polter
        real(dl) Hchi,pinu, pig
        real(dl) k,k2,a,a2
        real(dl) pir, adotoa, rhonu, shear

        real(dl) cothxor
      
        k2=EV%k2_buf
        k= EV%k_buf   

        a=ayt(1)        

        Hchi=ayt(2)  

        shear=ayt(3)

        a2=a*a
  
! Compute expansion rate from: grho=8*pi*rho*a**2
! Also calculate gpres: 8*pi*p*a**2
        grhob_t=grhob/a
        grhoc_t=grhoc/a
        grhor_t=grhornomass/a2
        grhog_t=grhog/a2
        if (is_cosmological_constant) then
          grhov_t=grhov*a2
        else
         grhov_t=grho_de(a)/a2
        end if
        
        grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t
     
!Do massive neutrinos
        if (CP%Num_Nu_Massive >0) then
         do nu_i=1,CP%Nu_mass_eigenstates
           call Nu_rho(a*nu_masses(nu_i),rhonu)
           grho=grho+grhormass(nu_i)*rhonu/a2
         end do
        end if

        if (CP%flat) then
         cothxor=1._dl/tau  
         adotoa=sqrt(grho/3._dl)
        else
         cothxor=1._dl/tanfunc(tau/CP%r)/CP%r  
         adotoa=sqrt((grho+grhok)/3._dl)
        end if

        aytprime(1)=adotoa*a

        call thermo(tau,cs2,opacity)

        if (.not. EV%TensTightCoupling) then
!  Don't use tight coupling approx - use explicit equations:
!  Equation for the photon anisotropic stress


        !E and B start at l=2. Set up pointers accordingly to fill in ayt arrays
        E => ayt(EV%E_ix+1:)   
        B => ayt(EV%B_ix+1:)  
        Eprime=> aytprime(EV%E_ix+1:) 
        Bprime => aytprime(EV%B_ix+1:)

        ind = EV%g_ix+2

        !  Photon anisotropic stress
        pig=ayt(ind)
        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)

        if (EV%lmaxt > 2) then
         
        aytprime(ind)=-EV%denlkt(2,2)*ayt(ind+1)+k*8._dl/15._dl*shear  &
                  -opacity*(pig - polter)

        do l=3, EV%lmaxt -1
         ind = ind+1
         aytprime(ind)=EV%denlkt(1,L)*ayt(ind-1)-EV%denlkt(2,L)*ayt(ind+1)-opacity*ayt(ind)
        end do

        !Truncate the hierarchy 
        ind=ind+1
        aytprime(ind)=k*EV%lmaxt/(EV%lmaxt-2._dl)*ayt(ind-1)- &
                       (EV%lmaxt+3._dl)*cothxor*ayt(ind)-opacity*ayt(ind)

!E and B-bar equations
     
        Eprime(2) = - opacity*(E(2) - polter) + EV%denlkt(4,2)*B(2) - &
                        EV%denlkt(3,2)*E(3)
        
        do l=3, EV%lmaxpolt-1
                       
           Eprime(l) =(EV%denlkt(1,L)*E(l-1)-EV%denlkt(3,L)*E(l+1) + EV%denlkt(4,L)*B(l)) &
                          -opacity*E(l) 
   
        end do
        l= EV%lmaxpolt
!truncate: difficult, but setting l+1 to zero seems to work OK
        Eprime(l) = (EV%denlkt(1,L)*E(l-1) + EV%denlkt(4,L)*B(l)) -opacity*E(l) 
                    
        Bprime(2) =-EV%denlkt(3,2)*B(3) - EV%denlkt(4,2)*E(2)  -opacity*B(2)
        do l=3, EV%lmaxpolt-1
        Bprime(l) =(EV%denlkt(1,L)*B(l-1) -EV%denlkt(3,L)*B(l+1) - EV%denlkt(4,L)*E(l)) &
                         -opacity*B(l)
        end do
        l=EV%lmaxpolt 
!truncate
        Bprime(l) =(EV%denlkt(1,L)*B(l-1) - EV%denlkt(4,L)*E(l))  -opacity*B(l)

        else !lmax=2
        
         aytprime(ind)=k*8._dl/15._dl*shear-opacity*(pig - polter) 
         Eprime(2) = - opacity*(E(2) - polter) + EV%denlkt(4,2)*B(2)
         Bprime(2) = - EV%denlkt(4,2)*E(2)  -opacity*B(2)
        
        end if     

        else  !Tight coupling
         pig = 32._dl/45._dl*k/opacity*shear
        
        endif
      
      rhopi=grhog_t*pig 


!  Neutrino equations: 
!  Anisotropic stress
        if (DoTensorNeutrinos) then
        
        neutprime => aytprime(EV%r_ix+1:)
        neut => ayt(EV%r_ix+1:)
       
!  Massless neutrino anisotropic stress
        pir=neut(2)

        rhopi=rhopi+grhor_t*pir
 
        if (EV%lmaxnrt>2) then   
        pirdt=-EV%denlkt(2,2)*neut(3) + 8._dl/15._dl*k*shear
        neutprime(2)=pirdt
!  And for the moments
        do  l=3, EV%lmaxnrt-1
           neutprime(l)= EV%denlkt(1,L)*neut(l-1) -EV%denlkt(2,L)*neut(l+1)
        end do
        
!  Truncate the hierarchy
        neutprime(EV%lmaxnrt)=k*EV%lmaxnrt/(EV%lmaxnrt-2._dl)*neut(EV%lmaxnrt-1)-  &
                       (EV%lmaxnrt+3._dl)*cothxor*neut(EV%lmaxnrt)

        else
         pirdt= 8._dl/15._dl*k*shear
         neutprime(2)=pirdt
        end if

         !  Massive neutrino equations of motion and contributions to anisotropic stress.
         if (CP%Num_Nu_massive > 0) then
          
          do nu_i=1,CP%Nu_mass_eigenstates
            if (.not. EV%EvolveTensorMassiveNu(nu_i)) then
              rhopi=rhopi+ grhormass(nu_i)/a2*pir !- good approx, note no rhonu weighting  
            else
              ind=EV%nu_ix(nu_i)+2
              
              pinu= Nu_pi(EV, ayt(ind),a, nu_i)                 
              rhopi=rhopi+ grhormass(nu_i)/a2*pinu   
         
              do i=1,nqmax
                q=nu_q(i)
                aq=a*nu_masses(nu_i)/q
                v=1._dl/sqrt(1._dl+aq*aq)
                if (EV%lmaxnut>2) then
                 aytprime(ind)=-v*EV%denlkt(2,2)*ayt(ind+1)+8._dl/15._dl*k*shear
                 do l=3,EV%lmaxnut-1
                  ind=ind+1
                  aytprime(ind)=v*(EV%denlkt(1,L)*ayt(ind-1)-EV%denlkt(2,L)*ayt(ind+1))     
                 end do
                 ind = ind+1
                !Truncate moment expansion.
                 aytprime(ind)=k*v*EV%lmaxnut/(EV%lmaxnut-2._dl)*ayt(ind-1)-(EV%lmaxnut+3)*cothxor*ayt(ind)
                else
                 aytprime(ind)=8._dl/15._dl*k*shear
                end if
                ind=ind+1
              end do
            end if          
          end do
                      
         end if
        end if
             
!  Get the propagation equation for the shear
        
        if (CP%flat) then
        aytprime(3)=-2*adotoa*shear+k*Hchi-rhopi/k   
        else
        aytprime(3)=-2*adotoa*shear+k*Hchi*(1+2*CP%curv/k2)-rhopi/k   
        endif  

        aytprime(2)=-k*shear

        end subroutine derivst



!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        end module GaugeInterface

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gphim(angle,rp,cm,np,rpi,cmi,cmimin,cmimax,tol,
     *  phi,iord)
      integer np,iord(2*np)
      real*10 angle,rp(3,np),cm(np),rpi(3),cmi,cmimin,cmimax,tol,
     *  phi(2,np)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c *
c * Same as gphi, but speed up matters by checking first whether cmi
c * lies outside |cmimin| and |cmimax|, giving angle of 0 or 2*pi.
c * cmimin and cmimax are gotten from prior call to gcmlim.
c *
      if (cmi.le.abs(cmimin)) then
c        region excludes circle
        if (cmimin.ge.0._10) then
          angle=0._10
c        region encloses circle
        elseif (cmimin.lt.0._10) then
          angle=TWOPI
        endif
      elseif (cmi.ge.abs(cmimax)) then
c        circle encloses region
        if (cmimax.ge.0._10) then
          angle=0._10
c        circle and region enclose each other
        elseif (cmimax.lt.0._10) then
          angle=TWOPI
        endif
      else
c        circle intersects boundary of region
        call gphi(angle,rp,cm,np,rpi,cmi,phi,tol,iord)
      endif
      return
      end
c

!General numerical routines and global accuracy. Includes modified dverk for CAMB.


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        subroutine splder(y,dy,n, g)
        use Precision
!  Splder fits a cubic spline to y and returns the first derivatives at
!  the grid points in dy.  Dy is equivalent to a 4th-order Pade
!  difference formula for dy/di.
        implicit none
        integer, intent(in) :: n
        real(dl), intent(in) :: y(n),g(n)
        real(dl), intent(out) :: dy(n)
        integer :: n1, i
        real(dl), allocatable, dimension(:) :: f

        allocate(f(n))
        n1=n-1
!  Quartic fit to dy/di at boundaries, assuming d3y/di3=0.
        f(1)=(-10._dl*y(1)+15._dl*y(2)-6._dl*y(3)+y(4))/6._dl
        f(n)=(10._dl*y(n)-15._dl*y(n1)+6._dl*y(n-2)-y(n-3))/6._dl
!  Solve the tridiagonal system
!  dy(i-1)+4*dy(i)+dy(i+1)=3*(y(i+1)-y(i-1)), i=2,3,...,n1,
!  with dy(1)=f(1), dy(n)=f(n).
        do i=2,n1
          f(i)=g(i)*(3._dl*(y(i+1)-y(i-1))-f(i-1))
        end do
        dy(n)=f(n)
        do i=n1,1,-1
          dy(i)=f(i)-g(i)*dy(i+1)
        end do
        deallocate(f)
        end subroutine splder
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine splini(g,n)
        use Precision
!  Splini must be called before splder to initialize array g in common.
        implicit none
        integer, intent(in) :: n
        real(dl), intent(out):: g(n)
        integer :: i

        g(1)=0._dl
        do i=2,n
          g(i)=1/(4._dl-g(i-1))
        end do
        end subroutine splini


 !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function rombint2(f,a,b,tol, maxit, minsteps)
        use precision
!  Rombint returns the integral from a to b of using Romberg integration.
!  The method converges provided that f(x) is continuous in (a,b).
!  f must be real(dl) and must be declared external in the calling
!  routine.  tol indicates the desired relative accuracy in the integral.

! Modified by AL to specify max iterations and minimum number of steps
! (min steps useful to stop wrong results on periodic or sharp functions)
        implicit none
        integer, parameter :: MAXITER=20,MAXJ=5
        dimension g(MAXJ+1)
        real(dl) f
        external f
        real(dl) :: rombint2
        real(dl), intent(in) :: a,b,tol
        integer, intent(in):: maxit,minsteps
     
        integer :: nint, i, k, jmax, j
        real(dl) :: h, gmax, error, g, g0, g1, fourj
      
        h=0.5d0*(b-a)
        gmax=h*(f(a)+f(b))
        g(1)=gmax
        nint=1
        error=1.0d20
        i=0
        do
          i=i+1
          if (i > maxit.or.(i > 5.and.abs(error) < tol) .and. nint > minsteps) exit
!  Calculate next trapezoidal rule approximation to integral.
          g0=0._dl
          do k=1,nint
            g0=g0+f(a+(k+k-1)*h)
          end do
          g0=0.5d0*g(1)+h*g0
          h=0.5d0*h
          nint=nint+nint
          jmax=min(i,MAXJ)
          fourj=1._dl
          do j=1,jmax
!  Use Richardson extrapolation.
            fourj=4._dl*fourj
            g1=g0+(g0-g(j))/(fourj-1._dl)
            g(j)=g0
            g0=g1
          end do  
          if (abs(g0).gt.tol) then
            error=1._dl-gmax/g0
          else
            error=gmax
          end if
          gmax=g0
          g(jmax+1)=g0
        end do
  
        rombint2=g0
        if (i > maxit .and. abs(error) > tol)  then
          write(*,*) 'Warning: Rombint2 failed to converge; '
          write (*,*)'integral, error, tol:', rombint2,error, tol
        end if
        
        end function rombint2

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function rombint(f,a,b,tol)
        use Precision
!  Rombint returns the integral from a to b of using Romberg integration.
!  The method converges provided that f(x) is continuous in (a,b).
!  f must be real(dl) and must be declared external in the calling
!  routine.  tol indicates the desired relative accuracy in the integral.
!
        implicit none
        integer, parameter :: MAXITER=20
        integer, parameter :: MAXJ=5
        dimension g(MAXJ+1)
        real(dl) f
        external f
        real(dl) :: rombint
        real(dl), intent(in) :: a,b,tol
        integer :: nint, i, k, jmax, j
        real(dl) :: h, gmax, error, g, g0, g1, fourj
!

        h=0.5d0*(b-a)
        gmax=h*(f(a)+f(b))
        g(1)=gmax
        nint=1
        error=1.0d20
        i=0
10        i=i+1
          if (i.gt.MAXITER.or.(i.gt.5.and.abs(error).lt.tol)) &
            go to 40
!  Calculate next trapezoidal rule approximation to integral.
          g0=0._dl
            do 20 k=1,nint
            g0=g0+f(a+(k+k-1)*h)
20        continue
          g0=0.5d0*g(1)+h*g0
          h=0.5d0*h
          nint=nint+nint
          jmax=min(i,MAXJ)
          fourj=1._dl
            do 30 j=1,jmax
!  Use Richardson extrapolation.
            fourj=4._dl*fourj
            g1=g0+(g0-g(j))/(fourj-1._dl)
            g(j)=g0
            g0=g1
30        continue
          if (abs(g0).gt.tol) then
            error=1._dl-gmax/g0
          else
            error=gmax
          end if
          gmax=g0
          g(jmax+1)=g0
        go to 10
40      rombint=g0
        if (i.gt.MAXITER.and.abs(error).gt.tol)  then
          write(*,*) 'Warning: Rombint failed to converge; '
          write (*,*)'integral, error, tol:', rombint,error, tol
        end if
        
        end function rombint


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function rombint_obj(obj,f,a,b,tol, maxit)
        use Precision
!  Rombint returns the integral from a to b of using Romberg integration.
!  The method converges provided that f(x) is continuous in (a,b).
!  f must be real(dl) and must be declared external in the calling
!  routine.  tol indicates the desired relative accuracy in the integral.
!
        implicit none
        integer, intent(in), optional :: maxit
        integer :: MAXITER=20
        integer, parameter :: MAXJ=5
        dimension g(MAXJ+1)
        real obj !dummy
        real(dl) f
        external f
        real(dl) :: rombint_obj
        real(dl), intent(in) :: a,b,tol
        integer :: nint, i, k, jmax, j
        real(dl) :: h, gmax, error, g, g0, g1, fourj
!

        if (present(maxit)) then
            MaxIter = maxit
        end if
        h=0.5d0*(b-a)
        gmax=h*(f(obj,a)+f(obj,b))
        g(1)=gmax
        nint=1
        error=1.0d20
        i=0
10        i=i+1
          if (i.gt.MAXITER.or.(i.gt.5.and.abs(error).lt.tol)) &
            go to 40
!  Calculate next trapezoidal rule approximation to integral.
          g0=0._dl
            do 20 k=1,nint
            g0=g0+f(obj,a+(k+k-1)*h)
20        continue
          g0=0.5d0*g(1)+h*g0
          h=0.5d0*h
          nint=nint+nint
          jmax=min(i,MAXJ)
          fourj=1._dl
            do 30 j=1,jmax
!  Use Richardson extrapolation.
            fourj=4._dl*fourj
            g1=g0+(g0-g(j))/(fourj-1._dl)
            g(j)=g0
            g0=g1
30        continue
          if (abs(g0).gt.tol) then
            error=1._dl-gmax/g0
          else
            error=gmax
          end if
          gmax=g0
          g(jmax+1)=g0
        go to 10
40      rombint_obj=g0
        if (i.gt.MAXITER.and.abs(error).gt.tol)  then
          write(*,*) 'Warning: Rombint failed to converge; '
          write (*,*)'integral, error, tol:', rombint_obj,error, tol
        end if
        
        end function rombint_obj


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! calculates array of second derivatives used by cubic spline
! interpolation. y2 is array of second derivatives, yp1 and ypn are first
! derivatives at end points.


      SUBROUTINE spline(x,y,n,yp1,ypn,y2)
      use Precision
      implicit none
      INTEGER, intent(in) :: n
      real(dl), intent(in) :: x(n), y(n), yp1, ypn
      real(dl), intent(out) :: y2(n)
      INTEGER i,k
      real(dl) p,qn,sig,un
      real(dl), dimension(:), allocatable :: u

       
      Allocate(u(1:n))
      if (yp1.gt..99d30) then
        y2(1)=0._dl
        u(1)=0._dl
      else
        y2(1)=-0.5d0
        u(1)=(3._dl/(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      
      do i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2._dl 
   
        y2(i)=(sig-1._dl)/p
      
         u(i)=(6._dl*((y(i+1)-y(i))/(x(i+ &
         1)-x(i))-(y(i)-y(i-1))/(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig* &
         u(i-1))/p
      end do
      if (ypn.gt..99d30) then
        qn=0._dl
        un=0._dl
      else
        qn=0.5d0
        un=(3._dl/(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1._dl)
      do k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
      end do

      Deallocate(u)
  
!  (C) Copr. 1986-92 Numerical Recipes Software =$j*m,).
      END SUBROUTINE spline


     SUBROUTINE spline_deriv(x,y,y2,y1,n)
     !Get derivative y1 given array of x, y and y''
      use Precision
      implicit none
      INTEGER, intent(in) :: n
      real(dl), intent(in) :: x(n), y(n), y2(n)
      real(dl), intent(out) :: y1(n)
      INTEGER i
      real(dl) dx
   

      do i=1, n-1
           
         dx = (x(i+1) - x(i))
         y1(i) = (y(i+1) - y(i))/dx - dx*(2*y2(i) + y2(i+1))/6
      end do
       dx = x(n) - x(n-1)
       y1(n) = (y(n) - y(n-1))/dx + dx* ( y2(i-1)  + 2*y2(i) )/6

      END SUBROUTINE spline_deriv

      subroutine spline_integrate(x,y,y2,yint,n)
       !Cumulative integral of cubic spline
       use Precision
       integer, intent(in) :: n
       real(dl), intent(in) :: x(n), y(n), y2(n)
       real(dl), intent(out) :: yint(n)
       real(dl) dx
       integer i

       yint(1) = 0
       do i=2, n
           
         dx = (x(i) - x(i-1))
         yint(i) = yint(i-1) + dx*( (y(i)+y(i-1))/2 - dx**2/24*(y2(i)+y2(i-1))) 
          
       end do
       
      end subroutine spline_integrate



!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  this is not the splint given in numerical recipes


        subroutine splint(y,z,n)
        use Precision
!  Splint integrates a cubic spline, providing the output value
!  z = integral from 1 to n of s(i)di, where s(i) is the spline fit
!  to y(i).
!
        implicit none
        integer, intent(in) :: n
        real(dl), intent(in) :: y(n)
        real(dl), intent(out) :: z

        integer :: n1
        real(dl) :: dy1, dyn
!
        n1=n-1
!  Cubic fit to dy/di at boundaries.
!       dy1=(-11._dl*y(1)+18._dl*y(2)-9._dl*y(3)+2._dl*y(4))/6._dl
        dy1=0._dl
        dyn=(11._dl*y(n)-18._dl*y(n1)+9._dl*y(n-2)-2._dl*y(n-3))/6._dl
!
        z=0.5d0*(y(1)+y(n))+(dy1-dyn)/12._dl
        z= z + sum(y(2:n1))
        end subroutine splint


!This version is modified to pass an object parameter to the function on each call
!Fortunately Fortran doesn't do type checking on functions, so we can pretend the
!passed object parameter (EV) is any type we like. In reality it is just a pointer.
      subroutine dverk (EV,n, fcn, x, y, xend, tol, ind, c, nw, w)
      use Precision
      use AMLUtils
      integer n, ind, nw, k
      real(dl) x, y(n), xend, tol, c(*), w(nw,9), temp
      real EV !It isn't, but as long as it maintains it as a pointer we are OK
!     class(*) EV !seems to be correct way to do this in Fortran 2003
!
!***********************************************************************
!                                                                      *
! note added 11/14/85.                                                 *
!                                                                      *
! if you discover any errors in this subroutine, please contact        *
!                                                                      *
!        kenneth r. jackson                                            *
!        department of computer science                                *
!        university of toronto                                         *
!        toronto, ontario,                                             *
!        canada   m5s 1a4                                              *
!                                                                      *
!        phone: 416-978-7075                                           *
!                                                                      *
!        electronic mail:                                              *
!        uucp:   {cornell,decvax,ihnp4,linus,uw-beaver}!utcsri!krj     *
!        csnet:  krj@toronto                                           *
!        arpa:   krj.toronto@csnet-relay                               *
!        bitnet: krj%toronto@csnet-relay.arpa                          *
!                                                                      *
! dverk is written in fortran 66.                                      *
!                                                                      *
! the constants dwarf and rreb -- c(10) and c(11), respectively -- are *
! set for a  vax  in  double  precision.  they  should  be  reset,  as *
! described below, if this program is run on another machine.          *
!                                                                      *
! the c array is declared in this subroutine to have one element only, *
! although  more  elements  are  referenced  in this subroutine.  this *
! causes some compilers to issue warning messages.  there is,  though, *
! no  error  provided  c is declared sufficiently large in the calling *
! program, as described below.                                         *
!                                                                      *
! the following external statement  for  fcn  was  added  to  avoid  a *
! warning  message  from  the  unix  f77 compiler.  the original dverk *
! comments and code follow it.                                         *
!                                                                      *
!***********************************************************************
!
      external fcn
!
!***********************************************************************
!                                                                      *
!     purpose - this is a runge-kutta  subroutine  based  on  verner's *
! fifth and sixth order pair of formulas for finding approximations to *
! the solution of  a  system  of  first  order  ordinary  differential *
! equations  with  initial  conditions. it attempts to keep the global *
! error proportional to  a  tolerance  specified  by  the  user.  (the *
! proportionality  depends  on the kind of error control that is used, *
! as well as the differential equation and the range of integration.)  *
!                                                                      *
!     various options are available to the user,  including  different *
! kinds  of  error control, restrictions on step sizes, and interrupts *
! which permit the user to examine the state of the  calculation  (and *
! perhaps make modifications) during intermediate stages.              *
!                                                                      *
!     the program is efficient for non-stiff systems.  however, a good *
! variable-order-adams  method  will probably be more efficient if the *
! function evaluations are very costly.  such a method would  also  be *
! more suitable if one wanted to obtain a large number of intermediate *
! solution values by interpolation, as might be the case  for  example *
! with graphical output.                                               *
!                                                                      *
!                                    hull-enright-jackson   1/10/76    *
!                                                                      *
!***********************************************************************
!                                                                      *
!     use - the user must specify each of the following                *
!                                                                      *
!     n  number of equations                                           *
!                                                                      *
!   fcn  name of subroutine for evaluating functions - the  subroutine *
!           itself must also be provided by the user - it should be of *
!           the following form                                         *
!              subroutine fcn(n, x, y, yprime)                         *
!              integer n                                               *
!              real(dl) x, y(n), yprime(n)                     *
!                      *** etc ***                                     *
!           and it should evaluate yprime, given n, x and y            *
!                                                                      *
!     x  independent variable - initial value supplied by user         *
!                                                                      *
!     y  dependent variable - initial values of components y(1), y(2), *
!           ..., y(n) supplied by user                                 *
!                                                                      *
!  xend  value of x to which integration is to be carried out - it may *
!           be less than the initial value of x                        *
!                                                                      *
!   tol  tolerance - the subroutine attempts to control a norm of  the *
!           local  error  in  such  a  way  that  the  global error is *
!           proportional to tol. in some problems there will be enough *
!           damping  of  errors, as well as some cancellation, so that *
!           the global error will be less than tol. alternatively, the *
!           control   can   be  viewed  as  attempting  to  provide  a *
!           calculated value of y at xend which is the exact  solution *
!           to  the  problem y' = f(x,y) + e(x) where the norm of e(x) *
!           is proportional to tol.  (the norm  is  a  max  norm  with *
!           weights  that  depend on the error control strategy chosen *
!           by the user.  the default weight for the k-th component is *
!           1/max(1,abs(y(k))),  which therefore provides a mixture of *
!           absolute and relative error control.)                      *
!                                                                      *
!   ind  indicator - on initial entry ind must be set equal to  either *
!           1  or  2. if the user does not wish to use any options, he *
!           should set ind to 1 - all that remains for the user to  do *
!           then  is  to  declare c and w, and to specify nw. the user *
!           may also  select  various  options  on  initial  entry  by *
!           setting ind = 2 and initializing the first 9 components of *
!           c as described in the next section.  he may also  re-enter *
!           the  subroutine  with ind = 3 as mentioned again below. in *
!           any event, the subroutine returns with ind equal to        *
!              3 after a normal return                                 *
!              4, 5, or 6 after an interrupt (see options c(8), c(9))  *
!              -1, -2, or -3 after an error condition (see below)      *
!                                                                      *
!     c  communications vector - the dimension must be greater than or *
!           equal to 24, unless option c(1) = 4 or 5 is used, in which *
!           case the dimension must be greater than or equal to n+30   *
!                                                                      *
!    nw  first dimension of workspace w -  must  be  greater  than  or *
!           equal to n                                                 *
!                                                                      *
!     w  workspace matrix - first dimension must be nw and second must *
!           be greater than or equal to 9                              *
!                                                                      *
!     the subroutine  will  normally  return  with  ind  =  3,  having *
! replaced the initial values of x and y with, respectively, the value *
! of xend and an approximation to y at xend.  the  subroutine  can  be *
! called  repeatedly  with new values of xend without having to change *
! any other argument.  however, changes in tol, or any of the  options *
! described below, may also be made on such a re-entry if desired.     *
!                                                                      *
!     three error returns are also possible, in which  case  x  and  y *
! will be the most recently accepted values -                          *
!     with ind = -3 the subroutine was unable  to  satisfy  the  error *
!        requirement  with a particular step-size that is less than or *
!        equal to hmin, which may mean that tol is too small           *
!     with ind = -2 the value of hmin  is  greater  than  hmax,  which *
!        probably  means  that the requested tol (which is used in the *
!        calculation of hmin) is too small                             *
!     with ind = -1 the allowed maximum number of fcn evaluations  has *
!        been  exceeded,  but  this  can only occur if option c(7), as *
!        described in the next section, has been used                  *
!                                                                      *
!     there are several circumstances that will cause the calculations *
! to  be  terminated,  along with output of information that will help *
! the user determine the cause of  the  trouble.  these  circumstances *
! involve  entry with illegal or inconsistent values of the arguments, *
! such as attempting a normal  re-entry  without  first  changing  the *
! value of xend, or attempting to re-enter with ind less than zero.    *
!                                                                      *
!***********************************************************************
!                                                                      *
!     options - if the subroutine is entered with ind = 1, the first 9 *
! components of the communications vector are initialized to zero, and *
! the subroutine uses only default values  for  each  option.  if  the *
! subroutine  is  entered  with ind = 2, the user must specify each of *
! these 9 components - normally he would first set them all  to  zero, *
! and  then  make  non-zero  those  that  correspond to the particular *
! options he wishes to select. in any event, options may be changed on *
! re-entry  to  the  subroutine  -  but if the user changes any of the *
! options, or tol, in the course of a calculation he should be careful *
! about  how  such changes affect the subroutine - it may be better to *
! restart with ind = 1 or 2. (components 10 to 24 of c are used by the *
! program  -  the information is available to the user, but should not *
! normally be changed by him.)                                         *
!                                                                      *
!  c(1)  error control indicator - the norm of the local error is  the *
!           max  norm  of  the  weighted  error  estimate  vector, the *
!           weights being determined according to the value of c(1) -  *
!              if c(1)=1 the weights are 1 (absolute error control)    *
!              if c(1)=2 the weights are 1/abs(y(k))  (relative  error *
!                 control)                                             *
!              if c(1)=3 the  weights  are  1/max(abs(c(2)),abs(y(k))) *
!                 (relative  error  control,  unless abs(y(k)) is less *
!                 than the floor value, abs(c(2)) )                    *
!              if c(1)=4 the weights are 1/max(abs(c(k+30)),abs(y(k))) *
!                 (here individual floor values are used)              *
!              if c(1)=5 the weights are 1/abs(c(k+30))                *
!              for all other values of c(1), including  c(1) = 0,  the *
!                 default  values  of  the  weights  are  taken  to be *
!                 1/max(1,abs(y(k))), as mentioned earlier             *
!           (in the two cases c(1) = 4 or 5 the user must declare  the *
!           dimension of c to be at least n+30 and must initialize the *
!           components c(31), c(32), ..., c(n+30).)                    *
!                                                                      *
!  c(2)  floor value - used when the indicator c(1) has the value 3    *
!                                                                      *
!  c(3)  hmin specification - if not zero, the subroutine chooses hmin *
!           to be abs(c(3)) - otherwise it uses the default value      *
!              10*max(dwarf,rreb*max(weighted norm y/tol,abs(x))),     *
!           where dwarf is a very small positive  machine  number  and *
!           rreb is the relative roundoff error bound                  *
!                                                                      *
!  c(4)  hstart specification - if not zero, the subroutine  will  use *
!           an  initial  hmag equal to abs(c(4)), except of course for *
!           the restrictions imposed by hmin and hmax  -  otherwise it *
!           uses the default value of hmax*(tol)**(1/6)                *
!                                                                      *
!  c(5)  scale specification - this is intended to be a measure of the *
!           scale of the problem - larger values of scale tend to make *
!           the method more reliable, first  by  possibly  restricting *
!           hmax  (as  described  below) and second, by tightening the *
!           acceptance requirement - if c(5) is zero, a default  value *
!           of  1  is  used.  for  linear  homogeneous  problems  with *
!           constant coefficients, an appropriate value for scale is a *
!           norm  of  the  associated  matrix.  for other problems, an *
!           approximation to  an  average  value  of  a  norm  of  the *
!           jacobian along the trajectory may be appropriate           *
!                                                                      *
!  c(6)  hmax specification - four cases are possible                  *
!           if c(6).ne.0 and c(5).ne.0, hmax is taken to be            *
!              min(abs(c(6)),2/abs(c(5)))                              *
!           if c(6).ne.0 and c(5).eq.0, hmax is taken to be  abs(c(6)) *
!           if c(6).eq.0 and c(5).ne.0, hmax is taken to be            *
!              2/abs(c(5))                                             *
!           if c(6).eq.0 and c(5).eq.0, hmax is given a default  value *
!              of 2                                                    *
!                                                                      *
!  c(7)  maximum number of function evaluations  -  if  not  zero,  an *
!           error  return with ind = -1 will be caused when the number *
!           of function evaluations exceeds abs(c(7))                  *
!                                                                      *
!  c(8)  interrupt number  1  -  if  not  zero,  the  subroutine  will *
!           interrupt   the  calculations  after  it  has  chosen  its *
!           preliminary value of hmag, and just before choosing htrial *
!           and  xtrial  in  preparation for taking a step (htrial may *
!           differ from hmag in sign, and may  require  adjustment  if *
!           xend  is  near) - the subroutine returns with ind = 4, and *
!           will resume calculation at the point  of  interruption  if *
!           re-entered with ind = 4                                    *
!                                                                      *
!  c(9)  interrupt number  2  -  if  not  zero,  the  subroutine  will *
!           interrupt   the  calculations  immediately  after  it  has *
!           decided whether or not to accept the result  of  the  most *
!           recent  trial step, with ind = 5 if it plans to accept, or *
!           ind = 6 if it plans to reject -  y(*)  is  the  previously *
!           accepted  result, while w(*,9) is the newly computed trial *
!           value, and w(*,2) is the unweighted error estimate vector. *
!           the  subroutine  will  resume calculations at the point of *
!           interruption on re-entry with ind = 5 or 6. (the user  may *
!           change ind in this case if he wishes, for example to force *
!           acceptance of a step that would otherwise be rejected,  or *
!           vice versa. he can also restart with ind = 1 or 2.)        *
!                                                                      *
!***********************************************************************
!                                                                      *
!  summary of the components of the communications vector              *
!                                                                      *
!     prescribed at the option       determined by the program         *
!           of the user                                                *
!                                                                      *
!                                    c(10) rreb(rel roundoff err bnd)  *
!     c(1) error control indicator   c(11) dwarf (very small mach no)  *
!     c(2) floor value               c(12) weighted norm y             *
!     c(3) hmin specification        c(13) hmin                        *
!     c(4) hstart specification      c(14) hmag                        *
!     c(5) scale specification       c(15) scale                       *
!     c(6) hmax specification        c(16) hmax                        *
!     c(7) max no of fcn evals       c(17) xtrial                      *
!     c(8) interrupt no 1            c(18) htrial                      *
!     c(9) interrupt no 2            c(19) est                         *
!                                    c(20) previous xend               *
!                                    c(21) flag for xend               *
!                                    c(22) no of successful steps      *
!                                    c(23) no of successive failures   *
!                                    c(24) no of fcn evals             *
!                                                                      *
!  if c(1) = 4 or 5, c(31), c(32), ... c(n+30) are floor values        *
!                                                                      *
!***********************************************************************
!                                                                      *
!  an overview of the program                                          *
!                                                                      *
!     begin initialization, parameter checking, interrupt re-entries   *
!  ......abort if ind out of range 1 to 6                              *
!  .     cases - initial entry, normal re-entry, interrupt re-entries  *
!  .     case 1 - initial entry (ind .eq. 1 or 2)                      *
!  v........abort if n.gt.nw or tol.le.0                               *
!  .        if initial entry without options (ind .eq. 1)              *
!  .           set c(1) to c(9) equal to zero                          *
!  .        else initial entry with options (ind .eq. 2)               *
!  .           make c(1) to c(9) non-negative                          *
!  .           make floor values non-negative if they are to be used   *
!  .        end if                                                     *
!  .        initialize rreb, dwarf, prev xend, flag, counts            *
!  .     case 2 - normal re-entry (ind .eq. 3)                         *
!  .........abort if xend reached, and either x changed or xend not    *
!  .        re-initialize flag                                         *
!  .     case 3 - re-entry following an interrupt (ind .eq. 4 to 6)    *
!  v        transfer control to the appropriate re-entry point.......  *
!  .     end cases                                                  .  *
!  .  end initialization, etc.                                      .  *
!  .                                                                v  *
!  .  loop through the following 4 stages, once for each trial step .  *
!  .     stage 1 - prepare                                          .  *
!***********error return (with ind=-1) if no of fcn evals too great .  *
!  .        calc slope (adding 1 to no of fcn evals) if ind .ne. 6  .  *
!  .        calc hmin, scale, hmax                                  .  *
!***********error return (with ind=-2) if hmin .gt. hmax            .  *
!  .        calc preliminary hmag                                   .  *
!***********interrupt no 1 (with ind=4) if requested.......re-entry.v  *
!  .        calc hmag, xtrial and htrial                            .  *
!  .     end stage 1                                                .  *
!  v     stage 2 - calc ytrial (adding 7 to no of fcn evals)        .  *
!  .     stage 3 - calc the error estimate                          .  *
!  .     stage 4 - make decisions                                   .  *
!  .        set ind=5 if step acceptable, else set ind=6            .  *
!***********interrupt no 2 if requested....................re-entry.v  *
!  .        if step accepted (ind .eq. 5)                              *
!  .           update x, y from xtrial, ytrial                         *
!  .           add 1 to no of successful steps                         *
!  .           set no of successive failures to zero                   *
!**************return(with ind=3, xend saved, flag set) if x .eq. xend *
!  .        else step not accepted (ind .eq. 6)                        *
!  .           add 1 to no of successive failures                      *
!**************error return (with ind=-3) if hmag .le. hmin            *
!  .        end if                                                     *
!  .     end stage 4                                                   *
!  .  end loop                                                         *
!  .                                                                   *
!  begin abort action                                                  *
!     output appropriate  message  about  stopping  the  calculations, *
!        along with values of ind, n, nw, tol, hmin,  hmax,  x,  xend, *
!        previous xend,  no of  successful  steps,  no  of  successive *
!        failures, no of fcn evals, and the components of y            *
!     stop                                                             *
!  end abort action                                                    *
!                                                                      *
!***********************************************************************
!
!     ******************************************************************
!     * begin initialization, parameter checking, interrupt re-entries *
!     ******************************************************************
!
!  ......abort if ind out of range 1 to 6
         if (ind.lt.1 .or. ind.gt.6) go to 500
!
!        cases - initial entry, normal re-entry, interrupt re-entries
!         go to (5, 5, 45, 1111, 2222, 2222), ind
         if (ind==3) goto 45
         if (ind==4) goto 1111
         if (ind==5 .or. ind==6) goto 2222

!        case 1 - initial entry (ind .eq. 1 or 2)
!  .........abort if n.gt.nw or tol.le.0
            if (n.gt.nw .or. tol.le.0._dl) go to 500
            if (ind.eq. 2) go to 15
!              initial entry without options (ind .eq. 1)
!              set c(1) to c(9) equal to 0
               do k = 1, 9
                  c(k) = 0._dl
               end do
               go to 35
   15       continue
!              initial entry with options (ind .eq. 2)
!              make c(1) to c(9) non-negative
               do k = 1, 9
                  c(k) = dabs(c(k))
               end do
!              make floor values non-negative if they are to be used
               if (c(1).ne.4._dl .and. c(1).ne.5._dl) go to 30
                  do k = 1, n
                     c(k+30) = dabs(c(k+30))
                  end do
   30          continue
   35       continue
!           initialize rreb, dwarf, prev xend, flag, counts
            c(10) = 2._dl**(-56)
            c(11) = 1.d-35
!           set previous xend initially to initial value of x
            c(20) = x
            do k = 21, 24
               c(k) = 0._dl
            end do
            go to 50
!        case 2 - normal re-entry (ind .eq. 3)
!  .........abort if xend reached, and either x changed or xend not
   45       if (c(21).ne.0._dl .and. &
                              (x.ne.c(20) .or. xend.eq.c(20))) go to 500
!           re-initialize flag
            c(21) = 0._dl
            go to 50
!        case 3 - re-entry following an interrupt (ind .eq. 4 to 6)
!           transfer control to the appropriate re-entry point..........
!           this has already been handled by the computed go to        .
!        end cases                                                     v
   50    continue
!
!     end initialization, etc.
!
!     ******************************************************************
!     * loop through the following 4 stages, once for each trial  step *
!     * until the occurrence of one of the following                   *
!     *    (a) the normal return (with ind .eq. 3) on reaching xend in *
!     *        stage 4                                                 *
!     *    (b) an error return (with ind .lt. 0) in stage 1 or stage 4 *
!     *    (c) an interrupt return (with ind  .eq.  4,  5  or  6),  if *
!     *        requested, in stage 1 or stage 4                        *
!     ******************************************************************
!
99999 continue
!
!        ***************************************************************
!        * stage 1 - prepare - do calculations of  hmin,  hmax,  etc., *
!        * and some parameter  checking,  and  end  up  with  suitable *
!        * values of hmag, xtrial and htrial in preparation for taking *
!        * an integration step.                                        *
!        ***************************************************************
!
!***********error return (with ind=-1) if no of fcn evals too great
            if (c(7).eq.0._dl .or. c(24).lt.c(7)) go to 100
               ind = -1
               return
  100       continue
!
!           calculate slope (adding 1 to no of fcn evals) if ind .ne. 6
            if (ind .eq. 6) go to 105
               call fcn(EV,n, x, y, w(1,1))
               c(24) = c(24) + 1._dl
  105       continue
!
!           calculate hmin - use default unless value prescribed
            c(13) = c(3)
            if (c(3) .ne. 0._dl) go to 165
!              calculate default value of hmin
!              first calculate weighted norm y - c(12) - as specified
!              by the error control indicator c(1)
               temp = 0._dl
               if (c(1) .ne. 1._dl) go to 115
!                 absolute error control - weights are 1
                  do 110 k = 1, n
                     temp = dmax1(temp, dabs(y(k)))
  110             continue
                  c(12) = temp
                  go to 160
  115          if (c(1) .ne. 2._dl) go to 120
!                 relative error control - weights are 1/dabs(y(k)) so
!                 weighted norm y is 1
                  c(12) = 1._dl
                  go to 160
  120          if (c(1) .ne. 3._dl) go to 130
!                 weights are 1/max(c(2),abs(y(k)))
                  do 125 k = 1, n
                     temp = dmax1(temp, dabs(y(k))/c(2))
  125             continue
                  c(12) = dmin1(temp, 1._dl)
                  go to 160
  130          if (c(1) .ne. 4._dl) go to 140
!                 weights are 1/max(c(k+30),abs(y(k)))
                  do 135 k = 1, n
                     temp = dmax1(temp, dabs(y(k))/c(k+30))
  135             continue
                  c(12) = dmin1(temp, 1._dl)
                  go to 160
  140          if (c(1) .ne. 5._dl) go to 150
!                 weights are 1/c(k+30)
                  do 145 k = 1, n
                     temp = dmax1(temp, dabs(y(k))/c(k+30))
  145             continue
                  c(12) = temp
                  go to 160
  150          continue
!                 default case - weights are 1/max(1,abs(y(k)))
                  do 155 k = 1, n
                     temp = dmax1(temp, dabs(y(k)))
  155             continue
                  c(12) = dmin1(temp, 1._dl)
  160          continue
               c(13) = 10._dl*dmax1(c(11),c(10)*dmax1(c(12)/tol,dabs(x)))
  165       continue
!
!           calculate scale - use default unless value prescribed
            c(15) = c(5)
            if (c(5) .eq. 0._dl) c(15) = 1._dl
!
!           calculate hmax - consider 4 cases
!           case 1 both hmax and scale prescribed
               if (c(6).ne.0._dl .and. c(5).ne.0._dl) &
                                          c(16) = dmin1(c(6), 2._dl/c(5))
!           case 2 - hmax prescribed, but scale not
               if (c(6).ne.0._dl .and. c(5).eq.0._dl) c(16) = c(6)
!           case 3 - hmax not prescribed, but scale is
               if (c(6).eq.0._dl .and. c(5).ne.0._dl) c(16) = 2._dl/c(5)
!           case 4 - neither hmax nor scale is provided
               if (c(6).eq.0._dl .and. c(5).eq.0._dl) c(16) = 2._dl
!
!***********error return (with ind=-2) if hmin .gt. hmax
            if (c(13) .le. c(16)) go to 170
               ind = -2
               return
  170       continue
!
!           calculate preliminary hmag - consider 3 cases
            if (ind .gt. 2) go to 175
!           case 1 - initial entry - use prescribed value of hstart, if
!              any, else default
               c(14) = c(4)
               if (c(4) .eq. 0._dl) c(14) = c(16)*tol**(1._dl/6._dl)
               go to 185
  175       if (c(23) .gt. 1._dl) go to 180
!           case 2 - after a successful step, or at most  one  failure,
!              use min(2, .9*(tol/est)**(1/6))*hmag, but avoid possible
!              overflow. then avoid reduction by more than half.
               temp = 2._dl*c(14)
               if (tol .lt. (2._dl/.9d0)**6*c(19)) &
                       temp = .9d0*(tol/c(19))**(1._dl/6._dl)*c(14)
               c(14) = dmax1(temp, .5d0*c(14))
               go to 185
  180       continue
!           case 3 - after two or more successive failures
               c(14) = .5d0*c(14)
  185       continue
!
!           check against hmax
            c(14) = dmin1(c(14), c(16))
!
!           check against hmin
            c(14) = dmax1(c(14), c(13))
!
!***********interrupt no 1 (with ind=4) if requested
            if (c(8) .eq. 0._dl) go to 1111
               ind = 4
               return
!           resume here on re-entry with ind .eq. 4   ........re-entry..
 1111       continue
!
!           calculate hmag, xtrial - depending on preliminary hmag, xend
            if (c(14) .ge. dabs(xend - x)) go to 190
!              do not step more than half way to xend
               c(14) = dmin1(c(14), .5d0*dabs(xend - x))
               c(17) = x + dsign(c(14), xend - x)
               go to 195
  190       continue
!              hit xend exactly
               c(14) = dabs(xend - x)
               c(17) = xend
  195       continue
!
!           calculate htrial
            c(18) = c(17) - x
!
!        end stage 1
!
!        ***************************************************************
!        * stage 2 - calculate ytrial (adding 7 to no of  fcn  evals). *
!        * w(*,2), ... w(*,8)  hold  intermediate  results  needed  in *
!        * stage 3. w(*,9) is temporary storage until finally it holds *
!        * ytrial.                                                     *
!        ***************************************************************
!
            temp = c(18)/1398169080000._dl
!
            do 200 k = 1, n
               w(k,9) = y(k) + temp*w(k,1)*233028180000._dl
  200       continue
            call fcn(EV,n, x + c(18)/6._dl, w(1,9), w(1,2))
!
            do 205 k = 1, n
               w(k,9) = y(k) + temp*(   w(k,1)*74569017600._dl &
                                      + w(k,2)*298276070400._dl  )
  205       continue
            call fcn(EV,n, x + c(18)*(4._dl/15._dl), w(1,9), w(1,3))
!
            do 210 k = 1, n
               w(k,9) = y(k) + temp*(   w(k,1)*1165140900000._dl &
                                      - w(k,2)*3728450880000._dl &
                                      + w(k,3)*3495422700000._dl )
  210       continue
            call fcn(EV,n, x + c(18)*(2._dl/3._dl), w(1,9), w(1,4))
!
            do 215 k = 1, n
               w(k,9) = y(k) + temp*( - w(k,1)*3604654659375._dl &
                                      + w(k,2)*12816549900000._dl &
                                      - w(k,3)*9284716546875._dl &
                                      + w(k,4)*1237962206250._dl )
  215       continue
            call fcn(EV,n, x + c(18)*(5._dl/6._dl), w(1,9), w(1,5))
!
            do 220 k = 1, n
               w(k,9) = y(k) + temp*(   w(k,1)*3355605792000._dl &
                                      - w(k,2)*11185352640000._dl &
                                      + w(k,3)*9172628850000._dl &
                                      - w(k,4)*427218330000._dl &
                                      + w(k,5)*482505408000._dl  )
  220       continue
            call fcn(EV,n, x + c(18), w(1,9), w(1,6))
!
            do 225 k = 1, n
               w(k,9) = y(k) + temp*( - w(k,1)*770204740536._dl &
                                      + w(k,2)*2311639545600._dl &
                                      - w(k,3)*1322092233000._dl &
                                      - w(k,4)*453006781920._dl &
                                      + w(k,5)*326875481856._dl  )
  225       continue
            call fcn(EV,n, x + c(18)/15._dl, w(1,9), w(1,7))
!
            do 230 k = 1, n
               w(k,9) = y(k) + temp*(   w(k,1)*2845924389000._dl &
                                      - w(k,2)*9754668000000._dl &
                                      + w(k,3)*7897110375000._dl &
                                      - w(k,4)*192082660000._dl &
                                      + w(k,5)*400298976000._dl &
                                      + w(k,7)*201586000000._dl  )
  230       continue
            call fcn(EV,n, x + c(18), w(1,9), w(1,8))
!
!           calculate ytrial, the extrapolated approximation and store
!              in w(*,9)
            do 235 k = 1, n
               w(k,9) = y(k) + temp*(   w(k,1)*104862681000._dl &
                                      + w(k,3)*545186250000._dl &
                                      + w(k,4)*446637345000._dl &
                                      + w(k,5)*188806464000._dl &
                                      + w(k,7)*15076875000._dl &
                                      + w(k,8)*97599465000._dl   )
  235       continue
!
!           add 7 to the no of fcn evals
            c(24) = c(24) + 7._dl
!
!        end stage 2
!
!        ***************************************************************
!        * stage 3 - calculate the error estimate est. first calculate *
!        * the  unweighted  absolute  error  estimate vector (per unit *
!        * step) for the unextrapolated approximation and store it  in *
!        * w(*,2).  then  calculate the weighted max norm of w(*,2) as *
!        * specified by the error  control  indicator  c(1).  finally, *
!        * modify  this result to produce est, the error estimate (per *
!        * unit step) for the extrapolated approximation ytrial.       *
!        ***************************************************************
!
!           calculate the unweighted absolute error estimate vector
            do 300 k = 1, n
               w(k,2) = (   w(k,1)*8738556750._dl &
                          + w(k,3)*9735468750._dl &
                          - w(k,4)*9709507500._dl &
                          + w(k,5)*8582112000._dl &
                          + w(k,6)*95329710000._dl &
                          - w(k,7)*15076875000._dl &
                          - w(k,8)*97599465000._dl)/1398169080000._dl
  300       continue
!
!           calculate the weighted max norm of w(*,2) as specified by
!           the error control indicator c(1)
            temp = 0._dl
            if (c(1) .ne. 1._dl) go to 310
!              absolute error control
               do 305 k = 1, n
                  temp = dmax1(temp,dabs(w(k,2)))
  305          continue
               go to 360
  310       if (c(1) .ne. 2._dl) go to 320
!              relative error control
               do 315 k = 1, n
                  temp = dmax1(temp, dabs(w(k,2)/y(k)))
  315          continue
               go to 360
  320       if (c(1) .ne. 3._dl) go to 330
!              weights are 1/max(c(2),abs(y(k)))
               do 325 k = 1, n
                  temp = dmax1(temp, dabs(w(k,2)) &
                                   / dmax1(c(2), dabs(y(k))) )
  325          continue
               go to 360
  330       if (c(1) .ne. 4._dl) go to 340
!              weights are 1/max(c(k+30),abs(y(k)))
               do 335 k = 1, n
                  temp = dmax1(temp, dabs(w(k,2)) &
                                   / dmax1(c(k+30), dabs(y(k))) )
  335          continue
               go to 360
  340       if (c(1) .ne. 5._dl) go to 350
!              weights are 1/c(k+30)
               do 345 k = 1, n
                  temp = dmax1(temp, dabs(w(k,2)/c(k+30)))
  345          continue
               go to 360
  350       continue
!              default case - weights are 1/max(1,abs(y(k)))
               do 355 k = 1, n
                  temp = dmax1(temp, dabs(w(k,2)) &
                                   / dmax1(1._dl, dabs(y(k))) )
  355          continue
  360       continue
!
!           calculate est - (the weighted max norm of w(*,2))*hmag*scale
!              - est is intended to be a measure of the error  per  unit
!              step in ytrial
            c(19) = temp*c(14)*c(15)
!
!        end stage 3
!
!        ***************************************************************
!        * stage 4 - make decisions.                                   *
!        ***************************************************************
!
!           set ind=5 if step acceptable, else set ind=6
            ind = 5
            if (c(19) .gt. tol) ind = 6
!
!***********interrupt no 2 if requested
            if (c(9) .eq. 0._dl) go to 2222
               return
!           resume here on re-entry with ind .eq. 5 or 6   ...re-entry..
 2222       continue
!
            if (ind .eq. 6) go to 410
!              step accepted (ind .eq. 5), so update x, y from xtrial,
!                 ytrial, add 1 to the no of successful steps, and set
!                 the no of successive failures to zero
               x = c(17)
               do 400 k = 1, n
                  y(k) = w(k,9)
  400          continue
               c(22) = c(22) + 1._dl
               c(23) = 0._dl
!**************return(with ind=3, xend saved, flag set) if x .eq. xend
               if (x .ne. xend) go to 405
                  ind = 3
                  c(20) = xend
                  c(21) = 1._dl
                  return
  405          continue
               go to 420
  410       continue
!              step not accepted (ind .eq. 6), so add 1 to the no of
!                 successive failures
               c(23) = c(23) + 1._dl
!**************error return (with ind=-3) if hmag .le. hmin
               if (c(14) .gt. c(13)) go to 415
                  ind = -3
                  return
  415          continue
  420       continue
!
!        end stage 4
!
      go to 99999
!     end loop
!
!  begin abort action
  500 continue
!

      write (*,*) 'Error in dverk, x =',x, 'xend=', xend
      call MpiStop()
!
!  end abort action
!
      end subroutine dverk

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gvphi(angle,v,rp,cm,np,rpi,cmi,vi,tol,phi,iord)
      integer np
      real*10 angle,v(3),rp(3,np),cm(np),rpi(3),cmi,vi(3),tol
c        work arrays (could be automatic if compiler supports it)
      integer iord(2*np)
      real*10 phi(2,np)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        externals
      integer gsegij,gzeroar
c        data variables
      real*10 big
c        local (automatic) variables
      integer i,iphin,iseg,j,jm,jml,jmu,jp,jpl,jpu,km,kp,ni,scmi
      real*10 dph,dphin,dphinmn,ph,phin,phm,php,
     *  si,xi(3),xv,yi(3),yv,zv
c *
c * This routine is mostly lifted from gphi and gvert.
c *
c * Point at centre of segment of circle
c *    1 - r.rpi = cmi
c * containing, or otherwise closest to, point vi,
c * lying inside
c *    1 - r.rp(j) <= cm(j)  (if cm(j).ge.0)
c *    1 - r.rp(j) > -cm(j)  (if cm(j).lt.0)
c * for j=1,np where rp(j) are unit directions.
c *
c  Input: rp(3,j),j=1,np
c         cm(j),j=1,np
c         np
c         rpi(3)
c         cmi
c         vi(3) = unit vector desired to lie inside,
c                 or closest to, segment.
c         tol
c Output: angle = angular length of segment of circle
c               = 0. if boundary lies entirely outside circle.
c         v(3) = unit vector at centre of segment of circle.
c Work arrays: phi and iord should be dimensioned at least 2*np
c
      data big /1.e6_10/
c
c        initialise length of segment to zero
      angle=0._10
c        initialise point at centre of segment to zero
      v(1)=0._10
      v(2)=0._10
      v(3)=0._10
c        check for null circle
      if (cmi.lt.0._10) goto 410
      if (cmi.gt.2._10) goto 410
c        check for zero angle because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        initialise dphinmn to impossibly large value
      dphinmn=big
c........si = sin thi
      scmi=1
      si=sqrt(cmi*(2._10-cmi))
c........construct cartesian axes with z-axis along rpi
      call gaxisi(rpi,xi,yi)
c........azimuthal angle closest to vector vi
      xv=xi(1)*vi(1)+xi(2)*vi(2)+xi(3)*vi(3)
      yv=yi(1)*vi(1)+yi(2)*vi(2)+yi(3)*vi(3)
      phin=atan2(yv,xv)
c........angles phi about z-axis rp(i) of intersection of i & j circles
c        passing i=0 means circle at edge is considered outside polygon
      call gphij(rp,cm,np,0,rpi,scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside (or at edge of) polygon
      if (ni.le.-1) goto 410
c........order angles around circle
c        circle has no intersections
      if (ni.eq.0) then
        angle=TWOPI
        ph=phin
        xv=si*cos(ph)
        yv=si*sin(ph)
        zv=1._10-cmi
        v(1)=zv*rpi(1)+xv*xi(1)+yv*yi(1)
        v(2)=zv*rpi(2)+xv*xi(2)+yv*yi(2)
        v(3)=zv*rpi(3)+xv*xi(3)+yv*yi(3)
c        circle has intersections
      elseif (ni.gt.0) then
c        find ordering of intersection angles around circle
        call findbot(phi,2*np,iord,ni)
c........vertices around i circle
        jpl=0
c        come here to do another segment
  220   continue
c........is segment edge of polygon?
          iseg=gsegij(rp,cm,np,0,0,i,rpi,scmi,cmi,tol,ni,
     *      phi,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
c        error
          if (iseg.eq.-1) goto 420
c        not an edge
          if (iseg.eq.0) goto 220
c        gone full circle
          if (iseg.eq.2) goto 280
c........segment satisfies conditions
c         print *,'segment',km,kp,
c    *      ' (',jm,' in',jml,jmu,',',jp,' in',jpl,jpu,' of',ni,')',
c    *      ' ph=',real(ph),' dph=',real(dph)
c        phase phin to central point ph
          iphin=nint((phin-ph)/TWOPI)
          phin=phin-iphin*TWOPI
          if (phm.le.phin.and.phin.le.php) then
            dphin=0._10
          elseif (phm.gt.phin) then
            dphin=phm-phin
          elseif (phin.gt.php) then
            dphin=phin-php
          endif
c        segment contains or is closest to phin
          if (dphin.lt.dphinmn) then
            dphinmn=dphin
            angle=dph
c        coords of centre of edge in frame where axes are xi, yi, rp
            xv=si*cos(ph)
            yv=si*sin(ph)
            zv=1._10-cmi
            v(1)=zv*rpi(1)+xv*xi(1)+yv*yi(1)
            v(2)=zv*rpi(2)+xv*xi(2)+yv*yi(2)
            v(3)=zv*rpi(3)+xv*xi(3)+yv*yi(3)
c        segment contains phin, so cannot be beaten
            if (dphin.eq.0._10) goto 280
          endif
c        do another segment
        goto 220
      endif
  280 continue
      return
c
c        zero angle
  410 continue
      return
c
  420 print *,'*** from gvphi: total failure at tol =',tol
      write (*,'(a3,a20,4a24)')
     *  ' ','x','y','z',
c    *  'r',
     *  '1-c'
      do j=1,np
        write (*,'(i3,5g24.16)')
     *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *    cm(j)
      enddo
      write (*,'(i3,5g24.16)')
     *  0,(rpi(i),i=1,3),
c    *  sqrt(rpi(1)**2+rpi(2)**2+rpi(3)**2),
     *  cmi
      return
c
      end
c

      subroutine dqage(f,a,b,epsabs,epsrel,key,limit,result,abserr,
     *   neval,ier,alist,blist,rlist,elist,iord,last)
c***begin prologue  dqage
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a1
c***keywords  automatic integrator, general-purpose,
c             integrand examinator, globally adaptive,
c             gauss-kronrod
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  the routine calculates an approximation result to a given
c            definite integral   i = integral of f over (a,b),
c            hopefully satisfying following claim for accuracy
c            abs(i-reslt).le.max(epsabs,epsrel*abs(i)).
c***description
c
c        computation of a definite integral
c        standard fortran subroutine
c        double precision version
c
c        parameters
c         on entry
c            f      - double precision
c                     function subprogram defining the integrand
c                     function f(x). the actual name for f needs to be
c                     declared e x t e r n a l in the driver program.
c
c            a      - double precision
c                     lower limit of integration
c
c            b      - double precision
c                     upper limit of integration
c
c            epsabs - double precision
c                     absolute accuracy requested
c            epsrel - double precision
c                     relative accuracy requested
c                     if  epsabs.le.0
c                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                     the routine will end with ier = 6.
c
c            key    - integer
c                     key for choice of local integration rule
c                     a gauss-kronrod pair is used with
c                          7 - 15 points if key.lt.2,
c                         10 - 21 points if key = 2,
c                         15 - 31 points if key = 3,
c                         20 - 41 points if key = 4,
c                         25 - 51 points if key = 5,
c                         30 - 61 points if key.gt.5.
c
c            limit  - integer
c                     gives an upperbound on the number of subintervals
c                     in the partition of (a,b), limit.ge.1.
c
c         on return
c            result - double precision
c                     approximation to the integral
c
c            abserr - double precision
c                     estimate of the modulus of the absolute error,
c                     which should equal or exceed abs(i-result)
c
c            neval  - integer
c                     number of integrand evaluations
c
c            ier    - integer
c                     ier = 0 normal and reliable termination of the
c                             routine. it is assumed that the requested
c                             accuracy has been achieved.
c                     ier.gt.0 abnormal termination of the routine
c                             the estimates for result and error are
c                             less reliable. it is assumed that the
c                             requested accuracy has not been achieved.
c            error messages
c                     ier = 1 maximum number of subdivisions allowed
c                             has been achieved. one can allow more
c                             subdivisions by increasing the value
c                             of limit.
c                             however, if this yields no improvement it
c                             is rather advised to analyze the integrand
c                             in order to determine the integration
c                             difficulties. if the position of a local
c                             difficulty can be determined(e.g.
c                             singularity, discontinuity within the
c                             interval) one will probably gain from
c                             splitting up the interval at this point
c                             and calling the integrator on the
c                             subranges. if possible, an appropriate
c                             special-purpose integrator should be used
c                             which is designed for handling the type of
c                             difficulty involved.
c                         = 2 the occurrence of roundoff error is
c                             detected, which prevents the requested
c                             tolerance from being achieved.
c                         = 3 extremely bad integrand behaviour occurs
c                             at some points of the integration
c                             interval.
c                         = 6 the input is invalid, because
c                             (epsabs.le.0 and
c                              epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                             result, abserr, neval, last, rlist(1) ,
c                             elist(1) and iord(1) are set to zero.
c                             alist(1) and blist(1) are set to a and b
c                             respectively.
c
c            alist   - double precision
c                      vector of dimension at least limit, the first
c                       last  elements of which are the left
c                      end points of the subintervals in the partition
c                      of the given integration range (a,b)
c
c            blist   - double precision
c                      vector of dimension at least limit, the first
c                       last  elements of which are the right
c                      end points of the subintervals in the partition
c                      of the given integration range (a,b)
c
c            rlist   - double precision
c                      vector of dimension at least limit, the first
c                       last  elements of which are the
c                      integral approximations on the subintervals
c
c            elist   - double precision
c                      vector of dimension at least limit, the first
c                       last  elements of which are the moduli of the
c                      absolute error estimates on the subintervals
c
c            iord    - integer
c                      vector of dimension at least limit, the first k
c                      elements of which are pointers to the
c                      error estimates over the subintervals,
c                      such that elist(iord(1)), ...,
c                      elist(iord(k)) form a decreasing sequence,
c                      with k = last if last.le.(limit/2+2), and
c                      k = limit+1-last otherwise
c
c            last    - integer
c                      number of subintervals actually produced in the
c                      subdivision process
c
c***references  (none)
c***routines called  d1mach,dqk15,dqk21,dqk31,
c                    dqk41,dqk51,dqk61,dqpsrt
c***end prologue  dqage
c
      double precision a,abserr,alist,area,area1,area12,area2,a1,a2,b,
     *  blist,b1,b2,dabs,defabs,defab1,defab2,dmax1,d1mach,elist,epmach,
     *  epsabs,epsrel,errbnd,errmax,error1,error2,erro12,errsum,f,
     *  resabs,result,rlist,uflow
      integer ier,iord,iroff1,iroff2,k,key,keyf,last,limit,maxerr,neval,
     *  nrmax
c
      dimension alist(limit),blist(limit),elist(limit),iord(limit),
     *  rlist(limit)
c
      external f
c
c            list of major variables
c            -----------------------
c
c           alist     - list of left end points of all subintervals
c                       considered up to now
c           blist     - list of right end points of all subintervals
c                       considered up to now
c           rlist(i)  - approximation to the integral over
c                      (alist(i),blist(i))
c           elist(i)  - error estimate applying to rlist(i)
c           maxerr    - pointer to the interval with largest
c                       error estimate
c           errmax    - elist(maxerr)
c           area      - sum of the integrals over the subintervals
c           errsum    - sum of the errors over the subintervals
c           errbnd    - requested accuracy max(epsabs,epsrel*
c                       abs(result))
c           *****1    - variable for the left subinterval
c           *****2    - variable for the right subinterval
c           last      - index for subdivision
c
c
c           machine dependent constants
c           ---------------------------
c
c           epmach  is the largest relative spacing.
c           uflow  is the smallest positive magnitude.
c
c***first executable statement  dqage
      epmach = d1mach(4)
      uflow = d1mach(1)
c
c           test on validity of parameters
c           ------------------------------
c
      ier = 0
      neval = 0
      last = 0
      result = 0.0d+00
      abserr = 0.0d+00
      alist(1) = a
      blist(1) = b
      rlist(1) = 0.0d+00
      elist(1) = 0.0d+00
      iord(1) = 0
      if(epsabs.le.0.0d+00.and.
     *  epsrel.lt.dmax1(0.5d+02*epmach,0.5d-28)) ier = 6
      if(ier.eq.6) go to 999
c
c           first approximation to the integral
c           -----------------------------------
c
      keyf = key
      if(key.le.0) keyf = 1
      if(key.ge.7) keyf = 6
      neval = 0
      if(keyf.eq.1) call dqk15(f,a,b,result,abserr,defabs,resabs)
      if(keyf.eq.2) call dqk21(f,a,b,result,abserr,defabs,resabs)
      if(keyf.eq.3) call dqk31(f,a,b,result,abserr,defabs,resabs)
      if(keyf.eq.4) call dqk41(f,a,b,result,abserr,defabs,resabs)
      if(keyf.eq.5) call dqk51(f,a,b,result,abserr,defabs,resabs)
      if(keyf.eq.6) call dqk61(f,a,b,result,abserr,defabs,resabs)
      last = 1
      rlist(1) = result
      elist(1) = abserr
      iord(1) = 1
c
c           test on accuracy.
c
      errbnd = dmax1(epsabs,epsrel*dabs(result))
      if(abserr.le.0.5d+02*epmach*defabs.and.abserr.gt.errbnd) ier = 2
      if(limit.eq.1) ier = 1
      if(ier.ne.0.or.(abserr.le.errbnd.and.abserr.ne.resabs)
     *  .or.abserr.eq.0.0d+00) go to 60
c
c           initialization
c           --------------
c
c
      errmax = abserr
      maxerr = 1
      area = result
      errsum = abserr
      nrmax = 1
      iroff1 = 0
      iroff2 = 0
c
c           main do-loop
c           ------------
c
      do 30 last = 2,limit
c
c           bisect the subinterval with the largest error estimate.
c
        a1 = alist(maxerr)
        b1 = 0.5d+00*(alist(maxerr)+blist(maxerr))
        a2 = b1
        b2 = blist(maxerr)
        if(keyf.eq.1) call dqk15(f,a1,b1,area1,error1,resabs,defab1)
        if(keyf.eq.2) call dqk21(f,a1,b1,area1,error1,resabs,defab1)
        if(keyf.eq.3) call dqk31(f,a1,b1,area1,error1,resabs,defab1)
        if(keyf.eq.4) call dqk41(f,a1,b1,area1,error1,resabs,defab1)
        if(keyf.eq.5) call dqk51(f,a1,b1,area1,error1,resabs,defab1)
        if(keyf.eq.6) call dqk61(f,a1,b1,area1,error1,resabs,defab1)
        if(keyf.eq.1) call dqk15(f,a2,b2,area2,error2,resabs,defab2)
        if(keyf.eq.2) call dqk21(f,a2,b2,area2,error2,resabs,defab2)
        if(keyf.eq.3) call dqk31(f,a2,b2,area2,error2,resabs,defab2)
        if(keyf.eq.4) call dqk41(f,a2,b2,area2,error2,resabs,defab2)
        if(keyf.eq.5) call dqk51(f,a2,b2,area2,error2,resabs,defab2)
        if(keyf.eq.6) call dqk61(f,a2,b2,area2,error2,resabs,defab2)
c
c           improve previous approximations to integral
c           and error and test for accuracy.
c
        neval = neval+1
        area12 = area1+area2
        erro12 = error1+error2
        errsum = errsum+erro12-errmax
        area = area+area12-rlist(maxerr)
        if(defab1.eq.error1.or.defab2.eq.error2) go to 5
        if(dabs(rlist(maxerr)-area12).le.0.1d-04*dabs(area12)
     *  .and.erro12.ge.0.99d+00*errmax) iroff1 = iroff1+1
        if(last.gt.10.and.erro12.gt.errmax) iroff2 = iroff2+1
    5   rlist(maxerr) = area1
        rlist(last) = area2
        errbnd = dmax1(epsabs,epsrel*dabs(area))
        if(errsum.le.errbnd) go to 8
c
c           test for roundoff error and eventually set error flag.
c
        if(iroff1.ge.6.or.iroff2.ge.20) ier = 2
c
c           set error flag in the case that the number of subintervals
c           equals limit.
c
        if(last.eq.limit) ier = 1
c
c           set error flag in the case of bad integrand behaviour
c           at a point of the integration range.
c
        if(dmax1(dabs(a1),dabs(b2)).le.(0.1d+01+0.1d+03*
     *  epmach)*(dabs(a2)+0.1d+04*uflow)) ier = 3
c
c           append the newly-created intervals to the list.
c
    8   if(error2.gt.error1) go to 10
        alist(last) = a2
        blist(maxerr) = b1
        blist(last) = b2
        elist(maxerr) = error1
        elist(last) = error2
        go to 20
   10   alist(maxerr) = a2
        alist(last) = a1
        blist(last) = b1
        rlist(maxerr) = area2
        rlist(last) = area1
        elist(maxerr) = error2
        elist(last) = error1
c
c           call subroutine dqpsrt to maintain the descending ordering
c           in the list of error estimates and select the subinterval
c           with the largest error estimate (to be bisected next).
c
   20   call dqpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
c ***jump out of do-loop
        if(ier.ne.0.or.errsum.le.errbnd) go to 40
   30 continue
c
c           compute final result.
c           ---------------------
c
   40 result = 0.0d+00
      do 50 k=1,last
        result = result+rlist(k)
   50 continue
      abserr = errsum
   60 if(keyf.ne.1) neval = (10*keyf+1)*(2*neval+1)
      if(keyf.eq.1) neval = 30*neval+15
  999 return
      end
      subroutine dqk15(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk15
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  15-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div - k.u.leuven
c***purpose  to compute i = integral of f over (a,b), with error
c                           estimate
c                       j = integral of abs(f) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       function subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the calling program.
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 15-point
c                       kronrod rule (resk) obtained by optimal addition
c                       of abscissae to the7-point gauss rule(resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should not exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integral of abs(f-i/(b-a))
c                       over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk15
c
      double precision a,absc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(7),fv2(7),wg(4),wgk(8),xgk(8)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 15-point kronrod rule
c                    xgk(2), xgk(4), ...  abscissae of the 7-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 7-point gauss rule
c
c           wgk    - weights of the 15-point kronrod rule
c
c           wg     - weights of the 7-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.1294849661 6886969327 0611432679 082 d0 /
      data wg  (  2) / 0.2797053914 8927666790 1467771423 780 d0 /
      data wg  (  3) / 0.3818300505 0511894495 0369775488 975 d0 /
      data wg  (  4) / 0.4179591836 7346938775 5102040816 327 d0 /
c
      data xgk (  1) / 0.9914553711 2081263920 6854697526 329 d0 /
      data xgk (  2) / 0.9491079123 4275852452 6189684047 851 d0 /
      data xgk (  3) / 0.8648644233 5976907278 9712788640 926 d0 /
      data xgk (  4) / 0.7415311855 9939443986 3864773280 788 d0 /
      data xgk (  5) / 0.5860872354 6769113029 4144838258 730 d0 /
      data xgk (  6) / 0.4058451513 7739716690 6606412076 961 d0 /
      data xgk (  7) / 0.2077849550 0789846760 0689403773 245 d0 /
      data xgk (  8) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0229353220 1052922496 3732008058 970 d0 /
      data wgk (  2) / 0.0630920926 2997855329 0700663189 204 d0 /
      data wgk (  3) / 0.1047900103 2225018383 9876322541 518 d0 /
      data wgk (  4) / 0.1406532597 1552591874 5189590510 238 d0 /
      data wgk (  5) / 0.1690047266 3926790282 6583426598 550 d0 /
      data wgk (  6) / 0.1903505780 6478540991 3256402421 014 d0 /
      data wgk (  7) / 0.2044329400 7529889241 4161999234 649 d0 /
      data wgk (  8) / 0.2094821410 8472782801 2999174891 714 d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc   - abscissa
c           fval*  - function value
c           resg   - result of the 7-point gauss formula
c           resk   - result of the 15-point kronrod formula
c           reskh  - approximation to the mean value of f over (a,b),
c                    i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk15
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 15-point kronrod approximation to
c           the integral, and estimate the absolute error.
c
      fc = f(centr)
      resg = fc*wg(4)
      resk = fc*wgk(8)
      resabs = dabs(resk)
      do 10 j=1,3
        jtw = j*2
        absc = hlgth*xgk(jtw)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j = 1,4
        jtwm1 = j*2-1
        absc = hlgth*xgk(jtwm1)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(8)*dabs(fc-reskh)
      do 20 j=1,7
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqk21(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk21
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  21-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f over (a,b), with error
c                           estimate
c                       j = integral of abs(f) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       function subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the driver program.
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 21-point
c                       kronrod rule (resk) obtained by optimal addition
c                       of abscissae to the 10-point gauss rule (resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should not exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integral of abs(f-i/(b-a))
c                       over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk21
c
      double precision a,absc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(10),fv2(10),wg(5),wgk(11),xgk(11)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 21-point kronrod rule
c                    xgk(2), xgk(4), ...  abscissae of the 10-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 10-point gauss rule
c
c           wgk    - weights of the 21-point kronrod rule
c
c           wg     - weights of the 10-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.0666713443 0868813759 3568809893 332 d0 /
      data wg  (  2) / 0.1494513491 5058059314 5776339657 697 d0 /
      data wg  (  3) / 0.2190863625 1598204399 5534934228 163 d0 /
      data wg  (  4) / 0.2692667193 0999635509 1226921569 469 d0 /
      data wg  (  5) / 0.2955242247 1475287017 3892994651 338 d0 /
c
      data xgk (  1) / 0.9956571630 2580808073 5527280689 003 d0 /
      data xgk (  2) / 0.9739065285 1717172007 7964012084 452 d0 /
      data xgk (  3) / 0.9301574913 5570822600 1207180059 508 d0 /
      data xgk (  4) / 0.8650633666 8898451073 2096688423 493 d0 /
      data xgk (  5) / 0.7808177265 8641689706 3717578345 042 d0 /
      data xgk (  6) / 0.6794095682 9902440623 4327365114 874 d0 /
      data xgk (  7) / 0.5627571346 6860468333 9000099272 694 d0 /
      data xgk (  8) / 0.4333953941 2924719079 9265943165 784 d0 /
      data xgk (  9) / 0.2943928627 0146019813 1126603103 866 d0 /
      data xgk ( 10) / 0.1488743389 8163121088 4826001129 720 d0 /
      data xgk ( 11) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0116946388 6737187427 8064396062 192 d0 /
      data wgk (  2) / 0.0325581623 0796472747 8818972459 390 d0 /
      data wgk (  3) / 0.0547558965 7435199603 1381300244 580 d0 /
      data wgk (  4) / 0.0750396748 1091995276 7043140916 190 d0 /
      data wgk (  5) / 0.0931254545 8369760553 5065465083 366 d0 /
      data wgk (  6) / 0.1093871588 0229764189 9210590325 805 d0 /
      data wgk (  7) / 0.1234919762 6206585107 7958109831 074 d0 /
      data wgk (  8) / 0.1347092173 1147332592 8054001771 707 d0 /
      data wgk (  9) / 0.1427759385 7706008079 7094273138 717 d0 /
      data wgk ( 10) / 0.1477391049 0133849137 4841515972 068 d0 /
      data wgk ( 11) / 0.1494455540 0291690566 4936468389 821 d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc   - abscissa
c           fval*  - function value
c           resg   - result of the 10-point gauss formula
c           resk   - result of the 21-point kronrod formula
c           reskh  - approximation to the mean value of f over (a,b),
c                    i.e. to i/(b-a)
c
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk21
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 21-point kronrod approximation to
c           the integral, and estimate the absolute error.
c
      resg = 0.0d+00
      fc = f(centr)
      resk = wgk(11)*fc
      resabs = dabs(resk)
      do 10 j=1,5
        jtw = 2*j
        absc = hlgth*xgk(jtw)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j = 1,5
        jtwm1 = 2*j-1
        absc = hlgth*xgk(jtwm1)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(11)*dabs(fc-reskh)
      do 20 j=1,10
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqk31(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk31
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  31-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f over (a,b) with error
c                           estimate
c                       j = integral of abs(f) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       function subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the calling program.
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 31-point
c                       gauss-kronrod rule (resk), obtained by optimal
c                       addition of abscissae to the 15-point gauss
c                       rule (resg).
c
c              abserr - double precison
c                       estimate of the modulus of the modulus,
c                       which should not exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integral of abs(f-i/(b-a))
c                       over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk31
      double precision a,absc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(15),fv2(15),xgk(16),wgk(16),wg(8)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 31-point kronrod rule
c                    xgk(2), xgk(4), ...  abscissae of the 15-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 15-point gauss rule
c
c           wgk    - weights of the 31-point kronrod rule
c
c           wg     - weights of the 15-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.0307532419 9611726835 4628393577 204 d0 /
      data wg  (  2) / 0.0703660474 8810812470 9267416450 667 d0 /
      data wg  (  3) / 0.1071592204 6717193501 1869546685 869 d0 /
      data wg  (  4) / 0.1395706779 2615431444 7804794511 028 d0 /
      data wg  (  5) / 0.1662692058 1699393355 3200860481 209 d0 /
      data wg  (  6) / 0.1861610000 1556221102 6800561866 423 d0 /
      data wg  (  7) / 0.1984314853 2711157645 6118326443 839 d0 /
      data wg  (  8) / 0.2025782419 2556127288 0620199967 519 d0 /
c
      data xgk (  1) / 0.9980022986 9339706028 5172840152 271 d0 /
      data xgk (  2) / 0.9879925180 2048542848 9565718586 613 d0 /
      data xgk (  3) / 0.9677390756 7913913425 7347978784 337 d0 /
      data xgk (  4) / 0.9372733924 0070590430 7758947710 209 d0 /
      data xgk (  5) / 0.8972645323 4408190088 2509656454 496 d0 /
      data xgk (  6) / 0.8482065834 1042721620 0648320774 217 d0 /
      data xgk (  7) / 0.7904185014 4246593296 7649294817 947 d0 /
      data xgk (  8) / 0.7244177313 6017004741 6186054613 938 d0 /
      data xgk (  9) / 0.6509967412 9741697053 3735895313 275 d0 /
      data xgk ( 10) / 0.5709721726 0853884753 7226737253 911 d0 /
      data xgk ( 11) / 0.4850818636 4023968069 3655740232 351 d0 /
      data xgk ( 12) / 0.3941513470 7756336989 7207370981 045 d0 /
      data xgk ( 13) / 0.2991800071 5316881216 6780024266 389 d0 /
      data xgk ( 14) / 0.2011940939 9743452230 0628303394 596 d0 /
      data xgk ( 15) / 0.1011420669 1871749902 7074231447 392 d0 /
      data xgk ( 16) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0053774798 7292334898 7792051430 128 d0 /
      data wgk (  2) / 0.0150079473 2931612253 8374763075 807 d0 /
      data wgk (  3) / 0.0254608473 2671532018 6874001019 653 d0 /
      data wgk (  4) / 0.0353463607 9137584622 2037948478 360 d0 /
      data wgk (  5) / 0.0445897513 2476487660 8227299373 280 d0 /
      data wgk (  6) / 0.0534815246 9092808726 5343147239 430 d0 /
      data wgk (  7) / 0.0620095678 0067064028 5139230960 803 d0 /
      data wgk (  8) / 0.0698541213 1872825870 9520077099 147 d0 /
      data wgk (  9) / 0.0768496807 5772037889 4432777482 659 d0 /
      data wgk ( 10) / 0.0830805028 2313302103 8289247286 104 d0 /
      data wgk ( 11) / 0.0885644430 5621177064 7275443693 774 d0 /
      data wgk ( 12) / 0.0931265981 7082532122 5486872747 346 d0 /
      data wgk ( 13) / 0.0966427269 8362367850 5179907627 589 d0 /
      data wgk ( 14) / 0.0991735987 2179195933 2393173484 603 d0 /
      data wgk ( 15) / 0.1007698455 2387559504 4946662617 570 d0 /
      data wgk ( 16) / 0.1013300070 1479154901 7374792767 493 d0 /
c
c
c           list of major variables
c           -----------------------
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc   - abscissa
c           fval*  - function value
c           resg   - result of the 15-point gauss formula
c           resk   - result of the 31-point kronrod formula
c           reskh  - approximation to the mean value of f over (a,b),
c                    i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c***first executable statement  dqk31
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 31-point kronrod approximation to
c           the integral, and estimate the absolute error.
c
      fc = f(centr)
      resg = wg(8)*fc
      resk = wgk(16)*fc
      resabs = dabs(resk)
      do 10 j=1,7
        jtw = j*2
        absc = hlgth*xgk(jtw)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j = 1,8
        jtwm1 = j*2-1
        absc = hlgth*xgk(jtwm1)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(16)*dabs(fc-reskh)
      do 20 j=1,15
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqk41(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk41
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  41-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f over (a,b), with error
c                           estimate
c                       j = integral of abs(f) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       function subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the calling program.
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 41-point
c                       gauss-kronrod rule (resk) obtained by optimal
c                       addition of abscissae to the 20-point gauss
c                       rule (resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should not exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integal of abs(f-i/(b-a))
c                       over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk41
c
      double precision a,absc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(20),fv2(20),xgk(21),wgk(21),wg(10)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 41-point gauss-kronrod rule
c                    xgk(2), xgk(4), ...  abscissae of the 20-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 20-point gauss rule
c
c           wgk    - weights of the 41-point gauss-kronrod rule
c
c           wg     - weights of the 20-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.0176140071 3915211831 1861962351 853 d0 /
      data wg  (  2) / 0.0406014298 0038694133 1039952274 932 d0 /
      data wg  (  3) / 0.0626720483 3410906356 9506535187 042 d0 /
      data wg  (  4) / 0.0832767415 7670474872 4758143222 046 d0 /
      data wg  (  5) / 0.1019301198 1724043503 6750135480 350 d0 /
      data wg  (  6) / 0.1181945319 6151841731 2377377711 382 d0 /
      data wg  (  7) / 0.1316886384 4917662689 8494499748 163 d0 /
      data wg  (  8) / 0.1420961093 1838205132 9298325067 165 d0 /
      data wg  (  9) / 0.1491729864 7260374678 7828737001 969 d0 /
      data wg  ( 10) / 0.1527533871 3072585069 8084331955 098 d0 /
c
      data xgk (  1) / 0.9988590315 8827766383 8315576545 863 d0 /
      data xgk (  2) / 0.9931285991 8509492478 6122388471 320 d0 /
      data xgk (  3) / 0.9815078774 5025025919 3342994720 217 d0 /
      data xgk (  4) / 0.9639719272 7791379126 7666131197 277 d0 /
      data xgk (  5) / 0.9408226338 3175475351 9982722212 443 d0 /
      data xgk (  6) / 0.9122344282 5132590586 7752441203 298 d0 /
      data xgk (  7) / 0.8782768112 5228197607 7442995113 078 d0 /
      data xgk (  8) / 0.8391169718 2221882339 4529061701 521 d0 /
      data xgk (  9) / 0.7950414288 3755119835 0638833272 788 d0 /
      data xgk ( 10) / 0.7463319064 6015079261 4305070355 642 d0 /
      data xgk ( 11) / 0.6932376563 3475138480 5490711845 932 d0 /
      data xgk ( 12) / 0.6360536807 2651502545 2836696226 286 d0 /
      data xgk ( 13) / 0.5751404468 1971031534 2946036586 425 d0 /
      data xgk ( 14) / 0.5108670019 5082709800 4364050955 251 d0 /
      data xgk ( 15) / 0.4435931752 3872510319 9992213492 640 d0 /
      data xgk ( 16) / 0.3737060887 1541956067 2548177024 927 d0 /
      data xgk ( 17) / 0.3016278681 1491300432 0555356858 592 d0 /
      data xgk ( 18) / 0.2277858511 4164507808 0496195368 575 d0 /
      data xgk ( 19) / 0.1526054652 4092267550 5220241022 678 d0 /
      data xgk ( 20) / 0.0765265211 3349733375 4640409398 838 d0 /
      data xgk ( 21) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0030735837 1852053150 1218293246 031 d0 /
      data wgk (  2) / 0.0086002698 5564294219 8661787950 102 d0 /
      data wgk (  3) / 0.0146261692 5697125298 3787960308 868 d0 /
      data wgk (  4) / 0.0203883734 6126652359 8010231432 755 d0 /
      data wgk (  5) / 0.0258821336 0495115883 4505067096 153 d0 /
      data wgk (  6) / 0.0312873067 7703279895 8543119323 801 d0 /
      data wgk (  7) / 0.0366001697 5820079803 0557240707 211 d0 /
      data wgk (  8) / 0.0416688733 2797368626 3788305936 895 d0 /
      data wgk (  9) / 0.0464348218 6749767472 0231880926 108 d0 /
      data wgk ( 10) / 0.0509445739 2372869193 2707670050 345 d0 /
      data wgk ( 11) / 0.0551951053 4828599474 4832372419 777 d0 /
      data wgk ( 12) / 0.0591114008 8063957237 4967220648 594 d0 /
      data wgk ( 13) / 0.0626532375 5478116802 5870122174 255 d0 /
      data wgk ( 14) / 0.0658345971 3361842211 1563556969 398 d0 /
      data wgk ( 15) / 0.0686486729 2852161934 5623411885 368 d0 /
      data wgk ( 16) / 0.0710544235 5344406830 5790361723 210 d0 /
      data wgk ( 17) / 0.0730306903 3278666749 5189417658 913 d0 /
      data wgk ( 18) / 0.0745828754 0049918898 6581418362 488 d0 /
      data wgk ( 19) / 0.0757044976 8455667465 9542775376 617 d0 /
      data wgk ( 20) / 0.0763778676 7208073670 5502835038 061 d0 /
      data wgk ( 21) / 0.0766007119 1799965644 5049901530 102 d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc   - abscissa
c           fval*  - function value
c           resg   - result of the 20-point gauss formula
c           resk   - result of the 41-point kronrod formula
c           reskh  - approximation to mean value of f over (a,b), i.e.
c                    to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk41
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 41-point gauss-kronrod approximation to
c           the integral, and estimate the absolute error.
c
      resg = 0.0d+00
      fc = f(centr)
      resk = wgk(21)*fc
      resabs = dabs(resk)
      do 10 j=1,10
        jtw = j*2
        absc = hlgth*xgk(jtw)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j = 1,10
        jtwm1 = j*2-1
        absc = hlgth*xgk(jtwm1)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(21)*dabs(fc-reskh)
      do 20 j=1,20
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqk51(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk51
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  51-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f over (a,b) with error
c                           estimate
c                       j = integral of abs(f) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       function subroutine defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the calling program.
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 51-point
c                       kronrod rule (resk) obtained by optimal addition
c                       of abscissae to the 25-point gauss rule (resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should not exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integral of abs(f-i/(b-a))
c                       over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk51
c
      double precision a,absc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(25),fv2(25),xgk(26),wgk(26),wg(13)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 51-point kronrod rule
c                    xgk(2), xgk(4), ...  abscissae of the 25-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 25-point gauss rule
c
c           wgk    - weights of the 51-point kronrod rule
c
c           wg     - weights of the 25-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.0113937985 0102628794 7902964113 235 d0 /
      data wg  (  2) / 0.0263549866 1503213726 1901815295 299 d0 /
      data wg  (  3) / 0.0409391567 0130631265 5623487711 646 d0 /
      data wg  (  4) / 0.0549046959 7583519192 5936891540 473 d0 /
      data wg  (  5) / 0.0680383338 1235691720 7187185656 708 d0 /
      data wg  (  6) / 0.0801407003 3500101801 3234959669 111 d0 /
      data wg  (  7) / 0.0910282619 8296364981 1497220702 892 d0 /
      data wg  (  8) / 0.1005359490 6705064420 2206890392 686 d0 /
      data wg  (  9) / 0.1085196244 7426365311 6093957050 117 d0 /
      data wg  ( 10) / 0.1148582591 4571164833 9325545869 556 d0 /
      data wg  ( 11) / 0.1194557635 3578477222 8178126512 901 d0 /
      data wg  ( 12) / 0.1222424429 9031004168 8959518945 852 d0 /
      data wg  ( 13) / 0.1231760537 2671545120 3902873079 050 d0 /
c
      data xgk (  1) / 0.9992621049 9260983419 3457486540 341 d0 /
      data xgk (  2) / 0.9955569697 9049809790 8784946893 902 d0 /
      data xgk (  3) / 0.9880357945 3407724763 7331014577 406 d0 /
      data xgk (  4) / 0.9766639214 5951751149 8315386479 594 d0 /
      data xgk (  5) / 0.9616149864 2584251241 8130033660 167 d0 /
      data xgk (  6) / 0.9429745712 2897433941 4011169658 471 d0 /
      data xgk (  7) / 0.9207471152 8170156174 6346084546 331 d0 /
      data xgk (  8) / 0.8949919978 7827536885 1042006782 805 d0 /
      data xgk (  9) / 0.8658470652 9327559544 8996969588 340 d0 /
      data xgk ( 10) / 0.8334426287 6083400142 1021108693 570 d0 /
      data xgk ( 11) / 0.7978737979 9850005941 0410904994 307 d0 /
      data xgk ( 12) / 0.7592592630 3735763057 7282865204 361 d0 /
      data xgk ( 13) / 0.7177664068 1308438818 6654079773 298 d0 /
      data xgk ( 14) / 0.6735663684 7346836448 5120633247 622 d0 /
      data xgk ( 15) / 0.6268100990 1031741278 8122681624 518 d0 /
      data xgk ( 16) / 0.5776629302 4122296772 3689841612 654 d0 /
      data xgk ( 17) / 0.5263252843 3471918259 9623778158 010 d0 /
      data xgk ( 18) / 0.4730027314 4571496052 2182115009 192 d0 /
      data xgk ( 19) / 0.4178853821 9303774885 1814394594 572 d0 /
      data xgk ( 20) / 0.3611723058 0938783773 5821730127 641 d0 /
      data xgk ( 21) / 0.3030895389 3110783016 7478909980 339 d0 /
      data xgk ( 22) / 0.2438668837 2098843204 5190362797 452 d0 /
      data xgk ( 23) / 0.1837189394 2104889201 5969888759 528 d0 /
      data xgk ( 24) / 0.1228646926 1071039638 7359818808 037 d0 /
      data xgk ( 25) / 0.0615444830 0568507888 6546392366 797 d0 /
      data xgk ( 26) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0019873838 9233031592 6507851882 843 d0 /
      data wgk (  2) / 0.0055619321 3535671375 8040236901 066 d0 /
      data wgk (  3) / 0.0094739733 8617415160 7207710523 655 d0 /
      data wgk (  4) / 0.0132362291 9557167481 3656405846 976 d0 /
      data wgk (  5) / 0.0168478177 0912829823 1516667536 336 d0 /
      data wgk (  6) / 0.0204353711 4588283545 6568292235 939 d0 /
      data wgk (  7) / 0.0240099456 0695321622 0092489164 881 d0 /
      data wgk (  8) / 0.0274753175 8785173780 2948455517 811 d0 /
      data wgk (  9) / 0.0307923001 6738748889 1109020215 229 d0 /
      data wgk ( 10) / 0.0340021302 7432933783 6748795229 551 d0 /
      data wgk ( 11) / 0.0371162714 8341554356 0330625367 620 d0 /
      data wgk ( 12) / 0.0400838255 0403238207 4839284467 076 d0 /
      data wgk ( 13) / 0.0428728450 2017004947 6895792439 495 d0 /
      data wgk ( 14) / 0.0455029130 4992178890 9870584752 660 d0 /
      data wgk ( 15) / 0.0479825371 3883671390 6392255756 915 d0 /
      data wgk ( 16) / 0.0502776790 8071567196 3325259433 440 d0 /
      data wgk ( 17) / 0.0523628858 0640747586 4366712137 873 d0 /
      data wgk ( 18) / 0.0542511298 8854549014 4543370459 876 d0 /
      data wgk ( 19) / 0.0559508112 2041231730 8240686382 747 d0 /
      data wgk ( 20) / 0.0574371163 6156783285 3582693939 506 d0 /
      data wgk ( 21) / 0.0586896800 2239420796 1974175856 788 d0 /
      data wgk ( 22) / 0.0597203403 2417405997 9099291932 562 d0 /
      data wgk ( 23) / 0.0605394553 7604586294 5360267517 565 d0 /
      data wgk ( 24) / 0.0611285097 1705304830 5859030416 293 d0 /
      data wgk ( 25) / 0.0614711898 7142531666 1544131965 264 d0 /
c       note: wgk (26) was calculated from the values of wgk(1..25)
      data wgk ( 26) / 0.0615808180 6783293507 8759824240 066 d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc   - abscissa
c           fval*  - function value
c           resg   - result of the 25-point gauss formula
c           resk   - result of the 51-point kronrod formula
c           reskh  - approximation to the mean value of f over (a,b),
c                    i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk51
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 51-point kronrod approximation to
c           the integral, and estimate the absolute error.
c
      fc = f(centr)
      resg = wg(13)*fc
      resk = wgk(26)*fc
      resabs = dabs(resk)
      do 10 j=1,12
        jtw = j*2
        absc = hlgth*xgk(jtw)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j = 1,13
        jtwm1 = j*2-1
        absc = hlgth*xgk(jtwm1)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(26)*dabs(fc-reskh)
      do 20 j=1,25
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end
      subroutine dqk61(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk61
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  61-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f over (a,b) with error
c                           estimate
c                       j = integral of dabs(f) over (a,b)
c***description
c
c        integration rule
c        standard fortran subroutine
c        double precision version
c
c
c        parameters
c         on entry
c           f      - double precision
c                    function subprogram defining the integrand
c                    function f(x). the actual name for f needs to be
c                    declared e x t e r n a l in the calling program.
c
c           a      - double precision
c                    lower limit of integration
c
c           b      - double precision
c                    upper limit of integration
c
c         on return
c           result - double precision
c                    approximation to the integral i
c                    result is computed by applying the 61-point
c                    kronrod rule (resk) obtained by optimal addition of
c                    abscissae to the 30-point gauss rule (resg).
c
c           abserr - double precision
c                    estimate of the modulus of the absolute error,
c                    which should equal or exceed dabs(i-result)
c
c           resabs - double precision
c                    approximation to the integral j
c
c           resasc - double precision
c                    approximation to the integral of dabs(f-i/(b-a))
c
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk61
c
      double precision a,dabsc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(30),fv2(30),xgk(31),wgk(31),wg(15)
c
c           the abscissae and weights are given for the
c           interval (-1,1). because of symmetry only the positive
c           abscissae and their corresponding weights are given.
c
c           xgk   - abscissae of the 61-point kronrod rule
c                   xgk(2), xgk(4)  ... abscissae of the 30-point
c                   gauss rule
c                   xgk(1), xgk(3)  ... optimally added abscissae
c                   to the 30-point gauss rule
c
c           wgk   - weights of the 61-point kronrod rule
c
c           wg    - weigths of the 30-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.0079681924 9616660561 5465883474 674 d0 /
      data wg  (  2) / 0.0184664683 1109095914 2302131912 047 d0 /
      data wg  (  3) / 0.0287847078 8332336934 9719179611 292 d0 /
      data wg  (  4) / 0.0387991925 6962704959 6801936446 348 d0 /
      data wg  (  5) / 0.0484026728 3059405290 2938140422 808 d0 /
      data wg  (  6) / 0.0574931562 1761906648 1721689402 056 d0 /
      data wg  (  7) / 0.0659742298 8218049512 8128515115 962 d0 /
      data wg  (  8) / 0.0737559747 3770520626 8243850022 191 d0 /
      data wg  (  9) / 0.0807558952 2942021535 4694938460 530 d0 /
      data wg  ( 10) / 0.0868997872 0108297980 2387530715 126 d0 /
      data wg  ( 11) / 0.0921225222 3778612871 7632707087 619 d0 /
      data wg  ( 12) / 0.0963687371 7464425963 9468626351 810 d0 /
      data wg  ( 13) / 0.0995934205 8679526706 2780282103 569 d0 /
      data wg  ( 14) / 0.1017623897 4840550459 6428952168 554 d0 /
      data wg  ( 15) / 0.1028526528 9355884034 1285636705 415 d0 /
c
      data xgk (  1) / 0.9994844100 5049063757 1325895705 811 d0 /
      data xgk (  2) / 0.9968934840 7464954027 1630050918 695 d0 /
      data xgk (  3) / 0.9916309968 7040459485 8628366109 486 d0 /
      data xgk (  4) / 0.9836681232 7974720997 0032581605 663 d0 /
      data xgk (  5) / 0.9731163225 0112626837 4693868423 707 d0 /
      data xgk (  6) / 0.9600218649 6830751221 6871025581 798 d0 /
      data xgk (  7) / 0.9443744447 4855997941 5831324037 439 d0 /
      data xgk (  8) / 0.9262000474 2927432587 9324277080 474 d0 /
      data xgk (  9) / 0.9055733076 9990779854 6522558925 958 d0 /
      data xgk ( 10) / 0.8825605357 9205268154 3116462530 226 d0 /
      data xgk ( 11) / 0.8572052335 4606109895 8658510658 944 d0 /
      data xgk ( 12) / 0.8295657623 8276839744 2898119732 502 d0 /
      data xgk ( 13) / 0.7997278358 2183908301 3668942322 683 d0 /
      data xgk ( 14) / 0.7677774321 0482619491 7977340974 503 d0 /
      data xgk ( 15) / 0.7337900624 5322680472 6171131369 528 d0 /
      data xgk ( 16) / 0.6978504947 9331579693 2292388026 640 d0 /
      data xgk ( 17) / 0.6600610641 2662696137 0053668149 271 d0 /
      data xgk ( 18) / 0.6205261829 8924286114 0477556431 189 d0 /
      data xgk ( 19) / 0.5793452358 2636169175 6024932172 540 d0 /
      data xgk ( 20) / 0.5366241481 4201989926 4169793311 073 d0 /
      data xgk ( 21) / 0.4924804678 6177857499 3693061207 709 d0 /
      data xgk ( 22) / 0.4470337695 3808917678 0609900322 854 d0 /
      data xgk ( 23) / 0.4004012548 3039439253 5476211542 661 d0 /
      data xgk ( 24) / 0.3527047255 3087811347 1037207089 374 d0 /
      data xgk ( 25) / 0.3040732022 7362507737 2677107199 257 d0 /
      data xgk ( 26) / 0.2546369261 6788984643 9805129817 805 d0 /
      data xgk ( 27) / 0.2045251166 8230989143 8957671002 025 d0 /
      data xgk ( 28) / 0.1538699136 0858354696 3794672743 256 d0 /
      data xgk ( 29) / 0.1028069379 6673703014 7096751318 001 d0 /
      data xgk ( 30) / 0.0514718425 5531769583 3025213166 723 d0 /
      data xgk ( 31) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0013890136 9867700762 4551591226 760 d0 /
      data wgk (  2) / 0.0038904611 2709988405 1267201844 516 d0 /
      data wgk (  3) / 0.0066307039 1593129217 3319826369 750 d0 /
      data wgk (  4) / 0.0092732796 5951776342 8441146892 024 d0 /
      data wgk (  5) / 0.0118230152 5349634174 2232898853 251 d0 /
      data wgk (  6) / 0.0143697295 0704580481 2451432443 580 d0 /
      data wgk (  7) / 0.0169208891 8905327262 7572289420 322 d0 /
      data wgk (  8) / 0.0194141411 9394238117 3408951050 128 d0 /
      data wgk (  9) / 0.0218280358 2160919229 7167485738 339 d0 /
      data wgk ( 10) / 0.0241911620 7808060136 5686370725 232 d0 /
      data wgk ( 11) / 0.0265099548 8233310161 0601709335 075 d0 /
      data wgk ( 12) / 0.0287540487 6504129284 3978785354 334 d0 /
      data wgk ( 13) / 0.0309072575 6238776247 2884252943 092 d0 /
      data wgk ( 14) / 0.0329814470 5748372603 1814191016 854 d0 /
      data wgk ( 15) / 0.0349793380 2806002413 7499670731 468 d0 /
      data wgk ( 16) / 0.0368823646 5182122922 3911065617 136 d0 /
      data wgk ( 17) / 0.0386789456 2472759295 0348651532 281 d0 /
      data wgk ( 18) / 0.0403745389 5153595911 1995279752 468 d0 /
      data wgk ( 19) / 0.0419698102 1516424614 7147541285 970 d0 /
      data wgk ( 20) / 0.0434525397 0135606931 6831728117 073 d0 /
      data wgk ( 21) / 0.0448148001 3316266319 2355551616 723 d0 /
      data wgk ( 22) / 0.0460592382 7100698811 6271735559 374 d0 /
      data wgk ( 23) / 0.0471855465 6929915394 5261478181 099 d0 /
      data wgk ( 24) / 0.0481858617 5708712914 0779492298 305 d0 /
      data wgk ( 25) / 0.0490554345 5502977888 7528165367 238 d0 /
      data wgk ( 26) / 0.0497956834 2707420635 7811569379 942 d0 /
      data wgk ( 27) / 0.0504059214 0278234684 0893085653 585 d0 /
      data wgk ( 28) / 0.0508817958 9874960649 2297473049 805 d0 /
      data wgk ( 29) / 0.0512215478 4925877217 0656282604 944 d0 /
      data wgk ( 30) / 0.0514261285 3745902593 3862879215 781 d0 /
      data wgk ( 31) / 0.0514947294 2945156755 8340433647 099 d0 /
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           dabsc  - abscissa
c           fval*  - function value
c           resg   - result of the 30-point gauss rule
c           resk   - result of the 61-point kronrod rule
c           reskh  - approximation to the mean value of f
c                    over (a,b), i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(b+a)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 61-point kronrod approximation to the
c           integral, and estimate the absolute error.
c
c***first executable statement  dqk61
      resg = 0.0d+00
      fc = f(centr)
      resk = wgk(31)*fc
      resabs = dabs(resk)
      do 10 j=1,15
        jtw = j*2
        dabsc = hlgth*xgk(jtw)
        fval1 = f(centr-dabsc)
        fval2 = f(centr+dabsc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j=1,15
        jtwm1 = j*2-1
        dabsc = hlgth*xgk(jtwm1)
        fval1 = f(centr-dabsc)
        fval2 = f(centr+dabsc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
  15    continue
      reskh = resk*0.5d+00
      resasc = wgk(31)*dabs(fc-reskh)
      do 20 j=1,30
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end

c-----------------------------------------------------------------------
c http://www.netlib.org/bihar/
c-----------------------------------------------------------------------
      subroutine drffti (n,wsave)
      integer n
c wsave is a work array which should be dimensioned at least 2*n+15
      real*8 wsave(*)
c
      if (n .eq. 1) return
c
      call drfti1 (n,wsave(n+1),wsave(2*n+1))
c
      return
      end
c
c-----------------------------------------------------------------------
      subroutine drfti1 (n,wa,ifac)
      integer n, ifac(15)
      real*8 wa(n)
c
      real*8 TPI
      parameter (TPI = 6.2831853071 7958647692 5286766559 00577d0)
c
      integer i, ib, ido, ii, ip, ipm, is, j, k1, l1, l2, ld,
     &  nf, nfm1, nl, nq, nr, ntry
      integer ntryh(4)
      real*8 arg, argh, argld, fi
c
      data ntryh /4, 2, 3, 5/
c
      nl = n
      nf = 0
      j = 0
c
  101 j = j+1
      if (j.le.4) ntry = ntryh(j)
      if (j.gt.4) ntry = ntry + 2
  104 nq = nl/ntry
      nr = nl-ntry*nq
      if (nr.ne.0) go to 101
c
  105 nf = nf+1
      ifac(nf+2) = ntry
      nl = nq
      if (ntry .ne. 2) go to 107
      if (nf .eq. 1) go to 107
      do 106 i=2,nf
         ib = nf-i+2
         ifac(ib+2) = ifac(ib+1)
  106 continue
      ifac(3) = 2
  107 if (nl .ne. 1) go to 104
      ifac(1) = n
      ifac(2) = nf
c
      argh = TPI/dble(n)
      is = 0
      nfm1 = nf-1
      l1 = 1
      if (nfm1 .eq. 0) return
      do 110 k1=1,nfm1
         ip = ifac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = n/l2
         ipm = ip-1
         do 109 j=1,ipm
            ld = ld+l1
            i = is
            argld = dble(ld)*argh
            fi = 0.d0
            do 108 ii=3,ido,2
               i = i+2
               fi = fi+1.d0
               arg = fi*argld
               wa(i-1) = dcos(arg)
               wa(i) = dsin(arg)
  108       continue
            is = is+ido
  109    continue
c
         l1 = l2
  110 continue
c
      return
      end
c

     !Simple test program to print out sigma_8 as a function of the CDM density
     program GetSigma8
        use CAMB
        implicit none
        integer i
    
        type(CAMBparams)  P !defined in ModelParams in modules.f90

        call CAMB_SetDefParams(P)

        P%WantTransfer= .true.

        P%WantCls = .false.

        P%omegab  = .045
        P%omegac  = 0.155
        P%omegav  = 0.8
        P%omegan  = 0.0
        P%H0      = 65
       
        P%InitPower%ScalarPowerAmp = 2e-9
        P%InitPower%nn     = 1 !number of initial power spectra
        P%InitPower%an(1)  = 1 !scalar spectral index
        P%InitPower%ant(1) = 0 !Not used here
        P%InitPower%rat(1) = 1 !ditto

        !these settings seem good enough for sigma8 to a percent or so
        P%Transfer%high_precision=.false.
        P%Transfer%kmax=0.5
        P%Transfer%k_per_logint=3
        P%Transfer%num_redshifts=1
        P%Transfer%redshifts(1)=0

        do i=1,10
         P%Omegav=P%Omegav-0.05
         P%Omegac=P%Omegac+0.05
        call CAMB_GetResults(P) 

        !Results are in the Transfer module in modules.f90
             
        write (*,*) 'Omc = ',real(P%Omegac),'OmLam=',real(P%Omegav) &
           , 'sigma_8 = ', real(MT%sigma_8(1,1))
        end do

        end program GetSigma8

* cuba.F
* Fortran chooser for the Cuba routines
* last modified 3 Feb 05 th

#define VEGAS 1
#define SUAVE 2
#define DIVONNE 3
#define CUHRE 4


	subroutine Cuba(method, ndim, ncomp, integrand,
     &    integral, error, prob)
	implicit none
	integer method, ndim, ncomp
	external integrand
	double precision integral(*), error(*), prob(*)

	character*7 name(4)
	data name /"Vegas", "Suave", "Divonne", "Cuhre"/

	integer mineval, maxeval, verbose, last
	double precision epsrel, epsabs
	parameter (epsrel = 1D-3)
	parameter (epsabs = 1D-12)
	parameter (verbose = 2)
	parameter (last = 4)
	parameter (mineval = 0)
	parameter (maxeval = 50000)

	integer nstart, nincrease
	parameter (nstart = 1000)
	parameter (nincrease = 500)

	integer nnew
	double precision flatness
	parameter (nnew = 1000)
	parameter (flatness = 25D0)

	integer key1, key2, key3, maxpass
	double precision border, maxchisq, mindeviation
	integer ngiven, ldxgiven, nextra
	parameter (key1 = 47)
	parameter (key2 = 1)
	parameter (key3 = 1)
	parameter (maxpass = 5)
	parameter (border = 0D0)
	parameter (maxchisq = 10D0)
	parameter (mindeviation = .25D0)
	parameter (ngiven = 0)
	parameter (ldxgiven = ndim)
	parameter (nextra = 0)

	integer key
	parameter (key = 0)

	integer nregions, neval, fail


	if( method .eq. VEGAS ) then

	  call vegas(ndim, ncomp, integrand,
     &      epsrel, epsabs, verbose, mineval, maxeval,
     &      nstart, nincrease,
     &      neval, fail, integral, error, prob)
	  nregions = 1

	else if( method .eq. SUAVE ) then

	  call suave(ndim, ncomp, integrand,
     &      epsrel, epsabs, verbose + last, mineval, maxeval,
     &      nnew, flatness,
     &      nregions, neval, fail, integral, error, prob)

	else if( method .eq. DIVONNE ) then

	  call divonne(ndim, ncomp, integrand,
     &      epsrel, epsabs, verbose, mineval, maxeval,
     &      key1, key2, key3, maxpass,
     &      border, maxchisq, mindeviation,
     &      ngiven, ldxgiven, 0, nextra, 0,
     &      nregions, neval, fail, integral, error, prob)

	else if( method .eq. CUHRE ) then

	  call cuhre(ndim, ncomp, integrand,
     &      epsrel, epsabs, verbose + last, mineval, maxeval,
     &      key,
     &      nregions, neval, fail, integral, error, prob)

	else

	  print *, "invalid method ", method
	  return

	endif

	print *, "method   =", name(method)
	print *, "nregions =", nregions
	print *, "neval    =", neval
	print *, "fail     =", fail
	print '(G20.12," +- ",G20.12,"   p = ",F8.3)',
     &    (integral(c), error(c), prob(c), c = 1, ncomp)
	end

    !---------------------------------------------------------------------------------------------------
    ! Recombination module for CAMB, using HyRec
    ! Author: Antony Lewis
    !---------------------------------------------------------------------------------------------------

    module Recombination
    use constants
    use AMLUtils
    implicit none
    private

    type RecombinationParams

    end type RecombinationParams

    character(LEN=*), parameter :: Recombination_Name = 'HyRec'

    public RecombinationParams, Recombination_xe, Recombination_tm, Recombination_init,   &
    Recombination_ReadParams, Recombination_SetDefParams, &
    Recombination_Validate, Recombination_Name


    contains

    subroutine Recombination_ReadParams(R, Ini)
    use IniFile
    Type(RecombinationParams) :: R
    Type(TIniFile) :: Ini


    end subroutine Recombination_ReadParams


    subroutine Recombination_SetDefParams(R)
    type (RecombinationParams) ::R


    end subroutine Recombination_SetDefParams


    subroutine Recombination_Validate(R, OK)
    Type(RecombinationParams), intent(in) :: R
    logical, intent(inout) :: OK


    end subroutine Recombination_Validate



    function Recombination_tm(a)
    real(dl), intent(in) :: a
    real(dl) Recombination_tm, hyrec_tm
    external hyrec_tm

    Recombination_tm =  hyrec_tm(a);

    end function Recombination_tm


    function Recombination_xe(a)
    real(dl), intent(in) :: a
    real(dl) Recombination_xe,hyrec_xe
    external hyrec_xe

    Recombination_xe = hyrec_xe(a);

    end function Recombination_xe


    subroutine Recombination_init(Recomb, OmegaC, OmegaB, OmegaN, Omegav, h0inp, tcmb, yp, num_nu)
    use AMLUtils
    implicit none
    Type (RecombinationParams), intent(in) :: Recomb
    real(dl), intent(in) :: OmegaC, OmegaB, OmegaN, OmegaV, h0inp, tcmb, yp, num_nu
    external rec_build_history_camb

    call rec_build_history_camb(OmegaC, OmegaB, OmegaN, Omegav, h0inp, tcmb, yp, num_nu)

    end subroutine Recombination_init




    end module Recombination

   module Precision
      implicit none

      integer, parameter :: dl = KIND(1.d0)
      integer, parameter :: sp = KIND(1.0)
   end module Precision

  
   module constants
       use precision
       implicit none
      
       real(dl), parameter :: const_pi = 3.1415926535897932384626433832795_dl
       real(dl), parameter :: const_twopi=2._dl*const_pi, const_fourpi=4._dl*const_pi
       real(dl), parameter :: const_sqrt6=2.4494897427831780981972840747059_dl

       real(dl), parameter :: c = 2.99792458e8_dl
       real(dl), parameter :: h_P = 6.62606896e-34_dl
        
       real(dl), parameter :: G=6.67428e-11_dl
       real(dl), parameter :: sigma_thomson = 6.6524616e-29_dl
       real(dl), parameter :: sigma_boltz = 5.6704e-8_dl
       real(dl), parameter :: k_B = 1.3806504e-23_dl
       real(dl), parameter :: eV = 1.60217646e-19_dl


       real(dl), parameter :: m_p = 1.672621637e-27_dl ! 1.672623e-27_dl
       real(dl), parameter :: m_H = 1.673575e-27_dl !av. H atom
       real(dl), parameter :: m_e = 9.10938215e-31_dl
       real(dl), parameter :: mass_ratio_He_H = 3.9715_dl
 

       real(dl), parameter :: Gyr=3.1556926e16_dl
       real(dl), parameter :: Mpc = 3.085678e22_dl !seem to be different definitions of this?
       real(dl), parameter :: MPC_in_sec = Mpc/c ! Mpc/c = 1.029272d14 in SI units

       real(dl), parameter :: barssc0= k_B / m_p / c**2
       real(dl), parameter :: kappa=8._dl*const_pi*G
       real(dl), parameter :: a_rad = 8._dl*const_pi**5*k_B**4/15/c**3/h_p**3
                !7.565914e-16_dl !radiation constant for u=aT^4


       real(dl), parameter :: Compton_CT = MPC_in_sec*(8.d0/3.d0)*(sigma_thomson/(m_e*c))*a_rad
        !Compton_CT is CT in Mpc units, (8./3.)*(sigma_T/(m_e*C))*a_R in Mpc
        !Used to get evolution of matter temperature
        
       !For 21cm
       real(dl), parameter :: f_21cm = 1420.40575e6_dl, l_21cm= c/f_21cm, T_21cm = h_P*f_21cm/k_B
       real(dl), parameter :: A10 = 2.869e-15, B10 = l_21cm**3/2/h_P/c*A10

       real(dl), parameter :: line21_const = 3*l_21cm**2*C*h_P/32/const_pi/k_B*A10 * Mpc_in_sec * 1000
        !1000 to get in MiliKelvin
       real(dl), parameter :: COBE_CMBTemp = 2.7255_dl !(Fixsen 2009) used as default value
       real(dl), parameter :: default_nnu = 3.046_dl

   end module constants


    module Errors
     implicit none
     
     integer :: global_error_flag=0
     character(LEN=1024) :: global_error_message = ''
     integer, parameter :: error_reionization=1
     integer, parameter :: error_recombination=2
     integer, parameter :: error_inital_power=3
     integer, parameter :: error_evolution=4
     integer, parameter :: error_unsupported_params=5
     
    contains
      
      subroutine GlobalError(message, id)
       character(LEN=*), intent(IN), optional :: message
       integer, intent(in), optional :: id
       
       if (present(message)) then
        global_error_message = message
       else
        global_error_message=''
       end if
       if (present(id)) then
         if (id==0) stop 'Error id must be non-zero'
         global_error_flag=id
       else
         global_error_flag=-1
       end if
      
      end subroutine GlobalError
  
    end module Errors
    

PROGRAM conversion

  IMPLICIT NONE
 
  INTEGER :: n1, n2, i, j
  CHARACTER(LEN=250) :: arg1, arg2, arg3, arg4
  CHARACTER(LEN=500) :: file1, file2
  CHARACTER(LEN=*), PARAMETER :: s1="file1", s2="file2"
  REAL:: x, y
  REAL, DIMENSION(:,:), ALLOCATABLE :: zz

  CALL GETARG(1,arg1)
  CALL GETARG(2,arg2)
  CALL GETARG(3,arg3) 
  CALL GETARG(4,arg4) 

  READ(arg1,*) n1
  READ(arg2,*) n2

  ALLOCATE(zz(n1,n2))

  file1 = TRIM(ADJUSTL(arg3))//s1//TRIM(ADJUSTL(arg4))
  file2 = TRIM(ADJUSTL(arg3))//s2//TRIM(ADJUSTL(arg4))


  OPEN (1,file=file1, status="old")

  DO i=1,n1
     DO j=1,n2
        read(1,*,END=10) x,y,zz(i,j)
     END DO
  END DO
10 CLOSE(1)


  OPEN (2,file=file2,form='unformatted')
  WRITE(2)n1,n2
  WRITE(2)zz
  CLOSE(2)

  
END PROGRAM conversion

    !Matrix utility routines. Uses BLAS/LAPACK. Mostly wrapper routines.
    !Generally (but not always) assumes that all matrix arrays are defined at exactly correct size
    !Not complete
    !Antony Lewis May 2003-2007
    !http://cosmologist.info/utils/


    module MatrixUtils
    use AMLutils
    implicit none

    logical, parameter :: Matrix_runmsgs = .false.
#ifdef MATRIX_SINGLE 
    integer, parameter :: dm = KIND(1.0)
#else
    integer, parameter :: dm = KIND(1.d0)
#endif
    !Precision of matrix operators
    !If changing also need to change prefix on LAPACK routine names
    integer, parameter :: Mat_F90=1, Mat_Norm=2, Mat_DC =3 !Normal, basic BLAS/LAPACK or divide and conquer
    integer, parameter :: matrix_method = mat_DC

    real Matrix_StartTime

    Type TMatrixType
        real(dm), dimension(:,:), pointer :: M
    end Type TMatrixType

    complex(dm), parameter :: COne = (1._dm,0._dm), CZero = (0._dm,0._dm)
    real(dm), parameter :: ROne = 1._dm, RZero = 0._dm
    real, parameter :: SOne = 1., SZero = 0.

    contains


    function GetMatrixTime()
    real GetMatrixTime
    real atime

    call cpu_time(atime)

    GetMatrixTime = atime  


    end function GetMatrixTime

    subroutine  Matrix_start(Name)
    character(LEN=*), intent(in) :: Name

    if (Matrix_runmsgs) then
        Matrix_StartTime = GetMatrixTime()
        Write(*,*) 'Matrix_'//trim(Name) //' start'
    end if
    end subroutine  Matrix_start

    subroutine  Matrix_end(Name)
    character(LEN=*), intent(in) :: Name

    if (Matrix_runmsgs) then
        Write(*,*) 'Matrix_'//trim(Name) //' end: ', GetMatrixTime() - Matrix_StartTime
    end if
    end subroutine  Matrix_end

    subroutine Matrix_WriteFileRow(aunit, vec,n)
    integer, intent(in) :: aunit
    integer, intent(in) :: n
    real(dm) :: vec(n)
    character(LEN=50) fmt

    fmt = trim(numcat('(',n))//'E17.7)'
    write (aunit, fmt) vec(1:n)

    end subroutine Matrix_WriteFileRow

    subroutine Matrix_Write(aname, mat, forcetable, commentline)
    character(LEN=*), intent(in) :: aname
    character(LEN=*), intent(in), optional :: commentline   
    real(dm), intent(in) :: mat(:,:)
    logical, intent(in), optional :: forcetable
    integer i,k
    character(LEN=50) fmt
    integer shp(2)
    logical WriteTab
    integer file_unit

    shp = shape(mat)
    WriteTab = shp(2)<=50
    if (present(forcetable)) then
        if (forcetable) WriteTab = .true.
    end if
    file_unit = new_file_unit()
    call CreateTxtFile(aname, file_unit)
    if (present(commentline)) then
        write(file_unit,'(a)') '#'//trim(commentline)
    end if
    fmt = trim(numcat('(',shp(2)))//'E15.5)'
    do i=1, shp(1)
        if (.not. WriteTab) then
            do k=1, shp(2)
                write (file_unit, '(1E17.7)') mat(i,k)
            end do
        else
            write (file_unit, fmt) mat(i,1:shp(2))
        end if
    end do

    call CloseFile(file_unit)

    end subroutine Matrix_Write

    subroutine Matrix_Write_double(aname, mat, forcetable)
    character(LEN=*), intent(in) :: aname
    double precision, intent(in) :: mat(:,:)
    logical, intent(in), optional :: forcetable
    integer i,k
    character(LEN=50) fmt
    integer shp(2)
    logical WriteTab
    integer file_unit

    shp = shape(mat)
    WriteTab = shp(2)<=50
    if (present(forcetable)) then
        if (forcetable) WriteTab = .true.
    end if
    file_unit = new_file_unit()
    call CreateTxtFile(aname, file_unit)
    fmt = trim(numcat('(',shp(2)))//'E15.5)'
    do i=1, shp(1)
        if (.not. WriteTab) then
            do k=1, shp(2)
                write (file_unit, '(1E17.7)') mat(i,k)
            end do
        else
            write (file_unit, fmt) mat(i,1:shp(2))
        end if
    end do

    call CloseFile(file_unit)

    end subroutine Matrix_Write_double


    subroutine Matrix_Write_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: mat(:,:)
    integer file_unit

    file_unit = new_file_unit()
    call CreateFile(aname, file_unit,'unformatted')
    write (file_unit) mat
    call CloseFile(file_unit)

    end subroutine Matrix_Write_Binary


    subroutine MatrixSym_Write_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: mat(:,:)
    integer i
    integer shp(2)
    integer file_unit

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop('MatrixSym_Write_Binary: Not square matrix')
    if (shp(1) == 0) return

    file_unit = new_file_unit()
    call CreateFile(aname, file_unit,'unformatted')
    do i=1,shp(1) 
        write (file_unit) mat(i:shp(2),i)
    end do 
    call CloseFile(file_unit)

    end subroutine MatrixSym_Write_Binary

    subroutine MatrixSym_Write_Binary_Single(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: mat(:,:)
    integer i,    file_unit 
    integer shp(2)

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop('MatrixSym_Write_Binary_Single: Not square matrix')
    if (shp(1) == 0) return

    file_unit = new_file_unit()
    call CreateFile(aname, file_unit,'unformatted')
    do i=1,shp(1) 
        write (file_unit) real(mat(i:shp(2),i), kind(1.0))
    end do 
    call CloseFile(file_unit)

    end subroutine MatrixSym_Write_Binary_Single



    subroutine Matrix_WriteVec(aname, vec)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: vec(:)
    integer i,   file_unit 

    file_unit = new_file_unit()
    call CreateTxtFile(aname, file_unit)
    do i=1, size(vec)
        write (file_unit, '(1E17.7)') vec(i)
    end do
    call CloseFile(file_unit)

    end subroutine Matrix_WriteVec


    subroutine Matrix_Read_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(out) :: mat(:,:)
    integer  file_unit

    file_unit = new_file_unit()
    call OpenFile(aname, file_unit,'unformatted')
    read (file_unit) mat
    call CloseFile(file_unit)

    end subroutine Matrix_Read_Binary


    subroutine MatrixSym_Read_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(out) :: mat(:,:)
    integer i,    file_unit
    integer shp(2)

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop( 'MatrixSym_Read_Binary: Not square matrix')
    if (shp(1) == 0) return

    file_unit = new_file_unit()
    call OpenFile(aname, file_unit,'unformatted')
    do i=1,shp(1)
        read (file_unit) mat(i:shp(1),i)
        mat(i,i:shp(1)) = mat(i:shp(1),i)
    end do
    call CloseFile(file_unit)

    end subroutine MatrixSym_Read_Binary

    subroutine MatrixSym_Read_Binary_Single(aname, mat)
    character(LEN=*), intent(in) :: aname
    real, intent(out) :: mat(:,:)
    integer i,    file_unit
    integer shp(2)

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop( 'MatrixSym_Read_Binary: Not square matrix')
    if (shp(1) == 0) return

    file_unit = new_file_unit()
    call OpenFile(aname, file_unit,'unformatted')
    do i=1,shp(1)
        read (file_unit) mat(i:shp(1),i)
        mat(i,i:shp(1)) = mat(i:shp(1),i)
    end do
    call CloseFile(file_unit)

    end subroutine MatrixSym_Read_Binary_Single





    subroutine Matrix_Read(aname, mat)
    character(LEN=*), intent(IN) :: aname
    real(dm), intent(out) :: mat(:,:)
    integer j,k,    file_unit
    integer shp(2)
    real(dm) tmp

    shp = shape(mat)

    file_unit = new_file_unit()
    call OpenTxtFile(aname, file_unit)

    do j=1,shp(1)
        read (file_unit,*, end = 200, err=100) mat(j,1:shp(2))
    end do
    goto 120

100 rewind(file_unit)  !Try other possible format
    do j=1,shp(1) 
        do k=1,shp(2)
            read (file_unit,*, end = 200) mat(j,k)
        end do
    end do

120 read (file_unit,*, err = 150, end =150) tmp
    goto 200

150 call CloseFile(file_unit)
    return

200 call MpiStop('Matrix_Read: file '//trim(aname)//' is the wrong size')


    end subroutine Matrix_Read

    subroutine Matrix_ReadSingle(aname, mat)
    character(LEN=*), intent(IN) :: aname
    real, intent(out) :: mat(:,:)
    integer j,k,    file_unit 
    integer shp(2)
    real tmp

    shp = shape(mat)

    file_unit = new_file_unit()
    call OpenTxtFile(aname, file_unit)

    do j=1,shp(1)
        read (file_unit,*, end = 200, err=100) mat(j,1:shp(2))
    end do
    goto 120

100 rewind(file_unit)  !Try other possible format
    do j=1,shp(1) 
        do k=1,shp(2)
            read (file_unit,*, end = 200) mat(j,k)
        end do
    end do

120 read (file_unit,*, err = 150, end =150) tmp
    goto 200

150 call CloseFile(file_unit)
    return

200 call MpiStop('Matrix_Read:Single file '//trim(aname)//' is the wrong size')


    end subroutine Matrix_ReadSingle


    function Matrix_Diag(M, n)
    integer, intent(in) :: n
    real(dm), intent(in) :: M(:,:)
    real(dm) Matrix_Diag(n)
    integer i

    do i=1,n

    Matrix_Diag(i) = M(i,i)

    end do

    end function Matrix_Diag

    function ILAENV_wrap(i,S1,S2,a,b,c,d)
    integer ILAENV_wrap
    integer, intent(in) :: i,a,b,c,d
    character(LEN=*), intent(in) :: S1, S2
    integer, external :: ILAENV

    !If you don't have ILAENV in math library, change routine to return some positive integer
    !that is a guess at the blocksize
#ifdef MATRIX_SINGLE
    ILAENV_wrap = 16
#else 
    ILAENV_wrap =  ILAENV(i,S1,S2,a,b,c,d)
#endif
    !!!IFC 
    end  function ILAENV_wrap


    subroutine Matrix_Diagonalize(M, diag, n)
    !Does m = U diag U^T, returning U in M
    integer, intent(in) :: n
    real(dm), intent(inout):: m(n,n)
    real(dm), intent(out) :: diag(n)
    integer ierr, tmpsize
    real(dm), allocatable, dimension(:) :: tmp

    call Matrix_Start('Diagonalize')      
#ifdef MATRIX_SINGLE 
    tmpsize =  max( (ILAENV_wrap(1,'SSYTRD','U',n,n,n,n)+2)*N,max(1,3*n-1))  !3*n**2
    allocate(tmp(tmpsize));
    call SSYEV('V','U',n,m,n,diag,tmp,tmpsize,ierr) !evalues and vectors of symmetric matrix
#else
    tmpsize =  max( (ILAENV_wrap(1,'DSYTRD','U',n,n,n,n)+2)*N,max(1,3*n-1))  !3*n**2
    allocate(tmp(tmpsize));
    call DSYEV('V','U',n,m,n,diag,tmp,tmpsize,ierr) !evalues and vectors of symmetric matrix
#endif
    if (ierr /= 0) call MpiStop('Error in Matrix_Diagonalize')
    deallocate(tmp)
    call Matrix_End('Diagonalize')

    end subroutine Matrix_Diagonalize

    subroutine Matrix_Diagonalize_DC(M, diag, n)
    !Complex version. Does m = U diag U^dag, returning U in M
    integer, intent(in) :: n
    real(dm), intent(inout):: m(n,n)
    real(dm), intent(out) :: diag(n)
    integer ierr, tmpsize ,isize
    real(dm), allocatable, dimension(:) :: tmp
    integer, allocatable,dimension(:):: iwork

    call Matrix_Start('Diagonalize')

    if (matrix_method == Mat_DC) then
        !Divide and conquer
        tmpsize = 1 + 6*N + 2*N**2 
        isize = 3+5*N
        allocate(tmp(tmpsize))
        allocate(iwork(isize))
#ifdef MATRIX_SINGLE 
        call SSYEVD('V','U',n,M,n,diag,tmp,tmpsize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#else
        call DSYEVD('V','U',n,M,n,diag,tmp,tmpsize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#endif
        deallocate(iwork)
        deallocate(tmp)
    else
        call Matrix_Diagonalize(M, diag, n)
    end if

    if (ierr /= 0) call MpiStop('Error in Matrix_Diagonalize')

    call Matrix_End('Diagonalize')

    end subroutine Matrix_Diagonalize_DC



    subroutine Matrix_Root(M, n, pow)
    !Does M**pow for symmetric M using U D**pow U^T
    !Not optimized for large matrices
    integer, intent(in) :: n
    real(dm), intent(inout):: M(n,n)
    real(dm) :: Tmp(n,n)
    real(dm), intent(in) :: pow

    real(dm) :: diag(n)
    integer i

    call Matrix_Diagonalize(M, diag, n)
    Tmp = M
    diag = diag**pow
    do i = 1, n
        M(:,i) = M(:,i)*diag(i)
    end do
    M = matmul(M,transpose(Tmp))

    end subroutine Matrix_Root


    subroutine Matrix_Diagonalize_Partial(M, diag, n, emin,emax, nfound)
    !Real version. Does m = U diag U^dag, returning U in M
    !Assumes up to nfound values will be found. nfound set to true value on exit
    integer, intent(in) :: n
    real(dm), intent(inout):: m(:,:)
    real(dm), intent(out) :: diag(:)
    real(dm), intent(in) :: emin,emax
    integer, intent(inout) :: nfound
    integer ierr, worksize, LIWork
    real(dm), allocatable, dimension(:) :: work
    real(dm), allocatable, dimension(:,:) :: tmp
    integer, allocatable,dimension(:):: supp,iwork
    real(dm) wsize(1)
    real(dm)  atol
    integer ISize(1)

    atol = 1d-9
    call Matrix_Start('Matrix_Diagonalize_Partial')
    allocate(tmp(n,nfound))
    allocate(Supp(n))
    !Query
    WorkSize = -1
    LIWork = -1
#ifdef MATRIX_SINGLE 
    call SSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,WSize,WorkSize,ISize,LIWork,ierr  )
#else     
    call DSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,WSize,WorkSize,ISize,LIWork,ierr  )
#endif
    WorkSize = Real(WSize(1))
    LIWork = ISize(1)
    allocate(Work(WorkSize),IWork(LIWork))
#ifdef MATRIX_SINGLE 
    call SSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,Work,WorkSize,IWork,LIWork,ierr )
#else
    call DSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,Work,WorkSize,IWork,LIWork,ierr )
#endif
    deallocate(Supp,Work,IWork)
    if (ierr /= 0) call MpiStop('Matrix_Diagonalize_Partial: Error') 
    M(1:n,1:nfound) = tmp(1:n,1:nfound)  !nfound now different
    deallocate(tmp)
    call Matrix_End('Matrix_Diagonalize_Partial')

    end subroutine Matrix_Diagonalize_Partial


    subroutine Matrix_CDiagonalize_Partial(M, diag, n, emin,emax, nfound)
    !Complex version. Does m = U diag U^dag, returning U in M
    !Assumes up to nfound values will be found. nfound set to true value on exit
    integer, intent(in) :: n
    complex(dm), intent(inout):: m(:,:)
    real(dm), intent(out) :: diag(:)
    real(dm), intent(in) :: emin,emax
    integer, intent(inout) :: nfound
    integer ierr, worksize, LRWork, LIWork
    real(dm), allocatable, dimension(:) :: Rwork
    complex(dm), allocatable, dimension(:) :: work
    complex(dm), allocatable, dimension(:,:) :: tmp
    integer, allocatable,dimension(:):: supp,iwork
    complex(dm) wsize(1)
    real(dm) Rsize(1), atol
    integer ISize(1)

    atol = 1d-9
    call Matrix_Start('Matrix_CDiagonalize_Partial')
    allocate(tmp(n,nfound))
    allocate(Supp(n))
    !Query
    WorkSize = -1
    LRWork = -1
    LIWork = -1
#ifdef MATRIX_SINGLE 
    call CHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,WSize,WorkSize,RSize,LRWork,ISize,LIWork,ierr  )
#else     
    call ZHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,WSize,WorkSize,RSize,LRWork,ISize,LIWork,ierr  )
#endif
    WorkSize = Real(WSize(1))
    LRWork = RSize(1)
    LIWork = ISize(1)
    allocate(Work(WorkSize),RWork(LRWork),IWork(LIWork))
#ifdef MATRIX_SINGLE 
    call CHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,Work,WorkSize,RWork,LRWork,IWork,LIWork,ierr )
#else
    call ZHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
    Supp,Work,WorkSize,RWork,LRWork,IWork,LIWork,ierr )
#endif
    deallocate(Supp,Work,RWork,IWork)
    if (ierr /= 0) call MpiStop('Matrix_CDiagonalize_Partial: Error') 
    M(1:n,1:nfound) = tmp(1:n,1:nfound)  !nfound now different
    deallocate(tmp)
    call Matrix_End('Matrix_CDiagonalize_Partial')


    end subroutine


    subroutine Matrix_CDiagonalize(M, diag, n)
    !Complex version. Does m = U diag U^dag, returning U in M
    integer, intent(in) :: n
    complex(dm), intent(inout):: m(n,n)
    real(dm), intent(out) :: diag(n)
    integer ierr, tmpsize ,isize, rworksize
    real(dm), allocatable, dimension(:) :: Rwork
    complex(dm), allocatable, dimension(:) :: tmp
    integer, allocatable,dimension(:):: iwork

    call Matrix_Start('CDiagonalize')

    if (matrix_method == Mat_DC) then
        !Divide and conquer
        tmpsize = 2*N + N**2 
        rworksize =  1 + 4*N + 2*N*int(log(real(N))/log(2.)+1) + 3*N**2
        isize =  (2 + 5*N)*4
        allocate(tmp(tmpsize),rwork(rworksize))
        allocate(iwork(isize))
#ifdef MATRIX_SINGLE 
        call CHEEVD('V','U',n,M,n,diag,tmp,tmpsize,Rwork,rworksize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#else
        call ZHEEVD('V','U',n,M,n,diag,tmp,tmpsize,Rwork,rworksize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#endif
        deallocate(iwork)

    else

    rworksize =  max(1, 3*n-2)
#ifdef MATRIX_SINGLE 
    tmpsize = max( (ILAENV_wrap(1,'CHETRD','U',n,n,n,n)+1)*N,max(1,2*n-1)) !   3*n**2
    allocate(tmp(tmpsize),rwork(rworksize));
    call CHEEV('V','U',n,m,n,diag,tmp,tmpsize,Rwork,ierr) !evalues and vectors of hermitian matrix
#else
    tmpsize = max( (ILAENV_wrap(1,'ZHETRD','U',n,n,n,n)+1)*N,max(1,2*n-1)) !   3*n**2
    allocate(tmp(tmpsize),rwork(rworksize));
    call ZHEEV('V','U',n,m,n,diag,tmp,tmpsize,Rwork,ierr) !evalues and vectors of hermitian matrix
#endif
    end if

    if (ierr /= 0) call MpiStop('Error in Matrix_CDiagonalize')
    deallocate(tmp,rwork)

    call Matrix_End('CDiagonalize')

    end subroutine Matrix_CDiagonalize

    function Matrix_CTrace(M)
    complex(dm), intent(in) :: M(:,:)
    complex(dm) tmp,Matrix_CTrace
    integer i

    if (size(M,dim=1) /= size(M,dim=2)) call MpiStop('Matrix_CTrace: non-square matrix')
    tmp =0
    do i=1,size(M,dim=1)
        tmp = tmp + M(i,i)  
    end do
    Matrix_CTrace = tmp

    end function Matrix_CTrace

    function Matrix_Trace(M)
    real(dm), intent(in) :: M(:,:)
    real(dm) tmp,Matrix_Trace
    integer i

    if (size(M,dim=1) /= size(M,dim=2)) call mpiStop('Matrix_Trace: non-square matrix')
    tmp =0
    do i=1,size(M,dim=1)
        tmp = tmp + M(i,i)  
    end do
    Matrix_Trace = tmp

    end function Matrix_Trace


    function MatrixSym_LogDet(mat) result (logDet)
    real(dm), intent(in) :: mat(:,:)
    real(dm) logDet
    real(dm) Tmp(size(mat,dim=1),size(mat,dim=1))
    integer i

    if (size(mat,dim=1) /= size(mat,dim=2)) call mpiStop('MatrixSym_LogDet: non-square matrix')
    Tmp = mat
    call Matrix_Cholesky(tmp)
    logDet =0
    do i=1, size(mat,dim=1)
        logDet = logDet  + log(tmp(i,i))
    end do
    logDet = 2._dm*logDet

    end function MatrixSym_LogDet


    subroutine Matrix_CRotateSymm(Mat,U,m,Out,triangular)
    !Gets U^dag Mat U
    integer, intent(in) ::m
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:) 
    complex(dm), dimension(:,:), allocatable :: C
    integer n
    logical, intent(in), optional :: triangular
    logical :: triang

    call Matrix_Start('CRotateSymm')

    if (present(triangular)) then
        triang=triangular
    else
        triang=.false.
    end if

    n = Size(Mat,DIM=1)
    if (n /= Size(Mat,DIM=2)) call mpiStop('Matrix_CRotateSymm: Need square matrix')
    if (n /= Size(U,DIM=1)) call MpiStop('Matrix_CRotateSymm: Matrix size mismatch')
    if (Size(Out,DIM=1) < m .or. Size(Out,DIM=2) < m) &
    call MpiStop('Matrix_CRotateSymm: Wrong output size')

    if (matrix_method == Mat_F90) then
        Out = matmul(matmul(transpose(conjg(U(1:n,1:m))),Mat),U(1:n,1:m))
    else
#ifdef MATRIX_SINGLE   
        if (triang) then
            if (m/=n) call MpiStop('Matrix_CRotateSymm: Matrices must be same size')
            call CHEMM('L','U',n,n,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
            call CTRMM('Left','Upper','Complex-Transpose','Not-unit',n,n,COne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else       
            allocate(C(n,m))
            call CHEMM('L','U',n,m,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,C,n)
            call CGEMM('C','N',m,m,n,COne,U,Size(U,DIM=1),C,n,CZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#else
        if (triang) then
            if (m/=n) call MpiStop('Matrix_CRotateSymm: Matrices must be same size')
            call ZHEMM('L','U',n,n,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
            call ZTRMM('Left','Upper','Complex-Transpose','Not-unit',n,n,COne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else 
            allocate(C(n,m))
            call ZHEMM('L','U',n,m,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,C,n)
            call ZGEMM('C','N',m,m,n,COne,U,Size(U,DIM=1),C,n,CZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#endif
    end if
    call Matrix_End('CRotateSymm')


    end subroutine Matrix_CRotateSymm

    subroutine Matrix_RotateSymm(Mat,U,m,Out, triangular)
    !Gets U^T Mat U
    !If triangular U = Upper triangular (U^T lower triangular)
    integer, intent(in) ::m
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:) 
    real(dm), dimension(:,:), allocatable :: C
    logical, intent(in), optional :: triangular
    logical triang
    integer n

    call Matrix_Start('RotateSymm')

    if (present(triangular)) then
        triang=triangular
    else
        triang=.false.
    end if

    n = Size(Mat,DIM=1)
    if (n /= Size(Mat,DIM=2)) call MpiStop('Matrix_RotateSymm: Need square matrix')
    if (n /= Size(U,DIM=1)) call MpiStop('Matrix_RotateSymm: Matrix size mismatch')
    if (Size(Out,DIM=1) < m .or. Size(Out,DIM=2) < m) &
    call MpiStop('Matrix_RotateSymm: Wrong output size')

    if (matrix_method == Mat_F90) then
        Out = matmul(matmul(transpose(U(1:n,1:m)),Mat),U(1:n,1:m))
    else
#ifdef MATRIX_SINGLE             
        if (triang) then
            if (m/=n) call MpiStop('Matrix_RotateSymm: Matrices must be same size')
            call SSYMM('L','U',n,n,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
            call STRMM('Left','Upper','Transpose','Not-unit',n,n,ROne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else
            allocate(C(n,m))
            call SSYMM('L','U',n,m,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,C,n)
            call SGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#else
        if (triang) then
            if (m/=n) call MpiStop('Matrix_RotateSymm: Matrices must be same size')
            call DSYMM('L','U',n,n,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
            call DTRMM('Left','Upper','Transpose','Not-unit',n,n,ROne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else
            allocate(C(n,m))
            call DSYMM('L','U',n,m,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,C,n)
            call DGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#endif
    end if
    call Matrix_End('RotateSymm')


    end subroutine Matrix_RotateSymm


    subroutine Matrix_RotateAntiSymm(Mat,U,m,Out)
    !Gets U^T Mat U
    !Where Mat = -Mat^T
    integer, intent(in) ::m
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:) 
    real(dm), dimension(:,:), allocatable :: C
    integer i,j,n

    call Matrix_Start('RotateAntiSymm')

    n = Size(Mat,DIM=1)
    if (n /= Size(Mat,DIM=2)) call MpiStop('Matrix_RotateAntiSymm: Need square matrix')
    if (n /= Size(U,DIM=1)) call MpiStop('Matrix_RotateAntiSymm: Matrix size mismatch')
    if (Size(Out,DIM=1) < m .or. Size(Out,DIM=2) < m) &
    call MpiStop('Matrix_RotateAntiSymm: Wrong output size')

    if (matrix_method == Mat_F90) then
        Out = matmul(matmul(transpose(U(1:n,1:m)),Mat),U(1:n,1:m))
    else
        allocate(C(n,m))
        C = U(1:n,1:m)
#ifdef MATRIX_SINGLE             
        call STRMM('Left','Lower','Not-Transpose','Not-unit',n,m,ROne,Mat,Size(Mat,DIM=1),C,Size(C,Dim=1))
        call SGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
#else
        call DTRMM('Left','Lower','Not-Transpose','Not-unit',n,m,ROne,Mat,Size(Mat,DIM=1),C,Size(C,Dim=1))
        call DGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
#endif
        deallocate(C)
    end if

    do i=1, m
        do j=1,i
            Out(j,i) = Out(j,i) - Out(i,j)
            out(i,j) = -Out(j,i)
        end do
    end do  

    call Matrix_End('RotateAntiSymm')

    end subroutine Matrix_RotateAntiSymm

    subroutine Matrix_CMult_SymmRight(Mat,U,Out,a,b)
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:) 
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta 
    integer n,m

    call Matrix_Start('CMult_SymmRight')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (n /= Size(Mat,DIM=2) .or. n/=Size(U,DIM=1)) &
    call MpiStop('Matrix_CMult_SymmRight: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = CZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if     
    else 
#ifdef MATRIX_SINGLE 
        call CHEMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#else     
        call ZHEMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('CMult_SymmRight')

    end subroutine Matrix_CMult_SymmRight


    subroutine Matrix_CMult_SymmLeft(Mat,U,Out,a,b)
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:) 
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta 
    integer n,m

    call Matrix_Start('CMult_SymmLeft')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (m /= Size(U,DIM=1) .or. m/=Size(Mat,DIM=2)) &
    call MpiStop('Matrix_CMult_SymmLeft: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = CZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if     
    else 
#ifdef MATRIX_SINGLE
        call CHEMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#else     
        call ZHEMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('CMult_SymmLeft')

    end subroutine Matrix_CMult_SymmLeft


    subroutine Matrix_CMult(Mat,U,Out,a,b)
    ! Out = a*Mat U + b*out
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:) 
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta 
    integer m,n,k

    call Matrix_Start('CMult')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_Mult: Matrix size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = CZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if     
    else
#ifdef MATRIX_SINGLE
        call CGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#else
        call ZGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMult')


    end subroutine Matrix_CMult


    subroutine Matrix_MultSq_RepRight(Mat,U,a)
    !U = a*Mat*U
    real(dm), intent(in) :: Mat(:,:)
    real(dm), intent(inout) ::U(:,:)
    real(dm), intent(in), optional :: a
    real(dm) aa
    integer m,n
    real(dm), dimension(:,:), allocatable :: tmp


    m = Size(Mat,DIM=1)
    n = Size(Mat,DIM=2)
    if (m /= n) call MpiStop('Matrix_MultSq: Matrix size mismatch')
    m = Size(U,DIM=1)
    n = Size(U,DIM=2)
    if (m /= n) call MpiStop('Matrix_MultSq: Matrix size mismatch')

    allocate(tmp(n,n))
    if (present(a)) then
        aa=a
    else
        aa=ROne
    end if 

    call Matrix_Mult(Mat,U,tmp,aa)
    U = tmp
    deallocate(tmp)

    end  subroutine Matrix_MultSq_RepRight

    subroutine Matrix_MultTri(Mat,L, side)
    ! Mat -> L Mat or Mat L where L is lower triangular
    real(dm), intent(inout) :: Mat(:,:)
    real(dm), intent(in) :: L(:,:) 
    character(LEN=*), intent(in) :: side
    integer m,n

    call Matrix_Start('Matrix_MultTri')

    m = Size(Mat,DIM=1)
    n = Size(Mat,DIM=2)

    if (side(1:1)=='L') then
        if (Size(L,DIM=2) /= m) call MpiStop('Matrix_MultTri: Matrix size mismatch')
    else
        if (Size(L,DIM=1) /= n) call MpiStop('Matrix_MultTri: Matrix size mismatch')
    end if
#ifdef MATRIX_SINGLE
    call STRMM(side,'Lower','Not-Transpose','Not-unit',m,n,ROne,L,Size(L,DIM=1),Mat,Size(Mat,Dim=1))
#else
    call DTRMM(side,'Lower','Not-Transpose','Not-unit',m,n,ROne,L,Size(L,DIM=1),Mat,Size(Mat,Dim=1))
#endif
    call Matrix_End('Matrix_MultTri')

    end subroutine Matrix_MultTri



    subroutine Matrix_Mult(Mat,U,Out,a,b)
    ! Out = a*Mat U + b*out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) :: Out(:,:) 
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer m,n,k

    call Matrix_Start('Mult')


    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_Mult: Matrix size mismatch')


    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= ROne) Out = Out*mult
        end if     
    else
#ifdef MATRIX_SINGLE
        call SGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#else     
        call DGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('Mult')


    end subroutine Matrix_Mult

    subroutine Matrix_Mult_SymmLeft(Mat,U,Out,a,b)
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:) 
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer n,m

    call Matrix_Start('Mult_SymmLeft')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (m /= Size(U,DIM=1) .or. m/=Size(Mat,DIM=2)) &
    call MpiStop('Matrix_Mult_SymmLeft: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if     
    else 
#ifdef MATRIX_SINGLE
        call SSYMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#else     
        call DSYMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('Mult_SymmLeft')

    end subroutine Matrix_Mult_SymmLeft


    subroutine Matrix_Mult_SymmRight(Mat,U,Out,a,b)
    ! Out = a*Mat U + b*out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:) 
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer n,m

    call Matrix_Start('Mult_SymmRight')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (n /= Size(Mat,DIM=2) .or. n/=Size(U,DIM=1)) &
    call MpiStop('Matrix_Mult_SymmRight: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= ROne) Out = Out*mult
        end if     
    else 
#ifdef MATRIX_SINGLE
        call SSYMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#else     
        call DSYMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('Mult_SymmRight')

    end subroutine Matrix_Mult_SymmRight


    subroutine Matrix_CMultGen(Mat,m,k,U,n,Out)
    !     out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    integer, intent(in) :: m,k,n
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:) 

    call Matrix_Start('CMultGen')

    if (SIZE(Out,DIM=1) <m .or. Size(Out,Dim=2) < n) call MpiStop('Matrix_CMultGen: bad Out size')

    if (matrix_method == Mat_F90) then
        out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    else
#ifdef MATRIX_SINGLE
        call CGEMM('N','N',m,n,k,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
#else
        call ZGEMM('N','N',m,n,k,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMultGen')


    end subroutine Matrix_CMultGen



    subroutine Matrix_MultGen(Mat,m,k,U,n,Out)
    !     out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    integer, intent(in) :: m,k,n
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:) 

    call Matrix_Start('MultGen')

    if (SIZE(Out,DIM=1) <m .or. Size(Out,Dim=2) < n) call MpiStop('Matrix_MultGen: bad Out size')

    if (matrix_method == Mat_F90) then
        out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    else
#ifdef MATRIX_SINGLE
        call SGEMM('N','N',m,n,k,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
#else
        call DGEMM('N','N',m,n,k,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('MultGen')


    end subroutine Matrix_MultGen


    subroutine Matrix_CMult_NT(Mat,U,Out,a,b)
    ! Out = a*Mat U^dag + b*out
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:) 
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta 
    integer m,n,k

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=1)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=2)) call MpiStop('Matrix_CMult_NT: Matrix size mismatch')
    call Matrix_start('CMult_NT')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = CZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            Out = beta*Out + mult*matmul(Mat,conjg(transpose(U))) 
        else
            Out = matmul(Mat,conjg(transpose(U))) 
            if (mult/= COne) Out=Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CGEMM('N','C',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#else     
        call ZGEMM('N','C',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMult_NT')


    end subroutine Matrix_CMult_NT

    subroutine Matrix_Mult_NT(Mat,U,Out,a,b)
    ! Out = a*Mat U^T + b*out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:) 
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer m,n,k

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=1)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=2)) call MpiStop('Matrix_Mult_NT: Matrix size mismatch')
    call Matrix_start('Mult_NT')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            Out = beta*Out + mult*matmul(Mat,transpose(U)) 
        else
            Out = matmul(Mat,transpose(U)) 
            if (mult/= ROne) Out=Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SGEMM('N','T',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#else
        call DGEMM('N','T',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('Mult_NT')


    end subroutine Matrix_Mult_NT


    subroutine Matrix_CMult_TN(Mat,U,Out,a,b)
    ! Out = a*Mat^dag U + b*Out
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta 
    integer m,n,k

    m = Size(Mat,DIM=2)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=1)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_CMult_TN: Matrix size mismatch')

    call Matrix_Start('CMult_TN')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = CZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = mult*MatMul(conjg(transpose(Mat)),U) + beta*out
        else
            out = MatMul(conjg(transpose(Mat)),U)
            if (mult /= COne) out = out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CGEMM('C','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#else
        call ZGEMM('C','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMult_TN')

    end subroutine Matrix_CMult_TN

    subroutine Matrix_Mult_TN(Mat,U,Out,a,b)
    ! Out = a*Mat^dag U + b*Out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer m,n,k

    m = Size(Mat,DIM=2)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=1)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_Mult_TN: Matrix size mismatch')

    call Matrix_Start('CMult_TN')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = mult*MatMul(transpose(Mat),U) + beta*out
        else
            out = MatMul(transpose(Mat),U)
            if (mult /= COne) out = out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SGEMM('T','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#else
        call DGEMM('T','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('Mult_TN')

    end subroutine Matrix_Mult_TN

    subroutine Matrix_Cholesky(M, err, zeroed)
    !Note upper triangular is not zeroed
    real(dm), intent(inout):: M(:,:)
    integer n, info
    integer, optional :: err
    logical, intent(in), optional :: zeroed
    integer i

    n=Size(M,DIM=1)
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_Cholesky: non-square matrix')

#ifdef MATRIX_SINGLE
    call spotrf ('L', n, M, n, info)
#else
    call dpotrf ('L', n, M, n, info)
#endif

    if (present(err)) then
        err = info
    else
        if (info/=0) &
        call MpiStop('Matrix_Cholesky: not positive definite '//trim(IntToStr(info))) 
    end if

    if (info==0 .and. present(zeroed)) then
        do i=1,n
            M(1:i-1,i)=0
        end do
    end if

    end subroutine Matrix_Cholesky

    subroutine Matrix_CCholesky(M)
    !M = L L^\dag
    complex(dm), intent(inout):: M(:,:)
    integer n, info

    n=Size(M,DIM=1)
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_CCholesky: non-square matrix')

#ifdef MATRIX_SINGLE
    call cpotrf ('L', n, M, n, info)
#else
    call zpotrf ('L', n, M, n, info)
#endif

    if (info/=0) call MpiStop('Matrix_CCholesky: not positive definite '//trim(IntToStr(info))) 

    end subroutine Matrix_CCholesky


    subroutine Matrix_CholeskyRootInverse(M,transpose, error)
    !M = L L^T and return L^{-1} in M  ( or [L^(-1}]^T )
    real(dm), intent(inout):: M(:,:)
    integer n, info
    integer i,j
    logical, intent(in), optional :: transpose 
    integer, intent(out), optional :: error
    logical trans

    call Matrix_Cholesky(M, info) 
    if (info==0) then
        n=size(M,dim=1)
#ifdef MATRIX_SINGLE
        call STRTRI( 'L', 'N', n, M, n, INFO )
#else
        call DTRTRI( 'L', 'N', n, M, n, INFO )
#endif
    end if
    if (present(error)) error=info
    if (info/=0) then
        if (present(error)) return
        call MpiStop('Matrix_CholeskyRootInverse: not positive definite '//trim(IntToStr(info)))
    end if

    if (present(transpose)) then
        trans = transpose
    else
        trans = .false.
    end if

    if (trans) then

    do i=1,n
        do j=1,i-1
            M(j,i) = M(i,j)
            M(i,j) = 0
        end do
    end do 

    else

    do i=1,n
        do j=1,i-1
            M(j,i) = 0
        end do
    end do 

    end if
    end subroutine Matrix_CholeskyRootInverse

    subroutine Matrix_CCholeskyRootInverse(M,dagger)
    !M = L L^\dag and return L^{-1} in M  ( or [L^(-1}]^\dag )
    complex(dm), intent(inout):: M(:,:)
    integer n, info
    integer i,j
    logical, intent(in), optional :: dagger 
    logical trans

    call Matrix_CCholesky(M) 
    n=size(M,dim=1)

#ifdef MATRIX_SINGLE
    call CTRTRI( 'L', 'N', n, M, n, INFO )
#else
    call ZTRTRI( 'L', 'N', n, M, n, INFO )
#endif

    if (info/=0) call MpiStop('Matrix_CCholeskyRootInverse: not positive definite '//trim(IntToStr(info))) 

    if (present(dagger)) then
        trans = dagger
    else
        trans = .false.
    end if

    if (trans) then

    do i=1,n
        do j=1,i-1
            M(j,i) = conjg(M(i,j))
            M(i,j) = 0
        end do
    end do 

    else

    do i=1,n
        do j=1,i-1
            M(j,i) = 0
        end do
    end do 

    end if
    end subroutine Matrix_CCholeskyRootInverse


    subroutine Matrix_inverse_chol(M, err)
    !Inverse of symmetric matrix
    !This should not be used in real situations, but useful for quick testing
    real(dm), intent(inout):: M(:,:)
    integer i,j,n
    integer info  
    integer, optional :: err

    n=Size(M,DIM=1)
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_Inverse: non-square matrix')
    call Matrix_Start('Inverse')
    if (present(err)) then
        call Matrix_Cholesky(M,err)
        if (err/=0) return
    else
        call Matrix_Cholesky(M)
    end if
#ifdef MATRIX_SINGLE
    call spotri ('L', n, M, n, info)
#else
    call dpotri ('L', n, M, n, info)
#endif
    if (present(err)) then
        err = info
        if (err/=0) return    
    else
        if (info/=0) call MpiStop('Matrix_inverse: error '//trim(IntToStr(info))) 
    end if
    do i=1,n
        do j=1,i-1
            M(j,i) = M(i,j)
        end do
    end do 
    call Matrix_End('Inverse')

    end   subroutine Matrix_inverse_chol

    subroutine Matrix_Inverse(M)
    !Inverse of symmetric positive definite matrix
    real(dm), intent(inout):: M(:,:)
    integer i, n

    !     real(dm) w(Size(M,DIM=1))
    !     real(dm), dimension(:,:), allocatable :: tmp, tmp2
    !     real(dm), dimension(:), allocatable :: norm


    n = size(M,DIM=1)
    do i=1, size(M,DIM=1)
        if (abs(M(i,i)) < 1d-30) call MpiStop('Matrix_Inverse: very small diagonal'  )
    end do

    call Matrix_Inverse_Chol(M)
    !
    !     allocate(tmp(Size(M,DIM=1),Size(M,DIM=1)))
    !   
    !     n=Size(M,DIM=1)
    !     if (n<=1) return
    !     if (Size(M,DIM=2)/=n) call MpiStop('Matrix_Inverse: non-square matrix')
    !     call Matrix_Start('Inverse')
    !          
    !
    !     allocate(norm(n))
    !     do i=1, n
    !        norm(i) = sqrt(abs(M(i,i)))
    !        if (norm(i) < 1d-30) &
    !         call MpiStop('Matrix_Inverse: very small diagonal'  )
    !        M(i,:) = M(i,:)/norm(i)
    !        M(:,i) = M(:,i)/norm(i)
    !     end do
    !
    !     call Matrix_Diagonalize(M,w,n)    
    !     write (*,*), 'min/max eigenvalues = ', minval(w), maxval(w)
    !     if (any(w<=0)) then
    !          write (*,*), 'min/max eigenvalues = ', minval(w), maxval(w)
    !          call MpiStop('Matrix_Inverse: negative or zero eigenvalues')  
    !     end if
    !     do i=1, n
    !        tmp(i,:) = M(:,i)/w(i)
    !     end do
    !     allocate(tmp2(Size(M,DIM=1),Size(M,DIM=1)))
    !     call Matrix_Mult(M,tmp,tmp2)     
    !     M = tmp2
    !     do i=1, n
    !        M(i,:) = M(i,:)/norm(i)
    !        M(:,i) = M(:,i)/norm(i)
    !     end do
    !     deallocate(tmp, tmp2) 
    !     deallocate(norm)
    !     call Matrix_End('Inverse')

    end subroutine Matrix_Inverse

    function Matrix_GaussianLogLike(Cov, d) result(LogLike)
    !Returns -Log Likelihood for Gaussian: (d^T Cov^{-1} d + log|Cov|)/2
    !** Cov is destroyed by the function** [replaced by choleksy lower triangular]
    real(dm), intent(inout):: Cov(:,:)
    real(dm), intent(in):: d(:)
    real(dm), allocatable :: tmp(:)
    real(dm) :: LogLike
    integer info,i,n

    call Matrix_Start('GaussianLogLike')
    n = size(COV,DIM=1)
    if (Size(COV,DIM=2)/=n) call MpiStop('Matrix_GaussianLogLike: non-square matrix')
    if (Size(d)/=n) call MpiStop('Matrix_GaussianLogLike: covariance and d different size')

    call Matrix_Cholesky(Cov)
    LogLike = 0
    !Log Det term:
    do i=1, n
        LogLike = LogLike  + log(Cov(i,i))
    end do

    !Solve for Cov^{-1}d [could use faster symmetric method]
    allocate(tmp(n))
    tmp = d
#ifdef MATRIX_SINGLE  
    call SPOTRS('L', N, 1, Cov, n, tmp, n, INFO )
#else 
    call DPOTRS('L', N, 1, Cov, n, tmp, n, INFO )
#endif
    if (INFO/=0) call MpiStop('Matrix_GaussianLogLike: error in solving for cov^{-1}d')

    !Add together
    LogLike = LogLike + dot_product(tmp,d)/2._dm
    deallocate(tmp)

    call Matrix_End('GaussianLogLike')

    end function Matrix_GaussianLogLike

    function Matrix_GaussianLogLikeDouble(Cov, d) result(LogLike)
    !Returns -Log Likelihood for Gaussian: (d^T Cov^{-1} d + log|Cov|)/2
    !** Cov is destroyed by the function** [replaced by choleksy lower triangular]
    double precision, intent(inout):: Cov(:,:)
    double precision, intent(in):: d(:)
    double precision, allocatable :: tmp(:)
    double precision :: LogLike
    integer info,i,n

    call Matrix_Start('GaussianLogLikeDouble')
    n = size(COV,DIM=1)
    if (Size(COV,DIM=2)/=n) call MpiStop('Matrix_GaussianLogLikeDouble: non-square matrix')
    if (Size(d)/=n) call MpiStop('Matrix_GaussianLogLikeDouble: covariance and d different size')

    call dpotrf ('L', n, Cov, n, info)
    if (info/=0) call MpiStop('Matrix_GaussianLogLikeDouble: not positive definite '//trim(IntToStr(info))) 

    LogLike = 0
    !Log Det term:
    do i=1, n
        LogLike = LogLike  + log(Cov(i,i))
    end do

    !Solve for Cov^{-1}d [could use faster symmetric method]
    allocate(tmp(n))
    tmp = d
    call DPOTRS('L', N, 1, Cov, n, tmp, n, INFO )
    if (INFO/=0) call MpiStop('Matrix_GaussianLogLikeDouble: error in solving for cov^{-1}d')

    !Add together
    LogLike = LogLike + dot_product(tmp,d)/2._dm
    deallocate(tmp)

    call Matrix_End('GaussianLogLikeDouble')

    end function Matrix_GaussianLogLikeDouble

    subroutine Matrix_InverseAsymm(M)
    !This should not be used in real situations, but useful for quick testing
    real(dm), intent(inout):: M(:,:)
    real(dm) w(Size(M,DIM=1))
    real(dm), dimension(:,:), allocatable :: tmp, VT
    integer i, n

    n=Size(M,DIM=1)
    if (n<=1) return
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_InverseAsymm: non-square matrix')

    allocate(tmp(n,n),VT(n,n))

    call Matrix_SVD(M,n,n,w,VT)      

    do i=1, n
        tmp(i,:) = M(:,i)/w(i)
    end do

    call Matrix_Mult_TN(VT,tmp,M,1._dm,0._dm)
    !  M = matmul(transpose(VT),tmp)   //Changed for HPCF prob Sept 07  

    deallocate(tmp,VT) 

    end subroutine Matrix_InverseAsymm

    subroutine Matrix_SVD(Mat,m, n, D, VT)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^T
    !returns U in Mat, vector D of diagonal elements of, orthogonal matrix VT= V^T  
    integer, intent(in) :: m,n
    real(dm), intent(inout) :: Mat(m,n)
    real(dm), intent(out) :: D(n), VT(n,n)

    integer WorkSize, ierr
    real(dm), allocatable, dimension (:) :: rv1 


    WorkSize=3*n**2

    allocate(rv1(WorkSize))
    call Matrix_Start('SVD')
#ifdef MATRIX_SINGLE
    call SGESVD('O','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,ierr) 
#else
    call DGESVD('O','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,ierr) 
#endif
    if (ierr/=0) call MpiStop('error in Matrix_SVD')
    call Matrix_End('SVD')

    deallocate(rv1)

    end subroutine Matrix_SVD

    subroutine Matrix_SVD_VT(Mat,m, n, D, U)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^dag
    !returns V^dag in Mat, vector D of diagonal elements of, unitary matrix U  
    integer, intent(in) :: m,n
    real(dm), intent(inout) :: Mat(m,n)
    real(dm), intent(out),optional :: U(m,m)
    real(dm), intent(out) :: D(*)

    integer WorkSize, ierr
    integer,allocatable, dimension (:) :: IWork
    real(dm), allocatable, dimension (:) :: rv1
    real(dm) OptWk 

    if (n<=m) call MpiStop('Matrix_SVD_VT assumed n>m. ')

    call Matrix_Start('SVD_VT')

    if (present(U) .and. Matrix_method == Mat_DC) then
        !Use divide and conquer
        allocate(IWork(8*MIN(M,N))) 
        WorkSize= -1 !3*min(M,N)*min(M,N) +max(max(M,N),5*min(M,N)*min(M,N)+4*min(M,N))
#ifdef MATRIX_SINGLE
        call SGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,OptWk,WorkSize,IWork,ierr) 
#else     
        call DGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,OptWk,WorkSize,IWork,ierr) 
#endif
        WorkSize = nint(OptWk)
        allocate(rv1(WorkSize))   
#ifdef MATRIX_SINGLE
        call SGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,IWork,ierr) 
#else     
        call DGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,IWork,ierr) 
#endif
        deallocate(IWOrk)
    else
        call MpiStop('Matrix_SVD_VT Not no-U non-DC case')
    end if

    if (ierr/=0) call MpiStop('error in Matrix_SVD_VT')
    deallocate(rv1)

    call Matrix_End('SVD_VT')

    end subroutine Matrix_SVD_VT


    subroutine Matrix_CSVD_VT(Mat,m, n, D, U)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^dag
    !returns V^dag in Mat, vector D of diagonal elements of, unitary matrix U  
    integer, intent(in) :: m,n
    complex(dm), intent(inout) :: Mat(m,n)
    complex(dm), intent(out),optional :: U(m,m)
    real(dm), intent(out) :: D(*)

    integer WorkSize, ierr
    integer,allocatable, dimension (:) :: IWork
    complex(dm), allocatable, dimension (:) :: rv1 
    real(dm), allocatable, dimension (:) :: rwork

    if (n<=m) call MpiStop('Matrix_CSVD_VT assumed n>m. If equal use SVD_U.')

    call Matrix_Start('CSVD_VT')


    if (present(U) .and. Matrix_method == Mat_DC) then
        !Use divide and conquer
        WorkSize= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N) + 5*N !Add on 5N.. 
        allocate(rv1(WorkSize))   
        allocate(rwork(5*min(M,N)*min(M,N) + 5*min(M,N) ))
        allocate(IWork(8*MIN(M,N))) 
#ifdef MATRIX_SINGLE
        call CGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,rwork,IWork,ierr) 
#else     
        call ZGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,rwork,IWork,ierr) 
#endif
        deallocate(IWOrk)
    else

    allocate(rwork((max(3*min(m,n),5*min(m,n)-4))))
    WorkSize= 3*max(m,n)**2
    allocate(rv1(WorkSize), STAT = ierr)
    if (ierr /=0) then
        WorkSize= MAX(3*MIN(M,N)+MAX(M,N),5*MIN(M,N))
        allocate(rv1(WorkSize))
    end if
#ifdef MATRIX_SINGLE
    if (present(U)) then
        call CGESVD('S','O',m,n, Mat, m , D,U,m,Mat,n,rv1,WorkSize,rwork,ierr) 
    else
        call CGESVD('N','O',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr) 
    end if
#else
    if (present(U)) then
        call ZGESVD('S','O',m,n, Mat, m , D,U,m,Mat,n,rv1,WorkSize,rwork,ierr) 
    else
        call ZGESVD('N','O',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr) 
    end if
#endif       
    end if

    if (ierr/=0) call MpiStop('error in Matrix_SVD_VT')
    deallocate(rv1)

    call Matrix_End('SVD_VT')

    end subroutine Matrix_CSVD_VT

    subroutine Matrix_CSVD_U(Mat,m, n, D, VT)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D VT
    !returns U in Mat, vector D of diagonal elements of, unitary matrix V  
    integer, intent(in) :: m,n
    complex(dm), intent(inout) :: Mat(m,n)
    complex(dm), intent(out),optional :: VT(n,n)
    real(dm), intent(out) :: D(*)
    integer WorkSize, ierr
    integer,allocatable, dimension (:) :: IWork
    complex(dm), allocatable, dimension (:) :: rv1 
    real(dm), allocatable, dimension (:) :: rwork

    call Matrix_Start('CSVD_U')

    if (m<n) call MpiStop('Matrix_CSVD_U assumed m>=n')

    if (present(VT) .and. Matrix_method == Mat_DC) then
        WorkSize= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N) + 5*N !Add on 5N.. 
        allocate(rv1(WorkSize))   
        allocate(rwork(5*min(M,N)*min(M,N) + 5*min(M,N) ))
        allocate(IWork(8*MIN(M,N))) 
#ifdef MATRIX_SINGLE
        call CGESDD('O',m,n, Mat, m ,D,Mat,m,VT,n,rv1,WorkSize,rwork,IWork,ierr) 
#else
        call ZGESDD('O',m,n, Mat, m ,D,Mat,m,VT,n,rv1,WorkSize,rwork,IWork,ierr) 
#endif
        deallocate(IWOrk)
    else
        allocate(rwork((max(3*min(m,n),5*min(m,n)-4))))

        WorkSize= 3*max(m,n)**2
        allocate(rv1(WorkSize), STAT = ierr)
        if (ierr /=0) then
            WorkSize= MAX(3*MIN(M,N)+MAX(M,N),5*MIN(M,N))
            allocate(rv1(WorkSize))
        end if
#ifdef MATRIX_SINGLE
        if (present(VT)) then
            call CGESVD('O','S',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr) 
        else
            call CGESVD('O','N',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr) 
        end if
#else
        if (present(VT)) then
            call ZGESVD('O','S',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr) 
        else
            call ZGESVD('O','N',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr) 
        end if
#endif  
    end if
    if (ierr/=0) call MpiStop('error in Matrix_SVD_U')
    call Matrix_End('CSVD_U')

    deallocate(rv1,rwork)

    end subroutine Matrix_CSVD_U


    subroutine Matrix_CSVD_AllVT(Mat,m, n, D, VT)
    !n>m
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^dag
    !returns all nxn V^dag in VT, vector D of diagonal elements of
    integer, intent(in) :: m,n
    complex(dm), intent(inout) :: Mat(m,n)
    complex(dm), intent(out):: VT(n,n)
    real(dm), intent(out) :: D(m)

    integer WorkSize, ierr
    complex(dm), allocatable, dimension (:) :: rv1 
    complex(dm), allocatable, dimension (:,:) :: U
    integer, allocatable, dimension(:) :: IWork
    real(dm), allocatable, dimension (:) :: rwork


    call Matrix_Start('CSVD_AllVT')

    if (Matrix_method == Mat_DC) then
        !Divide and conquer doesn't seem to provide outputs we want here
        WorkSize= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N) + 5*N !Add on 5N.. 
        allocate(rv1(WorkSize))   
        allocate(rwork(5*min(M,N)*min(M,N) + 5*min(M,N) ))
        allocate(IWork(8*MIN(M,N))) 
        allocate(U(m,m))
#ifdef MATRIX_SINGLE
        call CGESDD('A',m,n, Mat, m ,D,U,m,VT,n,rv1,WorkSize,rwork,IWork,ierr) 
#else     
        call ZGESDD('A',m,n, Mat, m ,D,U,m,VT,n,rv1,WorkSize,rwork,IWork,ierr) 
#endif
        deallocate(U)
        deallocate(IWork)

    else
        WorkSize=  2*m*n + 2*max(n,m)
        allocate(rwork(5*max(m,n)))
        allocate(rv1(WorkSize), STAT = ierr)
        if (ierr /=0) then
            WorkSize= MAX(3*MIN(M,N)+MAX(M,N),5*MIN(M,N))
            allocate(rv1(WorkSize))
        end if
#ifdef MATRIX_SINGLE
        call CGESVD('N','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr) 
#else    
        call ZGESVD('N','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr) 
#endif    
    end if

    if (ierr/=0) call MpiStop('error in Matrix_SVD_AllVT')
    deallocate(rv1,rwork)

    call Matrix_End('CSVD_AllVT')


    end subroutine Matrix_CSVD_allVT


    subroutine Matrix_DiagPreMul(D,M)
    ! M -> matmul(diag(D),M)
    real(dm), intent(inout) :: M(:,:)
    real(dm), intent(in) :: D(:)
    integer i

    if (Size(D) /= SiZE(M,DIM=1)) call MpiStop('Matrix_DiagPreMul: Wrong size')
    do i = 1, size(D)
        M(i,:) = M(i,:)*D(i)
    end do

    end subroutine Matrix_DiagPreMul


    subroutine Matrix_SolveSymm(M,a,soln)
    real(dm), intent(out) :: soln(:)
    real(dm), intent(in):: M(:,:),a(:)
    integer IPIV(size(a)),info
    real(dm), dimension(:,:), allocatable :: tmp
    real(dm), dimension(:), allocatable :: work
    integer n, WorkSize

    n=Size(M,DIM=1)
    if (n<=1) return
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_SolveSq: non-square matrix')
    call Matrix_Start('SolveSymm')


    WorkSize = n**2
    allocate(work(WorkSize))
    allocate(tmp(n,n))
    tmp = M
#ifdef MATRIX_SINGLE
    call SSYTRF('U',n,tmp,n,IPIV, work,WorkSize,info)
#else     
    call DSYTRF('U',n,tmp,n,IPIV, work,WorkSize,info)
#endif
    deallocate(work)
    if (info/=0) call MpiStop('error in SolveSymm')
    soln(1:n) = a(1:n)
#ifdef MATRIX_SINGLE
    call SSYTRS('U',n,1,tmp,n,IPIV,soln,n,info)
#else
    call DSYTRS('U',n,1,tmp,n,IPIV,soln,n,info)
#endif
    if (info/=0) call MpiStop('error (2) in SolveSymm')
    deallocate(tmp)

    call Matrix_End('SolveSymm')


    end subroutine Matrix_SolveSymm


    subroutine Matrix_SolveASymm(M,a,soln)
    real(dm), intent(out) :: soln(:)
    real(dm), intent(in):: M(:,:),a(:)
    integer IPIV(size(a)),info
    real(dm), dimension(:,:), allocatable :: tmp
    integer n

    n=Size(M,DIM=1)
    if (n<=1) return
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_SolveSq: non-square matrix')

    call Matrix_Start('SolveASymm')

    allocate(tmp(n,n))
    tmp = M
#ifdef MATRIX_SINGLE
    call SGETRF(n,n,tmp,n,IPIV, info)
#else
    call DGETRF(n,n,tmp,n,IPIV, info)
#endif
    if (info/=0) call MpiStop('error in SolveASymm')
    soln(1:n) = a(1:n)
#ifdef MATRIX_SINGLE
    call SGETRS('N',n,1,tmp,n,IPIV,Soln,n,info)
#else
    call DGETRS('N',n,1,tmp,n,IPIV,Soln,n,info)
#endif
    if (info/=0) call MpiStop('error (2) in SolveASymm')
    deallocate(tmp) 

    call Matrix_End('SolveASymm')

    end subroutine Matrix_SolveASymm

    function Matrix_vecdot(vec1,vec2)
    real(dm) vec1(:),vec2(:)
    real(dm) Matrix_vecdot
    integer n
#ifdef MATRIX_SINGLE
    real(dm) sdot
    external sdot
#else  
    real(dm) ddot
    external ddot
#endif
    n=size(vec1)
    if (n/=size(vec2)) call MpiStop('Matrix_vecdot: size mismatch')
#ifdef MATRIX_SINGLE
    Matrix_vecdot = sdot(n, vec1, 1, vec2, 1)
#else
    Matrix_vecdot = ddot(n, vec1, 1, vec2, 1)
#endif
    end function Matrix_vecdot

    function Matrix_QuadForm(Mat,vec)
    !Get vec^T*Mat*vec where Mat is symmetric
    real(dm) Matrix_QuadForm
    real(dm) vec(:)
    real(dm) Mat(:,:)
    real(dm), dimension(:), allocatable :: out
    integer n

    n=size(vec)
    allocate(out(n))
    call Matrix_MulVecSymm(Mat,vec,out)
    Matrix_QuadForm = Matrix_vecdot(vec, out)
    deallocate(out)

    end function Matrix_QuadForm

    subroutine Matrix_MulVec(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real(dm), intent(in) :: Mat(:,:)
    real(dm) vec(:)
    real(dm) Out(:) 
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer m,n

    call Matrix_Start('MulVec')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (Size(Mat,DIM=2) /= n) call MpiStop('Matrix_MulVec: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= ROne) Out = Out*mult
        end if     
    else
#ifdef MATRIX_SINGLE
        call SGEMV('N',m,n,mult,Mat,m,vec, 1,beta, Out,1)
#else     
        call DGEMV('N',m,n,mult,Mat,m,vec, 1,beta, Out,1)
#endif
    end if
    call Matrix_End('MulVec')

    end subroutine Matrix_MulVec

    subroutine Matrix_MulVecSingle(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real, intent(in) :: Mat(:,:)
    real vec(:)
    real Out(:) 
    real, intent(in), optional :: a,b
    real  mult, beta 
    integer m,n

    call Matrix_Start('MulVecSingle')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (Size(Mat,DIM=2) /= n) call MpiStop('Matrix_MulVecSingle: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = SOne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = SZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= SZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= SOne) Out = Out*mult
        end if     
    else
        call SGEMV('N',m,n,mult,Mat,m,vec, 1,beta, Out,1)
    end if
    call Matrix_End('MulVecSingle')

    end subroutine Matrix_MulVecSingle




    subroutine Matrix_MulVecSymm(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real(dm), intent(in) :: Mat(:,:)
    real(dm) vec(:)
    real(dm) Out(:) 
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta 
    integer m,n

    call Matrix_Start('MulVecSymm')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (m /= n) call MpiStop('Matrix_MulVecSymm: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= ROne) Out = Out*mult
        end if     
    else
#ifdef MATRIX_SINGLE
        call SSYMV('U',m,mult,Mat,m,vec, 1,beta, Out,1)
#else     
        call DSYMV('U',m,mult,Mat,m,vec, 1,beta, Out,1)
#endif
    end if
    call Matrix_End('MulVecSymm')

    end subroutine Matrix_MulVecSymm

    subroutine Matrix_MulVecSymmSingle(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real, intent(in) :: Mat(:,:)
    real vec(:)
    real Out(:) 
    real, intent(in), optional :: a,b
    real  mult, beta 
    integer m,n

    call Matrix_Start('MulVecSymm')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (m /= n) call MpiStop('Matrix_MulVecSymm: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = SOne
    end if
    if (present(b)) then
        beta = b    
    else
        beta = SZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= ROne) Out = Out*mult
        end if     
    else
        call SSYMV('U',m,mult,Mat,m,vec, 1,beta, Out,1)
    end if
    call Matrix_End('MulVecSymmSingle')

    end subroutine Matrix_MulVecSymmSingle

    function Matrix_vecdotSingle(vec1,vec2)
    real vec1(:),vec2(:)
    real Matrix_vecdotSingle
    integer n
    real sdot
    external sdot

    n=size(vec1)
    if (n/=size(vec2)) call MpiStop('Matrix_vecdotSingle: size mismatch')
    Matrix_vecdotSingle = sdot(n, vec1, 1, vec2, 1)

    end function Matrix_vecdotSingle


    subroutine Matrix_InverseArrayMPI(Arr,nmat)
    !Invert array of matrices by sending each to separate CPU
    integer, intent(in) :: nmat
#ifdef __GFORTRAN__    
    Type(TMatrixType), target :: Arr(:)
#else
    Type(TMatrixType), target :: Arr(*)
#endif
    Type(TMatrixType), pointer :: AM
    integer n
    integer i,MpiID, MpiSize
    integer sz
#ifdef MPI        
    integer j, ierr, sid
    Type(TMatrixType), target :: tmp
#endif     

    call MpiStat(MpiID, MpiSize)
    if (MpiId==0) then
        n=nmat
        sz = Size(Arr(1)%M,DIM=1)
    end if 
    !    if (MpiID==0) then
    !     do i=1,nmat
    !      print *,'inverting',i
    !      call Matrix_inverse(Arr(i)%M)
    !     end do
    !    end if
    !    return
#ifdef MPI        
    if (MpiID==0) print *, 'MatrixInverseArray: starting'
    call MPI_BCAST(n,1,MPI_INTEGER, 0, MPI_COMM_WORLD, ierr) 
    call MPI_BCAST(sz,1,MPI_INTEGER, 0, MPI_COMM_WORLD, ierr) 
    if (MpiID/=0) then
        allocate(tmp%M(sz,sz))           
        AM => tmp
    end if
#endif

    do i= 1,n
        if (MpiID==0) AM => Arr(i)
#ifdef MPI       
        if (mod(i,MpiSize)/=MpiID) then
            !Do nothing
            if (MpiId==0) then
                j=mod(i,MpiSize)
                call MPI_SEND(AM%M,size(AM%M),MPI_DOUBLE_PRECISION, j, 1, MPI_COMM_WORLD, ierr) 
            end if
        else
            if (MpiId/=0) then
                !Get from main thread
                call MPI_RECV(AM%M,size(AM%M),MPI_DOUBLE_PRECISION, 0, 1, MPI_COMM_WORLD,MPI_STATUS_IGNORE, ierr) 

            end if
#endif         
            call Matrix_Inverse(AM%M)

#ifdef MPI
            if (MpiID==0) then
                do j = max(1,i-MpiSize+1),i-1 
                    sid = mod(j,MpiSize)
                    call MPI_RECV(Arr(j)%M,size(Arr(j)%M),MPI_DOUBLE_PRECISION, sid, 1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr) 
                end do
            else
                call MPI_SEND(AM%M,size(AM%M),MPI_DOUBLE_PRECISION, 0, 1, MPI_COMM_WORLD, ierr) 
            end if

        end if 
#endif
    end do


#ifdef MPI
    if (MpiID==0) then
        do j=n - mod(n,MpiSize) +1 ,n
            sid= mod(j,MpiSize)
            call MPI_RECV(ARr(j)%M,Size(ARr(j)%M),MPI_DOUBLE_PRECISION, sid, 1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr) 
        end do
    else
        deallocate(tmp%M)           
    end if
#endif   
    if (MpiID==0) print *, 'MatrixInverseArray: Done'


    end subroutine Matrix_InverseArrayMPI



    end module MatrixUtils

c=======================================================================
c FFTLog
c    computes the discrete Fast Fourier Transform
c    or Fast Hankel Transform (of arbitrary real index)
c    of a periodic logarithmic sequence.
c
c---Start of revision history-------------------------------------------
c
c Original version 27 March 1999.
c
c 5 July 1999:
c Bug fix in singular transform.
c Store amp, arg of last element of wsave separately, for even n,
c enlarging wsave by 1, for even n and q != 0.

c 17 July 1999:
c Reorganized wsave more logically.
c drffti now gets first, not last, 2*n+15 elements of wsave.
c fhti now treats last element of wsave with others, not by itself;
c wsave is enlarged from original, for even n,
c by 1 for q = 0, and by 2 for q != 0.
c
c 18 July 1999:
c A backward transform (dir = -1) is the same as
c a forward transform with q -> -q [and rk -> 1/rk]
c for any kr if n is odd,
c but only for low-ringing kr if n is even.
c Original falsely stated that transforms were same irrespective of kr.
c
c 19 Dec 1999:
c Slightly spiffed up interactive option to change kr to low-ringing kr.
c
c 13 Mar 2000:
c Made g77-safe:
c 1. Checked for any automatic variables that needed explicitly
c    `save'ing - actually there weren't any.
c    g77 is unusual in that it does NOT save variables not in
c    common or data statements.
c 2. All double precision constants explicitly suffixed d0.
c    g77 is unusual in that it does NOT automatically promote
c    real constants such as 1.1 to double precision 1.1d0.
c 
c---End of revision history---------------------------------------------
c
c For more information about FFTLog, see
c
c http://casa.colorado.edu/~ajsh/FFTLog/
c
c Andrew J S Hamilton March 1999
c email: Andrew.Hamilton@Colorado.EDU
c
c Refs:	Talman J. D., 1978, J. Comp. Phys., 29, 35
c	Hamilton A. J. S., 2000, MNRAS, 312, 257
c	( http://xxx.lanl.gov/abs/astro-ph/9905191 )
c
c FFTLog uses the NCAR suite of FFT routines,
c and a modified version of the complex Gamma function
c from the gamerf package at
c http://momonga.t.u-tokyo.ac.jp/~ooura/gamerf.html .
c The original gamerf copyright statement states:
c   Copyright(C) 1996 Takuya OOURA (email: ooura@mmm.t.u-tokyo.ac.jp).
c   You may use, copy, modify this code for any purpose and
c   without fee. You may distribute this ORIGINAL package.
c
c Permission to distribute the modified gamma function code
c with the FFTLog package has been granted
c (email from Takuya Ooura to Andrew Hamilton dated 16 March 1999).
c
c-----------------------------------------------------------------------
c Note: email programs may zap the 8-bit characters in the program
c       comments by converting them into 7-bit characters.
c       If this happens, get an unzapped copy from
c       http://casa.colorado.edu/~ajsh/FFTLog/ .
c       The fortran code itself contains only 7-bit characters;
c       the 8-bit characters occur only in comments.
c
c       If you are on a UNIX machine and 8-bit characters are not
c       showing up properly (they may appear as \nnn where n are
c       integers), then try putting
c          setenv LC_CTYPE iso_8859_1
c       in your .login file.
c
c-----------------------------------------------------------------------
c FFTLog computes a discrete version of
c the Hankel Transform (= Fourier-Bessel Transform)
c with a power law bias (k r)^q
c
c          infinity
c           /           q
c    ã(k) = | a(r) (k r)  J  (k r) k dr
c           /              mu
c          0
c
c          infinity
c           /           -q
c    a(r) = | ã(k) (k r)   J  (k r) r dk
c           /               mu
c          0
c
c where J_mu is the Bessel function of order mu.
c The index mu may be any real number, positive or negative.
c
c The input array a_j is a periodic sequence of length n,
c uniformly logarithmically spaced with spacing dlnr
c    a_j = a(r_j)   at   r_j = r_c exp[(j-j_c) dlnr]
c centred about the point r_c.  The central index j_c = (n+1)/2
c is 1/2 integral if n is even.
c Similarly, the output array ã_j is a periodic sequence of length n,
c also uniformly logarithmically spaced with spacing dlnr
c    ã_j = ã(k_j)   at   k_j = k_c exp[(j-j_c) dlnr]
c centred about the point k_c.
c
c The centre points r_c and k_c of the periodic intervals may be
c chosen arbitrarily; but it would be normal to choose the product
c kr = k_c r_c = k_j r_(n+1-j) = k_(n+1-j) r_j
c to be about 1 (or 2, or pi, to taste).
c
c The FFTLog algorithm is (see Hamilton 2000):
c 1. FFT the input array a_j to obtain the Fourier coefficients c_m ;
c 2. Multiply c_m by 
c       u_m = (kr)^[- i 2 m pi/(n dlnr)] U_mu[q + i 2 m pi/(n dlnr)]
c    where
c       U_mu(x) = 2^x Gamma[(mu+1+x)/2] / Gamma[(mu+1-x)/2]
c    to obtain c_m u_m ;
c 3. FFT c_m u_m back to obtain the discrete Hankel transform ã_j .
c
c-----------------------------------------------------------------------
c The Fourier sine and cosine transforms
c
c                     infinity
c                      /
c    Ã(k) = sqrt(2/pi) | A(r) sin(k r) dr
c                      /
c                     0
c
c                     infinity
c                      /
c    Ã(k) = sqrt(2/pi) | A(r) cos(k r) dr
c                      /
c                     0
c
c may be regarded as special cases of the Hankel transform
c with mu = 1/2 and -1/2 since
c
c    sqrt(2/pi) sin(x) = sqrt(x) J   (x)
c                                 1/2
c
c    sqrt(2/pi) cos(x) = sqrt(x) J    (x)
c                                 -1/2
c
c The Fourier transforms may be done by making the substitutions
c                 q-(1/2)                      -q-(1/2)
c    A(r) = a(r) r          and   Ã(k) = ã(k) k    
c
c and Hankel transforming a(r) with a power law bias (k r)^q
c
c          infinity
c           /           q
c    ã(k) = | a(r) (k r)  J    (k r) k dr
c           /              ±1/2
c          0
c
c Different choices of power law bias q lead to different discrete
c Fourier transforms of A(r), because the assumption of periodicity of
c a(r) = A(r) r^[-q+(1/2)] is different for different q.
c
c If A(r) is a power law, A(r) proportional to r^[q-(1/2)],
c then applying a bias q yields a discrete Fourier transform Ã(k)
c that is exactly equal to the continuous Fourier transform,
c because then a(r) is a constant, which is a periodic function.
c
c-----------------------------------------------------------------------
c The Hankel transform
c
c          infinity
c           /
c    Ã(k) = | A(r) J  (k r) k dr
c           /       mu
c          0
c
c may be done by making the substitutions
c                 q                      -q
c    A(r) = a(r) r    and   Ã(k) = ã(k) k    
c
c and Hankel transforming a(r) with a power law bias (k r)^q
c
c          infinity
c           /           q
c    ã(k) = | a(r) (k r)  J  (k r) k dr
c           /              mu
c          0
c
c Different choices of power law bias q lead to different discrete
c Hankel transforms of A(r), because the assumption of periodicity of
c a(r) = A(r) r^-q is different for different q.
c
c If A(r) is a power law, A(r) proportional to r^q,
c then applying a bias q yields a discrete Hankel transform Ã(k)
c that is exactly equal to the continuous Hankel transform,
c because then a(r) is a constant, which is a periodic function.
c
c-----------------------------------------------------------------------
c ------------------------
c There are five routines:
c ------------------------
c Comments in the subroutines contain further details.
c
c (1) subroutine fhti(n,mu,q,dlnr,kr,kropt,wsave,ok)
c     is an initialization routine.
c
c (2) subroutine fftl(n,a,rk,dir,wsave)
c     computes the discrete Fourier sine or cosine transform
c     of a logarithmically spaced periodic sequence.
c     This is a driver routine that calls fhtq.
c
c (3) subroutine fht(n,a,dir,wsave)
c     computes the discrete Hankel transform
c     of a logarithmically spaced periodic sequence.
c     This is a driver routine that calls fhtq.
c
c (4) subroutine fhtq(n,a,dir,wsave)
c     computes the biased discrete Hankel transform
c     of a logarithmically spaced periodic sequence.
c     This is the basic FFTLog routine.
c
c (5) real*8 function krgood(mu,q,dlnr,kr)
c     takes an input kr and returns the nearest low-ringing kr.
c     This is an optional routine called by fhti.
c
c=======================================================================
c THE FFTLog CODE
c=======================================================================
      subroutine fhti(n,mu,q,dlnr,kr,kropt,wsave,ok)
      integer n,kropt
      logical ok
      real*8 mu,q,dlnr,kr,wsave(*)
c
c fhti initializes the working array wsave
c used by fftl, fht, and fhtq, and by NCAR routines drfftf and drfftb.
c fhti need be called once, whereafter fftl, fht, or fhtq may be
c called many times, as long as n, mu, q, dlnr, and kr remain unchanged.
c fhti should be called each time n, mu, q, dlnr, or kr is changed.
c The work array wsave should not be changed between calls to fftl,
c fht, or fhtq.
c
c If you are using the g77 fortran compiler, which by default does not
c save locally declared variables (unlike most other fortran compilers),
c then you should explicitly
c       save wsave
c in the calling program.
c
c  Input: n = number of points in the array to be transformed;
c             n may be any positive integer, but the NCAR FFT routines
c             run fastest if n is a product of small primes 2, 3, 5.
c	  mu = index of J_mu in Hankel transform;
c	       mu may be any real number, positive or negative.
c	  q = exponent of power law bias;
c	      q may be any real number, positive or negative.
c             If in doubt, use q = 0, for which case the Hankel
c             transform is orthogonal, i.e. self-inverse,
c             provided also that, for n even, kr is low-ringing.
c             Non-zero q may yield better approximations to the
c             continuous Hankel transform for some functions.
c         dlnr = separation between natural log of points;
c		 dlnr may be positive or negative.
c	  kr = k_c r_c where c is central point of array
c              = k_j r_(n+1-j) = k_(n+1-j) r_j .
c	       Normally one would choose kr to be about 1
c	       (or 2, or pi, to taste).
c         kropt = 0 to use input kr as is;
c                 1 to change kr to nearest low-ringing kr, quietly;
c                 2 to change kr to nearest low-ringing kr, verbosely;
c                 3 for option to change kr interactively.
c Output: wsave = working array used by fftl, fht, and fhtq,
c                 and by NCAR FFT routines drfftf and drfftb.
c                 wsave should be dimensioned at least:
c                 for q = 0 (unbiased transform):
c                    2*n+2*(n/2)+18
c                       [= 3*n+18 if n even, 3*n+17 if n odd]
c                 for q != 0 (biased transform):
c                    2*n+3*(n/2)+19
c                       [= (7*n)/2+19 if n even, (7*n)/2+18 if n odd]
c                 The first 2*n+15 elements of wsave are used by
c                 the NCAR FFT routines.
c         ok = .true. if all went ok;
c              .false. if not; currently only occurs if interactive
c                      response causes exit.
c
c        parameters
      real*8 PI
      parameter (PI=3.141592653589793238462643383279502884197d0)
      real*8 ZERO,ONE,TWO
      parameter (ZERO=0.d0,ONE=1.d0,TWO=2.d0)
      real*8 ROUND
      parameter (ROUND=1.d-15)
c        externals
      integer lnblnk,stblnk
      real*8 krgood
      complex*16 cdgamma
c        local (automatic) variables
      character*1 go
      character*64 temp
      integer l,m
      real*8 amp,arg,d,ln2,ln2kr,xm,xp,y
      complex*16 zm,zp
c
c--------adjust kr
c        keep kr as is
      if (kropt.eq.0) then
        continue
c        change kr to low-ringing kr quietly
      elseif (kropt.eq.1) then
        kr=krgood(mu,q,dlnr,kr)
c        change kr to low-ringing kr verbosely
      elseif (kropt.eq.2) then
        d=krgood(mu,q,dlnr,kr)
        if (abs(kr/d-ONE).gt.ROUND) then
          kr=d
          write (*,'(" kr changed to",g24.16)') kr
        endif
c        option to change kr to low-ringing kr interactively
      else
        d=krgood(mu,q,dlnr,kr)
        if (abs(kr/d-ONE).gt.ROUND) then
c        fortran demonstrates its inferiority to C
          write (*,'(" change kr = ",$)')
          write (temp,*) kr
          write (*,'(a,$)') temp(stblnk(temp):lnblnk(temp))
          write (*,'(" to low-ringing kr = ",$)')
          write (temp,*) d
          write (*,'(a,$)') temp(stblnk(temp):lnblnk(temp))
          write (*,'("? [CR,y=yes, n=no, x=exit]: ",$)')
          read (*,'(a1)') go
          if (go.eq.' '.or.go.eq.'y'.or.go.eq.'Y') then
            kr=d
            write (*,'(" kr changed to",g24.16)') kr
          elseif (go.eq.'n'.or.go.eq.'N') then
            print *,'kr left unchanged at',kr
          else
            print *,'exit'
            goto 300
          endif
        endif
      endif
c--------return if n is <= 0
      if (n.le.0) goto 200
c--------initialize normal FFT
      call drffti(n,wsave)
c        drfft uses first 2*n+15 elements of wsave
      l=2*n+15
c--------put q, dlnr, kr in next 3 elements of wsave
      wsave(l+1)=q
      wsave(l+2)=dlnr
      wsave(l+3)=kr
c        so far used 2*n+18 elements of wsave
      l=l+3
c--------rest of wsave used by fhtq - unbiased case (q = 0)
      if (q.eq.ZERO) then
        ln2kr=log(TWO/kr)
        xp=(mu+ONE)/TWO
        d=PI/(n*dlnr)
        do m=1,n/2
c        y = m pi/(n dlnr)
          y=m*d
          zp=dcmplx(xp,y)
          zp=cdgamma(zp,1)
c        Argument of kr^(-2 i y) U_mu(2 i y)
          arg=TWO*(ln2kr*y+dimag(zp))
          wsave(l+2*m-1)=cos(arg)
          wsave(l+2*m)=sin(arg)
        enddo
c Altogether 2*n+18 + 2*(n/2) = 2*((3*n)/2)+18 elements used for q = 0,
c which is 3*n+18 for even n, 3*n+17 for odd n.
c--------rest of wsave used by fhtq - biased case (q != 0)
      else
        ln2=log(TWO)
        ln2kr=log(TWO/kr)
        xp=(mu+ONE+q)/TWO
        xm=(mu+ONE-q)/TWO
c........first element of rest of wsave
        y=ZERO
c        case where xp or xm is a negative integer
        if ((anint(xp).eq.xp.and.anint(xp).le.ZERO)
     *    .or.(anint(xm).eq.xm.and.anint(xm).le.ZERO)) then
c        case where xp and xm are both negative integers
c U_mu(q) = 2^q Gamma[xp]/Gamma[xm] is finite in this case
          if ((anint(xp).eq.xp.and.anint(xp).le.ZERO)
     *      .and.(anint(xm).eq.xm.and.anint(xm).le.ZERO)) then
c        Amplitude and Argument of U_mu(q)
            amp=exp(ln2*q)
            if (xp.gt.xm) then
              do m=1,nint(xp-xm)
                amp=amp*(xm+m-ONE)
              enddo
            elseif (xp.lt.xm) then
              do m=1,nint(xm-xp)
                amp=amp/(xp+m-ONE)
              enddo
            endif
            arg=anint(xp+xm)*PI
c        one of xp or xm is a negative integer
          else
c Transformation is singular if xp is -ve integer,
c and inverse transformation is singular if xm is -ve integer,
c but transformation may be well-defined if sum_j a_j = 0,
c as may well occur in physical cases.
c Policy is to drop the potentially infinite constant in the transform.
            if (anint(xp).eq.xp.and.anint(xp).le.ZERO) then
              print *,'fhti: (mu+1+q)/2 =',nint(xp),
     &          ' is -ve integer, yields singular transform:'
              print *,'   transform will omit additive constant that is 
     &generically infinite,'
              print *,'   but that may be finite or zero if'
              print *,'   the sum of the elements of the input array a_j
     & is zero.'
            else
              print *,'fhti: (mu+1-q)/2 =',nint(xm),
     &          ' is -ve integer, yields singular inverse transform:'
              print *,'   inverse transform will omit additive constant 
     &that is generically'
              print *,'   infinite, but that may be finite or zero if'
              print *,'   the sum of the elements of the input array a_j
     & is zero.'
            endif
            amp=ZERO
            arg=ZERO
          endif
c        neither xp nor xm is a negative integer
        else
          zp=dcmplx(xp,y)
          zm=dcmplx(xm,y)
          zp=cdgamma(zp,1)
          zm=cdgamma(zm,1)
c        Amplitude and Argument of U_mu(q)
          amp=exp(ln2*q+dble(zp)-dble(zm))
c        note +Im(zm) to get conjugate value below real axis
          arg=dimag(zp)+dimag(zm)
        endif
c        cos(arg) = ±1, sin(arg) = 0
        wsave(l+1)=amp*cos(arg)
c........remaining elements of wsave
        d=PI/(n*dlnr)
        do m=1,n/2
c        y = m pi/(n dlnr)
          y=m*d
          zp=dcmplx(xp,y)
          zm=dcmplx(xm,y)
          zp=cdgamma(zp,1)
          zm=cdgamma(zm,1)
c        Amplitude and Argument of kr^(-2 i y) U_mu(q + 2 i y)
          amp=exp(ln2*q+dble(zp)-dble(zm))
          arg=2*ln2kr*y+dimag(zp)+dimag(zm)
          wsave(l+3*m-1)=amp
          wsave(l+3*m)=cos(arg)
          wsave(l+3*m+1)=sin(arg)
        enddo
c Altogether 2*n+18 + 3*(n/2)+1 elements used for q != 0,
c which is (7*n)/2+19 for even n, (7*n)/2+18 for odd n.
c For even n, the very last element of wsave
c [i.e. wsave(l+3*m+1)=sin(arg) for m=n/2] is not used within FFTLog;
c if a low-ringing kr is used, this element should be zero.
c The last element is computed in case somebody wants it.
      endif
  200 ok=.true.
      return
c
c--------error returns
  300 ok=.false.
      return
      end
c
c=======================================================================
      subroutine fftl(n,a,rk,dir,wsave)
      integer n,dir
      real*8 a(n),rk,wsave(*)
c
c This is a driver routine that calls fhtq.
c
c fftl computes a discrete version of the Fourier
c sine (if mu = 1/2) or cosine (if mu = -1/2) transform
c
c                     infinity
c                      /
c    Ã(k) = sqrt(2/pi) | A(r) sin(k r) dr
c                      /
c                     0
c
c                     infinity
c                      /
c    Ã(k) = sqrt(2/pi) | A(r) cos(k r) dr
c                      /
c                     0
c
c by making the substitutions
c                 q-(1/2)                      -q-(1/2)
c    A(r) = a(r) r          and   Ã(k) = ã(k) k    
c
c and applying a biased Hankel transform to a(r).
c
c The steps are:
c 1. a(r) = A(r) r^[-dir*(q-.5)]
c 2. call fhtq to transform a(r) -> ã(k)
c 3. Ã(k) = ã(k) k^[-dir*(q+.5)]
c
c fhti must be called before the first call to fftl,
c with mu = 1/2 for a sine transform,
c or mu = -1/2 for a cosine transform.
c
c A call to fftl with dir=1 followed by
c a call to fftl with dir=-1 (and rk unchanged), or vice versa,
c leaves the array a unchanged.
c
c  Input: n = length of a array.
c         rk = r_c/k_c
c              = r_j/k_j (a constant, the same constant for any j);
c              rk is not (necessarily) the same quantity as kr.
c              rk is used only to multiply the output array by
c              sqrt(rk)^dir, so if you want to do the normalization
c              later, or you don't care about the normalization,
c              you can set rk = 1.
c	  dir = 1 for forward transform,
c		-1 for backward transform.
c               A backward transform (dir = -1) is the same as
c               a forward transform with q -> -q and rk -> 1/rk,
c               for any kr if n is odd,
c               for low-ringing kr if n is even.
c	  wsave = working array set up by fhti.
c Input/Output:
c         a on  input is the array A(r) to transform:
c             a(j) is A(r_j) at r_j = r_c exp[(j-jc) dlnr]
c                where jc = (n+1)/2 = central index of array.
c         a on output is the transformed array Ã(k):
c             a(j) is Ã(k_j) at k_j = k_c exp[(j-jc) dlnr].
c
c        parameters
      real*8 ONE,TWO,HALF
      parameter (ONE=1.d0,TWO=2.d0,HALF=ONE/TWO)
c        local (automatic) variables
      integer j,l
      real*8 dlnr,jc,kr,lnkr,lnrk,q
c
      l=2*n+15
      q=wsave(l+1)
      dlnr=wsave(l+2)
      kr=wsave(l+3)
c........a(r) = A(r) (r/rc)^[-dir*(q-.5)]
c        centre point of array
      jc=dble(n+1)/TWO
      do j=1,n
        a(j)=a(j)*exp(-dir*(q-HALF)*(j-jc)*dlnr)
      enddo
c........transform a(r) -> ã(k)
      call fhtq(n,a,dir,wsave)
c........Ã(k) = ã(k) k^[-dir*(q+.5)] rc^[-dir*(q-.5)]
c        = ã(k) (k/kc)^[-dir*(q+.5)] (kc rc)^(-dir*q) (rc/kc)^(dir*.5)
      lnkr=log(kr)
      lnrk=log(rk)
      do j=1,n
        a(j)=a(j)*exp(-dir*((q+HALF)*(j-jc)*dlnr+q*lnkr-HALF*lnrk))
      enddo
      return
      end
c
c=======================================================================
      subroutine fht(n,a,dir,wsave)
      integer n,dir
      real*8 a(n),wsave(*)
c
c This is a driver routine that calls fhtq.
c
c fht computes a discrete version of the Hankel transform
c
c          infinity
c           /
c    Ã(k) = | A(r) J  (k r) k dr
c           /       mu
c          0
c
c by making the substitutions
c                 q                      -q
c    A(r) = a(r) r    and   Ã(k) = ã(k) k    
c
c and applying a biased Hankel transform to a(r).
c
c The steps are:
c 1. a(r) = A(r) r^(-dir*q)
c 2. call fhtq to transform a(r) -> ã(k)
c 3. Ã(k) = ã(k) k^(-dir*q)
c
c fhti must be called before the first call to fht.
c
c A call to fht with dir=1 followed by
c a call to fht with dir=-1, or vice versa,
c leaves the array a unchanged.
c
c  Input: n = length of a array.
c	  dir = 1 for forward transform,
c		-1 for backward transform.
c               A backward transform (dir = -1) is the same as
c               a forward transform with q -> -q,
c               for any kr if n is odd,
c               for low-ringing kr if n is even.
c	  wsave = working array set up by fhti.
c Input/Output:
c         a on  input is the array A(r) to transform:
c             a(j) is A(r_j) at r_j = r_c exp[(j-jc) dlnr]
c                where jc = (n+1)/2 = central index of array.
c         a on output is the transformed array Ã(k):
c             a(j) is Ã(k_j) at k_j = k_c exp[(j-jc) dlnr].
c
c        parameters
      real*8 ZERO,TWO
      parameter (ZERO=0.d0,TWO=2.d0)
c        local (automatic) variables
      integer j,l
      real*8 dlnr,jc,kr,lnkr,q
c
      l=2*n+15
      q=wsave(l+1)
      dlnr=wsave(l+2)
      kr=wsave(l+3)
c........a(r) = A(r) (r/rc)^(-dir*q)
      if (q.ne.ZERO) then
c        centre point of array
        jc=dble(n+1)/TWO
        do j=1,n
          a(j)=a(j)*exp(-dir*q*(j-jc)*dlnr)
        enddo
      endif
c........transform a(r) -> ã(k)
      call fhtq(n,a,dir,wsave)
c........Ã(k) = ã(k) (k rc)^(-dir*q)
c             = ã(k) (k/kc)^(-dir*q) (kc rc)^(-dir*q)
      if (q.ne.ZERO) then
        lnkr=log(kr)
        do j=1,n
          a(j)=a(j)*exp(-dir*q*((j-jc)*dlnr+lnkr))
        enddo
      endif
      return
      end
c
c=======================================================================
      subroutine fhtq(n,a,dir,wsave)
      integer n,dir
      real*8 a(n),wsave(*)
c
c This is the basic FFTLog routine.
c
c fhtq computes a discrete version of the biased Hankel transform
c
c          infinity
c           /           q
c    ã(k) = | a(r) (k r)  J  (k r) k dr
c           /              mu
c          0
c
c fhti must be called before the first call to fhtq.
c
c A call to fhtq with dir=1 followed by
c a call to fhtq with dir=-1, or vice versa,
c leaves the array a unchanged.
c
c  Input: n = length of a array.
c	  dir = 1 for forward transform,
c		-1 for backward transform.
c               A backward transform (dir = -1) is the same as
c               a forward transform with q -> -q,
c               for any kr if n is odd,
c               for low-ringing kr if n is even.
c Input/Output:
c         a on  input is the periodic array a(r) to transform:
c             a(j) is a(r_j) at r_j = r_c exp[(j-jc) dlnr]
c                 where jc = (n+1)/2 = central index of array.
c         a on output is the transformed periodic array ã(k):
c             a(j) is ã(k_j) at k_j = k_c exp[(j-jc) dlnr].
c
c        parameters
      real*8 ZERO
      parameter (ZERO=0.d0)
c        local (automatic) variables
      integer l,m
      real*8 ai,ar,q
c
      l=2*n+15
      q=wsave(l+1)
      l=l+3
c--------normal FFT
      call drfftf(n,a,wsave)
c--------unbiased (q = 0) transform
      if (q.eq.ZERO) then
c........multiply by
c        (kr)^[- i 2 m pi/(n dlnr)] U_mu[i 2 m pi/(n dlnr)]
        do m=1,(n-1)/2
          ar=a(2*m)
          ai=a(2*m+1)
          a(2*m)=ar*wsave(l+2*m-1)-ai*wsave(l+2*m)
          a(2*m+1)=ar*wsave(l+2*m)+ai*wsave(l+2*m-1)
        enddo
c        problematical last element, for even n
        if (mod(n,2).eq.0) then
          ar=wsave(l+n-1)
c        forward transform: multiply by real part
c Why?  See http://casa.colorado.edu/~ajsh/FFTLog/index.html#ure
          if (dir.eq.1) then
            a(n)=a(n)*ar
c        backward transform: divide by real part
          elseif (dir.eq.-1) then
c Real part ar can be zero for maximally bad choice of kr.
c This is unlikely to happen by chance, but if it does,
c policy is to let it happen.
c For low-ringing kr, imaginary part ai is zero by construction,
c and real part ar is guaranteed nonzero.
            a(n)=a(n)/ar
          endif
        endif
c--------biased (q != 0) transform
      else
c........multiply by
c        (kr)^[- i 2 m pi/(n dlnr)] U_mu[q + i 2 m pi/(n dlnr)]
c        phase
        do m=1,(n-1)/2
          ar=a(2*m)
          ai=a(2*m+1)
          a(2*m)=ar*wsave(l+3*m)-ai*wsave(l+3*m+1)
          a(2*m+1)=ar*wsave(l+3*m+1)+ai*wsave(l+3*m)
        enddo
c        forward transform: multiply by amplitude
        if (dir.eq.1) then
          a(1)=a(1)*wsave(l+1)
          do m=1,(n-1)/2
            a(2*m)=a(2*m)*wsave(l+3*m-1)
            a(2*m+1)=a(2*m+1)*wsave(l+3*m-1)
          enddo
c        backward transform: divide by amplitude
        elseif (dir.eq.-1) then
c        amplitude of m=0 element
          ar=wsave(l+1)
          if (ar.eq.ZERO) then
c Amplitude of m=0 element can be zero for some mu, q combinations
c (singular inverse); policy is to drop potentially infinite constant.
            a(1)=ZERO
          else
            a(1)=a(1)/ar
          endif
c        remaining amplitudes should never be zero
          do m=1,(n-1)/2
            a(2*m)=a(2*m)/wsave(l+3*m-1)
            a(2*m+1)=a(2*m+1)/wsave(l+3*m-1)
          enddo
        endif
c        problematical last element, for even n
        if (mod(n,2).eq.0) then
          m=n/2
          ar=wsave(l+3*m)*wsave(l+3*m-1)
c        forward transform: multiply by real part
          if (dir.eq.1) then
            a(n)=a(n)*ar
c        backward transform: divide by real part
          elseif (dir.eq.-1) then
c Real part ar can be zero for maximally bad choice of kr.
c This is unlikely to happen by chance, but if it does,
c policy is to let it happen.
c For low-ringing kr, imaginary part ai is zero by construction,
c and real part ar is guaranteed nonzero.
            a(n)=a(n)/ar
          endif
        endif
      endif
c--------normal FFT back
      call drfftb(n,a,wsave)
c--------reverse the array
c        and at the same time undo the FFTs' multiplication by n 
      do m=1,n/2
        ar=a(m)
        a(m)=a(n+1-m)/n
        a(n+1-m)=ar/n
      enddo
      if (mod(n,2).eq.1) then
        m=(n+1)/2
        a(m)=a(m)/n
      endif
      return
      end
c
c=======================================================================
      real*8 function krgood(mu,q,dlnr,kr)
      real*8 mu,q,dlnr,kr
c
c Use of this routine is optional.
c
c Choosing kr so that
c     (kr)^(- i pi/dlnr) U_mu(q + i pi/dlnr)
c is real may reduce ringing of the discrete Hankel transform,
c because it makes the transition of this function across the period
c boundary smoother.
c
c  Input: mu = index of J_mu in Hankel transform.
c	  q = exponent of power law bias.
c         dlnr = separation between natural log of points.
c	  kr = suggested value of kr.
c Output: krgood = low-ringing value of kr nearest to input kr.
c                  ln(krgood) is always within dlnr/2 of ln(kr).
c
c        parameters
      real*8 PI
      parameter (PI=3.141592653589793238462643383279502884197d0)
      real*8 ZERO,ONE,TWO
      parameter (ZERO=0.d0,ONE=1.d0,TWO=2.d0)
c        externals
      complex*16 cdgamma
c        local (automatic) variables
      real*8 arg,iarg,xm,xp,y
      complex*16 zm,zp
c
      krgood=kr
      if (dlnr.eq.ZERO) return
      xp=(mu+ONE+q)/TWO
      xm=(mu+ONE-q)/TWO
      y=PI/(TWO*dlnr)
      zp=dcmplx(xp,y)
      zm=dcmplx(xm,y)
      zp=cdgamma(zp,1)
      zm=cdgamma(zm,1)
c        low-ringing condition is that following should be integral
      arg=log(TWO/kr)/dlnr+(dimag(zp)+dimag(zm))/PI
      iarg=anint(arg)
c        if should ensure arg = +-Infinity dealt with correctly
      if (arg.ne.iarg) then
c        low-ringing kr
        krgood=kr*exp((arg-iarg)*dlnr)
      endif
      return
      end
c
c-----------------------------------------------------------------------
      integer function stblnk(string)
      character*(*) string
c
c        externals
      integer lnblnk
c        local (automatic) variables
      integer i
c *
c * Return index of first non-blank character in string.
c * If string is all blank, returned index is 1+lnblnk(string).
c *
      do i=1,lnblnk(string)
        if (string(i:i).ne.' ') goto 120
      enddo
  120 stblnk=i
      return
      end
c

!Lensing the C_l using the deflection angle from the computed lensing potential
!power spectrum. 
!lensing_method=1: using an accurate curved-sky correlation function method
!lensing_method=2: using the flat-sky lower order result of astro-ph/9505109 
!                  and astro-ph/9803150 as in CMBFAST 
!lensing_method=3: using inaccurate full sky harmonic method of astro-ph/0001303

!The flat sky result is accurate to about 0.1% in TT, and 0.4% in EE and is
!about a factor of two faster than lensing_method=1.
!lensing_method=3 is only present for comparison and is not recommended in any regime

!Set accurate_BB=T if you want BB accurately by integrating the full angular range
!otherwise it saves a large amount of time by only integrating the small scales
!accute_BB only does *not* include any non-linear corrections or ensure you have
!chosen sufficiently high l_max and k_max, so does not neccessarily give an accurate
!result

!Uses the un-lensed Cls and the computed lensing potential power spectrum.
!Usual values of k_max are fine for all but the lensed BB Cls
!To get the lensed BB accurate around l=1000 you need to go to l_max >2000, and
!higher for higher l. Since this probes small scales in the lensing power spectrum you
!also need to go to higher k_max - for concordance models something like 
!k_eta_max_scalar=10000. At l>1000 you can expect to need higher k_max, and for 
!non-linear evolution to cause a significant error.

!Correlation function routines by AL+AC Nov 2004 with flat-sky borrowings from CMBFAST
!Curved sky results use the method of astro-ph/xxx.

!Full sky harmonic lensing routines by Gayoung Chon and AC.
!Ref: astro-ph/0001303 by W. Hu. 
!For better derivations see also astro-ph/0301064 and astro-ph/0301031
!Adapted for CAMB and optimized by AL.
!Uses f90 version of "J1-RECURSION OF 3J-COEFFICIENTS" by K. Schulten and R.G. Gordon 
!obtainable from the CPC program library (www.cpc.cs.qub.ac.uk).

!March 2006: fixed problem with l_max when generating with tensors (thanks Chad Fendt)

module lensing
use Precision
use ModelParams
use AmlUtils
implicit none
 integer, parameter :: lensing_method_curv_corr=1,lensing_method_flat_corr=2, &
                       lensing_method_harmonic=3
 
 integer :: lensing_method = lensing_method_curv_corr

private

 logical  :: lensing_includes_tensors = .false.

!flat method stores
 real(dl), parameter :: dbessel = 0.05_dl 
 real(dl), dimension(:), allocatable :: Bess0, ddBess0
 real(dl), dimension(:), allocatable :: Bess2, ddBess2
 real(dl), dimension(:), allocatable :: Bess4, ddBess4
 real(dl), dimension(:), allocatable :: Bess6, ddBess6

 integer, parameter :: lensed_convolution_margin = 100
   !Number of L less than L max at which the lensed power spectrum is calculated 

!Harmonic method stores
 integer :: lmax_donelnfa = 0
 real(dl), dimension(:), allocatable  :: lnfa

public lens_Cls, lensing_includes_tensors, lensing_method, lensing_method_flat_corr,&
      lensing_method_curv_corr,lensing_method_harmonic, BessI, bessj0
contains


subroutine lens_Cls
 use lvalues

 !Must set l again in case computed tessors (thanks to Chad)
 call initlval(lSamp,CP%Max_l)
 if (lensing_method == lensing_method_curv_corr) then
    call CorrFuncFullSky()
  elseif (lensing_method == lensing_method_flat_corr) then 
    call CorrFuncFlatSky()
  elseif (lensing_method == lensing_method_harmonic) then 
    call BadHarmonic
  else
    stop 'Unknown lensing method'
 end if
end subroutine lens_Cls


subroutine CorrFuncFullSky

  integer :: lmax_extrap 
  
  lmax_extrap = CP%Max_l - lensed_convolution_margin + 450  
  if (HighAccuracyDefault) lmax_extrap=lmax_extrap+300
  lmax_extrap = min(lmax_extrap_highl,lmax_extrap)
  call CorrFuncFullSkyImpl(max(lmax_extrap,CP%max_l))

end subroutine CorrFuncFullSky


subroutine CorrFuncFullSkyImpl(lmax)
 !Accurate curved sky correlation function method
 !Uses non-perturbative isotropic term with 2nd order expansion in C_{gl,2}
 !Neglects C_{gl}(theta) terms (very good approx)
  use ModelParams
  use ModelData
  use lvalues
  implicit none
  integer, intent(in) :: lmax
  integer l, i, in
  integer :: npoints 
  real(dl) corr(4), Cg2, sigmasq, theta
  real(dl) dtheta
  real(dl) llp1,fac, fac1,fac2,fac3, rootllp1, rootfac1, rootfac2, rootfac3
  integer max_lensed_ix
  real(dl) P(lmax),dP(lmax)
  real(dl) sinth,halfsinth, x, T2,T4
  real(dl) roots(-1:lmax+4), lfacs(lmax), lfacs2(lmax), lrootfacs(lmax)
  real(dl) d_11(lmax),d_m11(lmax)
  real(dl) d_22(lmax),d_2m2(lmax),d_20(lmax)
  real(dl) Cphil3(lmin:lmax), CTT(lmin:lmax), CTE(lmin:lmax),CEE(lmin:lmax)
  real(dl) ls(lmax)
  real(dl) xl(lmax),ddcontribs(lmax,4),corrcontribs(lmax,4)
  real(dl), allocatable, dimension(:,:,:) :: lens_contrib(:,:,:)
  integer thread_ix
  real(dl) pmm, pmmp1
  real(dl) d4m4,d11,dm11,d2m2,d22,d20,d23,d2m3,d33,d3m3,d04,d1m2,d12,d13,d1m3,d2m4
  real(dl) sinfac, Cg2sq
  real(dl) X000,X022,X220,X121,X132,X242
  real(dl) dX000,dX022
  real(sp) timeprev
  integer  interp_fac
  integer j,jmax
  integer llo, lhi
  real(dl) a0,b0,ho, sc
  logical :: short_integral_range
  integer, parameter :: slow_highL = 5000 !Lmax at which to do full range to prevent ringing etc

  logical, parameter :: approx = .false.

!$ integer  OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS
!$ external OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS

    if (lensing_includes_tensors) stop 'Haven''t implemented tensor lensing'

    max_lensed_ix = lSamp%l0-1
!    do while(lSamp%l(max_lensed_ix) > CP%Max_l -250)
    do while(lSamp%l(max_lensed_ix) > CP%Max_l - lensed_convolution_margin) 
      max_lensed_ix = max_lensed_ix -1
    end do
    lmax_lensed = lSamp%l(max_lensed_ix)
    if (allocated(Cl_lensed)) deallocate(Cl_lensed)
    allocate(Cl_lensed(lmin:lmax_lensed,CP%InitPower%nn,1:4))
    
    Cl_Lensed = 0
   
    npoints = CP%Max_l  * 2    
    short_integral_range = .not. CP%AccurateBB .and. CP%Max_l<=slow_highL
    if (.not. short_integral_range ) npoints = npoints * 2 

    dtheta = pi / npoints
    if (short_integral_range) then
      npoints = int(npoints /32 *min(32._dl,AccuracyBoost)) 
      !OK for TT, EE, TE but inaccurate for low l BB
      !this induces high frequency ringing on very small scales
    end if

    if (DebugMsgs) timeprev=GetTestTime()

    if (.not. short_integral_range) then
     !There is an odd serious problem with interpolating if you do a large
     !angular range.
      
     interp_fac =1
    else
     interp_fac = max(1,nint(10/AccuracyBoost))
    end if

    jmax = 0
    do l=lmin,lmax
       if (l<=15 .or. mod(l-15,interp_fac)==interp_fac/2) then
         jmax =jmax+1
         ls(jmax)=l
         xl(jmax)=l
       end if
       lfacs(l) = real(l*(l+1),dl)
       lfacs2(l) = real((l+2)*(l-1),dl)
       lrootfacs(l) = sqrt(lfacs(l)*lfacs2(l))
    end do

    roots(-1)=0 !just so dipole doesn't screw up
    do l=0,lmax+4
     roots(l) = sqrt(real(l,dl))
    end do


    thread_ix = 1
    !$ thread_ix = OMP_GET_MAX_THREADS()  
    allocate(lens_contrib(4,lmax_lensed,thread_ix))

    do in = 1, CP%InitPower%nn

    do l=lmin,CP%Max_l
     ! (2*l+1)l(l+1)/4pi C_phi_phi: Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
       Cphil3(l) = Cl_scalar(l,in,C_Phi)*(2*l+1)*(l+1)/real(l,dl)**3/(4*pi) 
       fac = (2*l+1)/(4*pi) * 2*pi/(l*(l+1))
       CTT(l) =  Cl_scalar(l,in,C_Temp)*fac
       CEE(l) =  Cl_scalar(l,in,C_E)*fac
       CTE(l) =  Cl_scalar(l,in,C_Cross)*fac
    end do
    if (Cphil3(10) > 1e-7) then
     write (*,*) 'You need to normalize realistically to use lensing.'
     write (*,*) 'see http://cosmocoffee.info/viewtopic.php?t=94'
     stop
    end if
    if (lmax > CP%Max_l) then
     l=CP%Max_l
     sc = (2*l+1)/(4*pi) * 2*pi/(l*(l+1))     
     fac2=CTT(CP%Max_l)/(sc*highL_CL_template(CP%Max_l, C_Temp))
     fac=Cphil3(CP%Max_l)/(sc*highL_CL_template(CP%Max_l, C_Phi))  
     do l=CP%Max_l+1, lmax
       !Fill in tail from template
       sc = (2*l+1)/(4*pi) * 2*pi/(l*(l+1))  
       Cphil3(l) = highL_CL_template(l, C_Phi)*fac*sc
       
       CTT(l) =  highL_CL_template(l, C_Temp)*fac2*sc
       CEE(l) =  highL_CL_template(l, C_E)*fac2 *sc
       CTE(l) =  highL_CL_template(l, C_Cross)*fac2*sc 
      if (Cphil3(CP%Max_l+1) > 1e-7) then
       write (*,*) 'You need to normalize the high-L template so it is dimensionless'
       stop
      end if
     end do
   end if
  lens_contrib=0

  !uncomment second line for PGF90 workaround
  !$OMP PARALLEL DO DEFAULT(PRIVATE),  &
  !OMP PRIVATE(P,dP,d11,dm11,d22,d2m2,d20,corrcontribs,ddcontribs),& 
  !$OMP SHARED(lfacs,lfacs2,lrootfacs,Cphil3,CTT,CTE,CEE,lens_contrib, lmax), &
  !$OMP SHARED(dtheta,CP,lmax_lensed,roots, npoints,interp_fac,jmax,ls,xl,short_integral_range) 
      do i=1,npoints-1

      theta = i * dtheta 
      x = cos(theta)
      sinth = sin(theta)
      halfsinth = sinth/2

      pmm=1
      pmmp1=x

      Cg2=0
      sigmasq=0
      if (lmin==1) then
        d_11(1) = cos(theta/2)**2
        d_m11(1) = sin(theta/2)**2
        sigmasq = sigmasq  +  (1-d_11(1))*Cphil3(lmin) 
        Cg2 = Cg2  + d_m11(1)*Cphil3(lmin)
        P(1) = x
        d_22(1)=0
        d_2m2(1)=0
        d_20(1)=0
      end if
      do l=2,lmax

        P(l)= ((2*l-1)* x *pmmp1 - (l-1)*Pmm)/ l
        dP(l) = l*(pmmp1-x*P(l))/sinth**2
        Pmm=pmmp1
        pmmp1=P(l)
        llp1 = lfacs(l)
  
        fac1 = (1-x)
        fac2 = (1+x)
        fac = fac1/fac2

        d_11(l) =  fac1*dP(l)/llp1 + P(l)
        d_m11(l) = fac2*dP(l)/llp1 - P(l)

        sigmasq = sigmasq  +  (1-d_11(l))*Cphil3(l) 
        Cg2 = Cg2  + d_m11(l)*Cphil3(l)
        
        d_22(l) = ( ((4*x-8)/fac2 + llp1)*P(l) &
            + 4*fac*( fac2 + (x - 2)/llp1)*dP(l) )/ lfacs2(l)
                  
        d_2m2(l) = ( (llp1- (4*x+8)/fac1) *P(l) &
            +4/fac*( -fac1 + (x+2)/llp1) *dP(l) )/lfacs2(l)              

        d_20(l) = (2*x*dP(l) - llp1*P(l) ) / lrootfacs(l)

      end do
    
       do j=1,jmax
        l =ls(j)
 
        fac1 = (1-x)
        fac2 = (1+x)
        llp1 = lfacs(l)
  
        rootllp1 = roots(l)*roots(l+1) 
        rootfac1 = roots(l+2)*roots(l-1)
        rootfac2 = roots(l+3)*roots(l-2)

        llp1=lfacs(l)
        dm11=d_m11(l)
        d11=d_11(l)
        if (l<2) then
         d2m2=0
         d22=0
         d20=0
         d1m2 = 0
         d12 =  0     
        else
         d2m2=d_2m2(l)
         d22=d_22(l)
         d20=d_20(l)
         d1m2 = sinth/rootfac1*(dP(l) -2/fac1*dm11)
         d12 =  sinth/rootfac1*(dP(l) -2/fac2*d11)
        end if
        if (l<3) then
         d1m3=0
         d2m3=0
         d3m3=0
         d13 =0 
         d23 =0
         d33 =0 
        else
         sinfac=4/sinth
         d1m3 = (-(x+0.5_dl)*d1m2*sinfac - lfacs2(l)*dm11/rootfac1 )/rootfac2
         d2m3 = (-fac2*d2m2*sinfac - rootfac1*d1m2)/rootfac2
         d3m3 = (-(x+1.5_dl)*d2m3*sinfac - rootfac1*d1m3)/rootfac2
         d13  =  ((x-0.5_dl)*d12*sinfac - lfacs2(l)*d11/rootfac1 ) /rootfac2
         d23  = (-fac1*d22*sinfac + rootfac1*d12 ) / rootfac2
         d33  = (-(x-1.5_dl)*d23*sinfac - rootfac1*d13)/rootfac2
        end if 
        if (l<4) then
         d04=0
         d2m4=0
         d4m4=0
         rootfac3=0
        else
         rootfac3=roots(l-3)*roots(l+4)
         d04=( (-llp1 + (18*x**2 + 6)/sinth**2 )*d20  -&
             6*x*lfacs2(l)*dP(l)/lrootfacs(l) ) / (rootfac2*rootfac3)
         d2m4= (-(6*x+4)*d2m3/sinth - rootfac2*d2m2 ) / rootfac3
         d4m4 = (-7/5._dl*(llp1-6)*d2m2 + &
                12/5._dl*( -llp1+(9*x+26)/fac1)*d3m3 ) / (llp1-12)
        end if

       !Non perturbative isotropic integrals
       !these are approx, but extremely good approximations
         X000 = exp(-llp1*sigmasq/4)
         if (approx) then

         X022 = X000  
         X220 = rootllp1**2/4*X000
         X121 = -0.5_dl*rootllp1*X000
         X132 = -0.5_dl*rootllp1*X000
         X242 = 0.25_dl*rootllp1**2*X022 
         
         dX000 = -llp1/4*X000
         dX022 = -llp1/4*X022
        

         else
         X022 = X000*(1+sigmasq)   !exp(-(llp1-4)*sigmasq/4)
         X220 = lrootfacs(l)/4*X000
         X121 = -0.5_dl*rootfac1*X000
         X132 = -0.5_dl*rootfac2*X000
         X242 = 0.25_dl*rootfac2*rootfac3*X022 
         
         dX000 = -llp1/4*X000
         dX022 = (1-llp1/4)*X022
         end if  
!second order
         !TT
         fac1 = dX000**2
         fac3 = X220**2
         Cg2sq = Cg2**2

!Here we drop terms in Cgt which are down by powers of l
!Approx good to 1e-4 level
         fac = ( (X000**2-1) + Cg2sq*fac1)*P(l)+ Cg2sq*fac3*d2m2 &
                    + 8/llp1* fac1*Cg2*dm11 
     
         corrcontribs(j,1)=  CTT(l) * fac 

         fac2=(Cg2*dX022)**2+(X022**2-1)
!Q+U
         fac = 2*Cg2*X121*X132*d13 + fac2*d22 +Cg2sq*X242*X220*d04 

         corrcontribs(j,2)= CEE(l) * fac 

!Q-U 
         fac = ( fac3*P(l) + X242**2*d4m4)*Cg2sq/2 &
              + Cg2*(X121**2*dm11+ X132**2*d3m3) + fac2*d2m2 

         corrcontribs(j,3)= CEE(l) * fac 

!TE
        fac = (X000*X022-1)*d20+ &
          2*dX000*Cg2*(X121*d11 + X132*d1m3)/rootllp1 &
             + Cg2sq*(X220/2*d2m4*X242 +( fac3/2 + dX022*dX000)*d20) 

        corrcontribs(j,4)= CTE(l) * fac 

      end do

do j=1,4
  corr(j) = sum(corrcontribs(1:14,j))+interp_fac*sum(corrcontribs(15:jmax,j))
end do

if (short_integral_range .and. i>npoints-20) &
        corr=corr*exp(-(i-npoints+20)**2/150.0) !taper the end to help prevent ringing

!Interpolate contributions
!Increasing interp_fac and using this seems to be slower than above
if (.false.) then
      if (abs(sum(corrcontribs(1:jmax,1)))>1e-11) print *,i,sum(corrcontribs(1:jmax,1))
      do j=1,4
       call spline(xl,corrcontribs(1,j),jmax,1d30,1d30,ddcontribs(1,j))
      end do 
      corr=0
      llo=1
      do l=lmin,lmax
           if ((l > ls(llo+1)).and.(llo < jmax)) then
              llo=llo+1
           end if
           lhi=llo+1
           ho=ls(lhi)-ls(llo)
           a0=(ls(lhi)-l)/ho
           b0=(l-ls(llo))/ho
           fac1 = ho**2/6
           fac2 = (b0**3-b0)*fac1
           fac1 = (a0**3-a0)*fac1 
  
           corr(1) = Corr(1)+ a0*corrcontribs(llo,1)+ b0*corrcontribs(lhi,1)+ &
            fac1* ddcontribs(llo,1) +fac2*ddcontribs(lhi,1)
           corr(2) = Corr(2)+ a0*corrcontribs(llo,2)+ b0*corrcontribs(lhi,2)+ &
            fac1* ddcontribs(llo,2) +fac2*ddcontribs(lhi,2)
           corr(3) = Corr(3)+ a0*corrcontribs(llo,3)+ b0*corrcontribs(lhi,3)+ &
            fac1* ddcontribs(llo,3) +fac2*ddcontribs(lhi,3)
           corr(4) = Corr(4)+ a0*corrcontribs(llo,4)+ b0*corrcontribs(lhi,4)+ &
            fac1* ddcontribs(llo,4) +fac2*ddcontribs(lhi,4)
         
      end do
end if 
      
 !$   thread_ix = OMP_GET_THREAD_NUM()+1

      do l=lmin, lmax_lensed
       !theta factors were put in earlier (already in corr)


       lens_contrib(C_Temp, l, thread_ix)= lens_contrib(C_Temp,l, thread_ix) + &
                                          corr(1)*P(l)*sinth 

       T2 = corr(2)* d_22(l)
       T4 = corr(3)* d_2m2(l)


       lens_contrib(CT_E, l, thread_ix)= lens_contrib(CT_E,l, thread_ix) + &
                                          (T2+T4)*halfsinth 
       lens_contrib(CT_B, l, thread_ix)= lens_contrib(CT_B,l, thread_ix) + &
                                          (T2-T4)*halfsinth 
 
       lens_contrib(CT_Cross, l, thread_ix)= lens_contrib(CT_Cross,l, thread_ix) + &
                                          corr(4)*d_20(l)*sinth 
 
      end do

     end do
  !$OMP END PARALLEL DO
     
      do l=lmin, lmax_lensed
         !sign from d(cos theta) = -sin theta dtheta
       fac = l*(l+1)/OutputDenominator*dtheta *2*pi
       Cl_lensed(l,in,CT_Temp) = sum(lens_contrib(CT_Temp,l,:))*fac &
                 + Cl_scalar(l,in,C_Temp) 
       Cl_lensed(l,in,CT_E) = sum(lens_contrib(CT_E,l,:))*fac &
                 + Cl_scalar(l,in,C_E) 
       Cl_lensed(l,in,CT_B) = sum(lens_contrib(CT_B,l,:))*fac
       Cl_lensed(l,in,CT_Cross) = sum(lens_contrib(CT_Cross,l,:))*fac &
                 + Cl_scalar(l,in,C_Cross) 

      end do

      end do !loop over different initial power spectra
     deallocate(lens_contrib)

     if (DebugMsgs) write(*,*) GetTestTime()-timeprev, 'Time for corr lensing'

end subroutine CorrFuncFullSkyImpl



subroutine CorrFuncFlatSky
 !Do flat sky approx partially non-perturbative lensing, lensing_method=2
   use ModelParams
  use ModelData
  use lvalues
  integer l, i
  integer :: npoints 
  real(dl) Cgl2,  sigmasq, theta
  real(dl) dtheta
  real(dl) dbessfac, fac, fac1,fac2,  C2term, expsig, corr(4)
  real(sp) timeprev
  real(dl) Bessel0(lmin:CP%Max_l),Bessel2(lmin:CP%Max_l)
  real(dl) Bessel4(lmin:CP%Max_l),Bessel6(lmin:CP%Max_l)
  real(dl) Cphil3(lmin:CP%Max_l), CTT(lmin:CP%Max_l), CTE(lmin:CP%Max_l),CEE(lmin:CP%Max_l)
  integer max_lensed_ix
  integer b_lo
  integer in
  real(dl) T2,T4,a0, b0
  real(dl) lfacs(CP%Max_l)
  real(dl), allocatable, dimension(:,:,:) :: lens_contrib(:,:,:)
  integer thread_ix
!$ integer OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS
!$ external OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS

    if (lensing_includes_tensors) stop 'Haven''t implemented tensor lensing'

    max_lensed_ix = lSamp%l0-1
    do while(lSamp%l(max_lensed_ix) > CP%Max_l -250)
      max_lensed_ix = max_lensed_ix -1
    end do
    lmax_lensed = lSamp%l(max_lensed_ix)
    if (allocated(Cl_lensed)) deallocate(Cl_lensed)
    allocate(Cl_lensed(lmin:lmax_lensed,CP%InitPower%nn,1:4))
    
    Cl_Lensed = 0
   
    npoints = CP%Max_l  * 2   
    if (CP%AccurateBB) npoints = npoints * 2

    dtheta = pi / npoints
    if (.not. CP%AccurateBB) then
     npoints = int(npoints /32 *min(32._dl,AccuracyBoost)) 
      !OK for TT, EE, TE but inaccurate for low l BB
      !this induces high frequency ringing on very small scales
    end if

    call GetBessels(npoints*dtheta*CP%Max_l)

    if (DebugMsgs) timeprev=GetTestTime()

    dbessfac = dbessel**2/6

    thread_ix = 1
    !$ thread_ix = OMP_GET_MAX_THREADS()  
    allocate(lens_contrib(4,lmax_lensed,thread_ix))

    do in = 1, CP%InitPower%nn

    do l=lmin,CP%Max_l
     ! l^3 C_phi_phi/2/pi: Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
       Cphil3(l) = Cl_scalar(l,in,C_Phi)/l /(2*pi)
       fac = l/(2*pi)*2*pi/(l*(l+1))
       CTT(l) =  Cl_scalar(l,in,C_Temp)*fac
       CEE(l) =  Cl_scalar(l,in,C_E)*fac
       CTE(l) =  Cl_scalar(l,in,C_Cross)*fac
       lfacs(l) = l**2*0.5_dl
    end do

    if (Cphil3(10) > 1e-7) then
     write (*,*) 'You need to normalize realistically to use lensing.'
     write (*,*) 'see http://cosmocoffee.info/viewtopic.php?t=94'
     stop
    end if

  lens_contrib=0

  !$OMP PARALLEL DO DEFAULT(SHARED),  &
  !$OMP PRIVATE(theta, sigmasq,cgl2,b_lo,a0,b0,fac,fac1,fac2), &
  !$OMP PRIVATE(Bessel0,Bessel2,Bessel4,Bessel6), &
  !$OMP PRIVATE(corr,expsig,C2term,T2,T4,i,l, thread_ix)     

    do i=1,npoints-1

      theta = i * dtheta 
      sigmasq =0
      Cgl2=0
      fac = theta /dbessel
     
      do l=lmin,CP%Max_l

!Interpolate the Bessel functions, and compute sigma^2 and C_{gl,2} 
        b0 = l*fac
        b_lo = int(b0) +1 
        a0=  b_lo - b0                
        b0=  1._dl - a0 
        fac1 = a0*b0*dbessfac
        fac2 = fac1*(a0-2)
        fac1 = fac1*(b0-2)

        Bessel0(l) = a0*Bess0(b_lo)+ b0*Bess0(b_lo+1) +fac1*ddBess0(b_lo) &
                       +fac2*ddBess0(b_lo+1)
        sigmasq = sigmasq + (1-Bessel0(l))*Cphil3(l) 


        Bessel2(l) = a0*Bess2(b_lo)+ b0*Bess2(b_lo+1) +fac1*ddBess2(b_lo) &
                      +fac2*ddBess2(b_lo+1)
        Cgl2 =  Cgl2 + Bessel2(l)*Cphil3(l)

        Bessel4(l) = a0*Bess4(b_lo)+ b0*Bess4(b_lo+1) +fac1*ddBess4(b_lo) &
                      +fac2*ddBess4(b_lo+1)
        Bessel6(l) = a0*Bess6(b_lo)+ b0*Bess6(b_lo+1) +fac1*ddBess6(b_lo) &
                      +fac2*ddBess6(b_lo+1)

      end do

!Get difference between lensed and unlensed correlation function
     corr = 0
      do l=lmin,CP%Max_l
!For 2nd order perturbative result use 
!         expsig = 1 -sigmasq*l**2/2._dl
!         C2term = l**2*Cgl2/2._dl
          fac = sigmasq*lfacs(l)
          expsig = exp(-fac) 
          C2term = Cgl2*lfacs(l)
!Put theta factor later  in here
          fac1 = expsig*theta
          fac2 = C2term*fac1
          fac1 = fac1 - theta  !we want expsig-1 to get lensing difference

          fac = fac1*Bessel0(l) + fac2*Bessel2(l) 

          !TT
          corr(1) = corr(1) + CTT(l) * fac                              

          !Q + U
          corr(2) = corr(2) + CEE(l) * fac                              
          fac2 = fac2*0.5_dl
          !Q-U
          corr(3) = corr(3) + CEE(l) * &
              (fac1*Bessel4(l) + fac2*(Bessel2(l)+Bessel6(l)))                               
          !Cross
          corr(4) = corr(4) + CTE(l) * &
              (fac1*Bessel2(l) + fac2*(Bessel0(l)+Bessel4(l)))                               
 

      end do

      
 !$   thread_ix = OMP_GET_THREAD_NUM()+1

      do l=lmin, lmax_lensed
       !theta factors were put in earlier (already in corr)
       lens_contrib(C_Temp, l, thread_ix)= lens_contrib(C_Temp,l, thread_ix) + &
                                          corr(1)*Bessel0(l) 
       T2 = corr(2)*Bessel0(l)
       T4 = corr(3)*Bessel4(l)
       lens_contrib(CT_E,l,thread_ix)  = lens_contrib(CT_E,l, thread_ix) + T2+T4
       lens_contrib(CT_B,l,thread_ix)  = lens_contrib(CT_B,l, thread_ix) + T2-T4
       lens_contrib(CT_Cross,l, thread_ix) = lens_contrib(CT_Cross,l, thread_ix) + &
                                              corr(4)*Bessel2(l)
      end do

     end do
  !$OMP END PARALLEL DO
     
      do l=lmin, lmax_lensed
       fac = l*(l+1)* 2*pi/OutputDenominator*dtheta
       Cl_lensed(l,in,CT_Temp) = sum(lens_contrib(CT_Temp,l,:))*fac &
                 + Cl_scalar(l,in,CT_Temp) 
       Cl_lensed(l,in,CT_Cross) = sum(lens_contrib(CT_Cross,l,:))*fac &
                 +Cl_scalar(l,in,C_Cross)
       fac = fac /2 !(factor of 1/2 should have been in T2+/-T4 above           
       Cl_lensed(l,in,CT_E) = sum(lens_contrib(CT_E,l,:))*fac &
                 + Cl_scalar(l,in,CT_E) 
       Cl_lensed(l,in,CT_B) = sum(lens_contrib(CT_B,l,:))*fac
      end do

      end do !loop over different initial power spectra
     deallocate(lens_contrib)

     if (DebugMsgs) write(*,*) GetTestTime()-timeprev, 'Time for corr lensing'

end subroutine CorrFuncFlatSky

subroutine BadHarmonic
  use ModelParams
  use ModelData
  use lvalues
  use InitialPower
  integer maxl, i, in, almin, max_lensed_ix, maxl_phi
  real(dl) , dimension (:,:,:), allocatable :: bare_cls
  real(dl) pp(CP%InitPower%nn,CP%Max_l)
  real(dl) asum(CP%InitPower%nn), RR(CP%InitPower%nn), roots(CP%Max_l)
  real(dl) asum_TE(CP%InitPower%nn), asum_EE(CP%InitPower%nn), asum_BB(CP%InitPower%nn)
  integer l1,l2,al,j, j1, k, hk, llp_1, llp_al, g1
  real(dl)  F, fct
  real(dl) g2l,g2l1, norm
  real(dl) a3j(CP%Max_l*2+1), tF, expF
  logical DoPol
  real(dl) iContribs(lSamp%l0,CP%InitPower%nn, 1:4), intcontrib(lmin:lSamp%l(lSamp%l0))
  real(dl) , dimension (:,:,:), allocatable :: iCl_lensed
  integer max_j_contribs

  real(sp) timeprev
    
!Otherwise use second order perturbative harmonic method

  if (DebugMsgs) timeprev=GetTestTime()

  DoPol = CP%AccuratePolarization

  maxl = CP%Max_l
 
  if (allocated(Cl_lensed)) deallocate(Cl_lensed)


  allocate(bare_cls(CP%InitPower%nn,maxl,1:4))
  
  RR = 0
  do j=lmin,maxl
     norm = OutputDenominator/(j*(j+1))
     if (lensing_includes_tensors .and. CP%WantTensors .and. j<= CP%Max_l_tensor) then !Use total Cls
      bare_cls(:,j,CT_Temp:CT_E) = (Cl_scalar(j,:,C_Temp:C_E) + &
           Cl_tensor(j,:,CT_Temp:CT_E))*norm
      bare_cls(:,j,CT_B) = Cl_tensor(j,:,CT_B)*norm
      bare_cls(:,j,CT_Cross) =  (Cl_scalar(j,:,C_Cross) + &
          Cl_tensor(j,:,CT_Cross))*norm
     else
      bare_cls(:,j,CT_Temp:CT_E) = Cl_scalar(j,:,C_Temp:C_E)*norm
      bare_cls(:,j,CT_B) = 0
      bare_cls(:,j,CT_Cross) =  Cl_scalar(j,:,C_Cross)*norm
     end if
     pp(:,j) = Cl_scalar(j,:,C_Phi)/real(j**2,dl)**2
     RR = RR + j*(j+1)*real(2*j+1,dl)*pp(:,j)
     roots(j) = sqrt(real(2*j+1,dl))
  end do

  RR = RR/2/fourpi
  if (RR(1) > 1e-5) then
     write (*,*) 'You need to normalize realistically to use lensing.'
     write (*,*) 'see http://cosmocoffee.info/viewtopic.php?t=94'
   stop
  end if
  if (maxl > lmax_donelnfa) then 
   !Get ln factorials
   if (allocated(lnfa)) deallocate(lnfa)
   allocate(lnfa(0:maxl*3+1))
   lmax_donelnfa = maxl 
   lnfa(0) = 0
   do i=1,CP%Max_l*3+1 
     lnfa(i)=lnfa(i-1) + log(real(i,dl))
   end do
  end if
   
  max_lensed_ix = lSamp%l0-1
  do while(lSamp%l(max_lensed_ix) > maxl -250)
     max_lensed_ix = max_lensed_ix -1
  end do
  lmax_lensed = lSamp%l(max_lensed_ix)

  allocate(iCl_lensed(max_lensed_ix, CP%InitPower%nn, 1:4))

  max_j_contribs = lSamp%l0-1
  if (.not. DoPol) then
           maxl_phi = min(maxl,nint(max(600,(maxl*2)/5)*scale*AccuracyBoost))
           do while (lSamp%l(max_j_contribs) > maxl_phi)
              max_j_contribs=max_j_contribs-1
           end do
  end if

  !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(DYNAMIC), SHARED(max_j_contribs) &
  !$OMP PRIVATE(al,g1,llp_al,llp_1,g2l,asum,l1,g2l1,l2,k,hk,F,fct,almin), &
  !$OMP PRIVATE(asum_EE,asum_BB,asum_TE,expF,tF, a3j, iContribs,in,intcontrib)
  do j=max_lensed_ix,1,-1  
     !Only compute lensed spectra at lSamp%l(j). Start with slow ones.
     
     al=lSamp%l(j)

     llp_al = al*(al+1)
     g2l=sqrt((2*al+1)/fourpi)

     asum = 0
     asum_EE = 0
     asum_BB = 0
     asum_TE = 0

   
     do j1 = 1, max_j_contribs
        !  Contributions to C_al are a smooth function of l_1 - so interpolate
        l1=lSamp%l(j1)

        llp_1 = l1*(l1+1)
        g2l1=roots(l1)

        almin = max(abs(al-l1),2)

        if (DoPol) then
          call GetThreeJs(a3j(almin),l1,al,0,2)
          do l2= almin, min(maxl,al+l1)
              g1 = llp_1+l2*(l2+1)-llp_al
              if (g1 == 0 ) cycle

              k=al+l1+l2
              fct=g1*g2l*g2l1*roots(l2)/2
              tF = fct*a3j(l2)

              if (mod(k,2)==0) then

                 hk = k/2
                 F = lnfa(hk)-lnfa(hk-al)-lnfa(hk-l1)-lnfa(hk-l2)+(lnfa(k-2*al)+lnfa(k-2*l1)&
                  & +lnfa(k-2*l2)-lnfa(k+1))/2
                 
                 expF = exp(F)

                 asum=asum + bare_cls(:,l2,C_Temp)*(expF*fct)**2
        
                 asum_EE = asum_EE + bare_cls(:,l2,CT_E)*tF**2
                 asum_BB = asum_BB + bare_cls(:,l2,CT_B)*tF**2
                 if (mod(hk,2)/=0) tF=-tF
                 asum_TE = asum_TE + bare_cls(:,l2,CT_Cross)*expF*fct*tF

              else
                
                 asum_BB = asum_BB + bare_cls(:,l2,CT_E)*tF**2
                 asum_EE = asum_EE +bare_cls(:,l2,CT_B)*tF**2 

              end if
              
          end do

        else !No polarization
          do l2= almin +mod(al+l1+almin,2),min(maxl,al+l1), 2 
             !Only do lSamp%l's where al + l1 + l2 is even
             
              g1 = llp_1+l2*(l2+1)-llp_al
            
              if (g1 == 0 ) cycle  !Contribution is zero

              k=al+l1+l2
              hk=k/2
           
              fct=g1*g2l*g2l1*roots(l2)/2
              expF = exp(2*(lnfa(hk)-lnfa(hk-al)-lnfa(hk-l1)-lnfa(hk-l2))+lnfa(k-2*al)+lnfa(k-2*l1)&
                  & +lnfa(k-2*l2)-lnfa(k+1))
              asum=asum + bare_cls(:,l2,CT_Temp)*expF *fct**2
          
          end do
          end if !No polarization


             iContribs(j1,:,CT_Temp) = asum*pp(:,l1)
             if (DoPol) then
                iContribs(j1,:,CT_E) = asum_EE*pp(:,l1)
                iContribs(j1,:,CT_B) = asum_BB*pp(:,l1)
                iContribs(j1,:,CT_Cross) = asum_TE*pp(:,l1)
             end if
             asum = 0
             asum_EE = 0
             asum_BB = 0
             asum_TE = 0

        
       end do

          
       !Interpolate contributions to sum and add up
         do in=1, CP%InitPower%nn
          
            call InterpolateClArr(lSamp,iContribs(1,in,CT_Temp),intcontrib,max_j_contribs)
            asum(in) = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
            if (DoPol) then
               call InterpolateClArr(lSamp,iContribs(1,in,CT_E),intcontrib,max_j_contribs)
               asum_EE(in) = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
               call InterpolateClArr(lSamp,iContribs(1,in,CT_B),intcontrib,max_j_contribs)
               asum_BB(in) = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
               call InterpolateClArr(lSamp,iContribs(1,in,CT_Cross),intcontrib,max_j_contribs)
               asum_TE(in) = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
            end if
         end do

     iCl_lensed(j,:,CT_Temp) =  ((1-al*(al+1)*RR)*bare_cls(:,al,CT_Temp)  & !Linear part
              + asum/(2*al+1))*llp_al/OutputDenominator !add quadratic part and *l(l+1)/2pi
     if (DoPol) then
        iCl_lensed(j,:,CT_E) = ((1-(al**2+al-4)*RR)*bare_cls(:,al,CT_E)  & 
              + asum_EE/(2*al+1))*llp_al/OutputDenominator
        iCl_lensed(j,:,CT_B) = ((1-(al**2+al-4)*RR)*bare_cls(:,al,CT_B)  & 
              + asum_BB/(2*al+1))*llp_al/OutputDenominator
        iCl_lensed(j,:,CT_Cross) =  ((1-(al**2+al-2)*RR)*bare_cls(:,al,CT_Cross) &
                + asum_TE/(2*al+1))*llp_al/OutputDenominator

     else
        iCl_lensed(j,:,CT_E:CT_Cross) = bare_cls(:,al,CT_E:CT_Cross)
     end if

  end do
  !$OMP END PARALLEL DO

  deallocate(bare_cls)

  allocate(Cl_lensed(lmin:lmax_lensed,CP%InitPower%nn,1:4))

  !Interpolate to get final spectrum
  do in=1, CP%InitPower%nn
     do j = CT_Temp, CT_Cross
      call InterpolateClArr(lSamp,iCl_lensed(1,in,j),Cl_lensed(lmin, in, j),max_lensed_ix)
     end do
  end do

  deallocate(iCl_lensed)

  if (DebugMsgs) then
        if (FeedbackLevel>0) write(*,*) GetTestTime()-timeprev,' Timing for lensing'
   end if

end subroutine BadHarmonic

      subroutine GetBessels(MaxArg)
       real(dl), intent(in):: MaxArg
       integer i
       real(dl), allocatable, dimension(:) :: x
       integer max_bes_ix
       integer, save :: last_max = 0

       max_bes_ix = nint(MaxArg / dbessel) + 3
       if (max_bes_ix > last_max) then
           last_max = max_bes_ix
           if (allocated(Bess0)) then
             deallocate(Bess0,ddBess0)
             deallocate(Bess2,ddBess2)
             deallocate(Bess4,ddBess4)
             deallocate(Bess6,ddBess6)
           end if
           allocate(Bess0(max_bes_ix),ddBess0(max_bes_ix))
           allocate(Bess2(max_bes_ix),ddBess2(max_bes_ix))
           allocate(Bess4(max_bes_ix),ddBess4(max_bes_ix))
           allocate(Bess6(max_bes_ix),ddBess6(max_bes_ix))

           allocate(x(max_bes_ix))
           Bess0(1)=1
           Bess2(1)=0; Bess4(1)=0; Bess6(1)=0
           x(1)=0
           do i=2, max_bes_ix
             x(i) = (i-1)*dbessel
             Bess0(i) = Bessj0(x(i)) 
             Bess2(i) = Bessj(2,x(i)) 
             Bess4(i) = Bessj(4,x(i)) 
             Bess6(i) = Bessj(6,x(i)) 
           end do 
           call spline(x,Bess0,max_bes_ix,spl_large,spl_large,ddBess0)
           call spline(x,Bess2,max_bes_ix,spl_large,spl_large,ddBess2)
           call spline(x,Bess4,max_bes_ix,spl_large,spl_large,ddBess4)
           call spline(x,Bess6,max_bes_ix,spl_large,spl_large,ddBess6)

           deallocate(x)
       end if

      end subroutine GetBessels



      FUNCTION bessj0(x)
      real(dl) bessj0,x
      real(dl) ax,xx,z
      real(dl) p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6, &
        s1,s2,s3,s4,s5,s6,y
      SAVE p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,s1,s2,s3,s4, &
       s5,s6
      DATA p1,p2,p3,p4,p5/1.d0,-.1098628627d-2,.2734510407d-4, &
      -.2073370639d-5,.2093887211d-6/, q1,q2,q3,q4,q5/-.1562499995d-1, &
      .1430488765d-3,-.6911147651d-5,.7621095161d-6,-.934945152d-7/
      DATA r1,r2,r3,r4,r5,r6/57568490574.d0,-13362590354.d0, &
       651619640.7d0,-11214424.18d0,77392.33017d0,-184.9052456d0/,s1,s2, &
       s3,s4,s5,s6/57568490411.d0,1029532985.d0,9494680.718d0, &
       59272.64853d0,267.8532712d0,1.d0/

      if(abs(x).lt.8.d0)then
        y=x**2
        bessj0=(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))))/(s1+y*(s2+y*(s3+y* &
          (s4+y*(s5+y*s6)))))
      else
        ax=abs(x)
        z=8.d0/ax
        y=z**2
        xx=ax-.785398164d0
        bessj0=sqrt(.636619772d0/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y* &
           p5))))-z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))
      endif
!  (C) Copr. 1986-92 Numerical Recipes Software

      END FUNCTION bessj0



      FUNCTION BESSJ1(X)
      real(dl), intent(in) :: x
      real(dl) bessj1,ax,z,xx
      real(dl) Y,P1,P2,P3,P4,P5,Q1,Q2,Q3,Q4,Q5,R1,R2,R3,R4,R5, &
         R6,S1,S2,S3,S4,S5,S6
      DATA R1,R2,R3,R4,R5,R6/72362614232.D0,-7895059235.D0,242396853.1D0,&
         -2972611.439D0,15704.48260D0,-30.16036606D0/, &
         S1,S2,S3,S4,S5,S6/144725228442.D0,2300535178.D0, &
         18583304.74D0,99447.43394D0,376.9991397D0,1.D0/
      DATA P1,P2,P3,P4,P5/1.D0,.183105D-2,-.3516396496D-4,.2457520174D-5, & 
         -.240337019D-6/, Q1,Q2,Q3,Q4,Q5/.04687499995D0,-.2002690873D-3, &     
         .8449199096D-5,-.88228987D-6,.105787412D-6/
      IF(ABS(X).LT.8.)THEN
        Y=X**2
        BESSJ1=X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6))))) &
           /(S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
        AX=ABS(X)
        Z=8.0d0/AX
        Y=Z**2
        XX=AX-2.356194491d0
        BESSJ1=SQRT(.636619772d0/AX)*(COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y &
           *P5))))-Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5))))) &
           *SIGN(1._dl,x)
      ENDIF

      END FUNCTION BESSJ1


      FUNCTION BESSJ(N,X)
      real(dl) bessj
      real(dl), intent(in) :: x
      integer, intent(in) :: n
      integer, parameter :: IACC = 40
      real(dl), parameter :: BIGNO=1.d10,BIGNI=1.d-10
      integer jsum,j,m
      real(dl) bj,bjm, bjp, tox, sum
      
      IF(N.LT.2)STOP 'bad argument N in BESSJ'

      TOX=2/X
      IF(X.GT.FLOAT(N))THEN
        BJM=BESSJ0(X)
        BJ=BESSJ1(X)
        DO J=1,N-1
          BJP=J*TOX*BJ-BJM
          BJM=BJ
          BJ=BJP
        END DO
        BESSJ=BJ
      ELSE
        M=2*((N+INT(SQRT(FLOAT(IACC*N))))/2)
        BESSJ=0.0d0
        JSUM=0
        SUM=0._dl
        BJP=0._dl
        BJ=1._dl
        DO J=M,1,-1
          BJM=J*TOX*BJ-BJP
          BJP=BJ
          BJ=BJM
          IF(ABS(BJ).GT.BIGNO)THEN
            BJ=BJ*BIGNI
            BJP=BJP*BIGNI
            BESSJ=BESSJ*BIGNI
            SUM=SUM*BIGNI
          ENDIF
          IF(JSUM.NE.0)SUM=SUM+BJ
          JSUM=1-JSUM
          IF(J.EQ.N)BESSJ=BJP
        end do
        SUM=2.*SUM-BJ
        BESSJ=BESSJ/SUM
      ENDIF
      END FUNCTION BESSJ

! ----------------------------------------------------------------------
! Auxiliary Bessel functions for N=0, N=1
      FUNCTION BESSI0(X)
      double precision X,BESSI0,Y,P1,P2,P3,P4,P5,P6,P7,  &
      Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9,AX,BX
      DATA P1,P2,P3,P4,P5,P6,P7/1.D0,3.5156229D0,3.0899424D0,1.2067429D0,  &
      0.2659732D0,0.360768D-1,0.45813D-2/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1, &
      0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,  &
      0.2635537D-1,-0.1647633D-1,0.392377D-2/
      IF(ABS(X).LT.3.75D0) THEN
      Y=(X/3.75D0)**2
      BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7)))))
      ELSE
      AX=ABS(X)
      Y=3.75D0/AX
      BX=EXP(AX)/SQRT(AX)
      AX=Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9)))))))
      BESSI0=AX*BX
      ENDIF
      RETURN
      END FUNCTION BESSI0
! ----------------------------------------------------------------------
      FUNCTION BESSI1(X)
      double precision X,BESSI1,Y,P1,P2,P3,P4,P5,P6,P7,  &
      Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9,AX,BX
      DATA P1,P2,P3,P4,P5,P6,P7/0.5D0,0.87890594D0,0.51498869D0,  &
      0.15084934D0,0.2658733D-1,0.301532D-2,0.32411D-3/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,-0.3988024D-1, &
      -0.362018D-2,0.163801D-2,-0.1031555D-1,0.2282967D-1, &
      -0.2895312D-1,0.1787654D-1,-0.420059D-2/
      IF(ABS(X).LT.3.75D0) THEN
      Y=(X/3.75D0)**2
      BESSI1=X*(P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
      ELSE
      AX=ABS(X)
      Y=3.75D0/AX
      BX=EXP(AX)/SQRT(AX)
      AX=Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9)))))))
      BESSI1=AX*BX
      ENDIF
      RETURN
      END FUNCTION BESSI1


      FUNCTION BESSI(N,X)
      !from http://perso.orange.fr/jean-pierre.moreau/Fortran/tbessi_f90.txt
!
!     This subroutine calculates the first kind modified Bessel function
!     of integer order N, for any REAL X. We use here the classical
!     recursion formula, when X > N. For X < N, the Miller's algorithm
!     is used to avoid overflows. 
!     REFERENCE:
!     C.W.CLENSHAW, CHEBYSHEV SERIES FOR MATHEMATICAL FUNCTIONS,
!     MATHEMATICAL TABLES, VOL.5, 1962.
      integer, intent(in) :: N
      integer, PARAMETER :: IACC = 40
      integer m,j
      double precision, parameter ::  BIGNO = 1.D10, BIGNI = 1.D-10
      double precision X,BESSI,TOX,BIM,BI,BIP
      IF (N.EQ.0) THEN
      BESSI = BESSI0(X)
      RETURN
      ENDIF
      IF (N.EQ.1) THEN
      BESSI = BESSI1(X)
      RETURN
      ENDIF
      IF(X.EQ.0.D0) THEN
      BESSI=0.D0
      RETURN
      ENDIF
      TOX = 2.D0/X
      BIP = 0.D0
      BI  = 1.D0
      BESSI = 0.D0
      M = 2*((N+INT(SQRT(FLOAT(IACC*N)))))
      DO J = M,1,-1
      BIM = BIP+ J*TOX*BI
      BIP = BI
      BI  = BIM
      IF (ABS(BI).GT.BIGNO) THEN
      BI  = BI*BIGNI
      BIP = BIP*BIGNI
      BESSI = BESSI*BIGNI
      ENDIF
      IF (J.EQ.N) BESSI = BIP
      END DO
      BESSI = BESSI*BESSI0(X)/BI
      RETURN
      END FUNCTION BESSI


end module lensing

c-----------------------------------------------------------------------
c © A J S Hamilton 2001
c-----------------------------------------------------------------------
      subroutine gvlim(vmin,vmax,cmvmin,cmvmax,cmpmin,cmpmax,
     *  ipv,gp,ev,nvmax,nv,nev,nev0,
     *  rp,cm,np,rpi,vcirc,tol,phi,iord,wk,iwk,ldegen)
      integer nvmax,ipv(nvmax),np,gp(np),ev(nvmax),nv,nev,nev0,vcirc
      logical ldegen
      real*10 vmin(3,nvmax),vmax(3,nvmax),cmvmin(nvmax),cmvmax(nvmax),
     *  cmpmin(np),cmpmax(np),rp(3,np),cm(np),rpi(3),tol
c        work arrays (could be made automatic if compiler supports it)
      integer iord(2*np),iwk(nvmax,4)
      real*10 phi(2,np),wk(nvmax)
c
c        parameters
      include 'pi.par'
      real*10 TWOPI
      parameter (TWOPI=2._10*PI)
c        intrinsics
      intrinsic abs
c        externals
      integer gsegij,gzeroar
      real*10 cmijf
c        data variables
      real*10 big
c     real*10 dphmin
c        local variables
      integer i,ii,ik,iphi,iseg,iv,j,jm,jml,jmu,jp,jpl,jpu,km,kp,ni,scmi
C     logical warn
      real*10 cmi,cmik,dph,ikchk,ph,phin,phif,phm,phmax,phmin,php,
     *  si,sik,tolin,xi(3),xv,yi(3),yv,zv
c *
c * Lifted mostly from gvert and gcmlim.
c *
c * Points nearest to and farthest from unit direction rpi
c * on each edge of polygon defined by
c *    1 - r.rp(i) < cm(i)  (if cm(i).ge.0)
c *    1 - r.rp(i) > -cm(i)  (if cm(i).lt.0)
c * for i=1,np where rp(i) are unit directions.
c *
c * The edges are ordered right-handedly about the polygon
c * in the same order as given by gvert.
c * The array ev records the end index of each connected
c * sequences of vertices.
c * Intersecting boundaries come 1st, then non-intersecting boundaries.
c * If the polygon is connected and simply-connected, the usual case,
c * then ev(1) = nv on output, and ev(i) = 0 for i >= 2.
c * If the polygon is not connected and simply-connected,
c * then the number of non-zero elements of ev will equal the number
c * of distinct connected boundaries of the polygon.
c *
c  Input: nvmax = guess at maximum nv;
c                 must be >= np;
c                 recommend:
c               = np        if 0 <= np <= 2
c               = np*(np-1) if 2 <= np <= 4
c               = 6*(np-2)  if np >= 4
c         rp(3,i),i=1,np
c         cm(i),i=1,np
c         np
c         rpi(3) = unit vector.
c         vcirc = 1 to return nearest and farthest points also for
c                 non-intersecting boundary circles.
c               = 0 otherwise.
c Output: vmin(3,i),vmax(3,i),i=1,nv are unit vectors which are the
c            nearest and farthest points on each edge from rpi.
c         cmvmin, cmvmax = 1 - cos th between nearest and farthest
c                points vmin, vmax on each edge from rpi.
c         cmpmin, cmpmax = 1 - cos th between nearest and farthest
c                points on each circle from rpi.
c         ipv(iv),iv=1,nv is the circle number of the iv'th edge,
c                  that is,points ve(*,ive,iv) lie on circle number ipv.
c         gp(i),i=1,np = which group circle i belongs to:
c                circle i and circle j are friends if they intersect,
c                and friends of friends are friends.
c         ev(i) = end index of each connected sequence of edges;
c                 the number of non-zero elements of ev is the number
c                 nev of connected boundaries of the polygon,
c                 and the last nev0 of these are non-intersecting.
c         nv = number of points;
c              if this exceeds nvmax, then you should call gvlim again
c              with a larger nvmax.
c         nev = number of connected sequences of vertices,
c               including those in non-intersecting circles.
c         nev0 = number of non-intersecting boundary circles if vcirc=1;
c              = 0 if vcirc=0;
c                non-intersecting boundaries come last in ve,
c                and the last nev0 entries of ev(i) refer
c                to non-intersecting boundaries.
c         ldegen = .true. means there's a problem with multiply
c                  intersecting boundary.
c Input/Output: tol
c Work arrays: phi and iord should be dimensioned at least 2*np.
c              iwk should be dimensioned at least 4*nvmax.
c              wk should be dimensioned at least nvmax.
c
c     data dphmin /1.e-8_10/
      data big /1.e6_10/
c
c        input tolerance to multiple intersections
      tolin=tol
c        come here with modified tolerance
  100 continue
c        initialise error flag to no error
      ldegen=.false.
C     warn=.false.
c        zero number of vertices
      nv=0
      nev=0
      nev0=0
c        initialise ev to zero
      do iv=1,nvmax
        ev(iv)=0
      enddo
c        initially each circle is its own group
      do i=1,np
        gp(i)=i
      enddo
c        check for zero area because one circle is null
      if (gzeroar(cm,np).eq.0) goto 410
c        error check on evaluation of vertex terms
      ikchk=0._10
c        initialise iwk to inadmissible value
      do iv=1,nvmax
        iwk(iv,2)=-1
      enddo
      do iv=1,nvmax
        iwk(iv,3)=-1
      enddo
c--------identify boundary segments around each circle i in turn
      do 280 i=1,np
c        cm(i).ge.2 means include whole sphere, which is no constraint
        if (cm(i).ge.2._10) then
          cmpmin(i)=2._10
          cmpmax(i)=0._10
          goto 280
        endif
c        scmi * cmi = 1-cos th(i)
        if (cm(i).ge.0._10) then
          scmi=1
        else
          scmi=-1
        endif
        cmi=abs(cm(i))
c        si = sin th(i)
        si=sqrt(cmi*(2._10-cmi))
c        cmik = 1-cos th(ik), th(ik)=angle twixt rpi & rp(i)
        cmik=cmijf(rpi,rp(1,i))
c        sik = sin th(ik)
        sik=sqrt(cmik*(2._10-cmik))
c........minimum and maximum cm on circle
        cmpmin(i)=cmi+cmik-cmi*cmik-si*sik
        cmpmax(i)=cmi+cmik-cmi*cmik+si*sik
c........cartesian axes with z-axis along rp(i)
        call gaxisi(rp(1,i),xi,yi)
c........azimuthal angle closest to vector rpi
        xv=xi(1)*rpi(1)+xi(2)*rpi(2)+xi(3)*rpi(3)
        yv=yi(1)*rpi(1)+yi(2)*rpi(2)+yi(3)*rpi(3)
        phin=atan2(yv,xv)
        if (phin.ge.0._10) then
          phif=phin-PI
        else
          phif=phin+PI
        endif
c........angles phi about z-axis rp(i) of intersection of i & j circles
        call gphij(rp,cm,np,i,rp(1,i),scmi,cmi,xi,yi,big,tol,ni,phi)
c        i circle lies outside polygon
        if (ni.eq.-1) goto 280
c        area of polygon is zero
        if (ni.eq.-2) then
          nv=0
          nev=0
          nev0=0
          goto 410
        endif
c........i circle has no intersections
        if (ni.eq.0) then
c        want near and far points for non-intersecting boundary circles
          if (vcirc.eq.1) then
c        introduce pretend circle 0
            do j=1,2
              if (j.eq.1) then
                ii=0
                km=i
                kp=i
                phm=0._10
                php=PI
              elseif (j.eq.2) then
                ii=i
                km=0
                kp=0
                phm=PI
                php=TWOPI
              endif
              ph=(phm+php)/2._10
              dph=php-phm
              nv=nv+1
              if (nv.le.nvmax) then
c        edge index of this vertex
                ipv(nv)=i
c        phase phin to central point ph
                iphi=nint((phin-ph)/TWOPI)
                phin=phin-iphi*TWOPI
                if (phm.le.phin.and.phin.le.php) then
                  phmin=0._10
                elseif (phm.gt.phin) then
                  phmin=phm-phin
                elseif (phin.gt.php) then
                  phmin=php-phin
                endif
c        phase phif to central point ph
                iphi=nint((phif-ph)/TWOPI)
                phif=phif-iphi*TWOPI
                if (phm.le.phif.and.phif.le.php) then
                  phmax=0._10
                elseif (phm.gt.phif) then
                  phmax=phm-phif
                elseif (phif.gt.php) then
                  phmax=php-phif
                endif
c        nearest point on edge
                xv=si*cos(phmin+phin)
                yv=si*sin(phmin+phin)
                zv=1._10-cmi
                vmin(1,nv)=zv*rp(1,i)+xv*xi(1)+yv*yi(1)
                vmin(2,nv)=zv*rp(2,i)+xv*xi(2)+yv*yi(2)
                vmin(3,nv)=zv*rp(3,i)+xv*xi(3)+yv*yi(3)
c        farthest point on edge
                xv=si*cos(phmax+phif)
                yv=si*sin(phmax+phif)
                zv=1._10-cmi
                vmax(1,nv)=zv*rp(1,i)+xv*xi(1)+yv*yi(1)
                vmax(2,nv)=zv*rp(2,i)+xv*xi(2)+yv*yi(2)
                vmax(3,nv)=zv*rp(3,i)+xv*xi(3)+yv*yi(3)
c        minimum, maximum cm
                cmvmin(nv)=cmijf(rpi,vmin(1,nv))
                cmvmax(nv)=cmijf(rpi,vmax(1,nv))
              endif
c        record endpoints of edge
              call gvtrail(scmi,np,ii,km,kp,iwk,iwk(1,2),nvmax,nv,
     *          ik,ikchk)
            enddo
            nev0=nev0+1
          endif
c........i circle has intersections
        elseif (ni.gt.0) then
c........friends of i circle
          call ggpij(np,gp,i,big,phi)
c........find ordering of intersection angles around i circle
          call findbot(phi,2*np,iord,ni)
c........vertices around i circle
          jpl=0
c        come here to do another segment
  220     continue
c........is segment edge of polygon?
            iseg=gsegij(rp,cm,np,0,0,i,rp(1,i),scmi,cmi,tol,ni,
     *        phi,iord,jml,jmu,jpl,jpu,1,jm,jp,km,kp,phm,php,ph,dph)
c        error
            if (iseg.eq.-1) goto 420
c        not an edge
            if (iseg.eq.0) goto 220
c        gone full circle
            if (iseg.eq.2) goto 280
c........segment is edge
c        warn about near multiple intersection
c           if (dph.lt.dphmin) then
c             print *,'*** warning from gvlim: near multiple intersectio
c    *n at',i,': edge',km,kp,' dph=',real(dph)
c             warn=.true.
c           endif
c           print *,'at',i,': edge',km,kp,
c    *        ' (',jm,' in',jml,jmu,',',jp,' in',jpl,jpu,' of',ni,')',
c    *        ' ph=',real(ph),' dph=',real(dph)
            nv=nv+1
            if (nv.le.nvmax) then
c        edge index of this vertex
              ipv(nv)=i
c        phase phin to central point ph
              iphi=nint((phin-ph)/TWOPI)
              phin=phin-iphi*TWOPI
              if (phm.le.phin.and.phin.le.php) then
                phmin=0._10
              elseif (phm.gt.phin) then
                phmin=phm-phin
              elseif (phin.gt.php) then
                phmin=php-phin
              endif
c        phase phif to central point ph
              iphi=nint((phif-ph)/TWOPI)
              phif=phif-iphi*TWOPI
              if (phm.le.phif.and.phif.le.php) then
                phmax=0._10
              elseif (phm.gt.phif) then
                phmax=phm-phif
              elseif (phif.gt.php) then
                phmax=php-phif
              endif
c        nearest point on edge
              xv=si*cos(phmin+phin)
              yv=si*sin(phmin+phin)
              zv=1._10-cmi
              vmin(1,nv)=zv*rp(1,i)+xv*xi(1)+yv*yi(1)
              vmin(2,nv)=zv*rp(2,i)+xv*xi(2)+yv*yi(2)
              vmin(3,nv)=zv*rp(3,i)+xv*xi(3)+yv*yi(3)
c        farthest point on edge
              xv=si*cos(phmax+phif)
              yv=si*sin(phmax+phif)
              zv=1._10-cmi
              vmax(1,nv)=zv*rp(1,i)+xv*xi(1)+yv*yi(1)
              vmax(2,nv)=zv*rp(2,i)+xv*xi(2)+yv*yi(2)
              vmax(3,nv)=zv*rp(3,i)+xv*xi(3)+yv*yi(3)
c        minimum, maximum cm
              cmvmin(nv)=cmijf(rpi,vmin(1,nv))
              cmvmax(nv)=cmijf(rpi,vmax(1,nv))
            endif
c        record endpoints of edge
            call gvtrail(scmi,np,i,km,kp,iwk,iwk(1,2),nvmax,nv,ik,ikchk)
c        do another segment
          goto 220
        endif
  280 continue
c--------check on whether ik endpoints matched ki endpoints
      if (ikchk.ne.0._10) then
c       print *,'*** from gvlim: ikchk=',ikchk,' should be 0'
C       warn=.true.
        call gtol(tol,tolin)
        goto 100
      endif
c--------order vertices right-handedly about polygon
      if (nv.gt.0.and.nv.le.nvmax) then
c........which group of friends each circle belongs to
        call ggp(np,gp)
c........find order of vertices around polygon
        call gvord(np,nv,ipv,gp,ev,nev,iwk,iwk(1,2),iwk(1,3),iwk(1,4))
c........reorder vertices
        call vpermi(ipv,nv,iwk(1,2),iwk(1,3))
        call vpermdd(vmin,3,nv,iwk(1,2),wk)
        call vpermdd(vmax,3,nv,iwk(1,2),wk)
        call vpermd(cmvmin,nv,iwk(1,2),wk)
        call vpermd(cmvmax,nv,iwk(1,2),wk)
      endif
c--------done
 410  continue
C     if (warn) then
C       write (*,'(a3,a20,4a24)')
C    *    ' ','x','y','z',
c    *    'r',
C    *    '1-c'
C       do j=1,np
C         write (*,'(i3,5g24.16)')
C    *      j,(rp(i,j),i=1,3),
c    *      sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
C    *      cm(j)
C       enddo
C     endif
c     if (nv.gt.nvmax) then
c       print *,'*** from gvlim: number of vertices =',nv,
c    *    ' exceeds maximum',nvmax
c     endif
      return
c
  420 print *,'*** from gvlim: total failure at tol =',tol
      write (*,'(a3,a20,4a24)')
     *  ' ','x','y','z',
c    *  'r',
     *  '1-c'
      do j=1,np
        write (*,'(i3,5g24.16)')
     *    j,(rp(i,j),i=1,3),
c    *    sqrt(rp(1,j)**2+rp(2,j)**2+rp(3,j)**2),
     *    cm(j)
      enddo
      ldegen=.true.
      return
c
      end
c

!Module of generally useful routines and definitions
!Antony Lewis, http://cosmologist.info/

!April 2006: fix to TList_RealArr_Thin
!March 2008: fix to Ranges
!June 2010: fixed bug in  DeleteFile gradually using up file units

 module Ranges
 !A collection of ranges, consisting of sections of minimum step size
  implicit none

  integer, parameter :: Max_Ranges = 100
  double precision, parameter :: RangeTol = 0.1d0 
    !fraction of bin width we are prepared for merged bin widths to increase by

  Type Region
    integer start_index
    integer steps
    logical :: IsLog
    double precision Low, High
    double precision delta
    double precision delta_max, delta_min !for log spacing, the non-log max and min step size
  end Type Region

  Type Regions
    
     integer count
     integer npoints
     double precision Lowest, Highest
     Type(Region) :: R(Max_ranges)
     logical :: has_dpoints
     double precision, dimension(:), pointer :: points, dpoints
       !dpoints is (points(i+1)-points(i-1))/2
 
  end Type Regions

 contains
  
   subroutine Ranges_Init(R)
    Type(Regions) R

     call Ranges_Free(R)
    
   end  subroutine Ranges_Init

   subroutine Ranges_Free(R)
    Type(Regions) R
    integer status     

     deallocate(R%points,stat = status)
     deallocate(R%dpoints,stat = status)
     call Ranges_Nullify(R)
    
   end  subroutine Ranges_Free

    
  subroutine Ranges_Nullify(R)
   Type(Regions) R
  
     nullify(R%points)
     nullify(R%dpoints)
     R%count = 0
     R%npoints = 0
     R%has_dpoints = .false.
   

  end subroutine Ranges_Nullify

  subroutine Ranges_Assign(R,Rin)
   Type(Regions) R, Rin

    call Ranges_Init(R)
    R = Rin
    nullify(R%points,R%dpoints)
    if (associated(Rin%points)) then
      call Ranges_GetArray(R, associated(Rin%dpoints))
    end if
  
  end subroutine Ranges_Assign

   function Ranges_IndexOf(Reg, tau) result(pointstep)
      Type(Regions), intent(in), target :: Reg
      Type(Region), pointer :: AReg
      double precision :: tau
      integer pointstep
      integer i

      
      pointstep=0
      do i=1,Reg%count
          AReg => Reg%R(i)

          if (tau < AReg%High .and. tau >= AReg%Low) then
             if (AReg%IsLog) then
              pointstep = AReg%start_index + int( log(tau/AReg%Low)/AReg%delta)
              else
              pointstep = AReg%start_index + int(( tau - AReg%Low)/AReg%delta)
             end if
             return
          end if

      end do

      if (tau >= Reg%Highest) then
         pointstep = Reg%npoints
      else
       write (*,*) 'Ranges_IndexOf: value out of range'
       stop 
      end if

   end function Ranges_IndexOf

     
   subroutine Ranges_GetArray(Reg, want_dpoints)
     Type(Regions), target :: Reg
     Type(Region), pointer :: AReg
     logical, intent(in), optional :: want_dpoints 
     integer status,i,j,ix     
     

     if (present(want_dpoints)) then
      Reg%has_dpoints = want_dpoints
     else
      Reg%has_dpoints = .true.
     end if

     deallocate(Reg%points,stat = status)
     allocate(Reg%points(Reg%npoints)) 

     ix=0   
     do i=1, Reg%count
       AReg => Reg%R(i)
       do j = 0, AReg%steps-1
        ix=ix+1
        if (AReg%IsLog) then
         Reg%points(ix) = AReg%Low*exp(j*AReg%delta)
        else
         Reg%points(ix) = AReg%Low + AReg%delta*j
        end if
       end do
     end do
     ix =ix+1
     Reg%points(ix) = Reg%Highest
     if (ix /= Reg%npoints) stop 'Ranges_GetArray: ERROR'

     if (Reg%has_dpoints) call Ranges_Getdpoints(Reg)

   end subroutine Ranges_GetArray


   subroutine Ranges_Getdpoints(Reg, half_ends)
      Type(Regions), target :: Reg
      logical, intent(in), optional :: half_ends
      integer i, status
      logical halfs

      if (present(half_ends)) then
        halfs = half_ends
      else
        halfs = .true.
      end if
       
      deallocate(Reg%dpoints,stat = status)
      allocate(Reg%dpoints(Reg%npoints)) 

      do i=2, Reg%npoints-1
        Reg%dpoints(i) = (Reg%points(i+1) - Reg%points(i-1))/2
      end do
      if (halfs) then
       Reg%dpoints(1) = (Reg%points(2) - Reg%points(1))/2
       Reg%dpoints(Reg%npoints) = (Reg%points(Reg%npoints) - Reg%points(Reg%npoints-1))/2
      else
       Reg%dpoints(1) = (Reg%points(2) - Reg%points(1))
       Reg%dpoints(Reg%npoints) = (Reg%points(Reg%npoints) - Reg%points(Reg%npoints-1))
     end if
   end subroutine Ranges_Getdpoints


   subroutine Ranges_Add_delta(Reg, t_start, t_end, t_approx_delta, IsLog)
     Type(Regions), target :: Reg
     logical, intent(in), optional :: IsLog
     double precision, intent(in) :: t_start, t_end, t_approx_delta
     integer n
     logical :: WantLog

     if (present(IsLog)) then
        WantLog = IsLog      
     else
        WantLog = .false.    
     end if
     
     if (t_end <= t_start) & 
       stop 'Ranges_Add_delta: end must be larger than start'
     if (t_approx_delta <=0) stop 'Ranges_Add_delta: delta must be > 0'

     if (WantLog) then
      n  = max(1,int(log(t_end/t_start)/t_approx_delta + 1.d0 - RangeTol))
     else
      n  = max(1,int((t_end-t_start)/t_approx_delta + 1.d0 - RangeTol))
     end if
     call Ranges_Add(Reg,t_start, t_end, n, WantLog)
       
   end subroutine Ranges_Add_delta


   subroutine Ranges_Add(Reg, t_start, t_end, nstep, IsLog)
     Type(Regions), target :: Reg
     logical, intent(in), optional :: IsLog
     double precision, intent(in) :: t_start, t_end
     integer, intent(in) :: nstep
     Type(Region), pointer :: AReg, LastReg
     Type(Region), target :: NewRegions(Max_Ranges)
     double precision EndPoints(0:Max_Ranges*2)
     integer ixin, nreg, ix, i,j, nsteps
     double precision delta
     logical WantLog
     double precision min_request, max_request, min_log_step, max_log_step, diff, max_delta
     double precision RequestDelta(Max_Ranges)

     if (present(IsLog)) then
      WantLog = IsLog
     else
      WantLog = .false.
     end if

     if (WantLog) then
      delta = log(t_end/t_start) / nstep
     else
      delta = (t_end - t_start) / nstep
     end if

     if (t_end <= t_start) stop 'Ranges_Add: end must be larger than start'
     if (nstep <=0) stop 'Ranges_Add: nstep must be > 0'
     if (Reg%Count>= Max_Ranges) stop 'Ranges_Add: Increase Max_Ranges'

!avoid IBM compiler bug, from Angel de Vicente
!    if (Reg%count > 0) NewRegions(1:Reg%count) = Reg%R(1:Reg%count)
     if (Reg%count > 0) THEN
         DO i=1,Reg%count
         NewRegions(i) = Reg%R(i)
         END DO
     END IF
     nreg = Reg%count + 1
     AReg=> NewRegions(nreg)
     AReg%Low = t_start
     AReg%High = t_end
     AReg%delta = delta
     AReg%steps = nstep
     AReg%IsLog = WantLog 

!Get end point in order
     ix = 0
     do i=1, nreg

       AReg => NewRegions(i)
       if (ix==0) then
          ix = 1
          EndPoints(ix) = AReg%Low
          ix = 2
          EndPoints(ix) = AReg%High
       else
        ixin = ix
        do j=1,ixin
         if (AReg%Low < EndPoints(j)) then
           EndPoints(j+1:ix+1) = EndPoints(j:ix)
           EndPoints(j) = AReg%Low
           ix=ix+1
           exit
         end if
        end do
        if (ixin == ix) then
          ix = ix+1
          EndPoints(ix) = AReg%Low
          ix = ix+1
          EndPoints(ix) = AReg%High
        else
            ixin = ix
            do j=1,ixin
             if (AReg%High < EndPoints(j)) then
               EndPoints(j+1:ix+1) = EndPoints(j:ix)
               EndPoints(j) = AReg%High
               ix=ix+1
               exit
             end if
            end do
            if (ixin == ix) then
              ix = ix+1
              EndPoints(ix) = AReg%High
            end if
                  
        end if
       end if

     end do

!remove duplicate points
     ixin = ix
     ix = 1
     do i=2, ixin
       if (EndPoints(i) /= EndPoints(ix)) then
        ix=ix+1
        EndPoints(ix) = EndPoints(i)
       end if
     end do
    

!ix is the number of end points
     Reg%Lowest = EndPoints(1)
     Reg%Highest = EndPoints(ix)
     Reg%count = 0

     max_delta = Reg%Highest - Reg%Lowest

     do i=1, ix - 1
          AReg => Reg%R(i)
          AReg%Low = EndPoints(i)
          AReg%High = EndPoints(i+1)
          
!          max_delta = EndPoints(i+1) - EndPoints(i)
          delta = max_delta
          AReg%IsLog = .false.

          do j=1, nreg
           if (AReg%Low >= NewRegions(j)%Low .and. Areg%Low < NewRegions(j)%High) then
             if (NewRegions(j)%IsLog) then
                if (AReg%IsLog) then
                 delta = min(delta,NewRegions(j)%delta) 
                else
                 min_log_step = AReg%Low*(exp(NewRegions(j)%delta)-1)
                 if (min_log_step < delta) then
                   max_log_step = AReg%High*(1-exp(-NewRegions(j)%delta)) 
                   if  (delta < max_log_step) then
                     delta = min_log_step
                   else
                     AReg%IsLog = .true.
                     delta = NewRegions(j)%delta 
                   end if 
                 end if
                end if
             else !NewRegion is not log
              if (AReg%IsLog) then
                max_log_step = AReg%High*(1-exp(-delta)) 
                if (NewRegions(j)%delta < max_log_step) then
                  min_log_step = AReg%Low*(exp(delta)-1)
                  if (min_log_step <  NewRegions(j)%delta) then
                     AReg%IsLog = .false.
                     delta =  min_log_step
                  else
                     delta = - log(1- NewRegions(j)%delta/AReg%High)
                  end if
                end if
              else
               delta = min(delta, NewRegions(j)%delta)  
              end if
             end if
           end if
          end do

         if (AReg%IsLog) then
           Diff = log(AReg%High/AReg%Low)
         else
           Diff = AReg%High - AReg%Low
         endif
         if (delta >= Diff) then
           AReg%delta = Diff
           AReg%steps = 1
         else    
           AReg%steps  = max(1,int(Diff/delta + 1.d0 - RangeTol))
           AReg%delta = Diff / AReg%steps
         end if

         Reg%count = Reg%count + 1
         RequestDelta(Reg%Count) = delta

         if (AReg%IsLog) then
          if (AReg%steps ==1) then
           AReg%Delta_min = AReg%High - AReg%Low
           AReg%Delta_max = AReg%Delta_min
          else
           AReg%Delta_min = AReg%Low*(exp(AReg%delta)-1)
           AReg%Delta_max = AReg%High*(1-exp(-AReg%delta))
          end if
         else
           AReg%Delta_max = AReg%delta
           AReg%Delta_min = AReg%delta
         end if
     end do


!Get rid of tiny regions
     ix = Reg%Count
     do i=ix, 1, -1  
         AReg => Reg%R(i)
         if (AReg%steps ==1) then
              Diff = AReg%High - AReg%Low
              if (AReg%IsLog) then
               min_request = AReg%Low*(exp(RequestDelta(i))-1)
               max_request = AReg%High*(1-exp(-RequestDelta(i)))
              else
               min_request = RequestDelta(i)
               max_request = min_request
              end if
              if (i/= Reg%Count) then  !from i/= ix Mar08
               LastReg => Reg%R(i+1)
               if (RequestDelta(i) >= AReg%delta .and. Diff <= LastReg%Delta_min &
                          .and. LastReg%Delta_min <= max_request) then 

                   LastReg%Low = AReg%Low
                   if (Diff > LastReg%Delta_min*RangeTol) then
                      LastReg%steps =  LastReg%steps + 1
                   end if
                   if (LastReg%IsLog) then
                      LastReg%delta = log(LastReg%High/LastReg%Low) / LastReg%steps 
                   else
                      LastReg%delta = (LastReg%High -LastReg%Low) / LastReg%steps 
                   end if
                   Reg%R(i:Reg%Count-1) = Reg%R(i+1:Reg%Count)
                   Reg%Count = Reg%Count -1
                   cycle
               end if          
              end if
              if (i/=1) then
               LastReg => Reg%R(i-1)
               if (RequestDelta(i) >= AReg%delta .and. Diff <= LastReg%Delta_max &
                          .and. LastReg%Delta_max <= min_request) then
                   LastReg%High = AReg%High
                   !AlMat08 LastReg%Low = AReg%Low
                   if (Diff > LastReg%Delta_max*RangeTol) then
                      LastReg%steps =  LastReg%steps + 1
                   end if
                   if (LastReg%IsLog) then
                      LastReg%delta = log(LastReg%High/LastReg%Low) / LastReg%steps 
                   else
                      LastReg%delta = (LastReg%High -LastReg%Low) / LastReg%steps 
                   end if
                   Reg%R(i:Reg%Count-1) = Reg%R(i+1:Reg%Count)
                   Reg%Count = Reg%Count -1
               end if
              end if           
         end if       
     end do


!Set up start indices and get total number of steps
    nsteps = 1
    do i = 1, Reg%Count
         AReg => Reg%R(i)
         AReg%Start_index = nsteps
         nsteps = nsteps + AReg%steps
         if (AReg%IsLog) then
          if (AReg%steps ==1) then
           AReg%Delta_min = AReg%High - AReg%Low
           AReg%Delta_max = AReg%Delta_min
          else
           AReg%Delta_min = AReg%Low*(exp(AReg%delta)-1)
           AReg%Delta_max = AReg%High*(1-exp(-AReg%delta))
          end if
         else
           AReg%Delta_max = AReg%delta
           AReg%Delta_min = AReg%delta
         end if
    end do

    Reg%npoints = nsteps

   end subroutine Ranges_Add


   subroutine Ranges_Write(Reg) 
      Type(Regions), intent(in), target :: Reg
      Type(Region), pointer :: AReg
      integer i

      do i=1,Reg%count
          AReg => Reg%R(i)
          if (AReg%IsLog) then
           Write (*,'("Range ",I3,":", 3E14.4," log")') i, AReg%Low, AReg%High, AReg%delta 
          else
           Write (*,'("Range ",I3,":", 3E14.4," linear")') i, AReg%Low, AReg%High, AReg%delta 
          end if
      end do
   end subroutine Ranges_Write


 end module Ranges


 module Lists
  !Currently implements lists of strings and lists of arrays of reals
  implicit none

  type real_pointer
    real, dimension(:), pointer :: p 
  end type real_pointer

  type double_pointer
    double precision, dimension(:), pointer :: p 
  end type double_pointer

  type String_pointer
    character, dimension(:), pointer :: p
  end type String_pointer


  Type TList_RealArr
    integer Count
    integer Delta
    integer Capacity
    type(Real_Pointer), dimension(:), pointer :: Items 
  end Type TList_RealArr

  Type TStringList
    integer Count
    integer Delta
    integer Capacity 
    type(String_Pointer), dimension(:), pointer :: Items
  end Type TStringList

 contains
 
   subroutine TList_RealArr_Init(L)
    Type (TList_RealArr) :: L
    
     L%Count = 0
     L%Capacity = 0
     L%Delta = 1024
     nullify(L%items)

   end subroutine TList_RealArr_Init

   subroutine TList_RealArr_Clear(L)
    Type (TList_RealArr) :: L
    integer i, status
     
     do i=L%Count,1,-1 
       deallocate (L%Items(i)%P, stat = status)
     end do
    deallocate (L%Items, stat = status)
    nullify(L%Items)
    L%Count = 0
    L%Capacity = 0

   end subroutine TList_RealArr_Clear

    
   subroutine TList_RealArr_Add(L, P)
    Type (TList_RealArr) :: L
    real, intent(in) :: P(:)
    integer s
  
    if (L%Count == L%Capacity) call TList_RealArr_SetCapacity(L, L%Capacity + L%Delta)
    s = size(P)
    L%Count = L%Count + 1
    allocate(L%Items(L%Count)%P(s))
    L%Items(L%Count)%P = P

   end subroutine TList_RealArr_Add

   subroutine TList_RealArr_SetCapacity(L, C)
    Type (TList_RealArr) :: L
    integer C
    type(Real_Pointer), dimension(:), pointer :: TmpItems
    
    if (L%Count > 0) then
      if (C < L%Count) stop 'TList_RealArr_SetCapacity: smaller than Count'
      allocate(TmpItems(L%Count))
      TmpItems = L%Items(1:L%Count)
      deallocate(L%Items)
      allocate(L%Items(C))
      L%Items(1:L%Count) = TmpItems
      deallocate(TmpItems)
    else
     allocate(L%Items(C))
    end if  
    L%Capacity = C
   end subroutine TList_RealArr_SetCapacity

   subroutine TList_RealArr_Delete(L, i)
    Type (TList_RealArr) :: L
    integer, intent(in) :: i
    integer status
     
     deallocate(L%items(i)%P, stat = status)
     if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
     L%Count = L%Count -1
     
   end subroutine TList_RealArr_Delete

   subroutine TList_RealArr_SaveBinary(L,fid)
    Type (TList_RealArr) :: L
    integer, intent(in) :: fid
    integer i
     
      write (fid) L%Count
      do i=1,L%Count
       write(fid) size(L%Items(i)%P)
       write(fid) L%Items(i)%P
      end do

   end subroutine TList_RealArr_SaveBinary

   subroutine TList_RealArr_ReadBinary(L,fid)
    Type (TList_RealArr) :: L
    integer, intent(in) :: fid
    integer num,i,sz
     
      call TList_RealArr_Clear(L) 
      read (fid) num
      call TList_RealArr_SetCapacity(L, num)
      do i=1,num
       read(fid) sz
       allocate(L%Items(i)%P(sz))
       read(fid) L%Items(i)%P
      end do
      L%Count = num

   end subroutine TList_RealArr_ReadBinary


   subroutine TList_RealArr_Thin(L, i)
    Type (TList_RealArr) :: L
    integer, intent(in) :: i
    integer newCount
    type(Real_Pointer), dimension(:), pointer :: TmpItems
    
    if (L%Count > 1) then
      newCount = (L%Count-1)/i+1
      allocate(TmpItems(newCount))
      TmpItems = L%Items(1:L%Count:i)
      deallocate(L%Items)
      L%Capacity = newCount
      allocate(L%Items(L%Capacity))
      L%Items = TmpItems
      L%Count = newCount
      deallocate(TmpItems)
    end if    
   end subroutine TList_RealArr_Thin

   subroutine TList_RealArr_ConfidVal(L, ix, limfrac, ix1, ix2, Lower, Upper)
   !Taking the ix'th entry in each array to be a sample, value for which
   !limfrac of the items between ix1 and ix2 (inc) are above or below
   !e.g. if limfrac = 0.05 get two tail 90% confidence limits
     Type (TList_RealArr) :: L
     integer, intent(IN) :: ix
     real, intent(IN) :: limfrac
     real, intent(OUT), optional :: Lower, Upper
     integer, intent(IN), optional :: ix1,ix2
     integer b,t,samps
     real pos, d
     type(Real_Pointer), dimension(:), pointer :: SortItems
    
     b=1
     t=L%Count
     if (present(ix1)) b = ix1
     if (present(ix2)) t = ix2
     samps = t - b + 1
  
     allocate(SortItems(samps))
     SortItems = L%Items(b:t)
     call QuickSortArr_Real(SortItems, 1, samps, ix)
     if (present(Lower)) then
       pos = (samps-1)*limfrac + 1 
       b = max(int(pos),1)
       Lower = SortItems(b)%P(ix)
      if (b < samps .and. pos>b) then
       d = pos - b
       Lower = Lower*(1 - d) + d * SortItems(b+1)%P(ix) 
      end if
     end if
     if (present(Upper)) then
      pos = (samps-1)*(1.-limfrac) + 1
      b = max(int(pos),1)
      Upper = SortItems(b)%P(ix)
      if (b < samps .and. pos>b) then
       d = pos - b
       Upper = Upper*(1 - d) + d * SortItems(b+1)%P(ix) 
      end if
     end if
   
     deallocate(SortItems)

    end subroutine TList_RealArr_ConfidVal

   subroutine TStringList_Init(L)
    Type (TStringList) :: L
    
     L%Count = 0
     L%Capacity = 0
     L%Delta = 128
     nullify(L%items)
     
   end subroutine TStringList_Init

   subroutine TStringList_Clear(L)
    Type (TStringList) :: L
    integer i, status
     
     do i=L%Count,1,-1 
       deallocate (L%Items(i)%P, stat = status)
     end do
    deallocate (L%Items, stat = status)
    call TStringList_Init(L)

   end subroutine TStringList_Clear

   subroutine TStringList_SetFromString(L, S, valid_chars_in)
    Type (TStringList) :: L
    character(Len=*), intent(in) :: S
    character(Len=*), intent(in), optional :: valid_chars_in
    character(LEN=1024) item
    integer i,j
    character(LEN=256) valid_chars
    
    if (present(valid_chars_in)) then
       valid_chars = valid_chars_in
    else
       valid_chars='abcdefghijklmopqrstuvwxyzABCDEFGHIJKLMOPQRSTUVWXYZ0123456789_-.'
    endif

     call TStringList_Clear(L)
     item ='' 
     j=0
     do i=1, len_trim(S)
        if (verify(S(i:i),trim(valid_chars)) == 0) then
          j=j+1
          item(j:j) = S(i:i)
        else
          if (trim(S(i:i))/='') then
           write (*,*) 'Invalid character in: '//trim(S)
          end if 
          if (j>0) call TStringList_Add(L, item(1:j))
          j=0
        end if          
     end do
     if (j>0) call TStringList_Add(L, item(1:j))
   
   end subroutine TStringList_SetFromString


    
   subroutine TStringList_Add(L, P)
    Type (TStringList) :: L
    character(LEN=*), intent(in) :: P
    integer s,i
  
    if (L%Count == L%Capacity) call TStringList_SetCapacity(L, L%Capacity + L%Delta)
    s = len_trim(P)
    L%Count = L%Count + 1
    allocate(L%Items(L%Count)%P(s))
    do i=1,s
    L%Items(L%Count)%P(i) = P(i:i)
    end do
   end subroutine TStringList_Add

   function TStringList_Item(L, i) result(S)
    Type (TStringList) :: L
    integer, intent(in) :: i
    integer j
    character(LEN=1024) S

    S=''
    if (i<=L%Count .and. i>0) then
     do j=1,size(L%Items(i)%P)
       S(j:j)=L%Items(i)%P(j)       
     end do
    end if
   end function TStringList_Item

   subroutine TStringList_SetCapacity(L, C)
    Type (TStringList) :: L
    integer C
    type(String_Pointer), dimension(:), pointer :: TmpItems
    
    if (L%Count > 0) then
      if (C < L%Count) stop 'TStringList_SetCapacity: smaller than Count'
      allocate(TmpItems(L%Count))
      TmpItems = L%Items(1:L%Count)
      deallocate(L%Items)
      allocate(L%Items(C))
      L%Items(1:L%Count) = TmpItems
      deallocate(TmpItems)
    else
     allocate(L%Items(C))
    end if  
    L%Capacity = C
  
   end subroutine TStringList_SetCapacity

   subroutine TStringList_Delete(L, i)
    Type (TStringList) :: L
    integer, intent(in) :: i
    integer status
     
     deallocate(L%items(i)%P, stat = status)
     if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
     L%Count = L%Count -1
     
   end subroutine TStringList_Delete

   function TStringList_IndexOf(L, S)
    Type (TStringList) :: L
    character(LEN=*), intent(in) :: S
    integer TStringList_IndexOf, i, j,slen

    slen = len_trim(S)
    do i=1,L%Count
     if ( size(L%Items(i)%P)==slen) then
 !Yes, comparing strings and pointer strings really is this horrible...
       j=1
       do while (L%Items(i)%P(j)==S(j:j)) 
          j=j+1
          if (j>slen) then
            TStringList_IndexOf = i
            return         
          end if
       end do
     end if
    end do
    TStringList_IndexOf=-1
     
   end function TStringList_IndexOf


      recursive subroutine QuickSortArr_Real(Arr, Lin, R, index)
      !Sorts an array of pointers to arrays of reals by the value of the index'th entry
      integer, intent(in) :: Lin, R, index
#ifdef __GFORTRAN__
      type(real_pointer), dimension(:) :: Arr
#else
      type(real_pointer), dimension(*) :: Arr
#endif
      integer I, J, L
      real P
      type(real_pointer) :: temp
  
      L = Lin
      do

      I = L
      J = R
      P = Arr((L + R)/2)%p(index)
   
      do
      do while (Arr(I)%p(index) <  P) 
         I = I + 1
      end do
    
      do while (Arr(J)%p(index) > P) 
         J = J - 1
      end do

      if (I <= J) then
     
       Temp%p => Arr(I)%p
       Arr(I)%p => Arr(J)%p
       Arr(J)%p => Temp%p
       I = I + 1
       J = J - 1
      end if
      if (I > J) exit
      
      end do
    if (L < J) call QuickSortArr_Real(Arr, L, J, index);
    L = I
    if (I >= R) exit
    end do

    end subroutine QuickSortArr_Real



    recursive subroutine QuickSortArr(Arr, Lin, R, index)
      !Sorts an array of pointers to arrays of reals by the value of the index'th entry
      integer, intent(in) :: Lin, R, index
#ifdef __GFORTRAN__
      type(double_pointer), dimension(:) :: Arr
#else
      type(double_pointer), dimension(*) :: Arr
#endif
      integer I, J, L
      double precision P
      type(double_pointer) :: temp
  
      L = Lin
      do

      I = L
      J = R
      P = Arr((L + R)/2)%p(index)
   
      do
      do while (Arr(I)%p(index) <  P) 
         I = I + 1
      end do
    
      do while (Arr(J)%p(index) > P) 
         J = J - 1
      end do

      if (I <= J) then
     
       Temp%p => Arr(I)%p
       Arr(I)%p => Arr(J)%p
       Arr(J)%p => Temp%p
       I = I + 1
       J = J - 1
      end if
      if (I > J) exit
      
      end do
    if (L < J) call QuickSortArr(Arr, L, J, index);
    L = I
    if (I >= R) exit
    end do

    end subroutine QuickSortArr


 end module Lists

  module AMLutils
  use Lists
       
#ifdef DECONLY
   !Comment out if linking to LAPACK/MKL separetly 
   !CXML only has LAPACK 2.0
    include 'CXML_INCLUDE.F90'
#endif
 

#ifdef NAGF95
        use F90_UNIX
#endif

     implicit none

#ifndef NAGF95
#ifndef GFC
#ifndef __INTEL_COMPILER_BUILD_DATE
#ifndef __GFORTRAN__
        integer iargc
        external iargc
#endif        
#endif
#endif
#endif


#ifdef MPI
    include "mpif.h"
#endif

  integer :: Feedback = 1
  integer, parameter :: tmp_file_unit = 50


  double precision, parameter :: pi=3.14159265358979323846264338328d0, &
      twopi=2*pi, fourpi=4*pi
  double precision, parameter :: root2 = 1.41421356237309504880168872421d0, sqrt2 = root2
  double precision, parameter :: log2 = 0.693147180559945309417232121458d0

  real, parameter :: pi_r = 3.141592653, twopi_r = 2*pi_r, fourpi_r = twopi_r*2

  logical :: flush_write = .true.
    !True means no data lost on crashes, but may make it slower
    
  integer, parameter :: file_units_start = 20
  integer, parameter :: file_units_end = 100
  
  logical file_units(file_units_start:file_units_end)

  INTERFACE CONCAT
    module procedure concat_s, concat_s_n
  END INTERFACE
  
  INTERFACE RealToStr
   module procedure SingleToStr, DoubleToStr
  END INTERFACE RealToStr

  contains

 function new_file_unit()
  integer i, new_file_unit
  logical, save :: file_units_inited = .false.
  logical notfree
 
  if (.not. file_units_inited) then
   file_units = .false.
   file_units_inited = .true.
  end if
 
  do i=file_units_start, file_units_end
   if (.not. file_units(i) .and. i/=tmp_file_unit) then
    inquire(i,opened=notfree)
    if (notfree) cycle
    file_units(i)=.true.
    new_file_unit = i
    return
   end if
  end do 
  
  call mpiStop('No unused file unit numbers')
  
 end function new_file_unit


 subroutine CloseFile(i)
  integer, intent(in) :: i
  
  close(i)
  file_units(i) = .false.
    
 end subroutine CloseFile 

 subroutine ClearFileUnit(i)
  integer, intent(in) :: i
  
  file_units(i) = .false.
    
 end subroutine ClearFileUnit

  function GetParamCount()
   integer GetParamCount
 
    GetParamCount = iargc() 

  end function GetParamCount

  function GetMpiRank()
  integer GetMpiRank
#ifdef MPI 
   integer ierror
   call mpi_comm_rank(mpi_comm_world,GetMPIrank,ierror)
#else
    GetMpiRank=0
#endif    
   
  end function GetMpiRank

  function IsMainMPI()
   logical IsMainMPI

   IsMainMPI =  GetMpiRank() == 0
   
  end function IsMainMPI

  subroutine MpiStop(Msg)
   character(LEN=*), intent(in), optional :: Msg
   integer i
#ifdef MPI 
   integer ierror, MpiRank
#endif

   if (present(Msg)) write(*,*) trim(Msg)
   
#ifdef MPI
    call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
    write (*,*) 'MpiStop: ', MpiRank
    call MPI_ABORT(MPI_COMM_WORLD,i)
#endif
    i=1     !put breakpoint on this line to debug
    stop
    
 end subroutine MpiStop
 
   subroutine MpiStat(MpiID, MpiSize)
   implicit none
   integer MpiID,MpiSize  
#ifdef MPI  
   integer ierror
        call mpi_comm_rank(mpi_comm_world,MpiID,ierror)
        if (ierror/=MPI_SUCCESS) stop 'MpiStat: MPI rank'
        call mpi_comm_size(mpi_comm_world,MpiSize,ierror)
#else
  MpiID=0
  MpiSize=1   
#endif
  end subroutine MpiStat
                  
  subroutine MpiQuietWait
  !Set MPI thread to sleep, e.g. so can run openmp on cpu instead
#ifdef MPI  
     integer flag, ierr, STATUS(MPI_STATUS_SIZE)
     integer i, MpiId, MpiSize
       
     call MpiStat(MpiID, MpiSize)
     if (MpiID/=0) then  
      do
       call MPI_IPROBE(0,0,MPI_COMM_WORLD,flag, MPI_STATUS_IGNORE,ierr)
       if (flag/=0) then
             call MPI_RECV(i,1,MPI_INTEGER, 0,0,MPI_COMM_WORLD,status,ierr)
             exit
       end if
       call sleep(1)
      end do
     end if 
#endif
  end subroutine
  
  subroutine MpiWakeQuietWait
#ifdef MPI  
    integer j, MpiId, MpiSize, ierr,r
       
     call MpiStat(MpiID, MpiSize)
     if (MpiID==0) then
     do j=1, MpiSize-1              
           call MPI_ISSEND(MpiId,1,MPI_INTEGER, j,0,MPI_COMM_WORLD,r,ierr)
     end do  
     end if
#endif
  end subroutine MpiWakeQuietWait
 
#ifdef __GFORTRAN__
  
  ! ===========================================================
  function iargc ()
    ! ===========================================================
    integer iargc
    ! ===========================================================
    
    iargc=command_argument_count()
  end function iargc
  
  ! ===========================================================
  subroutine getarg(num, res)
    ! ===========================================================
    integer, intent(in) :: num
    character(len=*), intent(out) :: res
    integer l, err
    ! ===========================================================
    call get_command_argument(num,res,l,err)
  end subroutine getarg
  
#endif


  function GetParam(i)

   character(LEN=512) GetParam
   integer, intent(in) :: i
 
   if (iargc() < i) then
     GetParam = ''
   else
    call getarg(i,GetParam)
   end if
  end function GetParam

  function concat_s(S1,S2,S3,S4,S5,S6,S7,S8) result(concat)
   character(LEN=*), intent(in) :: S1, S2
   character(LEN=*), intent(in) , optional :: S3, S4, S5, S6,S7,S8
   character(LEN = 1000) concat

   concat = trim(S1) // S2
   if (present(S3)) then
    concat = trim(concat) // S3
     if (present(S4)) then
       concat = trim(concat) // S4
       if (present(S5)) then
         concat = trim(concat) // S5
           if (present(S6)) then
             concat = trim(concat) // S6
              if (present(S7)) then
                concat = trim(concat) // S7
                if (present(S8)) then
                  concat = trim(concat) // S8
                end if
              end if    
           end if
       end if
     end if
   end if

  end function concat_s

 function concat_s_n(SS1,N2,SS3,N4,SS5,N6,SS7,N8,SS9,N10,SS11) result(concat)
   character(LEN=*), intent(in) :: SS1
   integer, intent(in) :: N2
   character(LEN=*), intent(in) , optional :: SS3, SS5, SS7, SS9,SS11
   integer, intent(in), optional ::N4,N6,N8, N10
   character(LEN = 1000) concat
   
   concat = trim(SS1) //trim(IntToStr(N2))
     if (present(SS3)) then
    concat = trim(concat) // SS3
     if (present(N4)) then
       concat = trim(concat) // trim(IntToStr(N4))
       if (present(SS5)) then
         concat = trim(concat) // SS5
           if (present(N6)) then
             concat = trim(concat) // trim(intToStr(N6))
             if (present(SS7)) then
             concat = trim(concat) // SS7
              if (present(N8)) then
               concat = trim(concat) // trim(intToStr(N8))
              if (present(SS9)) then
               concat = trim(concat) // SS9
                if (present(N10)) then
                concat = trim(concat) // trim(intToStr(N10))
                  if (present(SS11)) then
                   concat = trim(concat) // SS11
                  end if
                end if
              end if       
           end if
       end if
     end if
   end if
   end if
   end if
   
 end  function concat_s_n

  subroutine Exchange(i1,i2)
   integer i1,i2,tmp
 
   tmp=i1
   i1=i2
   i2=tmp

  end subroutine Exchange

  subroutine WriteS(S)
   character(LEN=*), intent(in) :: S

    write (*,*) trim(S)
 
  end subroutine WriteS

  subroutine StringReplace(FindS, RepS, S)
   character(LEN=*), intent(in) :: FindS, RepS
   character(LEN=*), intent(inout) :: S
   integer i
   
   i = index(S,FindS)
   if (i>0) then
     S = S(1:i-1)//trim(RepS)//S(i+len_trim(FindS):len_trim(S))
   end if

  end subroutine StringReplace

  function numcat(S, num)
   character(LEN=*) S
   character(LEN=1024) numcat, numstr
   integer num

   write (numstr, *) num
   numcat = trim(S) // trim(adjustl(numstr))
   !OK, so can probably do with with a format statement too... 
  end function numcat

  function LogicalToint(B)
   integer LogicalToint
   logical, intent(in) :: B
   
   if (B) then
    LogicalToInt=1
   else
    LogicalToint=0
   end if  
   
  end function LogicalToInt
 
  function IntToLogical(I)
   integer, intent(in) :: I
   logical IntToLogical
   
   IntToLogical = I /= 0
   
  end  function IntToLogical
 
  function IntToStr(I, minlen)
   integer , intent(in) :: I
   character(LEN=30) IntToStr
   integer, intent(in), optional :: minlen
   integer n
   character (LEN=20) :: form

   if (present(minlen)) then
    n = minlen
    if (I<0) n=n+1
    form = concat('(I',n,'.',minlen,')')
    write (IntToStr,form) i
   else
    write (IntToStr,*) i
    IntToStr = adjustl(IntToStr)
   end if

 
  end function IntToStr

  function StrToInt(S)
   integer :: StrToInt
   character(LEN=30), intent(in) :: S

   read (S,*) StrToInt
  end function StrToInt

   function DoubleToStr(R, figs)
      double precision, intent(in) :: R
      integer, intent(in), optional :: figs
      character(LEN=30) DoubleToStr
  
   DoubleToStr = SingleToStr(real(R),figs)
      
   end function DoubleToStr
   
   function SingleToStr(R, figs)
   real, intent(in) :: R
   integer, intent(in), optional :: figs
   character(LEN=30) SingleToStr

    if (abs(R)>=0.001 .or. R==0.) then
     write (SingleToStr,'(f12.6)') R

   SingleToStr = adjustl(SingleToStr)
   if (present(figs)) then
    SingleToStr = SingleToStr(1:figs)
   else
    SingleToStr = SingleToStr(1:6)  
   end if

    else
     if (present(figs)) then
      write (SingleToStr,trim(numcat('(E',figs))//'.2)') R
     else
      write (SingleToStr,'(G9.2)') R
     end if
     SingleToStr = adjustl(SingleToStr)
    end if

   end function SingleToStr
  
   subroutine WriteFormatInts(unit, formatst, i1,i2,i3,i4)
     integer, intent(in) :: unit
     character(LEN=*), intent(in) :: formatst
     integer, intent(in) :: i1
     integer, intent(in),optional :: i2,i3,i4
     character(LEN=1024*16) S
     
     S = formatst
     call StringReplace('%u', IntToStr(i1), S)
     if (present(i2)) call StringReplace('%u', IntToStr(i2), S)
     if (present(i3)) call StringReplace('%u', IntToStr(i3), S)
     if (present(i4)) call StringReplace('%u', IntToStr(i4), S)

     write(unit,'(a)') trim(S)
   end subroutine WriteFormatInts
   
  function IndexOf(aval,arr, n)
     integer, intent(in) :: n, arr(n), aval
     integer IndexOf, i

     do i=1,n
        if (arr(i)==aval) then
          IndexOf= i
          return
        end if
     end do
    IndexOf = 0

  end function IndexOf

  function MaxIndex(arr, n)
     integer, intent(in) :: n
     real, intent(in) :: arr(n)
     integer locs(1:1), MaxIndex

     locs = maxloc(arr(1:n))
     MaxIndex = locs(1)

  end function MaxIndex

 
  function MinIndex(arr, n)
     integer, intent(in) :: n
     real, intent(in) :: arr(n)
     integer locs(1:1), MinIndex

     locs = minloc(arr(1:n))
     MinIndex = locs(1)

  end function MinIndex


   subroutine TList_RealArr_SaveToFile(L,fname)
    character(LEN=*), intent(IN) :: fname
    Type (TList_RealArr) :: L
    character(LEN=20) aform
    integer i
    integer :: Plen = -1
    integer :: file_id

    file_id = new_file_unit()
    call CreateTxtFile(fname,file_id)
    do i=1, L%Count 
     if (PLen /= size(L%Items(i)%P)) then
      PLen = size(L%Items(i)%P)
      aform = '('//trim(IntToStr(PLen))//'E16.8)'
     end if 
     write (file_id,aform) L%Items(i)%P
    end do
    call CloseFile(file_id)   

   end subroutine TList_RealArr_SaveToFile


  function ExtractFilePath(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=1024) ExtractFilePath
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
       if (aname(i:i)=='/') then
          ExtractFilePath = aname(1:i)
          return
       end if
    end do
    ExtractFilePath = ''

  end function ExtractFilePath

  function ExtractFileExt(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=120) ExtractFileExt
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
       if (aname(i:i)=='/') then
          ExtractFileExt = ''
          return
       else if (aname(i:i)=='.') then
          ExtractFileExt= aname(i:len)   
          return
       end if
    end do
    ExtractFileExt = ''

  end function ExtractFileExt


 function ExtractFileName(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=1024) ExtractFileName
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
       if (aname(i:i)=='/') then
          ExtractFileName = aname(i+1:len)
          return
       end if
    end do
    ExtractFileName = aname

  end function ExtractFileName

 function ChangeFileExt(aname,ext)
    character(LEN=*), intent(IN) :: aname,ext
    character(LEN=1024) ChangeFileExt
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
       if (aname(i:i)=='.') then
          ChangeFileExt = aname(1:i) // trim(ext)
          return
       end if
    end do
    ChangeFileExt = trim(aname) // '.' // trim(ext)

  end function ChangeFileExt


  function CheckTrailingSlash(aname)
     character(LEN=*), intent(in) :: aname
     character(LEN=1024) CheckTrailingSlash
     integer len
     
     len = len_trim(aname)
#ifdef IBMXL
     if (aname(len:len) /= '\\' .and. aname(len:len) /= '/') then
#else
#ifdef ESCAPEBACKSLASH
     if (aname(len:len) /= '\\' .and. aname(len:len) /= '/') then
#else
     if (aname(len:len) /= '\' .and. aname(len:len) /= '/') then
#endif
#endif
      CheckTrailingSlash = trim(aname)//'/'
     else
      CheckTrailingSlash = aname
     end if 


  end  function CheckTrailingSlash


  subroutine DeleteFile(aname)
    character(LEN=*), intent(IN) :: aname
    integer file_id 

     if (FileExists(aname)) then
      file_id = new_file_unit()
      open(unit = file_id, file = aname, err = 2)
      close(unit = file_id, status = 'DELETE')
 2    file_units(file_id) = .false.
     end if
     
  end subroutine DeleteFile


  subroutine FlushFile(aunit)
#ifdef __INTEL_COMPILER_BUILD_DATE
  USE IFPORT
#endif
    integer, intent(IN) :: aunit


#ifdef IBMXL
     call flush_(aunit)
#else
     call flush(aunit)
#endif
    
  end subroutine FlushFile


  function FileExists(aname)
    character(LEN=*), intent(IN) :: aname
    logical FileExists
        
        inquire(file=aname, exist = FileExists)

  end function FileExists

 subroutine OpenFile(aname, aunit,mode)
   character(LEN=*), intent(IN) :: aname,mode
   integer, intent(in) :: aunit


   open(unit=aunit,file=aname,form=mode,status='old', action='read', err=500)
   return

500 call MpiStop('File not found: '//trim(aname))
    

 end subroutine OpenFile
 
 
 subroutine OpenTxtFile(aname, aunit)
   character(LEN=*), intent(IN) :: aname
   integer, intent(in) :: aunit

   call OpenFile(aname,aunit,'formatted')
 
 end subroutine OpenTxtFile

subroutine CreateOpenTxtFile(aname, aunit, append)
   character(LEN=*), intent(IN) :: aname
   integer, intent(in) :: aunit
   logical, optional, intent(in) :: append
   logical A

   if (present(append)) then
      A=append
   else
      A = .false.
   endif

   call CreateOpenFile(aname,aunit,'formatted',A)

 end subroutine CreateOpenTxtFile


 subroutine CreateTxtFile(aname, aunit)
    character(LEN=*), intent(IN) :: aname
   integer, intent(in) :: aunit

   call CreateFile(aname,aunit,'formatted')

 end subroutine CreateTxtFile

 
 subroutine CreateFile(aname, aunit,mode)
    character(LEN=*), intent(IN) :: aname,mode
   integer, intent(in) :: aunit

     open(unit=aunit,file=aname,form=mode,status='replace', err=500)

   return

500 call MpiStop('Error creating file '//trim(aname))
    

 end subroutine CreateFile

 subroutine CreateOpenFile(aname, aunit,mode, append)
    character(LEN=*), intent(IN) :: aname,mode
   integer, intent(in) :: aunit
   logical, optional, intent(in) :: append
   logical A

   if (present(append)) then
      A=append
   else
      A = .false.
   endif

   if (A) then
     open(unit=aunit,file=aname,form=mode,status='unknown', err=500, position='append')
   else
     open(unit=aunit,file=aname,form=mode,status='replace', err=500)
   end if

   return

500 call MpiStop('Error creatinging or opening '//trim(aname))
    

 end subroutine CreateOpenFile

 function TxtNumberColumns(InLine) result(n)
   character(LEN=*) :: InLine
   integer n,i
   logical isNum    
   
   n=0
   isNum=.false.
   do i=1, len_trim(InLIne)
    if (verify(InLine(i:i),'-+eE.0123456789') == 0) then
      if (.not. IsNum) n=n+1
      IsNum=.true.
    else
      IsNum=.false.     
    end if
   end do
   
 end function TxtNumberColumns
 
  function TxtColumns(InLine) result(n)
   character(LEN=*) :: InLine
   integer n,i
   logical isNum    
   
   n=0
   isNum=.false.
   do i=1, len_trim(InLine)
    if (InLine(i:i) > char(32)) then
      if (.not. IsNum) n=n+1
      IsNum=.true.
    else
      IsNum=.false.     
    end if
   end do
   
 end function TxtColumns

 function FileColumns(aunit) result(n)
   integer, intent(in) :: aunit
   integer n
   character(LEN=4096*32) :: InLine

   n=0
   read(aunit,'(a)', end = 10) InLine
   n = TxtNumberColumns(InLine)
10 rewind aunit
  
 end function FileColumns

 function FileLines(aunit) result(n)
   integer, intent(in) :: aunit
   integer n
   character(LEN=4096) :: InLine

   n=0
   do

   read(aunit,'(a)', end = 200) InLine
   n = n+1
   end do
 
200 rewind aunit
    

 end function FileLines


 function TopCommentLine(aname) result(res)
    character(LEN=*), intent(IN) :: aname
    integer file_id 
    character(LEN=1024) :: InLine, res
    
    res = ''
    file_id = new_file_unit()
    call OpenTxtFile(aname, file_id)
    InLine=''
    do while (InLine /= '') 
     read(file_id,'(a)', end = 10) InLine
    end do
    If (InLIne(1:1)=='#') then
     res = InLine
    end if

10  call CloseFile(file_id)

 end function TopCommentLine


 function TxtFileColumns(aname) result(n)
    character(LEN=*), intent(IN) :: aname
    integer n, file_id 


    file_id = new_file_unit()

    call OpenTxtFile(aname, file_id)
    n = FileColumns(file_id)
    call CloseFile(file_id)

 end function TxtFileColumns
 
 
 function LastFileLine(aname)
   character(LEN=*), intent(IN) :: aname
   character(LEN = 5000) LastFileLine, InLine
   integer  file_id 
   
   file_id = new_file_unit()
 
   InLine = ''
   call OpenTxtFile(aname,file_id)
   do
    read(file_id,'(a)', end = 200) InLine
   end do
 
200 call CloseFile(file_id)

   LastFileLine = InLine
 
 end function LastFileLine

 subroutine writeArrayLine(unit, arr)
  real, intent(in) :: arr(:)
  integer, intent(in) :: unit
  
  write(unit,concat('(',size(arr),'E16.6)')) arr
  
 end subroutine writeArrayLine
 

      subroutine spline_real(x,y,n,y2)

      integer, intent(in) :: n
      real, intent(in) :: x(n),y(n)
      real, intent(out) :: y2(n)
      integer i,k
      real p,qn,sig,un
      real, dimension(:), allocatable :: u

       
      allocate(u(1:n))
  
        y2(1)=0
        u(1)=0
        
      do i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2.0 
   
        y2(i)=(sig-1.0)/p
      
         u(i)=(6.0*((y(i+1)-y(i))/(x(i+ &
         1)-x(i))-(y(i)-y(i-1))/(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig* &
         u(i-1))/p
      end do
        qn=0.0
        un=0.0

      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.0)
      do k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
      end do

      deallocate(u)
  
!  (C) Copr. 1986-92 Numerical Recipes Software, adapted.
      end subroutine spline_real


      subroutine spline_double(x,y,n,y2)

      integer, intent(in) :: n
      double precision, intent(in) :: x(n),y(n)
      double precision, intent(out) :: y2(n)
      integer i,k
      double precision p,qn,sig,un
      double precision, dimension(:), allocatable :: u

       
      allocate(u(1:n))
  
        y2(1)=0
        u(1)=0
        
      do i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2 
   
        y2(i)=(sig-1)/p
      
         u(i)=(6*((y(i+1)-y(i))/(x(i+ &
         1)-x(i))-(y(i)-y(i-1))/(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig* &
         u(i-1))/p
      end do
      qn=0
      un=0

      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1)
      do k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
      end do

      deallocate(u)
  
!  (C) Copr. 1986-92 Numerical Recipes Software, adapted.
      end subroutine spline_double


      function DLGAMMA(x)
       !Use Stirling generalization for large x
       !See e.g. http://en.wikipedia.org/wiki/Stirling's_approximation
       !Is accurate to at least 10 decimals, worse just about 30
       double precision :: x
       double precision:: DLGAMMA !approx log gamma
       double precision, parameter :: const = .91893853320467274180d0 !log(2pi)/2
   
       if (x<32.d0) then
        DLGAMMA = log(GAMMA(x))
       else
        DLGAMMA = (x-0.5d0)*log(x) - x + const +  &
         1/12.d0/(1+x)*(1+1/(x+2)*(1+59.d0/30/(x+3)*(1+2.9491525423728813559d0/(x+4))))
      end if
      end function DLGAMMA


      function LogGamma(x)
        real LogGamma
        real, intent(in) :: x
        integer i, j
        real r

        i = nint(x*2)
        if (abs(i-x*2) > 1e-4) call MpiStop('LogGamma function for half integral only')
        if (mod(i,2) == 0) then
           r=0
           do j = 2, i/2-1
              r = r + log(real(j))
           end do
           LogGamma = r
        else
           r = log(pi)/2
           do j = 1, i-2 , 2
             r = r+ log(j/2.0)
           end do
           LogGamma = r
        end if

      end function LogGamma

    DOUBLE PRECISION FUNCTION GAMMA(X)
!----------------------------------------------------------------------
!
! This routine calculates the GAMMA function for a real argument X.
!   Computation is based on an algorithm outlined in reference 1.
!   The program uses rational functions that approximate the GAMMA
!   function to at least 20 significant decimal digits.  Coefficients
!   for the approximation over the interval (1,2) are unpublished.
!   Those for the approximation for X .GE. 12 are from reference 2.
!   The accuracy achieved depends on the arithmetic system, the
!   compiler, the intrinsic functions, and proper selection of the
!   machine-dependent constants.
!*******************************************************************
!
! Explanation of machine-dependent constants
!
! beta   - radix for the floating-point representation
! maxexp - the smallest positive power of beta that overflows
! XBIG   - the largest argument for which GAMMA(X) is representable
!          in the machine, i.e., the solution to the equation
!                  GAMMA(XBIG) = beta**maxexp
! XINF   - the largest machine representable floating-point number;
!          approximately beta**maxexp
! EPS    - the smallest positive floating-point number such that
!          1.0+EPS .GT. 1.0
! XMININ - the smallest positive floating-point number such that
!          1/XMININ is machine representable
!
!     Approximate values for some important machines are:
!
!                            beta       maxexp        XBIG
!
! CRAY-1         (S.P.)        2         8191        966.961
! Cyber 180/855
!   under NOS    (S.P.)        2         1070        177.803
! IEEE (IBM/XT,
!   SUN, etc.)   (S.P.)        2          128        35.040
! IEEE (IBM/XT,
!   SUN, etc.)   (D.P.)        2         1024        171.624
! IBM 3033       (D.P.)       16           63        57.574
! VAX D-Format   (D.P.)        2          127        34.844
! VAX G-Format   (D.P.)        2         1023        171.489
!
!                            XINF         EPS        XMININ
!
! CRAY-1         (S.P.)   5.45E+2465   7.11E-15    1.84E-2466
! Cyber 180/855
!   under NOS    (S.P.)   1.26E+322    3.55E-15    3.14E-294
! IEEE (IBM/XT,
!   SUN, etc.)   (S.P.)   3.40E+38     1.19E-7     1.18E-38
! IEEE (IBM/XT,
!   SUN, etc.)   (D.P.)   1.79D+308    2.22D-16    2.23D-308
! IBM 3033       (D.P.)   7.23D+75     2.22D-16    1.39D-76
! VAX D-Format   (D.P.)   1.70D+38     1.39D-17    5.88D-39
! VAX G-Format   (D.P.)   8.98D+307    1.11D-16    1.12D-308
!
!*******************************************************************
!*******************************************************************
!
! Error returns
!
!  The program returns the value XINF for singularities or
!     when overflow would occur.  The computation is believed
!     to be free of underflow and overflow.
!
!
!  Intrinsic functions required are:
!
!     INT, DBLE, EXP, LOG, REAL, SIN
!
!
! References: "An Overview of Software Development for Special
!              Functions", W. J. Cody, Lecture Notes in Mathemati,
!              506, Numerical Analysis Dundee, 1975, G. A. Watson
!              (ed.), Springer Verlag, Berlin, 1976.
!
!              Computer Approximations, Hart, Et. Al., Wiley and
!              sons, New York, 1968.
!
!  Latest modification: October 12, 1989
!
!  Authors: W. J. Cody and L. Stoltz
!           Applied Mathemati Division
!           Argonne National Laboratory
!           Argonne, IL 60439
!
!----------------------------------------------------------------------
      INTEGER I,N
      LOGICAL PARITY
    DOUBLE PRECISION C,EPS,FACT,HALF,ONE,P,PI,Q,RES,SQRTPI,SUM,TWELVE, &
         TWO,X,XBIG,XDEN,XINF,XMININ,XNUM,Y,Y1,YSQ,Z,ZERO
      DIMENSION C(7),P(8),Q(8)
!----------------------------------------------------------------------
!  Mathematical constants
!----------------------------------------------------------------------
    DATA ONE,HALF,TWELVE,TWO,ZERO/1.0D0,0.5D0,12.0D0,2.0D0,0.0D0/, &
        SQRTPI/0.9189385332046727417803297D0/, &
        PI/3.1415926535897932384626434D0/
!----------------------------------------------------------------------
!  Machine dependent parameters
!----------------------------------------------------------------------
    DATA XBIG,XMININ,EPS/35.040D0,1.18D-38,1.19D-7/, &
        XINF/3.4E38/
!----------------------------------------------------------------------
!  Numerator and denominator coefficients for rational minimax
!     approximation over (1,2).
!----------------------------------------------------------------------
    DATA P/-1.71618513886549492533811E+0,2.47656508055759199108314E+1, &
          -3.79804256470945635097577E+2,6.29331155312818442661052E+2, &
          8.66966202790413211295064E+2,-3.14512729688483675254357E+4, &
          -3.61444134186911729807069E+4,6.64561438202405440627855E+4/
    DATA Q/-3.08402300119738975254353E+1,3.15350626979604161529144E+2, &
         -1.01515636749021914166146E+3,-3.10777167157231109440444E+3, &
           2.25381184209801510330112E+4,4.75584627752788110767815E+3, &
         -1.34659959864969306392456E+5,-1.15132259675553483497211E+5/
!----------------------------------------------------------------------
! Coefficients for minimax approximation over (12, INF).
!----------------------------------------------------------------------
    DATA C/-1.910444077728D-03,8.4171387781295D-04, &
        -5.952379913043012D-04,7.93650793500350248D-04, &
        -2.777777777777681622553D-03,8.333333333333333331554247D-02, &
         5.7083835261D-03/
!----------------------------------------------------------------------
!  Statement functions for conversion between integer and float
!----------------------------------------------------------------------
      PARITY = .FALSE.
      FACT = ONE
      N = 0
      Y = X
      IF (Y .LE. ZERO) THEN
!----------------------------------------------------------------------
!  Argument is negative
!----------------------------------------------------------------------
            Y = -X
            Y1 = AINT(Y)
            RES = Y - Y1
            IF (RES .NE. ZERO) THEN
                  IF (Y1 .NE. AINT(Y1*HALF)*TWO) PARITY = .TRUE.
                  FACT = -PI / SIN(PI*RES)
                  Y = Y + ONE
               ELSE
                  RES = XINF
                  GO TO 900
            END IF
      END IF
!----------------------------------------------------------------------
!  Argument is positive
!----------------------------------------------------------------------
      IF (Y .LT. EPS) THEN
!----------------------------------------------------------------------
!  Argument .LT. EPS
!----------------------------------------------------------------------
            IF (Y .GE. XMININ) THEN
                  RES = ONE / Y
               ELSE
                  RES = XINF
                  GO TO 900
            END IF
         ELSE IF (Y .LT. TWELVE) THEN
            Y1 = Y
            IF (Y .LT. ONE) THEN
!----------------------------------------------------------------------
!  0.0 .LT. argument .LT. 1.0
!----------------------------------------------------------------------
                  Z = Y
                  Y = Y + ONE
               ELSE
!----------------------------------------------------------------------
!  1.0 .LT. argument .LT. 12.0, reduce argument if necessary
!----------------------------------------------------------------------
                  N = INT(Y) - 1
                  Y = Y - REAL(N)
                  Z = Y - ONE
            END IF
!----------------------------------------------------------------------
!  Evaluate approximation for 1.0 .LT. argument .LT. 2.0
!----------------------------------------------------------------------
            XNUM = ZERO
            XDEN = ONE
            DO 260 I = 1, 8
               XNUM = (XNUM + P(I)) * Z
               XDEN = XDEN * Z + Q(I)
  260       CONTINUE
            RES = XNUM / XDEN + ONE
            IF (Y1 .LT. Y) THEN
!----------------------------------------------------------------------
!  Adjust result for case  0.0 .LT. argument .LT. 1.0
!----------------------------------------------------------------------
                  RES = RES / Y1
               ELSE IF (Y1 .GT. Y) THEN
!----------------------------------------------------------------------
!  Adjust result for case  2.0 .LT. argument .LT. 12.0
!----------------------------------------------------------------------
                  DO 290 I = 1, N
                     RES = RES * Y
                     Y = Y + ONE
  290             CONTINUE
            END IF
         ELSE
!----------------------------------------------------------------------
!  Evaluate for argument .GE. 12.0,
!----------------------------------------------------------------------
            IF (Y .LE. XBIG) THEN
                  YSQ = Y * Y
                  SUM = C(7)
                  DO 350 I = 1, 6
                     SUM = SUM / YSQ + C(I)
  350             CONTINUE
                  SUM = SUM/Y - Y + SQRTPI
                  SUM = SUM + (Y-HALF)*LOG(Y)
                  RES = EXP(SUM)
               ELSE
                  RES = XINF
                  GO TO 900
            END IF
      END IF
!----------------------------------------------------------------------
!  Final adjustments and return
!----------------------------------------------------------------------
      IF (PARITY) RES = -RES
      IF (FACT .NE. ONE) RES = FACT / RES
  900 GAMMA = RES

      END FUNCTION GAMMA

  subroutine SetIdlePriority
#ifdef RUNIDLE
    USE DFWIN
    Integer dwPriority 
    Integer CheckPriority

    dwPriority = 64 ! idle priority
    CheckPriority = SetPriorityClass(GetCurrentProcess(), dwPriority)
#endif
  end subroutine SetIdlePriority


    subroutine GetThreeJs(thrcof,l2in,l3in,m2in,m3in)
      !Recursive evaluation of 3j symbols. Does minimal error checking on input parameters.
      implicit none
      integer, parameter :: dl = KIND(1.d0)
      integer, intent(in) :: l2in,l3in, m2in,m3in
      real(dl), dimension(*) :: thrcof
      INTEGER, PARAMETER :: i8 = selected_int_kind(18)
      integer(i8) :: l2,l3,m2,m3
      integer(i8) :: l1, m1, l1min,l1max, lmatch, nfin, a1, a2
      
      real(dl) :: newfac, oldfac, sumfor, c1,c2,c1old, dv, denom, x, sum1, sumuni
      real(dl) :: x1,x2,x3, y,y1,y2,y3,sum2,sumbac, ratio,cnorm, sign1, thresh
      integer i,ier, index, nlim, sign2
      integer nfinp1,nfinp2,nfinp3, lstep, nstep2,n
      real(dl), parameter :: zero = 0._dl, one = 1._dl
      real(dl), parameter ::  tiny = 1.0d-30, srtiny=1.0d-15, huge = 1.d30, srhuge = 1.d15
  
    ! routine to generate set of 3j-coeffs (l1,l2,l3\\ m1,m2,m3)

    ! by recursion from l1min = max(abs(l2-l3),abs(m1)) 
    !                to l1max = l2+l3
    ! the resulting 3j-coeffs are stored as thrcof(l1-l1min+1)

    ! to achieve the numerical stability, the recursion will proceed
    ! simultaneously forwards and backwards, starting from l1min and l1max
    ! respectively.
    !
    ! lmatch is the l1-value at which forward and backward recursion are matched.
    !
    ! ndim is the length of the array thrcof
    !
    ! ier = -1 for all 3j vanish(l2-abs(m2)<0, l3-abs(m3)<0 or not integer)
    ! ier = -2 if possible 3j's exceed ndim
    ! ier >= 0 otherwise

      l2=l2in
      l3=l3in
      m2=m2in
      m3=m3in
      newfac = 0
      lmatch = 0
      m1 = -(m2+m3)

    ! check relative magnitude of l and m values
      ier = 0
 
      if (l2 < abs(m2) .or. l3 < m3) then
      ier = -1
      call MpiStop('error ier = -1')
      return
      end if

    ! limits for l1
      l1min = max(abs(l2-l3),abs(m1))
      l1max = l2+l3

      if (l1min >= l1max) then
       if (l1min/=l1max) then
       ier = -1
        call MpiStop('error ier = -1')
       return
       end if

    ! reached if l1 can take only one value, i.e.l1min=l1max
      thrcof(1) = (-1)**abs(l2+m2-l3+m3)/sqrt(real(l1min+l2+l3+1,dl))
      return

      end if

      nfin = l1max-l1min+1
 
    ! starting forward recursion from l1min taking nstep1 steps
      l1 = l1min
      thrcof(1) = srtiny
      sum1 = (2*l1 + 1)*tiny

      lstep = 1

30    lstep = lstep+1
      l1 = l1+1

      oldfac = newfac
      a1 = (l1+l2+l3+1)*(l1-l2+l3)*(l1+l2-l3)
      a2 = (l1+m1)*(l1-m1)*(-l1+l2+l3+1)
      newfac = sqrt(a2*real(a1,dl))
      if (l1 == 1) then
         !IF L1 = 1  (L1-1) HAS TO BE FACTORED OUT OF DV, HENCE
         c1 = -(2*l1-1)*l1*(m3-m2)/newfac
      else

       dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 + l1*(l1-1)*(m3-m2)
       denom = (l1-1)*newfac

       if (lstep > 2) c1old = abs(c1)
       c1 = -(2*l1-1)*dv/denom

      end if

      if (lstep<= 2) then

    ! if l1=l1min+1 the third term in the recursion eqn vanishes, hence
       x = srtiny*c1
       thrcof(2) = x
       sum1 = sum1+tiny*(2*l1+1)*c1*c1
       if(lstep==nfin) then
          sumuni=sum1
          go to 230
       end if
       goto 30

      end if

      c2 = -l1*oldfac/denom

    ! recursion to the next 3j-coeff x  
      x = c1*thrcof(lstep-1) + c2*thrcof(lstep-2)
      thrcof(lstep) = x
      sumfor = sum1
      sum1 = sum1 + (2*l1+1)*x*x
      if (lstep/=nfin) then

    ! see if last unnormalised 3j-coeff exceeds srhuge
      if (abs(x) >= srhuge) then
     
         ! REACHED IF LAST 3J-COEFFICIENT LARGER THAN SRHUGE
         ! SO THAT THE RECURSION SERIES THRCOF(1), ... , THRCOF(LSTEP)
         ! HAS TO BE RESCALED TO PREVENT OVERFLOW
     
         ier = ier+1
         do i = 1, lstep
            if (abs(thrcof(i)) < srtiny) thrcof(i)= zero
            thrcof(i) = thrcof(i)/srhuge
         end do

         sum1 = sum1/huge
         sumfor = sumfor/huge
         x = x/srhuge

      end if

    ! as long as abs(c1) is decreasing, the recursion proceeds towards increasing
    ! 3j-valuse and so is numerically stable. Once an increase of abs(c1) is 
    ! detected, the recursion direction is reversed.

     if (c1old > abs(c1)) goto 30

     end if !lstep/=nfin

    ! keep three 3j-coeffs around lmatch for comparison with backward recursion

      lmatch = l1-1
      x1 = x
      x2 = thrcof(lstep-1)
      x3 = thrcof(lstep-2)
      nstep2 = nfin-lstep+3

    ! --------------------------------------------------------------------------
    !
    ! starting backward recursion from l1max taking nstep2 stpes, so that
    ! forward and backward recursion overlap at 3 points 
    ! l1 = lmatch-1, lmatch, lmatch+1

      nfinp1 = nfin+1
      nfinp2 = nfin+2
      nfinp3 = nfin+3
      l1 = l1max
      thrcof(nfin) = srtiny
      sum2 = tiny*(2*l1+1)
 
      l1 = l1+2
      lstep=1

      do
      lstep = lstep + 1
      l1= l1-1

      oldfac = newfac
      a1 = (l1+l2+l3)*(l1-l2+l3-1)*(l1+l2-l3-1)
      a2 = (l1+m1-1)*(l1-m1-1)*(-l1+l2+l3+2)
      newfac = sqrt(a1*real(a2,dl))

      dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 +l1*(l1-1)*(m3-m2)

      denom = l1*newfac
      c1 = -(2*l1-1)*dv/denom
      if (lstep <= 2) then

         ! if l2=l2max+1, the third term in the recursion vanishes
     
         y = srtiny*c1
         thrcof(nfin-1) = y
         sumbac = sum2
         sum2 = sum2 + tiny*(2*l1-3)*c1*c1

         cycle

      end if

      c2 = -(l1-1)*oldfac/denom

    ! recursion to the next 3j-coeff y
      y = c1*thrcof(nfinp2-lstep)+c2*thrcof(nfinp3-lstep)

      if (lstep==nstep2) exit
  
      thrcof(nfinp1-lstep) = y
      sumbac = sum2
      sum2 = sum2+(2*l1-3)*y*y

    ! see if last unnormalised 3j-coeff exceeds srhuge
      if (abs(y) >= srhuge) then
     
         ! reached if 3j-coeff larger than srhuge so that the recursion series
         ! thrcof(nfin),..., thrcof(nfin-lstep+1) has to be rescaled to prevent overflow
     
         ier=ier+1
         do i = 1, lstep
            index=nfin-i+1
            if (abs(thrcof(index)) < srtiny) thrcof(index)=zero
            thrcof(index) = thrcof(index)/srhuge
         end do

         sum2=sum2/huge
         sumbac=sumbac/huge

      end if

      end do

    ! the forward recursion 3j-coeffs x1, x2, x3 are to be matched with the 
    ! corresponding backward recursion vals y1, y2, y3

      y3 = y
      y2 = thrcof(nfinp2-lstep)
      y1 = thrcof(nfinp3-lstep)

    ! determine now ratio such that yi=ratio*xi (i=1,2,3) holds with minimal error

      ratio = (x1*y1+x2*y2+x3*y3)/(x1*x1+x2*x2+x3*x3)
      nlim = nfin-nstep2+1

      if (abs(ratio) >= 1) then

       thrcof(1:nlim) = ratio*thrcof(1:nlim) 
       sumuni = ratio*ratio*sumfor + sumbac

      else

      nlim = nlim+1
      ratio = 1/ratio
      do n = nlim, nfin
         thrcof(n) = ratio*thrcof(n)
      end do
      sumuni = sumfor + ratio*ratio*sumbac

      end if
    ! normalise 3j-coeffs

230  cnorm = 1/sqrt(sumuni)

    ! sign convention for last 3j-coeff determines overall phase

      sign1 = sign(one,thrcof(nfin))
      sign2 = (-1)**(abs(l2+m2-l3+m3))
      if (sign1*sign2 <= 0) then
        cnorm = -cnorm
      end if
      if (abs(cnorm) >= one) then
         thrcof(1:nfin) = cnorm*thrcof(1:nfin)
         return
      end if

      thresh = tiny/abs(cnorm)

      do n = 1, nfin
         if (abs(thrcof(n)) < thresh) thrcof(n) = zero
         thrcof(n) = cnorm*thrcof(n)
      end do
      return 

    end subroutine GetThreeJs



  end module AMLutils
 
  
#ifdef ZIGGURAT
MODULE Ziggurat
! Marsaglia & Tsang generator for random normals & random exponentials.
! Translated from C by Alan Miller (amiller@bigpond.net.au)

! Marsaglia, G. & Tsang, W.W. (2000) `The ziggurat method for generating
! random variables', J. Statist. Software, v5(8).

! This is an electronic journal which can be downloaded from:
! http://www.jstatsoft.org/v05/i08

! N.B. It is assumed that all integers are 32-bit.
! N.B. The value of M2 has been halved to compensate for the lack of
!      unsigned integers in Fortran.

! Latest version - 1 January 2001
!
! AL: useful material at http://en.wikipedia.org/wiki/Ziggurat_algorithm
   IMPLICIT NONE

   PRIVATE

   INTEGER,  PARAMETER  ::  DP=SELECTED_REAL_KIND( 12, 60 )
   REAL(DP), PARAMETER  ::  m1=2147483648.0_DP,   m2=2147483648.0_DP,      &
                            half=0.5_DP
   REAL(DP)             ::  dn=3.442619855899_DP, tn=3.442619855899_DP,    &
                            vn=0.00991256303526217_DP,                     &
                            q,                    de=7.697117470131487_DP, &
                            te=7.697117470131487_DP,                       &
                            ve=0.003949659822581572_DP
   INTEGER,  SAVE       ::  iz, jz, jsr=123456789, kn(0:127),              &
                            ke(0:255), hz
   REAL(DP), SAVE       ::  wn(0:127), fn(0:127), we(0:255), fe(0:255)
   LOGICAL,  SAVE       ::  initialized=.FALSE.

   PUBLIC  :: zigset, shr3, uni, rnor, rexp


CONTAINS


SUBROUTINE zigset( jsrseed )

   INTEGER, INTENT(IN)  :: jsrseed

   INTEGER  :: i

   !  Set the seed
   jsr = jsrseed

   !  Tables for RNOR
   q = vn*EXP(half*dn*dn)
   kn(0) = (dn/q)*m1
   kn(1) = 0
   wn(0) = q/m1
   wn(127) = dn/m1
   fn(0) = 1.0_DP
   fn(127) = EXP( -half*dn*dn )
   DO  i = 126, 1, -1
      dn = SQRT( -2.0_DP * LOG( vn/dn + EXP( -half*dn*dn ) ) )
      kn(i+1) = (dn/tn)*m1
      tn = dn
      fn(i) = EXP(-half*dn*dn)
      wn(i) = dn/m1
   END DO

   !  Tables for REXP
   q = ve*EXP( de )
   ke(0) = (de/q)*m2
   ke(1) = 0
   we(0) = q/m2
   we(255) = de/m2
   fe(0) = 1.0_DP
   fe(255) = EXP( -de )
   DO  i = 254, 1, -1
      de = -LOG( ve/de + EXP( -de ) )
      ke(i+1) = m2 * (de/te)
      te = de
      fe(i) = EXP( -de )
      we(i) = de/m2
   END DO
   initialized = .TRUE.
   RETURN
END SUBROUTINE zigset



!  Generate random 32-bit integers
FUNCTION shr3( ) RESULT( ival )
   INTEGER  ::  ival

   jz = jsr
   jsr = IEOR( jsr, ISHFT( jsr,  13 ) )
   jsr = IEOR( jsr, ISHFT( jsr, -17 ) )
   jsr = IEOR( jsr, ISHFT( jsr,   5 ) )
   ival = jz + jsr
   RETURN
END FUNCTION shr3



!  Generate uniformly distributed random numbers
FUNCTION uni( ) RESULT( fn_val )
   REAL(DP)  ::  fn_val

   fn_val = half + 0.2328306e-9_DP * shr3( )
   RETURN
END FUNCTION uni



!  Generate random normals
FUNCTION rnor( ) RESULT( fn_val )
   REAL(DP)             ::  fn_val

   REAL(DP), PARAMETER  ::  r = 3.442620_DP
   REAL(DP)             ::  x, y

   IF( .NOT. initialized ) CALL zigset( jsr )
   hz = shr3( )
   iz = IAND( hz, 127 )
   IF( ABS( hz ) < kn(iz) ) THEN
      fn_val = hz * wn(iz)
   ELSE
      DO
         IF( iz == 0 ) THEN
            DO
               x = -0.2904764_DP* LOG( uni( ) )
               y = -LOG( uni( ) )
               IF( y+y >= x*x ) EXIT
            END DO
            fn_val = r+x
            IF( hz <= 0 ) fn_val = -fn_val
            RETURN
         END IF
         x = hz * wn(iz)
         IF( fn(iz) + uni( )*(fn(iz-1)-fn(iz)) < EXP(-half*x*x) ) THEN
            fn_val = x
            RETURN
         END IF
         hz = shr3( )
         iz = IAND( hz, 127 )
         IF( ABS( hz ) < kn(iz) ) THEN
            fn_val = hz * wn(iz)
            RETURN
         END IF
      END DO
   END IF
   RETURN
END FUNCTION rnor



!  Generate random exponentials
FUNCTION rexp( ) RESULT( fn_val )
   REAL(DP)  ::  fn_val

   REAL(DP)  ::  x

   IF( .NOT. initialized ) CALL Zigset( jsr )
   jz = shr3( )
   iz = IAND( jz, 255 )
   IF( ABS( jz ) < ke(iz) ) THEN
      fn_val = ABS(jz) * we(iz)
      RETURN
   END IF
   DO
      IF( iz == 0 ) THEN
         fn_val = 7.69711 - LOG( uni( ) )
         RETURN
      END IF
      x = ABS( jz ) * we(iz)
      IF( fe(iz) + uni( )*(fe(iz-1) - fe(iz)) < EXP( -x ) ) THEN
         fn_val = x
         RETURN
      END IF
      jz = shr3( )
      iz = IAND( jz, 255 )
      IF( ABS( jz ) < ke(iz) ) THEN
         fn_val = ABS( jz ) * we(iz)
         RETURN
      END IF
   END DO
   RETURN
END FUNCTION rexp

END MODULE ziggurat
#endif 

  

module Random
 integer :: rand_inst = 0 
 logical, parameter :: use_ziggurat = .false.
 integer, parameter :: krand = KIND(1.d0)
  !Ziggurat is significantly (3-4x) faster, see Wikipedia for details
  !Have seem some suspicious things, though couldn't replicate; may be OK..

  INTERFACE RandRotation
  MODULE PROCEDURE RandRotationS, RandRotationD
  END INTERFACE

contains
   
  subroutine initRandom(i, i2)
  use AMLUtils
#ifdef ZIGGURAT
  use Ziggurat
#endif
  implicit none
  integer, optional, intent(IN) :: i
  integer, optional, intent(IN) :: i2
  integer seed_in,kl,ij
  character(len=10) :: fred
  real(krand) :: klr
  
   if (present(i)) then
    seed_in = i
   else
    seed_in = -1
   end if
      if (seed_in /=-1) then
       if (present(i2)) then
        kl=i2
        if (i2 > 30081) call MpiStop('initRandom:second seed too large')
       else
        kl = 9373
       end if
       ij = i
      else
       call system_clock(count=ij)
       ij = mod(ij + rand_inst*100, 31328)
       call date_and_time(time=fred)
       read (fred,'(e10.3)') klr
       kl = mod(int(klr*1000), 30081)       
      end if

      if (Feedback > 0 ) write(*,'(" Random seeds:",1I6,",",1I6," rand_inst:",1I4)') ij,kl,rand_inst
      call rmarin(ij,kl)
#ifdef ZIGGURAT
      if (use_ziggurat) call zigset(ij)
#endif
  end subroutine initRandom

  subroutine RandIndices(indices, nmax, n)
   use AMLUtils
    integer, intent(in) :: nmax, n
    integer indices(n),i, ix
    integer tmp(nmax)
 
    if (n> nmax) call MpiStop('Error in RandIndices, n > nmax')
    do i=1, nmax
       tmp(i)=i
    end do
    do i=1, n
       ix = int(ranmar()*(nmax +1 -i)) + 1
       indices(i) = tmp(ix)
       tmp(ix) = tmp(nmax+1-i)
    end do

  end subroutine RandIndices

  subroutine RandRotationS(R, N)
   !this is most certainly not the world's most efficient or robust random rotation generator
    integer, intent(in) :: N
    real R(N,N), vec(N), norm
    integer i,j
    
    do j = 1, N
     do
         do i = 1, N
          vec(i) = Gaussian1()
         end do
         do i = 1, j-1
           vec = vec - sum(vec*R(i,:))*R(i,:)
         end do
         norm = sum(vec**2)
         if (norm > 1e-3) exit
     end do
     R(j,:) = vec / sqrt(norm)
    end do
    
  end subroutine RandRotationS
  
  
  subroutine RandRotationD(R, N)
   !this is most certainly not the world's most efficient or robust random rotation generator
    integer, intent(in) :: N
    double precision R(N,N), vec(N), norm
    integer i,j
    
    do j = 1, N
     do
         do i = 1, N
          vec(i) = Gaussian1()
         end do
         do i = 1, j-1
           vec = vec - sum(vec*R(i,:))*R(i,:)
         end do
         norm = sum(vec**2)
         if (norm > 1e-3) exit
     end do
     R(j,:) = vec / sqrt(norm)
    end do
    
  end subroutine RandRotationD


  double precision function GAUSSIAN1()
#ifdef ZIGGURAT
    use Ziggurat
#endif
    implicit none
    double precision R, V1, V2, FAC
    integer, save :: iset = 0
    double precision, save :: gset

    if (use_ziggurat) then
#ifdef ZIGGURAT
     Gaussian1 = rnor( )
#endif
    else
     !Box muller
     if (ISET==0) then
        R=2
        do while (R >= 1.d0)
        V1=2.d0*ranmar()-1.d0
        V2=2.d0*ranmar()-1.d0
        R=V1**2+V2**2
        end do
        FAC=sqrt(-2.d0*log(R)/R)
        GSET=V1*FAC
        GAUSSIAN1=V2*FAC
        ISET=1
      else
        GAUSSIAN1=GSET
        ISET=0
      endif
      end if
      end function GAUSSIAN1


     double precision function CAUCHY1()
      implicit none

      Cauchy1 = Gaussian1()/max(1d-15,abs(Gaussian1()))

     end function CAUCHY1


     real FUNCTION RANDEXP1()
!
!     Random-number generator for the exponential distribution
!     Algorithm EA from J. H. Ahrens and U. Dieter,
!     Communications of the ACM, 31 (1988) 1330--1337.
!     Coded by K. G. Hamilton, December 1996, with corrections.
!
      real u, up, g, y
  
      real, parameter ::   alog2= 0.6931471805599453
      real, parameter ::      a = 5.7133631526454228
      real, parameter ::      b = 3.4142135623730950
      real, parameter ::     c = -1.6734053240284925
      real, parameter ::      p = 0.9802581434685472
      real, parameter ::     aa = 5.6005707569738080
      real, parameter ::     bb = 3.3468106480569850
      real, parameter ::     hh = 0.0026106723602095
      real, parameter ::     dd = 0.0857864376269050

      u = ranmar()
      do while (u.le.0)                 ! Comment out this block 
        u = ranmar()                    ! if your RNG can never
      enddo                             ! return exact zero
      g = c
      u = u+u
      do while (u.lt.1.0)
         g = g + alog2
         u = u+u
      enddo
      u = u-1.0
      if (u.le.p) then
        randexp1 = g + aa/(bb-u)
        return
      endif
      do
        u = ranmar()
        y = a/(b-u)
        up = ranmar()
        if ((up*hh+dd)*(b-u)**2 .le. exp(-(y+c))) then
          randexp1 = g+y
          return
        endif
      enddo

      end function randexp1


! This random number generator originally appeared in ''Toward a Universal 
! Random Number Generator'' by George Marsaglia and Arif Zaman. 
! Florida State University Report: FSU-SCRI-87-50 (1987)
! 
! It was later modified by F. James and published in ''A Review of Pseudo-
! random Number Generators'' 
! 
! THIS IS THE BEST KNOWN RANDOM NUMBER GENERATOR AVAILABLE.
!    (However, a newly discovered technique can yield 
!        a period of 10^600. But that is still in the development stage.)
!
! It passes ALL of the tests for random number generators and has a period 
!   of 2^144, is completely portable (gives bit identical results on all 
!   machines with at least 24-bit mantissas in the floating point 
!   representation). 
! 
! The algorithm is a combination of a Fibonacci sequence (with lags of 97
!   and 33, and operation "subtraction plus one, modulo one") and an 
!   "arithmetic sequence" (using subtraction).
!
! On a Vax 11/780, this random number generator can produce a number in 
!    13 microseconds. 
!======================================================================== 
!
!      PROGRAM TstRAN
!     INTEGER IJ, KL, I
! Thee are the seeds needed to produce the test case results
!      IJ = 1802
!      KL = 9373
!
!
! Do the initialization
!      call rmarin(ij,kl)
!
! Generate 20000 random numbers
!      do 10 I = 1, 20000
!         x = RANMAR()
!10    continue
!
! If the random number generator is working properly, the next six random
!    numbers should be:
!          6533892.0  14220222.0  7275067.0
!    6172232.0  8354498.0   10633180.0
!           
!           
!        
!      write(6,20) (4096.0*4096.0*RANMAR(), I=1,6)
!20    format (3f12.1)
!      end
!
      subroutine RMARIN(IJ,KL)
! This is the initialization routine for the random number generator RANMAR()
! NOTE: The seed variables can have values between:    0 <= IJ <= 31328
!                                                      0 <= KL <= 30081
!The random number sequences created by these two seeds are of sufficient 
! length to complete an entire calculation with. For example, if sveral 
! different groups are working on different parts of the same calculation,
! each group could be assigned its own IJ seed. This would leave each group
! with 30000 choices for the second seed. That is to say, this random 
! number generator can create 900 million different subsequences -- with 
! each subsequence having a length of approximately 10^30.
!
! Use IJ = 1802 & KL = 9373 to test the random number generator. The
! subroutine RANMAR should be used to generate 20000 random numbers.
! Then display the next six random numbers generated multiplied by 4096*4096
! If the random number generator is working properly, the random numbers
!    should be:
!           6533892.0  14220222.0  7275067.0
!           6172232.0  8354498.0   10633180.0
      double precision U(97), C, CD, CM, S, T
      integer I97, J97,i,j,k,l,m
      integer ij,kl
      integer ii,jj
           
    
!      INTEGER IRM(103)
      
      common /RASET1/ U, C, CD, CM, I97, J97
      if( IJ .lt. 0  .or.  IJ .gt. 31328  .or. &
         KL .lt. 0  .or.  KL .gt. 30081 ) then
          print '(A)', ' The first random number seed must have a value  between 0 and 31328'
          print '(A)',' The second seed must have a value between 0 and   30081'
            stop
      endif
      I = mod(IJ/177, 177) + 2
      J = mod(IJ    , 177) + 2
      K = mod(KL/169, 178) + 1
      L = mod(KL,     169) 
      do 2 II = 1, 97
         S = 0.0
         T = 0.5
         do 3 JJ = 1, 24
            M = mod(mod(I*J, 179)*K, 179)
            I = J
            J = K
            K = M
            L = mod(53*L+1, 169)
            if (mod(L*M, 64) .ge. 32) then
               S = S + T
            endif
            T = 0.5 * T
3        continue
         U(II) = S
2     continue
      C = 362436.0 / 16777216.0
      CD = 7654321.0 / 16777216.0
      CM = 16777213.0 /16777216.0
      I97 = 97
      J97 = 33
    
      end subroutine RMARIN

      double precision function RANMAR()
! This is the random number generator proposed by George Marsaglia in 
! Florida State University Report: FSU-SCRI-87-50
! It was slightly modified by F. James to produce an array of pseudorandom
! numbers.
      double precision U(97), C, CD, CM
      integer I97, J97
       double precision uni
    
      common /RASET1/ U, C, CD, CM, I97, J97
!      INTEGER IVEC
         UNI = U(I97) - U(J97)
         if( UNI .lt. 0.0 ) UNI = UNI + 1.0
         U(I97) = UNI
         I97 = I97 - 1
         if(I97 .eq. 0) I97 = 97
         J97 = J97 - 1
         if(J97 .eq. 0) J97 = 97
         C = C - CD
         if( C .lt. 0.d0 ) C = C + CM
         UNI = UNI - C
         if( UNI .lt. 0.d0 ) UNI = UNI + 1.0 ! bug?
         RANMAR = UNI
      
      end function RANMAR


end module Random


 

      SUBROUTINE splint(xa,ya,y2a,n,x,y)
      INTEGER n
      REAL*8 x,y,xa(n),y2a(n),ya(n)
      INTEGER k,khi,klo
      REAL*8 a,b,h
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.d0) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**
     *2)/6.d0
      return
      END

#! /bin/sh
# © M E C Swanson 2008
#script to find the complement of a mangle mask
#USAGE: find_complement.sh <mask> <complement>
#EXAMPLE:find_complement.sh holes.pol complement.pol
#input mask can be pixelized beforehand to a fixed resolution
#if the mask is complicated, e.g. pixelize -Ps0,8 holes.pol holes_pixelized.pol

if [ "$MANGLEBINDIR" = "" ] ; then
    MANGLEBINDIR="../../bin"
fi
if [ "$MANGLESCRIPTSDIR" = "" ] ; then
    MANGLESCRIPTSDIR="../../scripts"
fi
if [ "$MANGLEDATADIR" = "" ] ; then
    MANGLEDATADIR="../../masks"
fi

mask=$1
complement=$2
dres=3
dscheme="s"

#check command line arguments
if [ "$mask" = "" ] || [ "$complement" = "" ] ; then
    echo >&2 "ERROR: enter the input and output polygon files as command line arguments."
    echo >&2 "" 
    echo >&2 "USAGE: find_complement.sh <mask> <complement>"
    echo >&2 "EXAMPLE:find_complement.sh holes.pol complement.pol"
    exit 1
fi

head -n 100 $mask > jmaskhead

#grab pixelization info from input files
awk '/pixelization/{print $0}' < jmaskhead > jpix
res=`awk '{print substr($2, 1, length($2)-1)}' < jpix`
scheme=`awk '{print substr($2, length($2))}' < jpix`
rm jpix jmaskhead

#if input file is unpixelized, pixelize it
#if input file is pixelized to a fixed resolution, use it as is.
if [ "$res" = "" ]; then
    res=$dres
    scheme=$dscheme
    echo ""
    echo "Pixelizing $1 ..."
    $MANGLEBINDIR/pixelize -P${scheme}0,$res $mask jp || exit  
    echo ""
elif [ "$res" = -1 ] ; then
    res=$dres
    scheme=$dscheme
    echo "WARNING: cannot take the complement of a mask pixelized adaptively."
    echo "Pixelizing your mask using a fixed resolution:"
    echo ""
    echo "Pixelizing $1 ..."
    $MANGLEBINDIR/pixelize -P${scheme}0,$res $mask jp || exit   
    echo ""
else
    cp $mask jp
fi

#check for appropriate allsky file, and generate it if it's not there:
allsky=$MANGLEDATADIR/allsky/allsky$res$scheme.pol
if [ ! -e $allsky ] ; then
    $MANGLESCRIPTSDIR/make_allsky.sh $res $scheme
fi

#check if input file is snapped
snapped=`awk '/snapped/{print $1}' < $mask`

#if input file isn't snapped, snap it
if [ ! "$snapped" = "snapped" ]; then
    echo "Snapping $1 ..."
    $MANGLEBINDIR/snap jp jps || exit
    rm jp
else
    mv jp jps
fi

#set weight of all polygons in mask to zero
echo 0 > jw0
echo "$MANGLEBINDIR/weight -zjw0 $mask jw"
$MANGLEBINDIR/weight -zjw0 jps jw || exit
rm jps

#balkanize the full sky with the zero-weighted mask to find the complement
echo "$MANGLEBINDIR/balkanize $allsky jw jb"
$MANGLEBINDIR/balkanize $allsky jw jb || exit
rm jw

#unify to get rid of zero weight polygons
echo "$MANGLEBINDIR/unify jb $complement"
$MANGLEBINDIR/unify jb $complement || exit
rm jb

echo "Complement of $mask written to ${complement}."

#!/bin/sh
# © M E C Swanson 2008
#plot the angular mask described by a polygon file in graphics format
#using sm
#
#optional 3rd-6th arguments give the RA and Dec range to plot the mask
#If no range is given, range will be calculated automatically from the data.
#If only an RA range is given, Dec range will be calculated automatically
#to give equal scaling on x and y axes, centered on the range of all the data.
#
#Entering in "0 0 0 0" for the range will also give an automatic range,
#which can be used if you also wish to, e.g., enter a title. 
#Likewise entering "0 0" for the Dec range is equivalent to only specifying an RA range. 
#
#optional 7th argument gives a title for the graph
#optional 8th argument turns on drawing black outlines around each polygon
#
#if specifying the full path to a file (rather than just running in the directory 
#containing the file you want to plot), put the path in double-quotes as shown below.
#
#USAGE: graphmasksm.sh <infile> <outfile> [<ramin> <ramax>] [<decmin> <decmax>] [<title>] [<outlines>]
#EXAMPLES: 
#default range, no outlines: graphmasksm.sh "dr4/safe0/sdss_dr4safe0_mask.grph" "dr4/safe0/sdss_dr4safe0_mask.eps"
#defined range, title, no outlines: graphmasksm.sh sdss_slice.grph sdss_slice.eps -45 35 8 21 "SDSS slice"
#defined range, no title, outlines: graphmasksm.sh sdss_slice.grph sdss_slice.eps -45 35 8 21 " " on
#default range, no title, outlines: graphmasksm.sh sdss_slice.grph sdss_slice.eps 0 0 0 0 " " on
		
#WARNINGS: (a.k.a., reasons to use the matlab plotting script instead!)		
# -This script uses the opposite color scheme than the matlab script, i.e., 		
#  weight 1 = black, weight 0 = white	       
# -RA and Dec are treated as linear variables (no spherical projection).  This means that 		
#  ranges that span RA=0 won't plot properly.		
# -SM can only plot square eps files, so if you define both RA and Dec range, they should		
#  have the same length, otherwise your plot will appear stretched.		
# -SM has a line length limit of 1500 characters, which SDSS tends to have no trouble overloading.  		
#  If you get an error reading the file, try making your graphics file with lower precision and 
#  fewer points per 2pi, i.e., use poly2poly -og12 -p3 instead of poly2poly -og30.
#


if [ "$MANGLESCRIPTSDIR" = "" ] ; then
    MANGLESCRIPTSDIR="../../scripts"
fi

if [ ! "$7" = "" ] ; then
    title="\"$7\""
else
    title=""
fi

if [ "$8" = "on" ] ; then
    outlines=1
else
    outlines=""
fi

if [ $# -ge 2 ]; then
    if [ -e $1 ]; then 
	echo "Plotting $1 using sm ..."
	if [ -e $2 ]; then
	    rm $2
	fi
	sm -m $MANGLESCRIPTSDIR/graphmask.sm $1 $2 $3 $4 $5 $6 $title $outlines > sm.temp
    else
	echo >&2 "ERROR: file $1 not found."
	exit 1
    fi
else
    echo >&2 "USAGE: graphmasksm.sh <infile> <outfile> [<ramin> <ramax>] [<decmin> <decmax>] [<title>] [<outlines>]"
    echo >&2 "EXAMPLES:" 
    echo >&2 "default range, no outlines: graphmasksm.sh \"dr4/safe0/sdss_dr4safe0_mask.grph\" \"dr4/safe0/sdss_dr4safe0_mask.eps\""
    echo >&2 "defined range, title, no outlines: graphmasksm.sh sdss_slice.grph sdss_slice.eps -45 35 8 21 \"SDSS slice\""
    echo >&2 "defined range, no title, outlines: graphmasksm.sh sdss_slice.grph sdss_slice.eps -45 35 8 21 \" \" on"
    echo >&2 "default range, no title, outlines: graphmasksm.sh sdss_slice.grph sdss_slice.eps 0 0 0 0 \" \" on"
    exit 1
fi
if [ -e smerr.temp ] || [ ! -e $2 ]; then
    echo >&2 "ERROR: error in sm plotting script."
    echo >&2 "See log in sm.temp for more details."
    if [ -e smerr.temp ]; then
	rm smerr.temp
    fi
    exit 1
fi
rm sm.temp
echo all done!

#!/bin/bash
# Author: Johannes Buchner (C) 2015
# For creating a shared library (libcuba.so)

echo $1
echo "rebuilding libcuba.a archive"
./configure
sed 's/CFLAGS = -O3 -fomit-frame-pointer/CFLAGS = -O3 -fPIC -fomit-frame-pointer/g' --in-place makefile
make -B libcuba.a
echo "unpacking libcuba.a"

FILES=$(ar xv libcuba.a |sed 's/x - //g')
ES="so"
FLAGS_LINK=-shared

LIB=libcuba.$ES

echo "making libcuba."$ES
gcc $FLAGS_LINK $FILES -o $LIB
rm $FILES

#!/bin/sh
# © M E C Swanson 2008
#
#This script tests the mangle installation and creates a tarball of
#output files for further examination.
#
#USAGE: source run_mangle_testsuite > test.log
mkdir test

echo "mangle environment variables are:"
echo "MANGLEBINDIR=$MANGLEBINDIR"
echo "MANGLESCRIPTSDIR=$MANGLESCRIPTSDIR"
echo "MANGLEDATADIR=$MANGLEDATADIR"
echo "PATH=$PATH"

echo "Checking if unformatted fortran files are readable."
cd ../masks/2df100k
../../bin/weight -z2dF100k ngp_fields.dat jnf || exit
../../bin/weight -z2dF100k sgp_fields.dat jnf || exit
cd ../2df230k
../../bin/weight -z2dF230k ngp_fields.dat jnf || exit
../../bin/weight -z2dF230k sgp_fields.dat jnf || exit
rm jnf

echo "Running mangle on 2qz10k mask ..."
cd ../2qz10k/
./2qz.sh
if [ -e 2qz_res4s.eps ]; then
    mv 2qz_res4s.eps ../../scripts/test
    if [ -e 2qz_north_res4s.eps ]; then
	mv 2qz_north_res4s.eps ../../scripts/test
    fi
    if [ -e 2qz_south_res4s.eps ]; then
	mv 2qz_south_res4s.eps ../../scripts/test
    fi
fi
mv 2qz_north_res4s.pol 2qz_south_res4s.pol  ../../scripts/test

rm 2qz_*

samp=dr6
echo "Running mangle on slice of SDSS $samp mask ..."
cd ../sdss
./sdss_quickstart.sh
if [ -e sdss_${samp}safe0_slice.eps ]; then 
    mv sdss_${samp}safe0_slice.eps ../../scripts/test
elif [ -e sdss_${samp}safe0_slice1.eps ] && [ -e sdss_${samp}safe0_slice2.eps ]; then
    mv sdss_${samp}safe0_slice1.eps sdss_${samp}safe0_slice2.eps ../../scripts/test
else
    mv sdss_${samp}safe0_slice.pol ../../scripts/test
fi
rm sdss_${samp}safe0_slice.*

echo "Trimming 2qz north mask with an icosahedron polygon ..."
cd ../../scripts/test
cp ../../masks/icosahedron/icosahedron.pol .
../../bin/poly2poly -J7,7 icosahedron.pol ico7.pol
../../scripts/trim_mask.sh 2qz_north_res4s.pol ico7.pol trimmed_mask.pol
rm icosahedron.pol ico7.pol

echo "Rasterizing 2qz north mask ... "
rm ../../masks/healpix/healpix_polys/nside16_p5s.pol
../../scripts/healpixrast.sh 2qz_north_res4s.pol 16 rasterized_mask.pol
../../scripts/healpixrast2fits.sh 2qz_north_res4s.pol 16 rasterized_mask.fits 16 rasterized_mask.gif
../../scripts/call ../../bin/fits2dat_binary.x 1 16 rasterized_mask.fits j2
echo healpix_weight 3072 > j1
cat j1 j2 > rasterized_mask1.dat
rm j1 j2 args.dat
../../bin/poly2poly rasterized_mask1.dat rasterized_mask1.pol

echo "Making pixelmaps of 2qz north mask ..."
cp ../../masks/2qz10k/azel.dat jazel
tail +2 jazel > azel.dat
../../scripts/make_pixelmaps.sh 2qz_north_res4s.pol azel.dat 0
rm azel.dat jazel

if which matlab >/dev/null 2>&1 ; then
    ../../bin/poly2poly -ol30 trimmed_mask.pol trimmed_mask.list
    ../../scripts/graphmask.sh trimmed_mask.list trimmed_mask.eps
    rm trimmed_mask.list*
    ../../bin/poly2poly -ol30 rasterized_mask.pol rasterized_mask.list
    ../../scripts/graphmask.sh rasterized_mask.list rasterized_mask.eps
    rm rasterized_mask.list*
    ../../bin/poly2poly -ol30 rasterized_mask1.pol rasterized_mask1.list
    ../../scripts/graphmask.sh rasterized_mask1.list rasterized_mask1.eps
    rm rasterized_mask1.list*
    for(( i=1; i<=4; i++ ))
      do
      ../../bin/poly2poly -ol30 2qz_north_res4s.pol.${i}s jpix.list
      graphmask.sh jpix.list pixmap${i}.eps
      rm jpix.list*
    done
elif which sm >/dev/null 2>&1 ; then
    ../../bin/poly2poly -og30 trimmed_mask.pol trimmed_mask.grph
    ../../scripts/graphmasksm.sh trimmed_mask.grph trimmed_mask.eps
    rm trimmed_mask.grph
    ../../bin/poly2poly -og30 rasterized_mask.pol rasterized_mask.grph
    ../../scripts/graphmasksm.sh rasterized_mask.grph rasterized_mask.eps
    rm rasterized_mask.grph
    ../../bin/poly2poly -og30 rasterized_mask1.pol rasterized_mask1.grph
    ../../scripts/graphmasksm.sh rasterized_mask1.grph rasterized_mask1.eps
    rm rasterized_mask1.grph
    for(( i=1; i<=4; i++ ))
      do
      ../../bin/poly2poly -og30 2qz_north_res4s.pol.${i}s jpix.grph
      ../../scripts/graphmasksm.sh jpix.grph pixmap${i}.eps
      rm jpix.grph*
    done
fi
cd ..
echo >&2 "mangle test suite complete!  Output files are in test.tar.gz"
mv test.log test
tar cfz test.tar.gz test

#!/bin/sh
# © M E C Swanson 2008
#Script to make pixelmaps of a mask at several resolutions 
#Pixelmaps give the average value of the mask's weight in each pixel,
#using one of mangle's pixelization schemes.
#pixelmaps are saved as $inputmask.$res$scheme, e.g. for 
#the input mask sdss_dr7safe0_res6d.pol, pixelmap files will be
#sdss_dr7safe0_res6d.pol.1d, sdss_dr7safe0_res6d.pol.2d, etc.
#
#if a galaxy file is given, this script also uses polyid to find in which pixels
#each galaxy in the list lies.  The input galaxy file can have any number of columns,
#but the first 2 columns should be the RA and dec.
#output galaxy files for each resolution will attach the pixel number to the end of 
#each line in the galaxy file that lies within a pixel in the pixelmap.  The naming
#scheme is the same as for the pixelmap files, e.g., for the input galaxy file
#sdss_dr7safe0_galdetails1.dat, the output galaxy files will be
#sdss_dr7safe0_galdetails1.dat.1d, sdss_dr7safe0_galdetails1.dat.2d, etc.
#
#By default, this script cuts out any pixels with average weights less than 0.5 for
#resolution 1 and average weights less than 0.8 for higher resolutions.  To run
#the script without these cuts, enter a 0 for the final command line argument.
#
#USAGE: make_pixelmaps.sh <input mask file> [<input galaxy file>] [<0 to turn cuts off>]
#EXAMPLES:
#make_pixelmaps.sh sdss_dr7safe0_res6d.pol 
#make_pixelmaps.sh sdss_dr7safe0_res6d.pol 0
#make_pixelmaps.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat
#make_pixelmaps.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat 0


if [ "$MANGLEBINDIR" = "" ] ; then
    MANGLEBINDIR="../../bin"
fi
if [ "$MANGLESCRIPTSDIR" = "" ] ; then
    MANGLESCRIPTSDIR="../../scripts"
fi
if [ "$MANGLEDATADIR" = "" ] ; then
    MANGLEDATADIR="../../masks"
fi

mask=$1
gals=$2
cutweights=$3

#check command line arguments
if [ "$mask" = "" ] ; then
    echo >&2 "ERROR: enter the input polygon and galaxy files as command line arguments."
    echo >&2 "" 
    echo >&2 "USAGE: make_pixelmaps.sh <input mask file> [<input galaxy file>] [<0 to turn cuts off>]"
    echo >&2 "EXAMPLES:"
    echo >&2 "make_pixelmaps.sh sdss_dr7safe0_res6d.pol" 
    echo >&2 "make_pixelmaps.sh sdss_dr7safe0_res6d.pol 0"
    echo >&2 "make_pixelmaps.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat"
    echo >&2 "make_pixelmaps.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat 0"
    exit 1
fi

if [ "$gals" == 0 ] ; then
    cutweights=0
    gals=
fi
if [ "$cutweights" = "" ] ; then
    cutweights=1
fi

dresmax=6
dscheme="d"

head -n 100 $mask > jmaskhead

#grab pixelization info from input file
awk '/pixelization/{print $0}' < jmaskhead > jpix
resmax=`awk '{print substr($2, 1, length($2)-1)}' < jpix`
scheme=`awk '{print substr($2, length($2))}' < jpix`
rm jpix

#check if input file is snapped and balkanized
snapped=`awk '/snapped/{print $1}' < jmaskhead`
balkanized=`awk '/balkanized/{print $1}' < jmaskhead`
rm jmaskhead

#if input file is not pixelized, snapped, and balkanized, exit.
#if input file is pixelized to a fixed resolution, use it as is.
if [ "$resmax" = "" ]; then
    echo >&2 "ERROR: cannot make pixelmaps of an unpixelized mask."
    echo >&2 "Pixelize your mask using the pixelize function first."
    exit 1
elif [ "$resmax" = -1 ] ; then
    resmax=$dresmax
    echo "WARNING: making pixelmaps of a mask pixelized adaptively."
    echo "Attempting to make pixelmaps up to resolution $resmax."
    echo "To guarantee that pixelmaps can be made up to a given resolution,"
    echo "Pixelize your mask using a fixed resolution <r> by using 'pixelize -P<scheme>0,<r>'."
fi

#if input file isn't snapped, exit
if [ ! "$snapped" = "snapped" ]; then
    echo >&2 "ERROR: cannot make pixelmaps of an unsnapped mask."
    echo >&2 "Run snap on your mask before running this script,"
    echo >&2 "or add the 'snapped' keyword to your file if it is already snapped."
    exit 1
fi

#if input file isn't balkanized, exit
if [ ! "$balkanized" = "balkanized" ]; then
    echo >&2 "ERROR: cannot make pixelmaps of an unbalkanized mask."
    echo >&2 "Run balkanize on your mask before running this script,"
    echo >&2 "or add the 'balkanized' keyword to your file if it already consists"
    echo >&2 "of only non-overlapping polygons."
    exit 1
fi

for (( res=1; res<=$resmax; res++ ))
  do
  
  outmask=$mask.$res$scheme
  echo "Generating pixelmap for resolution $res ..."
  $MANGLEBINDIR/pixelmap -P${scheme}0,$res $mask $outmask || exit
  
#cut all pixels with weights less than 0.5 for resolution 1 or 0.8 for higher resolutions
  if [ $cutweights -ne 0 ] ; then
      if [ $res -le 1 ] ; then 
	  weightcut=0.5
      else
	  weightcut=0.8
      fi
      mv $outmask jp
      $MANGLEBINDIR/poly2poly -j$weightcut jp $outmask || exit
      echo "Pixels in $outmask have weights in the range defined in make_pixelmaps.sh."
      echo "To run make_pixelmaps.sh without these cuts, enter a 0 for the last command line argument."
      echo "EXAMPLE: make_pixelmaps.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat 0"
  fi
  

  if [ ! "$gals" == "" ] ; then
      if [ -e "$gals" ] ; then 
	  outgals=$gals.$res$scheme
	  $MANGLESCRIPTSDIR/polyid_gals.sh $outmask $gals $outgals
      else 
	  echo >&2 "ERROR: input galaxy file $gals not found!"
	  exit 1
      fi
  fi

done

#! /bin/sh
# © M E C Swanson 2008
#script to trim a mask so that it only includes polygons in a specified region
#USAGE: trim_mask.sh <mask> <trimmer> <outfile> [<pixelization arguments>]
#EXAMPLE:trim_mask.sh mask.pol trimmer.pol trimmed_mask.pol
# You can also optionally provide arguments to the pixelize function
# in the 4th argument:
#EXAMPLE: trim_mask.sh mask.pol trimmer.pol trimmed_mask.pol -Ps0,6


if [ "$MANGLEBINDIR" = "" ] ; then
    MANGLEBINDIR="../../bin"
fi
if [ "$MANGLESCRIPTSDIR" = "" ] ; then
    MANGLESCRIPTSDIR="../../scripts"
fi
if [ "$MANGLEDATADIR" = "" ] ; then
    MANGLEDATADIR="../../masks"
fi

mask=$1
trimmer=$2
outfile=$3
pixargs=$4

#check command line arguments:
if [ "$mask" = "" ] || [ "$trimmer" = "" ] || [ "$outfile" = "" ] ; then
    echo >&2 "ERROR: enter the input polygon file, a polygon defining the region you" 
    echo >&2 "want to trim to, and the output polygon file as command line arguments."
    echo >&2 "" 
    echo >&2 "USAGE: trim_mask.sh <mask> <trimmer> <outfile> [<pixelization arguments>]"
    echo >&2 "EXAMPLE: trim_mask.sh mask.pol trimmer.pol trimmed_mask.pol"
    echo >&2 "EXAMPLE w/ optional argument to pixelize: trim_mask.sh mask.pol trimmer.pol trimmed_mask.pol -Ps0,6"   
    exit 1
fi

#if no argument for pixelize is given, pixelize to resolution 6 with the simple scheme:
if [ "$pixargs" = "" ] ; then
    pixargs="-Ps0,6"
fi

head -n 100 $mask > jmaskhead
head -n 100 $trimmer > jtrimmerhead

#grab pixelization info from input files
awk '/pixelization/{print $0}' < jmaskhead > jpix
res1=`awk '{print substr($2, 1, length($2)-1)}' < jpix`
scheme1=`awk '{print substr($2, length($2))}' < jpix`
awk '/pixelization/{print $0}' < jtrimmerhead > jpix
res2=`awk '{print substr($2, 1, length($2)-1)}' < jpix`
scheme2=`awk '{print substr($2, length($2))}' < jpix`
rm jpix jmaskhead jtrimmerhead

#if input files are pixelized, make sure they are consistent:
if [ ! "$res1" = "" ] && [ ! "$res2" = "" ] ; then
    if [ $res1 -eq -1 ] || [ $res2 -eq -1 ] ; then
	echo >&2 "ERROR: cannot trim a mask pixelized adaptively."
	echo >&2 "Pixelize both your mask and your trimmer polygon(s) using a fixed resolution," 
	echo >&2 "e.g. -Ps0,8, and try again."
	exit 1
    fi
    if [ $res1 -ne $res2 ] ; then
	echo >&2 "ERROR: mask polygons and trimmer polygons must be pixelized to the same resolution."
	echo >&2 "Pixelize both your mask and your trimmer polygon(s) using a fixed resolution," 
	echo >&2 "e.g. -Ps0,8, and try again."
	exit 1
    fi    
#if input files are unpixelized, pixelize them:
elif [ ! "$res1" = "" ] && [ "$res2" = "" ] ; then
    if [ $res1 -eq -1 ] ; then
	echo >&2 "ERROR: cannot trim a mask pixelized adaptively."
	echo >&2 "Pixelize both your mask and your trimmer polygon(s) using a fixed resolution," 
	echo >&2 "e.g. -Ps0,8, and try again."
	exit 1
    fi
    echo "$MANGLEBINDIR/pixelize -P${scheme1}0,$res1 $trimmer trimmer_pix"
    $MANGLEBINDIR/pixelize -P${scheme1}0,$res1 $trimmer trimmer_pix || exit
    trimmer="trimmer_pix"
elif [ "$res1" = "" ] && [ ! "$res2" = "" ] ; then
    if [ $res2 -eq -1 ] ; then
	echo >&2 "ERROR: cannot trim a mask pixelized adaptively."
	echo >&2 "Pixelize both your mask and your trimmer polygon(s) using a fixed resolution," 
	echo >&2 "e.g. -Ps0,8, and try again."
	exit 1
    fi
    echo "$MANGLEBINDIR/pixelize  -P${scheme2}0,$res2 $mask mask_pix"
    $MANGLEBINDIR/pixelize  -P${scheme2}0,$res2 $mask mask_pix || exit
    mask="mask_pix"
else
    echo "$MANGLEBINDIR/pixelize $pixargs $trimmer trimmer_pix"
    $MANGLEBINDIR/pixelize $pixargs $trimmer trimmer_pix || exit
    echo "$MANGLEBINDIR/pixelize $pixargs $mask mask_pix"
    $MANGLEBINDIR/pixelize $pixargs $mask mask_pix || exit
    trimmer="trimmer_pix"
    mask="mask_pix"
fi

#check if input file is snapped
snapped=`awk '/snapped/{print $1}' < $mask`

#if mask file isn't snapped, snap it
if [ ! "$snapped" = "snapped" ]; then
    echo "Snapping $mask ..."
    mv $mask jp
    $MANGLEBINDIR/snap jp $mask  || exit
    rm jp
fi

#find the complement of the trimmer polygon
echo "$MANGLESCRIPTSDIR/find_complement.sh $trimmer trimmer_comp"
$MANGLESCRIPTSDIR/find_complement.sh $trimmer trimmer_comp || exit

#set the complement to have zero weight
echo 0 > jw0
echo "$MANGLEBINDIR/weight -zjw0 trimmer_comp jcomp0"
$MANGLEBINDIR/weight -zjw0 trimmer_comp jcomp0 || exit
rm jw0

#balkanize the mask with the zero-weight complement, thereby trimming off 
#everything that does not lie within the trimmer polygon 
echo "$MANGLEBINDIR/balkanize $mask jcomp0 jb"
$MANGLEBINDIR/balkanize $mask jcomp0 jb || exit
rm jcomp0

#unify to get rid of zero weight polygons
echo "$MANGLEBINDIR/unify jb $outfile"
$MANGLEBINDIR/unify jb $outfile || exit
rm jb

echo "Polygons of $1 trimmed by $2 written to ${outfile}."

#clean up

rm trimmer_comp
if [ -e trimmer_pix ] ; then 
    rm trimmer_pix
fi
if [ -e mask_pix ] ; then 
    rm mask_pix
fi

#!/bin/sh
# © M E C Swanson 2008
#plot the angular mask described by a polygon file in .list format
#using the matlab mapping toolbox
#
#optional 3rd-6th arguments give the RA and Dec range to plot the mask
#if no range is given, the full sky will be plotted
#To plot range that includes RA=0, use a negative number for the "low"
#end, e.g. for a 10 degree strip covering RA=355 degrees to RA=5 degrees,
#use a range of -5 5.
#Entering in "0 0 0 0" for the range will also give the default full sky behavior,
#which can be used if you also wish to, e.g., enter a title. 
#
#optional 7th argument gives a title for the graph
#optional 8th argument turns on drawing black outlines around each polygon
#
#if specifying the full path to a file (rather than just running in the directory 
#containing the file you want to plot), put the path in double-quotes as shown below.
#
#USAGE: graphmask.sh <infile> <outfile> [<ramin> <ramax> <decmin> <decmax>] [<title>] [<outlines>]
#EXAMPLES: 
#fullsky, no outlines: graphmask.sh "dr4/safe0/sdss_dr4safe0_mask.list" "dr4/safe0/sdss_dr4safe0_mask.eps"
#defined range, title, no outlines: graphmask.sh sdss_slice.list sdss_slice.eps -45 35 8 21 "SDSS slice"
#defined range, no title, outlines: graphmask.sh sdss_slice.list sdss_slice.eps -45 35 8 21 "" on
#fullsky, no title, outlines: graphmask.sh sdss_slice.list sdss_slice.eps 0 0 0 0 "" on

if [ "$MANGLESCRIPTSDIR" = "" ] ; then
    MANGLESCRIPTSDIR="../../scripts"
fi

if [ $# -eq 2 ]; then
    if [ -e $1 ]; then 
	if [ -e $2 ]; then
	    rm $2
	fi
	matlab -nodisplay -r addpath\(\'$MANGLESCRIPTSDIR\'\)\;graphmask\(\'$1\',\'$2\'\)
    else
	echo >&2 "ERROR: file $1 not found."
	exit 1
    fi
elif [ $# -ge 6 ]; then
    if [ -e $1 ]; then 
	if [ -e $2 ]; then
	    rm $2
	fi
	echo "addpath('$MANGLESCRIPTSDIR'); graphmask('$1','$2',[$3,$4,$5,$6],'$7','$8')" > jgraphtemp.m
	matlab -nodisplay < jgraphtemp.m
	rm jgraphtemp.m
    else
	echo >&2 "ERROR: file $1 not found."
	exit 1
    fi
else
    echo >&2 "USAGE: graphmask.sh <infile> <outfile> [<ramin> <ramax> <decmin> <decmax>] [<title>] [<outlines>]"
    echo >&2 "EXAMPLES:" 
    echo >&2 "fullsky, no outlines: graphmask.sh \"dr4/safe0/sdss_dr4safe0_mask.list\" \"dr4/safe0/sdss_dr4safe0_mask.eps\""
    echo >&2 "defined range, title, no outlines: graphmask.sh sdss_slice.list sdss_slice.eps -45 35 8 21 \"SDSS slice\""
    echo >&2 "defined range, no title, outlines: graphmask.sh sdss_slice.list sdss_slice.eps -45 35 8 21 \"\" on"
    echo >&2 "fullsky, no title, outlines: graphmask.sh sdss_slice.list sdss_slice.eps 0 0 0 0 \"\" on"
    exit 1
fi
if [ -e matlabexit.temp ] || [ ! -e $2 ]; then
    echo >&2 "ERROR: error in matlab plotting script."
    if [ -e matlabexit.temp ]; then
	rm matlabexit.temp
    fi
    exit 1
fi
echo all done!

#! /bin/sh
# © M E C Swanson 2008
#
#script called by wrapper script setup_mangle_environment to set
#mangle environment variables
#
#USAGE: type 'source setup_mangle_environment' in the base mangle directory
#If environment is setup correctly, typing
#'echo $MANGLEBINDIR; echo $MANGLESCRIPTSDIR; echo $MANGLEDATADIR'
#should print out the names of the appropriate directories.
#
#If the above command doesn't work, try 'source setup_mangle_environment $PWD/' 
#
#
#You can also use 'source <MANGLEDIR>setup_mangle_environment <MANGLEDIR>'
#where <MANGLEDIR> is the path to the base mangle directory, e.g., /home/username/mangle2.1/
#
#To automatically set up the mangle environment variables when you start your shell, 
#add the following line to your .bashrc (or .tcshrc, or .cshrc, or .login, or .profile) 
#(replace <MANGLEDIR> with the path to your mangle installation):
#
#source <MANGLEDIR>setup_mangle_environment <MANGLEDIR>

#If no command line argument is given, assume we're running in the mangle directory 
#
#arguments to make_setup_script.sh are: 
# $1: 0 if export exists in the environment shell, nonzero otherwise
# $2: name of base mangle directory <MANGLEDIR>

if [ "$2" = "" ]; then
    MANGLEDIR=$PWD/
#otherwise use the path in the first command-line argument as $MANGLEDIR
else
    MANGLEDIR=$2
fi
MANGLEBINDIR="${MANGLEDIR}bin"
MANGLESCRIPTSDIR="${MANGLEDIR}scripts"
MANGLEDATADIR="${MANGLEDIR}masks"

#check to make sure directories exist
if [ ! -d $MANGLEBINDIR ]; then
    echo >&2 "ERROR: The directory $MANGLEBINDIR does not exist"
fi
if [ ! -d $MANGLESCRIPTSDIR ]; then
    echo >&2 "ERROR: The directory $MANGLESCRIPTSDIR does not exist"
fi
if [ ! -d $MANGLEDATADIR ]; then
    echo >&2 "ERROR: The directory $MANGLEDATADIR does not exist"
fi
if [ ! -d $MANGLEBINDIR ] || [ ! -d $MANGLESCRIPTSDIR ] || [ ! -d $MANGLEDATADIR ]; then
    echo >&2 ""
    echo >&2 "USAGE: type 'source setup_mangle_environment' in the base mangle directory"
    echo >&2 "Or use 'source <MANGLEDIR>setup_mangle_environment <MANGLEDIR>'"
    echo >&2 "where <MANGLEDIR> is the path to the base mangle directory," 
    echo >&2 "e.g., /home/username/mangle2.1/"
    exit 1
fi
 
#export environment variables and put bin and scripts directories in the path
if [ "$1" = "0" ] ; then
    cat <<EOF > setup_script
export MANGLEBINDIR=$MANGLEBINDIR
export MANGLESCRIPTSDIR=$MANGLESCRIPTSDIR
export MANGLEDATADIR=$MANGLEDATADIR
export PATH=$PATH:$MANGLEBINDIR:$MANGLESCRIPTSDIR
EOF
else
    cat <<EOF > setup_script
setenv MANGLEBINDIR $MANGLEBINDIR
setenv MANGLESCRIPTSDIR $MANGLESCRIPTSDIR
setenv MANGLEDATADIR $MANGLEDATADIR    
setenv PATH $PATH:$MANGLEBINDIR:$MANGLESCRIPTSDIR
EOF
fi

#!/bin/sh
# © M E C Swanson 2008
#
#This script uses polyid to find in which polygons in the input mask
#each galaxy in the list lies.  The input galaxy file can have any number of columns,
#but the first 2 columns should be the RA and dec.
#output galaxy files for each resolution will attach the polygon number to the end of 
#each line in the galaxy file.
#
#By default, galaxies that are not in any polygon in the mask will be cut out of
#the output file.  To keep all galaxies in the output file, enter a 0 for the final
#command line argument.
#
#USAGE: polyid_gals.sh <input mask file> <input galaxy file> <output galaxy file> [<0 to turn cuts off>]
#EXAMPLES:
#polyid_gals.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat sdss_dr7safe0_polyidgals_cut.dat
#polyid_gals.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat sdss_dr7safe0_polyidgals_uncut.dat 0


if [ "$MANGLEBINDIR" = "" ] ; then
    MANGLEBINDIR="../../bin"
fi
if [ "$MANGLESCRIPTSDIR" = "" ] ; then
    MANGLESCRIPTSDIR="../../scripts"
fi
if [ "$MANGLEDATADIR" = "" ] ; then
    MANGLEDATADIR="../../masks"
fi

mask=$1
gals=$2
outgals=$3
cut=$4

#check command line arguments
if [ "$mask" = "" ] || [ "$gals" = "" ] || [ "$outgals" = "" ]; then
    echo >&2 "ERROR: enter the input polygon file and input and output galaxy files as command line arguments."
    echo >&2 "" 
    echo >&2 "USAGE: polyid_gals.sh <input mask file> <input galaxy file> <output galaxy file> [<0 to turn cuts off>]"
    echo >&2 "EXAMPLES:"
    echo >&2 "polyid_gals.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat sdss_dr7safe0_polyidgals_cut.dat"
    echo >&2 "polyid_gals.sh sdss_dr7safe0_res6d.pol sdss_dr7safe0_galdetails1.dat sdss_dr7safe0_polyidgals_uncut.dat 0"
    exit 1
fi

if [ "$cut" = "" ] ; then
    cut=1
fi
	  
#count number of columns in input galaxy file
head -n 1 $gals > jgals
numfields=`awk '{print NF}' jgals`
rm jgals
	  
#run polyid on galaxy file and assemble output galaxy files with polygon numbers
echo "Running polyid to find galaxies from $gals in $mask  ... "
$MANGLEBINDIR/polyid $mask $gals j1 || exit
tail +2 j1 > j2
awk '{print $3}' j2 > j3
paste $gals j3 > j4
if [ $cut -ne 0 ] ; then
    awk "NF == ($numfields+1) {print \$0}" j4 > $outgals
else
    cp j4 $outgals
fi
rm j1 j2 j3 j4

count=`wc -l < $outgals`
echo ""
echo "wrote $count galaxies to $outgals."
